! --------------------------------------------------
! Fast and Accurate Motorola 68000 Emulation Library
! FAME SH4 version 0.05 (06/09/2005)
! Oscar Orallo Pelaez
! Assembly file generated on Oct 12 2005 23:07:04
! --------------------------------------------------
! Opciones de generacion empleadas:
! - Formato de generacion SH4 (compilador GNU)
! - Bus de direcciones de 24 bits
! - Emulacion de lecturas tontas (OFF)
! - Emulacion de comportamiento no documentado (OFF)
! - Espacio de memoria unico (supervisor)
! - Emulacion de excepciones del grupo 0 (OFF)
! - Prefijo del nombre de las funciones: m68k
! - Realizar calculo preciso de ciclos de reloj (ON)
! - Cachear descriptores de mapas de memoria (ON)
! - Realizar cuenta interna de ciclos de reloj (OFF)
! - Emular bit 0 de execinfo (ON)
! - Emular excepcion de traza (OFF)
! - Emular accesos en dos regiones de memoria (OFF)
! - Contar ciclos de generacion de las IRQs (OFF)
! ---------------------------------------------------
.data
.align 2
.global _m68kcontext
_m68kcontext:
contextbegin:
fetch:     .long 0
readbyte:  .long 0
readword:  .long 0
writebyte: .long 0
writeword: .long 0
s_fetch:     .long 0
s_readbyte:  .long 0
s_readword:  .long 0
s_writebyte: .long 0
s_writeword: .long 0
u_fetch:     .long 0
u_readbyte:  .long 0
u_readword:  .long 0
u_writebyte: .long 0
u_writeword: .long 0
resethandler: .long 0
iackhandler:  .long 0
icusthandler: .long 0
reg:
dreg: .long 0,0,0,0,0,0,0,0
areg: .long 0,0,0,0,0,0,0
a7:   .long 0
asp:  .long 0
pc:   .long 0
cycles_counter: .long 0
interrupts: .byte 0,0,0,0,0,0,0,0
sreg: .word 0
execinfo: .word 0
contextend:
execexit_addr: .long execexit
io_cycle_counter: .long -1
io_fetchbase:     .long 0
io_fetchbased_pc: .long 0
fetch_vector:	    .long sfmhtbl, srwmhtbl, ufmhtbl, urwmhtbl
fetch_idx:        .long 0
readbyte_idx:     .long 0
readword_idx:     .long 0
writebyte_idx:    .long 0
writeword_idx:    .long 0
decode_extw_addr: .long decode_extw
rb_addr: .long readmemorybyte
rw_addr: .long readmemoryword
rl_addr: .long readmemorydword
wb_addr: .long writememorybyte
ww_addr: .long writememoryword
wl_addr: .long writememorydword
sfmhtbl:
.rept 4096
 .long 0
 .endr
srbmhtbl:
.rept 4096
 .long 0
 .endr
srwmhtbl:
.rept 4096
 .long 0
 .endr
swbmhtbl:
.rept 4096
 .long 0
 .endr
swwmhtbl:
.rept 4096
 .long 0
 .endr
ufmhtbl:
.rept 4096
 .long 0
 .endr
urbmhtbl:
.rept 4096
 .long 0
 .endr
urwmhtbl:
.rept 4096
 .long 0
 .endr
uwbmhtbl:
.rept 4096
 .long 0
 .endr
uwwmhtbl:
.rept 4096
 .long 0
 .endr
.text
top:
.align 5
.global _m68k_init
_m68k_init:
mov.l jmptbl_addr0,r6
mov.l jmptblcomp_addr0,r5
mov.l opcodetbl_size,r3
mov r6,r1
mov r6,r7
add r3,r1
shlr r3
add r3,r7
shll r3
decomp:
cmp/eq r7,r6
bf continue
sub r3,r6
sub r3,r1
continue:
mov.l @r5+,r0
mov r0,r2
shll8 r0
shlr16 r2
shlr8 r0
shlr8 r2
mov.l top_addr0,r4
add r4,r0
add #1,r2
jloop:
mov.l r0,@r6
add #4,r6
dt r2
bf jloop
cmp/ge r1,r6
bf decomp
rts
mov #0,r0
.align 2
opcodetbl_size: .long 262144
jmptbl_addr0: .long jmptbl
jmptblcomp_addr0: .long jmptblcomp
top_addr0: .long top
.align 5
.global _m68k_emulate
_m68k_emulate:
mov.l execinfo_addr,r1
mov.w @r1,r0
tst #0x80,r0
bt notstopped
mov.l cycles_counter_addr,r0
mov.l @r0,r1
add r4,r1
mov.l r1,@r0
rts
mov #0,r0
.align 5
notstopped:
mov.l r8,@-r15
mov r4,r7
mov.l r9,@-r15
mov.l r10,@-r15
mov.l r11,@-r15
mov.l r12,@-r15
mov.l fetch_idx_addr,r11
mov.l r13,@-r15
mov.l jmptbl_addr,r12
mov.l r14,@-r15
mov.l reg_addr,r13
sts.l pr,@-r15
mov.l areg_addr,r14
or #1,r0
mov.w r0,@r1
mov r0,r2
mov.l sreg_addr,r1
mov.w @r1,r0
mov r0,r10
shlr8 r10
mov #3,r8
and r0,r8
mov r0,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.l pc_addr,r1
mov.l @r1,r6
flush_irqs:
mov.l interrupts_addr,r0
mov #7,r5
mov r5,r1
mov.b @r0,r2
and r10,r1
sub r1,r5
mov #7,r1
shll16 r2
shll8 r2
.loop:
shll r2
bt .int
dt r5
cmp/pl r5
bt/s .loop
dt r1
bra .noint
mov #0,r0
.align 5
.int:
mov.b @r0,r2
mov r1,r5
mov #1,r1
shld r5,r1
xor r1,r2
mov.l r5,@-r15
mov.b r2,@r0
mov.b @(r0,r5),r4
mov #0,r5
mov.l g1_exception_addr,r0
jsr @r0
shll2 r4
mov #0xf8,r0
mov.l @r15+,r5
and r0,r10
mov.l iackhandler_addr,r0
mov.l @r0,r1
or r5,r10
tst r1,r1
bt .intdone
mov.l r3,@-r15
mov.l io_cycle_counter_addr1,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-io_cycle_counter,r0)
jsr @r1
nop
mov.l io_cycle_counter_addr1,r0
mov.l @r0,r7
mov.l @(io_fetchbase-io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-io_cycle_counter,r0),r6
mov.l @r15+,r3
.intdone:
mov #1,r0
.noint:
execbase:
bsr basefunction
nop
add r5,r6
execloop:
mov.w @r6+,r0
mov #0x1C,r1
shll2 r0
mov.l @(r0,r12),r4
jmp @r4
mov r0,r2
.align 5
execexit:
mov.l pc_addr,r2
sub r5,r6
mov r8,r0
shlr r0
addc r9,r9
tst r3,r3
addc r9,r9
and #3,r0
shll2 r9
or r0,r9
shll8 r10
mov.l sreg_addr,r0
or r10,r9
mov.w r9,@r0
mov.l r6,@r2
mov.l execinfo_addr,r1
mov.w @r1,r0
xor #1,r0
mov.w r0,@r1
lds.l	@r15+,pr
mov.l @r15+,r14
mov.l @r15+,r13
mov.l @r15+,r12
mov.l @r15+,r11
mov.l @r15+,r10
mov.l @r15+,r9
rts
mov.l @r15+,r8
.align 2
interrupts_addr: .long interrupts
pc_addr: .long pc
reg_addr: .long reg
areg_addr: .long areg
fetch_vector_addr: .long fetch_vector
sreg_addr: .long sreg
jmptbl_addr: .long jmptbl
cycles_counter_addr: .long cycles_counter
execinfo_addr: .long execinfo
fetch_idx_addr: .long fetch_idx
g1_exception_addr: .long group_1_exception
basefunction_addr: .long basefunction
iackhandler_addr: .long iackhandler
io_cycle_counter_addr1: .long io_cycle_counter
.align 5
.global _m68k_reset
_m68k_reset:
mov.l r11,@-r15
mov.l fetchidx_addr,r11
mov #1,r0
mov.l execinfo_addr2,r2
mov.w @r2,r1
tst r1,r0
bf return
mov.l sup_fetch_addr,r0
mov.l @r0,r1
mov #2,r0
tst r1,r1
bt return
mov.l reg_addr2,r0
mov #64,r1
add r1,r0
shlr2 r1
xor r4,r4
gp:
mov.l r4,@-r0
dt r1
bf gp
mov.l asp_addr2,r2
mov.l r4,@r2
mov.l interrupts_addr2,r2
mov.b @r2,r0
and #1,r0
mov.b r0,@r2
mov.l execinfo_addr2,r2
mov.w r4,@r2
mov.l sreg_addr2,r2
mov #0x27,r4
shll8 r4
mov.w r4,@r2
mov.l sfmhtbl_addr2,r0
mov.l fetch_idx_addr2,r1
mov.l r0,@r1
mov.l srbmhtbl_addr2,r0
mov.l r0,@(4,r1)
mov.l srwmhtbl_addr2,r0
mov.l r0,@(8,r1)
mov.l swbmhtbl_addr2,r0
mov.l r0,@(12,r1)
mov.l swwmhtbl_addr2,r0
mov.l r0,@(16,r1)
sts pr,r4
bsr basefunction
xor r6,r6
lds r4,pr
add r5,r6
mov.l @r6+,r0
swap.w r0,r0
mov.l a7_addr2,r2
mov.l r0,@r2
mov.l @r6,r0
swap.w r0,r0
mov.l pc_addr2,r2
mov.l r0,@r2
mov #0,r0
return:
rts
mov.l @r15+,r11
.align 2
reg_addr2: .long reg
execinfo_addr2: .long execinfo
interrupts_addr2: .long interrupts
pc_addr2: .long pc
sreg_addr2: .long sreg
a7_addr2: .long a7
asp_addr2: .long asp
sup_fetch_addr: .long s_fetch
sup_readbyte: .long s_readbyte
sup_readword: .long s_readword
sup_writebyte: .long s_writebyte
sup_writeword: .long s_writeword
act_fetch: .long fetch
act_readbyte: .long readbyte
act_readword: .long readword
act_writebyte: .long writebyte
act_writeword: .long writeword
fetchidx_addr: .long fetch_idx
sfmhtbl_addr2: .long sfmhtbl
srbmhtbl_addr2: .long srbmhtbl
srwmhtbl_addr2: .long srwmhtbl
swbmhtbl_addr2: .long swbmhtbl
swwmhtbl_addr2: .long swwmhtbl
fetch_idx_addr2: .long fetch_idx
.align 5
.global _m68k_raise_irq
_m68k_raise_irq:
mov r4,r0
and #7,r0
tst r0,r0
bt badinput
mov #0xff,r4
extu.b r4,r4
cmp/gt r4,r5
bt badinput
mov #-2,r4
cmp/ge r4,r5
bf badinput
cmp/eq r5,r4
bf notspurious
bra notauto
mov #0x18,r5
notspurious:
mov #-1,r4
cmp/eq r5,r4
bf notauto
mov #0x18,r5
add r0,r5
notauto:
mov #1,r4
shld r0,r4
mov.l interrupts_addr3,r1
mov.b @r1,r6
tst r6,r4
bf failure
or r4,r6
mov.b r5,@(r0,r1)
mov.b r6,@r1
mov #0x80,r1
extu.b r1,r1
mov.l execinfo_addr3,r6
mov.w @r6,r7
tst r1,r7
bt .notstopped
mov.l sreg_addr3,r1
mov.w @r1,r5
shlr8 r5
mov #7,r1
cmp/eq r1,r0
movt r4
and r1,r5
add r4,r0
cmp/hs r0,r5
movt r2
mov #0x7f,r0
shld r1,r2
and r0,r7
or r2,r7
mov.w r7,@r6
.notstopped:
rts
mov #0,r0
failure:
rts
mov #-1,r0
badinput:
rts
mov #-2,r0
.align 2
interrupts_addr3: .long interrupts
execinfo_addr3: .long execinfo
sreg_addr3: .long sreg
.align 5
.global _m68k_lower_irq
_m68k_lower_irq:
mov #6,r1
cmp/gt r1,r4
bt .badlevel
tst r4,r4
bt .badlevel
mov #1,r1
shld r4,r1
mov.l interrupts_addr4,r2
mov.b @r2,r3
tst r3,r1
bt .failstat
not r1,r1
and r1,r3
mov.b r3,@r2
rts
mov #0,r0
.failstat:
rts
mov #-1,r0
.badlevel:
rts
mov #-2,r0
.align 2
interrupts_addr4: .long interrupts
.align 5
.global _m68k_set_irq_type
_m68k_set_irq_type:
mov #1,r0
and r0,r5
tst r4,r4
bt .si_irq
mov #interrupts-contextbegin,r0
mov.b @(r0,r4),r1
shlr r1
shll r1
or r5,r1
mov.b r1,@(r0,r4)
rts
mov #0,r0
.si_irq:
mov.l interrupts_addr5,r1
mov.b @r1,r0
and #0xFE,r0
or r5,r0
mov.b r0,@r1
rts
mov #0,r0
.align 2
interrupts_addr5: .long interrupts
.align 5
.global _m68k_get_irq_vector
_m68k_get_irq_vector:
mov r4,r0
and #7,r0
tst r0,r0
bt badlev
mov #1,r1
shld r0,r1
mov.l interrupts_addr6,r2
mov.b @r2,r3
tst r3,r1
bt notraised
mov.b @(r0,r2),r0
rts
extu.b r0,r0
notraised:
rts
mov #-1,r0
badlev:
rts
mov #-2,r0
.align 2
interrupts_addr6: .long interrupts
.align 5
.global _m68k_change_irq_vector
_m68k_change_irq_vector:
mov r4,r0
and #7,r0
tst r0,r0
bt .badin
mov #1,r1
shld r0,r1
mov.l interrupts_addr7,r7
mov.b @r7,r3
tst r3,r1
bt .nraised
mov #255,r4
extu.b r4,r4
cmp/gt r4,r5
bt .badin
mov #-2,r4
cmp/gt r5,r4
bt .badin
cmp/eq r5,r4
bf .notspurious
bra .notauto
mov #0x18,r5
.notspurious:
dt r4
cmp/eq r5,r4
bf .notauto
mov #0x18,r5
add r0,r5
.notauto:
mov.b r5,@(r0,r7)
rts
mov #0,r0
.nraised:
rts
mov #-1,r0
.badin:
rts
mov #-2,r0
.align 2
interrupts_addr7: .long interrupts
.align 5
.global _m68k_get_context_size
_m68k_get_context_size:
mov.l contextend_addr8,r0
mov.l contextbegin_addr8,r1
rts
sub r1,r0
.align 2
contextbegin_addr8: .long contextbegin
contextend_addr8: .long contextend
.align 5
.global _m68k_get_context
_m68k_get_context:
mov.l contextbegin_addr9,r2
mov.l contextend_addr9,r1
loopgc:
mov.l @r2+,r0
mov.l r0,@r4
add #4,r4
cmp/eq r2,r1
bf loopgc
rts
mov #0,r0
.align 2
contextbegin_addr9: .long contextbegin
contextend_addr9: .long contextend
.align 5
.global _m68k_set_context
_m68k_set_context:
mov.l contxtb,r2
mov.l contxte,r1
lloop:
mov.l @r4+,r0
mov.l r0,@r2
add #4,r2
cmp/eq r2,r1
bf lloop
mov.l idxtbl_size,r1
mov.l sfmhtbl_addr,r2
mov #0,r0
mloop:
mov.l r0,@r2
add #4,r2
dt r1
bf mloop
mov.l sfmhtbl_addr,r4
mov.l s_fetch_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm0:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm0
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop0:
mov.l r1,@r0
add r6,r0
dt r2
bf loop0
bra begincmm0
add #12,r1
endcmm0:
mov.l ufmhtbl_addr,r4
mov.l u_fetch_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm1:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm1
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop1:
mov.l r1,@r0
add r6,r0
dt r2
bf loop1
bra begincmm1
add #12,r1
endcmm1:
mov.l srbmhtbl_addr,r4
mov.l s_readbyte_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm2:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm2
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop2:
mov.l r1,@r0
add r6,r0
dt r2
bf loop2
bra begincmm2
add #16,r1
endcmm2:
mov.l srwmhtbl_addr,r4
mov.l s_readword_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm3:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm3
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop3:
mov.l r1,@r0
add r6,r0
dt r2
bf loop3
bra begincmm3
add #16,r1
endcmm3:
mov.l urbmhtbl_addr,r4
mov.l u_readbyte_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm4:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm4
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop4:
mov.l r1,@r0
add r6,r0
dt r2
bf loop4
bra begincmm4
add #16,r1
endcmm4:
mov.l urwmhtbl_addr,r4
mov.l u_readword_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm5:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm5
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop5:
mov.l r1,@r0
add r6,r0
dt r2
bf loop5
bra begincmm5
add #16,r1
endcmm5:
mov.l swbmhtbl_addr,r4
mov.l s_writebyte_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm6:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm6
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop6:
mov.l r1,@r0
add r6,r0
dt r2
bf loop6
bra begincmm6
add #16,r1
endcmm6:
mov.l swwmhtbl_addr,r4
mov.l s_writeword_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm7:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm7
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop7:
mov.l r1,@r0
add r6,r0
dt r2
bf loop7
bra begincmm7
add #16,r1
endcmm7:
mov.l uwbmhtbl_addr,r4
mov.l u_writebyte_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm8:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm8
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop8:
mov.l r1,@r0
add r6,r0
dt r2
bf loop8
bra begincmm8
add #16,r1
endcmm8:
mov.l uwwmhtbl_addr,r4
mov.l u_writeword_addr,r1
mov #-12,r3
mov #4,r6
mov.l @r1,r1
begincmm9:
mov.l @r1,r0
cmp/eq #-1,r0
bt endcmm9
mov.l @r1,r0
mov.l @(4,r1),r2
shld r3,r0
shld r3,r2
sub r0,r2
add #1,r2
shll2 r0
add r4,r0
loop9:
mov.l r1,@r0
add r6,r0
dt r2
bf loop9
bra begincmm9
add #16,r1
endcmm9:
rts
mov #0,r0
.align 2
interrupts_addr10: .long interrupts
idxtbl_size: .long 40960
contxte: .long contextend
contxtb: .long contextbegin
sfmhtbl_addr: .long sfmhtbl
ufmhtbl_addr: .long ufmhtbl
srbmhtbl_addr: .long srbmhtbl
urbmhtbl_addr: .long urbmhtbl
swbmhtbl_addr: .long swbmhtbl
uwbmhtbl_addr: .long uwbmhtbl
srwmhtbl_addr: .long srwmhtbl
urwmhtbl_addr: .long urwmhtbl
swwmhtbl_addr: .long swwmhtbl
uwwmhtbl_addr: .long uwwmhtbl
s_fetch_addr: .long s_fetch
u_fetch_addr: .long u_fetch
s_readbyte_addr: .long s_readbyte
u_readbyte_addr: .long u_readbyte
s_writebyte_addr: .long s_writebyte
u_writebyte_addr: .long u_writebyte
s_readword_addr: .long s_readword
u_readword_addr: .long u_readword
s_writeword_addr: .long s_writeword
u_writeword_addr: .long u_writeword
.align 5
.global _m68k_get_register
_m68k_get_register:
mov #17,r0
cmp/gt r0,r4
bt cont_get
mov #16,r0
cmp/gt r0,r4
bf .set_dareg
bra _m68k_get_pc
nop
.set_dareg:
mov.l reg_addr11,r0
shll2 r4
rts
mov.l @(r0,r4),r0
cont_get:
mov #18,r0
cmp/eq r0,r4
bf inv_idx
mov.l sreg_addr11,r0
mov.w @r0,r0
rts
extu.w r0,r0
inv_idx:
rts
mov #-1,r0
.align 2
sreg_addr11: .long sreg
reg_addr11: .long reg
.align 5
.global _m68k_get_pc
_m68k_get_pc:
mov.l execinfo_addr12,r0
mov.w @r0,r0
tst #1,r0
bf running
mov.l pc_addr12,r0
rts
mov.l @r0,r0
running:
mov.l io_fetchbased_pc_addr12,r0
mov.l @r0,r0
mov.l io_fetchbase_addr12,r1
mov.l @r1,r1
rts
sub r1,r0
.align 2
pc_addr12: .long pc
execinfo_addr12: .long execinfo
io_fetchbase_addr12: .long io_fetchbase
io_fetchbased_pc_addr12: .long io_fetchbased_pc
.align 5
.global _m68k_set_register
_m68k_set_register:
mov #17,r0
cmp/gt r0,r4
bt .cont_set
mov #16,r0
cmp/gt r0,r4
bt .set_pc
mov.l reg_addr13,r0
shll2 r4
mov.l r5,@(r0,r4)
rts
mov #0,r0
.set_pc:
shll8 r5
shlr8 r5
mov.l execinfo_addr13,r0
mov #1,r2
mov.b @r0,r1
tst r2,r1
bf .cpulive
mov.l pc_addr13,r0
mov.l r5,@r0
rts
mov #0,r0
.cpulive:
mov.l io_fetchbase_addr13,r0
mov.l @r0,r1
mov.l io_fetchbased_pc_addr13,r2
add r5,r1
mov.l r1,@r2
rts
mov #0,r0
.cont_set:
mov #18,r0
cmp/eq r0,r4
bf .inv_idx
mov.l sreg_addr13,r0
mov.w r5,@r0
rts
mov #0,r0
.inv_idx:
rts
mov #-1,r0
.align 2
sreg_addr13: .long sreg
reg_addr13: .long reg
execinfo_addr13: .long execinfo
pc_addr13: .long pc
io_fetchbase_addr13: .long io_fetchbase
io_fetchbased_pc_addr13: .long io_fetchbased_pc
.align 5
.global _m68k_fetch
_m68k_fetch:
mov #3,r0
and r0,r5
mov r4,r2
mov #-12,r0
shld r0,r4
mov.l fetch_vector_addr14,r0
shll2 r5
mov.l @(r0,r5),r0
shll2 r4
mov.l @(r0,r4),r0
mov r2,r4
tst r0,r0
bt .outofrange
mov #4,r1
tst r1,r5
bt .base_prg
bra .base_dat
nop
.outofrange:
rts
mov #-1,r0
.base_prg:
mov.l @(8,r0),r0
mov.w @(r0,r4),r0
rts
extu.w r0,r0
.base_dat:
mov.l @(8,r0),r1
tst r1,r1
bf .callio
mov.l @(12,r0),r0
mov.w @(r0,r4),r0
rts
extu.w r0,r0
.callio:
sts.l	pr,@-r15
jsr @r1
nop
lds.l	@r15+,pr
rts
extu.w r0,r0
.align 2
fetch_vector_addr14: .long fetch_vector
.align 5
.global _m68k_get_cycles_counter
_m68k_get_cycles_counter:
rts
mov #-1,r0
.align 5
.global _m68k_control_cycles_counter
_m68k_control_cycles_counter:
rts
mov #-1,r0
.align 5
.global _m68k_trip_cycles_counter
_m68k_trip_cycles_counter:
rts
mov #-1,r0
.align 5
.global _m68k_release_timeslice
_m68k_release_timeslice:
rts
mov #0,r0
.align 5
.global _m68k_add_cycles
_m68k_add_cycles:
rts
mov #-1,r0
.align 5
.global _m68k_release_cycles
_m68k_release_cycles:
rts
mov #-1,r0
.align 5
.global _m68k_get_cpu_state
_m68k_get_cpu_state:
mov.l execinfo_addr20,r0
mov.w @r0,r0
rts
extu.w r0,r0
.align 2
execinfo_addr20: .long execinfo
.align 5
basefunction:
shll8 r6
shlr8 r6
mov r6,r0
mov #-12,r1
shld r1,r0
mov.l @r11,r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt outofrange
rts
mov.l @(8,r0),r5
outofrange:
xor r5,r5
mov.l execinfo_addr21,r1
mov.w @r1,r0
or #2,r0
rts
mov.w r0,@r1
.align 2
execinfo_addr21: .long execinfo
.align 5
readmemorybyte:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov #-12,r1
mov r4,r0
shld r1,r0
mov.l @(readbyte_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt readb_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf readb_callio
mov.l @(12,r0),r0
add r4,r0
xor #1,r0
mov.b @r0,r3
rts
mov.l @r15+,r4
.align 5
readb_callio:
mov.l r2,@-r15
mov.l io_cycle_counter_addr22,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
nop
exts.b r0,r3
lds.l	@r15+,pr
mov.l io_cycle_counter_addr22,r0
mov.l @r0,r7
mov.l @(io_fetchbase-io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-io_cycle_counter,r0),r6
mov.l @r15+,r2
rts
mov.l @r15+,r4
readb_outofrange:
bra readw_outofrange
nop
.align 2
io_cycle_counter_addr22: .long io_cycle_counter
.align 5
readmemoryword:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov #-12,r1
mov r4,r0
shld r1,r0
mov.l @(readword_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt readw_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf readw_callio
mov.l @(12,r0),r0
mov.w @(r0,r4),r3
rts
mov.l @r15+,r4
.align 5
readw_callio:
mov.l r2,@-r15
mov.l io_cycle_counter_addr24,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
nop
exts.w r0,r3
lds.l	@r15+,pr
mov.l io_cycle_counter_addr24,r0
mov.l @r0,r7
mov.l @(io_fetchbase-io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-io_cycle_counter,r0),r6
mov.l @r15+,r2
rts
mov.l @r15+,r4
readw_outofrange:
mov #-1,r3
rts
mov.l @r15+,r4
.align 2
io_cycle_counter_addr24: .long io_cycle_counter
.align 5
readmemorydword:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov #-12,r1
mov r4,r0
shld r1,r0
mov.l @(readword_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt readl_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf readl_callio
mov.l @(12,r0),r1
add r1,r4
mov.w @r4+,r0
mov.w @r4,r3
shll16 r3
xtrct r0,r3
rts
mov.l @r15+,r4
readl_outofrange:
bra readw_outofrange
nop
.align 5
readl_callio:
mov.l r2,@-r15
sts.l	pr,@-r15
mov.l r4,@-r15
mov.l r1,@-r15
mov.l io_cycle_counter_addr26,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-io_cycle_counter,r0)
jsr @r1
nop
mov.l @r15+,r1
mov.l @r15+,r4
mov.l r0,@-r15
jsr @r1
add #2,r4
mov.l @r15+,r3
lds.l	@r15+,pr
shll16 r3
extu.w r0,r0
mov.l @r15+,r2
or r0,r3
mov.l io_cycle_counter_addr26,r0
mov.l @r0,r7
mov.l @(io_fetchbase-io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-io_cycle_counter,r0),r6
rts
mov.l @r15+,r4
.align 2
io_cycle_counter_addr26: .long io_cycle_counter
.align 5
writememorybyte:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov #-12,r1
mov r4,r0
shld r1,r0
mov.l @(writebyte_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt writeb_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf writeb_callio
mov.l @(12,r0),r0
add r4,r0
xor #1,r0
mov.b r3,@r0
rts
mov.l @r15+,r4
writeb_outofrange:
bra writew_outofrange
nop
.align 5
writeb_callio:
mov.l r2,@-r15
mov.l r3,@-r15
mov.l io_cycle_counter_addr28,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
extu.b r3,r5
lds.l	@r15+,pr
mov.l io_cycle_counter_addr28,r0
mov.l @r0,r7
mov.l @(io_fetchbase-io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-io_cycle_counter,r0),r6
mov.l @r15+,r3
mov.l @r15+,r2
rts
mov.l @r15+,r4
.align 2
io_cycle_counter_addr28: .long io_cycle_counter
.align 5
writememoryword:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov #-12,r1
mov r4,r0
shld r1,r0
mov.l @(writeword_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt writew_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf writew_callio
mov.l @(12,r0),r0
mov.w r3,@(r0,r4)
rts
mov.l @r15+,r4
writew_outofrange:
rts
mov.l @r15+,r4
.align 5
writew_callio:
mov.l r2,@-r15
mov.l r3,@-r15
mov.l io_cycle_counter_addr30,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
extu.w r3,r5
lds.l	@r15+,pr
mov.l io_cycle_counter_addr30,r0
mov.l @r0,r7
mov.l @(io_fetchbase-io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-io_cycle_counter,r0),r6
mov.l @r15+,r3
mov.l @r15+,r2
rts
mov.l @r15+,r4
.align 2
io_cycle_counter_addr30: .long io_cycle_counter
.align 5
writememorydword:
mov.l r4,@-r15
shll8 r4
shlr8 r4
mov #-12,r1
mov r4,r0
shld r1,r0
mov.l @(writeword_idx-fetch_idx,r11),r1
shll2 r0
mov.l @(r0,r1),r0
tst r0,r0
bt writel_outofrange
mov.l @(8,r0),r1
tst r1,r1
bf writel_callio
mov.l @(12,r0),r0
mov r3,r1
shlr16 r1
mov.w r1,@(r0,r4)
add #2,r4
mov.w r3,@(r0,r4)
rts
mov.l @r15+,r4
writel_outofrange:
bra readw_outofrange
nop
.align 5
writel_callio:
mov.l @(8,r0),r1
mov.l io_cycle_counter_addr32,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-io_cycle_counter,r0)
mov.l r2,@-r15
mov.l r3,@-r15
sts.l	pr,@-r15
mov.l r4,@-r15
mov.l r1,@-r15
mov r3,r5
jsr @r1
shlr16 r5
mov.l @r15+,r1
mov.l @r15+,r4
mov.l @(4,r15),r5
add #2,r4
jsr @r1
extu.w r5,r5
lds.l	@r15+,pr
mov.l @r15+,r3
mov.l @r15+,r2
mov.l io_cycle_counter_addr32,r0
mov.l @r0,r7
mov.l @(io_fetchbase-io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-io_cycle_counter,r0),r6
rts
mov.l @r15+,r4
.align 2
io_cycle_counter_addr32: .long io_cycle_counter
.align 5
decode_extw:
mov.w @r6+,r0
exts.b r0,r4
shlr8 r0
shlr2 r0
tst #2,r0
and #0x3c,r0
mov.l @(r0,r13),r0
bf longwd
exts.w r0,r0
longwd:
rts
add r0,r4
.align 5
group_1_exception:
group_2_exception:
mov.l execinfo_addr34,r1
mov.w @r1,r0
and #0x7F,r0
mov.w r0,@r1
mov.l icusthandler_addr34,r0
mov.l @r0,r0
tst r0,r0
bt .vect_except
mov r4,r1
shll2 r1
mov.l @(r0,r1),r1
tst r1,r1
bt .vect_except
mov.l r3,@-r15
mov.l io_cycle_counter_addr34,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
nop
lds.l	@r15+,pr
mov.l io_cycle_counter_addr34,r0
mov.l @r0,r7
mov.l @(io_fetchbase-io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-io_cycle_counter,r0),r6
mov.l @r15+,r3
rts
sub r5,r6
.align 5
.vect_except:
sts.l	pr,@-r15
mov.l r3,@-r15
mov.l readmemorydword_addr34,r0
jsr @r0
sub r5,r6
mov r3,r2
mov.l @r15,r3
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
mov r3,r5
mov #0x20,r0
tst r0,r10
bf ln35
or r0,r10
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln35:
mov #0x27,r0
mov r6,r3
and r0,r10
mov.l @(60,r13),r4
mov.l writememorydword_addr34,r0
jsr @r0
add #-4,r4
mov r5,r3
mov.l writememoryword_addr34,r0
jsr @r0
add #-2,r4
mov.l @r15+,r3
mov.l r4,@(60,r13)
lds.l	@r15+,pr
rts
mov r2,r6
.align 2
readmemoryword_addr34: .long readmemoryword
readmemorydword_addr34: .long readmemorydword
writememoryword_addr34: .long writememoryword
writememorydword_addr34: .long writememorydword
icusthandler_addr34: .long icusthandler
io_cycle_counter_addr34: .long io_cycle_counter
execinfo_addr34: .long execinfo
.align 5
privilege_violation:
add #-2,r6
bsr group_1_exception
mov #0x20,r4
mov.l bf_addr36,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl37
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl37:
jmp @r4
mov r0,r2
.align 2
bf_addr36: .long basefunction
! Opcodes 0000 - 0007
K000:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
or r1,r3
mov.b r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl38
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl38:
jmp @r4
mov r0,r2
! Opcodes 0010 - 0017
K010:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl39
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl39:
jmp @r4
mov r0,r2
! Opcodes 0018 - 001F
K018:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl40
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl40:
jmp @r4
mov r0,r2
! Opcodes 0020 - 0027
K020:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl41
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl41:
jmp @r4
mov r0,r2
! Opcodes 0028 - 002F
K028:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl42
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl42:
jmp @r4
mov r0,r2
! Opcodes 0030 - 0037
K030:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl43
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl43:
jmp @r4
mov r0,r2
! Opcode 0038
K038:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl44
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl44:
jmp @r4
mov r0,r2
! Opcode 0039
K039:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl45
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl45:
jmp @r4
mov r0,r2
! Opcode 003C
K03C:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
or r2,r3
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl46
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl46:
jmp @r4
mov r0,r2
! Opcodes 0040 - 0047
K040:
and r1,r2
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
or r1,r3
mov.w r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl47
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl47:
jmp @r4
mov r0,r2
! Opcodes 0050 - 0057
K050:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl48
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl48:
jmp @r4
mov r0,r2
! Opcodes 0058 - 005F
K058:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl49
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl49:
jmp @r4
mov r0,r2
! Opcodes 0060 - 0067
K060:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl50
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl50:
jmp @r4
mov r0,r2
! Opcodes 0068 - 006F
K068:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl51
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl51:
jmp @r4
mov r0,r2
! Opcodes 0070 - 0077
K070:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl52
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl52:
jmp @r4
mov r0,r2
! Opcode 0078
K078:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl53
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl53:
jmp @r4
mov r0,r2
! Opcode 0079
K079:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl54
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl54:
jmp @r4
mov r0,r2
! Opcode 007C
K07C:
mov r10,r0
tst #0x20,r0
bf pcheck_ok55
mov.l priviolation_addr55,r0
jmp @r0
nop
.align 2
priviolation_addr55: .long privilege_violation
pcheck_ok55:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
or r2,r3
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln56
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln56:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue58
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue58:
jmp @r4
mov r0,r2
! Opcodes 0080 - 0087
K080:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
or r1,r3
mov.l r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl59
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl59:
jmp @r4
mov r0,r2
! Opcodes 0090 - 0097
K090:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl60
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl60:
jmp @r4
mov r0,r2
! Opcodes 0098 - 009F
K098:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl61
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl61:
jmp @r4
mov r0,r2
! Opcodes 00A0 - 00A7
K0A0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl62
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl62:
jmp @r4
mov r0,r2
! Opcodes 00A8 - 00AF
K0A8:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl63
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl63:
jmp @r4
mov r0,r2
! Opcodes 00B0 - 00B7
K0B0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl64
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl64:
jmp @r4
mov r0,r2
! Opcode 00B8
K0B8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl65
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl65:
jmp @r4
mov r0,r2
! Opcode 00B9
K0B9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-36,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl66
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl66:
jmp @r4
mov r0,r2
! Opcodes 0100 - 0107
K100:
and r1,r2
mov.b @r13,r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl67
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl67:
jmp @r4
mov r0,r2
! Opcodes 0108 - 010F
K108:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.w r2,@r13
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl68
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl68:
jmp @r4
mov r0,r2
! Opcodes 0110 - 0117
K110:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl69
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl69:
jmp @r4
mov r0,r2
! Opcodes 0118 - 011F
K118:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl70
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl70:
jmp @r4
mov r0,r2
! Opcodes 0120 - 0127
K120:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl71
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl71:
jmp @r4
mov r0,r2
! Opcodes 0128 - 012F
K128:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl72
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl72:
jmp @r4
mov r0,r2
! Opcodes 0130 - 0137
K130:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl73
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl73:
jmp @r4
mov r0,r2
! Opcode 0138
K138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl74
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl74:
jmp @r4
mov r0,r2
! Opcode 0139
K139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl75
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl75:
jmp @r4
mov r0,r2
! Opcode 013A
K13A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl76
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl76:
jmp @r4
mov r0,r2
! Opcode 013B
K13B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl77
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl77:
jmp @r4
mov r0,r2
! Opcode 013C
K13C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl78
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl78:
jmp @r4
mov r0,r2
! Opcodes 0140 - 0147
K140:
and r1,r2
mov.b @r13,r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
xor r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl79
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl79:
jmp @r4
mov r0,r2
! Opcodes 0148 - 014F
K148:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@r13
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl80
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl80:
jmp @r4
mov r0,r2
! Opcodes 0150 - 0157
K150:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl81
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl81:
jmp @r4
mov r0,r2
! Opcodes 0158 - 015F
K158:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl82
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl82:
jmp @r4
mov r0,r2
! Opcodes 0160 - 0167
K160:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl83
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl83:
jmp @r4
mov r0,r2
! Opcodes 0168 - 016F
K168:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl84
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl84:
jmp @r4
mov r0,r2
! Opcodes 0170 - 0177
K170:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl85
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl85:
jmp @r4
mov r0,r2
! Opcode 0178
K178:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl86
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl86:
jmp @r4
mov r0,r2
! Opcode 0179
K179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl87
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl87:
jmp @r4
mov r0,r2
! Opcodes 0180 - 0187
K180:
and r1,r2
mov.b @r13,r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
not r4,r4
and r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl88
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl88:
jmp @r4
mov r0,r2
! Opcodes 0188 - 018F
K188:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @r13,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl89
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl89:
jmp @r4
mov r0,r2
! Opcodes 0190 - 0197
K190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl90
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl90:
jmp @r4
mov r0,r2
! Opcodes 0198 - 019F
K198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl91
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl91:
jmp @r4
mov r0,r2
! Opcodes 01A0 - 01A7
K1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl92
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl92:
jmp @r4
mov r0,r2
! Opcodes 01A8 - 01AF
K1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl93
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl93:
jmp @r4
mov r0,r2
! Opcodes 01B0 - 01B7
K1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl94
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl94:
jmp @r4
mov r0,r2
! Opcode 01B8
K1B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl95
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl95:
jmp @r4
mov r0,r2
! Opcode 01B9
K1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl96
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl96:
jmp @r4
mov r0,r2
! Opcodes 01C0 - 01C7
K1C0:
and r1,r2
mov.b @r13,r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
or r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl97
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl97:
jmp @r4
mov r0,r2
! Opcodes 01C8 - 01CF
K1C8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @r13,r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl98
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl98:
jmp @r4
mov r0,r2
! Opcodes 01D0 - 01D7
K1D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl99
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl99:
jmp @r4
mov r0,r2
! Opcodes 01D8 - 01DF
K1D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl100
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl100:
jmp @r4
mov r0,r2
! Opcodes 01E0 - 01E7
K1E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl101
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl101:
jmp @r4
mov r0,r2
! Opcodes 01E8 - 01EF
K1E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl102
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl102:
jmp @r4
mov r0,r2
! Opcodes 01F0 - 01F7
K1F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl103
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl103:
jmp @r4
mov r0,r2
! Opcode 01F8
K1F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl104
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl104:
jmp @r4
mov r0,r2
! Opcode 01F9
K1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl105
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl105:
jmp @r4
mov r0,r2
! Opcodes 0200 - 0207
K200:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
and r1,r3
mov.b r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl106
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl106:
jmp @r4
mov r0,r2
! Opcodes 0210 - 0217
K210:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl107
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl107:
jmp @r4
mov r0,r2
! Opcodes 0218 - 021F
K218:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl108
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl108:
jmp @r4
mov r0,r2
! Opcodes 0220 - 0227
K220:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl109
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl109:
jmp @r4
mov r0,r2
! Opcodes 0228 - 022F
K228:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl110
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl110:
jmp @r4
mov r0,r2
! Opcodes 0230 - 0237
K230:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl111
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl111:
jmp @r4
mov r0,r2
! Opcode 0238
K238:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl112
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl112:
jmp @r4
mov r0,r2
! Opcode 0239
K239:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl113
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl113:
jmp @r4
mov r0,r2
! Opcode 023C
K23C:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
and r2,r3
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl114
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl114:
jmp @r4
mov r0,r2
! Opcodes 0240 - 0247
K240:
and r1,r2
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
and r1,r3
mov.w r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl115
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl115:
jmp @r4
mov r0,r2
! Opcodes 0250 - 0257
K250:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl116
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl116:
jmp @r4
mov r0,r2
! Opcodes 0258 - 025F
K258:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl117
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl117:
jmp @r4
mov r0,r2
! Opcodes 0260 - 0267
K260:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl118
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl118:
jmp @r4
mov r0,r2
! Opcodes 0268 - 026F
K268:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl119
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl119:
jmp @r4
mov r0,r2
! Opcodes 0270 - 0277
K270:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl120
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl120:
jmp @r4
mov r0,r2
! Opcode 0278
K278:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl121
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl121:
jmp @r4
mov r0,r2
! Opcode 0279
K279:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl122
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl122:
jmp @r4
mov r0,r2
! Opcode 027C
K27C:
mov r10,r0
tst #0x20,r0
bf pcheck_ok123
mov.l priviolation_addr123,r0
jmp @r0
nop
.align 2
priviolation_addr123: .long privilege_violation
pcheck_ok123:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
and r2,r3
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln124
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln124:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue126
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue126:
jmp @r4
mov r0,r2
! Opcodes 0280 - 0287
K280:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
and r1,r3
mov.l r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl127
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl127:
jmp @r4
mov r0,r2
! Opcodes 0290 - 0297
K290:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl128
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl128:
jmp @r4
mov r0,r2
! Opcodes 0298 - 029F
K298:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl129
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl129:
jmp @r4
mov r0,r2
! Opcodes 02A0 - 02A7
K2A0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl130
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl130:
jmp @r4
mov r0,r2
! Opcodes 02A8 - 02AF
K2A8:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl131
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl131:
jmp @r4
mov r0,r2
! Opcodes 02B0 - 02B7
K2B0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl132
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl132:
jmp @r4
mov r0,r2
! Opcode 02B8
K2B8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl133
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl133:
jmp @r4
mov r0,r2
! Opcode 02B9
K2B9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-36,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl134
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl134:
jmp @r4
mov r0,r2
! Opcodes 0300 - 0307
K300:
and r1,r2
mov #4,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl135
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl135:
jmp @r4
mov r0,r2
! Opcodes 0308 - 030F
K308:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #4,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl136
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl136:
jmp @r4
mov r0,r2
! Opcodes 0310 - 0317
K310:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl137
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl137:
jmp @r4
mov r0,r2
! Opcodes 0318 - 031F
K318:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl138
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl138:
jmp @r4
mov r0,r2
! Opcodes 0320 - 0327
K320:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl139
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl139:
jmp @r4
mov r0,r2
! Opcodes 0328 - 032F
K328:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl140
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl140:
jmp @r4
mov r0,r2
! Opcodes 0330 - 0337
K330:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl141
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl141:
jmp @r4
mov r0,r2
! Opcode 0338
K338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl142
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl142:
jmp @r4
mov r0,r2
! Opcode 0339
K339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl143
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl143:
jmp @r4
mov r0,r2
! Opcode 033A
K33A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl144
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl144:
jmp @r4
mov r0,r2
! Opcode 033B
K33B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl145
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl145:
jmp @r4
mov r0,r2
! Opcode 033C
K33C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl146
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl146:
jmp @r4
mov r0,r2
! Opcodes 0340 - 0347
K340:
and r1,r2
mov #4,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
xor r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl147
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl147:
jmp @r4
mov r0,r2
! Opcodes 0348 - 034F
K348:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(4,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl148
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl148:
jmp @r4
mov r0,r2
! Opcodes 0350 - 0357
K350:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl149
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl149:
jmp @r4
mov r0,r2
! Opcodes 0358 - 035F
K358:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl150
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl150:
jmp @r4
mov r0,r2
! Opcodes 0360 - 0367
K360:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl151
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl151:
jmp @r4
mov r0,r2
! Opcodes 0368 - 036F
K368:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl152
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl152:
jmp @r4
mov r0,r2
! Opcodes 0370 - 0377
K370:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl153
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl153:
jmp @r4
mov r0,r2
! Opcode 0378
K378:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl154
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl154:
jmp @r4
mov r0,r2
! Opcode 0379
K379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl155
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl155:
jmp @r4
mov r0,r2
! Opcodes 0380 - 0387
K380:
and r1,r2
mov #4,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
not r4,r4
and r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl156
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl156:
jmp @r4
mov r0,r2
! Opcodes 0388 - 038F
K388:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(4,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl157
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl157:
jmp @r4
mov r0,r2
! Opcodes 0390 - 0397
K390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl158
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl158:
jmp @r4
mov r0,r2
! Opcodes 0398 - 039F
K398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl159
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl159:
jmp @r4
mov r0,r2
! Opcodes 03A0 - 03A7
K3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl160
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl160:
jmp @r4
mov r0,r2
! Opcodes 03A8 - 03AF
K3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl161
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl161:
jmp @r4
mov r0,r2
! Opcodes 03B0 - 03B7
K3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl162
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl162:
jmp @r4
mov r0,r2
! Opcode 03B8
K3B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl163
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl163:
jmp @r4
mov r0,r2
! Opcode 03B9
K3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl164
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl164:
jmp @r4
mov r0,r2
! Opcodes 03C0 - 03C7
K3C0:
and r1,r2
mov #4,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
or r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl165
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl165:
jmp @r4
mov r0,r2
! Opcodes 03C8 - 03CF
K3C8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(4,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl166
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl166:
jmp @r4
mov r0,r2
! Opcodes 03D0 - 03D7
K3D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl167
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl167:
jmp @r4
mov r0,r2
! Opcodes 03D8 - 03DF
K3D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl168
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl168:
jmp @r4
mov r0,r2
! Opcodes 03E0 - 03E7
K3E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl169
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl169:
jmp @r4
mov r0,r2
! Opcodes 03E8 - 03EF
K3E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl170
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl170:
jmp @r4
mov r0,r2
! Opcodes 03F0 - 03F7
K3F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl171
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl171:
jmp @r4
mov r0,r2
! Opcode 03F8
K3F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl172
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl172:
jmp @r4
mov r0,r2
! Opcode 03F9
K3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl173
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl173:
jmp @r4
mov r0,r2
! Opcodes 0400 - 0407
K400:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl174
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl174:
jmp @r4
mov r0,r2
! Opcodes 0410 - 0417
K410:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl175
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl175:
jmp @r4
mov r0,r2
! Opcodes 0418 - 041F
K418:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl176
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl176:
jmp @r4
mov r0,r2
! Opcodes 0420 - 0427
K420:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl177
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl177:
jmp @r4
mov r0,r2
! Opcodes 0428 - 042F
K428:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl178
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl178:
jmp @r4
mov r0,r2
! Opcodes 0430 - 0437
K430:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl179
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl179:
jmp @r4
mov r0,r2
! Opcode 0438
K438:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl180
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl180:
jmp @r4
mov r0,r2
! Opcode 0439
K439:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl181
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl181:
jmp @r4
mov r0,r2
! Opcodes 0440 - 0447
K440:
and r1,r2
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl182
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl182:
jmp @r4
mov r0,r2
! Opcodes 0450 - 0457
K450:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl183
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl183:
jmp @r4
mov r0,r2
! Opcodes 0458 - 045F
K458:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl184
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl184:
jmp @r4
mov r0,r2
! Opcodes 0460 - 0467
K460:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl185
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl185:
jmp @r4
mov r0,r2
! Opcodes 0468 - 046F
K468:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl186
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl186:
jmp @r4
mov r0,r2
! Opcodes 0470 - 0477
K470:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl187
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl187:
jmp @r4
mov r0,r2
! Opcode 0478
K478:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl188
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl188:
jmp @r4
mov r0,r2
! Opcode 0479
K479:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl189
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl189:
jmp @r4
mov r0,r2
! Opcodes 0480 - 0487
K480:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl190
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl190:
jmp @r4
mov r0,r2
! Opcodes 0490 - 0497
K490:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl191
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl191:
jmp @r4
mov r0,r2
! Opcodes 0498 - 049F
K498:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl192
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl192:
jmp @r4
mov r0,r2
! Opcodes 04A0 - 04A7
K4A0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl193
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl193:
jmp @r4
mov r0,r2
! Opcodes 04A8 - 04AF
K4A8:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl194
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl194:
jmp @r4
mov r0,r2
! Opcodes 04B0 - 04B7
K4B0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl195
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl195:
jmp @r4
mov r0,r2
! Opcode 04B8
K4B8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl196
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl196:
jmp @r4
mov r0,r2
! Opcode 04B9
K4B9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-36,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl197
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl197:
jmp @r4
mov r0,r2
! Opcodes 0500 - 0507
K500:
and r1,r2
mov #8,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl198
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl198:
jmp @r4
mov r0,r2
! Opcodes 0508 - 050F
K508:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #8,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl199
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl199:
jmp @r4
mov r0,r2
! Opcodes 0510 - 0517
K510:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl200
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl200:
jmp @r4
mov r0,r2
! Opcodes 0518 - 051F
K518:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl201
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl201:
jmp @r4
mov r0,r2
! Opcodes 0520 - 0527
K520:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl202
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl202:
jmp @r4
mov r0,r2
! Opcodes 0528 - 052F
K528:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl203
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl203:
jmp @r4
mov r0,r2
! Opcodes 0530 - 0537
K530:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl204
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl204:
jmp @r4
mov r0,r2
! Opcode 0538
K538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl205
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl205:
jmp @r4
mov r0,r2
! Opcode 0539
K539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl206
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl206:
jmp @r4
mov r0,r2
! Opcode 053A
K53A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl207
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl207:
jmp @r4
mov r0,r2
! Opcode 053B
K53B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl208
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl208:
jmp @r4
mov r0,r2
! Opcode 053C
K53C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl209
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl209:
jmp @r4
mov r0,r2
! Opcodes 0540 - 0547
K540:
and r1,r2
mov #8,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
xor r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl210
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl210:
jmp @r4
mov r0,r2
! Opcodes 0548 - 054F
K548:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(8,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl211
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl211:
jmp @r4
mov r0,r2
! Opcodes 0550 - 0557
K550:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl212
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl212:
jmp @r4
mov r0,r2
! Opcodes 0558 - 055F
K558:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl213
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl213:
jmp @r4
mov r0,r2
! Opcodes 0560 - 0567
K560:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl214
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl214:
jmp @r4
mov r0,r2
! Opcodes 0568 - 056F
K568:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl215
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl215:
jmp @r4
mov r0,r2
! Opcodes 0570 - 0577
K570:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl216
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl216:
jmp @r4
mov r0,r2
! Opcode 0578
K578:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl217
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl217:
jmp @r4
mov r0,r2
! Opcode 0579
K579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl218
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl218:
jmp @r4
mov r0,r2
! Opcodes 0580 - 0587
K580:
and r1,r2
mov #8,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
not r4,r4
and r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl219
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl219:
jmp @r4
mov r0,r2
! Opcodes 0588 - 058F
K588:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(8,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl220
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl220:
jmp @r4
mov r0,r2
! Opcodes 0590 - 0597
K590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl221
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl221:
jmp @r4
mov r0,r2
! Opcodes 0598 - 059F
K598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl222
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl222:
jmp @r4
mov r0,r2
! Opcodes 05A0 - 05A7
K5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl223
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl223:
jmp @r4
mov r0,r2
! Opcodes 05A8 - 05AF
K5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl224
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl224:
jmp @r4
mov r0,r2
! Opcodes 05B0 - 05B7
K5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl225
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl225:
jmp @r4
mov r0,r2
! Opcode 05B8
K5B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl226
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl226:
jmp @r4
mov r0,r2
! Opcode 05B9
K5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl227
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl227:
jmp @r4
mov r0,r2
! Opcodes 05C0 - 05C7
K5C0:
and r1,r2
mov #8,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
or r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl228
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl228:
jmp @r4
mov r0,r2
! Opcodes 05C8 - 05CF
K5C8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(8,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl229
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl229:
jmp @r4
mov r0,r2
! Opcodes 05D0 - 05D7
K5D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl230
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl230:
jmp @r4
mov r0,r2
! Opcodes 05D8 - 05DF
K5D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl231
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl231:
jmp @r4
mov r0,r2
! Opcodes 05E0 - 05E7
K5E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl232
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl232:
jmp @r4
mov r0,r2
! Opcodes 05E8 - 05EF
K5E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl233
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl233:
jmp @r4
mov r0,r2
! Opcodes 05F0 - 05F7
K5F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl234
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl234:
jmp @r4
mov r0,r2
! Opcode 05F8
K5F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl235
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl235:
jmp @r4
mov r0,r2
! Opcode 05F9
K5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl236
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl236:
jmp @r4
mov r0,r2
! Opcodes 0600 - 0607
K600:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl237
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl237:
jmp @r4
mov r0,r2
! Opcodes 0610 - 0617
K610:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl238
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl238:
jmp @r4
mov r0,r2
! Opcodes 0618 - 061F
K618:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl239
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl239:
jmp @r4
mov r0,r2
! Opcodes 0620 - 0627
K620:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl240
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl240:
jmp @r4
mov r0,r2
! Opcodes 0628 - 062F
K628:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl241
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl241:
jmp @r4
mov r0,r2
! Opcodes 0630 - 0637
K630:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl242
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl242:
jmp @r4
mov r0,r2
! Opcode 0638
K638:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl243
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl243:
jmp @r4
mov r0,r2
! Opcode 0639
K639:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl244
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl244:
jmp @r4
mov r0,r2
! Opcodes 0640 - 0647
K640:
and r1,r2
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl245
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl245:
jmp @r4
mov r0,r2
! Opcodes 0650 - 0657
K650:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl246
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl246:
jmp @r4
mov r0,r2
! Opcodes 0658 - 065F
K658:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl247
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl247:
jmp @r4
mov r0,r2
! Opcodes 0660 - 0667
K660:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl248
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl248:
jmp @r4
mov r0,r2
! Opcodes 0668 - 066F
K668:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl249
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl249:
jmp @r4
mov r0,r2
! Opcodes 0670 - 0677
K670:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl250
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl250:
jmp @r4
mov r0,r2
! Opcode 0678
K678:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl251
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl251:
jmp @r4
mov r0,r2
! Opcode 0679
K679:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl252
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl252:
jmp @r4
mov r0,r2
! Opcodes 0680 - 0687
K680:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl253
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl253:
jmp @r4
mov r0,r2
! Opcodes 0690 - 0697
K690:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl254
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl254:
jmp @r4
mov r0,r2
! Opcodes 0698 - 069F
K698:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl255
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl255:
jmp @r4
mov r0,r2
! Opcodes 06A0 - 06A7
K6A0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl256
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl256:
jmp @r4
mov r0,r2
! Opcodes 06A8 - 06AF
K6A8:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl257
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl257:
jmp @r4
mov r0,r2
! Opcodes 06B0 - 06B7
K6B0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl258
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl258:
jmp @r4
mov r0,r2
! Opcode 06B8
K6B8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl259
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl259:
jmp @r4
mov r0,r2
! Opcode 06B9
K6B9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-36,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl260
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl260:
jmp @r4
mov r0,r2
! Opcodes 0700 - 0707
K700:
and r1,r2
mov #12,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl261
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl261:
jmp @r4
mov r0,r2
! Opcodes 0708 - 070F
K708:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #12,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl262
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl262:
jmp @r4
mov r0,r2
! Opcodes 0710 - 0717
K710:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl263
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl263:
jmp @r4
mov r0,r2
! Opcodes 0718 - 071F
K718:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl264
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl264:
jmp @r4
mov r0,r2
! Opcodes 0720 - 0727
K720:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl265
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl265:
jmp @r4
mov r0,r2
! Opcodes 0728 - 072F
K728:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl266
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl266:
jmp @r4
mov r0,r2
! Opcodes 0730 - 0737
K730:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl267
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl267:
jmp @r4
mov r0,r2
! Opcode 0738
K738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl268
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl268:
jmp @r4
mov r0,r2
! Opcode 0739
K739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl269
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl269:
jmp @r4
mov r0,r2
! Opcode 073A
K73A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl270
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl270:
jmp @r4
mov r0,r2
! Opcode 073B
K73B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl271
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl271:
jmp @r4
mov r0,r2
! Opcode 073C
K73C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl272
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl272:
jmp @r4
mov r0,r2
! Opcodes 0740 - 0747
K740:
and r1,r2
mov #12,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
xor r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl273
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl273:
jmp @r4
mov r0,r2
! Opcodes 0748 - 074F
K748:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(12,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl274
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl274:
jmp @r4
mov r0,r2
! Opcodes 0750 - 0757
K750:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl275
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl275:
jmp @r4
mov r0,r2
! Opcodes 0758 - 075F
K758:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl276
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl276:
jmp @r4
mov r0,r2
! Opcodes 0760 - 0767
K760:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl277
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl277:
jmp @r4
mov r0,r2
! Opcodes 0768 - 076F
K768:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl278
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl278:
jmp @r4
mov r0,r2
! Opcodes 0770 - 0777
K770:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl279
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl279:
jmp @r4
mov r0,r2
! Opcode 0778
K778:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl280
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl280:
jmp @r4
mov r0,r2
! Opcode 0779
K779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl281
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl281:
jmp @r4
mov r0,r2
! Opcodes 0780 - 0787
K780:
and r1,r2
mov #12,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
not r4,r4
and r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl282
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl282:
jmp @r4
mov r0,r2
! Opcodes 0788 - 078F
K788:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(12,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl283
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl283:
jmp @r4
mov r0,r2
! Opcodes 0790 - 0797
K790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl284
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl284:
jmp @r4
mov r0,r2
! Opcodes 0798 - 079F
K798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl285
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl285:
jmp @r4
mov r0,r2
! Opcodes 07A0 - 07A7
K7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl286
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl286:
jmp @r4
mov r0,r2
! Opcodes 07A8 - 07AF
K7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl287
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl287:
jmp @r4
mov r0,r2
! Opcodes 07B0 - 07B7
K7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl288
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl288:
jmp @r4
mov r0,r2
! Opcode 07B8
K7B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl289
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl289:
jmp @r4
mov r0,r2
! Opcode 07B9
K7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl290
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl290:
jmp @r4
mov r0,r2
! Opcodes 07C0 - 07C7
K7C0:
and r1,r2
mov #12,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
or r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl291
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl291:
jmp @r4
mov r0,r2
! Opcodes 07C8 - 07CF
K7C8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(12,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl292
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl292:
jmp @r4
mov r0,r2
! Opcodes 07D0 - 07D7
K7D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl293
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl293:
jmp @r4
mov r0,r2
! Opcodes 07D8 - 07DF
K7D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl294
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl294:
jmp @r4
mov r0,r2
! Opcodes 07E0 - 07E7
K7E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl295
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl295:
jmp @r4
mov r0,r2
! Opcodes 07E8 - 07EF
K7E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl296
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl296:
jmp @r4
mov r0,r2
! Opcodes 07F0 - 07F7
K7F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl297
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl297:
jmp @r4
mov r0,r2
! Opcode 07F8
K7F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl298
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl298:
jmp @r4
mov r0,r2
! Opcode 07F9
K7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl299
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl299:
jmp @r4
mov r0,r2
! Opcodes 0800 - 0807
K800:
and r1,r2
mov.w @r6+,r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl300
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl300:
jmp @r4
mov r0,r2
! Opcodes 0810 - 0817
K810:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl301
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl301:
jmp @r4
mov r0,r2
! Opcodes 0818 - 081F
K818:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl302
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl302:
jmp @r4
mov r0,r2
! Opcodes 0820 - 0827
K820:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl303
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl303:
jmp @r4
mov r0,r2
! Opcodes 0828 - 082F
K828:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl304
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl304:
jmp @r4
mov r0,r2
! Opcodes 0830 - 0837
K830:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl305
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl305:
jmp @r4
mov r0,r2
! Opcode 0838
K838:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl306
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl306:
jmp @r4
mov r0,r2
! Opcode 0839
K839:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl307
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl307:
jmp @r4
mov r0,r2
! Opcode 083A
K83A:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl308
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl308:
jmp @r4
mov r0,r2
! Opcode 083B
K83B:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl309
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl309:
jmp @r4
mov r0,r2
! Opcode 083C
K83C:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.b @r6,r3
add #2,r6
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl310
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl310:
jmp @r4
mov r0,r2
! Opcodes 0840 - 0847
K840:
and r1,r2
mov.w @r6+,r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
xor r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl311
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl311:
jmp @r4
mov r0,r2
! Opcodes 0850 - 0857
K850:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl312
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl312:
jmp @r4
mov r0,r2
! Opcodes 0858 - 085F
K858:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl313
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl313:
jmp @r4
mov r0,r2
! Opcodes 0860 - 0867
K860:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl314
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl314:
jmp @r4
mov r0,r2
! Opcodes 0868 - 086F
K868:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl315
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl315:
jmp @r4
mov r0,r2
! Opcodes 0870 - 0877
K870:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl316
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl316:
jmp @r4
mov r0,r2
! Opcode 0878
K878:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl317
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl317:
jmp @r4
mov r0,r2
! Opcode 0879
K879:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl318
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl318:
jmp @r4
mov r0,r2
! Opcodes 0880 - 0887
K880:
and r1,r2
mov.w @r6+,r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
not r4,r4
and r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl319
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl319:
jmp @r4
mov r0,r2
! Opcodes 0890 - 0897
K890:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl320
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl320:
jmp @r4
mov r0,r2
! Opcodes 0898 - 089F
K898:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl321
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl321:
jmp @r4
mov r0,r2
! Opcodes 08A0 - 08A7
K8A0:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl322
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl322:
jmp @r4
mov r0,r2
! Opcodes 08A8 - 08AF
K8A8:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl323
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl323:
jmp @r4
mov r0,r2
! Opcodes 08B0 - 08B7
K8B0:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl324
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl324:
jmp @r4
mov r0,r2
! Opcode 08B8
K8B8:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl325
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl325:
jmp @r4
mov r0,r2
! Opcode 08B9
K8B9:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl326
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl326:
jmp @r4
mov r0,r2
! Opcodes 08C0 - 08C7
K8C0:
and r1,r2
mov.w @r6+,r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
or r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl327
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl327:
jmp @r4
mov r0,r2
! Opcodes 08D0 - 08D7
K8D0:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl328
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl328:
jmp @r4
mov r0,r2
! Opcodes 08D8 - 08DF
K8D8:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl329
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl329:
jmp @r4
mov r0,r2
! Opcodes 08E0 - 08E7
K8E0:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl330
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl330:
jmp @r4
mov r0,r2
! Opcodes 08E8 - 08EF
K8E8:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl331
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl331:
jmp @r4
mov r0,r2
! Opcodes 08F0 - 08F7
K8F0:
and r1,r2
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl332
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl332:
jmp @r4
mov r0,r2
! Opcode 08F8
K8F8:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl333
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl333:
jmp @r4
mov r0,r2
! Opcode 08F9
K8F9:
mov.w @r6+,r0
and #7,r0
mov.l r0,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl334
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl334:
jmp @r4
mov r0,r2
! Opcodes 0900 - 0907
K900:
and r1,r2
mov #16,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl335
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl335:
jmp @r4
mov r0,r2
! Opcodes 0908 - 090F
K908:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #16,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl336
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl336:
jmp @r4
mov r0,r2
! Opcodes 0910 - 0917
K910:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl337
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl337:
jmp @r4
mov r0,r2
! Opcodes 0918 - 091F
K918:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl338
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl338:
jmp @r4
mov r0,r2
! Opcodes 0920 - 0927
K920:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl339
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl339:
jmp @r4
mov r0,r2
! Opcodes 0928 - 092F
K928:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl340
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl340:
jmp @r4
mov r0,r2
! Opcodes 0930 - 0937
K930:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl341
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl341:
jmp @r4
mov r0,r2
! Opcode 0938
K938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl342
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl342:
jmp @r4
mov r0,r2
! Opcode 0939
K939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl343
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl343:
jmp @r4
mov r0,r2
! Opcode 093A
K93A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl344
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl344:
jmp @r4
mov r0,r2
! Opcode 093B
K93B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl345
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl345:
jmp @r4
mov r0,r2
! Opcode 093C
K93C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl346
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl346:
jmp @r4
mov r0,r2
! Opcodes 0940 - 0947
K940:
and r1,r2
mov #16,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
xor r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl347
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl347:
jmp @r4
mov r0,r2
! Opcodes 0948 - 094F
K948:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(16,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl348
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl348:
jmp @r4
mov r0,r2
! Opcodes 0950 - 0957
K950:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl349
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl349:
jmp @r4
mov r0,r2
! Opcodes 0958 - 095F
K958:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl350
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl350:
jmp @r4
mov r0,r2
! Opcodes 0960 - 0967
K960:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl351
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl351:
jmp @r4
mov r0,r2
! Opcodes 0968 - 096F
K968:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl352
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl352:
jmp @r4
mov r0,r2
! Opcodes 0970 - 0977
K970:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl353
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl353:
jmp @r4
mov r0,r2
! Opcode 0978
K978:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl354
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl354:
jmp @r4
mov r0,r2
! Opcode 0979
K979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl355
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl355:
jmp @r4
mov r0,r2
! Opcodes 0980 - 0987
K980:
and r1,r2
mov #16,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
not r4,r4
and r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl356
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl356:
jmp @r4
mov r0,r2
! Opcodes 0988 - 098F
K988:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(16,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl357
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl357:
jmp @r4
mov r0,r2
! Opcodes 0990 - 0997
K990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl358
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl358:
jmp @r4
mov r0,r2
! Opcodes 0998 - 099F
K998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl359
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl359:
jmp @r4
mov r0,r2
! Opcodes 09A0 - 09A7
K9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl360
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl360:
jmp @r4
mov r0,r2
! Opcodes 09A8 - 09AF
K9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl361
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl361:
jmp @r4
mov r0,r2
! Opcodes 09B0 - 09B7
K9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl362
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl362:
jmp @r4
mov r0,r2
! Opcode 09B8
K9B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl363
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl363:
jmp @r4
mov r0,r2
! Opcode 09B9
K9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl364
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl364:
jmp @r4
mov r0,r2
! Opcodes 09C0 - 09C7
K9C0:
and r1,r2
mov #16,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
or r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl365
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl365:
jmp @r4
mov r0,r2
! Opcodes 09C8 - 09CF
K9C8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(16,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl366
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl366:
jmp @r4
mov r0,r2
! Opcodes 09D0 - 09D7
K9D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl367
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl367:
jmp @r4
mov r0,r2
! Opcodes 09D8 - 09DF
K9D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl368
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl368:
jmp @r4
mov r0,r2
! Opcodes 09E0 - 09E7
K9E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl369
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl369:
jmp @r4
mov r0,r2
! Opcodes 09E8 - 09EF
K9E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl370
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl370:
jmp @r4
mov r0,r2
! Opcodes 09F0 - 09F7
K9F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl371
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl371:
jmp @r4
mov r0,r2
! Opcode 09F8
K9F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl372
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl372:
jmp @r4
mov r0,r2
! Opcode 09F9
K9F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl373
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl373:
jmp @r4
mov r0,r2
! Opcodes 0A00 - 0A07
KA00:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
xor r1,r3
mov.b r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl374
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl374:
jmp @r4
mov r0,r2
! Opcodes 0A10 - 0A17
KA10:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl375
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl375:
jmp @r4
mov r0,r2
! Opcodes 0A18 - 0A1F
KA18:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl376
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl376:
jmp @r4
mov r0,r2
! Opcodes 0A20 - 0A27
KA20:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl377
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl377:
jmp @r4
mov r0,r2
! Opcodes 0A28 - 0A2F
KA28:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl378
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl378:
jmp @r4
mov r0,r2
! Opcodes 0A30 - 0A37
KA30:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl379
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl379:
jmp @r4
mov r0,r2
! Opcode 0A38
KA38:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl380
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl380:
jmp @r4
mov r0,r2
! Opcode 0A39
KA39:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl381
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl381:
jmp @r4
mov r0,r2
! Opcode 0A3C
KA3C:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
xor r2,r3
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl382
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl382:
jmp @r4
mov r0,r2
! Opcodes 0A40 - 0A47
KA40:
and r1,r2
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
xor r1,r3
mov.w r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl383
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl383:
jmp @r4
mov r0,r2
! Opcodes 0A50 - 0A57
KA50:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl384
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl384:
jmp @r4
mov r0,r2
! Opcodes 0A58 - 0A5F
KA58:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl385
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl385:
jmp @r4
mov r0,r2
! Opcodes 0A60 - 0A67
KA60:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl386
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl386:
jmp @r4
mov r0,r2
! Opcodes 0A68 - 0A6F
KA68:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl387
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl387:
jmp @r4
mov r0,r2
! Opcodes 0A70 - 0A77
KA70:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl388
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl388:
jmp @r4
mov r0,r2
! Opcode 0A78
KA78:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl389
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl389:
jmp @r4
mov r0,r2
! Opcode 0A79
KA79:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl390
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl390:
jmp @r4
mov r0,r2
! Opcode 0A7C
KA7C:
mov r10,r0
tst #0x20,r0
bf pcheck_ok391
mov.l priviolation_addr391,r0
jmp @r0
nop
.align 2
priviolation_addr391: .long privilege_violation
pcheck_ok391:
mov.w @r6+,r2
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
xor r2,r3
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln392
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln392:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue394
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue394:
jmp @r4
mov r0,r2
! Opcodes 0A80 - 0A87
KA80:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
xor r1,r3
mov.l r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl395
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl395:
jmp @r4
mov r0,r2
! Opcodes 0A90 - 0A97
KA90:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl396
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl396:
jmp @r4
mov r0,r2
! Opcodes 0A98 - 0A9F
KA98:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl397
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl397:
jmp @r4
mov r0,r2
! Opcodes 0AA0 - 0AA7
KAA0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl398
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl398:
jmp @r4
mov r0,r2
! Opcodes 0AA8 - 0AAF
KAA8:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl399
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl399:
jmp @r4
mov r0,r2
! Opcodes 0AB0 - 0AB7
KAB0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl400
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl400:
jmp @r4
mov r0,r2
! Opcode 0AB8
KAB8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl401
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl401:
jmp @r4
mov r0,r2
! Opcode 0AB9
KAB9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-36,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl402
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl402:
jmp @r4
mov r0,r2
! Opcodes 0B00 - 0B07
KB00:
and r1,r2
mov #20,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl403
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl403:
jmp @r4
mov r0,r2
! Opcodes 0B08 - 0B0F
KB08:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #20,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl404
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl404:
jmp @r4
mov r0,r2
! Opcodes 0B10 - 0B17
KB10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl405
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl405:
jmp @r4
mov r0,r2
! Opcodes 0B18 - 0B1F
KB18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl406
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl406:
jmp @r4
mov r0,r2
! Opcodes 0B20 - 0B27
KB20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl407
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl407:
jmp @r4
mov r0,r2
! Opcodes 0B28 - 0B2F
KB28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl408
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl408:
jmp @r4
mov r0,r2
! Opcodes 0B30 - 0B37
KB30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl409
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl409:
jmp @r4
mov r0,r2
! Opcode 0B38
KB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl410
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl410:
jmp @r4
mov r0,r2
! Opcode 0B39
KB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl411
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl411:
jmp @r4
mov r0,r2
! Opcode 0B3A
KB3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl412
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl412:
jmp @r4
mov r0,r2
! Opcode 0B3B
KB3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl413
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl413:
jmp @r4
mov r0,r2
! Opcode 0B3C
KB3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl414
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl414:
jmp @r4
mov r0,r2
! Opcodes 0B40 - 0B47
KB40:
and r1,r2
mov #20,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
xor r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl415
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl415:
jmp @r4
mov r0,r2
! Opcodes 0B48 - 0B4F
KB48:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(20,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl416
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl416:
jmp @r4
mov r0,r2
! Opcodes 0B50 - 0B57
KB50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl417
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl417:
jmp @r4
mov r0,r2
! Opcodes 0B58 - 0B5F
KB58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl418
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl418:
jmp @r4
mov r0,r2
! Opcodes 0B60 - 0B67
KB60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl419
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl419:
jmp @r4
mov r0,r2
! Opcodes 0B68 - 0B6F
KB68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl420
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl420:
jmp @r4
mov r0,r2
! Opcodes 0B70 - 0B77
KB70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl421
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl421:
jmp @r4
mov r0,r2
! Opcode 0B78
KB78:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl422
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl422:
jmp @r4
mov r0,r2
! Opcode 0B79
KB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl423
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl423:
jmp @r4
mov r0,r2
! Opcodes 0B80 - 0B87
KB80:
and r1,r2
mov #20,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
not r4,r4
and r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl424
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl424:
jmp @r4
mov r0,r2
! Opcodes 0B88 - 0B8F
KB88:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(20,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl425
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl425:
jmp @r4
mov r0,r2
! Opcodes 0B90 - 0B97
KB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl426
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl426:
jmp @r4
mov r0,r2
! Opcodes 0B98 - 0B9F
KB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl427
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl427:
jmp @r4
mov r0,r2
! Opcodes 0BA0 - 0BA7
KBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl428
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl428:
jmp @r4
mov r0,r2
! Opcodes 0BA8 - 0BAF
KBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl429
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl429:
jmp @r4
mov r0,r2
! Opcodes 0BB0 - 0BB7
KBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl430
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl430:
jmp @r4
mov r0,r2
! Opcode 0BB8
KBB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl431
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl431:
jmp @r4
mov r0,r2
! Opcode 0BB9
KBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl432
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl432:
jmp @r4
mov r0,r2
! Opcodes 0BC0 - 0BC7
KBC0:
and r1,r2
mov #20,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
or r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl433
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl433:
jmp @r4
mov r0,r2
! Opcodes 0BC8 - 0BCF
KBC8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(20,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl434
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl434:
jmp @r4
mov r0,r2
! Opcodes 0BD0 - 0BD7
KBD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl435
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl435:
jmp @r4
mov r0,r2
! Opcodes 0BD8 - 0BDF
KBD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl436
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl436:
jmp @r4
mov r0,r2
! Opcodes 0BE0 - 0BE7
KBE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl437
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl437:
jmp @r4
mov r0,r2
! Opcodes 0BE8 - 0BEF
KBE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl438
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl438:
jmp @r4
mov r0,r2
! Opcodes 0BF0 - 0BF7
KBF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl439
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl439:
jmp @r4
mov r0,r2
! Opcode 0BF8
KBF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl440
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl440:
jmp @r4
mov r0,r2
! Opcode 0BF9
KBF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl441
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl441:
jmp @r4
mov r0,r2
! Opcodes 0C00 - 0C07
KC00:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
add r13,r2
mov.b @r2,r3
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl442
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl442:
jmp @r4
mov r0,r2
! Opcodes 0C10 - 0C17
KC10:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl443
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl443:
jmp @r4
mov r0,r2
! Opcodes 0C18 - 0C1F
KC18:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl444
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl444:
jmp @r4
mov r0,r2
! Opcodes 0C20 - 0C27
KC20:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl445
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl445:
jmp @r4
mov r0,r2
! Opcodes 0C28 - 0C2F
KC28:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl446
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl446:
jmp @r4
mov r0,r2
! Opcodes 0C30 - 0C37
KC30:
and r1,r2
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl447
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl447:
jmp @r4
mov r0,r2
! Opcode 0C38
KC38:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl448
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl448:
jmp @r4
mov r0,r2
! Opcode 0C39
KC39:
mov.w @r6+,r1
exts.b r1,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl449
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl449:
jmp @r4
mov r0,r2
! Opcodes 0C40 - 0C47
KC40:
and r1,r2
mov.w @r6+,r1
add r13,r2
mov.w @r2,r3
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl450
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl450:
jmp @r4
mov r0,r2
! Opcodes 0C50 - 0C57
KC50:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl451
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl451:
jmp @r4
mov r0,r2
! Opcodes 0C58 - 0C5F
KC58:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl452
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl452:
jmp @r4
mov r0,r2
! Opcodes 0C60 - 0C67
KC60:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl453
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl453:
jmp @r4
mov r0,r2
! Opcodes 0C68 - 0C6F
KC68:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl454
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl454:
jmp @r4
mov r0,r2
! Opcodes 0C70 - 0C77
KC70:
and r1,r2
mov.w @r6+,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl455
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl455:
jmp @r4
mov r0,r2
! Opcode 0C78
KC78:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl456
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl456:
jmp @r4
mov r0,r2
! Opcode 0C79
KC79:
mov.w @r6+,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl457
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl457:
jmp @r4
mov r0,r2
! Opcodes 0C80 - 0C87
KC80:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
add r13,r2
mov.l @r2,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl458
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl458:
jmp @r4
mov r0,r2
! Opcodes 0C90 - 0C97
KC90:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl459
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl459:
jmp @r4
mov r0,r2
! Opcodes 0C98 - 0C9F
KC98:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl460
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl460:
jmp @r4
mov r0,r2
! Opcodes 0CA0 - 0CA7
KCA0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl461
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl461:
jmp @r4
mov r0,r2
! Opcodes 0CA8 - 0CAF
KCA8:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl462
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl462:
jmp @r4
mov r0,r2
! Opcodes 0CB0 - 0CB7
KCB0:
and r1,r2
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl463
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl463:
jmp @r4
mov r0,r2
! Opcode 0CB8
KCB8:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl464
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl464:
jmp @r4
mov r0,r2
! Opcode 0CB9
KCB9:
mov.w @r6+,r0
mov.w @r6+,r1
shll16 r1
xtrct r0,r1
mov r1,r8
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r8,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl465
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl465:
jmp @r4
mov r0,r2
! Opcodes 0D00 - 0D07
KD00:
and r1,r2
mov #24,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl466
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl466:
jmp @r4
mov r0,r2
! Opcodes 0D08 - 0D0F
KD08:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #24,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl467
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl467:
jmp @r4
mov r0,r2
! Opcodes 0D10 - 0D17
KD10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl468
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl468:
jmp @r4
mov r0,r2
! Opcodes 0D18 - 0D1F
KD18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl469
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl469:
jmp @r4
mov r0,r2
! Opcodes 0D20 - 0D27
KD20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl470
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl470:
jmp @r4
mov r0,r2
! Opcodes 0D28 - 0D2F
KD28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl471
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl471:
jmp @r4
mov r0,r2
! Opcodes 0D30 - 0D37
KD30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl472
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl472:
jmp @r4
mov r0,r2
! Opcode 0D38
KD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl473
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl473:
jmp @r4
mov r0,r2
! Opcode 0D39
KD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl474
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl474:
jmp @r4
mov r0,r2
! Opcode 0D3A
KD3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl475
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl475:
jmp @r4
mov r0,r2
! Opcode 0D3B
KD3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl476
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl476:
jmp @r4
mov r0,r2
! Opcode 0D3C
KD3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl477
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl477:
jmp @r4
mov r0,r2
! Opcodes 0D40 - 0D47
KD40:
and r1,r2
mov #24,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
xor r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl478
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl478:
jmp @r4
mov r0,r2
! Opcodes 0D48 - 0D4F
KD48:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(24,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl479
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl479:
jmp @r4
mov r0,r2
! Opcodes 0D50 - 0D57
KD50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl480
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl480:
jmp @r4
mov r0,r2
! Opcodes 0D58 - 0D5F
KD58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl481
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl481:
jmp @r4
mov r0,r2
! Opcodes 0D60 - 0D67
KD60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl482
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl482:
jmp @r4
mov r0,r2
! Opcodes 0D68 - 0D6F
KD68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl483
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl483:
jmp @r4
mov r0,r2
! Opcodes 0D70 - 0D77
KD70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl484
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl484:
jmp @r4
mov r0,r2
! Opcode 0D78
KD78:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl485
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl485:
jmp @r4
mov r0,r2
! Opcode 0D79
KD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl486
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl486:
jmp @r4
mov r0,r2
! Opcodes 0D80 - 0D87
KD80:
and r1,r2
mov #24,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
not r4,r4
and r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl487
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl487:
jmp @r4
mov r0,r2
! Opcodes 0D88 - 0D8F
KD88:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(24,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl488
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl488:
jmp @r4
mov r0,r2
! Opcodes 0D90 - 0D97
KD90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl489
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl489:
jmp @r4
mov r0,r2
! Opcodes 0D98 - 0D9F
KD98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl490
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl490:
jmp @r4
mov r0,r2
! Opcodes 0DA0 - 0DA7
KDA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl491
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl491:
jmp @r4
mov r0,r2
! Opcodes 0DA8 - 0DAF
KDA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl492
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl492:
jmp @r4
mov r0,r2
! Opcodes 0DB0 - 0DB7
KDB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl493
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl493:
jmp @r4
mov r0,r2
! Opcode 0DB8
KDB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl494
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl494:
jmp @r4
mov r0,r2
! Opcode 0DB9
KDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl495
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl495:
jmp @r4
mov r0,r2
! Opcodes 0DC0 - 0DC7
KDC0:
and r1,r2
mov #24,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
or r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl496
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl496:
jmp @r4
mov r0,r2
! Opcodes 0DC8 - 0DCF
KDC8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(24,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl497
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl497:
jmp @r4
mov r0,r2
! Opcodes 0DD0 - 0DD7
KDD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl498
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl498:
jmp @r4
mov r0,r2
! Opcodes 0DD8 - 0DDF
KDD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl499
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl499:
jmp @r4
mov r0,r2
! Opcodes 0DE0 - 0DE7
KDE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl500
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl500:
jmp @r4
mov r0,r2
! Opcodes 0DE8 - 0DEF
KDE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl501
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl501:
jmp @r4
mov r0,r2
! Opcodes 0DF0 - 0DF7
KDF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl502
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl502:
jmp @r4
mov r0,r2
! Opcode 0DF8
KDF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl503
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl503:
jmp @r4
mov r0,r2
! Opcode 0DF9
KDF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl504
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl504:
jmp @r4
mov r0,r2
! Opcodes 0F00 - 0F07
KF00:
and r1,r2
mov #28,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl505
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl505:
jmp @r4
mov r0,r2
! Opcodes 0F08 - 0F0F
KF08:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov #28,r0
mov.w r2,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl506
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl506:
jmp @r4
mov r0,r2
! Opcodes 0F10 - 0F17
KF10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl507
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl507:
jmp @r4
mov r0,r2
! Opcodes 0F18 - 0F1F
KF18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl508
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl508:
jmp @r4
mov r0,r2
! Opcodes 0F20 - 0F27
KF20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl509
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl509:
jmp @r4
mov r0,r2
! Opcodes 0F28 - 0F2F
KF28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl510
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl510:
jmp @r4
mov r0,r2
! Opcodes 0F30 - 0F37
KF30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl511
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl511:
jmp @r4
mov r0,r2
! Opcode 0F38
KF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl512
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl512:
jmp @r4
mov r0,r2
! Opcode 0F39
KF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl513
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl513:
jmp @r4
mov r0,r2
! Opcode 0F3A
KF3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl514
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl514:
jmp @r4
mov r0,r2
! Opcode 0F3B
KF3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl515
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl515:
jmp @r4
mov r0,r2
! Opcode 0F3C
KF3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl516
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl516:
jmp @r4
mov r0,r2
! Opcodes 0F40 - 0F47
KF40:
and r1,r2
mov #28,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
xor r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl517
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl517:
jmp @r4
mov r0,r2
! Opcodes 0F48 - 0F4F
KF48:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add r1,r4
mov r3,r2
extu.b r2,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
shll8 r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
extu.b r3,r3
or r3,r2
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
add #2,r4
shll8 r2
extu.b r3,r3
or r3,r2
mov.l r2,@(28,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl518
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl518:
jmp @r4
mov r0,r2
! Opcodes 0F50 - 0F57
KF50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl519
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl519:
jmp @r4
mov r0,r2
! Opcodes 0F58 - 0F5F
KF58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl520
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl520:
jmp @r4
mov r0,r2
! Opcodes 0F60 - 0F67
KF60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl521
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl521:
jmp @r4
mov r0,r2
! Opcodes 0F68 - 0F6F
KF68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl522
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl522:
jmp @r4
mov r0,r2
! Opcodes 0F70 - 0F77
KF70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl523
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl523:
jmp @r4
mov r0,r2
! Opcode 0F78
KF78:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl524
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl524:
jmp @r4
mov r0,r2
! Opcode 0F79
KF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl525
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl525:
jmp @r4
mov r0,r2
! Opcodes 0F80 - 0F87
KF80:
and r1,r2
mov #28,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
not r4,r4
and r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl526
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl526:
jmp @r4
mov r0,r2
! Opcodes 0F88 - 0F8F
KF88:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(28,r13),r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl527
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl527:
jmp @r4
mov r0,r2
! Opcodes 0F90 - 0F97
KF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl528
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl528:
jmp @r4
mov r0,r2
! Opcodes 0F98 - 0F9F
KF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl529
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl529:
jmp @r4
mov r0,r2
! Opcodes 0FA0 - 0FA7
KFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl530
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl530:
jmp @r4
mov r0,r2
! Opcodes 0FA8 - 0FAF
KFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl531
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl531:
jmp @r4
mov r0,r2
! Opcodes 0FB0 - 0FB7
KFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl532
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl532:
jmp @r4
mov r0,r2
! Opcode 0FB8
KFB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl533
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl533:
jmp @r4
mov r0,r2
! Opcode 0FB9
KFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
not r1,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl534
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl534:
jmp @r4
mov r0,r2
! Opcodes 0FC0 - 0FC7
KFC0:
and r1,r2
mov #28,r0
mov.b @(r0,r13),r0
and #31,r0
mov #1,r4
shld r0,r4
add r13,r2
mov.l @r2,r3
tst r4,r3
rotcl r8
or r4,r3
mov.l r3,@r2
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl535
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl535:
jmp @r4
mov r0,r2
! Opcodes 0FC8 - 0FCF
KFC8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(28,r13),r2
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
add #2,r4
swap.w r2,r2
mov r2,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
shlr8 r3
add #2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
mov r2,r3
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl536
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl536:
jmp @r4
mov r0,r2
! Opcodes 0FD0 - 0FD7
KFD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl537
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl537:
jmp @r4
mov r0,r2
! Opcodes 0FD8 - 0FDF
KFD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl538
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl538:
jmp @r4
mov r0,r2
! Opcodes 0FE0 - 0FE7
KFE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl539
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl539:
jmp @r4
mov r0,r2
! Opcodes 0FE8 - 0FEF
KFE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl540
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl540:
jmp @r4
mov r0,r2
! Opcodes 0FF0 - 0FF7
KFF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl541
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl541:
jmp @r4
mov r0,r2
! Opcode 0FF8
KFF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl542
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl542:
jmp @r4
mov r0,r2
! Opcode 0FF9
KFF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r0
and #7,r0
mov #1,r1
shld r0,r1
tst r1,r3
rotcl r8
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r8
movt r3
dt r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl543
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl543:
jmp @r4
mov r0,r2
! Opcodes 1000 - 1007
L000:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl544
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl544:
jmp @r4
mov r0,r2
! Opcodes 1008 - 100F
L008:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl545
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl545:
jmp @r4
mov r0,r2
! Opcodes 1010 - 1017
L010:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl546
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl546:
jmp @r4
mov r0,r2
! Opcodes 1018 - 101F
L018:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl547
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl547:
jmp @r4
mov r0,r2
! Opcodes 1020 - 1027
L020:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl548
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl548:
jmp @r4
mov r0,r2
! Opcodes 1028 - 102F
L028:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl549
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl549:
jmp @r4
mov r0,r2
! Opcodes 1030 - 1037
L030:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl550
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl550:
jmp @r4
mov r0,r2
! Opcode 1038
L038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl551
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl551:
jmp @r4
mov r0,r2
! Opcode 1039
L039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl552
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl552:
jmp @r4
mov r0,r2
! Opcode 103A
L03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl553
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl553:
jmp @r4
mov r0,r2
! Opcode 103B
L03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl554
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl554:
jmp @r4
mov r0,r2
! Opcode 103C
L03C:
mov.b @r6,r3
add #2,r6
mov.b r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl555
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl555:
jmp @r4
mov r0,r2
! Opcodes 1080 - 1087
L080:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl556
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl556:
jmp @r4
mov r0,r2
! Opcodes 1088 - 108F
L088:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl557
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl557:
jmp @r4
mov r0,r2
! Opcodes 1090 - 1097
L090:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl558
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl558:
jmp @r4
mov r0,r2
! Opcodes 1098 - 109F
L098:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl559
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl559:
jmp @r4
mov r0,r2
! Opcodes 10A0 - 10A7
L0A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl560
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl560:
jmp @r4
mov r0,r2
! Opcodes 10A8 - 10AF
L0A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl561
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl561:
jmp @r4
mov r0,r2
! Opcodes 10B0 - 10B7
L0B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl562
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl562:
jmp @r4
mov r0,r2
! Opcode 10B8
L0B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl563
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl563:
jmp @r4
mov r0,r2
! Opcode 10B9
L0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl564
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl564:
jmp @r4
mov r0,r2
! Opcode 10BA
L0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl565
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl565:
jmp @r4
mov r0,r2
! Opcode 10BB
L0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl566
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl566:
jmp @r4
mov r0,r2
! Opcode 10BC
L0BC:
mov.b @r6,r3
add #2,r6
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl567
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl567:
jmp @r4
mov r0,r2
! Opcodes 10C0 - 10C7
L0C0:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl568
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl568:
jmp @r4
mov r0,r2
! Opcodes 10C8 - 10CF
L0C8:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl569
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl569:
jmp @r4
mov r0,r2
! Opcodes 10D0 - 10D7
L0D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl570
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl570:
jmp @r4
mov r0,r2
! Opcodes 10D8 - 10DF
L0D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl571
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl571:
jmp @r4
mov r0,r2
! Opcodes 10E0 - 10E7
L0E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl572
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl572:
jmp @r4
mov r0,r2
! Opcodes 10E8 - 10EF
L0E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl573
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl573:
jmp @r4
mov r0,r2
! Opcodes 10F0 - 10F7
L0F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl574
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl574:
jmp @r4
mov r0,r2
! Opcode 10F8
L0F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl575
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl575:
jmp @r4
mov r0,r2
! Opcode 10F9
L0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl576
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl576:
jmp @r4
mov r0,r2
! Opcode 10FA
L0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl577
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl577:
jmp @r4
mov r0,r2
! Opcode 10FB
L0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl578
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl578:
jmp @r4
mov r0,r2
! Opcode 10FC
L0FC:
mov.b @r6,r3
add #2,r6
mov.l @(32,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl579
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl579:
jmp @r4
mov r0,r2
! Opcodes 1100 - 1107
L100:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl580
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl580:
jmp @r4
mov r0,r2
! Opcodes 1108 - 110F
L108:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl581
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl581:
jmp @r4
mov r0,r2
! Opcodes 1110 - 1117
L110:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl582
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl582:
jmp @r4
mov r0,r2
! Opcodes 1118 - 111F
L118:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl583
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl583:
jmp @r4
mov r0,r2
! Opcodes 1120 - 1127
L120:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl584
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl584:
jmp @r4
mov r0,r2
! Opcodes 1128 - 112F
L128:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl585
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl585:
jmp @r4
mov r0,r2
! Opcodes 1130 - 1137
L130:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl586
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl586:
jmp @r4
mov r0,r2
! Opcode 1138
L138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl587
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl587:
jmp @r4
mov r0,r2
! Opcode 1139
L139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl588
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl588:
jmp @r4
mov r0,r2
! Opcode 113A
L13A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl589
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl589:
jmp @r4
mov r0,r2
! Opcode 113B
L13B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl590
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl590:
jmp @r4
mov r0,r2
! Opcode 113C
L13C:
mov.b @r6,r3
add #2,r6
mov.l @(32,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl591
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl591:
jmp @r4
mov r0,r2
! Opcodes 1140 - 1147
L140:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl592
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl592:
jmp @r4
mov r0,r2
! Opcodes 1148 - 114F
L148:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl593
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl593:
jmp @r4
mov r0,r2
! Opcodes 1150 - 1157
L150:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl594
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl594:
jmp @r4
mov r0,r2
! Opcodes 1158 - 115F
L158:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl595
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl595:
jmp @r4
mov r0,r2
! Opcodes 1160 - 1167
L160:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl596
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl596:
jmp @r4
mov r0,r2
! Opcodes 1168 - 116F
L168:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl597
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl597:
jmp @r4
mov r0,r2
! Opcodes 1170 - 1177
L170:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl598
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl598:
jmp @r4
mov r0,r2
! Opcode 1178
L178:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl599
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl599:
jmp @r4
mov r0,r2
! Opcode 1179
L179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl600
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl600:
jmp @r4
mov r0,r2
! Opcode 117A
L17A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl601
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl601:
jmp @r4
mov r0,r2
! Opcode 117B
L17B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl602
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl602:
jmp @r4
mov r0,r2
! Opcode 117C
L17C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl603
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl603:
jmp @r4
mov r0,r2
! Opcodes 1180 - 1187
L180:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl604
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl604:
jmp @r4
mov r0,r2
! Opcodes 1188 - 118F
L188:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl605
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl605:
jmp @r4
mov r0,r2
! Opcodes 1190 - 1197
L190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl606
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl606:
jmp @r4
mov r0,r2
! Opcodes 1198 - 119F
L198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl607
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl607:
jmp @r4
mov r0,r2
! Opcodes 11A0 - 11A7
L1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl608
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl608:
jmp @r4
mov r0,r2
! Opcodes 11A8 - 11AF
L1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl609
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl609:
jmp @r4
mov r0,r2
! Opcodes 11B0 - 11B7
L1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl610
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl610:
jmp @r4
mov r0,r2
! Opcode 11B8
L1B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl611
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl611:
jmp @r4
mov r0,r2
! Opcode 11B9
L1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl612
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl612:
jmp @r4
mov r0,r2
! Opcode 11BA
L1BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl613
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl613:
jmp @r4
mov r0,r2
! Opcode 11BB
L1BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl614
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl614:
jmp @r4
mov r0,r2
! Opcode 11BC
L1BC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl615
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl615:
jmp @r4
mov r0,r2
! Opcodes 11C0 - 11C7
L1C0:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl616
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl616:
jmp @r4
mov r0,r2
! Opcodes 11C8 - 11CF
L1C8:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl617
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl617:
jmp @r4
mov r0,r2
! Opcodes 11D0 - 11D7
L1D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl618
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl618:
jmp @r4
mov r0,r2
! Opcodes 11D8 - 11DF
L1D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl619
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl619:
jmp @r4
mov r0,r2
! Opcodes 11E0 - 11E7
L1E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl620
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl620:
jmp @r4
mov r0,r2
! Opcodes 11E8 - 11EF
L1E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl621
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl621:
jmp @r4
mov r0,r2
! Opcodes 11F0 - 11F7
L1F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl622
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl622:
jmp @r4
mov r0,r2
! Opcode 11F8
L1F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl623
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl623:
jmp @r4
mov r0,r2
! Opcode 11F9
L1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl624
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl624:
jmp @r4
mov r0,r2
! Opcode 11FA
L1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl625
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl625:
jmp @r4
mov r0,r2
! Opcode 11FB
L1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl626
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl626:
jmp @r4
mov r0,r2
! Opcode 11FC
L1FC:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl627
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl627:
jmp @r4
mov r0,r2
! Opcodes 1200 - 1207
L200:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl628
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl628:
jmp @r4
mov r0,r2
! Opcodes 1208 - 120F
L208:
and r1,r2
add r14,r2
mov.b @r2,r3
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl629
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl629:
jmp @r4
mov r0,r2
! Opcodes 1210 - 1217
L210:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl630
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl630:
jmp @r4
mov r0,r2
! Opcodes 1218 - 121F
L218:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl631
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl631:
jmp @r4
mov r0,r2
! Opcodes 1220 - 1227
L220:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl632
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl632:
jmp @r4
mov r0,r2
! Opcodes 1228 - 122F
L228:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl633
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl633:
jmp @r4
mov r0,r2
! Opcodes 1230 - 1237
L230:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl634
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl634:
jmp @r4
mov r0,r2
! Opcode 1238
L238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl635
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl635:
jmp @r4
mov r0,r2
! Opcode 1239
L239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl636
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl636:
jmp @r4
mov r0,r2
! Opcode 123A
L23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl637
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl637:
jmp @r4
mov r0,r2
! Opcode 123B
L23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl638
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl638:
jmp @r4
mov r0,r2
! Opcode 123C
L23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl639
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl639:
jmp @r4
mov r0,r2
! Opcodes 1280 - 1287
L280:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl640
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl640:
jmp @r4
mov r0,r2
! Opcodes 1288 - 128F
L288:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl641
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl641:
jmp @r4
mov r0,r2
! Opcodes 1290 - 1297
L290:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl642
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl642:
jmp @r4
mov r0,r2
! Opcodes 1298 - 129F
L298:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl643
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl643:
jmp @r4
mov r0,r2
! Opcodes 12A0 - 12A7
L2A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl644
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl644:
jmp @r4
mov r0,r2
! Opcodes 12A8 - 12AF
L2A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl645
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl645:
jmp @r4
mov r0,r2
! Opcodes 12B0 - 12B7
L2B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl646
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl646:
jmp @r4
mov r0,r2
! Opcode 12B8
L2B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl647
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl647:
jmp @r4
mov r0,r2
! Opcode 12B9
L2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl648
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl648:
jmp @r4
mov r0,r2
! Opcode 12BA
L2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl649
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl649:
jmp @r4
mov r0,r2
! Opcode 12BB
L2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl650
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl650:
jmp @r4
mov r0,r2
! Opcode 12BC
L2BC:
mov.b @r6,r3
add #2,r6
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl651
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl651:
jmp @r4
mov r0,r2
! Opcodes 12C0 - 12C7
L2C0:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl652
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl652:
jmp @r4
mov r0,r2
! Opcodes 12C8 - 12CF
L2C8:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl653
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl653:
jmp @r4
mov r0,r2
! Opcodes 12D0 - 12D7
L2D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl654
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl654:
jmp @r4
mov r0,r2
! Opcodes 12D8 - 12DF
L2D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl655
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl655:
jmp @r4
mov r0,r2
! Opcodes 12E0 - 12E7
L2E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl656
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl656:
jmp @r4
mov r0,r2
! Opcodes 12E8 - 12EF
L2E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl657
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl657:
jmp @r4
mov r0,r2
! Opcodes 12F0 - 12F7
L2F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl658
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl658:
jmp @r4
mov r0,r2
! Opcode 12F8
L2F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl659
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl659:
jmp @r4
mov r0,r2
! Opcode 12F9
L2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl660
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl660:
jmp @r4
mov r0,r2
! Opcode 12FA
L2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl661
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl661:
jmp @r4
mov r0,r2
! Opcode 12FB
L2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl662
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl662:
jmp @r4
mov r0,r2
! Opcode 12FC
L2FC:
mov.b @r6,r3
add #2,r6
mov.l @(36,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl663
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl663:
jmp @r4
mov r0,r2
! Opcodes 1300 - 1307
L300:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl664
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl664:
jmp @r4
mov r0,r2
! Opcodes 1308 - 130F
L308:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl665
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl665:
jmp @r4
mov r0,r2
! Opcodes 1310 - 1317
L310:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl666
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl666:
jmp @r4
mov r0,r2
! Opcodes 1318 - 131F
L318:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl667
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl667:
jmp @r4
mov r0,r2
! Opcodes 1320 - 1327
L320:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl668
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl668:
jmp @r4
mov r0,r2
! Opcodes 1328 - 132F
L328:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl669
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl669:
jmp @r4
mov r0,r2
! Opcodes 1330 - 1337
L330:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl670
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl670:
jmp @r4
mov r0,r2
! Opcode 1338
L338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl671
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl671:
jmp @r4
mov r0,r2
! Opcode 1339
L339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl672
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl672:
jmp @r4
mov r0,r2
! Opcode 133A
L33A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl673
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl673:
jmp @r4
mov r0,r2
! Opcode 133B
L33B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl674
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl674:
jmp @r4
mov r0,r2
! Opcode 133C
L33C:
mov.b @r6,r3
add #2,r6
mov.l @(36,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl675
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl675:
jmp @r4
mov r0,r2
! Opcodes 1340 - 1347
L340:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl676
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl676:
jmp @r4
mov r0,r2
! Opcodes 1348 - 134F
L348:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl677
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl677:
jmp @r4
mov r0,r2
! Opcodes 1350 - 1357
L350:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl678
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl678:
jmp @r4
mov r0,r2
! Opcodes 1358 - 135F
L358:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl679
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl679:
jmp @r4
mov r0,r2
! Opcodes 1360 - 1367
L360:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl680
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl680:
jmp @r4
mov r0,r2
! Opcodes 1368 - 136F
L368:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl681
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl681:
jmp @r4
mov r0,r2
! Opcodes 1370 - 1377
L370:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl682
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl682:
jmp @r4
mov r0,r2
! Opcode 1378
L378:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl683
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl683:
jmp @r4
mov r0,r2
! Opcode 1379
L379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl684
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl684:
jmp @r4
mov r0,r2
! Opcode 137A
L37A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl685
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl685:
jmp @r4
mov r0,r2
! Opcode 137B
L37B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl686
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl686:
jmp @r4
mov r0,r2
! Opcode 137C
L37C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl687
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl687:
jmp @r4
mov r0,r2
! Opcodes 1380 - 1387
L380:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl688
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl688:
jmp @r4
mov r0,r2
! Opcodes 1388 - 138F
L388:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl689
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl689:
jmp @r4
mov r0,r2
! Opcodes 1390 - 1397
L390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl690
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl690:
jmp @r4
mov r0,r2
! Opcodes 1398 - 139F
L398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl691
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl691:
jmp @r4
mov r0,r2
! Opcodes 13A0 - 13A7
L3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl692
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl692:
jmp @r4
mov r0,r2
! Opcodes 13A8 - 13AF
L3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl693
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl693:
jmp @r4
mov r0,r2
! Opcodes 13B0 - 13B7
L3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl694
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl694:
jmp @r4
mov r0,r2
! Opcode 13B8
L3B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl695
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl695:
jmp @r4
mov r0,r2
! Opcode 13B9
L3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl696
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl696:
jmp @r4
mov r0,r2
! Opcode 13BA
L3BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl697
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl697:
jmp @r4
mov r0,r2
! Opcode 13BB
L3BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl698
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl698:
jmp @r4
mov r0,r2
! Opcode 13BC
L3BC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl699
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl699:
jmp @r4
mov r0,r2
! Opcodes 13C0 - 13C7
L3C0:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl700
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl700:
jmp @r4
mov r0,r2
! Opcodes 13C8 - 13CF
L3C8:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl701
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl701:
jmp @r4
mov r0,r2
! Opcodes 13D0 - 13D7
L3D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl702
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl702:
jmp @r4
mov r0,r2
! Opcodes 13D8 - 13DF
L3D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl703
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl703:
jmp @r4
mov r0,r2
! Opcodes 13E0 - 13E7
L3E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl704
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl704:
jmp @r4
mov r0,r2
! Opcodes 13E8 - 13EF
L3E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl705
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl705:
jmp @r4
mov r0,r2
! Opcodes 13F0 - 13F7
L3F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl706
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl706:
jmp @r4
mov r0,r2
! Opcode 13F8
L3F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl707
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl707:
jmp @r4
mov r0,r2
! Opcode 13F9
L3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl708
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl708:
jmp @r4
mov r0,r2
! Opcode 13FA
L3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl709
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl709:
jmp @r4
mov r0,r2
! Opcode 13FB
L3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl710
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl710:
jmp @r4
mov r0,r2
! Opcode 13FC
L3FC:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl711
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl711:
jmp @r4
mov r0,r2
! Opcodes 1400 - 1407
L400:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl712
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl712:
jmp @r4
mov r0,r2
! Opcodes 1408 - 140F
L408:
and r1,r2
add r14,r2
mov.b @r2,r3
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl713
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl713:
jmp @r4
mov r0,r2
! Opcodes 1410 - 1417
L410:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl714
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl714:
jmp @r4
mov r0,r2
! Opcodes 1418 - 141F
L418:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl715
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl715:
jmp @r4
mov r0,r2
! Opcodes 1420 - 1427
L420:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl716
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl716:
jmp @r4
mov r0,r2
! Opcodes 1428 - 142F
L428:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl717
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl717:
jmp @r4
mov r0,r2
! Opcodes 1430 - 1437
L430:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl718
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl718:
jmp @r4
mov r0,r2
! Opcode 1438
L438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl719
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl719:
jmp @r4
mov r0,r2
! Opcode 1439
L439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl720
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl720:
jmp @r4
mov r0,r2
! Opcode 143A
L43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl721
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl721:
jmp @r4
mov r0,r2
! Opcode 143B
L43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl722
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl722:
jmp @r4
mov r0,r2
! Opcode 143C
L43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl723
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl723:
jmp @r4
mov r0,r2
! Opcodes 1480 - 1487
L480:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl724
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl724:
jmp @r4
mov r0,r2
! Opcodes 1488 - 148F
L488:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl725
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl725:
jmp @r4
mov r0,r2
! Opcodes 1490 - 1497
L490:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl726
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl726:
jmp @r4
mov r0,r2
! Opcodes 1498 - 149F
L498:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl727
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl727:
jmp @r4
mov r0,r2
! Opcodes 14A0 - 14A7
L4A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl728
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl728:
jmp @r4
mov r0,r2
! Opcodes 14A8 - 14AF
L4A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl729
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl729:
jmp @r4
mov r0,r2
! Opcodes 14B0 - 14B7
L4B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl730
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl730:
jmp @r4
mov r0,r2
! Opcode 14B8
L4B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl731
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl731:
jmp @r4
mov r0,r2
! Opcode 14B9
L4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl732
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl732:
jmp @r4
mov r0,r2
! Opcode 14BA
L4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl733
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl733:
jmp @r4
mov r0,r2
! Opcode 14BB
L4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl734
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl734:
jmp @r4
mov r0,r2
! Opcode 14BC
L4BC:
mov.b @r6,r3
add #2,r6
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl735
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl735:
jmp @r4
mov r0,r2
! Opcodes 14C0 - 14C7
L4C0:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl736
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl736:
jmp @r4
mov r0,r2
! Opcodes 14C8 - 14CF
L4C8:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl737
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl737:
jmp @r4
mov r0,r2
! Opcodes 14D0 - 14D7
L4D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl738
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl738:
jmp @r4
mov r0,r2
! Opcodes 14D8 - 14DF
L4D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl739
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl739:
jmp @r4
mov r0,r2
! Opcodes 14E0 - 14E7
L4E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl740
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl740:
jmp @r4
mov r0,r2
! Opcodes 14E8 - 14EF
L4E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl741
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl741:
jmp @r4
mov r0,r2
! Opcodes 14F0 - 14F7
L4F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl742
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl742:
jmp @r4
mov r0,r2
! Opcode 14F8
L4F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl743
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl743:
jmp @r4
mov r0,r2
! Opcode 14F9
L4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl744
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl744:
jmp @r4
mov r0,r2
! Opcode 14FA
L4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl745
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl745:
jmp @r4
mov r0,r2
! Opcode 14FB
L4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl746
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl746:
jmp @r4
mov r0,r2
! Opcode 14FC
L4FC:
mov.b @r6,r3
add #2,r6
mov.l @(40,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl747
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl747:
jmp @r4
mov r0,r2
! Opcodes 1500 - 1507
L500:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl748
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl748:
jmp @r4
mov r0,r2
! Opcodes 1508 - 150F
L508:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl749
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl749:
jmp @r4
mov r0,r2
! Opcodes 1510 - 1517
L510:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl750
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl750:
jmp @r4
mov r0,r2
! Opcodes 1518 - 151F
L518:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl751
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl751:
jmp @r4
mov r0,r2
! Opcodes 1520 - 1527
L520:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl752
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl752:
jmp @r4
mov r0,r2
! Opcodes 1528 - 152F
L528:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl753
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl753:
jmp @r4
mov r0,r2
! Opcodes 1530 - 1537
L530:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl754
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl754:
jmp @r4
mov r0,r2
! Opcode 1538
L538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl755
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl755:
jmp @r4
mov r0,r2
! Opcode 1539
L539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl756
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl756:
jmp @r4
mov r0,r2
! Opcode 153A
L53A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl757
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl757:
jmp @r4
mov r0,r2
! Opcode 153B
L53B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl758
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl758:
jmp @r4
mov r0,r2
! Opcode 153C
L53C:
mov.b @r6,r3
add #2,r6
mov.l @(40,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl759
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl759:
jmp @r4
mov r0,r2
! Opcodes 1540 - 1547
L540:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl760
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl760:
jmp @r4
mov r0,r2
! Opcodes 1548 - 154F
L548:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl761
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl761:
jmp @r4
mov r0,r2
! Opcodes 1550 - 1557
L550:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl762
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl762:
jmp @r4
mov r0,r2
! Opcodes 1558 - 155F
L558:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl763
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl763:
jmp @r4
mov r0,r2
! Opcodes 1560 - 1567
L560:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl764
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl764:
jmp @r4
mov r0,r2
! Opcodes 1568 - 156F
L568:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl765
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl765:
jmp @r4
mov r0,r2
! Opcodes 1570 - 1577
L570:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl766
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl766:
jmp @r4
mov r0,r2
! Opcode 1578
L578:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl767
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl767:
jmp @r4
mov r0,r2
! Opcode 1579
L579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl768
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl768:
jmp @r4
mov r0,r2
! Opcode 157A
L57A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl769
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl769:
jmp @r4
mov r0,r2
! Opcode 157B
L57B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl770
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl770:
jmp @r4
mov r0,r2
! Opcode 157C
L57C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl771
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl771:
jmp @r4
mov r0,r2
! Opcodes 1580 - 1587
L580:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl772
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl772:
jmp @r4
mov r0,r2
! Opcodes 1588 - 158F
L588:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl773
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl773:
jmp @r4
mov r0,r2
! Opcodes 1590 - 1597
L590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl774
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl774:
jmp @r4
mov r0,r2
! Opcodes 1598 - 159F
L598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl775
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl775:
jmp @r4
mov r0,r2
! Opcodes 15A0 - 15A7
L5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl776
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl776:
jmp @r4
mov r0,r2
! Opcodes 15A8 - 15AF
L5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl777
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl777:
jmp @r4
mov r0,r2
! Opcodes 15B0 - 15B7
L5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl778
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl778:
jmp @r4
mov r0,r2
! Opcode 15B8
L5B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl779
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl779:
jmp @r4
mov r0,r2
! Opcode 15B9
L5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl780
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl780:
jmp @r4
mov r0,r2
! Opcode 15BA
L5BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl781
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl781:
jmp @r4
mov r0,r2
! Opcode 15BB
L5BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl782
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl782:
jmp @r4
mov r0,r2
! Opcode 15BC
L5BC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl783
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl783:
jmp @r4
mov r0,r2
! Opcodes 1600 - 1607
L600:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl784
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl784:
jmp @r4
mov r0,r2
! Opcodes 1608 - 160F
L608:
and r1,r2
add r14,r2
mov.b @r2,r3
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl785
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl785:
jmp @r4
mov r0,r2
! Opcodes 1610 - 1617
L610:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl786
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl786:
jmp @r4
mov r0,r2
! Opcodes 1618 - 161F
L618:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl787
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl787:
jmp @r4
mov r0,r2
! Opcodes 1620 - 1627
L620:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl788
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl788:
jmp @r4
mov r0,r2
! Opcodes 1628 - 162F
L628:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl789
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl789:
jmp @r4
mov r0,r2
! Opcodes 1630 - 1637
L630:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl790
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl790:
jmp @r4
mov r0,r2
! Opcode 1638
L638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl791
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl791:
jmp @r4
mov r0,r2
! Opcode 1639
L639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl792
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl792:
jmp @r4
mov r0,r2
! Opcode 163A
L63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl793
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl793:
jmp @r4
mov r0,r2
! Opcode 163B
L63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl794
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl794:
jmp @r4
mov r0,r2
! Opcode 163C
L63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl795
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl795:
jmp @r4
mov r0,r2
! Opcodes 1680 - 1687
L680:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl796
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl796:
jmp @r4
mov r0,r2
! Opcodes 1688 - 168F
L688:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl797
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl797:
jmp @r4
mov r0,r2
! Opcodes 1690 - 1697
L690:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl798
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl798:
jmp @r4
mov r0,r2
! Opcodes 1698 - 169F
L698:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl799
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl799:
jmp @r4
mov r0,r2
! Opcodes 16A0 - 16A7
L6A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl800
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl800:
jmp @r4
mov r0,r2
! Opcodes 16A8 - 16AF
L6A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl801
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl801:
jmp @r4
mov r0,r2
! Opcodes 16B0 - 16B7
L6B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl802
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl802:
jmp @r4
mov r0,r2
! Opcode 16B8
L6B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl803
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl803:
jmp @r4
mov r0,r2
! Opcode 16B9
L6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl804
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl804:
jmp @r4
mov r0,r2
! Opcode 16BA
L6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl805
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl805:
jmp @r4
mov r0,r2
! Opcode 16BB
L6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl806
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl806:
jmp @r4
mov r0,r2
! Opcode 16BC
L6BC:
mov.b @r6,r3
add #2,r6
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl807
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl807:
jmp @r4
mov r0,r2
! Opcodes 16C0 - 16C7
L6C0:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl808
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl808:
jmp @r4
mov r0,r2
! Opcodes 16C8 - 16CF
L6C8:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl809
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl809:
jmp @r4
mov r0,r2
! Opcodes 16D0 - 16D7
L6D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl810
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl810:
jmp @r4
mov r0,r2
! Opcodes 16D8 - 16DF
L6D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl811
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl811:
jmp @r4
mov r0,r2
! Opcodes 16E0 - 16E7
L6E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl812
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl812:
jmp @r4
mov r0,r2
! Opcodes 16E8 - 16EF
L6E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl813
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl813:
jmp @r4
mov r0,r2
! Opcodes 16F0 - 16F7
L6F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl814
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl814:
jmp @r4
mov r0,r2
! Opcode 16F8
L6F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl815
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl815:
jmp @r4
mov r0,r2
! Opcode 16F9
L6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl816
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl816:
jmp @r4
mov r0,r2
! Opcode 16FA
L6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl817
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl817:
jmp @r4
mov r0,r2
! Opcode 16FB
L6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl818
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl818:
jmp @r4
mov r0,r2
! Opcode 16FC
L6FC:
mov.b @r6,r3
add #2,r6
mov.l @(44,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl819
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl819:
jmp @r4
mov r0,r2
! Opcodes 1700 - 1707
L700:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl820
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl820:
jmp @r4
mov r0,r2
! Opcodes 1708 - 170F
L708:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl821
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl821:
jmp @r4
mov r0,r2
! Opcodes 1710 - 1717
L710:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl822
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl822:
jmp @r4
mov r0,r2
! Opcodes 1718 - 171F
L718:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl823
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl823:
jmp @r4
mov r0,r2
! Opcodes 1720 - 1727
L720:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl824
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl824:
jmp @r4
mov r0,r2
! Opcodes 1728 - 172F
L728:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl825
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl825:
jmp @r4
mov r0,r2
! Opcodes 1730 - 1737
L730:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl826
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl826:
jmp @r4
mov r0,r2
! Opcode 1738
L738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl827
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl827:
jmp @r4
mov r0,r2
! Opcode 1739
L739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl828
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl828:
jmp @r4
mov r0,r2
! Opcode 173A
L73A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl829
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl829:
jmp @r4
mov r0,r2
! Opcode 173B
L73B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl830
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl830:
jmp @r4
mov r0,r2
! Opcode 173C
L73C:
mov.b @r6,r3
add #2,r6
mov.l @(44,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl831
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl831:
jmp @r4
mov r0,r2
! Opcodes 1740 - 1747
L740:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl832
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl832:
jmp @r4
mov r0,r2
! Opcodes 1748 - 174F
L748:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl833
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl833:
jmp @r4
mov r0,r2
! Opcodes 1750 - 1757
L750:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl834
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl834:
jmp @r4
mov r0,r2
! Opcodes 1758 - 175F
L758:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl835
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl835:
jmp @r4
mov r0,r2
! Opcodes 1760 - 1767
L760:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl836
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl836:
jmp @r4
mov r0,r2
! Opcodes 1768 - 176F
L768:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl837
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl837:
jmp @r4
mov r0,r2
! Opcodes 1770 - 1777
L770:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl838
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl838:
jmp @r4
mov r0,r2
! Opcode 1778
L778:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl839
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl839:
jmp @r4
mov r0,r2
! Opcode 1779
L779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl840
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl840:
jmp @r4
mov r0,r2
! Opcode 177A
L77A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl841
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl841:
jmp @r4
mov r0,r2
! Opcode 177B
L77B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl842
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl842:
jmp @r4
mov r0,r2
! Opcode 177C
L77C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl843
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl843:
jmp @r4
mov r0,r2
! Opcodes 1780 - 1787
L780:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl844
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl844:
jmp @r4
mov r0,r2
! Opcodes 1788 - 178F
L788:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl845
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl845:
jmp @r4
mov r0,r2
! Opcodes 1790 - 1797
L790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl846
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl846:
jmp @r4
mov r0,r2
! Opcodes 1798 - 179F
L798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl847
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl847:
jmp @r4
mov r0,r2
! Opcodes 17A0 - 17A7
L7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl848
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl848:
jmp @r4
mov r0,r2
! Opcodes 17A8 - 17AF
L7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl849
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl849:
jmp @r4
mov r0,r2
! Opcodes 17B0 - 17B7
L7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl850
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl850:
jmp @r4
mov r0,r2
! Opcode 17B8
L7B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl851
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl851:
jmp @r4
mov r0,r2
! Opcode 17B9
L7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl852
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl852:
jmp @r4
mov r0,r2
! Opcode 17BA
L7BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl853
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl853:
jmp @r4
mov r0,r2
! Opcode 17BB
L7BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl854
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl854:
jmp @r4
mov r0,r2
! Opcode 17BC
L7BC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl855
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl855:
jmp @r4
mov r0,r2
! Opcodes 1800 - 1807
L800:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl856
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl856:
jmp @r4
mov r0,r2
! Opcodes 1808 - 180F
L808:
and r1,r2
add r14,r2
mov.b @r2,r3
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl857
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl857:
jmp @r4
mov r0,r2
! Opcodes 1810 - 1817
L810:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl858
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl858:
jmp @r4
mov r0,r2
! Opcodes 1818 - 181F
L818:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl859
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl859:
jmp @r4
mov r0,r2
! Opcodes 1820 - 1827
L820:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl860
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl860:
jmp @r4
mov r0,r2
! Opcodes 1828 - 182F
L828:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl861
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl861:
jmp @r4
mov r0,r2
! Opcodes 1830 - 1837
L830:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl862
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl862:
jmp @r4
mov r0,r2
! Opcode 1838
L838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl863
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl863:
jmp @r4
mov r0,r2
! Opcode 1839
L839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl864
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl864:
jmp @r4
mov r0,r2
! Opcode 183A
L83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl865
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl865:
jmp @r4
mov r0,r2
! Opcode 183B
L83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl866
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl866:
jmp @r4
mov r0,r2
! Opcode 183C
L83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl867
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl867:
jmp @r4
mov r0,r2
! Opcodes 1880 - 1887
L880:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl868
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl868:
jmp @r4
mov r0,r2
! Opcodes 1888 - 188F
L888:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl869
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl869:
jmp @r4
mov r0,r2
! Opcodes 1890 - 1897
L890:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl870
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl870:
jmp @r4
mov r0,r2
! Opcodes 1898 - 189F
L898:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl871
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl871:
jmp @r4
mov r0,r2
! Opcodes 18A0 - 18A7
L8A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl872
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl872:
jmp @r4
mov r0,r2
! Opcodes 18A8 - 18AF
L8A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl873
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl873:
jmp @r4
mov r0,r2
! Opcodes 18B0 - 18B7
L8B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl874
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl874:
jmp @r4
mov r0,r2
! Opcode 18B8
L8B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl875
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl875:
jmp @r4
mov r0,r2
! Opcode 18B9
L8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl876
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl876:
jmp @r4
mov r0,r2
! Opcode 18BA
L8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl877
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl877:
jmp @r4
mov r0,r2
! Opcode 18BB
L8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl878
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl878:
jmp @r4
mov r0,r2
! Opcode 18BC
L8BC:
mov.b @r6,r3
add #2,r6
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl879
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl879:
jmp @r4
mov r0,r2
! Opcodes 18C0 - 18C7
L8C0:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl880
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl880:
jmp @r4
mov r0,r2
! Opcodes 18C8 - 18CF
L8C8:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl881
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl881:
jmp @r4
mov r0,r2
! Opcodes 18D0 - 18D7
L8D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl882
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl882:
jmp @r4
mov r0,r2
! Opcodes 18D8 - 18DF
L8D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl883
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl883:
jmp @r4
mov r0,r2
! Opcodes 18E0 - 18E7
L8E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl884
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl884:
jmp @r4
mov r0,r2
! Opcodes 18E8 - 18EF
L8E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl885
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl885:
jmp @r4
mov r0,r2
! Opcodes 18F0 - 18F7
L8F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl886
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl886:
jmp @r4
mov r0,r2
! Opcode 18F8
L8F8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl887
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl887:
jmp @r4
mov r0,r2
! Opcode 18F9
L8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl888
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl888:
jmp @r4
mov r0,r2
! Opcode 18FA
L8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl889
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl889:
jmp @r4
mov r0,r2
! Opcode 18FB
L8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl890
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl890:
jmp @r4
mov r0,r2
! Opcode 18FC
L8FC:
mov.b @r6,r3
add #2,r6
mov.l @(48,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl891
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl891:
jmp @r4
mov r0,r2
! Opcodes 1900 - 1907
L900:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl892
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl892:
jmp @r4
mov r0,r2
! Opcodes 1908 - 190F
L908:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl893
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl893:
jmp @r4
mov r0,r2
! Opcodes 1910 - 1917
L910:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl894
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl894:
jmp @r4
mov r0,r2
! Opcodes 1918 - 191F
L918:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl895
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl895:
jmp @r4
mov r0,r2
! Opcodes 1920 - 1927
L920:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl896
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl896:
jmp @r4
mov r0,r2
! Opcodes 1928 - 192F
L928:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl897
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl897:
jmp @r4
mov r0,r2
! Opcodes 1930 - 1937
L930:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl898
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl898:
jmp @r4
mov r0,r2
! Opcode 1938
L938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl899
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl899:
jmp @r4
mov r0,r2
! Opcode 1939
L939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl900
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl900:
jmp @r4
mov r0,r2
! Opcode 193A
L93A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl901
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl901:
jmp @r4
mov r0,r2
! Opcode 193B
L93B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl902
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl902:
jmp @r4
mov r0,r2
! Opcode 193C
L93C:
mov.b @r6,r3
add #2,r6
mov.l @(48,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl903
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl903:
jmp @r4
mov r0,r2
! Opcodes 1940 - 1947
L940:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl904
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl904:
jmp @r4
mov r0,r2
! Opcodes 1948 - 194F
L948:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl905
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl905:
jmp @r4
mov r0,r2
! Opcodes 1950 - 1957
L950:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl906
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl906:
jmp @r4
mov r0,r2
! Opcodes 1958 - 195F
L958:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl907
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl907:
jmp @r4
mov r0,r2
! Opcodes 1960 - 1967
L960:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl908
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl908:
jmp @r4
mov r0,r2
! Opcodes 1968 - 196F
L968:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl909
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl909:
jmp @r4
mov r0,r2
! Opcodes 1970 - 1977
L970:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl910
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl910:
jmp @r4
mov r0,r2
! Opcode 1978
L978:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl911
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl911:
jmp @r4
mov r0,r2
! Opcode 1979
L979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl912
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl912:
jmp @r4
mov r0,r2
! Opcode 197A
L97A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl913
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl913:
jmp @r4
mov r0,r2
! Opcode 197B
L97B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl914
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl914:
jmp @r4
mov r0,r2
! Opcode 197C
L97C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl915
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl915:
jmp @r4
mov r0,r2
! Opcodes 1980 - 1987
L980:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl916
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl916:
jmp @r4
mov r0,r2
! Opcodes 1988 - 198F
L988:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl917
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl917:
jmp @r4
mov r0,r2
! Opcodes 1990 - 1997
L990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl918
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl918:
jmp @r4
mov r0,r2
! Opcodes 1998 - 199F
L998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl919
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl919:
jmp @r4
mov r0,r2
! Opcodes 19A0 - 19A7
L9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl920
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl920:
jmp @r4
mov r0,r2
! Opcodes 19A8 - 19AF
L9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl921
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl921:
jmp @r4
mov r0,r2
! Opcodes 19B0 - 19B7
L9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl922
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl922:
jmp @r4
mov r0,r2
! Opcode 19B8
L9B8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl923
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl923:
jmp @r4
mov r0,r2
! Opcode 19B9
L9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl924
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl924:
jmp @r4
mov r0,r2
! Opcode 19BA
L9BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl925
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl925:
jmp @r4
mov r0,r2
! Opcode 19BB
L9BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl926
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl926:
jmp @r4
mov r0,r2
! Opcode 19BC
L9BC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl927
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl927:
jmp @r4
mov r0,r2
! Opcodes 1A00 - 1A07
LA00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl928
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl928:
jmp @r4
mov r0,r2
! Opcodes 1A08 - 1A0F
LA08:
and r1,r2
add r14,r2
mov.b @r2,r3
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl929
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl929:
jmp @r4
mov r0,r2
! Opcodes 1A10 - 1A17
LA10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl930
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl930:
jmp @r4
mov r0,r2
! Opcodes 1A18 - 1A1F
LA18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl931
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl931:
jmp @r4
mov r0,r2
! Opcodes 1A20 - 1A27
LA20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl932
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl932:
jmp @r4
mov r0,r2
! Opcodes 1A28 - 1A2F
LA28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl933
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl933:
jmp @r4
mov r0,r2
! Opcodes 1A30 - 1A37
LA30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl934
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl934:
jmp @r4
mov r0,r2
! Opcode 1A38
LA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl935
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl935:
jmp @r4
mov r0,r2
! Opcode 1A39
LA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl936
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl936:
jmp @r4
mov r0,r2
! Opcode 1A3A
LA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl937
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl937:
jmp @r4
mov r0,r2
! Opcode 1A3B
LA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl938
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl938:
jmp @r4
mov r0,r2
! Opcode 1A3C
LA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl939
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl939:
jmp @r4
mov r0,r2
! Opcodes 1A80 - 1A87
LA80:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl940
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl940:
jmp @r4
mov r0,r2
! Opcodes 1A88 - 1A8F
LA88:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl941
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl941:
jmp @r4
mov r0,r2
! Opcodes 1A90 - 1A97
LA90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl942
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl942:
jmp @r4
mov r0,r2
! Opcodes 1A98 - 1A9F
LA98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl943
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl943:
jmp @r4
mov r0,r2
! Opcodes 1AA0 - 1AA7
LAA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl944
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl944:
jmp @r4
mov r0,r2
! Opcodes 1AA8 - 1AAF
LAA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl945
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl945:
jmp @r4
mov r0,r2
! Opcodes 1AB0 - 1AB7
LAB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl946
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl946:
jmp @r4
mov r0,r2
! Opcode 1AB8
LAB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl947
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl947:
jmp @r4
mov r0,r2
! Opcode 1AB9
LAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl948
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl948:
jmp @r4
mov r0,r2
! Opcode 1ABA
LABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl949
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl949:
jmp @r4
mov r0,r2
! Opcode 1ABB
LABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl950
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl950:
jmp @r4
mov r0,r2
! Opcode 1ABC
LABC:
mov.b @r6,r3
add #2,r6
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl951
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl951:
jmp @r4
mov r0,r2
! Opcodes 1AC0 - 1AC7
LAC0:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl952
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl952:
jmp @r4
mov r0,r2
! Opcodes 1AC8 - 1ACF
LAC8:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl953
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl953:
jmp @r4
mov r0,r2
! Opcodes 1AD0 - 1AD7
LAD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl954
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl954:
jmp @r4
mov r0,r2
! Opcodes 1AD8 - 1ADF
LAD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl955
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl955:
jmp @r4
mov r0,r2
! Opcodes 1AE0 - 1AE7
LAE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl956
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl956:
jmp @r4
mov r0,r2
! Opcodes 1AE8 - 1AEF
LAE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl957
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl957:
jmp @r4
mov r0,r2
! Opcodes 1AF0 - 1AF7
LAF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl958
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl958:
jmp @r4
mov r0,r2
! Opcode 1AF8
LAF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl959
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl959:
jmp @r4
mov r0,r2
! Opcode 1AF9
LAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl960
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl960:
jmp @r4
mov r0,r2
! Opcode 1AFA
LAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl961
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl961:
jmp @r4
mov r0,r2
! Opcode 1AFB
LAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl962
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl962:
jmp @r4
mov r0,r2
! Opcode 1AFC
LAFC:
mov.b @r6,r3
add #2,r6
mov.l @(52,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl963
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl963:
jmp @r4
mov r0,r2
! Opcodes 1B00 - 1B07
LB00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl964
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl964:
jmp @r4
mov r0,r2
! Opcodes 1B08 - 1B0F
LB08:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl965
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl965:
jmp @r4
mov r0,r2
! Opcodes 1B10 - 1B17
LB10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl966
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl966:
jmp @r4
mov r0,r2
! Opcodes 1B18 - 1B1F
LB18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl967
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl967:
jmp @r4
mov r0,r2
! Opcodes 1B20 - 1B27
LB20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl968
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl968:
jmp @r4
mov r0,r2
! Opcodes 1B28 - 1B2F
LB28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl969
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl969:
jmp @r4
mov r0,r2
! Opcodes 1B30 - 1B37
LB30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl970
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl970:
jmp @r4
mov r0,r2
! Opcode 1B38
LB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl971
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl971:
jmp @r4
mov r0,r2
! Opcode 1B39
LB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl972
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl972:
jmp @r4
mov r0,r2
! Opcode 1B3A
LB3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl973
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl973:
jmp @r4
mov r0,r2
! Opcode 1B3B
LB3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl974
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl974:
jmp @r4
mov r0,r2
! Opcode 1B3C
LB3C:
mov.b @r6,r3
add #2,r6
mov.l @(52,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl975
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl975:
jmp @r4
mov r0,r2
! Opcodes 1B40 - 1B47
LB40:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl976
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl976:
jmp @r4
mov r0,r2
! Opcodes 1B48 - 1B4F
LB48:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl977
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl977:
jmp @r4
mov r0,r2
! Opcodes 1B50 - 1B57
LB50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl978
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl978:
jmp @r4
mov r0,r2
! Opcodes 1B58 - 1B5F
LB58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl979
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl979:
jmp @r4
mov r0,r2
! Opcodes 1B60 - 1B67
LB60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl980
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl980:
jmp @r4
mov r0,r2
! Opcodes 1B68 - 1B6F
LB68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl981
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl981:
jmp @r4
mov r0,r2
! Opcodes 1B70 - 1B77
LB70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl982
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl982:
jmp @r4
mov r0,r2
! Opcode 1B78
LB78:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl983
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl983:
jmp @r4
mov r0,r2
! Opcode 1B79
LB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl984
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl984:
jmp @r4
mov r0,r2
! Opcode 1B7A
LB7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl985
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl985:
jmp @r4
mov r0,r2
! Opcode 1B7B
LB7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl986
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl986:
jmp @r4
mov r0,r2
! Opcode 1B7C
LB7C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl987
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl987:
jmp @r4
mov r0,r2
! Opcodes 1B80 - 1B87
LB80:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl988
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl988:
jmp @r4
mov r0,r2
! Opcodes 1B88 - 1B8F
LB88:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl989
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl989:
jmp @r4
mov r0,r2
! Opcodes 1B90 - 1B97
LB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl990
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl990:
jmp @r4
mov r0,r2
! Opcodes 1B98 - 1B9F
LB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl991
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl991:
jmp @r4
mov r0,r2
! Opcodes 1BA0 - 1BA7
LBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl992
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl992:
jmp @r4
mov r0,r2
! Opcodes 1BA8 - 1BAF
LBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl993
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl993:
jmp @r4
mov r0,r2
! Opcodes 1BB0 - 1BB7
LBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl994
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl994:
jmp @r4
mov r0,r2
! Opcode 1BB8
LBB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl995
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl995:
jmp @r4
mov r0,r2
! Opcode 1BB9
LBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl996
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl996:
jmp @r4
mov r0,r2
! Opcode 1BBA
LBBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl997
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl997:
jmp @r4
mov r0,r2
! Opcode 1BBB
LBBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl998
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl998:
jmp @r4
mov r0,r2
! Opcode 1BBC
LBBC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl999
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl999:
jmp @r4
mov r0,r2
! Opcodes 1C00 - 1C07
LC00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1000
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1000:
jmp @r4
mov r0,r2
! Opcodes 1C08 - 1C0F
LC08:
and r1,r2
add r14,r2
mov.b @r2,r3
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1001
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1001:
jmp @r4
mov r0,r2
! Opcodes 1C10 - 1C17
LC10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1002
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1002:
jmp @r4
mov r0,r2
! Opcodes 1C18 - 1C1F
LC18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1003
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1003:
jmp @r4
mov r0,r2
! Opcodes 1C20 - 1C27
LC20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1004
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1004:
jmp @r4
mov r0,r2
! Opcodes 1C28 - 1C2F
LC28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1005
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1005:
jmp @r4
mov r0,r2
! Opcodes 1C30 - 1C37
LC30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1006
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1006:
jmp @r4
mov r0,r2
! Opcode 1C38
LC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1007
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1007:
jmp @r4
mov r0,r2
! Opcode 1C39
LC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1008
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1008:
jmp @r4
mov r0,r2
! Opcode 1C3A
LC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1009
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1009:
jmp @r4
mov r0,r2
! Opcode 1C3B
LC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1010
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1010:
jmp @r4
mov r0,r2
! Opcode 1C3C
LC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1011
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1011:
jmp @r4
mov r0,r2
! Opcodes 1C80 - 1C87
LC80:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1012
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1012:
jmp @r4
mov r0,r2
! Opcodes 1C88 - 1C8F
LC88:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1013
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1013:
jmp @r4
mov r0,r2
! Opcodes 1C90 - 1C97
LC90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1014
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1014:
jmp @r4
mov r0,r2
! Opcodes 1C98 - 1C9F
LC98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1015
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1015:
jmp @r4
mov r0,r2
! Opcodes 1CA0 - 1CA7
LCA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1016
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1016:
jmp @r4
mov r0,r2
! Opcodes 1CA8 - 1CAF
LCA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1017
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1017:
jmp @r4
mov r0,r2
! Opcodes 1CB0 - 1CB7
LCB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1018
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1018:
jmp @r4
mov r0,r2
! Opcode 1CB8
LCB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1019
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1019:
jmp @r4
mov r0,r2
! Opcode 1CB9
LCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1020
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1020:
jmp @r4
mov r0,r2
! Opcode 1CBA
LCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1021
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1021:
jmp @r4
mov r0,r2
! Opcode 1CBB
LCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1022
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1022:
jmp @r4
mov r0,r2
! Opcode 1CBC
LCBC:
mov.b @r6,r3
add #2,r6
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1023
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1023:
jmp @r4
mov r0,r2
! Opcodes 1CC0 - 1CC7
LCC0:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1024
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1024:
jmp @r4
mov r0,r2
! Opcodes 1CC8 - 1CCF
LCC8:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1025
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1025:
jmp @r4
mov r0,r2
! Opcodes 1CD0 - 1CD7
LCD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1026
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1026:
jmp @r4
mov r0,r2
! Opcodes 1CD8 - 1CDF
LCD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1027
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1027:
jmp @r4
mov r0,r2
! Opcodes 1CE0 - 1CE7
LCE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1028
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1028:
jmp @r4
mov r0,r2
! Opcodes 1CE8 - 1CEF
LCE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1029
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1029:
jmp @r4
mov r0,r2
! Opcodes 1CF0 - 1CF7
LCF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1030
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1030:
jmp @r4
mov r0,r2
! Opcode 1CF8
LCF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1031
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1031:
jmp @r4
mov r0,r2
! Opcode 1CF9
LCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1032
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1032:
jmp @r4
mov r0,r2
! Opcode 1CFA
LCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1033
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1033:
jmp @r4
mov r0,r2
! Opcode 1CFB
LCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1034
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1034:
jmp @r4
mov r0,r2
! Opcode 1CFC
LCFC:
mov.b @r6,r3
add #2,r6
mov.l @(56,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1035
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1035:
jmp @r4
mov r0,r2
! Opcodes 1D00 - 1D07
LD00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1036
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1036:
jmp @r4
mov r0,r2
! Opcodes 1D08 - 1D0F
LD08:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1037
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1037:
jmp @r4
mov r0,r2
! Opcodes 1D10 - 1D17
LD10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1038
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1038:
jmp @r4
mov r0,r2
! Opcodes 1D18 - 1D1F
LD18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1039
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1039:
jmp @r4
mov r0,r2
! Opcodes 1D20 - 1D27
LD20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1040
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1040:
jmp @r4
mov r0,r2
! Opcodes 1D28 - 1D2F
LD28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1041
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1041:
jmp @r4
mov r0,r2
! Opcodes 1D30 - 1D37
LD30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1042
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1042:
jmp @r4
mov r0,r2
! Opcode 1D38
LD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1043
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1043:
jmp @r4
mov r0,r2
! Opcode 1D39
LD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1044
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1044:
jmp @r4
mov r0,r2
! Opcode 1D3A
LD3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1045
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1045:
jmp @r4
mov r0,r2
! Opcode 1D3B
LD3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1046
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1046:
jmp @r4
mov r0,r2
! Opcode 1D3C
LD3C:
mov.b @r6,r3
add #2,r6
mov.l @(56,r13),r4
dt r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1047
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1047:
jmp @r4
mov r0,r2
! Opcodes 1D40 - 1D47
LD40:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1048
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1048:
jmp @r4
mov r0,r2
! Opcodes 1D48 - 1D4F
LD48:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1049
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1049:
jmp @r4
mov r0,r2
! Opcodes 1D50 - 1D57
LD50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1050
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1050:
jmp @r4
mov r0,r2
! Opcodes 1D58 - 1D5F
LD58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1051
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1051:
jmp @r4
mov r0,r2
! Opcodes 1D60 - 1D67
LD60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1052
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1052:
jmp @r4
mov r0,r2
! Opcodes 1D68 - 1D6F
LD68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1053
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1053:
jmp @r4
mov r0,r2
! Opcodes 1D70 - 1D77
LD70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1054
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1054:
jmp @r4
mov r0,r2
! Opcode 1D78
LD78:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1055
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1055:
jmp @r4
mov r0,r2
! Opcode 1D79
LD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1056
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1056:
jmp @r4
mov r0,r2
! Opcode 1D7A
LD7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1057
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1057:
jmp @r4
mov r0,r2
! Opcode 1D7B
LD7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1058
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1058:
jmp @r4
mov r0,r2
! Opcode 1D7C
LD7C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1059
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1059:
jmp @r4
mov r0,r2
! Opcodes 1D80 - 1D87
LD80:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1060
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1060:
jmp @r4
mov r0,r2
! Opcodes 1D88 - 1D8F
LD88:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1061
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1061:
jmp @r4
mov r0,r2
! Opcodes 1D90 - 1D97
LD90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1062
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1062:
jmp @r4
mov r0,r2
! Opcodes 1D98 - 1D9F
LD98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1063
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1063:
jmp @r4
mov r0,r2
! Opcodes 1DA0 - 1DA7
LDA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1064
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1064:
jmp @r4
mov r0,r2
! Opcodes 1DA8 - 1DAF
LDA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1065
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1065:
jmp @r4
mov r0,r2
! Opcodes 1DB0 - 1DB7
LDB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1066
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1066:
jmp @r4
mov r0,r2
! Opcode 1DB8
LDB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1067
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1067:
jmp @r4
mov r0,r2
! Opcode 1DB9
LDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1068
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1068:
jmp @r4
mov r0,r2
! Opcode 1DBA
LDBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1069
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1069:
jmp @r4
mov r0,r2
! Opcode 1DBB
LDBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1070
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1070:
jmp @r4
mov r0,r2
! Opcode 1DBC
LDBC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1071
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1071:
jmp @r4
mov r0,r2
! Opcodes 1E00 - 1E07
LE00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1072
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1072:
jmp @r4
mov r0,r2
! Opcodes 1E08 - 1E0F
LE08:
and r1,r2
add r14,r2
mov.b @r2,r3
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1073
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1073:
jmp @r4
mov r0,r2
! Opcodes 1E10 - 1E17
LE10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1074
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1074:
jmp @r4
mov r0,r2
! Opcodes 1E18 - 1E1F
LE18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1075
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1075:
jmp @r4
mov r0,r2
! Opcodes 1E20 - 1E27
LE20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1076
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1076:
jmp @r4
mov r0,r2
! Opcodes 1E28 - 1E2F
LE28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1077
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1077:
jmp @r4
mov r0,r2
! Opcodes 1E30 - 1E37
LE30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1078
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1078:
jmp @r4
mov r0,r2
! Opcode 1E38
LE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1079
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1079:
jmp @r4
mov r0,r2
! Opcode 1E39
LE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1080
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1080:
jmp @r4
mov r0,r2
! Opcode 1E3A
LE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1081
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1081:
jmp @r4
mov r0,r2
! Opcode 1E3B
LE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1082
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1082:
jmp @r4
mov r0,r2
! Opcode 1E3C
LE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1083
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1083:
jmp @r4
mov r0,r2
! Opcodes 1E80 - 1E87
LE80:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1084
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1084:
jmp @r4
mov r0,r2
! Opcodes 1E88 - 1E8F
LE88:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1085
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1085:
jmp @r4
mov r0,r2
! Opcodes 1E90 - 1E97
LE90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1086
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1086:
jmp @r4
mov r0,r2
! Opcodes 1E98 - 1E9F
LE98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1087
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1087:
jmp @r4
mov r0,r2
! Opcodes 1EA0 - 1EA7
LEA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1088
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1088:
jmp @r4
mov r0,r2
! Opcodes 1EA8 - 1EAF
LEA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1089
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1089:
jmp @r4
mov r0,r2
! Opcodes 1EB0 - 1EB7
LEB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1090
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1090:
jmp @r4
mov r0,r2
! Opcode 1EB8
LEB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1091
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1091:
jmp @r4
mov r0,r2
! Opcode 1EB9
LEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1092
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1092:
jmp @r4
mov r0,r2
! Opcode 1EBA
LEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1093
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1093:
jmp @r4
mov r0,r2
! Opcode 1EBB
LEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1094
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1094:
jmp @r4
mov r0,r2
! Opcode 1EBC
LEBC:
mov.b @r6,r3
add #2,r6
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1095
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1095:
jmp @r4
mov r0,r2
! Opcodes 1EC0 - 1EC7
LEC0:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1096
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1096:
jmp @r4
mov r0,r2
! Opcodes 1EC8 - 1ECF
LEC8:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1097
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1097:
jmp @r4
mov r0,r2
! Opcodes 1ED0 - 1ED7
LED0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1098
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1098:
jmp @r4
mov r0,r2
! Opcodes 1ED8 - 1EDF
LED8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1099
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1099:
jmp @r4
mov r0,r2
! Opcodes 1EE0 - 1EE7
LEE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1100
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1100:
jmp @r4
mov r0,r2
! Opcodes 1EE8 - 1EEF
LEE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1101
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1101:
jmp @r4
mov r0,r2
! Opcodes 1EF0 - 1EF7
LEF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1102
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1102:
jmp @r4
mov r0,r2
! Opcode 1EF8
LEF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1103
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1103:
jmp @r4
mov r0,r2
! Opcode 1EF9
LEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1104
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1104:
jmp @r4
mov r0,r2
! Opcode 1EFA
LEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1105
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1105:
jmp @r4
mov r0,r2
! Opcode 1EFB
LEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1106
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1106:
jmp @r4
mov r0,r2
! Opcode 1EFC
LEFC:
mov.b @r6,r3
add #2,r6
mov.l @(60,r13),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1107
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1107:
jmp @r4
mov r0,r2
! Opcodes 1F00 - 1F07
LF00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1108
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1108:
jmp @r4
mov r0,r2
! Opcodes 1F08 - 1F0F
LF08:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1109
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1109:
jmp @r4
mov r0,r2
! Opcodes 1F10 - 1F17
LF10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1110
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1110:
jmp @r4
mov r0,r2
! Opcodes 1F18 - 1F1F
LF18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1111
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1111:
jmp @r4
mov r0,r2
! Opcodes 1F20 - 1F27
LF20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1112
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1112:
jmp @r4
mov r0,r2
! Opcodes 1F28 - 1F2F
LF28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1113
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1113:
jmp @r4
mov r0,r2
! Opcodes 1F30 - 1F37
LF30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1114
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1114:
jmp @r4
mov r0,r2
! Opcode 1F38
LF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1115
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1115:
jmp @r4
mov r0,r2
! Opcode 1F39
LF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1116
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1116:
jmp @r4
mov r0,r2
! Opcode 1F3A
LF3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1117
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1117:
jmp @r4
mov r0,r2
! Opcode 1F3B
LF3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1118
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1118:
jmp @r4
mov r0,r2
! Opcode 1F3C
LF3C:
mov.b @r6,r3
add #2,r6
mov.l @(60,r13),r4
add #-2,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1119
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1119:
jmp @r4
mov r0,r2
! Opcodes 1F40 - 1F47
LF40:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1120
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1120:
jmp @r4
mov r0,r2
! Opcodes 1F48 - 1F4F
LF48:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1121
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1121:
jmp @r4
mov r0,r2
! Opcodes 1F50 - 1F57
LF50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1122
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1122:
jmp @r4
mov r0,r2
! Opcodes 1F58 - 1F5F
LF58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1123
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1123:
jmp @r4
mov r0,r2
! Opcodes 1F60 - 1F67
LF60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1124
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1124:
jmp @r4
mov r0,r2
! Opcodes 1F68 - 1F6F
LF68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1125
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1125:
jmp @r4
mov r0,r2
! Opcodes 1F70 - 1F77
LF70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1126
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1126:
jmp @r4
mov r0,r2
! Opcode 1F78
LF78:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1127
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1127:
jmp @r4
mov r0,r2
! Opcode 1F79
LF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1128
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1128:
jmp @r4
mov r0,r2
! Opcode 1F7A
LF7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1129
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1129:
jmp @r4
mov r0,r2
! Opcode 1F7B
LF7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1130
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1130:
jmp @r4
mov r0,r2
! Opcode 1F7C
LF7C:
mov.b @r6,r3
add #2,r6
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1131
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1131:
jmp @r4
mov r0,r2
! Opcodes 1F80 - 1F87
LF80:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1132
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1132:
jmp @r4
mov r0,r2
! Opcodes 1F88 - 1F8F
LF88:
and r1,r2
add r14,r2
mov.b @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1133
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1133:
jmp @r4
mov r0,r2
! Opcodes 1F90 - 1F97
LF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1134
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1134:
jmp @r4
mov r0,r2
! Opcodes 1F98 - 1F9F
LF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1135
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1135:
jmp @r4
mov r0,r2
! Opcodes 1FA0 - 1FA7
LFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1136
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1136:
jmp @r4
mov r0,r2
! Opcodes 1FA8 - 1FAF
LFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1137
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1137:
jmp @r4
mov r0,r2
! Opcodes 1FB0 - 1FB7
LFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1138
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1138:
jmp @r4
mov r0,r2
! Opcode 1FB8
LFB8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1139
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1139:
jmp @r4
mov r0,r2
! Opcode 1FB9
LFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1140
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1140:
jmp @r4
mov r0,r2
! Opcode 1FBA
LFBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1141
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1141:
jmp @r4
mov r0,r2
! Opcode 1FBB
LFBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1142
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1142:
jmp @r4
mov r0,r2
! Opcode 1FBC
LFBC:
mov.b @r6,r3
add #2,r6
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1143
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1143:
jmp @r4
mov r0,r2
! Opcodes 2000 - 2007
M000:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1144
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1144:
jmp @r4
mov r0,r2
! Opcodes 2008 - 200F
M008:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1145
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1145:
jmp @r4
mov r0,r2
! Opcodes 2010 - 2017
M010:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1146
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1146:
jmp @r4
mov r0,r2
! Opcodes 2018 - 201F
M018:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1147
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1147:
jmp @r4
mov r0,r2
! Opcodes 2020 - 2027
M020:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1148
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1148:
jmp @r4
mov r0,r2
! Opcodes 2028 - 202F
M028:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1149
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1149:
jmp @r4
mov r0,r2
! Opcodes 2030 - 2037
M030:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1150
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1150:
jmp @r4
mov r0,r2
! Opcode 2038
M038:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1151
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1151:
jmp @r4
mov r0,r2
! Opcode 2039
M039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1152
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1152:
jmp @r4
mov r0,r2
! Opcode 203A
M03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1153
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1153:
jmp @r4
mov r0,r2
! Opcode 203B
M03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1154
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1154:
jmp @r4
mov r0,r2
! Opcode 203C
M03C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1155
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1155:
jmp @r4
mov r0,r2
! Opcodes 2040 - 2047
M040:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1156
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1156:
jmp @r4
mov r0,r2
! Opcodes 2048 - 204F
M048:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1157
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1157:
jmp @r4
mov r0,r2
! Opcodes 2050 - 2057
M050:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1158
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1158:
jmp @r4
mov r0,r2
! Opcodes 2058 - 205F
M058:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1159
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1159:
jmp @r4
mov r0,r2
! Opcodes 2060 - 2067
M060:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1160
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1160:
jmp @r4
mov r0,r2
! Opcodes 2068 - 206F
M068:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1161
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1161:
jmp @r4
mov r0,r2
! Opcodes 2070 - 2077
M070:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1162
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1162:
jmp @r4
mov r0,r2
! Opcode 2078
M078:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1163
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1163:
jmp @r4
mov r0,r2
! Opcode 2079
M079:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1164
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1164:
jmp @r4
mov r0,r2
! Opcode 207A
M07A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1165
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1165:
jmp @r4
mov r0,r2
! Opcode 207B
M07B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1166
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1166:
jmp @r4
mov r0,r2
! Opcode 207C
M07C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1167
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1167:
jmp @r4
mov r0,r2
! Opcodes 2080 - 2087
M080:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1168
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1168:
jmp @r4
mov r0,r2
! Opcodes 2088 - 208F
M088:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1169
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1169:
jmp @r4
mov r0,r2
! Opcodes 2090 - 2097
M090:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1170
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1170:
jmp @r4
mov r0,r2
! Opcodes 2098 - 209F
M098:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1171
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1171:
jmp @r4
mov r0,r2
! Opcodes 20A0 - 20A7
M0A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1172
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1172:
jmp @r4
mov r0,r2
! Opcodes 20A8 - 20AF
M0A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1173
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1173:
jmp @r4
mov r0,r2
! Opcodes 20B0 - 20B7
M0B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1174
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1174:
jmp @r4
mov r0,r2
! Opcode 20B8
M0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1175
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1175:
jmp @r4
mov r0,r2
! Opcode 20B9
M0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1176
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1176:
jmp @r4
mov r0,r2
! Opcode 20BA
M0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1177
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1177:
jmp @r4
mov r0,r2
! Opcode 20BB
M0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1178
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1178:
jmp @r4
mov r0,r2
! Opcode 20BC
M0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1179
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1179:
jmp @r4
mov r0,r2
! Opcodes 20C0 - 20C7
M0C0:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1180
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1180:
jmp @r4
mov r0,r2
! Opcodes 20C8 - 20CF
M0C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1181
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1181:
jmp @r4
mov r0,r2
! Opcodes 20D0 - 20D7
M0D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1182
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1182:
jmp @r4
mov r0,r2
! Opcodes 20D8 - 20DF
M0D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1183
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1183:
jmp @r4
mov r0,r2
! Opcodes 20E0 - 20E7
M0E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1184
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1184:
jmp @r4
mov r0,r2
! Opcodes 20E8 - 20EF
M0E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1185
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1185:
jmp @r4
mov r0,r2
! Opcodes 20F0 - 20F7
M0F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1186
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1186:
jmp @r4
mov r0,r2
! Opcode 20F8
M0F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1187
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1187:
jmp @r4
mov r0,r2
! Opcode 20F9
M0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1188
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1188:
jmp @r4
mov r0,r2
! Opcode 20FA
M0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1189
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1189:
jmp @r4
mov r0,r2
! Opcode 20FB
M0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1190
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1190:
jmp @r4
mov r0,r2
! Opcode 20FC
M0FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1191
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1191:
jmp @r4
mov r0,r2
! Opcodes 2100 - 2107
M100:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1192
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1192:
jmp @r4
mov r0,r2
! Opcodes 2108 - 210F
M108:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1193
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1193:
jmp @r4
mov r0,r2
! Opcodes 2110 - 2117
M110:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1194
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1194:
jmp @r4
mov r0,r2
! Opcodes 2118 - 211F
M118:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1195
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1195:
jmp @r4
mov r0,r2
! Opcodes 2120 - 2127
M120:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1196
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1196:
jmp @r4
mov r0,r2
! Opcodes 2128 - 212F
M128:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1197
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1197:
jmp @r4
mov r0,r2
! Opcodes 2130 - 2137
M130:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1198
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1198:
jmp @r4
mov r0,r2
! Opcode 2138
M138:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1199
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1199:
jmp @r4
mov r0,r2
! Opcode 2139
M139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1200
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1200:
jmp @r4
mov r0,r2
! Opcode 213A
M13A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1201
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1201:
jmp @r4
mov r0,r2
! Opcode 213B
M13B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1202
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1202:
jmp @r4
mov r0,r2
! Opcode 213C
M13C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1203
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1203:
jmp @r4
mov r0,r2
! Opcodes 2140 - 2147
M140:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1204
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1204:
jmp @r4
mov r0,r2
! Opcodes 2148 - 214F
M148:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1205
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1205:
jmp @r4
mov r0,r2
! Opcodes 2150 - 2157
M150:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1206
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1206:
jmp @r4
mov r0,r2
! Opcodes 2158 - 215F
M158:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1207
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1207:
jmp @r4
mov r0,r2
! Opcodes 2160 - 2167
M160:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1208
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1208:
jmp @r4
mov r0,r2
! Opcodes 2168 - 216F
M168:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1209
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1209:
jmp @r4
mov r0,r2
! Opcodes 2170 - 2177
M170:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1210
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1210:
jmp @r4
mov r0,r2
! Opcode 2178
M178:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1211
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1211:
jmp @r4
mov r0,r2
! Opcode 2179
M179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1212
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1212:
jmp @r4
mov r0,r2
! Opcode 217A
M17A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1213
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1213:
jmp @r4
mov r0,r2
! Opcode 217B
M17B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1214
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1214:
jmp @r4
mov r0,r2
! Opcode 217C
M17C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1215
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1215:
jmp @r4
mov r0,r2
! Opcodes 2180 - 2187
M180:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1216
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1216:
jmp @r4
mov r0,r2
! Opcodes 2188 - 218F
M188:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1217
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1217:
jmp @r4
mov r0,r2
! Opcodes 2190 - 2197
M190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1218
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1218:
jmp @r4
mov r0,r2
! Opcodes 2198 - 219F
M198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1219
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1219:
jmp @r4
mov r0,r2
! Opcodes 21A0 - 21A7
M1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1220
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1220:
jmp @r4
mov r0,r2
! Opcodes 21A8 - 21AF
M1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1221
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1221:
jmp @r4
mov r0,r2
! Opcodes 21B0 - 21B7
M1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1222
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1222:
jmp @r4
mov r0,r2
! Opcode 21B8
M1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1223
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1223:
jmp @r4
mov r0,r2
! Opcode 21B9
M1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1224
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1224:
jmp @r4
mov r0,r2
! Opcode 21BA
M1BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1225
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1225:
jmp @r4
mov r0,r2
! Opcode 21BB
M1BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1226
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1226:
jmp @r4
mov r0,r2
! Opcode 21BC
M1BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1227
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1227:
jmp @r4
mov r0,r2
! Opcodes 21C0 - 21C7
M1C0:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1228
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1228:
jmp @r4
mov r0,r2
! Opcodes 21C8 - 21CF
M1C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1229
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1229:
jmp @r4
mov r0,r2
! Opcodes 21D0 - 21D7
M1D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1230
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1230:
jmp @r4
mov r0,r2
! Opcodes 21D8 - 21DF
M1D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1231
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1231:
jmp @r4
mov r0,r2
! Opcodes 21E0 - 21E7
M1E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1232
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1232:
jmp @r4
mov r0,r2
! Opcodes 21E8 - 21EF
M1E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1233
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1233:
jmp @r4
mov r0,r2
! Opcodes 21F0 - 21F7
M1F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1234
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1234:
jmp @r4
mov r0,r2
! Opcode 21F8
M1F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1235
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1235:
jmp @r4
mov r0,r2
! Opcode 21F9
M1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1236
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1236:
jmp @r4
mov r0,r2
! Opcode 21FA
M1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1237
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1237:
jmp @r4
mov r0,r2
! Opcode 21FB
M1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1238
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1238:
jmp @r4
mov r0,r2
! Opcode 21FC
M1FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1239
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1239:
jmp @r4
mov r0,r2
! Opcodes 2200 - 2207
M200:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1240
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1240:
jmp @r4
mov r0,r2
! Opcodes 2208 - 220F
M208:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1241
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1241:
jmp @r4
mov r0,r2
! Opcodes 2210 - 2217
M210:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1242
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1242:
jmp @r4
mov r0,r2
! Opcodes 2218 - 221F
M218:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1243
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1243:
jmp @r4
mov r0,r2
! Opcodes 2220 - 2227
M220:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1244
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1244:
jmp @r4
mov r0,r2
! Opcodes 2228 - 222F
M228:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1245
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1245:
jmp @r4
mov r0,r2
! Opcodes 2230 - 2237
M230:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1246
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1246:
jmp @r4
mov r0,r2
! Opcode 2238
M238:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1247
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1247:
jmp @r4
mov r0,r2
! Opcode 2239
M239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1248
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1248:
jmp @r4
mov r0,r2
! Opcode 223A
M23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1249
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1249:
jmp @r4
mov r0,r2
! Opcode 223B
M23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1250
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1250:
jmp @r4
mov r0,r2
! Opcode 223C
M23C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1251
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1251:
jmp @r4
mov r0,r2
! Opcodes 2240 - 2247
M240:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1252
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1252:
jmp @r4
mov r0,r2
! Opcodes 2248 - 224F
M248:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1253
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1253:
jmp @r4
mov r0,r2
! Opcodes 2250 - 2257
M250:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1254
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1254:
jmp @r4
mov r0,r2
! Opcodes 2258 - 225F
M258:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1255
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1255:
jmp @r4
mov r0,r2
! Opcodes 2260 - 2267
M260:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1256
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1256:
jmp @r4
mov r0,r2
! Opcodes 2268 - 226F
M268:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1257
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1257:
jmp @r4
mov r0,r2
! Opcodes 2270 - 2277
M270:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1258
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1258:
jmp @r4
mov r0,r2
! Opcode 2278
M278:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1259
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1259:
jmp @r4
mov r0,r2
! Opcode 2279
M279:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1260
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1260:
jmp @r4
mov r0,r2
! Opcode 227A
M27A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1261
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1261:
jmp @r4
mov r0,r2
! Opcode 227B
M27B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1262
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1262:
jmp @r4
mov r0,r2
! Opcode 227C
M27C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1263
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1263:
jmp @r4
mov r0,r2
! Opcodes 2280 - 2287
M280:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1264
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1264:
jmp @r4
mov r0,r2
! Opcodes 2288 - 228F
M288:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1265
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1265:
jmp @r4
mov r0,r2
! Opcodes 2290 - 2297
M290:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1266
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1266:
jmp @r4
mov r0,r2
! Opcodes 2298 - 229F
M298:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1267
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1267:
jmp @r4
mov r0,r2
! Opcodes 22A0 - 22A7
M2A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1268
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1268:
jmp @r4
mov r0,r2
! Opcodes 22A8 - 22AF
M2A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1269
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1269:
jmp @r4
mov r0,r2
! Opcodes 22B0 - 22B7
M2B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1270
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1270:
jmp @r4
mov r0,r2
! Opcode 22B8
M2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1271
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1271:
jmp @r4
mov r0,r2
! Opcode 22B9
M2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1272
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1272:
jmp @r4
mov r0,r2
! Opcode 22BA
M2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1273
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1273:
jmp @r4
mov r0,r2
! Opcode 22BB
M2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1274
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1274:
jmp @r4
mov r0,r2
! Opcode 22BC
M2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1275
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1275:
jmp @r4
mov r0,r2
! Opcodes 22C0 - 22C7
M2C0:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1276
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1276:
jmp @r4
mov r0,r2
! Opcodes 22C8 - 22CF
M2C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1277
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1277:
jmp @r4
mov r0,r2
! Opcodes 22D0 - 22D7
M2D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1278
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1278:
jmp @r4
mov r0,r2
! Opcodes 22D8 - 22DF
M2D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1279
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1279:
jmp @r4
mov r0,r2
! Opcodes 22E0 - 22E7
M2E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1280
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1280:
jmp @r4
mov r0,r2
! Opcodes 22E8 - 22EF
M2E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1281
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1281:
jmp @r4
mov r0,r2
! Opcodes 22F0 - 22F7
M2F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1282
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1282:
jmp @r4
mov r0,r2
! Opcode 22F8
M2F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1283
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1283:
jmp @r4
mov r0,r2
! Opcode 22F9
M2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1284
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1284:
jmp @r4
mov r0,r2
! Opcode 22FA
M2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1285
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1285:
jmp @r4
mov r0,r2
! Opcode 22FB
M2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1286
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1286:
jmp @r4
mov r0,r2
! Opcode 22FC
M2FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1287
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1287:
jmp @r4
mov r0,r2
! Opcodes 2300 - 2307
M300:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1288
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1288:
jmp @r4
mov r0,r2
! Opcodes 2308 - 230F
M308:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1289
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1289:
jmp @r4
mov r0,r2
! Opcodes 2310 - 2317
M310:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1290
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1290:
jmp @r4
mov r0,r2
! Opcodes 2318 - 231F
M318:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1291
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1291:
jmp @r4
mov r0,r2
! Opcodes 2320 - 2327
M320:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1292
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1292:
jmp @r4
mov r0,r2
! Opcodes 2328 - 232F
M328:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1293
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1293:
jmp @r4
mov r0,r2
! Opcodes 2330 - 2337
M330:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1294
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1294:
jmp @r4
mov r0,r2
! Opcode 2338
M338:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1295
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1295:
jmp @r4
mov r0,r2
! Opcode 2339
M339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1296
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1296:
jmp @r4
mov r0,r2
! Opcode 233A
M33A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1297
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1297:
jmp @r4
mov r0,r2
! Opcode 233B
M33B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1298
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1298:
jmp @r4
mov r0,r2
! Opcode 233C
M33C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1299
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1299:
jmp @r4
mov r0,r2
! Opcodes 2340 - 2347
M340:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1300
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1300:
jmp @r4
mov r0,r2
! Opcodes 2348 - 234F
M348:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1301
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1301:
jmp @r4
mov r0,r2
! Opcodes 2350 - 2357
M350:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1302
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1302:
jmp @r4
mov r0,r2
! Opcodes 2358 - 235F
M358:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1303
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1303:
jmp @r4
mov r0,r2
! Opcodes 2360 - 2367
M360:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1304
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1304:
jmp @r4
mov r0,r2
! Opcodes 2368 - 236F
M368:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1305
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1305:
jmp @r4
mov r0,r2
! Opcodes 2370 - 2377
M370:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1306
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1306:
jmp @r4
mov r0,r2
! Opcode 2378
M378:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1307
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1307:
jmp @r4
mov r0,r2
! Opcode 2379
M379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1308
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1308:
jmp @r4
mov r0,r2
! Opcode 237A
M37A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1309
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1309:
jmp @r4
mov r0,r2
! Opcode 237B
M37B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1310
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1310:
jmp @r4
mov r0,r2
! Opcode 237C
M37C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1311
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1311:
jmp @r4
mov r0,r2
! Opcodes 2380 - 2387
M380:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1312
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1312:
jmp @r4
mov r0,r2
! Opcodes 2388 - 238F
M388:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1313
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1313:
jmp @r4
mov r0,r2
! Opcodes 2390 - 2397
M390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1314
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1314:
jmp @r4
mov r0,r2
! Opcodes 2398 - 239F
M398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1315
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1315:
jmp @r4
mov r0,r2
! Opcodes 23A0 - 23A7
M3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1316
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1316:
jmp @r4
mov r0,r2
! Opcodes 23A8 - 23AF
M3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1317
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1317:
jmp @r4
mov r0,r2
! Opcodes 23B0 - 23B7
M3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1318
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1318:
jmp @r4
mov r0,r2
! Opcode 23B8
M3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1319
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1319:
jmp @r4
mov r0,r2
! Opcode 23B9
M3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1320
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1320:
jmp @r4
mov r0,r2
! Opcode 23BA
M3BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1321
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1321:
jmp @r4
mov r0,r2
! Opcode 23BB
M3BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1322
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1322:
jmp @r4
mov r0,r2
! Opcode 23BC
M3BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1323
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1323:
jmp @r4
mov r0,r2
! Opcodes 23C0 - 23C7
M3C0:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1324
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1324:
jmp @r4
mov r0,r2
! Opcodes 23C8 - 23CF
M3C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1325
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1325:
jmp @r4
mov r0,r2
! Opcodes 23D0 - 23D7
M3D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1326
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1326:
jmp @r4
mov r0,r2
! Opcodes 23D8 - 23DF
M3D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1327
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1327:
jmp @r4
mov r0,r2
! Opcodes 23E0 - 23E7
M3E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1328
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1328:
jmp @r4
mov r0,r2
! Opcodes 23E8 - 23EF
M3E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1329
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1329:
jmp @r4
mov r0,r2
! Opcodes 23F0 - 23F7
M3F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1330
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1330:
jmp @r4
mov r0,r2
! Opcode 23F8
M3F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1331
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1331:
jmp @r4
mov r0,r2
! Opcode 23F9
M3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-36,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1332
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1332:
jmp @r4
mov r0,r2
! Opcode 23FA
M3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1333
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1333:
jmp @r4
mov r0,r2
! Opcode 23FB
M3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1334
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1334:
jmp @r4
mov r0,r2
! Opcode 23FC
M3FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1335
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1335:
jmp @r4
mov r0,r2
! Opcodes 2400 - 2407
M400:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1336
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1336:
jmp @r4
mov r0,r2
! Opcodes 2408 - 240F
M408:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1337
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1337:
jmp @r4
mov r0,r2
! Opcodes 2410 - 2417
M410:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1338
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1338:
jmp @r4
mov r0,r2
! Opcodes 2418 - 241F
M418:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1339
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1339:
jmp @r4
mov r0,r2
! Opcodes 2420 - 2427
M420:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1340
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1340:
jmp @r4
mov r0,r2
! Opcodes 2428 - 242F
M428:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1341
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1341:
jmp @r4
mov r0,r2
! Opcodes 2430 - 2437
M430:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1342
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1342:
jmp @r4
mov r0,r2
! Opcode 2438
M438:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1343
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1343:
jmp @r4
mov r0,r2
! Opcode 2439
M439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1344
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1344:
jmp @r4
mov r0,r2
! Opcode 243A
M43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1345
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1345:
jmp @r4
mov r0,r2
! Opcode 243B
M43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1346
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1346:
jmp @r4
mov r0,r2
! Opcode 243C
M43C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1347
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1347:
jmp @r4
mov r0,r2
! Opcodes 2440 - 2447
M440:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1348
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1348:
jmp @r4
mov r0,r2
! Opcodes 2448 - 244F
M448:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1349
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1349:
jmp @r4
mov r0,r2
! Opcodes 2450 - 2457
M450:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1350
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1350:
jmp @r4
mov r0,r2
! Opcodes 2458 - 245F
M458:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1351
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1351:
jmp @r4
mov r0,r2
! Opcodes 2460 - 2467
M460:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1352
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1352:
jmp @r4
mov r0,r2
! Opcodes 2468 - 246F
M468:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1353
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1353:
jmp @r4
mov r0,r2
! Opcodes 2470 - 2477
M470:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1354
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1354:
jmp @r4
mov r0,r2
! Opcode 2478
M478:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1355
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1355:
jmp @r4
mov r0,r2
! Opcode 2479
M479:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1356
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1356:
jmp @r4
mov r0,r2
! Opcode 247A
M47A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1357
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1357:
jmp @r4
mov r0,r2
! Opcode 247B
M47B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1358
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1358:
jmp @r4
mov r0,r2
! Opcode 247C
M47C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1359
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1359:
jmp @r4
mov r0,r2
! Opcodes 2480 - 2487
M480:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1360
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1360:
jmp @r4
mov r0,r2
! Opcodes 2488 - 248F
M488:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1361
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1361:
jmp @r4
mov r0,r2
! Opcodes 2490 - 2497
M490:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1362
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1362:
jmp @r4
mov r0,r2
! Opcodes 2498 - 249F
M498:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1363
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1363:
jmp @r4
mov r0,r2
! Opcodes 24A0 - 24A7
M4A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1364
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1364:
jmp @r4
mov r0,r2
! Opcodes 24A8 - 24AF
M4A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1365
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1365:
jmp @r4
mov r0,r2
! Opcodes 24B0 - 24B7
M4B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1366
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1366:
jmp @r4
mov r0,r2
! Opcode 24B8
M4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1367
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1367:
jmp @r4
mov r0,r2
! Opcode 24B9
M4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1368
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1368:
jmp @r4
mov r0,r2
! Opcode 24BA
M4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1369
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1369:
jmp @r4
mov r0,r2
! Opcode 24BB
M4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1370
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1370:
jmp @r4
mov r0,r2
! Opcode 24BC
M4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1371
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1371:
jmp @r4
mov r0,r2
! Opcodes 24C0 - 24C7
M4C0:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1372
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1372:
jmp @r4
mov r0,r2
! Opcodes 24C8 - 24CF
M4C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1373
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1373:
jmp @r4
mov r0,r2
! Opcodes 24D0 - 24D7
M4D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1374
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1374:
jmp @r4
mov r0,r2
! Opcodes 24D8 - 24DF
M4D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1375
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1375:
jmp @r4
mov r0,r2
! Opcodes 24E0 - 24E7
M4E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1376
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1376:
jmp @r4
mov r0,r2
! Opcodes 24E8 - 24EF
M4E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1377
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1377:
jmp @r4
mov r0,r2
! Opcodes 24F0 - 24F7
M4F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1378
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1378:
jmp @r4
mov r0,r2
! Opcode 24F8
M4F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1379
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1379:
jmp @r4
mov r0,r2
! Opcode 24F9
M4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1380
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1380:
jmp @r4
mov r0,r2
! Opcode 24FA
M4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1381
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1381:
jmp @r4
mov r0,r2
! Opcode 24FB
M4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1382
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1382:
jmp @r4
mov r0,r2
! Opcode 24FC
M4FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1383
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1383:
jmp @r4
mov r0,r2
! Opcodes 2500 - 2507
M500:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1384
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1384:
jmp @r4
mov r0,r2
! Opcodes 2508 - 250F
M508:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1385
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1385:
jmp @r4
mov r0,r2
! Opcodes 2510 - 2517
M510:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1386
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1386:
jmp @r4
mov r0,r2
! Opcodes 2518 - 251F
M518:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1387
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1387:
jmp @r4
mov r0,r2
! Opcodes 2520 - 2527
M520:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1388
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1388:
jmp @r4
mov r0,r2
! Opcodes 2528 - 252F
M528:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1389
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1389:
jmp @r4
mov r0,r2
! Opcodes 2530 - 2537
M530:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1390
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1390:
jmp @r4
mov r0,r2
! Opcode 2538
M538:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1391
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1391:
jmp @r4
mov r0,r2
! Opcode 2539
M539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1392
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1392:
jmp @r4
mov r0,r2
! Opcode 253A
M53A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1393
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1393:
jmp @r4
mov r0,r2
! Opcode 253B
M53B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1394
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1394:
jmp @r4
mov r0,r2
! Opcode 253C
M53C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1395
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1395:
jmp @r4
mov r0,r2
! Opcodes 2540 - 2547
M540:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1396
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1396:
jmp @r4
mov r0,r2
! Opcodes 2548 - 254F
M548:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1397
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1397:
jmp @r4
mov r0,r2
! Opcodes 2550 - 2557
M550:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1398
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1398:
jmp @r4
mov r0,r2
! Opcodes 2558 - 255F
M558:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1399
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1399:
jmp @r4
mov r0,r2
! Opcodes 2560 - 2567
M560:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1400
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1400:
jmp @r4
mov r0,r2
! Opcodes 2568 - 256F
M568:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1401
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1401:
jmp @r4
mov r0,r2
! Opcodes 2570 - 2577
M570:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1402
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1402:
jmp @r4
mov r0,r2
! Opcode 2578
M578:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1403
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1403:
jmp @r4
mov r0,r2
! Opcode 2579
M579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1404
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1404:
jmp @r4
mov r0,r2
! Opcode 257A
M57A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1405
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1405:
jmp @r4
mov r0,r2
! Opcode 257B
M57B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1406
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1406:
jmp @r4
mov r0,r2
! Opcode 257C
M57C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1407
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1407:
jmp @r4
mov r0,r2
! Opcodes 2580 - 2587
M580:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1408
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1408:
jmp @r4
mov r0,r2
! Opcodes 2588 - 258F
M588:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1409
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1409:
jmp @r4
mov r0,r2
! Opcodes 2590 - 2597
M590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1410
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1410:
jmp @r4
mov r0,r2
! Opcodes 2598 - 259F
M598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1411
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1411:
jmp @r4
mov r0,r2
! Opcodes 25A0 - 25A7
M5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1412
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1412:
jmp @r4
mov r0,r2
! Opcodes 25A8 - 25AF
M5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1413
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1413:
jmp @r4
mov r0,r2
! Opcodes 25B0 - 25B7
M5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1414
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1414:
jmp @r4
mov r0,r2
! Opcode 25B8
M5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1415
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1415:
jmp @r4
mov r0,r2
! Opcode 25B9
M5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1416
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1416:
jmp @r4
mov r0,r2
! Opcode 25BA
M5BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1417
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1417:
jmp @r4
mov r0,r2
! Opcode 25BB
M5BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1418
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1418:
jmp @r4
mov r0,r2
! Opcode 25BC
M5BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1419
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1419:
jmp @r4
mov r0,r2
! Opcodes 2600 - 2607
M600:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1420
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1420:
jmp @r4
mov r0,r2
! Opcodes 2608 - 260F
M608:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1421
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1421:
jmp @r4
mov r0,r2
! Opcodes 2610 - 2617
M610:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1422
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1422:
jmp @r4
mov r0,r2
! Opcodes 2618 - 261F
M618:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1423
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1423:
jmp @r4
mov r0,r2
! Opcodes 2620 - 2627
M620:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1424
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1424:
jmp @r4
mov r0,r2
! Opcodes 2628 - 262F
M628:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1425
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1425:
jmp @r4
mov r0,r2
! Opcodes 2630 - 2637
M630:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1426
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1426:
jmp @r4
mov r0,r2
! Opcode 2638
M638:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1427
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1427:
jmp @r4
mov r0,r2
! Opcode 2639
M639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1428
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1428:
jmp @r4
mov r0,r2
! Opcode 263A
M63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1429
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1429:
jmp @r4
mov r0,r2
! Opcode 263B
M63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1430
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1430:
jmp @r4
mov r0,r2
! Opcode 263C
M63C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1431
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1431:
jmp @r4
mov r0,r2
! Opcodes 2640 - 2647
M640:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1432
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1432:
jmp @r4
mov r0,r2
! Opcodes 2648 - 264F
M648:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1433
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1433:
jmp @r4
mov r0,r2
! Opcodes 2650 - 2657
M650:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1434
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1434:
jmp @r4
mov r0,r2
! Opcodes 2658 - 265F
M658:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1435
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1435:
jmp @r4
mov r0,r2
! Opcodes 2660 - 2667
M660:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1436
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1436:
jmp @r4
mov r0,r2
! Opcodes 2668 - 266F
M668:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1437
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1437:
jmp @r4
mov r0,r2
! Opcodes 2670 - 2677
M670:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1438
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1438:
jmp @r4
mov r0,r2
! Opcode 2678
M678:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1439
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1439:
jmp @r4
mov r0,r2
! Opcode 2679
M679:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1440
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1440:
jmp @r4
mov r0,r2
! Opcode 267A
M67A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1441
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1441:
jmp @r4
mov r0,r2
! Opcode 267B
M67B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1442
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1442:
jmp @r4
mov r0,r2
! Opcode 267C
M67C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1443
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1443:
jmp @r4
mov r0,r2
! Opcodes 2680 - 2687
M680:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1444
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1444:
jmp @r4
mov r0,r2
! Opcodes 2688 - 268F
M688:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1445
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1445:
jmp @r4
mov r0,r2
! Opcodes 2690 - 2697
M690:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1446
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1446:
jmp @r4
mov r0,r2
! Opcodes 2698 - 269F
M698:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1447
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1447:
jmp @r4
mov r0,r2
! Opcodes 26A0 - 26A7
M6A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1448
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1448:
jmp @r4
mov r0,r2
! Opcodes 26A8 - 26AF
M6A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1449
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1449:
jmp @r4
mov r0,r2
! Opcodes 26B0 - 26B7
M6B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1450
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1450:
jmp @r4
mov r0,r2
! Opcode 26B8
M6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1451
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1451:
jmp @r4
mov r0,r2
! Opcode 26B9
M6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1452
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1452:
jmp @r4
mov r0,r2
! Opcode 26BA
M6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1453
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1453:
jmp @r4
mov r0,r2
! Opcode 26BB
M6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1454
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1454:
jmp @r4
mov r0,r2
! Opcode 26BC
M6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1455
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1455:
jmp @r4
mov r0,r2
! Opcodes 26C0 - 26C7
M6C0:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1456
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1456:
jmp @r4
mov r0,r2
! Opcodes 26C8 - 26CF
M6C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1457
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1457:
jmp @r4
mov r0,r2
! Opcodes 26D0 - 26D7
M6D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1458
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1458:
jmp @r4
mov r0,r2
! Opcodes 26D8 - 26DF
M6D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1459
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1459:
jmp @r4
mov r0,r2
! Opcodes 26E0 - 26E7
M6E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1460
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1460:
jmp @r4
mov r0,r2
! Opcodes 26E8 - 26EF
M6E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1461
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1461:
jmp @r4
mov r0,r2
! Opcodes 26F0 - 26F7
M6F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1462
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1462:
jmp @r4
mov r0,r2
! Opcode 26F8
M6F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1463
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1463:
jmp @r4
mov r0,r2
! Opcode 26F9
M6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1464
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1464:
jmp @r4
mov r0,r2
! Opcode 26FA
M6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1465
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1465:
jmp @r4
mov r0,r2
! Opcode 26FB
M6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1466
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1466:
jmp @r4
mov r0,r2
! Opcode 26FC
M6FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1467
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1467:
jmp @r4
mov r0,r2
! Opcodes 2700 - 2707
M700:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1468
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1468:
jmp @r4
mov r0,r2
! Opcodes 2708 - 270F
M708:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1469
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1469:
jmp @r4
mov r0,r2
! Opcodes 2710 - 2717
M710:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1470
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1470:
jmp @r4
mov r0,r2
! Opcodes 2718 - 271F
M718:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1471
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1471:
jmp @r4
mov r0,r2
! Opcodes 2720 - 2727
M720:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1472
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1472:
jmp @r4
mov r0,r2
! Opcodes 2728 - 272F
M728:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1473
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1473:
jmp @r4
mov r0,r2
! Opcodes 2730 - 2737
M730:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1474
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1474:
jmp @r4
mov r0,r2
! Opcode 2738
M738:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1475
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1475:
jmp @r4
mov r0,r2
! Opcode 2739
M739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1476
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1476:
jmp @r4
mov r0,r2
! Opcode 273A
M73A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1477
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1477:
jmp @r4
mov r0,r2
! Opcode 273B
M73B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1478
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1478:
jmp @r4
mov r0,r2
! Opcode 273C
M73C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1479
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1479:
jmp @r4
mov r0,r2
! Opcodes 2740 - 2747
M740:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1480
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1480:
jmp @r4
mov r0,r2
! Opcodes 2748 - 274F
M748:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1481
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1481:
jmp @r4
mov r0,r2
! Opcodes 2750 - 2757
M750:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1482
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1482:
jmp @r4
mov r0,r2
! Opcodes 2758 - 275F
M758:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1483
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1483:
jmp @r4
mov r0,r2
! Opcodes 2760 - 2767
M760:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1484
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1484:
jmp @r4
mov r0,r2
! Opcodes 2768 - 276F
M768:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1485
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1485:
jmp @r4
mov r0,r2
! Opcodes 2770 - 2777
M770:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1486
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1486:
jmp @r4
mov r0,r2
! Opcode 2778
M778:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1487
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1487:
jmp @r4
mov r0,r2
! Opcode 2779
M779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1488
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1488:
jmp @r4
mov r0,r2
! Opcode 277A
M77A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1489
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1489:
jmp @r4
mov r0,r2
! Opcode 277B
M77B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1490
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1490:
jmp @r4
mov r0,r2
! Opcode 277C
M77C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1491
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1491:
jmp @r4
mov r0,r2
! Opcodes 2780 - 2787
M780:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1492
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1492:
jmp @r4
mov r0,r2
! Opcodes 2788 - 278F
M788:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1493
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1493:
jmp @r4
mov r0,r2
! Opcodes 2790 - 2797
M790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1494
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1494:
jmp @r4
mov r0,r2
! Opcodes 2798 - 279F
M798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1495
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1495:
jmp @r4
mov r0,r2
! Opcodes 27A0 - 27A7
M7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1496
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1496:
jmp @r4
mov r0,r2
! Opcodes 27A8 - 27AF
M7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1497
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1497:
jmp @r4
mov r0,r2
! Opcodes 27B0 - 27B7
M7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1498
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1498:
jmp @r4
mov r0,r2
! Opcode 27B8
M7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1499
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1499:
jmp @r4
mov r0,r2
! Opcode 27B9
M7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1500
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1500:
jmp @r4
mov r0,r2
! Opcode 27BA
M7BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1501
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1501:
jmp @r4
mov r0,r2
! Opcode 27BB
M7BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1502
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1502:
jmp @r4
mov r0,r2
! Opcode 27BC
M7BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1503
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1503:
jmp @r4
mov r0,r2
! Opcodes 2800 - 2807
M800:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1504
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1504:
jmp @r4
mov r0,r2
! Opcodes 2808 - 280F
M808:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1505
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1505:
jmp @r4
mov r0,r2
! Opcodes 2810 - 2817
M810:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1506
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1506:
jmp @r4
mov r0,r2
! Opcodes 2818 - 281F
M818:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1507
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1507:
jmp @r4
mov r0,r2
! Opcodes 2820 - 2827
M820:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1508
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1508:
jmp @r4
mov r0,r2
! Opcodes 2828 - 282F
M828:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1509
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1509:
jmp @r4
mov r0,r2
! Opcodes 2830 - 2837
M830:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1510
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1510:
jmp @r4
mov r0,r2
! Opcode 2838
M838:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1511
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1511:
jmp @r4
mov r0,r2
! Opcode 2839
M839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1512
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1512:
jmp @r4
mov r0,r2
! Opcode 283A
M83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1513
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1513:
jmp @r4
mov r0,r2
! Opcode 283B
M83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1514
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1514:
jmp @r4
mov r0,r2
! Opcode 283C
M83C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1515
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1515:
jmp @r4
mov r0,r2
! Opcodes 2840 - 2847
M840:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1516
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1516:
jmp @r4
mov r0,r2
! Opcodes 2848 - 284F
M848:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1517
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1517:
jmp @r4
mov r0,r2
! Opcodes 2850 - 2857
M850:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1518
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1518:
jmp @r4
mov r0,r2
! Opcodes 2858 - 285F
M858:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1519
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1519:
jmp @r4
mov r0,r2
! Opcodes 2860 - 2867
M860:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1520
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1520:
jmp @r4
mov r0,r2
! Opcodes 2868 - 286F
M868:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1521
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1521:
jmp @r4
mov r0,r2
! Opcodes 2870 - 2877
M870:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1522
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1522:
jmp @r4
mov r0,r2
! Opcode 2878
M878:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1523
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1523:
jmp @r4
mov r0,r2
! Opcode 2879
M879:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1524
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1524:
jmp @r4
mov r0,r2
! Opcode 287A
M87A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1525
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1525:
jmp @r4
mov r0,r2
! Opcode 287B
M87B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1526
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1526:
jmp @r4
mov r0,r2
! Opcode 287C
M87C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1527
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1527:
jmp @r4
mov r0,r2
! Opcodes 2880 - 2887
M880:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1528
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1528:
jmp @r4
mov r0,r2
! Opcodes 2888 - 288F
M888:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1529
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1529:
jmp @r4
mov r0,r2
! Opcodes 2890 - 2897
M890:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1530
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1530:
jmp @r4
mov r0,r2
! Opcodes 2898 - 289F
M898:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1531
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1531:
jmp @r4
mov r0,r2
! Opcodes 28A0 - 28A7
M8A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1532
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1532:
jmp @r4
mov r0,r2
! Opcodes 28A8 - 28AF
M8A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1533
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1533:
jmp @r4
mov r0,r2
! Opcodes 28B0 - 28B7
M8B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1534
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1534:
jmp @r4
mov r0,r2
! Opcode 28B8
M8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1535
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1535:
jmp @r4
mov r0,r2
! Opcode 28B9
M8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1536
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1536:
jmp @r4
mov r0,r2
! Opcode 28BA
M8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1537
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1537:
jmp @r4
mov r0,r2
! Opcode 28BB
M8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1538
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1538:
jmp @r4
mov r0,r2
! Opcode 28BC
M8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1539
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1539:
jmp @r4
mov r0,r2
! Opcodes 28C0 - 28C7
M8C0:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1540
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1540:
jmp @r4
mov r0,r2
! Opcodes 28C8 - 28CF
M8C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1541
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1541:
jmp @r4
mov r0,r2
! Opcodes 28D0 - 28D7
M8D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1542
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1542:
jmp @r4
mov r0,r2
! Opcodes 28D8 - 28DF
M8D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1543
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1543:
jmp @r4
mov r0,r2
! Opcodes 28E0 - 28E7
M8E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1544
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1544:
jmp @r4
mov r0,r2
! Opcodes 28E8 - 28EF
M8E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1545
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1545:
jmp @r4
mov r0,r2
! Opcodes 28F0 - 28F7
M8F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1546
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1546:
jmp @r4
mov r0,r2
! Opcode 28F8
M8F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1547
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1547:
jmp @r4
mov r0,r2
! Opcode 28F9
M8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1548
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1548:
jmp @r4
mov r0,r2
! Opcode 28FA
M8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1549
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1549:
jmp @r4
mov r0,r2
! Opcode 28FB
M8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1550
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1550:
jmp @r4
mov r0,r2
! Opcode 28FC
M8FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1551
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1551:
jmp @r4
mov r0,r2
! Opcodes 2900 - 2907
M900:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1552
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1552:
jmp @r4
mov r0,r2
! Opcodes 2908 - 290F
M908:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1553
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1553:
jmp @r4
mov r0,r2
! Opcodes 2910 - 2917
M910:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1554
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1554:
jmp @r4
mov r0,r2
! Opcodes 2918 - 291F
M918:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1555
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1555:
jmp @r4
mov r0,r2
! Opcodes 2920 - 2927
M920:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1556
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1556:
jmp @r4
mov r0,r2
! Opcodes 2928 - 292F
M928:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1557
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1557:
jmp @r4
mov r0,r2
! Opcodes 2930 - 2937
M930:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1558
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1558:
jmp @r4
mov r0,r2
! Opcode 2938
M938:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1559
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1559:
jmp @r4
mov r0,r2
! Opcode 2939
M939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1560
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1560:
jmp @r4
mov r0,r2
! Opcode 293A
M93A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1561
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1561:
jmp @r4
mov r0,r2
! Opcode 293B
M93B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1562
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1562:
jmp @r4
mov r0,r2
! Opcode 293C
M93C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1563
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1563:
jmp @r4
mov r0,r2
! Opcodes 2940 - 2947
M940:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1564
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1564:
jmp @r4
mov r0,r2
! Opcodes 2948 - 294F
M948:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1565
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1565:
jmp @r4
mov r0,r2
! Opcodes 2950 - 2957
M950:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1566
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1566:
jmp @r4
mov r0,r2
! Opcodes 2958 - 295F
M958:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1567
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1567:
jmp @r4
mov r0,r2
! Opcodes 2960 - 2967
M960:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1568
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1568:
jmp @r4
mov r0,r2
! Opcodes 2968 - 296F
M968:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1569
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1569:
jmp @r4
mov r0,r2
! Opcodes 2970 - 2977
M970:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1570
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1570:
jmp @r4
mov r0,r2
! Opcode 2978
M978:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1571
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1571:
jmp @r4
mov r0,r2
! Opcode 2979
M979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1572
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1572:
jmp @r4
mov r0,r2
! Opcode 297A
M97A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1573
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1573:
jmp @r4
mov r0,r2
! Opcode 297B
M97B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1574
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1574:
jmp @r4
mov r0,r2
! Opcode 297C
M97C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1575
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1575:
jmp @r4
mov r0,r2
! Opcodes 2980 - 2987
M980:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1576
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1576:
jmp @r4
mov r0,r2
! Opcodes 2988 - 298F
M988:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1577
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1577:
jmp @r4
mov r0,r2
! Opcodes 2990 - 2997
M990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1578
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1578:
jmp @r4
mov r0,r2
! Opcodes 2998 - 299F
M998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1579
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1579:
jmp @r4
mov r0,r2
! Opcodes 29A0 - 29A7
M9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1580
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1580:
jmp @r4
mov r0,r2
! Opcodes 29A8 - 29AF
M9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1581
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1581:
jmp @r4
mov r0,r2
! Opcodes 29B0 - 29B7
M9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1582
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1582:
jmp @r4
mov r0,r2
! Opcode 29B8
M9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1583
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1583:
jmp @r4
mov r0,r2
! Opcode 29B9
M9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1584
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1584:
jmp @r4
mov r0,r2
! Opcode 29BA
M9BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1585
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1585:
jmp @r4
mov r0,r2
! Opcode 29BB
M9BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1586
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1586:
jmp @r4
mov r0,r2
! Opcode 29BC
M9BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1587
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1587:
jmp @r4
mov r0,r2
! Opcodes 2A00 - 2A07
MA00:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1588
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1588:
jmp @r4
mov r0,r2
! Opcodes 2A08 - 2A0F
MA08:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1589
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1589:
jmp @r4
mov r0,r2
! Opcodes 2A10 - 2A17
MA10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1590
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1590:
jmp @r4
mov r0,r2
! Opcodes 2A18 - 2A1F
MA18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1591
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1591:
jmp @r4
mov r0,r2
! Opcodes 2A20 - 2A27
MA20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1592
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1592:
jmp @r4
mov r0,r2
! Opcodes 2A28 - 2A2F
MA28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1593
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1593:
jmp @r4
mov r0,r2
! Opcodes 2A30 - 2A37
MA30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1594
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1594:
jmp @r4
mov r0,r2
! Opcode 2A38
MA38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1595
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1595:
jmp @r4
mov r0,r2
! Opcode 2A39
MA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1596
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1596:
jmp @r4
mov r0,r2
! Opcode 2A3A
MA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1597
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1597:
jmp @r4
mov r0,r2
! Opcode 2A3B
MA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1598
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1598:
jmp @r4
mov r0,r2
! Opcode 2A3C
MA3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1599
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1599:
jmp @r4
mov r0,r2
! Opcodes 2A40 - 2A47
MA40:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1600
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1600:
jmp @r4
mov r0,r2
! Opcodes 2A48 - 2A4F
MA48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1601
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1601:
jmp @r4
mov r0,r2
! Opcodes 2A50 - 2A57
MA50:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1602
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1602:
jmp @r4
mov r0,r2
! Opcodes 2A58 - 2A5F
MA58:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1603
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1603:
jmp @r4
mov r0,r2
! Opcodes 2A60 - 2A67
MA60:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1604
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1604:
jmp @r4
mov r0,r2
! Opcodes 2A68 - 2A6F
MA68:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1605
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1605:
jmp @r4
mov r0,r2
! Opcodes 2A70 - 2A77
MA70:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1606
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1606:
jmp @r4
mov r0,r2
! Opcode 2A78
MA78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1607
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1607:
jmp @r4
mov r0,r2
! Opcode 2A79
MA79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1608
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1608:
jmp @r4
mov r0,r2
! Opcode 2A7A
MA7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1609
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1609:
jmp @r4
mov r0,r2
! Opcode 2A7B
MA7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1610
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1610:
jmp @r4
mov r0,r2
! Opcode 2A7C
MA7C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1611
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1611:
jmp @r4
mov r0,r2
! Opcodes 2A80 - 2A87
MA80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1612
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1612:
jmp @r4
mov r0,r2
! Opcodes 2A88 - 2A8F
MA88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1613
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1613:
jmp @r4
mov r0,r2
! Opcodes 2A90 - 2A97
MA90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1614
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1614:
jmp @r4
mov r0,r2
! Opcodes 2A98 - 2A9F
MA98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1615
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1615:
jmp @r4
mov r0,r2
! Opcodes 2AA0 - 2AA7
MAA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1616
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1616:
jmp @r4
mov r0,r2
! Opcodes 2AA8 - 2AAF
MAA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1617
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1617:
jmp @r4
mov r0,r2
! Opcodes 2AB0 - 2AB7
MAB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1618
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1618:
jmp @r4
mov r0,r2
! Opcode 2AB8
MAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1619
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1619:
jmp @r4
mov r0,r2
! Opcode 2AB9
MAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1620
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1620:
jmp @r4
mov r0,r2
! Opcode 2ABA
MABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1621
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1621:
jmp @r4
mov r0,r2
! Opcode 2ABB
MABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1622
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1622:
jmp @r4
mov r0,r2
! Opcode 2ABC
MABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1623
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1623:
jmp @r4
mov r0,r2
! Opcodes 2AC0 - 2AC7
MAC0:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1624
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1624:
jmp @r4
mov r0,r2
! Opcodes 2AC8 - 2ACF
MAC8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1625
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1625:
jmp @r4
mov r0,r2
! Opcodes 2AD0 - 2AD7
MAD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1626
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1626:
jmp @r4
mov r0,r2
! Opcodes 2AD8 - 2ADF
MAD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1627
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1627:
jmp @r4
mov r0,r2
! Opcodes 2AE0 - 2AE7
MAE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1628
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1628:
jmp @r4
mov r0,r2
! Opcodes 2AE8 - 2AEF
MAE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1629
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1629:
jmp @r4
mov r0,r2
! Opcodes 2AF0 - 2AF7
MAF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1630
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1630:
jmp @r4
mov r0,r2
! Opcode 2AF8
MAF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1631
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1631:
jmp @r4
mov r0,r2
! Opcode 2AF9
MAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1632
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1632:
jmp @r4
mov r0,r2
! Opcode 2AFA
MAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1633
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1633:
jmp @r4
mov r0,r2
! Opcode 2AFB
MAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1634
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1634:
jmp @r4
mov r0,r2
! Opcode 2AFC
MAFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1635
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1635:
jmp @r4
mov r0,r2
! Opcodes 2B00 - 2B07
MB00:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1636
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1636:
jmp @r4
mov r0,r2
! Opcodes 2B08 - 2B0F
MB08:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1637
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1637:
jmp @r4
mov r0,r2
! Opcodes 2B10 - 2B17
MB10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1638
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1638:
jmp @r4
mov r0,r2
! Opcodes 2B18 - 2B1F
MB18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1639
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1639:
jmp @r4
mov r0,r2
! Opcodes 2B20 - 2B27
MB20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1640
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1640:
jmp @r4
mov r0,r2
! Opcodes 2B28 - 2B2F
MB28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1641
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1641:
jmp @r4
mov r0,r2
! Opcodes 2B30 - 2B37
MB30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1642
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1642:
jmp @r4
mov r0,r2
! Opcode 2B38
MB38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1643
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1643:
jmp @r4
mov r0,r2
! Opcode 2B39
MB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1644
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1644:
jmp @r4
mov r0,r2
! Opcode 2B3A
MB3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1645
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1645:
jmp @r4
mov r0,r2
! Opcode 2B3B
MB3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1646
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1646:
jmp @r4
mov r0,r2
! Opcode 2B3C
MB3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1647
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1647:
jmp @r4
mov r0,r2
! Opcodes 2B40 - 2B47
MB40:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1648
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1648:
jmp @r4
mov r0,r2
! Opcodes 2B48 - 2B4F
MB48:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1649
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1649:
jmp @r4
mov r0,r2
! Opcodes 2B50 - 2B57
MB50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1650
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1650:
jmp @r4
mov r0,r2
! Opcodes 2B58 - 2B5F
MB58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1651
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1651:
jmp @r4
mov r0,r2
! Opcodes 2B60 - 2B67
MB60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1652
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1652:
jmp @r4
mov r0,r2
! Opcodes 2B68 - 2B6F
MB68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1653
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1653:
jmp @r4
mov r0,r2
! Opcodes 2B70 - 2B77
MB70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1654
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1654:
jmp @r4
mov r0,r2
! Opcode 2B78
MB78:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1655
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1655:
jmp @r4
mov r0,r2
! Opcode 2B79
MB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1656
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1656:
jmp @r4
mov r0,r2
! Opcode 2B7A
MB7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1657
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1657:
jmp @r4
mov r0,r2
! Opcode 2B7B
MB7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1658
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1658:
jmp @r4
mov r0,r2
! Opcode 2B7C
MB7C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1659
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1659:
jmp @r4
mov r0,r2
! Opcodes 2B80 - 2B87
MB80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1660
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1660:
jmp @r4
mov r0,r2
! Opcodes 2B88 - 2B8F
MB88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1661
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1661:
jmp @r4
mov r0,r2
! Opcodes 2B90 - 2B97
MB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1662
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1662:
jmp @r4
mov r0,r2
! Opcodes 2B98 - 2B9F
MB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1663
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1663:
jmp @r4
mov r0,r2
! Opcodes 2BA0 - 2BA7
MBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1664
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1664:
jmp @r4
mov r0,r2
! Opcodes 2BA8 - 2BAF
MBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1665
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1665:
jmp @r4
mov r0,r2
! Opcodes 2BB0 - 2BB7
MBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1666
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1666:
jmp @r4
mov r0,r2
! Opcode 2BB8
MBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1667
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1667:
jmp @r4
mov r0,r2
! Opcode 2BB9
MBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1668
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1668:
jmp @r4
mov r0,r2
! Opcode 2BBA
MBBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1669
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1669:
jmp @r4
mov r0,r2
! Opcode 2BBB
MBBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1670
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1670:
jmp @r4
mov r0,r2
! Opcode 2BBC
MBBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1671
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1671:
jmp @r4
mov r0,r2
! Opcodes 2C00 - 2C07
MC00:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1672
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1672:
jmp @r4
mov r0,r2
! Opcodes 2C08 - 2C0F
MC08:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1673
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1673:
jmp @r4
mov r0,r2
! Opcodes 2C10 - 2C17
MC10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1674
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1674:
jmp @r4
mov r0,r2
! Opcodes 2C18 - 2C1F
MC18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1675
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1675:
jmp @r4
mov r0,r2
! Opcodes 2C20 - 2C27
MC20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1676
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1676:
jmp @r4
mov r0,r2
! Opcodes 2C28 - 2C2F
MC28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1677
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1677:
jmp @r4
mov r0,r2
! Opcodes 2C30 - 2C37
MC30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1678
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1678:
jmp @r4
mov r0,r2
! Opcode 2C38
MC38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1679
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1679:
jmp @r4
mov r0,r2
! Opcode 2C39
MC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1680
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1680:
jmp @r4
mov r0,r2
! Opcode 2C3A
MC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1681
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1681:
jmp @r4
mov r0,r2
! Opcode 2C3B
MC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1682
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1682:
jmp @r4
mov r0,r2
! Opcode 2C3C
MC3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1683
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1683:
jmp @r4
mov r0,r2
! Opcodes 2C40 - 2C47
MC40:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1684
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1684:
jmp @r4
mov r0,r2
! Opcodes 2C48 - 2C4F
MC48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1685
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1685:
jmp @r4
mov r0,r2
! Opcodes 2C50 - 2C57
MC50:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1686
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1686:
jmp @r4
mov r0,r2
! Opcodes 2C58 - 2C5F
MC58:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1687
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1687:
jmp @r4
mov r0,r2
! Opcodes 2C60 - 2C67
MC60:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1688
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1688:
jmp @r4
mov r0,r2
! Opcodes 2C68 - 2C6F
MC68:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1689
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1689:
jmp @r4
mov r0,r2
! Opcodes 2C70 - 2C77
MC70:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1690
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1690:
jmp @r4
mov r0,r2
! Opcode 2C78
MC78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1691
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1691:
jmp @r4
mov r0,r2
! Opcode 2C79
MC79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1692
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1692:
jmp @r4
mov r0,r2
! Opcode 2C7A
MC7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1693
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1693:
jmp @r4
mov r0,r2
! Opcode 2C7B
MC7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1694
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1694:
jmp @r4
mov r0,r2
! Opcode 2C7C
MC7C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1695
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1695:
jmp @r4
mov r0,r2
! Opcodes 2C80 - 2C87
MC80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1696
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1696:
jmp @r4
mov r0,r2
! Opcodes 2C88 - 2C8F
MC88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1697
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1697:
jmp @r4
mov r0,r2
! Opcodes 2C90 - 2C97
MC90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1698
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1698:
jmp @r4
mov r0,r2
! Opcodes 2C98 - 2C9F
MC98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1699
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1699:
jmp @r4
mov r0,r2
! Opcodes 2CA0 - 2CA7
MCA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1700
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1700:
jmp @r4
mov r0,r2
! Opcodes 2CA8 - 2CAF
MCA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1701
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1701:
jmp @r4
mov r0,r2
! Opcodes 2CB0 - 2CB7
MCB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1702
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1702:
jmp @r4
mov r0,r2
! Opcode 2CB8
MCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1703
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1703:
jmp @r4
mov r0,r2
! Opcode 2CB9
MCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1704
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1704:
jmp @r4
mov r0,r2
! Opcode 2CBA
MCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1705
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1705:
jmp @r4
mov r0,r2
! Opcode 2CBB
MCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1706
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1706:
jmp @r4
mov r0,r2
! Opcode 2CBC
MCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1707
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1707:
jmp @r4
mov r0,r2
! Opcodes 2CC0 - 2CC7
MCC0:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1708
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1708:
jmp @r4
mov r0,r2
! Opcodes 2CC8 - 2CCF
MCC8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1709
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1709:
jmp @r4
mov r0,r2
! Opcodes 2CD0 - 2CD7
MCD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1710
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1710:
jmp @r4
mov r0,r2
! Opcodes 2CD8 - 2CDF
MCD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1711
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1711:
jmp @r4
mov r0,r2
! Opcodes 2CE0 - 2CE7
MCE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1712
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1712:
jmp @r4
mov r0,r2
! Opcodes 2CE8 - 2CEF
MCE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1713
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1713:
jmp @r4
mov r0,r2
! Opcodes 2CF0 - 2CF7
MCF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1714
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1714:
jmp @r4
mov r0,r2
! Opcode 2CF8
MCF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1715
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1715:
jmp @r4
mov r0,r2
! Opcode 2CF9
MCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1716
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1716:
jmp @r4
mov r0,r2
! Opcode 2CFA
MCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1717
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1717:
jmp @r4
mov r0,r2
! Opcode 2CFB
MCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1718
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1718:
jmp @r4
mov r0,r2
! Opcode 2CFC
MCFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1719
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1719:
jmp @r4
mov r0,r2
! Opcodes 2D00 - 2D07
MD00:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1720
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1720:
jmp @r4
mov r0,r2
! Opcodes 2D08 - 2D0F
MD08:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1721
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1721:
jmp @r4
mov r0,r2
! Opcodes 2D10 - 2D17
MD10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1722
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1722:
jmp @r4
mov r0,r2
! Opcodes 2D18 - 2D1F
MD18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1723
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1723:
jmp @r4
mov r0,r2
! Opcodes 2D20 - 2D27
MD20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1724
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1724:
jmp @r4
mov r0,r2
! Opcodes 2D28 - 2D2F
MD28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1725
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1725:
jmp @r4
mov r0,r2
! Opcodes 2D30 - 2D37
MD30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1726
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1726:
jmp @r4
mov r0,r2
! Opcode 2D38
MD38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1727
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1727:
jmp @r4
mov r0,r2
! Opcode 2D39
MD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1728
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1728:
jmp @r4
mov r0,r2
! Opcode 2D3A
MD3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1729
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1729:
jmp @r4
mov r0,r2
! Opcode 2D3B
MD3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1730
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1730:
jmp @r4
mov r0,r2
! Opcode 2D3C
MD3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1731
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1731:
jmp @r4
mov r0,r2
! Opcodes 2D40 - 2D47
MD40:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1732
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1732:
jmp @r4
mov r0,r2
! Opcodes 2D48 - 2D4F
MD48:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1733
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1733:
jmp @r4
mov r0,r2
! Opcodes 2D50 - 2D57
MD50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1734
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1734:
jmp @r4
mov r0,r2
! Opcodes 2D58 - 2D5F
MD58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1735
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1735:
jmp @r4
mov r0,r2
! Opcodes 2D60 - 2D67
MD60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1736
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1736:
jmp @r4
mov r0,r2
! Opcodes 2D68 - 2D6F
MD68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1737
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1737:
jmp @r4
mov r0,r2
! Opcodes 2D70 - 2D77
MD70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1738
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1738:
jmp @r4
mov r0,r2
! Opcode 2D78
MD78:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1739
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1739:
jmp @r4
mov r0,r2
! Opcode 2D79
MD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1740
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1740:
jmp @r4
mov r0,r2
! Opcode 2D7A
MD7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1741
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1741:
jmp @r4
mov r0,r2
! Opcode 2D7B
MD7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1742
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1742:
jmp @r4
mov r0,r2
! Opcode 2D7C
MD7C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1743
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1743:
jmp @r4
mov r0,r2
! Opcodes 2D80 - 2D87
MD80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1744
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1744:
jmp @r4
mov r0,r2
! Opcodes 2D88 - 2D8F
MD88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1745
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1745:
jmp @r4
mov r0,r2
! Opcodes 2D90 - 2D97
MD90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1746
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1746:
jmp @r4
mov r0,r2
! Opcodes 2D98 - 2D9F
MD98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1747
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1747:
jmp @r4
mov r0,r2
! Opcodes 2DA0 - 2DA7
MDA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1748
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1748:
jmp @r4
mov r0,r2
! Opcodes 2DA8 - 2DAF
MDA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1749
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1749:
jmp @r4
mov r0,r2
! Opcodes 2DB0 - 2DB7
MDB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1750
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1750:
jmp @r4
mov r0,r2
! Opcode 2DB8
MDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1751
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1751:
jmp @r4
mov r0,r2
! Opcode 2DB9
MDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1752
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1752:
jmp @r4
mov r0,r2
! Opcode 2DBA
MDBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1753
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1753:
jmp @r4
mov r0,r2
! Opcode 2DBB
MDBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1754
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1754:
jmp @r4
mov r0,r2
! Opcode 2DBC
MDBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1755
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1755:
jmp @r4
mov r0,r2
! Opcodes 2E00 - 2E07
ME00:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1756
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1756:
jmp @r4
mov r0,r2
! Opcodes 2E08 - 2E0F
ME08:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1757
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1757:
jmp @r4
mov r0,r2
! Opcodes 2E10 - 2E17
ME10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1758
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1758:
jmp @r4
mov r0,r2
! Opcodes 2E18 - 2E1F
ME18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1759
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1759:
jmp @r4
mov r0,r2
! Opcodes 2E20 - 2E27
ME20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1760
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1760:
jmp @r4
mov r0,r2
! Opcodes 2E28 - 2E2F
ME28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1761
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1761:
jmp @r4
mov r0,r2
! Opcodes 2E30 - 2E37
ME30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1762
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1762:
jmp @r4
mov r0,r2
! Opcode 2E38
ME38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1763
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1763:
jmp @r4
mov r0,r2
! Opcode 2E39
ME39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1764
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1764:
jmp @r4
mov r0,r2
! Opcode 2E3A
ME3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1765
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1765:
jmp @r4
mov r0,r2
! Opcode 2E3B
ME3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1766
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1766:
jmp @r4
mov r0,r2
! Opcode 2E3C
ME3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1767
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1767:
jmp @r4
mov r0,r2
! Opcodes 2E40 - 2E47
ME40:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1768
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1768:
jmp @r4
mov r0,r2
! Opcodes 2E48 - 2E4F
ME48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1769
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1769:
jmp @r4
mov r0,r2
! Opcodes 2E50 - 2E57
ME50:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1770
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1770:
jmp @r4
mov r0,r2
! Opcodes 2E58 - 2E5F
ME58:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1771
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1771:
jmp @r4
mov r0,r2
! Opcodes 2E60 - 2E67
ME60:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1772
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1772:
jmp @r4
mov r0,r2
! Opcodes 2E68 - 2E6F
ME68:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1773
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1773:
jmp @r4
mov r0,r2
! Opcodes 2E70 - 2E77
ME70:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1774
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1774:
jmp @r4
mov r0,r2
! Opcode 2E78
ME78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1775
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1775:
jmp @r4
mov r0,r2
! Opcode 2E79
ME79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1776
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1776:
jmp @r4
mov r0,r2
! Opcode 2E7A
ME7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1777
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1777:
jmp @r4
mov r0,r2
! Opcode 2E7B
ME7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1778
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1778:
jmp @r4
mov r0,r2
! Opcode 2E7C
ME7C:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1779
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1779:
jmp @r4
mov r0,r2
! Opcodes 2E80 - 2E87
ME80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1780
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1780:
jmp @r4
mov r0,r2
! Opcodes 2E88 - 2E8F
ME88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1781
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1781:
jmp @r4
mov r0,r2
! Opcodes 2E90 - 2E97
ME90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1782
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1782:
jmp @r4
mov r0,r2
! Opcodes 2E98 - 2E9F
ME98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1783
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1783:
jmp @r4
mov r0,r2
! Opcodes 2EA0 - 2EA7
MEA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1784
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1784:
jmp @r4
mov r0,r2
! Opcodes 2EA8 - 2EAF
MEA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1785
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1785:
jmp @r4
mov r0,r2
! Opcodes 2EB0 - 2EB7
MEB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1786
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1786:
jmp @r4
mov r0,r2
! Opcode 2EB8
MEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1787
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1787:
jmp @r4
mov r0,r2
! Opcode 2EB9
MEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1788
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1788:
jmp @r4
mov r0,r2
! Opcode 2EBA
MEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1789
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1789:
jmp @r4
mov r0,r2
! Opcode 2EBB
MEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1790
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1790:
jmp @r4
mov r0,r2
! Opcode 2EBC
MEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1791
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1791:
jmp @r4
mov r0,r2
! Opcodes 2EC0 - 2EC7
MEC0:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1792
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1792:
jmp @r4
mov r0,r2
! Opcodes 2EC8 - 2ECF
MEC8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1793
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1793:
jmp @r4
mov r0,r2
! Opcodes 2ED0 - 2ED7
MED0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1794
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1794:
jmp @r4
mov r0,r2
! Opcodes 2ED8 - 2EDF
MED8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1795
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1795:
jmp @r4
mov r0,r2
! Opcodes 2EE0 - 2EE7
MEE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1796
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1796:
jmp @r4
mov r0,r2
! Opcodes 2EE8 - 2EEF
MEE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1797
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1797:
jmp @r4
mov r0,r2
! Opcodes 2EF0 - 2EF7
MEF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1798
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1798:
jmp @r4
mov r0,r2
! Opcode 2EF8
MEF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1799
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1799:
jmp @r4
mov r0,r2
! Opcode 2EF9
MEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1800
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1800:
jmp @r4
mov r0,r2
! Opcode 2EFA
MEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1801
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1801:
jmp @r4
mov r0,r2
! Opcode 2EFB
MEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1802
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1802:
jmp @r4
mov r0,r2
! Opcode 2EFC
MEFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1803
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1803:
jmp @r4
mov r0,r2
! Opcodes 2F00 - 2F07
MF00:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1804
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1804:
jmp @r4
mov r0,r2
! Opcodes 2F08 - 2F0F
MF08:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1805
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1805:
jmp @r4
mov r0,r2
! Opcodes 2F10 - 2F17
MF10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1806
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1806:
jmp @r4
mov r0,r2
! Opcodes 2F18 - 2F1F
MF18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1807
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1807:
jmp @r4
mov r0,r2
! Opcodes 2F20 - 2F27
MF20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1808
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1808:
jmp @r4
mov r0,r2
! Opcodes 2F28 - 2F2F
MF28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1809
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1809:
jmp @r4
mov r0,r2
! Opcodes 2F30 - 2F37
MF30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1810
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1810:
jmp @r4
mov r0,r2
! Opcode 2F38
MF38:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1811
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1811:
jmp @r4
mov r0,r2
! Opcode 2F39
MF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1812
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1812:
jmp @r4
mov r0,r2
! Opcode 2F3A
MF3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1813
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1813:
jmp @r4
mov r0,r2
! Opcode 2F3B
MF3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1814
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1814:
jmp @r4
mov r0,r2
! Opcode 2F3C
MF3C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1815
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1815:
jmp @r4
mov r0,r2
! Opcodes 2F40 - 2F47
MF40:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1816
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1816:
jmp @r4
mov r0,r2
! Opcodes 2F48 - 2F4F
MF48:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1817
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1817:
jmp @r4
mov r0,r2
! Opcodes 2F50 - 2F57
MF50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1818
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1818:
jmp @r4
mov r0,r2
! Opcodes 2F58 - 2F5F
MF58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1819
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1819:
jmp @r4
mov r0,r2
! Opcodes 2F60 - 2F67
MF60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1820
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1820:
jmp @r4
mov r0,r2
! Opcodes 2F68 - 2F6F
MF68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1821
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1821:
jmp @r4
mov r0,r2
! Opcodes 2F70 - 2F77
MF70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1822
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1822:
jmp @r4
mov r0,r2
! Opcode 2F78
MF78:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1823
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1823:
jmp @r4
mov r0,r2
! Opcode 2F79
MF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1824
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1824:
jmp @r4
mov r0,r2
! Opcode 2F7A
MF7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1825
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1825:
jmp @r4
mov r0,r2
! Opcode 2F7B
MF7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1826
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1826:
jmp @r4
mov r0,r2
! Opcode 2F7C
MF7C:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1827
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1827:
jmp @r4
mov r0,r2
! Opcodes 2F80 - 2F87
MF80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1828
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1828:
jmp @r4
mov r0,r2
! Opcodes 2F88 - 2F8F
MF88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1829
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1829:
jmp @r4
mov r0,r2
! Opcodes 2F90 - 2F97
MF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1830
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1830:
jmp @r4
mov r0,r2
! Opcodes 2F98 - 2F9F
MF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1831
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1831:
jmp @r4
mov r0,r2
! Opcodes 2FA0 - 2FA7
MFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1832
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1832:
jmp @r4
mov r0,r2
! Opcodes 2FA8 - 2FAF
MFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1833
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1833:
jmp @r4
mov r0,r2
! Opcodes 2FB0 - 2FB7
MFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1834
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1834:
jmp @r4
mov r0,r2
! Opcode 2FB8
MFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1835
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1835:
jmp @r4
mov r0,r2
! Opcode 2FB9
MFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1836
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1836:
jmp @r4
mov r0,r2
! Opcode 2FBA
MFBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1837
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1837:
jmp @r4
mov r0,r2
! Opcode 2FBB
MFBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-32,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1838
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1838:
jmp @r4
mov r0,r2
! Opcode 2FBC
MFBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1839
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1839:
jmp @r4
mov r0,r2
! Opcodes 3000 - 3007
N000:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1840
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1840:
jmp @r4
mov r0,r2
! Opcodes 3008 - 300F
N008:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1841
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1841:
jmp @r4
mov r0,r2
! Opcodes 3010 - 3017
N010:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1842
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1842:
jmp @r4
mov r0,r2
! Opcodes 3018 - 301F
N018:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1843
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1843:
jmp @r4
mov r0,r2
! Opcodes 3020 - 3027
N020:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1844
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1844:
jmp @r4
mov r0,r2
! Opcodes 3028 - 302F
N028:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1845
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1845:
jmp @r4
mov r0,r2
! Opcodes 3030 - 3037
N030:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1846
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1846:
jmp @r4
mov r0,r2
! Opcode 3038
N038:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1847
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1847:
jmp @r4
mov r0,r2
! Opcode 3039
N039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1848
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1848:
jmp @r4
mov r0,r2
! Opcode 303A
N03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1849
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1849:
jmp @r4
mov r0,r2
! Opcode 303B
N03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1850
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1850:
jmp @r4
mov r0,r2
! Opcode 303C
N03C:
mov.w @r6+,r3
mov.w r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1851
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1851:
jmp @r4
mov r0,r2
! Opcodes 3040 - 3047
N040:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1852
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1852:
jmp @r4
mov r0,r2
! Opcodes 3048 - 304F
N048:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1853
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1853:
jmp @r4
mov r0,r2
! Opcodes 3050 - 3057
N050:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1854
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1854:
jmp @r4
mov r0,r2
! Opcodes 3058 - 305F
N058:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1855
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1855:
jmp @r4
mov r0,r2
! Opcodes 3060 - 3067
N060:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1856
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1856:
jmp @r4
mov r0,r2
! Opcodes 3068 - 306F
N068:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1857
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1857:
jmp @r4
mov r0,r2
! Opcodes 3070 - 3077
N070:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1858
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1858:
jmp @r4
mov r0,r2
! Opcode 3078
N078:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1859
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1859:
jmp @r4
mov r0,r2
! Opcode 3079
N079:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1860
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1860:
jmp @r4
mov r0,r2
! Opcode 307A
N07A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1861
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1861:
jmp @r4
mov r0,r2
! Opcode 307B
N07B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1862
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1862:
jmp @r4
mov r0,r2
! Opcode 307C
N07C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1863
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1863:
jmp @r4
mov r0,r2
! Opcodes 3080 - 3087
N080:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1864
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1864:
jmp @r4
mov r0,r2
! Opcodes 3088 - 308F
N088:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1865
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1865:
jmp @r4
mov r0,r2
! Opcodes 3090 - 3097
N090:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1866
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1866:
jmp @r4
mov r0,r2
! Opcodes 3098 - 309F
N098:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1867
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1867:
jmp @r4
mov r0,r2
! Opcodes 30A0 - 30A7
N0A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1868
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1868:
jmp @r4
mov r0,r2
! Opcodes 30A8 - 30AF
N0A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1869
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1869:
jmp @r4
mov r0,r2
! Opcodes 30B0 - 30B7
N0B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1870
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1870:
jmp @r4
mov r0,r2
! Opcode 30B8
N0B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1871
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1871:
jmp @r4
mov r0,r2
! Opcode 30B9
N0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1872
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1872:
jmp @r4
mov r0,r2
! Opcode 30BA
N0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1873
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1873:
jmp @r4
mov r0,r2
! Opcode 30BB
N0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1874
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1874:
jmp @r4
mov r0,r2
! Opcode 30BC
N0BC:
mov.w @r6+,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1875
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1875:
jmp @r4
mov r0,r2
! Opcodes 30C0 - 30C7
N0C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1876
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1876:
jmp @r4
mov r0,r2
! Opcodes 30C8 - 30CF
N0C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1877
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1877:
jmp @r4
mov r0,r2
! Opcodes 30D0 - 30D7
N0D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1878
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1878:
jmp @r4
mov r0,r2
! Opcodes 30D8 - 30DF
N0D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1879
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1879:
jmp @r4
mov r0,r2
! Opcodes 30E0 - 30E7
N0E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1880
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1880:
jmp @r4
mov r0,r2
! Opcodes 30E8 - 30EF
N0E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1881
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1881:
jmp @r4
mov r0,r2
! Opcodes 30F0 - 30F7
N0F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1882
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1882:
jmp @r4
mov r0,r2
! Opcode 30F8
N0F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1883
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1883:
jmp @r4
mov r0,r2
! Opcode 30F9
N0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1884
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1884:
jmp @r4
mov r0,r2
! Opcode 30FA
N0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1885
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1885:
jmp @r4
mov r0,r2
! Opcode 30FB
N0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1886
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1886:
jmp @r4
mov r0,r2
! Opcode 30FC
N0FC:
mov.w @r6+,r3
mov.l @(32,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1887
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1887:
jmp @r4
mov r0,r2
! Opcodes 3100 - 3107
N100:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1888
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1888:
jmp @r4
mov r0,r2
! Opcodes 3108 - 310F
N108:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1889
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1889:
jmp @r4
mov r0,r2
! Opcodes 3110 - 3117
N110:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1890
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1890:
jmp @r4
mov r0,r2
! Opcodes 3118 - 311F
N118:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1891
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1891:
jmp @r4
mov r0,r2
! Opcodes 3120 - 3127
N120:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1892
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1892:
jmp @r4
mov r0,r2
! Opcodes 3128 - 312F
N128:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1893
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1893:
jmp @r4
mov r0,r2
! Opcodes 3130 - 3137
N130:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1894
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1894:
jmp @r4
mov r0,r2
! Opcode 3138
N138:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1895
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1895:
jmp @r4
mov r0,r2
! Opcode 3139
N139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1896
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1896:
jmp @r4
mov r0,r2
! Opcode 313A
N13A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1897
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1897:
jmp @r4
mov r0,r2
! Opcode 313B
N13B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1898
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1898:
jmp @r4
mov r0,r2
! Opcode 313C
N13C:
mov.w @r6+,r3
mov.l @(32,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1899
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1899:
jmp @r4
mov r0,r2
! Opcodes 3140 - 3147
N140:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1900
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1900:
jmp @r4
mov r0,r2
! Opcodes 3148 - 314F
N148:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1901
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1901:
jmp @r4
mov r0,r2
! Opcodes 3150 - 3157
N150:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1902
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1902:
jmp @r4
mov r0,r2
! Opcodes 3158 - 315F
N158:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1903
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1903:
jmp @r4
mov r0,r2
! Opcodes 3160 - 3167
N160:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1904
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1904:
jmp @r4
mov r0,r2
! Opcodes 3168 - 316F
N168:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1905
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1905:
jmp @r4
mov r0,r2
! Opcodes 3170 - 3177
N170:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1906
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1906:
jmp @r4
mov r0,r2
! Opcode 3178
N178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1907
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1907:
jmp @r4
mov r0,r2
! Opcode 3179
N179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1908
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1908:
jmp @r4
mov r0,r2
! Opcode 317A
N17A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1909
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1909:
jmp @r4
mov r0,r2
! Opcode 317B
N17B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1910
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1910:
jmp @r4
mov r0,r2
! Opcode 317C
N17C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1911
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1911:
jmp @r4
mov r0,r2
! Opcodes 3180 - 3187
N180:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1912
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1912:
jmp @r4
mov r0,r2
! Opcodes 3188 - 318F
N188:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1913
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1913:
jmp @r4
mov r0,r2
! Opcodes 3190 - 3197
N190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1914
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1914:
jmp @r4
mov r0,r2
! Opcodes 3198 - 319F
N198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1915
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1915:
jmp @r4
mov r0,r2
! Opcodes 31A0 - 31A7
N1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1916
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1916:
jmp @r4
mov r0,r2
! Opcodes 31A8 - 31AF
N1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1917
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1917:
jmp @r4
mov r0,r2
! Opcodes 31B0 - 31B7
N1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1918
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1918:
jmp @r4
mov r0,r2
! Opcode 31B8
N1B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1919
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1919:
jmp @r4
mov r0,r2
! Opcode 31B9
N1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1920
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1920:
jmp @r4
mov r0,r2
! Opcode 31BA
N1BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1921
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1921:
jmp @r4
mov r0,r2
! Opcode 31BB
N1BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1922
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1922:
jmp @r4
mov r0,r2
! Opcode 31BC
N1BC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(32,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1923
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1923:
jmp @r4
mov r0,r2
! Opcodes 31C0 - 31C7
N1C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1924
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1924:
jmp @r4
mov r0,r2
! Opcodes 31C8 - 31CF
N1C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1925
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1925:
jmp @r4
mov r0,r2
! Opcodes 31D0 - 31D7
N1D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1926
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1926:
jmp @r4
mov r0,r2
! Opcodes 31D8 - 31DF
N1D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1927
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1927:
jmp @r4
mov r0,r2
! Opcodes 31E0 - 31E7
N1E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1928
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1928:
jmp @r4
mov r0,r2
! Opcodes 31E8 - 31EF
N1E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1929
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1929:
jmp @r4
mov r0,r2
! Opcodes 31F0 - 31F7
N1F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1930
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1930:
jmp @r4
mov r0,r2
! Opcode 31F8
N1F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1931
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1931:
jmp @r4
mov r0,r2
! Opcode 31F9
N1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1932
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1932:
jmp @r4
mov r0,r2
! Opcode 31FA
N1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1933
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1933:
jmp @r4
mov r0,r2
! Opcode 31FB
N1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1934
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1934:
jmp @r4
mov r0,r2
! Opcode 31FC
N1FC:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1935
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1935:
jmp @r4
mov r0,r2
! Opcodes 3200 - 3207
N200:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1936
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1936:
jmp @r4
mov r0,r2
! Opcodes 3208 - 320F
N208:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1937
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1937:
jmp @r4
mov r0,r2
! Opcodes 3210 - 3217
N210:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1938
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1938:
jmp @r4
mov r0,r2
! Opcodes 3218 - 321F
N218:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1939
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1939:
jmp @r4
mov r0,r2
! Opcodes 3220 - 3227
N220:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1940
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1940:
jmp @r4
mov r0,r2
! Opcodes 3228 - 322F
N228:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1941
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1941:
jmp @r4
mov r0,r2
! Opcodes 3230 - 3237
N230:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1942
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1942:
jmp @r4
mov r0,r2
! Opcode 3238
N238:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1943
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1943:
jmp @r4
mov r0,r2
! Opcode 3239
N239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1944
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1944:
jmp @r4
mov r0,r2
! Opcode 323A
N23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1945
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1945:
jmp @r4
mov r0,r2
! Opcode 323B
N23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1946
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1946:
jmp @r4
mov r0,r2
! Opcode 323C
N23C:
mov.w @r6+,r3
mov #4,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1947
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1947:
jmp @r4
mov r0,r2
! Opcodes 3240 - 3247
N240:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1948
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1948:
jmp @r4
mov r0,r2
! Opcodes 3248 - 324F
N248:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1949
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1949:
jmp @r4
mov r0,r2
! Opcodes 3250 - 3257
N250:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1950
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1950:
jmp @r4
mov r0,r2
! Opcodes 3258 - 325F
N258:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1951
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1951:
jmp @r4
mov r0,r2
! Opcodes 3260 - 3267
N260:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1952
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1952:
jmp @r4
mov r0,r2
! Opcodes 3268 - 326F
N268:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1953
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1953:
jmp @r4
mov r0,r2
! Opcodes 3270 - 3277
N270:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1954
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1954:
jmp @r4
mov r0,r2
! Opcode 3278
N278:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1955
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1955:
jmp @r4
mov r0,r2
! Opcode 3279
N279:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1956
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1956:
jmp @r4
mov r0,r2
! Opcode 327A
N27A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1957
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1957:
jmp @r4
mov r0,r2
! Opcode 327B
N27B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1958
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1958:
jmp @r4
mov r0,r2
! Opcode 327C
N27C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1959
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1959:
jmp @r4
mov r0,r2
! Opcodes 3280 - 3287
N280:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1960
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1960:
jmp @r4
mov r0,r2
! Opcodes 3288 - 328F
N288:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1961
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1961:
jmp @r4
mov r0,r2
! Opcodes 3290 - 3297
N290:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1962
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1962:
jmp @r4
mov r0,r2
! Opcodes 3298 - 329F
N298:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1963
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1963:
jmp @r4
mov r0,r2
! Opcodes 32A0 - 32A7
N2A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1964
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1964:
jmp @r4
mov r0,r2
! Opcodes 32A8 - 32AF
N2A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1965
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1965:
jmp @r4
mov r0,r2
! Opcodes 32B0 - 32B7
N2B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1966
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1966:
jmp @r4
mov r0,r2
! Opcode 32B8
N2B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1967
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1967:
jmp @r4
mov r0,r2
! Opcode 32B9
N2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1968
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1968:
jmp @r4
mov r0,r2
! Opcode 32BA
N2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1969
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1969:
jmp @r4
mov r0,r2
! Opcode 32BB
N2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1970
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1970:
jmp @r4
mov r0,r2
! Opcode 32BC
N2BC:
mov.w @r6+,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1971
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1971:
jmp @r4
mov r0,r2
! Opcodes 32C0 - 32C7
N2C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1972
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1972:
jmp @r4
mov r0,r2
! Opcodes 32C8 - 32CF
N2C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1973
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1973:
jmp @r4
mov r0,r2
! Opcodes 32D0 - 32D7
N2D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1974
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1974:
jmp @r4
mov r0,r2
! Opcodes 32D8 - 32DF
N2D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1975
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1975:
jmp @r4
mov r0,r2
! Opcodes 32E0 - 32E7
N2E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1976
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1976:
jmp @r4
mov r0,r2
! Opcodes 32E8 - 32EF
N2E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1977
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1977:
jmp @r4
mov r0,r2
! Opcodes 32F0 - 32F7
N2F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1978
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1978:
jmp @r4
mov r0,r2
! Opcode 32F8
N2F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1979
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1979:
jmp @r4
mov r0,r2
! Opcode 32F9
N2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1980
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1980:
jmp @r4
mov r0,r2
! Opcode 32FA
N2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1981
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1981:
jmp @r4
mov r0,r2
! Opcode 32FB
N2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1982
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1982:
jmp @r4
mov r0,r2
! Opcode 32FC
N2FC:
mov.w @r6+,r3
mov.l @(36,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1983
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1983:
jmp @r4
mov r0,r2
! Opcodes 3300 - 3307
N300:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1984
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1984:
jmp @r4
mov r0,r2
! Opcodes 3308 - 330F
N308:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1985
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1985:
jmp @r4
mov r0,r2
! Opcodes 3310 - 3317
N310:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1986
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1986:
jmp @r4
mov r0,r2
! Opcodes 3318 - 331F
N318:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1987
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1987:
jmp @r4
mov r0,r2
! Opcodes 3320 - 3327
N320:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1988
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1988:
jmp @r4
mov r0,r2
! Opcodes 3328 - 332F
N328:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1989
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1989:
jmp @r4
mov r0,r2
! Opcodes 3330 - 3337
N330:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1990
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1990:
jmp @r4
mov r0,r2
! Opcode 3338
N338:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1991
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1991:
jmp @r4
mov r0,r2
! Opcode 3339
N339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1992
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1992:
jmp @r4
mov r0,r2
! Opcode 333A
N33A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1993
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1993:
jmp @r4
mov r0,r2
! Opcode 333B
N33B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1994
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1994:
jmp @r4
mov r0,r2
! Opcode 333C
N33C:
mov.w @r6+,r3
mov.l @(36,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1995
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1995:
jmp @r4
mov r0,r2
! Opcodes 3340 - 3347
N340:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1996
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1996:
jmp @r4
mov r0,r2
! Opcodes 3348 - 334F
N348:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1997
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1997:
jmp @r4
mov r0,r2
! Opcodes 3350 - 3357
N350:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1998
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1998:
jmp @r4
mov r0,r2
! Opcodes 3358 - 335F
N358:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl1999
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl1999:
jmp @r4
mov r0,r2
! Opcodes 3360 - 3367
N360:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2000
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2000:
jmp @r4
mov r0,r2
! Opcodes 3368 - 336F
N368:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2001
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2001:
jmp @r4
mov r0,r2
! Opcodes 3370 - 3377
N370:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2002
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2002:
jmp @r4
mov r0,r2
! Opcode 3378
N378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2003
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2003:
jmp @r4
mov r0,r2
! Opcode 3379
N379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2004
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2004:
jmp @r4
mov r0,r2
! Opcode 337A
N37A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2005
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2005:
jmp @r4
mov r0,r2
! Opcode 337B
N37B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2006
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2006:
jmp @r4
mov r0,r2
! Opcode 337C
N37C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2007
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2007:
jmp @r4
mov r0,r2
! Opcodes 3380 - 3387
N380:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2008
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2008:
jmp @r4
mov r0,r2
! Opcodes 3388 - 338F
N388:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2009
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2009:
jmp @r4
mov r0,r2
! Opcodes 3390 - 3397
N390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2010
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2010:
jmp @r4
mov r0,r2
! Opcodes 3398 - 339F
N398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2011
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2011:
jmp @r4
mov r0,r2
! Opcodes 33A0 - 33A7
N3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2012
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2012:
jmp @r4
mov r0,r2
! Opcodes 33A8 - 33AF
N3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2013
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2013:
jmp @r4
mov r0,r2
! Opcodes 33B0 - 33B7
N3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2014
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2014:
jmp @r4
mov r0,r2
! Opcode 33B8
N3B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2015
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2015:
jmp @r4
mov r0,r2
! Opcode 33B9
N3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2016
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2016:
jmp @r4
mov r0,r2
! Opcode 33BA
N3BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2017
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2017:
jmp @r4
mov r0,r2
! Opcode 33BB
N3BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2018
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2018:
jmp @r4
mov r0,r2
! Opcode 33BC
N3BC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(36,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2019
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2019:
jmp @r4
mov r0,r2
! Opcodes 33C0 - 33C7
N3C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2020
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2020:
jmp @r4
mov r0,r2
! Opcodes 33C8 - 33CF
N3C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2021
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2021:
jmp @r4
mov r0,r2
! Opcodes 33D0 - 33D7
N3D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2022
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2022:
jmp @r4
mov r0,r2
! Opcodes 33D8 - 33DF
N3D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2023
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2023:
jmp @r4
mov r0,r2
! Opcodes 33E0 - 33E7
N3E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2024
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2024:
jmp @r4
mov r0,r2
! Opcodes 33E8 - 33EF
N3E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2025
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2025:
jmp @r4
mov r0,r2
! Opcodes 33F0 - 33F7
N3F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2026
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2026:
jmp @r4
mov r0,r2
! Opcode 33F8
N3F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2027
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2027:
jmp @r4
mov r0,r2
! Opcode 33F9
N3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2028
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2028:
jmp @r4
mov r0,r2
! Opcode 33FA
N3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2029
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2029:
jmp @r4
mov r0,r2
! Opcode 33FB
N3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2030
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2030:
jmp @r4
mov r0,r2
! Opcode 33FC
N3FC:
mov.w @r6+,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2031
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2031:
jmp @r4
mov r0,r2
! Opcodes 3400 - 3407
N400:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2032
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2032:
jmp @r4
mov r0,r2
! Opcodes 3408 - 340F
N408:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2033
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2033:
jmp @r4
mov r0,r2
! Opcodes 3410 - 3417
N410:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2034
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2034:
jmp @r4
mov r0,r2
! Opcodes 3418 - 341F
N418:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2035
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2035:
jmp @r4
mov r0,r2
! Opcodes 3420 - 3427
N420:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2036
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2036:
jmp @r4
mov r0,r2
! Opcodes 3428 - 342F
N428:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2037
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2037:
jmp @r4
mov r0,r2
! Opcodes 3430 - 3437
N430:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2038
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2038:
jmp @r4
mov r0,r2
! Opcode 3438
N438:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2039
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2039:
jmp @r4
mov r0,r2
! Opcode 3439
N439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2040
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2040:
jmp @r4
mov r0,r2
! Opcode 343A
N43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2041
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2041:
jmp @r4
mov r0,r2
! Opcode 343B
N43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2042
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2042:
jmp @r4
mov r0,r2
! Opcode 343C
N43C:
mov.w @r6+,r3
mov #8,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2043
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2043:
jmp @r4
mov r0,r2
! Opcodes 3440 - 3447
N440:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2044
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2044:
jmp @r4
mov r0,r2
! Opcodes 3448 - 344F
N448:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2045
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2045:
jmp @r4
mov r0,r2
! Opcodes 3450 - 3457
N450:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2046
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2046:
jmp @r4
mov r0,r2
! Opcodes 3458 - 345F
N458:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2047
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2047:
jmp @r4
mov r0,r2
! Opcodes 3460 - 3467
N460:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2048
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2048:
jmp @r4
mov r0,r2
! Opcodes 3468 - 346F
N468:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2049
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2049:
jmp @r4
mov r0,r2
! Opcodes 3470 - 3477
N470:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2050
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2050:
jmp @r4
mov r0,r2
! Opcode 3478
N478:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2051
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2051:
jmp @r4
mov r0,r2
! Opcode 3479
N479:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2052
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2052:
jmp @r4
mov r0,r2
! Opcode 347A
N47A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2053
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2053:
jmp @r4
mov r0,r2
! Opcode 347B
N47B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2054
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2054:
jmp @r4
mov r0,r2
! Opcode 347C
N47C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2055
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2055:
jmp @r4
mov r0,r2
! Opcodes 3480 - 3487
N480:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2056
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2056:
jmp @r4
mov r0,r2
! Opcodes 3488 - 348F
N488:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2057
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2057:
jmp @r4
mov r0,r2
! Opcodes 3490 - 3497
N490:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2058
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2058:
jmp @r4
mov r0,r2
! Opcodes 3498 - 349F
N498:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2059
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2059:
jmp @r4
mov r0,r2
! Opcodes 34A0 - 34A7
N4A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2060
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2060:
jmp @r4
mov r0,r2
! Opcodes 34A8 - 34AF
N4A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2061
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2061:
jmp @r4
mov r0,r2
! Opcodes 34B0 - 34B7
N4B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2062
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2062:
jmp @r4
mov r0,r2
! Opcode 34B8
N4B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2063
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2063:
jmp @r4
mov r0,r2
! Opcode 34B9
N4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2064
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2064:
jmp @r4
mov r0,r2
! Opcode 34BA
N4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2065
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2065:
jmp @r4
mov r0,r2
! Opcode 34BB
N4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2066
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2066:
jmp @r4
mov r0,r2
! Opcode 34BC
N4BC:
mov.w @r6+,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2067
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2067:
jmp @r4
mov r0,r2
! Opcodes 34C0 - 34C7
N4C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2068
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2068:
jmp @r4
mov r0,r2
! Opcodes 34C8 - 34CF
N4C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2069
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2069:
jmp @r4
mov r0,r2
! Opcodes 34D0 - 34D7
N4D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2070
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2070:
jmp @r4
mov r0,r2
! Opcodes 34D8 - 34DF
N4D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2071
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2071:
jmp @r4
mov r0,r2
! Opcodes 34E0 - 34E7
N4E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2072
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2072:
jmp @r4
mov r0,r2
! Opcodes 34E8 - 34EF
N4E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2073
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2073:
jmp @r4
mov r0,r2
! Opcodes 34F0 - 34F7
N4F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2074
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2074:
jmp @r4
mov r0,r2
! Opcode 34F8
N4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2075
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2075:
jmp @r4
mov r0,r2
! Opcode 34F9
N4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2076
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2076:
jmp @r4
mov r0,r2
! Opcode 34FA
N4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2077
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2077:
jmp @r4
mov r0,r2
! Opcode 34FB
N4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2078
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2078:
jmp @r4
mov r0,r2
! Opcode 34FC
N4FC:
mov.w @r6+,r3
mov.l @(40,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2079
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2079:
jmp @r4
mov r0,r2
! Opcodes 3500 - 3507
N500:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2080
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2080:
jmp @r4
mov r0,r2
! Opcodes 3508 - 350F
N508:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2081
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2081:
jmp @r4
mov r0,r2
! Opcodes 3510 - 3517
N510:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2082
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2082:
jmp @r4
mov r0,r2
! Opcodes 3518 - 351F
N518:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2083
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2083:
jmp @r4
mov r0,r2
! Opcodes 3520 - 3527
N520:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2084
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2084:
jmp @r4
mov r0,r2
! Opcodes 3528 - 352F
N528:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2085
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2085:
jmp @r4
mov r0,r2
! Opcodes 3530 - 3537
N530:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2086
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2086:
jmp @r4
mov r0,r2
! Opcode 3538
N538:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2087
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2087:
jmp @r4
mov r0,r2
! Opcode 3539
N539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2088
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2088:
jmp @r4
mov r0,r2
! Opcode 353A
N53A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2089
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2089:
jmp @r4
mov r0,r2
! Opcode 353B
N53B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2090
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2090:
jmp @r4
mov r0,r2
! Opcode 353C
N53C:
mov.w @r6+,r3
mov.l @(40,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2091
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2091:
jmp @r4
mov r0,r2
! Opcodes 3540 - 3547
N540:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2092
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2092:
jmp @r4
mov r0,r2
! Opcodes 3548 - 354F
N548:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2093
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2093:
jmp @r4
mov r0,r2
! Opcodes 3550 - 3557
N550:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2094
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2094:
jmp @r4
mov r0,r2
! Opcodes 3558 - 355F
N558:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2095
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2095:
jmp @r4
mov r0,r2
! Opcodes 3560 - 3567
N560:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2096
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2096:
jmp @r4
mov r0,r2
! Opcodes 3568 - 356F
N568:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2097
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2097:
jmp @r4
mov r0,r2
! Opcodes 3570 - 3577
N570:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2098
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2098:
jmp @r4
mov r0,r2
! Opcode 3578
N578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2099
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2099:
jmp @r4
mov r0,r2
! Opcode 3579
N579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2100
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2100:
jmp @r4
mov r0,r2
! Opcode 357A
N57A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2101
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2101:
jmp @r4
mov r0,r2
! Opcode 357B
N57B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2102
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2102:
jmp @r4
mov r0,r2
! Opcode 357C
N57C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2103
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2103:
jmp @r4
mov r0,r2
! Opcodes 3580 - 3587
N580:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2104
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2104:
jmp @r4
mov r0,r2
! Opcodes 3588 - 358F
N588:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2105
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2105:
jmp @r4
mov r0,r2
! Opcodes 3590 - 3597
N590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2106
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2106:
jmp @r4
mov r0,r2
! Opcodes 3598 - 359F
N598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2107
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2107:
jmp @r4
mov r0,r2
! Opcodes 35A0 - 35A7
N5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2108
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2108:
jmp @r4
mov r0,r2
! Opcodes 35A8 - 35AF
N5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2109
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2109:
jmp @r4
mov r0,r2
! Opcodes 35B0 - 35B7
N5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2110
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2110:
jmp @r4
mov r0,r2
! Opcode 35B8
N5B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2111
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2111:
jmp @r4
mov r0,r2
! Opcode 35B9
N5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2112
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2112:
jmp @r4
mov r0,r2
! Opcode 35BA
N5BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2113
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2113:
jmp @r4
mov r0,r2
! Opcode 35BB
N5BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2114
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2114:
jmp @r4
mov r0,r2
! Opcode 35BC
N5BC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(40,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2115
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2115:
jmp @r4
mov r0,r2
! Opcodes 3600 - 3607
N600:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2116
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2116:
jmp @r4
mov r0,r2
! Opcodes 3608 - 360F
N608:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2117
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2117:
jmp @r4
mov r0,r2
! Opcodes 3610 - 3617
N610:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2118
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2118:
jmp @r4
mov r0,r2
! Opcodes 3618 - 361F
N618:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2119
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2119:
jmp @r4
mov r0,r2
! Opcodes 3620 - 3627
N620:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2120
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2120:
jmp @r4
mov r0,r2
! Opcodes 3628 - 362F
N628:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2121
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2121:
jmp @r4
mov r0,r2
! Opcodes 3630 - 3637
N630:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2122
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2122:
jmp @r4
mov r0,r2
! Opcode 3638
N638:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2123
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2123:
jmp @r4
mov r0,r2
! Opcode 3639
N639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2124
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2124:
jmp @r4
mov r0,r2
! Opcode 363A
N63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2125
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2125:
jmp @r4
mov r0,r2
! Opcode 363B
N63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2126
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2126:
jmp @r4
mov r0,r2
! Opcode 363C
N63C:
mov.w @r6+,r3
mov #12,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2127
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2127:
jmp @r4
mov r0,r2
! Opcodes 3640 - 3647
N640:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2128
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2128:
jmp @r4
mov r0,r2
! Opcodes 3648 - 364F
N648:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2129
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2129:
jmp @r4
mov r0,r2
! Opcodes 3650 - 3657
N650:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2130
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2130:
jmp @r4
mov r0,r2
! Opcodes 3658 - 365F
N658:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2131
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2131:
jmp @r4
mov r0,r2
! Opcodes 3660 - 3667
N660:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2132
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2132:
jmp @r4
mov r0,r2
! Opcodes 3668 - 366F
N668:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2133
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2133:
jmp @r4
mov r0,r2
! Opcodes 3670 - 3677
N670:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2134
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2134:
jmp @r4
mov r0,r2
! Opcode 3678
N678:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2135
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2135:
jmp @r4
mov r0,r2
! Opcode 3679
N679:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2136
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2136:
jmp @r4
mov r0,r2
! Opcode 367A
N67A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2137
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2137:
jmp @r4
mov r0,r2
! Opcode 367B
N67B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2138
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2138:
jmp @r4
mov r0,r2
! Opcode 367C
N67C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2139
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2139:
jmp @r4
mov r0,r2
! Opcodes 3680 - 3687
N680:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2140
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2140:
jmp @r4
mov r0,r2
! Opcodes 3688 - 368F
N688:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2141
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2141:
jmp @r4
mov r0,r2
! Opcodes 3690 - 3697
N690:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2142
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2142:
jmp @r4
mov r0,r2
! Opcodes 3698 - 369F
N698:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2143
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2143:
jmp @r4
mov r0,r2
! Opcodes 36A0 - 36A7
N6A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2144
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2144:
jmp @r4
mov r0,r2
! Opcodes 36A8 - 36AF
N6A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2145
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2145:
jmp @r4
mov r0,r2
! Opcodes 36B0 - 36B7
N6B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2146
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2146:
jmp @r4
mov r0,r2
! Opcode 36B8
N6B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2147
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2147:
jmp @r4
mov r0,r2
! Opcode 36B9
N6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2148
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2148:
jmp @r4
mov r0,r2
! Opcode 36BA
N6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2149
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2149:
jmp @r4
mov r0,r2
! Opcode 36BB
N6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2150
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2150:
jmp @r4
mov r0,r2
! Opcode 36BC
N6BC:
mov.w @r6+,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2151
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2151:
jmp @r4
mov r0,r2
! Opcodes 36C0 - 36C7
N6C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2152
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2152:
jmp @r4
mov r0,r2
! Opcodes 36C8 - 36CF
N6C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2153
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2153:
jmp @r4
mov r0,r2
! Opcodes 36D0 - 36D7
N6D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2154
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2154:
jmp @r4
mov r0,r2
! Opcodes 36D8 - 36DF
N6D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2155
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2155:
jmp @r4
mov r0,r2
! Opcodes 36E0 - 36E7
N6E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2156
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2156:
jmp @r4
mov r0,r2
! Opcodes 36E8 - 36EF
N6E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2157
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2157:
jmp @r4
mov r0,r2
! Opcodes 36F0 - 36F7
N6F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2158
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2158:
jmp @r4
mov r0,r2
! Opcode 36F8
N6F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2159
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2159:
jmp @r4
mov r0,r2
! Opcode 36F9
N6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2160
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2160:
jmp @r4
mov r0,r2
! Opcode 36FA
N6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2161
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2161:
jmp @r4
mov r0,r2
! Opcode 36FB
N6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2162
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2162:
jmp @r4
mov r0,r2
! Opcode 36FC
N6FC:
mov.w @r6+,r3
mov.l @(44,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2163
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2163:
jmp @r4
mov r0,r2
! Opcodes 3700 - 3707
N700:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2164
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2164:
jmp @r4
mov r0,r2
! Opcodes 3708 - 370F
N708:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2165
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2165:
jmp @r4
mov r0,r2
! Opcodes 3710 - 3717
N710:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2166
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2166:
jmp @r4
mov r0,r2
! Opcodes 3718 - 371F
N718:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2167
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2167:
jmp @r4
mov r0,r2
! Opcodes 3720 - 3727
N720:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2168
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2168:
jmp @r4
mov r0,r2
! Opcodes 3728 - 372F
N728:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2169
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2169:
jmp @r4
mov r0,r2
! Opcodes 3730 - 3737
N730:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2170
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2170:
jmp @r4
mov r0,r2
! Opcode 3738
N738:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2171
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2171:
jmp @r4
mov r0,r2
! Opcode 3739
N739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2172
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2172:
jmp @r4
mov r0,r2
! Opcode 373A
N73A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2173
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2173:
jmp @r4
mov r0,r2
! Opcode 373B
N73B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2174
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2174:
jmp @r4
mov r0,r2
! Opcode 373C
N73C:
mov.w @r6+,r3
mov.l @(44,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2175
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2175:
jmp @r4
mov r0,r2
! Opcodes 3740 - 3747
N740:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2176
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2176:
jmp @r4
mov r0,r2
! Opcodes 3748 - 374F
N748:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2177
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2177:
jmp @r4
mov r0,r2
! Opcodes 3750 - 3757
N750:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2178
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2178:
jmp @r4
mov r0,r2
! Opcodes 3758 - 375F
N758:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2179
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2179:
jmp @r4
mov r0,r2
! Opcodes 3760 - 3767
N760:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2180
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2180:
jmp @r4
mov r0,r2
! Opcodes 3768 - 376F
N768:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2181
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2181:
jmp @r4
mov r0,r2
! Opcodes 3770 - 3777
N770:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2182
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2182:
jmp @r4
mov r0,r2
! Opcode 3778
N778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2183
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2183:
jmp @r4
mov r0,r2
! Opcode 3779
N779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2184
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2184:
jmp @r4
mov r0,r2
! Opcode 377A
N77A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2185
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2185:
jmp @r4
mov r0,r2
! Opcode 377B
N77B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2186
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2186:
jmp @r4
mov r0,r2
! Opcode 377C
N77C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2187
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2187:
jmp @r4
mov r0,r2
! Opcodes 3780 - 3787
N780:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2188
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2188:
jmp @r4
mov r0,r2
! Opcodes 3788 - 378F
N788:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2189
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2189:
jmp @r4
mov r0,r2
! Opcodes 3790 - 3797
N790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2190
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2190:
jmp @r4
mov r0,r2
! Opcodes 3798 - 379F
N798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2191
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2191:
jmp @r4
mov r0,r2
! Opcodes 37A0 - 37A7
N7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2192
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2192:
jmp @r4
mov r0,r2
! Opcodes 37A8 - 37AF
N7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2193
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2193:
jmp @r4
mov r0,r2
! Opcodes 37B0 - 37B7
N7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2194
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2194:
jmp @r4
mov r0,r2
! Opcode 37B8
N7B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2195
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2195:
jmp @r4
mov r0,r2
! Opcode 37B9
N7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2196
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2196:
jmp @r4
mov r0,r2
! Opcode 37BA
N7BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2197
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2197:
jmp @r4
mov r0,r2
! Opcode 37BB
N7BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2198
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2198:
jmp @r4
mov r0,r2
! Opcode 37BC
N7BC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(44,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2199
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2199:
jmp @r4
mov r0,r2
! Opcodes 3800 - 3807
N800:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2200
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2200:
jmp @r4
mov r0,r2
! Opcodes 3808 - 380F
N808:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2201
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2201:
jmp @r4
mov r0,r2
! Opcodes 3810 - 3817
N810:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2202
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2202:
jmp @r4
mov r0,r2
! Opcodes 3818 - 381F
N818:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2203
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2203:
jmp @r4
mov r0,r2
! Opcodes 3820 - 3827
N820:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2204
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2204:
jmp @r4
mov r0,r2
! Opcodes 3828 - 382F
N828:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2205
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2205:
jmp @r4
mov r0,r2
! Opcodes 3830 - 3837
N830:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2206
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2206:
jmp @r4
mov r0,r2
! Opcode 3838
N838:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2207
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2207:
jmp @r4
mov r0,r2
! Opcode 3839
N839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2208
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2208:
jmp @r4
mov r0,r2
! Opcode 383A
N83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2209
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2209:
jmp @r4
mov r0,r2
! Opcode 383B
N83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2210
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2210:
jmp @r4
mov r0,r2
! Opcode 383C
N83C:
mov.w @r6+,r3
mov #16,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2211
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2211:
jmp @r4
mov r0,r2
! Opcodes 3840 - 3847
N840:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2212
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2212:
jmp @r4
mov r0,r2
! Opcodes 3848 - 384F
N848:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2213
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2213:
jmp @r4
mov r0,r2
! Opcodes 3850 - 3857
N850:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2214
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2214:
jmp @r4
mov r0,r2
! Opcodes 3858 - 385F
N858:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2215
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2215:
jmp @r4
mov r0,r2
! Opcodes 3860 - 3867
N860:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2216
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2216:
jmp @r4
mov r0,r2
! Opcodes 3868 - 386F
N868:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2217
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2217:
jmp @r4
mov r0,r2
! Opcodes 3870 - 3877
N870:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2218
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2218:
jmp @r4
mov r0,r2
! Opcode 3878
N878:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2219
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2219:
jmp @r4
mov r0,r2
! Opcode 3879
N879:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2220
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2220:
jmp @r4
mov r0,r2
! Opcode 387A
N87A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2221
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2221:
jmp @r4
mov r0,r2
! Opcode 387B
N87B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2222
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2222:
jmp @r4
mov r0,r2
! Opcode 387C
N87C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2223
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2223:
jmp @r4
mov r0,r2
! Opcodes 3880 - 3887
N880:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2224
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2224:
jmp @r4
mov r0,r2
! Opcodes 3888 - 388F
N888:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2225
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2225:
jmp @r4
mov r0,r2
! Opcodes 3890 - 3897
N890:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2226
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2226:
jmp @r4
mov r0,r2
! Opcodes 3898 - 389F
N898:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2227
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2227:
jmp @r4
mov r0,r2
! Opcodes 38A0 - 38A7
N8A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2228
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2228:
jmp @r4
mov r0,r2
! Opcodes 38A8 - 38AF
N8A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2229
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2229:
jmp @r4
mov r0,r2
! Opcodes 38B0 - 38B7
N8B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2230
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2230:
jmp @r4
mov r0,r2
! Opcode 38B8
N8B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2231
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2231:
jmp @r4
mov r0,r2
! Opcode 38B9
N8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2232
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2232:
jmp @r4
mov r0,r2
! Opcode 38BA
N8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2233
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2233:
jmp @r4
mov r0,r2
! Opcode 38BB
N8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2234
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2234:
jmp @r4
mov r0,r2
! Opcode 38BC
N8BC:
mov.w @r6+,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2235
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2235:
jmp @r4
mov r0,r2
! Opcodes 38C0 - 38C7
N8C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2236
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2236:
jmp @r4
mov r0,r2
! Opcodes 38C8 - 38CF
N8C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2237
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2237:
jmp @r4
mov r0,r2
! Opcodes 38D0 - 38D7
N8D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2238
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2238:
jmp @r4
mov r0,r2
! Opcodes 38D8 - 38DF
N8D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2239
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2239:
jmp @r4
mov r0,r2
! Opcodes 38E0 - 38E7
N8E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2240
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2240:
jmp @r4
mov r0,r2
! Opcodes 38E8 - 38EF
N8E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2241
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2241:
jmp @r4
mov r0,r2
! Opcodes 38F0 - 38F7
N8F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2242
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2242:
jmp @r4
mov r0,r2
! Opcode 38F8
N8F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2243
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2243:
jmp @r4
mov r0,r2
! Opcode 38F9
N8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2244
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2244:
jmp @r4
mov r0,r2
! Opcode 38FA
N8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2245
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2245:
jmp @r4
mov r0,r2
! Opcode 38FB
N8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2246
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2246:
jmp @r4
mov r0,r2
! Opcode 38FC
N8FC:
mov.w @r6+,r3
mov.l @(48,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2247
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2247:
jmp @r4
mov r0,r2
! Opcodes 3900 - 3907
N900:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2248
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2248:
jmp @r4
mov r0,r2
! Opcodes 3908 - 390F
N908:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2249
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2249:
jmp @r4
mov r0,r2
! Opcodes 3910 - 3917
N910:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2250
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2250:
jmp @r4
mov r0,r2
! Opcodes 3918 - 391F
N918:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2251
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2251:
jmp @r4
mov r0,r2
! Opcodes 3920 - 3927
N920:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2252
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2252:
jmp @r4
mov r0,r2
! Opcodes 3928 - 392F
N928:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2253
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2253:
jmp @r4
mov r0,r2
! Opcodes 3930 - 3937
N930:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2254
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2254:
jmp @r4
mov r0,r2
! Opcode 3938
N938:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2255
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2255:
jmp @r4
mov r0,r2
! Opcode 3939
N939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2256
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2256:
jmp @r4
mov r0,r2
! Opcode 393A
N93A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2257
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2257:
jmp @r4
mov r0,r2
! Opcode 393B
N93B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2258
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2258:
jmp @r4
mov r0,r2
! Opcode 393C
N93C:
mov.w @r6+,r3
mov.l @(48,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2259
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2259:
jmp @r4
mov r0,r2
! Opcodes 3940 - 3947
N940:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2260
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2260:
jmp @r4
mov r0,r2
! Opcodes 3948 - 394F
N948:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2261
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2261:
jmp @r4
mov r0,r2
! Opcodes 3950 - 3957
N950:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2262
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2262:
jmp @r4
mov r0,r2
! Opcodes 3958 - 395F
N958:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2263
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2263:
jmp @r4
mov r0,r2
! Opcodes 3960 - 3967
N960:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2264
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2264:
jmp @r4
mov r0,r2
! Opcodes 3968 - 396F
N968:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2265
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2265:
jmp @r4
mov r0,r2
! Opcodes 3970 - 3977
N970:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2266
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2266:
jmp @r4
mov r0,r2
! Opcode 3978
N978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2267
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2267:
jmp @r4
mov r0,r2
! Opcode 3979
N979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2268
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2268:
jmp @r4
mov r0,r2
! Opcode 397A
N97A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2269
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2269:
jmp @r4
mov r0,r2
! Opcode 397B
N97B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2270
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2270:
jmp @r4
mov r0,r2
! Opcode 397C
N97C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2271
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2271:
jmp @r4
mov r0,r2
! Opcodes 3980 - 3987
N980:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2272
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2272:
jmp @r4
mov r0,r2
! Opcodes 3988 - 398F
N988:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2273
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2273:
jmp @r4
mov r0,r2
! Opcodes 3990 - 3997
N990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2274
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2274:
jmp @r4
mov r0,r2
! Opcodes 3998 - 399F
N998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2275
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2275:
jmp @r4
mov r0,r2
! Opcodes 39A0 - 39A7
N9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2276
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2276:
jmp @r4
mov r0,r2
! Opcodes 39A8 - 39AF
N9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2277
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2277:
jmp @r4
mov r0,r2
! Opcodes 39B0 - 39B7
N9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2278
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2278:
jmp @r4
mov r0,r2
! Opcode 39B8
N9B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2279
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2279:
jmp @r4
mov r0,r2
! Opcode 39B9
N9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2280
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2280:
jmp @r4
mov r0,r2
! Opcode 39BA
N9BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2281
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2281:
jmp @r4
mov r0,r2
! Opcode 39BB
N9BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2282
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2282:
jmp @r4
mov r0,r2
! Opcode 39BC
N9BC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(48,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2283
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2283:
jmp @r4
mov r0,r2
! Opcodes 3A00 - 3A07
NA00:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2284
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2284:
jmp @r4
mov r0,r2
! Opcodes 3A08 - 3A0F
NA08:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2285
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2285:
jmp @r4
mov r0,r2
! Opcodes 3A10 - 3A17
NA10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2286
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2286:
jmp @r4
mov r0,r2
! Opcodes 3A18 - 3A1F
NA18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2287
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2287:
jmp @r4
mov r0,r2
! Opcodes 3A20 - 3A27
NA20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2288
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2288:
jmp @r4
mov r0,r2
! Opcodes 3A28 - 3A2F
NA28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2289
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2289:
jmp @r4
mov r0,r2
! Opcodes 3A30 - 3A37
NA30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2290
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2290:
jmp @r4
mov r0,r2
! Opcode 3A38
NA38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2291
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2291:
jmp @r4
mov r0,r2
! Opcode 3A39
NA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2292
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2292:
jmp @r4
mov r0,r2
! Opcode 3A3A
NA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2293
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2293:
jmp @r4
mov r0,r2
! Opcode 3A3B
NA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2294
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2294:
jmp @r4
mov r0,r2
! Opcode 3A3C
NA3C:
mov.w @r6+,r3
mov #20,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2295
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2295:
jmp @r4
mov r0,r2
! Opcodes 3A40 - 3A47
NA40:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2296
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2296:
jmp @r4
mov r0,r2
! Opcodes 3A48 - 3A4F
NA48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2297
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2297:
jmp @r4
mov r0,r2
! Opcodes 3A50 - 3A57
NA50:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2298
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2298:
jmp @r4
mov r0,r2
! Opcodes 3A58 - 3A5F
NA58:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2299
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2299:
jmp @r4
mov r0,r2
! Opcodes 3A60 - 3A67
NA60:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2300
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2300:
jmp @r4
mov r0,r2
! Opcodes 3A68 - 3A6F
NA68:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2301
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2301:
jmp @r4
mov r0,r2
! Opcodes 3A70 - 3A77
NA70:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2302
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2302:
jmp @r4
mov r0,r2
! Opcode 3A78
NA78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2303
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2303:
jmp @r4
mov r0,r2
! Opcode 3A79
NA79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2304
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2304:
jmp @r4
mov r0,r2
! Opcode 3A7A
NA7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2305
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2305:
jmp @r4
mov r0,r2
! Opcode 3A7B
NA7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2306
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2306:
jmp @r4
mov r0,r2
! Opcode 3A7C
NA7C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2307
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2307:
jmp @r4
mov r0,r2
! Opcodes 3A80 - 3A87
NA80:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2308
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2308:
jmp @r4
mov r0,r2
! Opcodes 3A88 - 3A8F
NA88:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2309
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2309:
jmp @r4
mov r0,r2
! Opcodes 3A90 - 3A97
NA90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2310
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2310:
jmp @r4
mov r0,r2
! Opcodes 3A98 - 3A9F
NA98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2311
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2311:
jmp @r4
mov r0,r2
! Opcodes 3AA0 - 3AA7
NAA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2312
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2312:
jmp @r4
mov r0,r2
! Opcodes 3AA8 - 3AAF
NAA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2313
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2313:
jmp @r4
mov r0,r2
! Opcodes 3AB0 - 3AB7
NAB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2314
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2314:
jmp @r4
mov r0,r2
! Opcode 3AB8
NAB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2315
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2315:
jmp @r4
mov r0,r2
! Opcode 3AB9
NAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2316
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2316:
jmp @r4
mov r0,r2
! Opcode 3ABA
NABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2317
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2317:
jmp @r4
mov r0,r2
! Opcode 3ABB
NABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2318
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2318:
jmp @r4
mov r0,r2
! Opcode 3ABC
NABC:
mov.w @r6+,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2319
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2319:
jmp @r4
mov r0,r2
! Opcodes 3AC0 - 3AC7
NAC0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2320
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2320:
jmp @r4
mov r0,r2
! Opcodes 3AC8 - 3ACF
NAC8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2321
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2321:
jmp @r4
mov r0,r2
! Opcodes 3AD0 - 3AD7
NAD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2322
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2322:
jmp @r4
mov r0,r2
! Opcodes 3AD8 - 3ADF
NAD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2323
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2323:
jmp @r4
mov r0,r2
! Opcodes 3AE0 - 3AE7
NAE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2324
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2324:
jmp @r4
mov r0,r2
! Opcodes 3AE8 - 3AEF
NAE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2325
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2325:
jmp @r4
mov r0,r2
! Opcodes 3AF0 - 3AF7
NAF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2326
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2326:
jmp @r4
mov r0,r2
! Opcode 3AF8
NAF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2327
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2327:
jmp @r4
mov r0,r2
! Opcode 3AF9
NAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2328
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2328:
jmp @r4
mov r0,r2
! Opcode 3AFA
NAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2329
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2329:
jmp @r4
mov r0,r2
! Opcode 3AFB
NAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2330
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2330:
jmp @r4
mov r0,r2
! Opcode 3AFC
NAFC:
mov.w @r6+,r3
mov.l @(52,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2331
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2331:
jmp @r4
mov r0,r2
! Opcodes 3B00 - 3B07
NB00:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2332
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2332:
jmp @r4
mov r0,r2
! Opcodes 3B08 - 3B0F
NB08:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2333
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2333:
jmp @r4
mov r0,r2
! Opcodes 3B10 - 3B17
NB10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2334
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2334:
jmp @r4
mov r0,r2
! Opcodes 3B18 - 3B1F
NB18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2335
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2335:
jmp @r4
mov r0,r2
! Opcodes 3B20 - 3B27
NB20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2336
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2336:
jmp @r4
mov r0,r2
! Opcodes 3B28 - 3B2F
NB28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2337
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2337:
jmp @r4
mov r0,r2
! Opcodes 3B30 - 3B37
NB30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2338
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2338:
jmp @r4
mov r0,r2
! Opcode 3B38
NB38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2339
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2339:
jmp @r4
mov r0,r2
! Opcode 3B39
NB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2340
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2340:
jmp @r4
mov r0,r2
! Opcode 3B3A
NB3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2341
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2341:
jmp @r4
mov r0,r2
! Opcode 3B3B
NB3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2342
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2342:
jmp @r4
mov r0,r2
! Opcode 3B3C
NB3C:
mov.w @r6+,r3
mov.l @(52,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2343
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2343:
jmp @r4
mov r0,r2
! Opcodes 3B40 - 3B47
NB40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2344
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2344:
jmp @r4
mov r0,r2
! Opcodes 3B48 - 3B4F
NB48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2345
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2345:
jmp @r4
mov r0,r2
! Opcodes 3B50 - 3B57
NB50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2346
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2346:
jmp @r4
mov r0,r2
! Opcodes 3B58 - 3B5F
NB58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2347
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2347:
jmp @r4
mov r0,r2
! Opcodes 3B60 - 3B67
NB60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2348
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2348:
jmp @r4
mov r0,r2
! Opcodes 3B68 - 3B6F
NB68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2349
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2349:
jmp @r4
mov r0,r2
! Opcodes 3B70 - 3B77
NB70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2350
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2350:
jmp @r4
mov r0,r2
! Opcode 3B78
NB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2351
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2351:
jmp @r4
mov r0,r2
! Opcode 3B79
NB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2352
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2352:
jmp @r4
mov r0,r2
! Opcode 3B7A
NB7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2353
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2353:
jmp @r4
mov r0,r2
! Opcode 3B7B
NB7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2354
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2354:
jmp @r4
mov r0,r2
! Opcode 3B7C
NB7C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2355
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2355:
jmp @r4
mov r0,r2
! Opcodes 3B80 - 3B87
NB80:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2356
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2356:
jmp @r4
mov r0,r2
! Opcodes 3B88 - 3B8F
NB88:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2357
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2357:
jmp @r4
mov r0,r2
! Opcodes 3B90 - 3B97
NB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2358
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2358:
jmp @r4
mov r0,r2
! Opcodes 3B98 - 3B9F
NB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2359
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2359:
jmp @r4
mov r0,r2
! Opcodes 3BA0 - 3BA7
NBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2360
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2360:
jmp @r4
mov r0,r2
! Opcodes 3BA8 - 3BAF
NBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2361
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2361:
jmp @r4
mov r0,r2
! Opcodes 3BB0 - 3BB7
NBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2362
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2362:
jmp @r4
mov r0,r2
! Opcode 3BB8
NBB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2363
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2363:
jmp @r4
mov r0,r2
! Opcode 3BB9
NBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2364
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2364:
jmp @r4
mov r0,r2
! Opcode 3BBA
NBBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2365
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2365:
jmp @r4
mov r0,r2
! Opcode 3BBB
NBBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2366
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2366:
jmp @r4
mov r0,r2
! Opcode 3BBC
NBBC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(52,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2367
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2367:
jmp @r4
mov r0,r2
! Opcodes 3C00 - 3C07
NC00:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2368
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2368:
jmp @r4
mov r0,r2
! Opcodes 3C08 - 3C0F
NC08:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2369
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2369:
jmp @r4
mov r0,r2
! Opcodes 3C10 - 3C17
NC10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2370
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2370:
jmp @r4
mov r0,r2
! Opcodes 3C18 - 3C1F
NC18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2371
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2371:
jmp @r4
mov r0,r2
! Opcodes 3C20 - 3C27
NC20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2372
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2372:
jmp @r4
mov r0,r2
! Opcodes 3C28 - 3C2F
NC28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2373
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2373:
jmp @r4
mov r0,r2
! Opcodes 3C30 - 3C37
NC30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2374
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2374:
jmp @r4
mov r0,r2
! Opcode 3C38
NC38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2375
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2375:
jmp @r4
mov r0,r2
! Opcode 3C39
NC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2376
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2376:
jmp @r4
mov r0,r2
! Opcode 3C3A
NC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2377
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2377:
jmp @r4
mov r0,r2
! Opcode 3C3B
NC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2378
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2378:
jmp @r4
mov r0,r2
! Opcode 3C3C
NC3C:
mov.w @r6+,r3
mov #24,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2379
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2379:
jmp @r4
mov r0,r2
! Opcodes 3C40 - 3C47
NC40:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2380
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2380:
jmp @r4
mov r0,r2
! Opcodes 3C48 - 3C4F
NC48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2381
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2381:
jmp @r4
mov r0,r2
! Opcodes 3C50 - 3C57
NC50:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2382
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2382:
jmp @r4
mov r0,r2
! Opcodes 3C58 - 3C5F
NC58:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2383
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2383:
jmp @r4
mov r0,r2
! Opcodes 3C60 - 3C67
NC60:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2384
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2384:
jmp @r4
mov r0,r2
! Opcodes 3C68 - 3C6F
NC68:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2385
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2385:
jmp @r4
mov r0,r2
! Opcodes 3C70 - 3C77
NC70:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2386
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2386:
jmp @r4
mov r0,r2
! Opcode 3C78
NC78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2387
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2387:
jmp @r4
mov r0,r2
! Opcode 3C79
NC79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2388
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2388:
jmp @r4
mov r0,r2
! Opcode 3C7A
NC7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2389
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2389:
jmp @r4
mov r0,r2
! Opcode 3C7B
NC7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2390
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2390:
jmp @r4
mov r0,r2
! Opcode 3C7C
NC7C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2391
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2391:
jmp @r4
mov r0,r2
! Opcodes 3C80 - 3C87
NC80:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2392
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2392:
jmp @r4
mov r0,r2
! Opcodes 3C88 - 3C8F
NC88:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2393
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2393:
jmp @r4
mov r0,r2
! Opcodes 3C90 - 3C97
NC90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2394
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2394:
jmp @r4
mov r0,r2
! Opcodes 3C98 - 3C9F
NC98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2395
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2395:
jmp @r4
mov r0,r2
! Opcodes 3CA0 - 3CA7
NCA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2396
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2396:
jmp @r4
mov r0,r2
! Opcodes 3CA8 - 3CAF
NCA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2397
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2397:
jmp @r4
mov r0,r2
! Opcodes 3CB0 - 3CB7
NCB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2398
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2398:
jmp @r4
mov r0,r2
! Opcode 3CB8
NCB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2399
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2399:
jmp @r4
mov r0,r2
! Opcode 3CB9
NCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2400
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2400:
jmp @r4
mov r0,r2
! Opcode 3CBA
NCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2401
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2401:
jmp @r4
mov r0,r2
! Opcode 3CBB
NCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2402
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2402:
jmp @r4
mov r0,r2
! Opcode 3CBC
NCBC:
mov.w @r6+,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2403
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2403:
jmp @r4
mov r0,r2
! Opcodes 3CC0 - 3CC7
NCC0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2404
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2404:
jmp @r4
mov r0,r2
! Opcodes 3CC8 - 3CCF
NCC8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2405
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2405:
jmp @r4
mov r0,r2
! Opcodes 3CD0 - 3CD7
NCD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2406
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2406:
jmp @r4
mov r0,r2
! Opcodes 3CD8 - 3CDF
NCD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2407
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2407:
jmp @r4
mov r0,r2
! Opcodes 3CE0 - 3CE7
NCE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2408
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2408:
jmp @r4
mov r0,r2
! Opcodes 3CE8 - 3CEF
NCE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2409
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2409:
jmp @r4
mov r0,r2
! Opcodes 3CF0 - 3CF7
NCF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2410
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2410:
jmp @r4
mov r0,r2
! Opcode 3CF8
NCF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2411
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2411:
jmp @r4
mov r0,r2
! Opcode 3CF9
NCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2412
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2412:
jmp @r4
mov r0,r2
! Opcode 3CFA
NCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2413
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2413:
jmp @r4
mov r0,r2
! Opcode 3CFB
NCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2414
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2414:
jmp @r4
mov r0,r2
! Opcode 3CFC
NCFC:
mov.w @r6+,r3
mov.l @(56,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2415
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2415:
jmp @r4
mov r0,r2
! Opcodes 3D00 - 3D07
ND00:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2416
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2416:
jmp @r4
mov r0,r2
! Opcodes 3D08 - 3D0F
ND08:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2417
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2417:
jmp @r4
mov r0,r2
! Opcodes 3D10 - 3D17
ND10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2418
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2418:
jmp @r4
mov r0,r2
! Opcodes 3D18 - 3D1F
ND18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2419
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2419:
jmp @r4
mov r0,r2
! Opcodes 3D20 - 3D27
ND20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2420
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2420:
jmp @r4
mov r0,r2
! Opcodes 3D28 - 3D2F
ND28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2421
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2421:
jmp @r4
mov r0,r2
! Opcodes 3D30 - 3D37
ND30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2422
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2422:
jmp @r4
mov r0,r2
! Opcode 3D38
ND38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2423
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2423:
jmp @r4
mov r0,r2
! Opcode 3D39
ND39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2424
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2424:
jmp @r4
mov r0,r2
! Opcode 3D3A
ND3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2425
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2425:
jmp @r4
mov r0,r2
! Opcode 3D3B
ND3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2426
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2426:
jmp @r4
mov r0,r2
! Opcode 3D3C
ND3C:
mov.w @r6+,r3
mov.l @(56,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2427
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2427:
jmp @r4
mov r0,r2
! Opcodes 3D40 - 3D47
ND40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2428
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2428:
jmp @r4
mov r0,r2
! Opcodes 3D48 - 3D4F
ND48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2429
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2429:
jmp @r4
mov r0,r2
! Opcodes 3D50 - 3D57
ND50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2430
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2430:
jmp @r4
mov r0,r2
! Opcodes 3D58 - 3D5F
ND58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2431
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2431:
jmp @r4
mov r0,r2
! Opcodes 3D60 - 3D67
ND60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2432
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2432:
jmp @r4
mov r0,r2
! Opcodes 3D68 - 3D6F
ND68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2433
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2433:
jmp @r4
mov r0,r2
! Opcodes 3D70 - 3D77
ND70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2434
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2434:
jmp @r4
mov r0,r2
! Opcode 3D78
ND78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2435
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2435:
jmp @r4
mov r0,r2
! Opcode 3D79
ND79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2436
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2436:
jmp @r4
mov r0,r2
! Opcode 3D7A
ND7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2437
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2437:
jmp @r4
mov r0,r2
! Opcode 3D7B
ND7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2438
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2438:
jmp @r4
mov r0,r2
! Opcode 3D7C
ND7C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2439
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2439:
jmp @r4
mov r0,r2
! Opcodes 3D80 - 3D87
ND80:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2440
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2440:
jmp @r4
mov r0,r2
! Opcodes 3D88 - 3D8F
ND88:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2441
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2441:
jmp @r4
mov r0,r2
! Opcodes 3D90 - 3D97
ND90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2442
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2442:
jmp @r4
mov r0,r2
! Opcodes 3D98 - 3D9F
ND98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2443
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2443:
jmp @r4
mov r0,r2
! Opcodes 3DA0 - 3DA7
NDA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2444
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2444:
jmp @r4
mov r0,r2
! Opcodes 3DA8 - 3DAF
NDA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2445
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2445:
jmp @r4
mov r0,r2
! Opcodes 3DB0 - 3DB7
NDB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2446
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2446:
jmp @r4
mov r0,r2
! Opcode 3DB8
NDB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2447
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2447:
jmp @r4
mov r0,r2
! Opcode 3DB9
NDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2448
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2448:
jmp @r4
mov r0,r2
! Opcode 3DBA
NDBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2449
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2449:
jmp @r4
mov r0,r2
! Opcode 3DBB
NDBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2450
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2450:
jmp @r4
mov r0,r2
! Opcode 3DBC
NDBC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(56,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2451
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2451:
jmp @r4
mov r0,r2
! Opcodes 3E00 - 3E07
NE00:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2452
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2452:
jmp @r4
mov r0,r2
! Opcodes 3E08 - 3E0F
NE08:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2453
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2453:
jmp @r4
mov r0,r2
! Opcodes 3E10 - 3E17
NE10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2454
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2454:
jmp @r4
mov r0,r2
! Opcodes 3E18 - 3E1F
NE18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2455
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2455:
jmp @r4
mov r0,r2
! Opcodes 3E20 - 3E27
NE20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2456
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2456:
jmp @r4
mov r0,r2
! Opcodes 3E28 - 3E2F
NE28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2457
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2457:
jmp @r4
mov r0,r2
! Opcodes 3E30 - 3E37
NE30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2458
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2458:
jmp @r4
mov r0,r2
! Opcode 3E38
NE38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2459
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2459:
jmp @r4
mov r0,r2
! Opcode 3E39
NE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2460
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2460:
jmp @r4
mov r0,r2
! Opcode 3E3A
NE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2461
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2461:
jmp @r4
mov r0,r2
! Opcode 3E3B
NE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2462
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2462:
jmp @r4
mov r0,r2
! Opcode 3E3C
NE3C:
mov.w @r6+,r3
mov #28,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2463
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2463:
jmp @r4
mov r0,r2
! Opcodes 3E40 - 3E47
NE40:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2464
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2464:
jmp @r4
mov r0,r2
! Opcodes 3E48 - 3E4F
NE48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2465
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2465:
jmp @r4
mov r0,r2
! Opcodes 3E50 - 3E57
NE50:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2466
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2466:
jmp @r4
mov r0,r2
! Opcodes 3E58 - 3E5F
NE58:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2467
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2467:
jmp @r4
mov r0,r2
! Opcodes 3E60 - 3E67
NE60:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2468
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2468:
jmp @r4
mov r0,r2
! Opcodes 3E68 - 3E6F
NE68:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2469
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2469:
jmp @r4
mov r0,r2
! Opcodes 3E70 - 3E77
NE70:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2470
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2470:
jmp @r4
mov r0,r2
! Opcode 3E78
NE78:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2471
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2471:
jmp @r4
mov r0,r2
! Opcode 3E79
NE79:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2472
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2472:
jmp @r4
mov r0,r2
! Opcode 3E7A
NE7A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2473
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2473:
jmp @r4
mov r0,r2
! Opcode 3E7B
NE7B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2474
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2474:
jmp @r4
mov r0,r2
! Opcode 3E7C
NE7C:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2475
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2475:
jmp @r4
mov r0,r2
! Opcodes 3E80 - 3E87
NE80:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2476
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2476:
jmp @r4
mov r0,r2
! Opcodes 3E88 - 3E8F
NE88:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2477
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2477:
jmp @r4
mov r0,r2
! Opcodes 3E90 - 3E97
NE90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2478
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2478:
jmp @r4
mov r0,r2
! Opcodes 3E98 - 3E9F
NE98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2479
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2479:
jmp @r4
mov r0,r2
! Opcodes 3EA0 - 3EA7
NEA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2480
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2480:
jmp @r4
mov r0,r2
! Opcodes 3EA8 - 3EAF
NEA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2481
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2481:
jmp @r4
mov r0,r2
! Opcodes 3EB0 - 3EB7
NEB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2482
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2482:
jmp @r4
mov r0,r2
! Opcode 3EB8
NEB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2483
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2483:
jmp @r4
mov r0,r2
! Opcode 3EB9
NEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2484
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2484:
jmp @r4
mov r0,r2
! Opcode 3EBA
NEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2485
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2485:
jmp @r4
mov r0,r2
! Opcode 3EBB
NEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2486
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2486:
jmp @r4
mov r0,r2
! Opcode 3EBC
NEBC:
mov.w @r6+,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2487
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2487:
jmp @r4
mov r0,r2
! Opcodes 3EC0 - 3EC7
NEC0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2488
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2488:
jmp @r4
mov r0,r2
! Opcodes 3EC8 - 3ECF
NEC8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2489
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2489:
jmp @r4
mov r0,r2
! Opcodes 3ED0 - 3ED7
NED0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2490
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2490:
jmp @r4
mov r0,r2
! Opcodes 3ED8 - 3EDF
NED8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2491
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2491:
jmp @r4
mov r0,r2
! Opcodes 3EE0 - 3EE7
NEE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2492
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2492:
jmp @r4
mov r0,r2
! Opcodes 3EE8 - 3EEF
NEE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2493
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2493:
jmp @r4
mov r0,r2
! Opcodes 3EF0 - 3EF7
NEF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2494
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2494:
jmp @r4
mov r0,r2
! Opcode 3EF8
NEF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2495
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2495:
jmp @r4
mov r0,r2
! Opcode 3EF9
NEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2496
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2496:
jmp @r4
mov r0,r2
! Opcode 3EFA
NEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2497
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2497:
jmp @r4
mov r0,r2
! Opcode 3EFB
NEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2498
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2498:
jmp @r4
mov r0,r2
! Opcode 3EFC
NEFC:
mov.w @r6+,r3
mov.l @(60,r13),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2499
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2499:
jmp @r4
mov r0,r2
! Opcodes 3F00 - 3F07
NF00:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2500
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2500:
jmp @r4
mov r0,r2
! Opcodes 3F08 - 3F0F
NF08:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2501
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2501:
jmp @r4
mov r0,r2
! Opcodes 3F10 - 3F17
NF10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2502
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2502:
jmp @r4
mov r0,r2
! Opcodes 3F18 - 3F1F
NF18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2503
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2503:
jmp @r4
mov r0,r2
! Opcodes 3F20 - 3F27
NF20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2504
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2504:
jmp @r4
mov r0,r2
! Opcodes 3F28 - 3F2F
NF28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2505
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2505:
jmp @r4
mov r0,r2
! Opcodes 3F30 - 3F37
NF30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2506
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2506:
jmp @r4
mov r0,r2
! Opcode 3F38
NF38:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2507
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2507:
jmp @r4
mov r0,r2
! Opcode 3F39
NF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2508
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2508:
jmp @r4
mov r0,r2
! Opcode 3F3A
NF3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2509
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2509:
jmp @r4
mov r0,r2
! Opcode 3F3B
NF3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2510
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2510:
jmp @r4
mov r0,r2
! Opcode 3F3C
NF3C:
mov.w @r6+,r3
mov.l @(60,r13),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2511
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2511:
jmp @r4
mov r0,r2
! Opcodes 3F40 - 3F47
NF40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2512
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2512:
jmp @r4
mov r0,r2
! Opcodes 3F48 - 3F4F
NF48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2513
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2513:
jmp @r4
mov r0,r2
! Opcodes 3F50 - 3F57
NF50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2514
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2514:
jmp @r4
mov r0,r2
! Opcodes 3F58 - 3F5F
NF58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2515
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2515:
jmp @r4
mov r0,r2
! Opcodes 3F60 - 3F67
NF60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2516
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2516:
jmp @r4
mov r0,r2
! Opcodes 3F68 - 3F6F
NF68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2517
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2517:
jmp @r4
mov r0,r2
! Opcodes 3F70 - 3F77
NF70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2518
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2518:
jmp @r4
mov r0,r2
! Opcode 3F78
NF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2519
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2519:
jmp @r4
mov r0,r2
! Opcode 3F79
NF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2520
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2520:
jmp @r4
mov r0,r2
! Opcode 3F7A
NF7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2521
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2521:
jmp @r4
mov r0,r2
! Opcode 3F7B
NF7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2522
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2522:
jmp @r4
mov r0,r2
! Opcode 3F7C
NF7C:
mov.w @r6+,r3
mov.w @r6+,r4
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2523
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2523:
jmp @r4
mov r0,r2
! Opcodes 3F80 - 3F87
NF80:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2524
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2524:
jmp @r4
mov r0,r2
! Opcodes 3F88 - 3F8F
NF88:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2525
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2525:
jmp @r4
mov r0,r2
! Opcodes 3F90 - 3F97
NF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2526
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2526:
jmp @r4
mov r0,r2
! Opcodes 3F98 - 3F9F
NF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2527
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2527:
jmp @r4
mov r0,r2
! Opcodes 3FA0 - 3FA7
NFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2528
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2528:
jmp @r4
mov r0,r2
! Opcodes 3FA8 - 3FAF
NFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2529
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2529:
jmp @r4
mov r0,r2
! Opcodes 3FB0 - 3FB7
NFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2530
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2530:
jmp @r4
mov r0,r2
! Opcode 3FB8
NFB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2531
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2531:
jmp @r4
mov r0,r2
! Opcode 3FB9
NFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2532
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2532:
jmp @r4
mov r0,r2
! Opcode 3FBA
NFBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2533
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2533:
jmp @r4
mov r0,r2
! Opcode 3FBB
NFBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2534
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2534:
jmp @r4
mov r0,r2
! Opcode 3FBC
NFBC:
mov.w @r6+,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov.l @(60,r13),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2535
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2535:
jmp @r4
mov r0,r2
! Opcodes 4000 - 4007
O000:
and r1,r2
mov.l r3,@-r15
add r13,r2
mov.b @r2,r3
mov #24,r0
shld r0,r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.b r3,@r2
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2536
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2536:
jmp @r4
mov r0,r2
! Opcodes 4010 - 4017
O010:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2537
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2537:
jmp @r4
mov r0,r2
! Opcodes 4018 - 401F
O018:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2538
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2538:
jmp @r4
mov r0,r2
! Opcodes 4020 - 4027
O020:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2539
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2539:
jmp @r4
mov r0,r2
! Opcodes 4028 - 402F
O028:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2540
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2540:
jmp @r4
mov r0,r2
! Opcodes 4030 - 4037
O030:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2541
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2541:
jmp @r4
mov r0,r2
! Opcode 4038
O038:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2542
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2542:
jmp @r4
mov r0,r2
! Opcode 4039
O039:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
shld r0,r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2543
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2543:
jmp @r4
mov r0,r2
! Opcodes 4040 - 4047
O040:
and r1,r2
mov.l r3,@-r15
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.w r3,@r2
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2544
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2544:
jmp @r4
mov r0,r2
! Opcodes 4050 - 4057
O050:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2545
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2545:
jmp @r4
mov r0,r2
! Opcodes 4058 - 405F
O058:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2546
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2546:
jmp @r4
mov r0,r2
! Opcodes 4060 - 4067
O060:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2547
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2547:
jmp @r4
mov r0,r2
! Opcodes 4068 - 406F
O068:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2548
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2548:
jmp @r4
mov r0,r2
! Opcodes 4070 - 4077
O070:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2549
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2549:
jmp @r4
mov r0,r2
! Opcode 4078
O078:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2550
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2550:
jmp @r4
mov r0,r2
! Opcode 4079
O079:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2551
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2551:
jmp @r4
mov r0,r2
! Opcodes 4080 - 4087
O080:
and r1,r2
mov.l r3,@-r15
add r13,r2
mov.l @r2,r3
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@r2
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2552
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2552:
jmp @r4
mov r0,r2
! Opcodes 4090 - 4097
O090:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2553
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2553:
jmp @r4
mov r0,r2
! Opcodes 4098 - 409F
O098:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2554
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2554:
jmp @r4
mov r0,r2
! Opcodes 40A0 - 40A7
O0A0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2555
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2555:
jmp @r4
mov r0,r2
! Opcodes 40A8 - 40AF
O0A8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2556
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2556:
jmp @r4
mov r0,r2
! Opcodes 40B0 - 40B7
O0B0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2557
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2557:
jmp @r4
mov r0,r2
! Opcode 40B8
O0B8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2558
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2558:
jmp @r4
mov r0,r2
! Opcode 40B9
O0B9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
shlr r9
movt r8
negc r3,r3
movt r9
mov #0,r0
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2559
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2559:
jmp @r4
mov r0,r2
! Opcodes 40C0 - 40C7
O0C0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2560
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2560:
jmp @r4
mov r0,r2
! Opcodes 40D0 - 40D7
O0D0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2561
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2561:
jmp @r4
mov r0,r2
! Opcodes 40D8 - 40DF
O0D8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2562
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2562:
jmp @r4
mov r0,r2
! Opcodes 40E0 - 40E7
O0E0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2563
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2563:
jmp @r4
mov r0,r2
! Opcodes 40E8 - 40EF
O0E8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2564
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2564:
jmp @r4
mov r0,r2
! Opcodes 40F0 - 40F7
O0F0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2565
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2565:
jmp @r4
mov r0,r2
! Opcode 40F8
O0F8:
mov.l r3,@-r15
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2566
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2566:
jmp @r4
mov r0,r2
! Opcode 40F9
O0F9:
mov.l r3,@-r15
mov r8,r0
mov r9,r1
shlr r0
addc r1,r1
tst r3,r3
addc r1,r1
and #3,r0
mov r1,r3
shll2 r3
or r0,r3
mov r10,r0
shll8 r0
or r0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2567
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2567:
jmp @r4
mov r0,r2
! Opcodes 4180 - 4187
O180:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2568
mov #0,r8
cmp/hi r3,r1
bt ln2568
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2569
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2569:
jmp @r4
mov r0,r2
.align 5
setn2568:
mov #1,r8
ln2568:
mov.l r1,@-r15
mov.l g2_except_ptr2568,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2568,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2570
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2570:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2568: .long group_2_exception
bf_addr2568: .long basefunction
! Opcodes 4190 - 4197
O190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2571
mov #0,r8
cmp/hi r3,r1
bt ln2571
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2572
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2572:
jmp @r4
mov r0,r2
.align 5
setn2571:
mov #1,r8
ln2571:
mov.l r1,@-r15
mov.l g2_except_ptr2571,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2571,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2573
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2573:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2571: .long group_2_exception
bf_addr2571: .long basefunction
! Opcodes 4198 - 419F
O198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2574
mov #0,r8
cmp/hi r3,r1
bt ln2574
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2575
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2575:
jmp @r4
mov r0,r2
.align 5
setn2574:
mov #1,r8
ln2574:
mov.l r1,@-r15
mov.l g2_except_ptr2574,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2574,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2576
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2576:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2574: .long group_2_exception
bf_addr2574: .long basefunction
! Opcodes 41A0 - 41A7
O1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2577
mov #0,r8
cmp/hi r3,r1
bt ln2577
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2578
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2578:
jmp @r4
mov r0,r2
.align 5
setn2577:
mov #1,r8
ln2577:
mov.l r1,@-r15
mov.l g2_except_ptr2577,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2577,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-56,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2579
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2579:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2577: .long group_2_exception
bf_addr2577: .long basefunction
! Opcodes 41A8 - 41AF
O1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2580
mov #0,r8
cmp/hi r3,r1
bt ln2580
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2581
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2581:
jmp @r4
mov r0,r2
.align 5
setn2580:
mov #1,r8
ln2580:
mov.l r1,@-r15
mov.l g2_except_ptr2580,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2580,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2582
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2582:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2580: .long group_2_exception
bf_addr2580: .long basefunction
! Opcodes 41B0 - 41B7
O1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2583
mov #0,r8
cmp/hi r3,r1
bt ln2583
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2584
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2584:
jmp @r4
mov r0,r2
.align 5
setn2583:
mov #1,r8
ln2583:
mov.l r1,@-r15
mov.l g2_except_ptr2583,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2583,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2585
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2585:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2583: .long group_2_exception
bf_addr2583: .long basefunction
! Opcode 41B8
O1B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2586
mov #0,r8
cmp/hi r3,r1
bt ln2586
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2587
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2587:
jmp @r4
mov r0,r2
.align 5
setn2586:
mov #1,r8
ln2586:
mov.l r1,@-r15
mov.l g2_except_ptr2586,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2586,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2588
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2588:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2586: .long group_2_exception
bf_addr2586: .long basefunction
! Opcode 41B9
O1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2589
mov #0,r8
cmp/hi r3,r1
bt ln2589
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2590
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2590:
jmp @r4
mov r0,r2
.align 5
setn2589:
mov #1,r8
ln2589:
mov.l r1,@-r15
mov.l g2_except_ptr2589,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2589,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-62,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2591
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2591:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2589: .long group_2_exception
bf_addr2589: .long basefunction
! Opcode 41BA
O1BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2592
mov #0,r8
cmp/hi r3,r1
bt ln2592
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2593
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2593:
jmp @r4
mov r0,r2
.align 5
setn2592:
mov #1,r8
ln2592:
mov.l r1,@-r15
mov.l g2_except_ptr2592,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2592,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2594
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2594:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2592: .long group_2_exception
bf_addr2592: .long basefunction
! Opcode 41BB
O1BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2595
mov #0,r8
cmp/hi r3,r1
bt ln2595
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2596
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2596:
jmp @r4
mov r0,r2
.align 5
setn2595:
mov #1,r8
ln2595:
mov.l r1,@-r15
mov.l g2_except_ptr2595,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2595,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2597
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2597:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2595: .long group_2_exception
bf_addr2595: .long basefunction
! Opcode 41BC
O1BC:
mov.w @r6+,r3
mov.w @r13,r1
extu.w r1,r1
cmp/pz r1
bf setn2598
mov #0,r8
cmp/hi r3,r1
bt ln2598
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2599
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2599:
jmp @r4
mov r0,r2
.align 5
setn2598:
mov #1,r8
ln2598:
mov.l r1,@-r15
mov.l g2_except_ptr2598,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2598,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2600
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2600:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2598: .long group_2_exception
bf_addr2598: .long basefunction
! Opcodes 41D0 - 41D7
O1D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(32,r13)
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2601
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2601:
jmp @r4
mov r0,r2
! Opcodes 41E8 - 41EF
O1E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(32,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2602
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2602:
jmp @r4
mov r0,r2
! Opcodes 41F0 - 41F7
O1F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(32,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2603
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2603:
jmp @r4
mov r0,r2
! Opcode 41F8
O1F8:
mov.w @r6+,r4
mov.l r4,@(32,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2604
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2604:
jmp @r4
mov r0,r2
! Opcode 41F9
O1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(32,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2605
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2605:
jmp @r4
mov r0,r2
! Opcode 41FA
O1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(32,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2606
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2606:
jmp @r4
mov r0,r2
! Opcode 41FB
O1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l r4,@(32,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2607
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2607:
jmp @r4
mov r0,r2
! Opcodes 4200 - 4207
O200:
and r1,r2
mov #0,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov r3,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2608
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2608:
jmp @r4
mov r0,r2
! Opcodes 4210 - 4217
O210:
and r1,r2
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2609
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2609:
jmp @r4
mov r0,r2
! Opcodes 4218 - 421F
O218:
and r1,r2
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2610
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2610:
jmp @r4
mov r0,r2
! Opcodes 4220 - 4227
O220:
and r1,r2
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2611
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2611:
jmp @r4
mov r0,r2
! Opcodes 4228 - 422F
O228:
and r1,r2
mov #0,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2612
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2612:
jmp @r4
mov r0,r2
! Opcodes 4230 - 4237
O230:
and r1,r2
mov #0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2613
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2613:
jmp @r4
mov r0,r2
! Opcode 4238
O238:
mov #0,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2614
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2614:
jmp @r4
mov r0,r2
! Opcode 4239
O239:
mov #0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2615
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2615:
jmp @r4
mov r0,r2
! Opcodes 4240 - 4247
O240:
and r1,r2
mov #0,r3
mov r2,r0
mov.w r3,@(r0,r13)
mov r3,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2616
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2616:
jmp @r4
mov r0,r2
! Opcodes 4250 - 4257
O250:
and r1,r2
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2617
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2617:
jmp @r4
mov r0,r2
! Opcodes 4258 - 425F
O258:
and r1,r2
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2618
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2618:
jmp @r4
mov r0,r2
! Opcodes 4260 - 4267
O260:
and r1,r2
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2619
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2619:
jmp @r4
mov r0,r2
! Opcodes 4268 - 426F
O268:
and r1,r2
mov #0,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2620
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2620:
jmp @r4
mov r0,r2
! Opcodes 4270 - 4277
O270:
and r1,r2
mov #0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2621
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2621:
jmp @r4
mov r0,r2
! Opcode 4278
O278:
mov #0,r3
mov.w @r6+,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2622
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2622:
jmp @r4
mov r0,r2
! Opcode 4279
O279:
mov #0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2623
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2623:
jmp @r4
mov r0,r2
! Opcodes 4280 - 4287
O280:
and r1,r2
mov #0,r3
mov r2,r0
mov.l r3,@(r0,r13)
mov r3,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2624
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2624:
jmp @r4
mov r0,r2
! Opcodes 4290 - 4297
O290:
and r1,r2
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2625
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2625:
jmp @r4
mov r0,r2
! Opcodes 4298 - 429F
O298:
and r1,r2
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2626
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2626:
jmp @r4
mov r0,r2
! Opcodes 42A0 - 42A7
O2A0:
and r1,r2
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2627
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2627:
jmp @r4
mov r0,r2
! Opcodes 42A8 - 42AF
O2A8:
and r1,r2
mov #0,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2628
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2628:
jmp @r4
mov r0,r2
! Opcodes 42B0 - 42B7
O2B0:
and r1,r2
mov #0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2629
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2629:
jmp @r4
mov r0,r2
! Opcode 42B8
O2B8:
mov #0,r3
mov.w @r6+,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2630
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2630:
jmp @r4
mov r0,r2
! Opcode 42B9
O2B9:
mov #0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2631
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2631:
jmp @r4
mov r0,r2
! Opcodes 4380 - 4387
O380:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2632
mov #0,r8
cmp/hi r3,r1
bt ln2632
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2633
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2633:
jmp @r4
mov r0,r2
.align 5
setn2632:
mov #1,r8
ln2632:
mov.l r1,@-r15
mov.l g2_except_ptr2632,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2632,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2634
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2634:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2632: .long group_2_exception
bf_addr2632: .long basefunction
! Opcodes 4390 - 4397
O390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2635
mov #0,r8
cmp/hi r3,r1
bt ln2635
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2636
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2636:
jmp @r4
mov r0,r2
.align 5
setn2635:
mov #1,r8
ln2635:
mov.l r1,@-r15
mov.l g2_except_ptr2635,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2635,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2637
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2637:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2635: .long group_2_exception
bf_addr2635: .long basefunction
! Opcodes 4398 - 439F
O398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2638
mov #0,r8
cmp/hi r3,r1
bt ln2638
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2639
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2639:
jmp @r4
mov r0,r2
.align 5
setn2638:
mov #1,r8
ln2638:
mov.l r1,@-r15
mov.l g2_except_ptr2638,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2638,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2640
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2640:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2638: .long group_2_exception
bf_addr2638: .long basefunction
! Opcodes 43A0 - 43A7
O3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2641
mov #0,r8
cmp/hi r3,r1
bt ln2641
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2642
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2642:
jmp @r4
mov r0,r2
.align 5
setn2641:
mov #1,r8
ln2641:
mov.l r1,@-r15
mov.l g2_except_ptr2641,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2641,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-56,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2643
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2643:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2641: .long group_2_exception
bf_addr2641: .long basefunction
! Opcodes 43A8 - 43AF
O3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2644
mov #0,r8
cmp/hi r3,r1
bt ln2644
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2645
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2645:
jmp @r4
mov r0,r2
.align 5
setn2644:
mov #1,r8
ln2644:
mov.l r1,@-r15
mov.l g2_except_ptr2644,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2644,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2646
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2646:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2644: .long group_2_exception
bf_addr2644: .long basefunction
! Opcodes 43B0 - 43B7
O3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2647
mov #0,r8
cmp/hi r3,r1
bt ln2647
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2648
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2648:
jmp @r4
mov r0,r2
.align 5
setn2647:
mov #1,r8
ln2647:
mov.l r1,@-r15
mov.l g2_except_ptr2647,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2647,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2649
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2649:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2647: .long group_2_exception
bf_addr2647: .long basefunction
! Opcode 43B8
O3B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2650
mov #0,r8
cmp/hi r3,r1
bt ln2650
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2651
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2651:
jmp @r4
mov r0,r2
.align 5
setn2650:
mov #1,r8
ln2650:
mov.l r1,@-r15
mov.l g2_except_ptr2650,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2650,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2652
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2652:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2650: .long group_2_exception
bf_addr2650: .long basefunction
! Opcode 43B9
O3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2653
mov #0,r8
cmp/hi r3,r1
bt ln2653
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2654
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2654:
jmp @r4
mov r0,r2
.align 5
setn2653:
mov #1,r8
ln2653:
mov.l r1,@-r15
mov.l g2_except_ptr2653,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2653,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-62,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2655
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2655:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2653: .long group_2_exception
bf_addr2653: .long basefunction
! Opcode 43BA
O3BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2656
mov #0,r8
cmp/hi r3,r1
bt ln2656
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2657
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2657:
jmp @r4
mov r0,r2
.align 5
setn2656:
mov #1,r8
ln2656:
mov.l r1,@-r15
mov.l g2_except_ptr2656,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2656,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2658
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2658:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2656: .long group_2_exception
bf_addr2656: .long basefunction
! Opcode 43BB
O3BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2659
mov #0,r8
cmp/hi r3,r1
bt ln2659
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2660
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2660:
jmp @r4
mov r0,r2
.align 5
setn2659:
mov #1,r8
ln2659:
mov.l r1,@-r15
mov.l g2_except_ptr2659,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2659,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2661
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2661:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2659: .long group_2_exception
bf_addr2659: .long basefunction
! Opcode 43BC
O3BC:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2662
mov #0,r8
cmp/hi r3,r1
bt ln2662
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2663
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2663:
jmp @r4
mov r0,r2
.align 5
setn2662:
mov #1,r8
ln2662:
mov.l r1,@-r15
mov.l g2_except_ptr2662,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2662,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2664
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2664:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2662: .long group_2_exception
bf_addr2662: .long basefunction
! Opcodes 43D0 - 43D7
O3D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(36,r13)
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2665
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2665:
jmp @r4
mov r0,r2
! Opcodes 43E8 - 43EF
O3E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(36,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2666
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2666:
jmp @r4
mov r0,r2
! Opcodes 43F0 - 43F7
O3F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(36,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2667
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2667:
jmp @r4
mov r0,r2
! Opcode 43F8
O3F8:
mov.w @r6+,r4
mov.l r4,@(36,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2668
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2668:
jmp @r4
mov r0,r2
! Opcode 43F9
O3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(36,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2669
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2669:
jmp @r4
mov r0,r2
! Opcode 43FA
O3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(36,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2670
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2670:
jmp @r4
mov r0,r2
! Opcode 43FB
O3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l r4,@(36,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2671
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2671:
jmp @r4
mov r0,r2
! Opcodes 4400 - 4407
O400:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2672
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2672:
jmp @r4
mov r0,r2
! Opcodes 4410 - 4417
O410:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2673
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2673:
jmp @r4
mov r0,r2
! Opcodes 4418 - 441F
O418:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2674
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2674:
jmp @r4
mov r0,r2
! Opcodes 4420 - 4427
O420:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2675
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2675:
jmp @r4
mov r0,r2
! Opcodes 4428 - 442F
O428:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2676
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2676:
jmp @r4
mov r0,r2
! Opcodes 4430 - 4437
O430:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2677
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2677:
jmp @r4
mov r0,r2
! Opcode 4438
O438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2678
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2678:
jmp @r4
mov r0,r2
! Opcode 4439
O439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
shll8 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2679
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2679:
jmp @r4
mov r0,r2
! Opcodes 4440 - 4447
O440:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2680
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2680:
jmp @r4
mov r0,r2
! Opcodes 4450 - 4457
O450:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2681
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2681:
jmp @r4
mov r0,r2
! Opcodes 4458 - 445F
O458:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2682
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2682:
jmp @r4
mov r0,r2
! Opcodes 4460 - 4467
O460:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2683
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2683:
jmp @r4
mov r0,r2
! Opcodes 4468 - 446F
O468:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2684
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2684:
jmp @r4
mov r0,r2
! Opcodes 4470 - 4477
O470:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2685
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2685:
jmp @r4
mov r0,r2
! Opcode 4478
O478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2686
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2686:
jmp @r4
mov r0,r2
! Opcode 4479
O479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2687
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2687:
jmp @r4
mov r0,r2
! Opcodes 4480 - 4487
O480:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2688
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2688:
jmp @r4
mov r0,r2
! Opcodes 4490 - 4497
O490:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2689
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2689:
jmp @r4
mov r0,r2
! Opcodes 4498 - 449F
O498:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2690
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2690:
jmp @r4
mov r0,r2
! Opcodes 44A0 - 44A7
O4A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2691
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2691:
jmp @r4
mov r0,r2
! Opcodes 44A8 - 44AF
O4A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2692
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2692:
jmp @r4
mov r0,r2
! Opcodes 44B0 - 44B7
O4B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2693
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2693:
jmp @r4
mov r0,r2
! Opcode 44B8
O4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2694
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2694:
jmp @r4
mov r0,r2
! Opcode 44B9
O4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
subv r3,r0
movt r8
mov #0,r0
clrt
subc r3,r0
movt r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2695
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2695:
jmp @r4
mov r0,r2
! Opcodes 44C0 - 44C7
O4C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2696
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2696:
jmp @r4
mov r0,r2
! Opcodes 44D0 - 44D7
O4D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2697
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2697:
jmp @r4
mov r0,r2
! Opcodes 44D8 - 44DF
O4D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2698
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2698:
jmp @r4
mov r0,r2
! Opcodes 44E0 - 44E7
O4E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2699
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2699:
jmp @r4
mov r0,r2
! Opcodes 44E8 - 44EF
O4E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2700
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2700:
jmp @r4
mov r0,r2
! Opcodes 44F0 - 44F7
O4F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2701
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2701:
jmp @r4
mov r0,r2
! Opcode 44F8
O4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2702
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2702:
jmp @r4
mov r0,r2
! Opcode 44F9
O4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2703
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2703:
jmp @r4
mov r0,r2
! Opcode 44FA
O4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2704
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2704:
jmp @r4
mov r0,r2
! Opcode 44FB
O4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2705
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2705:
jmp @r4
mov r0,r2
! Opcode 44FC
O4FC:
mov.w @r6+,r3
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2706
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2706:
jmp @r4
mov r0,r2
! Opcodes 4580 - 4587
O580:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2707
mov #0,r8
cmp/hi r3,r1
bt ln2707
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2708
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2708:
jmp @r4
mov r0,r2
.align 5
setn2707:
mov #1,r8
ln2707:
mov.l r1,@-r15
mov.l g2_except_ptr2707,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2707,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2709
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2709:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2707: .long group_2_exception
bf_addr2707: .long basefunction
! Opcodes 4590 - 4597
O590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2710
mov #0,r8
cmp/hi r3,r1
bt ln2710
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2711
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2711:
jmp @r4
mov r0,r2
.align 5
setn2710:
mov #1,r8
ln2710:
mov.l r1,@-r15
mov.l g2_except_ptr2710,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2710,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2712
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2712:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2710: .long group_2_exception
bf_addr2710: .long basefunction
! Opcodes 4598 - 459F
O598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2713
mov #0,r8
cmp/hi r3,r1
bt ln2713
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2714
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2714:
jmp @r4
mov r0,r2
.align 5
setn2713:
mov #1,r8
ln2713:
mov.l r1,@-r15
mov.l g2_except_ptr2713,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2713,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2715
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2715:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2713: .long group_2_exception
bf_addr2713: .long basefunction
! Opcodes 45A0 - 45A7
O5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2716
mov #0,r8
cmp/hi r3,r1
bt ln2716
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2717
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2717:
jmp @r4
mov r0,r2
.align 5
setn2716:
mov #1,r8
ln2716:
mov.l r1,@-r15
mov.l g2_except_ptr2716,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2716,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-56,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2718
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2718:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2716: .long group_2_exception
bf_addr2716: .long basefunction
! Opcodes 45A8 - 45AF
O5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2719
mov #0,r8
cmp/hi r3,r1
bt ln2719
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2720
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2720:
jmp @r4
mov r0,r2
.align 5
setn2719:
mov #1,r8
ln2719:
mov.l r1,@-r15
mov.l g2_except_ptr2719,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2719,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2721
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2721:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2719: .long group_2_exception
bf_addr2719: .long basefunction
! Opcodes 45B0 - 45B7
O5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2722
mov #0,r8
cmp/hi r3,r1
bt ln2722
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2723
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2723:
jmp @r4
mov r0,r2
.align 5
setn2722:
mov #1,r8
ln2722:
mov.l r1,@-r15
mov.l g2_except_ptr2722,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2722,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2724
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2724:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2722: .long group_2_exception
bf_addr2722: .long basefunction
! Opcode 45B8
O5B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2725
mov #0,r8
cmp/hi r3,r1
bt ln2725
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2726
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2726:
jmp @r4
mov r0,r2
.align 5
setn2725:
mov #1,r8
ln2725:
mov.l r1,@-r15
mov.l g2_except_ptr2725,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2725,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2727
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2727:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2725: .long group_2_exception
bf_addr2725: .long basefunction
! Opcode 45B9
O5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2728
mov #0,r8
cmp/hi r3,r1
bt ln2728
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2729
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2729:
jmp @r4
mov r0,r2
.align 5
setn2728:
mov #1,r8
ln2728:
mov.l r1,@-r15
mov.l g2_except_ptr2728,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2728,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-62,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2730
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2730:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2728: .long group_2_exception
bf_addr2728: .long basefunction
! Opcode 45BA
O5BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2731
mov #0,r8
cmp/hi r3,r1
bt ln2731
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2732
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2732:
jmp @r4
mov r0,r2
.align 5
setn2731:
mov #1,r8
ln2731:
mov.l r1,@-r15
mov.l g2_except_ptr2731,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2731,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2733
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2733:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2731: .long group_2_exception
bf_addr2731: .long basefunction
! Opcode 45BB
O5BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2734
mov #0,r8
cmp/hi r3,r1
bt ln2734
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2735
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2735:
jmp @r4
mov r0,r2
.align 5
setn2734:
mov #1,r8
ln2734:
mov.l r1,@-r15
mov.l g2_except_ptr2734,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2734,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2736
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2736:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2734: .long group_2_exception
bf_addr2734: .long basefunction
! Opcode 45BC
O5BC:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2737
mov #0,r8
cmp/hi r3,r1
bt ln2737
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2738
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2738:
jmp @r4
mov r0,r2
.align 5
setn2737:
mov #1,r8
ln2737:
mov.l r1,@-r15
mov.l g2_except_ptr2737,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2737,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2739
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2739:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2737: .long group_2_exception
bf_addr2737: .long basefunction
! Opcodes 45D0 - 45D7
O5D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(40,r13)
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2740
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2740:
jmp @r4
mov r0,r2
! Opcodes 45E8 - 45EF
O5E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(40,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2741
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2741:
jmp @r4
mov r0,r2
! Opcodes 45F0 - 45F7
O5F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(40,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2742
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2742:
jmp @r4
mov r0,r2
! Opcode 45F8
O5F8:
mov.w @r6+,r4
mov.l r4,@(40,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2743
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2743:
jmp @r4
mov r0,r2
! Opcode 45F9
O5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(40,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2744
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2744:
jmp @r4
mov r0,r2
! Opcode 45FA
O5FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(40,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2745
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2745:
jmp @r4
mov r0,r2
! Opcode 45FB
O5FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l r4,@(40,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2746
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2746:
jmp @r4
mov r0,r2
! Opcodes 4600 - 4607
O600:
and r1,r2
add r13,r2
mov.b @r2,r3
not r3,r3
mov.b r3,@r2
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2747
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2747:
jmp @r4
mov r0,r2
! Opcodes 4610 - 4617
O610:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2748
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2748:
jmp @r4
mov r0,r2
! Opcodes 4618 - 461F
O618:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2749
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2749:
jmp @r4
mov r0,r2
! Opcodes 4620 - 4627
O620:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2750
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2750:
jmp @r4
mov r0,r2
! Opcodes 4628 - 462F
O628:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2751
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2751:
jmp @r4
mov r0,r2
! Opcodes 4630 - 4637
O630:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2752
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2752:
jmp @r4
mov r0,r2
! Opcode 4638
O638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2753
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2753:
jmp @r4
mov r0,r2
! Opcode 4639
O639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2754
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2754:
jmp @r4
mov r0,r2
! Opcodes 4640 - 4647
O640:
and r1,r2
add r13,r2
mov.w @r2,r3
not r3,r3
mov.w r3,@r2
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2755
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2755:
jmp @r4
mov r0,r2
! Opcodes 4650 - 4657
O650:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2756
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2756:
jmp @r4
mov r0,r2
! Opcodes 4658 - 465F
O658:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2757
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2757:
jmp @r4
mov r0,r2
! Opcodes 4660 - 4667
O660:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2758
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2758:
jmp @r4
mov r0,r2
! Opcodes 4668 - 466F
O668:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2759
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2759:
jmp @r4
mov r0,r2
! Opcodes 4670 - 4677
O670:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2760
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2760:
jmp @r4
mov r0,r2
! Opcode 4678
O678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2761
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2761:
jmp @r4
mov r0,r2
! Opcode 4679
O679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2762
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2762:
jmp @r4
mov r0,r2
! Opcodes 4680 - 4687
O680:
and r1,r2
add r13,r2
mov.l @r2,r3
not r3,r3
mov.l r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2763
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2763:
jmp @r4
mov r0,r2
! Opcodes 4690 - 4697
O690:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2764
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2764:
jmp @r4
mov r0,r2
! Opcodes 4698 - 469F
O698:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2765
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2765:
jmp @r4
mov r0,r2
! Opcodes 46A0 - 46A7
O6A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2766
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2766:
jmp @r4
mov r0,r2
! Opcodes 46A8 - 46AF
O6A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2767
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2767:
jmp @r4
mov r0,r2
! Opcodes 46B0 - 46B7
O6B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2768
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2768:
jmp @r4
mov r0,r2
! Opcode 46B8
O6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2769
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2769:
jmp @r4
mov r0,r2
! Opcode 46B9
O6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
not r3,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2770
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2770:
jmp @r4
mov r0,r2
! Opcodes 46C0 - 46C7
O6C0:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2771
mov.l priviolation_addr2771,r0
jmp @r0
nop
.align 2
priviolation_addr2771: .long privilege_violation
pcheck_ok2771:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2772
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2772:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2774
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2774:
jmp @r4
mov r0,r2
! Opcodes 46D0 - 46D7
O6D0:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2775
mov.l priviolation_addr2775,r0
jmp @r0
nop
.align 2
priviolation_addr2775: .long privilege_violation
pcheck_ok2775:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2776
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2776:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2778
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2778:
jmp @r4
mov r0,r2
! Opcodes 46D8 - 46DF
O6D8:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2779
mov.l priviolation_addr2779,r0
jmp @r0
nop
.align 2
priviolation_addr2779: .long privilege_violation
pcheck_ok2779:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2780
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2780:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2782
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2782:
jmp @r4
mov r0,r2
! Opcodes 46E0 - 46E7
O6E0:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2783
mov.l priviolation_addr2783,r0
jmp @r0
nop
.align 2
priviolation_addr2783: .long privilege_violation
pcheck_ok2783:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2784
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2784:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2786
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2786:
jmp @r4
mov r0,r2
! Opcodes 46E8 - 46EF
O6E8:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2787
mov.l priviolation_addr2787,r0
jmp @r0
nop
.align 2
priviolation_addr2787: .long privilege_violation
pcheck_ok2787:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2788
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2788:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2790
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2790:
jmp @r4
mov r0,r2
! Opcodes 46F0 - 46F7
O6F0:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2791
mov.l priviolation_addr2791,r0
jmp @r0
nop
.align 2
priviolation_addr2791: .long privilege_violation
pcheck_ok2791:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2792
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2792:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2794
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2794:
jmp @r4
mov r0,r2
! Opcode 46F8
O6F8:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2795
mov.l priviolation_addr2795,r0
jmp @r0
nop
.align 2
priviolation_addr2795: .long privilege_violation
pcheck_ok2795:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2796
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2796:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2798
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2798:
jmp @r4
mov r0,r2
! Opcode 46F9
O6F9:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2799
mov.l priviolation_addr2799,r0
jmp @r0
nop
.align 2
priviolation_addr2799: .long privilege_violation
pcheck_ok2799:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2800
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2800:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2802
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2802:
jmp @r4
mov r0,r2
! Opcode 46FA
O6FA:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2803
mov.l priviolation_addr2803,r0
jmp @r0
nop
.align 2
priviolation_addr2803: .long privilege_violation
pcheck_ok2803:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2804
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2804:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2806
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2806:
jmp @r4
mov r0,r2
! Opcode 46FB
O6FB:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2807
mov.l priviolation_addr2807,r0
jmp @r0
nop
.align 2
priviolation_addr2807: .long privilege_violation
pcheck_ok2807:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2808
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2808:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2810
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2810:
jmp @r4
mov r0,r2
! Opcode 46FC
O6FC:
mov r10,r0
tst #0x20,r0
bf pcheck_ok2811
mov.l priviolation_addr2811,r0
jmp @r0
nop
.align 2
priviolation_addr2811: .long privilege_violation
pcheck_ok2811:
mov.w @r6+,r3
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln2812
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln2812:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue2814
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue2814:
jmp @r4
mov r0,r2
! Opcodes 4780 - 4787
O780:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2815
mov #0,r8
cmp/hi r3,r1
bt ln2815
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2816
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2816:
jmp @r4
mov r0,r2
.align 5
setn2815:
mov #1,r8
ln2815:
mov.l r1,@-r15
mov.l g2_except_ptr2815,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2815,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2817
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2817:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2815: .long group_2_exception
bf_addr2815: .long basefunction
! Opcodes 4790 - 4797
O790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2818
mov #0,r8
cmp/hi r3,r1
bt ln2818
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2819
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2819:
jmp @r4
mov r0,r2
.align 5
setn2818:
mov #1,r8
ln2818:
mov.l r1,@-r15
mov.l g2_except_ptr2818,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2818,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2820
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2820:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2818: .long group_2_exception
bf_addr2818: .long basefunction
! Opcodes 4798 - 479F
O798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2821
mov #0,r8
cmp/hi r3,r1
bt ln2821
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2822
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2822:
jmp @r4
mov r0,r2
.align 5
setn2821:
mov #1,r8
ln2821:
mov.l r1,@-r15
mov.l g2_except_ptr2821,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2821,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2823
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2823:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2821: .long group_2_exception
bf_addr2821: .long basefunction
! Opcodes 47A0 - 47A7
O7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2824
mov #0,r8
cmp/hi r3,r1
bt ln2824
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2825
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2825:
jmp @r4
mov r0,r2
.align 5
setn2824:
mov #1,r8
ln2824:
mov.l r1,@-r15
mov.l g2_except_ptr2824,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2824,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-56,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2826
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2826:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2824: .long group_2_exception
bf_addr2824: .long basefunction
! Opcodes 47A8 - 47AF
O7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2827
mov #0,r8
cmp/hi r3,r1
bt ln2827
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2828
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2828:
jmp @r4
mov r0,r2
.align 5
setn2827:
mov #1,r8
ln2827:
mov.l r1,@-r15
mov.l g2_except_ptr2827,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2827,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2829
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2829:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2827: .long group_2_exception
bf_addr2827: .long basefunction
! Opcodes 47B0 - 47B7
O7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2830
mov #0,r8
cmp/hi r3,r1
bt ln2830
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2831
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2831:
jmp @r4
mov r0,r2
.align 5
setn2830:
mov #1,r8
ln2830:
mov.l r1,@-r15
mov.l g2_except_ptr2830,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2830,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2832
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2832:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2830: .long group_2_exception
bf_addr2830: .long basefunction
! Opcode 47B8
O7B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2833
mov #0,r8
cmp/hi r3,r1
bt ln2833
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2834
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2834:
jmp @r4
mov r0,r2
.align 5
setn2833:
mov #1,r8
ln2833:
mov.l r1,@-r15
mov.l g2_except_ptr2833,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2833,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2835
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2835:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2833: .long group_2_exception
bf_addr2833: .long basefunction
! Opcode 47B9
O7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2836
mov #0,r8
cmp/hi r3,r1
bt ln2836
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2837
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2837:
jmp @r4
mov r0,r2
.align 5
setn2836:
mov #1,r8
ln2836:
mov.l r1,@-r15
mov.l g2_except_ptr2836,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2836,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-62,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2838
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2838:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2836: .long group_2_exception
bf_addr2836: .long basefunction
! Opcode 47BA
O7BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2839
mov #0,r8
cmp/hi r3,r1
bt ln2839
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2840
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2840:
jmp @r4
mov r0,r2
.align 5
setn2839:
mov #1,r8
ln2839:
mov.l r1,@-r15
mov.l g2_except_ptr2839,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2839,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2841
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2841:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2839: .long group_2_exception
bf_addr2839: .long basefunction
! Opcode 47BB
O7BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2842
mov #0,r8
cmp/hi r3,r1
bt ln2842
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2843
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2843:
jmp @r4
mov r0,r2
.align 5
setn2842:
mov #1,r8
ln2842:
mov.l r1,@-r15
mov.l g2_except_ptr2842,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2842,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2844
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2844:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2842: .long group_2_exception
bf_addr2842: .long basefunction
! Opcode 47BC
O7BC:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2845
mov #0,r8
cmp/hi r3,r1
bt ln2845
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2846
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2846:
jmp @r4
mov r0,r2
.align 5
setn2845:
mov #1,r8
ln2845:
mov.l r1,@-r15
mov.l g2_except_ptr2845,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2845,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2847
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2847:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2845: .long group_2_exception
bf_addr2845: .long basefunction
! Opcodes 47D0 - 47D7
O7D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(44,r13)
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2848
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2848:
jmp @r4
mov r0,r2
! Opcodes 47E8 - 47EF
O7E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(44,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2849
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2849:
jmp @r4
mov r0,r2
! Opcodes 47F0 - 47F7
O7F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(44,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2850
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2850:
jmp @r4
mov r0,r2
! Opcode 47F8
O7F8:
mov.w @r6+,r4
mov.l r4,@(44,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2851
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2851:
jmp @r4
mov r0,r2
! Opcode 47F9
O7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(44,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2852
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2852:
jmp @r4
mov r0,r2
! Opcode 47FA
O7FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(44,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2853
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2853:
jmp @r4
mov r0,r2
! Opcode 47FB
O7FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l r4,@(44,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2854
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2854:
jmp @r4
mov r0,r2
! Opcodes 4800 - 4807
O800:
and r1,r2
mov.l r3,@-r15
add r13,r2
mov.b @r2,r3
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd2856
add #-6,r8
.nonibadd2856:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop2856
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop2856:
exts.b r3,r3
mov r9,r8
mov.b r3,@r2
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2857
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2857:
jmp @r4
mov r0,r2
! Opcodes 4810 - 4817
O810:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd2859
add #-6,r8
.nonibadd2859:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop2859
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop2859:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2860
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2860:
jmp @r4
mov r0,r2
! Opcodes 4818 - 481F
O818:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd2862
add #-6,r8
.nonibadd2862:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop2862
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop2862:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2863
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2863:
jmp @r4
mov r0,r2
! Opcodes 4820 - 4827
O820:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd2865
add #-6,r8
.nonibadd2865:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop2865
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop2865:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2866
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2866:
jmp @r4
mov r0,r2
! Opcodes 4828 - 482F
O828:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd2868
add #-6,r8
.nonibadd2868:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop2868
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop2868:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2869
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2869:
jmp @r4
mov r0,r2
! Opcodes 4830 - 4837
O830:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd2871
add #-6,r8
.nonibadd2871:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop2871
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop2871:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2872
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2872:
jmp @r4
mov r0,r2
! Opcode 4838
O838:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd2874
add #-6,r8
.nonibadd2874:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop2874
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop2874:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2875
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2875:
jmp @r4
mov r0,r2
! Opcode 4839
O839:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov #0,r3
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd2877
add #-6,r8
.nonibadd2877:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop2877
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop2877:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2878
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2878:
jmp @r4
mov r0,r2
! Opcodes 4840 - 4847
O840:
and r1,r2
add r13,r2
mov.l @r2,r3
swap.w r3,r3
mov.l r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2879
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2879:
jmp @r4
mov r0,r2
! Opcodes 4850 - 4857
O850:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2880
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2880:
jmp @r4
mov r0,r2
! Opcodes 4868 - 486F
O868:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2881
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2881:
jmp @r4
mov r0,r2
! Opcodes 4870 - 4877
O870:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2882
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2882:
jmp @r4
mov r0,r2
! Opcode 4878
O878:
mov.l r3,@-r15
mov.w @r6+,r4
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2883
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2883:
jmp @r4
mov r0,r2
! Opcode 4879
O879:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2884
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2884:
jmp @r4
mov r0,r2
! Opcode 487A
O87A:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2885
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2885:
jmp @r4
mov r0,r2
! Opcode 487B
O87B:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov r4,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2886
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2886:
jmp @r4
mov r0,r2
! Opcodes 4880 - 4887
O880:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.w r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2887
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2887:
jmp @r4
mov r0,r2
! Opcodes 4890 - 4897
O890:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov #0,r2
ln2888:
shlr r10
bf ln2889
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
add #2,r4
ln2889:
add #4,r2
mov #64,r0
tst r0,r2
bt ln2888
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2890
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2890:
jmp @r4
mov r0,r2
! Opcodes 48A0 - 48A7
O8A0:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov.l r2,@-r15
mov #60,r2
ln2891:
shlr r10
bf ln2892
mov r13,r0
add #-2,r4
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
ln2892:
add #-4,r2
cmp/pz r2
bt ln2891
mov.l @r15+,r2
mov.l @r15+,r10
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2893
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2893:
jmp @r4
mov r0,r2
! Opcodes 48A8 - 48AF
O8A8:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln2894:
shlr r10
bf ln2895
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
add #2,r4
ln2895:
add #4,r2
mov #64,r0
tst r0,r2
bt ln2894
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2896
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2896:
jmp @r4
mov r0,r2
! Opcodes 48B0 - 48B7
O8B0:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln2897:
shlr r10
bf ln2898
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
add #2,r4
ln2898:
add #4,r2
mov #64,r0
tst r0,r2
bt ln2897
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2899
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2899:
jmp @r4
mov r0,r2
! Opcode 48B8
O8B8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov #0,r2
ln2900:
shlr r10
bf ln2901
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
add #2,r4
ln2901:
add #4,r2
mov #64,r0
tst r0,r2
bt ln2900
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2902
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2902:
jmp @r4
mov r0,r2
! Opcode 48B9
O8B9:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov #0,r2
ln2903:
shlr r10
bf ln2904
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
add #2,r4
ln2904:
add #4,r2
mov #64,r0
tst r0,r2
bt ln2903
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2905
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2905:
jmp @r4
mov r0,r2
! Opcodes 48C0 - 48C7
O8C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l r3,@r2
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2906
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2906:
jmp @r4
mov r0,r2
! Opcodes 48D0 - 48D7
O8D0:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov #0,r2
ln2907:
shlr r10
bf ln2908
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
add #4,r4
ln2908:
add #4,r2
mov #64,r0
tst r0,r2
bt ln2907
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2909
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2909:
jmp @r4
mov r0,r2
! Opcodes 48E0 - 48E7
O8E0:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov.l r2,@-r15
mov #60,r2
ln2910:
shlr r10
bf ln2911
mov r13,r0
add #-4,r4
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
ln2911:
add #-4,r2
cmp/pz r2
bt ln2910
mov.l @r15+,r2
mov.l @r15+,r10
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2912
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2912:
jmp @r4
mov r0,r2
! Opcodes 48E8 - 48EF
O8E8:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln2913:
shlr r10
bf ln2914
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
add #4,r4
ln2914:
add #4,r2
mov #64,r0
tst r0,r2
bt ln2913
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2915
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2915:
jmp @r4
mov r0,r2
! Opcodes 48F0 - 48F7
O8F0:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln2916:
shlr r10
bf ln2917
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
add #4,r4
ln2917:
add #4,r2
mov #64,r0
tst r0,r2
bt ln2916
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2918
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2918:
jmp @r4
mov r0,r2
! Opcode 48F8
O8F8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov #0,r2
ln2919:
shlr r10
bf ln2920
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
add #4,r4
ln2920:
add #4,r2
mov #64,r0
tst r0,r2
bt ln2919
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2921
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2921:
jmp @r4
mov r0,r2
! Opcode 48F9
O8F9:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov #0,r2
ln2922:
shlr r10
bf ln2923
mov r13,r0
mov.l @(r0,r2),r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
add #4,r4
ln2923:
add #4,r2
mov #64,r0
tst r0,r2
bt ln2922
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2924
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2924:
jmp @r4
mov r0,r2
! Opcodes 4980 - 4987
O980:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2925
mov #0,r8
cmp/hi r3,r1
bt ln2925
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2926
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2926:
jmp @r4
mov r0,r2
.align 5
setn2925:
mov #1,r8
ln2925:
mov.l r1,@-r15
mov.l g2_except_ptr2925,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2925,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2927
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2927:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2925: .long group_2_exception
bf_addr2925: .long basefunction
! Opcodes 4990 - 4997
O990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2928
mov #0,r8
cmp/hi r3,r1
bt ln2928
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2929
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2929:
jmp @r4
mov r0,r2
.align 5
setn2928:
mov #1,r8
ln2928:
mov.l r1,@-r15
mov.l g2_except_ptr2928,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2928,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2930
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2930:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2928: .long group_2_exception
bf_addr2928: .long basefunction
! Opcodes 4998 - 499F
O998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2931
mov #0,r8
cmp/hi r3,r1
bt ln2931
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2932
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2932:
jmp @r4
mov r0,r2
.align 5
setn2931:
mov #1,r8
ln2931:
mov.l r1,@-r15
mov.l g2_except_ptr2931,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2931,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2933
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2933:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2931: .long group_2_exception
bf_addr2931: .long basefunction
! Opcodes 49A0 - 49A7
O9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2934
mov #0,r8
cmp/hi r3,r1
bt ln2934
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2935
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2935:
jmp @r4
mov r0,r2
.align 5
setn2934:
mov #1,r8
ln2934:
mov.l r1,@-r15
mov.l g2_except_ptr2934,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2934,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-56,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2936
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2936:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2934: .long group_2_exception
bf_addr2934: .long basefunction
! Opcodes 49A8 - 49AF
O9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2937
mov #0,r8
cmp/hi r3,r1
bt ln2937
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2938
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2938:
jmp @r4
mov r0,r2
.align 5
setn2937:
mov #1,r8
ln2937:
mov.l r1,@-r15
mov.l g2_except_ptr2937,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2937,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2939
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2939:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2937: .long group_2_exception
bf_addr2937: .long basefunction
! Opcodes 49B0 - 49B7
O9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2940
mov #0,r8
cmp/hi r3,r1
bt ln2940
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2941
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2941:
jmp @r4
mov r0,r2
.align 5
setn2940:
mov #1,r8
ln2940:
mov.l r1,@-r15
mov.l g2_except_ptr2940,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2940,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2942
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2942:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2940: .long group_2_exception
bf_addr2940: .long basefunction
! Opcode 49B8
O9B8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2943
mov #0,r8
cmp/hi r3,r1
bt ln2943
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2944
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2944:
jmp @r4
mov r0,r2
.align 5
setn2943:
mov #1,r8
ln2943:
mov.l r1,@-r15
mov.l g2_except_ptr2943,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2943,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2945
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2945:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2943: .long group_2_exception
bf_addr2943: .long basefunction
! Opcode 49B9
O9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2946
mov #0,r8
cmp/hi r3,r1
bt ln2946
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2947
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2947:
jmp @r4
mov r0,r2
.align 5
setn2946:
mov #1,r8
ln2946:
mov.l r1,@-r15
mov.l g2_except_ptr2946,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2946,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-62,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2948
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2948:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2946: .long group_2_exception
bf_addr2946: .long basefunction
! Opcode 49BA
O9BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2949
mov #0,r8
cmp/hi r3,r1
bt ln2949
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2950
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2950:
jmp @r4
mov r0,r2
.align 5
setn2949:
mov #1,r8
ln2949:
mov.l r1,@-r15
mov.l g2_except_ptr2949,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2949,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2951
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2951:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2949: .long group_2_exception
bf_addr2949: .long basefunction
! Opcode 49BB
O9BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2952
mov #0,r8
cmp/hi r3,r1
bt ln2952
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2953
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2953:
jmp @r4
mov r0,r2
.align 5
setn2952:
mov #1,r8
ln2952:
mov.l r1,@-r15
mov.l g2_except_ptr2952,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2952,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2954
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2954:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2952: .long group_2_exception
bf_addr2952: .long basefunction
! Opcode 49BC
O9BC:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn2955
mov #0,r8
cmp/hi r3,r1
bt ln2955
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2956
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2956:
jmp @r4
mov r0,r2
.align 5
setn2955:
mov #1,r8
ln2955:
mov.l r1,@-r15
mov.l g2_except_ptr2955,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr2955,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2957
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2957:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr2955: .long group_2_exception
bf_addr2955: .long basefunction
! Opcodes 49D0 - 49D7
O9D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(48,r13)
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2958
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2958:
jmp @r4
mov r0,r2
! Opcodes 49E8 - 49EF
O9E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(48,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2959
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2959:
jmp @r4
mov r0,r2
! Opcodes 49F0 - 49F7
O9F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(48,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2960
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2960:
jmp @r4
mov r0,r2
! Opcode 49F8
O9F8:
mov.w @r6+,r4
mov.l r4,@(48,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2961
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2961:
jmp @r4
mov r0,r2
! Opcode 49F9
O9F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(48,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2962
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2962:
jmp @r4
mov r0,r2
! Opcode 49FA
O9FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(48,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2963
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2963:
jmp @r4
mov r0,r2
! Opcode 49FB
O9FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l r4,@(48,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2964
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2964:
jmp @r4
mov r0,r2
! Opcodes 4A00 - 4A07
OA00:
and r1,r2
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2965
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2965:
jmp @r4
mov r0,r2
! Opcodes 4A10 - 4A17
OA10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2966
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2966:
jmp @r4
mov r0,r2
! Opcodes 4A18 - 4A1F
OA18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2967
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2967:
jmp @r4
mov r0,r2
! Opcodes 4A20 - 4A27
OA20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2968
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2968:
jmp @r4
mov r0,r2
! Opcodes 4A28 - 4A2F
OA28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2969
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2969:
jmp @r4
mov r0,r2
! Opcodes 4A30 - 4A37
OA30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2970
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2970:
jmp @r4
mov r0,r2
! Opcode 4A38
OA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2971
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2971:
jmp @r4
mov r0,r2
! Opcode 4A39
OA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2972
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2972:
jmp @r4
mov r0,r2
! Opcodes 4A40 - 4A47
OA40:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2973
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2973:
jmp @r4
mov r0,r2
! Opcodes 4A50 - 4A57
OA50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2974
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2974:
jmp @r4
mov r0,r2
! Opcodes 4A58 - 4A5F
OA58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2975
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2975:
jmp @r4
mov r0,r2
! Opcodes 4A60 - 4A67
OA60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2976
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2976:
jmp @r4
mov r0,r2
! Opcodes 4A68 - 4A6F
OA68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2977
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2977:
jmp @r4
mov r0,r2
! Opcodes 4A70 - 4A77
OA70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2978
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2978:
jmp @r4
mov r0,r2
! Opcode 4A78
OA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2979
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2979:
jmp @r4
mov r0,r2
! Opcode 4A79
OA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2980
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2980:
jmp @r4
mov r0,r2
! Opcodes 4A80 - 4A87
OA80:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2981
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2981:
jmp @r4
mov r0,r2
! Opcodes 4A90 - 4A97
OA90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2982
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2982:
jmp @r4
mov r0,r2
! Opcodes 4A98 - 4A9F
OA98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2983
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2983:
jmp @r4
mov r0,r2
! Opcodes 4AA0 - 4AA7
OAA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2984
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2984:
jmp @r4
mov r0,r2
! Opcodes 4AA8 - 4AAF
OAA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2985
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2985:
jmp @r4
mov r0,r2
! Opcodes 4AB0 - 4AB7
OAB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2986
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2986:
jmp @r4
mov r0,r2
! Opcode 4AB8
OAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2987
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2987:
jmp @r4
mov r0,r2
! Opcode 4AB9
OAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2988
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2988:
jmp @r4
mov r0,r2
! Opcodes 4AC0 - 4AC7
OAC0:
and r1,r2
mov r2,r0
mov.b @(r0,r13),r3
mov r3,r1
mov.l r3,@-r15
rotl r3
movt r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2989
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2989:
jmp @r4
mov r0,r2
! Opcodes 4AD0 - 4AD7
OAD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
rotl r3
movt r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2990
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2990:
jmp @r4
mov r0,r2
! Opcodes 4AD8 - 4ADF
OAD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
rotl r3
movt r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2991
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2991:
jmp @r4
mov r0,r2
! Opcodes 4AE0 - 4AE7
OAE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
rotl r3
movt r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2992
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2992:
jmp @r4
mov r0,r2
! Opcodes 4AE8 - 4AEF
OAE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
rotl r3
movt r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2993
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2993:
jmp @r4
mov r0,r2
! Opcodes 4AF0 - 4AF7
OAF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
rotl r3
movt r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2994
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2994:
jmp @r4
mov r0,r2
! Opcode 4AF8
OAF8:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
rotl r3
movt r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2995
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2995:
jmp @r4
mov r0,r2
! Opcode 4AF9
OAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r3,r1
mov.l r3,@-r15
rotl r3
movt r8
mov r1,r0
or #0x80,r0
mov r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2996
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2996:
jmp @r4
mov r0,r2
! Opcode 4AFA
OAFA:
r_illegal:
mov.l r3,@-r15
mov.l g1_except_addr2997,r0
add #-2,r6
jsr @r0
mov #0x10,r4
mov.l bf_addr2997,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl2998
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl2998:
jmp @r4
mov r0,r2
.align 2
g1_except_addr2997: .long group_1_exception
bf_addr2997: .long basefunction
! Opcode 4AFB
OAFB:
mov.l r3,@-r15
mov.l g1_except_addr2999,r0
add #-2,r6
jsr @r0
mov #0x10,r4
mov.l bf_addr2999,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3000
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3000:
jmp @r4
mov r0,r2
.align 2
g1_except_addr2999: .long group_1_exception
bf_addr2999: .long basefunction
! Opcode 4AFC
OAFC:
mov.l r3,@-r15
mov.l g1_except_addr3001,r0
add #-2,r6
jsr @r0
mov #0x10,r4
mov.l bf_addr3001,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3002
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3002:
jmp @r4
mov r0,r2
.align 2
g1_except_addr3001: .long group_1_exception
bf_addr3001: .long basefunction
! Opcodes 4B80 - 4B87
OB80:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3003
mov #0,r8
cmp/hi r3,r1
bt ln3003
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3004
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3004:
jmp @r4
mov r0,r2
.align 5
setn3003:
mov #1,r8
ln3003:
mov.l r1,@-r15
mov.l g2_except_ptr3003,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3003,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3005
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3005:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3003: .long group_2_exception
bf_addr3003: .long basefunction
! Opcodes 4B90 - 4B97
OB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3006
mov #0,r8
cmp/hi r3,r1
bt ln3006
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3007
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3007:
jmp @r4
mov r0,r2
.align 5
setn3006:
mov #1,r8
ln3006:
mov.l r1,@-r15
mov.l g2_except_ptr3006,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3006,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3008
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3008:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3006: .long group_2_exception
bf_addr3006: .long basefunction
! Opcodes 4B98 - 4B9F
OB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3009
mov #0,r8
cmp/hi r3,r1
bt ln3009
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3010
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3010:
jmp @r4
mov r0,r2
.align 5
setn3009:
mov #1,r8
ln3009:
mov.l r1,@-r15
mov.l g2_except_ptr3009,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3009,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3011
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3011:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3009: .long group_2_exception
bf_addr3009: .long basefunction
! Opcodes 4BA0 - 4BA7
OBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3012
mov #0,r8
cmp/hi r3,r1
bt ln3012
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3013
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3013:
jmp @r4
mov r0,r2
.align 5
setn3012:
mov #1,r8
ln3012:
mov.l r1,@-r15
mov.l g2_except_ptr3012,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3012,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-56,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3014
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3014:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3012: .long group_2_exception
bf_addr3012: .long basefunction
! Opcodes 4BA8 - 4BAF
OBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3015
mov #0,r8
cmp/hi r3,r1
bt ln3015
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3016
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3016:
jmp @r4
mov r0,r2
.align 5
setn3015:
mov #1,r8
ln3015:
mov.l r1,@-r15
mov.l g2_except_ptr3015,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3015,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3017
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3017:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3015: .long group_2_exception
bf_addr3015: .long basefunction
! Opcodes 4BB0 - 4BB7
OBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3018
mov #0,r8
cmp/hi r3,r1
bt ln3018
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3019
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3019:
jmp @r4
mov r0,r2
.align 5
setn3018:
mov #1,r8
ln3018:
mov.l r1,@-r15
mov.l g2_except_ptr3018,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3018,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3020
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3020:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3018: .long group_2_exception
bf_addr3018: .long basefunction
! Opcode 4BB8
OBB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3021
mov #0,r8
cmp/hi r3,r1
bt ln3021
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3022
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3022:
jmp @r4
mov r0,r2
.align 5
setn3021:
mov #1,r8
ln3021:
mov.l r1,@-r15
mov.l g2_except_ptr3021,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3021,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3023
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3023:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3021: .long group_2_exception
bf_addr3021: .long basefunction
! Opcode 4BB9
OBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3024
mov #0,r8
cmp/hi r3,r1
bt ln3024
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3025
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3025:
jmp @r4
mov r0,r2
.align 5
setn3024:
mov #1,r8
ln3024:
mov.l r1,@-r15
mov.l g2_except_ptr3024,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3024,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-62,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3026
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3026:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3024: .long group_2_exception
bf_addr3024: .long basefunction
! Opcode 4BBA
OBBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3027
mov #0,r8
cmp/hi r3,r1
bt ln3027
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3028
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3028:
jmp @r4
mov r0,r2
.align 5
setn3027:
mov #1,r8
ln3027:
mov.l r1,@-r15
mov.l g2_except_ptr3027,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3027,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3029
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3029:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3027: .long group_2_exception
bf_addr3027: .long basefunction
! Opcode 4BBB
OBBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3030
mov #0,r8
cmp/hi r3,r1
bt ln3030
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3031
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3031:
jmp @r4
mov r0,r2
.align 5
setn3030:
mov #1,r8
ln3030:
mov.l r1,@-r15
mov.l g2_except_ptr3030,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3030,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3032
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3032:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3030: .long group_2_exception
bf_addr3030: .long basefunction
! Opcode 4BBC
OBBC:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3033
mov #0,r8
cmp/hi r3,r1
bt ln3033
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3034
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3034:
jmp @r4
mov r0,r2
.align 5
setn3033:
mov #1,r8
ln3033:
mov.l r1,@-r15
mov.l g2_except_ptr3033,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3033,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3035
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3035:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3033: .long group_2_exception
bf_addr3033: .long basefunction
! Opcodes 4BD0 - 4BD7
OBD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(52,r13)
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3036
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3036:
jmp @r4
mov r0,r2
! Opcodes 4BE8 - 4BEF
OBE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(52,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3037
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3037:
jmp @r4
mov r0,r2
! Opcodes 4BF0 - 4BF7
OBF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(52,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3038
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3038:
jmp @r4
mov r0,r2
! Opcode 4BF8
OBF8:
mov.w @r6+,r4
mov.l r4,@(52,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3039
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3039:
jmp @r4
mov r0,r2
! Opcode 4BF9
OBF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(52,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3040
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3040:
jmp @r4
mov r0,r2
! Opcode 4BFA
OBFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(52,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3041
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3041:
jmp @r4
mov r0,r2
! Opcode 4BFB
OBFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l r4,@(52,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3042
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3042:
jmp @r4
mov r0,r2
! Opcodes 4C90 - 4C97
OC90:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov #0,r2
ln3043:
shlr r10
bf ln3044
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln3044:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3043
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3045
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3045:
jmp @r4
mov r0,r2
! Opcodes 4C98 - 4C9F
OC98:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov.l r2,@-r15
xor r2,r2
ln3046:
shlr r10
bf ln3047
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
add #2,r4
mov.l r3,@(r0,r2)
ln3047:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3046
mov.l @r15+,r2
mov.l @r15+,r10
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3048
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3048:
jmp @r4
mov r0,r2
! Opcodes 4CA8 - 4CAF
OCA8:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln3049:
shlr r10
bf ln3050
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln3050:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3049
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3051
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3051:
jmp @r4
mov r0,r2
! Opcodes 4CB0 - 4CB7
OCB0:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln3052:
shlr r10
bf ln3053
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln3053:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3052
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3054
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3054:
jmp @r4
mov r0,r2
! Opcode 4CB8
OCB8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov #0,r2
ln3055:
shlr r10
bf ln3056
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln3056:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3055
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3057
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3057:
jmp @r4
mov r0,r2
! Opcode 4CB9
OCB9:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov #0,r2
ln3058:
shlr r10
bf ln3059
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln3059:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3058
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3060
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3060:
jmp @r4
mov r0,r2
! Opcode 4CBA
OCBA:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov #0,r2
ln3061:
shlr r10
bf ln3062
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln3062:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3061
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3063
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3063:
jmp @r4
mov r0,r2
! Opcode 4CBB
OCBB:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov #0,r2
ln3064:
shlr r10
bf ln3065
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
add #-4,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #2,r4
ln3065:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3064
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3066
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3066:
jmp @r4
mov r0,r2
! Opcodes 4CD0 - 4CD7
OCD0:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov #0,r2
ln3067:
shlr r10
bf ln3068
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln3068:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3067
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3069
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3069:
jmp @r4
mov r0,r2
! Opcodes 4CD8 - 4CDF
OCD8:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r2,r0
mov.l @(r0,r14),r4
mov.l r2,@-r15
xor r2,r2
ln3070:
shlr r10
bf ln3071
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
add #4,r4
mov.l r3,@(r0,r2)
ln3071:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3070
mov.l @r15+,r2
mov.l @r15+,r10
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3072
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3072:
jmp @r4
mov r0,r2
! Opcodes 4CE8 - 4CEF
OCE8:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln3073:
shlr r10
bf ln3074
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln3074:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3073
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3075
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3075:
jmp @r4
mov r0,r2
! Opcodes 4CF0 - 4CF7
OCF0:
and r1,r2
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov #0,r2
ln3076:
shlr r10
bf ln3077
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln3077:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3076
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3078
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3078:
jmp @r4
mov r0,r2
! Opcode 4CF8
OCF8:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r4
mov #0,r2
ln3079:
shlr r10
bf ln3080
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln3080:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3079
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3081
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3081:
jmp @r4
mov r0,r2
! Opcode 4CF9
OCF9:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov #0,r2
ln3082:
shlr r10
bf ln3083
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln3083:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3082
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3084
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3084:
jmp @r4
mov r0,r2
! Opcode 4CFA
OCFA:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov #0,r2
ln3085:
shlr r10
bf ln3086
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln3086:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3085
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3087
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3087:
jmp @r4
mov r0,r2
! Opcode 4CFB
OCFB:
mov.l r3,@-r15
mov.l r10,@-r15
mov.w @r6+,r10
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov #0,r2
ln3088:
shlr r10
bf ln3089
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #-8,r7
mov r13,r0
mov.l r3,@(r0,r2)
add #4,r4
ln3089:
add #4,r2
mov #64,r0
tst r0,r2
bt ln3088
mov.l @r15+,r10
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3090
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3090:
jmp @r4
mov r0,r2
! Opcodes 4D80 - 4D87
OD80:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3091
mov #0,r8
cmp/hi r3,r1
bt ln3091
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3092
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3092:
jmp @r4
mov r0,r2
.align 5
setn3091:
mov #1,r8
ln3091:
mov.l r1,@-r15
mov.l g2_except_ptr3091,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3091,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3093
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3093:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3091: .long group_2_exception
bf_addr3091: .long basefunction
! Opcodes 4D90 - 4D97
OD90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3094
mov #0,r8
cmp/hi r3,r1
bt ln3094
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3095
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3095:
jmp @r4
mov r0,r2
.align 5
setn3094:
mov #1,r8
ln3094:
mov.l r1,@-r15
mov.l g2_except_ptr3094,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3094,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3096
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3096:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3094: .long group_2_exception
bf_addr3094: .long basefunction
! Opcodes 4D98 - 4D9F
OD98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3097
mov #0,r8
cmp/hi r3,r1
bt ln3097
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3098
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3098:
jmp @r4
mov r0,r2
.align 5
setn3097:
mov #1,r8
ln3097:
mov.l r1,@-r15
mov.l g2_except_ptr3097,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3097,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3099
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3099:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3097: .long group_2_exception
bf_addr3097: .long basefunction
! Opcodes 4DA0 - 4DA7
ODA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3100
mov #0,r8
cmp/hi r3,r1
bt ln3100
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3101
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3101:
jmp @r4
mov r0,r2
.align 5
setn3100:
mov #1,r8
ln3100:
mov.l r1,@-r15
mov.l g2_except_ptr3100,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3100,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-56,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3102
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3102:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3100: .long group_2_exception
bf_addr3100: .long basefunction
! Opcodes 4DA8 - 4DAF
ODA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3103
mov #0,r8
cmp/hi r3,r1
bt ln3103
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3104
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3104:
jmp @r4
mov r0,r2
.align 5
setn3103:
mov #1,r8
ln3103:
mov.l r1,@-r15
mov.l g2_except_ptr3103,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3103,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3105
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3105:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3103: .long group_2_exception
bf_addr3103: .long basefunction
! Opcodes 4DB0 - 4DB7
ODB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3106
mov #0,r8
cmp/hi r3,r1
bt ln3106
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3107
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3107:
jmp @r4
mov r0,r2
.align 5
setn3106:
mov #1,r8
ln3106:
mov.l r1,@-r15
mov.l g2_except_ptr3106,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3106,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3108
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3108:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3106: .long group_2_exception
bf_addr3106: .long basefunction
! Opcode 4DB8
ODB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3109
mov #0,r8
cmp/hi r3,r1
bt ln3109
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3110
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3110:
jmp @r4
mov r0,r2
.align 5
setn3109:
mov #1,r8
ln3109:
mov.l r1,@-r15
mov.l g2_except_ptr3109,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3109,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3111
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3111:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3109: .long group_2_exception
bf_addr3109: .long basefunction
! Opcode 4DB9
ODB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3112
mov #0,r8
cmp/hi r3,r1
bt ln3112
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3113
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3113:
jmp @r4
mov r0,r2
.align 5
setn3112:
mov #1,r8
ln3112:
mov.l r1,@-r15
mov.l g2_except_ptr3112,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3112,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-62,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3114
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3114:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3112: .long group_2_exception
bf_addr3112: .long basefunction
! Opcode 4DBA
ODBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3115
mov #0,r8
cmp/hi r3,r1
bt ln3115
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3116
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3116:
jmp @r4
mov r0,r2
.align 5
setn3115:
mov #1,r8
ln3115:
mov.l r1,@-r15
mov.l g2_except_ptr3115,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3115,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3117
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3117:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3115: .long group_2_exception
bf_addr3115: .long basefunction
! Opcode 4DBB
ODBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3118
mov #0,r8
cmp/hi r3,r1
bt ln3118
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3119
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3119:
jmp @r4
mov r0,r2
.align 5
setn3118:
mov #1,r8
ln3118:
mov.l r1,@-r15
mov.l g2_except_ptr3118,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3118,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3120
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3120:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3118: .long group_2_exception
bf_addr3118: .long basefunction
! Opcode 4DBC
ODBC:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3121
mov #0,r8
cmp/hi r3,r1
bt ln3121
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3122
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3122:
jmp @r4
mov r0,r2
.align 5
setn3121:
mov #1,r8
ln3121:
mov.l r1,@-r15
mov.l g2_except_ptr3121,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3121,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3123
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3123:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3121: .long group_2_exception
bf_addr3121: .long basefunction
! Opcodes 4DD0 - 4DD7
ODD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(56,r13)
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3124
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3124:
jmp @r4
mov r0,r2
! Opcodes 4DE8 - 4DEF
ODE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(56,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3125
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3125:
jmp @r4
mov r0,r2
! Opcodes 4DF0 - 4DF7
ODF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(56,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3126
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3126:
jmp @r4
mov r0,r2
! Opcode 4DF8
ODF8:
mov.w @r6+,r4
mov.l r4,@(56,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3127
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3127:
jmp @r4
mov r0,r2
! Opcode 4DF9
ODF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(56,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3128
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3128:
jmp @r4
mov r0,r2
! Opcode 4DFA
ODFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(56,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3129
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3129:
jmp @r4
mov r0,r2
! Opcode 4DFB
ODFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l r4,@(56,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3130
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3130:
jmp @r4
mov r0,r2
! Opcodes 4E40 - 4E4F
OE40:
mov #0x3C,r0
mov #0x80,r4
and r0,r2
extu.b r4,r4
mov.l g2_exception_addr,r0
jsr @r0
add r2,r4
mov.l bf_addr3131,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3132
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3132:
jmp @r4
mov r0,r2
.align 2
g2_exception_addr: .long group_2_exception
bf_addr3131: .long basefunction
! Opcodes 4E50 - 4E57
OE50:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @(60,r13),r3
mov r2,r0
mov.l r3,@(r0,r14)
mov.w @r6+,r4
add r4,r3
mov.l r3,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3133
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3133:
jmp @r4
mov r0,r2
! Opcodes 4E58 - 4E5F
OE58:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r3
mov.l r3,@(60,r13)
mov.l @(60,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov r2,r0
mov.l r3,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3134
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3134:
jmp @r4
mov r0,r2
! Opcodes 4E60 - 4E67
OE60:
mov r10,r0
tst #0x20,r0
bf pcheck_ok3135
mov.l priviolation_addr3135,r0
jmp @r0
nop
.align 2
priviolation_addr3135: .long privilege_violation
pcheck_ok3135:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r1
mov.l r1,@(32,r14)
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3136
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3136:
jmp @r4
mov r0,r2
! Opcodes 4E68 - 4E6F
OE68:
mov r10,r0
tst #0x20,r0
bf pcheck_ok3137
mov.l priviolation_addr3137,r0
jmp @r0
nop
.align 2
priviolation_addr3137: .long privilege_violation
pcheck_ok3137:
and r1,r2
mov.l @(32,r14),r1
mov r2,r0
mov.l r1,@(r0,r14)
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3138
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3138:
jmp @r4
mov r0,r2
! Opcode 4E70
OE70:
mov r10,r0
tst #0x20,r0
bf pcheck_ok3140
mov.l priviolation_addr3140,r0
jmp @r0
nop
.align 2
priviolation_addr3140: .long privilege_violation
pcheck_ok3140:
mov.l resethandler_addr3139,r0
mov.l @r0,r1
tst r1,r1
bt r_done
mov.l r3,@-r15
mov.l io_cycle_counter_addr3139,r0
mov.l r7,@r0
mov.l r5,@(io_fetchbase-io_cycle_counter,r0)
mov.l r6,@(io_fetchbased_pc-io_cycle_counter,r0)
sts.l	pr,@-r15
jsr @r1
nop
lds.l	@r15+,pr
mov.l io_cycle_counter_addr3139,r0
mov.l @r0,r7
mov.l @(io_fetchbase-io_cycle_counter,r0),r5
mov.l @(io_fetchbased_pc-io_cycle_counter,r0),r6
mov.l @r15+,r3
r_done:
mov.w @r6+,r0
add #-128,r7
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3141
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3141:
jmp @r4
mov r0,r2
.align 2
io_cycle_counter_addr3139: .long io_cycle_counter
resethandler_addr3139: .long resethandler
! Opcode 4E71
OE71:
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3142
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3142:
jmp @r4
mov r0,r2
! Opcode 4E72
OE72:
mov r10,r0
tst #0x20,r0
bf pcheck_ok3143
mov.l priviolation_addr3143,r0
jmp @r0
nop
.align 2
priviolation_addr3143: .long privilege_violation
pcheck_ok3143:
mov.w @r6+,r3
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln3144
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln3144:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.l execinfo_addr3143,r2
mov.w @r2,r0
mov #0x80,r1
extu.b r1,r1
or r1,r0
mov.w r0,@r2
mov.l exit_addr,r0
jmp @r0
add #-4,r7
.align 2
exit_addr: .long execexit
execinfo_addr3143: .long execinfo
! Opcode 4E73
OE73:
mov r10,r0
tst #0x20,r0
bf pcheck_ok3147
mov.l priviolation_addr3147,r0
jmp @r0
nop
.align 2
priviolation_addr3147: .long privilege_violation
pcheck_ok3147:
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
mov.l @(60,r13),r4
add #2,r4
mov r3,r0
shlr8 r0
xor r10,r0
tst #0x20,r0
bt ln3148
mov.l @(32,r14),r0
mov.l @(60,r13),r1
mov.l r0,@(60,r13)
mov.l r1,@(32,r14)
ln3148:
mov r3,r0
shlr8 r0
and #0xA7,r0
mov r0,r10
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov r10,r0
tst #0x20,r0
movt r2
mov.l r3,@-r15
shll2 r2
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
add #28,r2
add r14,r2
mov.l @r2,r4
add #6,r4
mov.l r4,@r2
mov.l execinfo_addr3146,r1
mov.w @r1,r0
and #0xE7,r0
mov.w r0,@r1
mov r3,r6
mov.l bf_addr3146,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt continue3150
mov.l @(execexit_addr-areg,r14),r0
jmp @r0
add #-2,r6
.align 5
continue3150:
jmp @r4
mov r0,r2
.align 2
bf_addr3146: .long basefunction
execinfo_addr3146: .long execinfo
! Opcode 4E75
OE75:
mov.l r3,@-r15
mov.l @(60,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov r3,r6
mov.l bf_addr3151,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3152
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3152:
jmp @r4
mov r0,r2
.align 2
bf_addr3151: .long basefunction
! Opcode 4E76
OE76:
mov #8,r0
tst r0,r8
bf ln3153
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3154
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3154:
jmp @r4
mov r0,r2
ln3153:
mov.l g2_exception_ptr,r0
jsr @r0
mov #0x1C,r4
mov.l bf_addr3153,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3155
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3155:
jmp @r4
mov r0,r2
.align 2
g2_exception_ptr: .long group_2_exception
bf_addr3153: .long basefunction
! Opcode 4E77
OE77:
mov.l @(60,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #3,r8
and r3,r8
mov r3,r9
shlr2 r9
not r9,r3
shlr r9
mov #1,r0
shlr r9
addc r8,r8
and r0,r9
and r0,r3
mov.l r3,@-r15
mov.l @(60,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov r3,r6
mov.l bf_addr3156,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3157
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3157:
jmp @r4
mov r0,r2
.align 2
bf_addr3156: .long basefunction
! Opcodes 4E90 - 4E97
OE90:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr3158,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3159
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3159:
jmp @r4
mov r0,r2
.align 2
bf_addr3158: .long basefunction
! Opcodes 4EA8 - 4EAF
OEA8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr3160,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3161
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3161:
jmp @r4
mov r0,r2
.align 2
bf_addr3160: .long basefunction
! Opcodes 4EB0 - 4EB7
OEB0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr3162,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3163
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3163:
jmp @r4
mov r0,r2
.align 2
bf_addr3162: .long basefunction
! Opcode 4EB8
OEB8:
mov.l r3,@-r15
mov.w @r6+,r4
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr3164,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3165
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3165:
jmp @r4
mov r0,r2
.align 2
bf_addr3164: .long basefunction
! Opcode 4EB9
OEB9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr3166,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3167
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3167:
jmp @r4
mov r0,r2
.align 2
bf_addr3166: .long basefunction
! Opcode 4EBA
OEBA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr3168,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3169
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3169:
jmp @r4
mov r0,r2
.align 2
bf_addr3168: .long basefunction
! Opcode 4EBB
OEBB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov r6,r3
sub r5,r3
mov r4,r6
mov.l bf_addr3170,r0
jsr @r0
nop
add r5,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3171
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3171:
jmp @r4
mov r0,r2
.align 2
bf_addr3170: .long basefunction
! Opcodes 4ED0 - 4ED7
OED0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov r4,r6
mov.l bf_addr3172,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3173
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3173:
jmp @r4
mov r0,r2
.align 2
bf_addr3172: .long basefunction
! Opcodes 4EE8 - 4EEF
OEE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov r4,r6
mov.l bf_addr3174,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3175
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3175:
jmp @r4
mov r0,r2
.align 2
bf_addr3174: .long basefunction
! Opcodes 4EF0 - 4EF7
OEF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov r4,r6
mov.l bf_addr3176,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3177
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3177:
jmp @r4
mov r0,r2
.align 2
bf_addr3176: .long basefunction
! Opcode 4EF8
OEF8:
mov.w @r6+,r4
mov r4,r6
mov.l bf_addr3178,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3179
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3179:
jmp @r4
mov r0,r2
.align 2
bf_addr3178: .long basefunction
! Opcode 4EF9
OEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov r4,r6
mov.l bf_addr3180,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3181
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3181:
jmp @r4
mov r0,r2
.align 2
bf_addr3180: .long basefunction
! Opcode 4EFA
OEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov r4,r6
mov.l bf_addr3182,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3183
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3183:
jmp @r4
mov r0,r2
.align 2
bf_addr3182: .long basefunction
! Opcode 4EFB
OEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov r4,r6
mov.l bf_addr3184,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3185
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3185:
jmp @r4
mov r0,r2
.align 2
bf_addr3184: .long basefunction
! Opcodes 4F80 - 4F87
OF80:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3186
mov #0,r8
cmp/hi r3,r1
bt ln3186
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3187
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3187:
jmp @r4
mov r0,r2
.align 5
setn3186:
mov #1,r8
ln3186:
mov.l r1,@-r15
mov.l g2_except_ptr3186,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3186,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3188
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3188:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3186: .long group_2_exception
bf_addr3186: .long basefunction
! Opcodes 4F90 - 4F97
OF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3189
mov #0,r8
cmp/hi r3,r1
bt ln3189
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3190
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3190:
jmp @r4
mov r0,r2
.align 5
setn3189:
mov #1,r8
ln3189:
mov.l r1,@-r15
mov.l g2_except_ptr3189,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3189,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3191
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3191:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3189: .long group_2_exception
bf_addr3189: .long basefunction
! Opcodes 4F98 - 4F9F
OF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3192
mov #0,r8
cmp/hi r3,r1
bt ln3192
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3193
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3193:
jmp @r4
mov r0,r2
.align 5
setn3192:
mov #1,r8
ln3192:
mov.l r1,@-r15
mov.l g2_except_ptr3192,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3192,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3194
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3194:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3192: .long group_2_exception
bf_addr3192: .long basefunction
! Opcodes 4FA0 - 4FA7
OFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3195
mov #0,r8
cmp/hi r3,r1
bt ln3195
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3196
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3196:
jmp @r4
mov r0,r2
.align 5
setn3195:
mov #1,r8
ln3195:
mov.l r1,@-r15
mov.l g2_except_ptr3195,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3195,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-56,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3197
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3197:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3195: .long group_2_exception
bf_addr3195: .long basefunction
! Opcodes 4FA8 - 4FAF
OFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3198
mov #0,r8
cmp/hi r3,r1
bt ln3198
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3199
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3199:
jmp @r4
mov r0,r2
.align 5
setn3198:
mov #1,r8
ln3198:
mov.l r1,@-r15
mov.l g2_except_ptr3198,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3198,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3200
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3200:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3198: .long group_2_exception
bf_addr3198: .long basefunction
! Opcodes 4FB0 - 4FB7
OFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3201
mov #0,r8
cmp/hi r3,r1
bt ln3201
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3202
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3202:
jmp @r4
mov r0,r2
.align 5
setn3201:
mov #1,r8
ln3201:
mov.l r1,@-r15
mov.l g2_except_ptr3201,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3201,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3203
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3203:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3201: .long group_2_exception
bf_addr3201: .long basefunction
! Opcode 4FB8
OFB8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3204
mov #0,r8
cmp/hi r3,r1
bt ln3204
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3205
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3205:
jmp @r4
mov r0,r2
.align 5
setn3204:
mov #1,r8
ln3204:
mov.l r1,@-r15
mov.l g2_except_ptr3204,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3204,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3206
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3206:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3204: .long group_2_exception
bf_addr3204: .long basefunction
! Opcode 4FB9
OFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3207
mov #0,r8
cmp/hi r3,r1
bt ln3207
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3208
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3208:
jmp @r4
mov r0,r2
.align 5
setn3207:
mov #1,r8
ln3207:
mov.l r1,@-r15
mov.l g2_except_ptr3207,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3207,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-62,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3209
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3209:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3207: .long group_2_exception
bf_addr3207: .long basefunction
! Opcode 4FBA
OFBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3210
mov #0,r8
cmp/hi r3,r1
bt ln3210
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3211
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3211:
jmp @r4
mov r0,r2
.align 5
setn3210:
mov #1,r8
ln3210:
mov.l r1,@-r15
mov.l g2_except_ptr3210,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3210,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-58,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3212
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3212:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3210: .long group_2_exception
bf_addr3210: .long basefunction
! Opcode 4FBB
OFBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3213
mov #0,r8
cmp/hi r3,r1
bt ln3213
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3214
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3214:
jmp @r4
mov r0,r2
.align 5
setn3213:
mov #1,r8
ln3213:
mov.l r1,@-r15
mov.l g2_except_ptr3213,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3213,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-60,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3215
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3215:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3213: .long group_2_exception
bf_addr3213: .long basefunction
! Opcode 4FBC
OFBC:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
extu.w r1,r1
cmp/pz r1
bf setn3216
mov #0,r8
cmp/hi r3,r1
bt ln3216
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3217
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3217:
jmp @r4
mov r0,r2
.align 5
setn3216:
mov #1,r8
ln3216:
mov.l r1,@-r15
mov.l g2_except_ptr3216,r0
jsr @r0
mov #0x18,r4
mov.l @r15+,r3
mov.l bf_addr3216,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-54,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3218
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3218:
jmp @r4
mov r0,r2
.align 2
g2_except_ptr3216: .long group_2_exception
bf_addr3216: .long basefunction
! Opcodes 4FD0 - 4FD7
OFD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l r4,@(60,r13)
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3219
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3219:
jmp @r4
mov r0,r2
! Opcodes 4FE8 - 4FEF
OFE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(60,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3220
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3220:
jmp @r4
mov r0,r2
! Opcodes 4FF0 - 4FF7
OFF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l r4,@(60,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3221
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3221:
jmp @r4
mov r0,r2
! Opcode 4FF8
OFF8:
mov.w @r6+,r4
mov.l r4,@(60,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3222
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3222:
jmp @r4
mov r0,r2
! Opcode 4FF9
OFF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l r4,@(60,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3223
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3223:
jmp @r4
mov r0,r2
! Opcode 4FFA
OFFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l r4,@(60,r13)
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3224
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3224:
jmp @r4
mov r0,r2
! Opcode 4FFB
OFFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l r4,@(60,r13)
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3225
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3225:
jmp @r4
mov r0,r2
! Opcodes 5000 - 5007
P000:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3226
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3226:
jmp @r4
mov r0,r2
! Opcodes 5008 - 500F
P008:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3227
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3227:
jmp @r4
mov r0,r2
! Opcodes 5010 - 5017
P010:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3228
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3228:
jmp @r4
mov r0,r2
! Opcodes 5018 - 501F
P018:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3229
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3229:
jmp @r4
mov r0,r2
! Opcodes 5020 - 5027
P020:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3230
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3230:
jmp @r4
mov r0,r2
! Opcodes 5028 - 502F
P028:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3231
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3231:
jmp @r4
mov r0,r2
! Opcodes 5030 - 5037
P030:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3232
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3232:
jmp @r4
mov r0,r2
! Opcode 5038
P038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3233
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3233:
jmp @r4
mov r0,r2
! Opcode 5039
P039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3234
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3234:
jmp @r4
mov r0,r2
! Opcodes 5040 - 5047
P040:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3235
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3235:
jmp @r4
mov r0,r2
! Opcodes 5048 - 504F
P048:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 8,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3236
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3236:
jmp @r4
mov r0,r2
! Opcodes 5050 - 5057
P050:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3237
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3237:
jmp @r4
mov r0,r2
! Opcodes 5058 - 505F
P058:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3238
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3238:
jmp @r4
mov r0,r2
! Opcodes 5060 - 5067
P060:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3239
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3239:
jmp @r4
mov r0,r2
! Opcodes 5068 - 506F
P068:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3240
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3240:
jmp @r4
mov r0,r2
! Opcodes 5070 - 5077
P070:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3241
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3241:
jmp @r4
mov r0,r2
! Opcode 5078
P078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3242
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3242:
jmp @r4
mov r0,r2
! Opcode 5079
P079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3243
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3243:
jmp @r4
mov r0,r2
! Opcodes 5080 - 5087
P080:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #8,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3244
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3244:
jmp @r4
mov r0,r2
! Opcodes 5088 - 508F
P088:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 8,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3245
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3245:
jmp @r4
mov r0,r2
! Opcodes 5090 - 5097
P090:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3246
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3246:
jmp @r4
mov r0,r2
! Opcodes 5098 - 509F
P098:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3247
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3247:
jmp @r4
mov r0,r2
! Opcodes 50A0 - 50A7
P0A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3248
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3248:
jmp @r4
mov r0,r2
! Opcodes 50A8 - 50AF
P0A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3249
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3249:
jmp @r4
mov r0,r2
! Opcodes 50B0 - 50B7
P0B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3250
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3250:
jmp @r4
mov r0,r2
! Opcode 50B8
P0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3251
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3251:
jmp @r4
mov r0,r2
! Opcode 50B9
P0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3252
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3252:
jmp @r4
mov r0,r2
! Opcodes 50C0 - 50C7
P0C0:
and r1,r2
mov.l r3,@-r15
mov #255,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3253
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3253:
jmp @r4
mov r0,r2
! Opcodes 50C8 - 50CF
P0C8:
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3254
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3254:
jmp @r4
mov r0,r2
! Opcodes 50D0 - 50D7
P0D0:
and r1,r2
mov.l r3,@-r15
mov #255,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3255
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3255:
jmp @r4
mov r0,r2
! Opcodes 50D8 - 50DF
P0D8:
and r1,r2
mov.l r3,@-r15
mov #255,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3256
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3256:
jmp @r4
mov r0,r2
! Opcodes 50E0 - 50E7
P0E0:
and r1,r2
mov.l r3,@-r15
mov #255,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3257
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3257:
jmp @r4
mov r0,r2
! Opcodes 50E8 - 50EF
P0E8:
and r1,r2
mov.l r3,@-r15
mov #255,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3258
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3258:
jmp @r4
mov r0,r2
! Opcodes 50F0 - 50F7
P0F0:
and r1,r2
mov.l r3,@-r15
mov #255,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3259
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3259:
jmp @r4
mov r0,r2
! Opcode 50F8
P0F8:
mov.l r3,@-r15
mov #255,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3260
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3260:
jmp @r4
mov r0,r2
! Opcode 50F9
P0F9:
mov.l r3,@-r15
mov #255,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3261
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3261:
jmp @r4
mov r0,r2
! Opcodes 5100 - 5107
P100:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3262
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3262:
jmp @r4
mov r0,r2
! Opcodes 5108 - 510F
P108:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3263
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3263:
jmp @r4
mov r0,r2
! Opcodes 5110 - 5117
P110:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3264
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3264:
jmp @r4
mov r0,r2
! Opcodes 5118 - 511F
P118:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3265
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3265:
jmp @r4
mov r0,r2
! Opcodes 5120 - 5127
P120:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3266
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3266:
jmp @r4
mov r0,r2
! Opcodes 5128 - 512F
P128:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3267
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3267:
jmp @r4
mov r0,r2
! Opcodes 5130 - 5137
P130:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3268
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3268:
jmp @r4
mov r0,r2
! Opcode 5138
P138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3269
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3269:
jmp @r4
mov r0,r2
! Opcode 5139
P139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #8,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3270
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3270:
jmp @r4
mov r0,r2
! Opcodes 5140 - 5147
P140:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3271
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3271:
jmp @r4
mov r0,r2
! Opcodes 5148 - 514F
P148:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-8,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3272
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3272:
jmp @r4
mov r0,r2
! Opcodes 5150 - 5157
P150:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3273
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3273:
jmp @r4
mov r0,r2
! Opcodes 5158 - 515F
P158:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3274
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3274:
jmp @r4
mov r0,r2
! Opcodes 5160 - 5167
P160:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3275
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3275:
jmp @r4
mov r0,r2
! Opcodes 5168 - 516F
P168:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3276
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3276:
jmp @r4
mov r0,r2
! Opcodes 5170 - 5177
P170:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3277
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3277:
jmp @r4
mov r0,r2
! Opcode 5178
P178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3278
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3278:
jmp @r4
mov r0,r2
! Opcode 5179
P179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #8,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3279
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3279:
jmp @r4
mov r0,r2
! Opcodes 5180 - 5187
P180:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #8,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3280
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3280:
jmp @r4
mov r0,r2
! Opcodes 5188 - 518F
P188:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-8,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3281
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3281:
jmp @r4
mov r0,r2
! Opcodes 5190 - 5197
P190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3282
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3282:
jmp @r4
mov r0,r2
! Opcodes 5198 - 519F
P198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3283
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3283:
jmp @r4
mov r0,r2
! Opcodes 51A0 - 51A7
P1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3284
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3284:
jmp @r4
mov r0,r2
! Opcodes 51A8 - 51AF
P1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3285
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3285:
jmp @r4
mov r0,r2
! Opcodes 51B0 - 51B7
P1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3286
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3286:
jmp @r4
mov r0,r2
! Opcode 51B8
P1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3287
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3287:
jmp @r4
mov r0,r2
! Opcode 51B9
P1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3288
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3288:
jmp @r4
mov r0,r2
! Opcodes 51C0 - 51C7
P1C0:
and r1,r2
mov.l r3,@-r15
mov #0,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3289
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3289:
jmp @r4
mov r0,r2
! Opcodes 51C8 - 51CF
P1C8:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3290
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3291
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3291:
jmp @r4
mov r0,r2
.align 5
bcc_w3290:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3292
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3292:
jmp @r4
mov r0,r2
! Opcodes 51D0 - 51D7
P1D0:
and r1,r2
mov.l r3,@-r15
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3293
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3293:
jmp @r4
mov r0,r2
! Opcodes 51D8 - 51DF
P1D8:
and r1,r2
mov.l r3,@-r15
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3294
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3294:
jmp @r4
mov r0,r2
! Opcodes 51E0 - 51E7
P1E0:
and r1,r2
mov.l r3,@-r15
mov #0,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3295
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3295:
jmp @r4
mov r0,r2
! Opcodes 51E8 - 51EF
P1E8:
and r1,r2
mov.l r3,@-r15
mov #0,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3296
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3296:
jmp @r4
mov r0,r2
! Opcodes 51F0 - 51F7
P1F0:
and r1,r2
mov.l r3,@-r15
mov #0,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3297
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3297:
jmp @r4
mov r0,r2
! Opcode 51F8
P1F8:
mov.l r3,@-r15
mov #0,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3298
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3298:
jmp @r4
mov r0,r2
! Opcode 51F9
P1F9:
mov.l r3,@-r15
mov #0,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3299
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3299:
jmp @r4
mov r0,r2
! Opcodes 5200 - 5207
P200:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3300
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3300:
jmp @r4
mov r0,r2
! Opcodes 5208 - 520F
P208:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3301
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3301:
jmp @r4
mov r0,r2
! Opcodes 5210 - 5217
P210:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3302
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3302:
jmp @r4
mov r0,r2
! Opcodes 5218 - 521F
P218:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3303
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3303:
jmp @r4
mov r0,r2
! Opcodes 5220 - 5227
P220:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3304
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3304:
jmp @r4
mov r0,r2
! Opcodes 5228 - 522F
P228:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3305
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3305:
jmp @r4
mov r0,r2
! Opcodes 5230 - 5237
P230:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3306
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3306:
jmp @r4
mov r0,r2
! Opcode 5238
P238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3307
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3307:
jmp @r4
mov r0,r2
! Opcode 5239
P239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3308
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3308:
jmp @r4
mov r0,r2
! Opcodes 5240 - 5247
P240:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3309
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3309:
jmp @r4
mov r0,r2
! Opcodes 5248 - 524F
P248:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 1,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3310
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3310:
jmp @r4
mov r0,r2
! Opcodes 5250 - 5257
P250:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3311
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3311:
jmp @r4
mov r0,r2
! Opcodes 5258 - 525F
P258:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3312
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3312:
jmp @r4
mov r0,r2
! Opcodes 5260 - 5267
P260:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3313
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3313:
jmp @r4
mov r0,r2
! Opcodes 5268 - 526F
P268:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3314
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3314:
jmp @r4
mov r0,r2
! Opcodes 5270 - 5277
P270:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3315
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3315:
jmp @r4
mov r0,r2
! Opcode 5278
P278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3316
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3316:
jmp @r4
mov r0,r2
! Opcode 5279
P279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3317
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3317:
jmp @r4
mov r0,r2
! Opcodes 5280 - 5287
P280:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3318
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3318:
jmp @r4
mov r0,r2
! Opcodes 5288 - 528F
P288:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 1,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3319
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3319:
jmp @r4
mov r0,r2
! Opcodes 5290 - 5297
P290:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3320
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3320:
jmp @r4
mov r0,r2
! Opcodes 5298 - 529F
P298:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3321
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3321:
jmp @r4
mov r0,r2
! Opcodes 52A0 - 52A7
P2A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3322
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3322:
jmp @r4
mov r0,r2
! Opcodes 52A8 - 52AF
P2A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3323
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3323:
jmp @r4
mov r0,r2
! Opcodes 52B0 - 52B7
P2B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3324
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3324:
jmp @r4
mov r0,r2
! Opcode 52B8
P2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3325
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3325:
jmp @r4
mov r0,r2
! Opcode 52B9
P2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3326
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3326:
jmp @r4
mov r0,r2
! Opcodes 52C0 - 52C7
P2C0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3327
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3327:
jmp @r4
mov r0,r2
! Opcodes 52C8 - 52CF
P2C8:
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
bf dbcc3328
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3329
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3329:
jmp @r4
mov r0,r2
.align 5
dbcc3328:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3330
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3331
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3331:
jmp @r4
mov r0,r2
.align 5
bcc_w3330:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3332
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3332:
jmp @r4
mov r0,r2
! Opcodes 52D0 - 52D7
P2D0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3333
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3333:
jmp @r4
mov r0,r2
! Opcodes 52D8 - 52DF
P2D8:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3334
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3334:
jmp @r4
mov r0,r2
! Opcodes 52E0 - 52E7
P2E0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3335
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3335:
jmp @r4
mov r0,r2
! Opcodes 52E8 - 52EF
P2E8:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3336
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3336:
jmp @r4
mov r0,r2
! Opcodes 52F0 - 52F7
P2F0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3337
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3337:
jmp @r4
mov r0,r2
! Opcode 52F8
P2F8:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3338
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3338:
jmp @r4
mov r0,r2
! Opcode 52F9
P2F9:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3339
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3339:
jmp @r4
mov r0,r2
! Opcodes 5300 - 5307
P300:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3340
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3340:
jmp @r4
mov r0,r2
! Opcodes 5308 - 530F
P308:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3341
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3341:
jmp @r4
mov r0,r2
! Opcodes 5310 - 5317
P310:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3342
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3342:
jmp @r4
mov r0,r2
! Opcodes 5318 - 531F
P318:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3343
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3343:
jmp @r4
mov r0,r2
! Opcodes 5320 - 5327
P320:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3344
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3344:
jmp @r4
mov r0,r2
! Opcodes 5328 - 532F
P328:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3345
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3345:
jmp @r4
mov r0,r2
! Opcodes 5330 - 5337
P330:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3346
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3346:
jmp @r4
mov r0,r2
! Opcode 5338
P338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3347
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3347:
jmp @r4
mov r0,r2
! Opcode 5339
P339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #1,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3348
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3348:
jmp @r4
mov r0,r2
! Opcodes 5340 - 5347
P340:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3349
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3349:
jmp @r4
mov r0,r2
! Opcodes 5348 - 534F
P348:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-1,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3350
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3350:
jmp @r4
mov r0,r2
! Opcodes 5350 - 5357
P350:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3351
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3351:
jmp @r4
mov r0,r2
! Opcodes 5358 - 535F
P358:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3352
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3352:
jmp @r4
mov r0,r2
! Opcodes 5360 - 5367
P360:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3353
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3353:
jmp @r4
mov r0,r2
! Opcodes 5368 - 536F
P368:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3354
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3354:
jmp @r4
mov r0,r2
! Opcodes 5370 - 5377
P370:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3355
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3355:
jmp @r4
mov r0,r2
! Opcode 5378
P378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3356
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3356:
jmp @r4
mov r0,r2
! Opcode 5379
P379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #1,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3357
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3357:
jmp @r4
mov r0,r2
! Opcodes 5380 - 5387
P380:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3358
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3358:
jmp @r4
mov r0,r2
! Opcodes 5388 - 538F
P388:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-1,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3359
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3359:
jmp @r4
mov r0,r2
! Opcodes 5390 - 5397
P390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3360
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3360:
jmp @r4
mov r0,r2
! Opcodes 5398 - 539F
P398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3361
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3361:
jmp @r4
mov r0,r2
! Opcodes 53A0 - 53A7
P3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3362
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3362:
jmp @r4
mov r0,r2
! Opcodes 53A8 - 53AF
P3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3363
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3363:
jmp @r4
mov r0,r2
! Opcodes 53B0 - 53B7
P3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3364
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3364:
jmp @r4
mov r0,r2
! Opcode 53B8
P3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3365
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3365:
jmp @r4
mov r0,r2
! Opcode 53B9
P3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3366
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3366:
jmp @r4
mov r0,r2
! Opcodes 53C0 - 53C7
P3C0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
tst r3,r3
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3367
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3367:
jmp @r4
mov r0,r2
! Opcodes 53C8 - 53CF
P3C8:
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
bt dbcc3368
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3369
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3369:
jmp @r4
mov r0,r2
.align 5
dbcc3368:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3370
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3371
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3371:
jmp @r4
mov r0,r2
.align 5
bcc_w3370:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3372
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3372:
jmp @r4
mov r0,r2
! Opcodes 53D0 - 53D7
P3D0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3373
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3373:
jmp @r4
mov r0,r2
! Opcodes 53D8 - 53DF
P3D8:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3374
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3374:
jmp @r4
mov r0,r2
! Opcodes 53E0 - 53E7
P3E0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3375
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3375:
jmp @r4
mov r0,r2
! Opcodes 53E8 - 53EF
P3E8:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3376
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3376:
jmp @r4
mov r0,r2
! Opcodes 53F0 - 53F7
P3F0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3377
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3377:
jmp @r4
mov r0,r2
! Opcode 53F8
P3F8:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3378
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3378:
jmp @r4
mov r0,r2
! Opcode 53F9
P3F9:
mov.l r3,@-r15
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3379
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3379:
jmp @r4
mov r0,r2
! Opcodes 5400 - 5407
P400:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3380
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3380:
jmp @r4
mov r0,r2
! Opcodes 5408 - 540F
P408:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3381
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3381:
jmp @r4
mov r0,r2
! Opcodes 5410 - 5417
P410:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3382
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3382:
jmp @r4
mov r0,r2
! Opcodes 5418 - 541F
P418:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3383
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3383:
jmp @r4
mov r0,r2
! Opcodes 5420 - 5427
P420:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3384
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3384:
jmp @r4
mov r0,r2
! Opcodes 5428 - 542F
P428:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3385
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3385:
jmp @r4
mov r0,r2
! Opcodes 5430 - 5437
P430:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3386
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3386:
jmp @r4
mov r0,r2
! Opcode 5438
P438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3387
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3387:
jmp @r4
mov r0,r2
! Opcode 5439
P439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3388
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3388:
jmp @r4
mov r0,r2
! Opcodes 5440 - 5447
P440:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3389
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3389:
jmp @r4
mov r0,r2
! Opcodes 5448 - 544F
P448:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 2,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3390
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3390:
jmp @r4
mov r0,r2
! Opcodes 5450 - 5457
P450:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3391
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3391:
jmp @r4
mov r0,r2
! Opcodes 5458 - 545F
P458:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3392
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3392:
jmp @r4
mov r0,r2
! Opcodes 5460 - 5467
P460:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3393
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3393:
jmp @r4
mov r0,r2
! Opcodes 5468 - 546F
P468:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3394
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3394:
jmp @r4
mov r0,r2
! Opcodes 5470 - 5477
P470:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3395
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3395:
jmp @r4
mov r0,r2
! Opcode 5478
P478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3396
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3396:
jmp @r4
mov r0,r2
! Opcode 5479
P479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3397
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3397:
jmp @r4
mov r0,r2
! Opcodes 5480 - 5487
P480:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #2,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3398
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3398:
jmp @r4
mov r0,r2
! Opcodes 5488 - 548F
P488:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 2,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3399
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3399:
jmp @r4
mov r0,r2
! Opcodes 5490 - 5497
P490:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3400
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3400:
jmp @r4
mov r0,r2
! Opcodes 5498 - 549F
P498:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3401
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3401:
jmp @r4
mov r0,r2
! Opcodes 54A0 - 54A7
P4A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3402
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3402:
jmp @r4
mov r0,r2
! Opcodes 54A8 - 54AF
P4A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3403
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3403:
jmp @r4
mov r0,r2
! Opcodes 54B0 - 54B7
P4B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3404
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3404:
jmp @r4
mov r0,r2
! Opcode 54B8
P4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3405
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3405:
jmp @r4
mov r0,r2
! Opcode 54B9
P4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3406
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3406:
jmp @r4
mov r0,r2
! Opcodes 54C0 - 54C7
P4C0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3407
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3407:
jmp @r4
mov r0,r2
! Opcodes 54C8 - 54CF
P4C8:
mov r8,r0
tst #2,r0
bf dbcc3408
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3409
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3409:
jmp @r4
mov r0,r2
.align 5
dbcc3408:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3410
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3411
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3411:
jmp @r4
mov r0,r2
.align 5
bcc_w3410:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3412
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3412:
jmp @r4
mov r0,r2
! Opcodes 54D0 - 54D7
P4D0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3413
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3413:
jmp @r4
mov r0,r2
! Opcodes 54D8 - 54DF
P4D8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3414
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3414:
jmp @r4
mov r0,r2
! Opcodes 54E0 - 54E7
P4E0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3415
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3415:
jmp @r4
mov r0,r2
! Opcodes 54E8 - 54EF
P4E8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3416
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3416:
jmp @r4
mov r0,r2
! Opcodes 54F0 - 54F7
P4F0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3417
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3417:
jmp @r4
mov r0,r2
! Opcode 54F8
P4F8:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3418
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3418:
jmp @r4
mov r0,r2
! Opcode 54F9
P4F9:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3419
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3419:
jmp @r4
mov r0,r2
! Opcodes 5500 - 5507
P500:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3420
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3420:
jmp @r4
mov r0,r2
! Opcodes 5508 - 550F
P508:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3421
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3421:
jmp @r4
mov r0,r2
! Opcodes 5510 - 5517
P510:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3422
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3422:
jmp @r4
mov r0,r2
! Opcodes 5518 - 551F
P518:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3423
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3423:
jmp @r4
mov r0,r2
! Opcodes 5520 - 5527
P520:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3424
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3424:
jmp @r4
mov r0,r2
! Opcodes 5528 - 552F
P528:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3425
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3425:
jmp @r4
mov r0,r2
! Opcodes 5530 - 5537
P530:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3426
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3426:
jmp @r4
mov r0,r2
! Opcode 5538
P538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3427
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3427:
jmp @r4
mov r0,r2
! Opcode 5539
P539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #2,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3428
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3428:
jmp @r4
mov r0,r2
! Opcodes 5540 - 5547
P540:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3429
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3429:
jmp @r4
mov r0,r2
! Opcodes 5548 - 554F
P548:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-2,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3430
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3430:
jmp @r4
mov r0,r2
! Opcodes 5550 - 5557
P550:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3431
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3431:
jmp @r4
mov r0,r2
! Opcodes 5558 - 555F
P558:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3432
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3432:
jmp @r4
mov r0,r2
! Opcodes 5560 - 5567
P560:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3433
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3433:
jmp @r4
mov r0,r2
! Opcodes 5568 - 556F
P568:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3434
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3434:
jmp @r4
mov r0,r2
! Opcodes 5570 - 5577
P570:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3435
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3435:
jmp @r4
mov r0,r2
! Opcode 5578
P578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3436
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3436:
jmp @r4
mov r0,r2
! Opcode 5579
P579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #2,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3437
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3437:
jmp @r4
mov r0,r2
! Opcodes 5580 - 5587
P580:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #2,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3438
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3438:
jmp @r4
mov r0,r2
! Opcodes 5588 - 558F
P588:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-2,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3439
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3439:
jmp @r4
mov r0,r2
! Opcodes 5590 - 5597
P590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3440
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3440:
jmp @r4
mov r0,r2
! Opcodes 5598 - 559F
P598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3441
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3441:
jmp @r4
mov r0,r2
! Opcodes 55A0 - 55A7
P5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3442
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3442:
jmp @r4
mov r0,r2
! Opcodes 55A8 - 55AF
P5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3443
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3443:
jmp @r4
mov r0,r2
! Opcodes 55B0 - 55B7
P5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3444
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3444:
jmp @r4
mov r0,r2
! Opcode 55B8
P5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3445
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3445:
jmp @r4
mov r0,r2
! Opcode 55B9
P5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #2,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3446
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3446:
jmp @r4
mov r0,r2
! Opcodes 55C0 - 55C7
P5C0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
tst r3,r3
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3447
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3447:
jmp @r4
mov r0,r2
! Opcodes 55C8 - 55CF
P5C8:
mov r8,r0
tst #2,r0
bt dbcc3448
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3449
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3449:
jmp @r4
mov r0,r2
.align 5
dbcc3448:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3450
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3451
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3451:
jmp @r4
mov r0,r2
.align 5
bcc_w3450:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3452
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3452:
jmp @r4
mov r0,r2
! Opcodes 55D0 - 55D7
P5D0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3453
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3453:
jmp @r4
mov r0,r2
! Opcodes 55D8 - 55DF
P5D8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3454
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3454:
jmp @r4
mov r0,r2
! Opcodes 55E0 - 55E7
P5E0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3455
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3455:
jmp @r4
mov r0,r2
! Opcodes 55E8 - 55EF
P5E8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3456
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3456:
jmp @r4
mov r0,r2
! Opcodes 55F0 - 55F7
P5F0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3457
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3457:
jmp @r4
mov r0,r2
! Opcode 55F8
P5F8:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3458
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3458:
jmp @r4
mov r0,r2
! Opcode 55F9
P5F9:
mov.l r3,@-r15
mov r8,r0
tst #2,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3459
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3459:
jmp @r4
mov r0,r2
! Opcodes 5600 - 5607
P600:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3460
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3460:
jmp @r4
mov r0,r2
! Opcodes 5608 - 560F
P608:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3461
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3461:
jmp @r4
mov r0,r2
! Opcodes 5610 - 5617
P610:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3462
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3462:
jmp @r4
mov r0,r2
! Opcodes 5618 - 561F
P618:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3463
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3463:
jmp @r4
mov r0,r2
! Opcodes 5620 - 5627
P620:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3464
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3464:
jmp @r4
mov r0,r2
! Opcodes 5628 - 562F
P628:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3465
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3465:
jmp @r4
mov r0,r2
! Opcodes 5630 - 5637
P630:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3466
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3466:
jmp @r4
mov r0,r2
! Opcode 5638
P638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3467
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3467:
jmp @r4
mov r0,r2
! Opcode 5639
P639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3468
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3468:
jmp @r4
mov r0,r2
! Opcodes 5640 - 5647
P640:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3469
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3469:
jmp @r4
mov r0,r2
! Opcodes 5648 - 564F
P648:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 3,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3470
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3470:
jmp @r4
mov r0,r2
! Opcodes 5650 - 5657
P650:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3471
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3471:
jmp @r4
mov r0,r2
! Opcodes 5658 - 565F
P658:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3472
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3472:
jmp @r4
mov r0,r2
! Opcodes 5660 - 5667
P660:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3473
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3473:
jmp @r4
mov r0,r2
! Opcodes 5668 - 566F
P668:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3474
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3474:
jmp @r4
mov r0,r2
! Opcodes 5670 - 5677
P670:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3475
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3475:
jmp @r4
mov r0,r2
! Opcode 5678
P678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3476
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3476:
jmp @r4
mov r0,r2
! Opcode 5679
P679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3477
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3477:
jmp @r4
mov r0,r2
! Opcodes 5680 - 5687
P680:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #3,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3478
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3478:
jmp @r4
mov r0,r2
! Opcodes 5688 - 568F
P688:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 3,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3479
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3479:
jmp @r4
mov r0,r2
! Opcodes 5690 - 5697
P690:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3480
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3480:
jmp @r4
mov r0,r2
! Opcodes 5698 - 569F
P698:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3481
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3481:
jmp @r4
mov r0,r2
! Opcodes 56A0 - 56A7
P6A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3482
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3482:
jmp @r4
mov r0,r2
! Opcodes 56A8 - 56AF
P6A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3483
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3483:
jmp @r4
mov r0,r2
! Opcodes 56B0 - 56B7
P6B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3484
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3484:
jmp @r4
mov r0,r2
! Opcode 56B8
P6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3485
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3485:
jmp @r4
mov r0,r2
! Opcode 56B9
P6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3486
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3486:
jmp @r4
mov r0,r2
! Opcodes 56C0 - 56C7
P6C0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
tst r3,r3
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3487
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3487:
jmp @r4
mov r0,r2
! Opcodes 56C8 - 56CF
P6C8:
tst r3,r3
bt dbcc3488
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3489
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3489:
jmp @r4
mov r0,r2
.align 5
dbcc3488:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3490
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3491
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3491:
jmp @r4
mov r0,r2
.align 5
bcc_w3490:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3492
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3492:
jmp @r4
mov r0,r2
! Opcodes 56D0 - 56D7
P6D0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3493
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3493:
jmp @r4
mov r0,r2
! Opcodes 56D8 - 56DF
P6D8:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3494
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3494:
jmp @r4
mov r0,r2
! Opcodes 56E0 - 56E7
P6E0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3495
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3495:
jmp @r4
mov r0,r2
! Opcodes 56E8 - 56EF
P6E8:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3496
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3496:
jmp @r4
mov r0,r2
! Opcodes 56F0 - 56F7
P6F0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3497
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3497:
jmp @r4
mov r0,r2
! Opcode 56F8
P6F8:
mov.l r3,@-r15
tst r3,r3
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3498
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3498:
jmp @r4
mov r0,r2
! Opcode 56F9
P6F9:
mov.l r3,@-r15
tst r3,r3
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3499
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3499:
jmp @r4
mov r0,r2
! Opcodes 5700 - 5707
P700:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3500
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3500:
jmp @r4
mov r0,r2
! Opcodes 5708 - 570F
P708:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3501
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3501:
jmp @r4
mov r0,r2
! Opcodes 5710 - 5717
P710:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3502
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3502:
jmp @r4
mov r0,r2
! Opcodes 5718 - 571F
P718:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3503
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3503:
jmp @r4
mov r0,r2
! Opcodes 5720 - 5727
P720:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3504
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3504:
jmp @r4
mov r0,r2
! Opcodes 5728 - 572F
P728:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3505
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3505:
jmp @r4
mov r0,r2
! Opcodes 5730 - 5737
P730:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3506
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3506:
jmp @r4
mov r0,r2
! Opcode 5738
P738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3507
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3507:
jmp @r4
mov r0,r2
! Opcode 5739
P739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #3,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3508
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3508:
jmp @r4
mov r0,r2
! Opcodes 5740 - 5747
P740:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3509
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3509:
jmp @r4
mov r0,r2
! Opcodes 5748 - 574F
P748:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-3,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3510
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3510:
jmp @r4
mov r0,r2
! Opcodes 5750 - 5757
P750:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3511
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3511:
jmp @r4
mov r0,r2
! Opcodes 5758 - 575F
P758:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3512
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3512:
jmp @r4
mov r0,r2
! Opcodes 5760 - 5767
P760:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3513
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3513:
jmp @r4
mov r0,r2
! Opcodes 5768 - 576F
P768:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3514
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3514:
jmp @r4
mov r0,r2
! Opcodes 5770 - 5777
P770:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3515
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3515:
jmp @r4
mov r0,r2
! Opcode 5778
P778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3516
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3516:
jmp @r4
mov r0,r2
! Opcode 5779
P779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #3,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3517
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3517:
jmp @r4
mov r0,r2
! Opcodes 5780 - 5787
P780:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #3,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3518
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3518:
jmp @r4
mov r0,r2
! Opcodes 5788 - 578F
P788:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-3,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3519
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3519:
jmp @r4
mov r0,r2
! Opcodes 5790 - 5797
P790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3520
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3520:
jmp @r4
mov r0,r2
! Opcodes 5798 - 579F
P798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3521
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3521:
jmp @r4
mov r0,r2
! Opcodes 57A0 - 57A7
P7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3522
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3522:
jmp @r4
mov r0,r2
! Opcodes 57A8 - 57AF
P7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3523
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3523:
jmp @r4
mov r0,r2
! Opcodes 57B0 - 57B7
P7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3524
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3524:
jmp @r4
mov r0,r2
! Opcode 57B8
P7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3525
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3525:
jmp @r4
mov r0,r2
! Opcode 57B9
P7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #3,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3526
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3526:
jmp @r4
mov r0,r2
! Opcodes 57C0 - 57C7
P7C0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3527
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3527:
jmp @r4
mov r0,r2
! Opcodes 57C8 - 57CF
P7C8:
tst r3,r3
bf dbcc3528
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3529
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3529:
jmp @r4
mov r0,r2
.align 5
dbcc3528:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3530
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3531
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3531:
jmp @r4
mov r0,r2
.align 5
bcc_w3530:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3532
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3532:
jmp @r4
mov r0,r2
! Opcodes 57D0 - 57D7
P7D0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3533
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3533:
jmp @r4
mov r0,r2
! Opcodes 57D8 - 57DF
P7D8:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3534
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3534:
jmp @r4
mov r0,r2
! Opcodes 57E0 - 57E7
P7E0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3535
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3535:
jmp @r4
mov r0,r2
! Opcodes 57E8 - 57EF
P7E8:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3536
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3536:
jmp @r4
mov r0,r2
! Opcodes 57F0 - 57F7
P7F0:
and r1,r2
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3537
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3537:
jmp @r4
mov r0,r2
! Opcode 57F8
P7F8:
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3538
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3538:
jmp @r4
mov r0,r2
! Opcode 57F9
P7F9:
mov.l r3,@-r15
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3539
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3539:
jmp @r4
mov r0,r2
! Opcodes 5800 - 5807
P800:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3540
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3540:
jmp @r4
mov r0,r2
! Opcodes 5808 - 580F
P808:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3541
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3541:
jmp @r4
mov r0,r2
! Opcodes 5810 - 5817
P810:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3542
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3542:
jmp @r4
mov r0,r2
! Opcodes 5818 - 581F
P818:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3543
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3543:
jmp @r4
mov r0,r2
! Opcodes 5820 - 5827
P820:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3544
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3544:
jmp @r4
mov r0,r2
! Opcodes 5828 - 582F
P828:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3545
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3545:
jmp @r4
mov r0,r2
! Opcodes 5830 - 5837
P830:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3546
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3546:
jmp @r4
mov r0,r2
! Opcode 5838
P838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3547
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3547:
jmp @r4
mov r0,r2
! Opcode 5839
P839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3548
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3548:
jmp @r4
mov r0,r2
! Opcodes 5840 - 5847
P840:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3549
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3549:
jmp @r4
mov r0,r2
! Opcodes 5848 - 584F
P848:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 4,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3550
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3550:
jmp @r4
mov r0,r2
! Opcodes 5850 - 5857
P850:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3551
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3551:
jmp @r4
mov r0,r2
! Opcodes 5858 - 585F
P858:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3552
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3552:
jmp @r4
mov r0,r2
! Opcodes 5860 - 5867
P860:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3553
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3553:
jmp @r4
mov r0,r2
! Opcodes 5868 - 586F
P868:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3554
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3554:
jmp @r4
mov r0,r2
! Opcodes 5870 - 5877
P870:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3555
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3555:
jmp @r4
mov r0,r2
! Opcode 5878
P878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3556
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3556:
jmp @r4
mov r0,r2
! Opcode 5879
P879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3557
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3557:
jmp @r4
mov r0,r2
! Opcodes 5880 - 5887
P880:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #4,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3558
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3558:
jmp @r4
mov r0,r2
! Opcodes 5888 - 588F
P888:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 4,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3559
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3559:
jmp @r4
mov r0,r2
! Opcodes 5890 - 5897
P890:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3560
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3560:
jmp @r4
mov r0,r2
! Opcodes 5898 - 589F
P898:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3561
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3561:
jmp @r4
mov r0,r2
! Opcodes 58A0 - 58A7
P8A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3562
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3562:
jmp @r4
mov r0,r2
! Opcodes 58A8 - 58AF
P8A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3563
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3563:
jmp @r4
mov r0,r2
! Opcodes 58B0 - 58B7
P8B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3564
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3564:
jmp @r4
mov r0,r2
! Opcode 58B8
P8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3565
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3565:
jmp @r4
mov r0,r2
! Opcode 58B9
P8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3566
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3566:
jmp @r4
mov r0,r2
! Opcodes 58C0 - 58C7
P8C0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3567
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3567:
jmp @r4
mov r0,r2
! Opcodes 58C8 - 58CF
P8C8:
mov r8,r0
tst #4,r0
bf dbcc3568
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3569
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3569:
jmp @r4
mov r0,r2
.align 5
dbcc3568:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3570
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3571
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3571:
jmp @r4
mov r0,r2
.align 5
bcc_w3570:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3572
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3572:
jmp @r4
mov r0,r2
! Opcodes 58D0 - 58D7
P8D0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3573
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3573:
jmp @r4
mov r0,r2
! Opcodes 58D8 - 58DF
P8D8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3574
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3574:
jmp @r4
mov r0,r2
! Opcodes 58E0 - 58E7
P8E0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3575
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3575:
jmp @r4
mov r0,r2
! Opcodes 58E8 - 58EF
P8E8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3576
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3576:
jmp @r4
mov r0,r2
! Opcodes 58F0 - 58F7
P8F0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3577
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3577:
jmp @r4
mov r0,r2
! Opcode 58F8
P8F8:
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3578
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3578:
jmp @r4
mov r0,r2
! Opcode 58F9
P8F9:
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3579
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3579:
jmp @r4
mov r0,r2
! Opcodes 5900 - 5907
P900:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3580
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3580:
jmp @r4
mov r0,r2
! Opcodes 5908 - 590F
P908:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3581
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3581:
jmp @r4
mov r0,r2
! Opcodes 5910 - 5917
P910:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3582
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3582:
jmp @r4
mov r0,r2
! Opcodes 5918 - 591F
P918:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3583
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3583:
jmp @r4
mov r0,r2
! Opcodes 5920 - 5927
P920:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3584
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3584:
jmp @r4
mov r0,r2
! Opcodes 5928 - 592F
P928:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3585
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3585:
jmp @r4
mov r0,r2
! Opcodes 5930 - 5937
P930:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3586
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3586:
jmp @r4
mov r0,r2
! Opcode 5938
P938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3587
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3587:
jmp @r4
mov r0,r2
! Opcode 5939
P939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #4,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3588
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3588:
jmp @r4
mov r0,r2
! Opcodes 5940 - 5947
P940:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3589
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3589:
jmp @r4
mov r0,r2
! Opcodes 5948 - 594F
P948:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-4,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3590
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3590:
jmp @r4
mov r0,r2
! Opcodes 5950 - 5957
P950:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3591
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3591:
jmp @r4
mov r0,r2
! Opcodes 5958 - 595F
P958:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3592
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3592:
jmp @r4
mov r0,r2
! Opcodes 5960 - 5967
P960:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3593
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3593:
jmp @r4
mov r0,r2
! Opcodes 5968 - 596F
P968:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3594
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3594:
jmp @r4
mov r0,r2
! Opcodes 5970 - 5977
P970:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3595
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3595:
jmp @r4
mov r0,r2
! Opcode 5978
P978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3596
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3596:
jmp @r4
mov r0,r2
! Opcode 5979
P979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #4,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3597
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3597:
jmp @r4
mov r0,r2
! Opcodes 5980 - 5987
P980:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #4,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3598
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3598:
jmp @r4
mov r0,r2
! Opcodes 5988 - 598F
P988:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-4,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3599
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3599:
jmp @r4
mov r0,r2
! Opcodes 5990 - 5997
P990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3600
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3600:
jmp @r4
mov r0,r2
! Opcodes 5998 - 599F
P998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3601
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3601:
jmp @r4
mov r0,r2
! Opcodes 59A0 - 59A7
P9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3602
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3602:
jmp @r4
mov r0,r2
! Opcodes 59A8 - 59AF
P9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3603
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3603:
jmp @r4
mov r0,r2
! Opcodes 59B0 - 59B7
P9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3604
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3604:
jmp @r4
mov r0,r2
! Opcode 59B8
P9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3605
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3605:
jmp @r4
mov r0,r2
! Opcode 59B9
P9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3606
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3606:
jmp @r4
mov r0,r2
! Opcodes 59C0 - 59C7
P9C0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
tst r3,r3
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3607
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3607:
jmp @r4
mov r0,r2
! Opcodes 59C8 - 59CF
P9C8:
mov r8,r0
tst #4,r0
bt dbcc3608
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3609
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3609:
jmp @r4
mov r0,r2
.align 5
dbcc3608:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3610
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3611
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3611:
jmp @r4
mov r0,r2
.align 5
bcc_w3610:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3612
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3612:
jmp @r4
mov r0,r2
! Opcodes 59D0 - 59D7
P9D0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3613
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3613:
jmp @r4
mov r0,r2
! Opcodes 59D8 - 59DF
P9D8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3614
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3614:
jmp @r4
mov r0,r2
! Opcodes 59E0 - 59E7
P9E0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3615
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3615:
jmp @r4
mov r0,r2
! Opcodes 59E8 - 59EF
P9E8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3616
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3616:
jmp @r4
mov r0,r2
! Opcodes 59F0 - 59F7
P9F0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3617
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3617:
jmp @r4
mov r0,r2
! Opcode 59F8
P9F8:
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3618
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3618:
jmp @r4
mov r0,r2
! Opcode 59F9
P9F9:
mov.l r3,@-r15
mov r8,r0
tst #4,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3619
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3619:
jmp @r4
mov r0,r2
! Opcodes 5A00 - 5A07
PA00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3620
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3620:
jmp @r4
mov r0,r2
! Opcodes 5A08 - 5A0F
PA08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3621
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3621:
jmp @r4
mov r0,r2
! Opcodes 5A10 - 5A17
PA10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3622
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3622:
jmp @r4
mov r0,r2
! Opcodes 5A18 - 5A1F
PA18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3623
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3623:
jmp @r4
mov r0,r2
! Opcodes 5A20 - 5A27
PA20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3624
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3624:
jmp @r4
mov r0,r2
! Opcodes 5A28 - 5A2F
PA28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3625
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3625:
jmp @r4
mov r0,r2
! Opcodes 5A30 - 5A37
PA30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3626
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3626:
jmp @r4
mov r0,r2
! Opcode 5A38
PA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3627
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3627:
jmp @r4
mov r0,r2
! Opcode 5A39
PA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3628
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3628:
jmp @r4
mov r0,r2
! Opcodes 5A40 - 5A47
PA40:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3629
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3629:
jmp @r4
mov r0,r2
! Opcodes 5A48 - 5A4F
PA48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 5,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3630
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3630:
jmp @r4
mov r0,r2
! Opcodes 5A50 - 5A57
PA50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3631
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3631:
jmp @r4
mov r0,r2
! Opcodes 5A58 - 5A5F
PA58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3632
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3632:
jmp @r4
mov r0,r2
! Opcodes 5A60 - 5A67
PA60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3633
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3633:
jmp @r4
mov r0,r2
! Opcodes 5A68 - 5A6F
PA68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3634
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3634:
jmp @r4
mov r0,r2
! Opcodes 5A70 - 5A77
PA70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3635
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3635:
jmp @r4
mov r0,r2
! Opcode 5A78
PA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3636
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3636:
jmp @r4
mov r0,r2
! Opcode 5A79
PA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3637
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3637:
jmp @r4
mov r0,r2
! Opcodes 5A80 - 5A87
PA80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #5,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3638
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3638:
jmp @r4
mov r0,r2
! Opcodes 5A88 - 5A8F
PA88:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 5,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3639
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3639:
jmp @r4
mov r0,r2
! Opcodes 5A90 - 5A97
PA90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3640
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3640:
jmp @r4
mov r0,r2
! Opcodes 5A98 - 5A9F
PA98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3641
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3641:
jmp @r4
mov r0,r2
! Opcodes 5AA0 - 5AA7
PAA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3642
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3642:
jmp @r4
mov r0,r2
! Opcodes 5AA8 - 5AAF
PAA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3643
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3643:
jmp @r4
mov r0,r2
! Opcodes 5AB0 - 5AB7
PAB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3644
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3644:
jmp @r4
mov r0,r2
! Opcode 5AB8
PAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3645
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3645:
jmp @r4
mov r0,r2
! Opcode 5AB9
PAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3646
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3646:
jmp @r4
mov r0,r2
! Opcodes 5AC0 - 5AC7
PAC0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3647
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3647:
jmp @r4
mov r0,r2
! Opcodes 5AC8 - 5ACF
PAC8:
mov r8,r0
tst #1,r0
bf dbcc3648
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3649
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3649:
jmp @r4
mov r0,r2
.align 5
dbcc3648:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3650
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3651
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3651:
jmp @r4
mov r0,r2
.align 5
bcc_w3650:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3652
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3652:
jmp @r4
mov r0,r2
! Opcodes 5AD0 - 5AD7
PAD0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3653
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3653:
jmp @r4
mov r0,r2
! Opcodes 5AD8 - 5ADF
PAD8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3654
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3654:
jmp @r4
mov r0,r2
! Opcodes 5AE0 - 5AE7
PAE0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3655
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3655:
jmp @r4
mov r0,r2
! Opcodes 5AE8 - 5AEF
PAE8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3656
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3656:
jmp @r4
mov r0,r2
! Opcodes 5AF0 - 5AF7
PAF0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3657
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3657:
jmp @r4
mov r0,r2
! Opcode 5AF8
PAF8:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3658
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3658:
jmp @r4
mov r0,r2
! Opcode 5AF9
PAF9:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3659
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3659:
jmp @r4
mov r0,r2
! Opcodes 5B00 - 5B07
PB00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3660
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3660:
jmp @r4
mov r0,r2
! Opcodes 5B08 - 5B0F
PB08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3661
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3661:
jmp @r4
mov r0,r2
! Opcodes 5B10 - 5B17
PB10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3662
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3662:
jmp @r4
mov r0,r2
! Opcodes 5B18 - 5B1F
PB18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3663
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3663:
jmp @r4
mov r0,r2
! Opcodes 5B20 - 5B27
PB20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3664
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3664:
jmp @r4
mov r0,r2
! Opcodes 5B28 - 5B2F
PB28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3665
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3665:
jmp @r4
mov r0,r2
! Opcodes 5B30 - 5B37
PB30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3666
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3666:
jmp @r4
mov r0,r2
! Opcode 5B38
PB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3667
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3667:
jmp @r4
mov r0,r2
! Opcode 5B39
PB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #5,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3668
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3668:
jmp @r4
mov r0,r2
! Opcodes 5B40 - 5B47
PB40:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3669
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3669:
jmp @r4
mov r0,r2
! Opcodes 5B48 - 5B4F
PB48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-5,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3670
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3670:
jmp @r4
mov r0,r2
! Opcodes 5B50 - 5B57
PB50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3671
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3671:
jmp @r4
mov r0,r2
! Opcodes 5B58 - 5B5F
PB58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3672
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3672:
jmp @r4
mov r0,r2
! Opcodes 5B60 - 5B67
PB60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3673
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3673:
jmp @r4
mov r0,r2
! Opcodes 5B68 - 5B6F
PB68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3674
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3674:
jmp @r4
mov r0,r2
! Opcodes 5B70 - 5B77
PB70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3675
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3675:
jmp @r4
mov r0,r2
! Opcode 5B78
PB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3676
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3676:
jmp @r4
mov r0,r2
! Opcode 5B79
PB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #5,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3677
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3677:
jmp @r4
mov r0,r2
! Opcodes 5B80 - 5B87
PB80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #5,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3678
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3678:
jmp @r4
mov r0,r2
! Opcodes 5B88 - 5B8F
PB88:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-5,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3679
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3679:
jmp @r4
mov r0,r2
! Opcodes 5B90 - 5B97
PB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3680
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3680:
jmp @r4
mov r0,r2
! Opcodes 5B98 - 5B9F
PB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3681
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3681:
jmp @r4
mov r0,r2
! Opcodes 5BA0 - 5BA7
PBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3682
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3682:
jmp @r4
mov r0,r2
! Opcodes 5BA8 - 5BAF
PBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3683
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3683:
jmp @r4
mov r0,r2
! Opcodes 5BB0 - 5BB7
PBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3684
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3684:
jmp @r4
mov r0,r2
! Opcode 5BB8
PBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3685
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3685:
jmp @r4
mov r0,r2
! Opcode 5BB9
PBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #5,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3686
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3686:
jmp @r4
mov r0,r2
! Opcodes 5BC0 - 5BC7
PBC0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
tst r3,r3
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3687
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3687:
jmp @r4
mov r0,r2
! Opcodes 5BC8 - 5BCF
PBC8:
mov r8,r0
tst #1,r0
bt dbcc3688
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3689
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3689:
jmp @r4
mov r0,r2
.align 5
dbcc3688:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3690
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3691
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3691:
jmp @r4
mov r0,r2
.align 5
bcc_w3690:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3692
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3692:
jmp @r4
mov r0,r2
! Opcodes 5BD0 - 5BD7
PBD0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3693
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3693:
jmp @r4
mov r0,r2
! Opcodes 5BD8 - 5BDF
PBD8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3694
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3694:
jmp @r4
mov r0,r2
! Opcodes 5BE0 - 5BE7
PBE0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3695
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3695:
jmp @r4
mov r0,r2
! Opcodes 5BE8 - 5BEF
PBE8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3696
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3696:
jmp @r4
mov r0,r2
! Opcodes 5BF0 - 5BF7
PBF0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3697
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3697:
jmp @r4
mov r0,r2
! Opcode 5BF8
PBF8:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3698
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3698:
jmp @r4
mov r0,r2
! Opcode 5BF9
PBF9:
mov.l r3,@-r15
mov r8,r0
tst #1,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3699
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3699:
jmp @r4
mov r0,r2
! Opcodes 5C00 - 5C07
PC00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3700
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3700:
jmp @r4
mov r0,r2
! Opcodes 5C08 - 5C0F
PC08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3701
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3701:
jmp @r4
mov r0,r2
! Opcodes 5C10 - 5C17
PC10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3702
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3702:
jmp @r4
mov r0,r2
! Opcodes 5C18 - 5C1F
PC18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3703
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3703:
jmp @r4
mov r0,r2
! Opcodes 5C20 - 5C27
PC20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3704
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3704:
jmp @r4
mov r0,r2
! Opcodes 5C28 - 5C2F
PC28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3705
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3705:
jmp @r4
mov r0,r2
! Opcodes 5C30 - 5C37
PC30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3706
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3706:
jmp @r4
mov r0,r2
! Opcode 5C38
PC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3707
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3707:
jmp @r4
mov r0,r2
! Opcode 5C39
PC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3708
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3708:
jmp @r4
mov r0,r2
! Opcodes 5C40 - 5C47
PC40:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3709
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3709:
jmp @r4
mov r0,r2
! Opcodes 5C48 - 5C4F
PC48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 6,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3710
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3710:
jmp @r4
mov r0,r2
! Opcodes 5C50 - 5C57
PC50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3711
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3711:
jmp @r4
mov r0,r2
! Opcodes 5C58 - 5C5F
PC58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3712
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3712:
jmp @r4
mov r0,r2
! Opcodes 5C60 - 5C67
PC60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3713
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3713:
jmp @r4
mov r0,r2
! Opcodes 5C68 - 5C6F
PC68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3714
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3714:
jmp @r4
mov r0,r2
! Opcodes 5C70 - 5C77
PC70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3715
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3715:
jmp @r4
mov r0,r2
! Opcode 5C78
PC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3716
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3716:
jmp @r4
mov r0,r2
! Opcode 5C79
PC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3717
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3717:
jmp @r4
mov r0,r2
! Opcodes 5C80 - 5C87
PC80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #6,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3718
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3718:
jmp @r4
mov r0,r2
! Opcodes 5C88 - 5C8F
PC88:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 6,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3719
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3719:
jmp @r4
mov r0,r2
! Opcodes 5C90 - 5C97
PC90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3720
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3720:
jmp @r4
mov r0,r2
! Opcodes 5C98 - 5C9F
PC98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3721
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3721:
jmp @r4
mov r0,r2
! Opcodes 5CA0 - 5CA7
PCA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3722
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3722:
jmp @r4
mov r0,r2
! Opcodes 5CA8 - 5CAF
PCA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3723
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3723:
jmp @r4
mov r0,r2
! Opcodes 5CB0 - 5CB7
PCB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3724
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3724:
jmp @r4
mov r0,r2
! Opcode 5CB8
PCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3725
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3725:
jmp @r4
mov r0,r2
! Opcode 5CB9
PCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3726
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3726:
jmp @r4
mov r0,r2
! Opcodes 5CC0 - 5CC7
PCC0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
tst r3,r3
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3727
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3727:
jmp @r4
mov r0,r2
! Opcodes 5CC8 - 5CCF
PCC8:
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
bt dbcc3728
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3729
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3729:
jmp @r4
mov r0,r2
.align 5
dbcc3728:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3730
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3731
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3731:
jmp @r4
mov r0,r2
.align 5
bcc_w3730:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3732
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3732:
jmp @r4
mov r0,r2
! Opcodes 5CD0 - 5CD7
PCD0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3733
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3733:
jmp @r4
mov r0,r2
! Opcodes 5CD8 - 5CDF
PCD8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3734
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3734:
jmp @r4
mov r0,r2
! Opcodes 5CE0 - 5CE7
PCE0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3735
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3735:
jmp @r4
mov r0,r2
! Opcodes 5CE8 - 5CEF
PCE8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3736
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3736:
jmp @r4
mov r0,r2
! Opcodes 5CF0 - 5CF7
PCF0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3737
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3737:
jmp @r4
mov r0,r2
! Opcode 5CF8
PCF8:
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3738
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3738:
jmp @r4
mov r0,r2
! Opcode 5CF9
PCF9:
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3739
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3739:
jmp @r4
mov r0,r2
! Opcodes 5D00 - 5D07
PD00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3740
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3740:
jmp @r4
mov r0,r2
! Opcodes 5D08 - 5D0F
PD08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3741
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3741:
jmp @r4
mov r0,r2
! Opcodes 5D10 - 5D17
PD10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3742
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3742:
jmp @r4
mov r0,r2
! Opcodes 5D18 - 5D1F
PD18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3743
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3743:
jmp @r4
mov r0,r2
! Opcodes 5D20 - 5D27
PD20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3744
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3744:
jmp @r4
mov r0,r2
! Opcodes 5D28 - 5D2F
PD28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3745
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3745:
jmp @r4
mov r0,r2
! Opcodes 5D30 - 5D37
PD30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3746
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3746:
jmp @r4
mov r0,r2
! Opcode 5D38
PD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3747
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3747:
jmp @r4
mov r0,r2
! Opcode 5D39
PD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #6,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3748
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3748:
jmp @r4
mov r0,r2
! Opcodes 5D40 - 5D47
PD40:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3749
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3749:
jmp @r4
mov r0,r2
! Opcodes 5D48 - 5D4F
PD48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-6,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3750
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3750:
jmp @r4
mov r0,r2
! Opcodes 5D50 - 5D57
PD50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3751
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3751:
jmp @r4
mov r0,r2
! Opcodes 5D58 - 5D5F
PD58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3752
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3752:
jmp @r4
mov r0,r2
! Opcodes 5D60 - 5D67
PD60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3753
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3753:
jmp @r4
mov r0,r2
! Opcodes 5D68 - 5D6F
PD68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3754
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3754:
jmp @r4
mov r0,r2
! Opcodes 5D70 - 5D77
PD70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3755
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3755:
jmp @r4
mov r0,r2
! Opcode 5D78
PD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3756
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3756:
jmp @r4
mov r0,r2
! Opcode 5D79
PD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #6,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3757
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3757:
jmp @r4
mov r0,r2
! Opcodes 5D80 - 5D87
PD80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #6,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3758
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3758:
jmp @r4
mov r0,r2
! Opcodes 5D88 - 5D8F
PD88:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-6,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3759
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3759:
jmp @r4
mov r0,r2
! Opcodes 5D90 - 5D97
PD90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3760
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3760:
jmp @r4
mov r0,r2
! Opcodes 5D98 - 5D9F
PD98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3761
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3761:
jmp @r4
mov r0,r2
! Opcodes 5DA0 - 5DA7
PDA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3762
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3762:
jmp @r4
mov r0,r2
! Opcodes 5DA8 - 5DAF
PDA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3763
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3763:
jmp @r4
mov r0,r2
! Opcodes 5DB0 - 5DB7
PDB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3764
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3764:
jmp @r4
mov r0,r2
! Opcode 5DB8
PDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3765
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3765:
jmp @r4
mov r0,r2
! Opcode 5DB9
PDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #6,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3766
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3766:
jmp @r4
mov r0,r2
! Opcodes 5DC0 - 5DC7
PDC0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3767
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3767:
jmp @r4
mov r0,r2
! Opcodes 5DC8 - 5DCF
PDC8:
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
bf dbcc3768
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3769
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3769:
jmp @r4
mov r0,r2
.align 5
dbcc3768:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3770
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3771
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3771:
jmp @r4
mov r0,r2
.align 5
bcc_w3770:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3772
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3772:
jmp @r4
mov r0,r2
! Opcodes 5DD0 - 5DD7
PDD0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3773
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3773:
jmp @r4
mov r0,r2
! Opcodes 5DD8 - 5DDF
PDD8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3774
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3774:
jmp @r4
mov r0,r2
! Opcodes 5DE0 - 5DE7
PDE0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3775
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3775:
jmp @r4
mov r0,r2
! Opcodes 5DE8 - 5DEF
PDE8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3776
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3776:
jmp @r4
mov r0,r2
! Opcodes 5DF0 - 5DF7
PDF0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3777
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3777:
jmp @r4
mov r0,r2
! Opcode 5DF8
PDF8:
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3778
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3778:
jmp @r4
mov r0,r2
! Opcode 5DF9
PDF9:
mov.l r3,@-r15
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3779
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3779:
jmp @r4
mov r0,r2
! Opcodes 5E00 - 5E07
PE00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3780
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3780:
jmp @r4
mov r0,r2
! Opcodes 5E08 - 5E0F
PE08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3781
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3781:
jmp @r4
mov r0,r2
! Opcodes 5E10 - 5E17
PE10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3782
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3782:
jmp @r4
mov r0,r2
! Opcodes 5E18 - 5E1F
PE18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3783
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3783:
jmp @r4
mov r0,r2
! Opcodes 5E20 - 5E27
PE20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3784
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3784:
jmp @r4
mov r0,r2
! Opcodes 5E28 - 5E2F
PE28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3785
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3785:
jmp @r4
mov r0,r2
! Opcodes 5E30 - 5E37
PE30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3786
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3786:
jmp @r4
mov r0,r2
! Opcode 5E38
PE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3787
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3787:
jmp @r4
mov r0,r2
! Opcode 5E39
PE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3788
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3788:
jmp @r4
mov r0,r2
! Opcodes 5E40 - 5E47
PE40:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3789
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3789:
jmp @r4
mov r0,r2
! Opcodes 5E48 - 5E4F
PE48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 7,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3790
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3790:
jmp @r4
mov r0,r2
! Opcodes 5E50 - 5E57
PE50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3791
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3791:
jmp @r4
mov r0,r2
! Opcodes 5E58 - 5E5F
PE58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3792
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3792:
jmp @r4
mov r0,r2
! Opcodes 5E60 - 5E67
PE60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3793
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3793:
jmp @r4
mov r0,r2
! Opcodes 5E68 - 5E6F
PE68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3794
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3794:
jmp @r4
mov r0,r2
! Opcodes 5E70 - 5E77
PE70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3795
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3795:
jmp @r4
mov r0,r2
! Opcode 5E78
PE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3796
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3796:
jmp @r4
mov r0,r2
! Opcode 5E79
PE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3797
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3797:
jmp @r4
mov r0,r2
! Opcodes 5E80 - 5E87
PE80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #7,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3798
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3798:
jmp @r4
mov r0,r2
! Opcodes 5E88 - 5E8F
PE88:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add # 7,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3799
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3799:
jmp @r4
mov r0,r2
! Opcodes 5E90 - 5E97
PE90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3800
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3800:
jmp @r4
mov r0,r2
! Opcodes 5E98 - 5E9F
PE98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3801
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3801:
jmp @r4
mov r0,r2
! Opcodes 5EA0 - 5EA7
PEA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3802
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3802:
jmp @r4
mov r0,r2
! Opcodes 5EA8 - 5EAF
PEA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3803
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3803:
jmp @r4
mov r0,r2
! Opcodes 5EB0 - 5EB7
PEB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3804
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3804:
jmp @r4
mov r0,r2
! Opcode 5EB8
PEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3805
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3805:
jmp @r4
mov r0,r2
! Opcode 5EB9
PEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
addv r0,r1
movt r8
clrt
addc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3806
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3806:
jmp @r4
mov r0,r2
! Opcodes 5EC0 - 5EC7
PEC0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3807
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3807:
jmp @r4
mov r0,r2
! Opcodes 5EC8 - 5ECF
PEC8:
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
bf dbcc3808
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3809
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3809:
jmp @r4
mov r0,r2
.align 5
dbcc3808:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3810
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3811
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3811:
jmp @r4
mov r0,r2
.align 5
bcc_w3810:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3812
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3812:
jmp @r4
mov r0,r2
! Opcodes 5ED0 - 5ED7
PED0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3813
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3813:
jmp @r4
mov r0,r2
! Opcodes 5ED8 - 5EDF
PED8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3814
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3814:
jmp @r4
mov r0,r2
! Opcodes 5EE0 - 5EE7
PEE0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3815
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3815:
jmp @r4
mov r0,r2
! Opcodes 5EE8 - 5EEF
PEE8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3816
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3816:
jmp @r4
mov r0,r2
! Opcodes 5EF0 - 5EF7
PEF0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3817
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3817:
jmp @r4
mov r0,r2
! Opcode 5EF8
PEF8:
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3818
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3818:
jmp @r4
mov r0,r2
! Opcode 5EF9
PEF9:
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3819
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3819:
jmp @r4
mov r0,r2
! Opcodes 5F00 - 5F07
PF00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3820
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3820:
jmp @r4
mov r0,r2
! Opcodes 5F08 - 5F0F
PF08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3821
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3821:
jmp @r4
mov r0,r2
! Opcodes 5F10 - 5F17
PF10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3822
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3822:
jmp @r4
mov r0,r2
! Opcodes 5F18 - 5F1F
PF18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3823
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3823:
jmp @r4
mov r0,r2
! Opcodes 5F20 - 5F27
PF20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3824
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3824:
jmp @r4
mov r0,r2
! Opcodes 5F28 - 5F2F
PF28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3825
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3825:
jmp @r4
mov r0,r2
! Opcodes 5F30 - 5F37
PF30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3826
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3826:
jmp @r4
mov r0,r2
! Opcode 5F38
PF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3827
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3827:
jmp @r4
mov r0,r2
! Opcode 5F39
PF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r1
mov #7,r0
shld r1,r3
shld r1,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3828
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3828:
jmp @r4
mov r0,r2
! Opcodes 5F40 - 5F47
PF40:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3829
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3829:
jmp @r4
mov r0,r2
! Opcodes 5F48 - 5F4F
PF48:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-7,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3830
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3830:
jmp @r4
mov r0,r2
! Opcodes 5F50 - 5F57
PF50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3831
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3831:
jmp @r4
mov r0,r2
! Opcodes 5F58 - 5F5F
PF58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3832
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3832:
jmp @r4
mov r0,r2
! Opcodes 5F60 - 5F67
PF60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3833
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3833:
jmp @r4
mov r0,r2
! Opcodes 5F68 - 5F6F
PF68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3834
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3834:
jmp @r4
mov r0,r2
! Opcodes 5F70 - 5F77
PF70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3835
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3835:
jmp @r4
mov r0,r2
! Opcode 5F78
PF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3836
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3836:
jmp @r4
mov r0,r2
! Opcode 5F79
PF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll16 r3
mov #7,r0
shll16 r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3837
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3837:
jmp @r4
mov r0,r2
! Opcodes 5F80 - 5F87
PF80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #7,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3838
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3838:
jmp @r4
mov r0,r2
! Opcodes 5F88 - 5F8F
PF88:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
add #-7,r3
mov.l r3,@r2
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3839
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3839:
jmp @r4
mov r0,r2
! Opcodes 5F90 - 5F97
PF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3840
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3840:
jmp @r4
mov r0,r2
! Opcodes 5F98 - 5F9F
PF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3841
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3841:
jmp @r4
mov r0,r2
! Opcodes 5FA0 - 5FA7
PFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3842
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3842:
jmp @r4
mov r0,r2
! Opcodes 5FA8 - 5FAF
PFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3843
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3843:
jmp @r4
mov r0,r2
! Opcodes 5FB0 - 5FB7
PFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3844
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3844:
jmp @r4
mov r0,r2
! Opcode 5FB8
PFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3845
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3845:
jmp @r4
mov r0,r2
! Opcode 5FB9
PFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #7,r0
mov r3,r1
subv r0,r1
movt r8
clrt
subc r0,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3846
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3846:
jmp @r4
mov r0,r2
! Opcodes 5FC0 - 5FC7
PFC0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
tst r3,r3
movt r3
sub r3,r7
sub r3,r7
neg r3,r3
mov r2,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3847
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3847:
jmp @r4
mov r0,r2
! Opcodes 5FC8 - 5FCF
PFC8:
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
bt dbcc3848
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3849
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3849:
jmp @r4
mov r0,r2
.align 5
dbcc3848:
and r1,r2
mov r13,r0
mov.w @(r0,r2),r1
tst r1,r1
add #-1,r1
mov.w r1,@(r0,r2)
bf bcc_w3850
add #2,r6
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3851
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3851:
jmp @r4
mov r0,r2
.align 5
bcc_w3850:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3852
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3852:
jmp @r4
mov r0,r2
! Opcodes 5FD0 - 5FD7
PFD0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3853
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3853:
jmp @r4
mov r0,r2
! Opcodes 5FD8 - 5FDF
PFD8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3854
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3854:
jmp @r4
mov r0,r2
! Opcodes 5FE0 - 5FE7
PFE0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3855
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3855:
jmp @r4
mov r0,r2
! Opcodes 5FE8 - 5FEF
PFE8:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3856
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3856:
jmp @r4
mov r0,r2
! Opcodes 5FF0 - 5FF7
PFF0:
and r1,r2
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3857
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3857:
jmp @r4
mov r0,r2
! Opcode 5FF8
PFF8:
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3858
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3858:
jmp @r4
mov r0,r2
! Opcode 5FF9
PFF9:
mov.l r3,@-r15
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
movt r3
tst r3,r3
movt r3
neg r3,r3
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3859
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3859:
jmp @r4
mov r0,r2
! Opcode 6000
Q000:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3860
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3860:
jmp @r4
mov r0,r2
! Opcodes 6001 - 60FF
Q001:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3861
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3861:
jmp @r4
mov r0,r2
! Opcode 6100
Q100:
mov.w @r6,r1
mov.l r3,@-r15
mov r6,r3
add #2,r3
sub r5,r3
add r1,r6
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3862
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3862:
jmp @r4
mov r0,r2
! Opcodes 6101 - 61FF
Q101:
shlr2 r2
mov.l r3,@-r15
exts.b r2,r2
mov r6,r3
add r2,r6
sub r5,r3
mov.l @(60,r13),r4
add #-4,r4
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3863
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3863:
jmp @r4
mov r0,r2
! Opcode 6200
Q200:
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
bt bcc_w3864
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3865
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3865:
jmp @r4
mov r0,r2
.align 5
bcc_w3864:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3866
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3866:
jmp @r4
mov r0,r2
! Opcodes 6201 - 62FF
Q201:
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
bt bcc_b3867
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3868
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3868:
jmp @r4
mov r0,r2
.align 5
bcc_b3867:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3869
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3869:
jmp @r4
mov r0,r2
! Opcode 6300
Q300:
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
bf bcc_w3870
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3871
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3871:
jmp @r4
mov r0,r2
.align 5
bcc_w3870:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3872
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3872:
jmp @r4
mov r0,r2
! Opcodes 6301 - 63FF
Q301:
tst r3,r3
mov r8,r0
addc r0,r0
tst #5,r0
bf bcc_b3873
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3874
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3874:
jmp @r4
mov r0,r2
.align 5
bcc_b3873:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3875
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3875:
jmp @r4
mov r0,r2
! Opcode 6400
Q400:
mov r8,r0
tst #2,r0
bt bcc_w3876
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3877
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3877:
jmp @r4
mov r0,r2
.align 5
bcc_w3876:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3878
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3878:
jmp @r4
mov r0,r2
! Opcodes 6401 - 64FF
Q401:
mov r8,r0
tst #2,r0
bt bcc_b3879
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3880
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3880:
jmp @r4
mov r0,r2
.align 5
bcc_b3879:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3881
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3881:
jmp @r4
mov r0,r2
! Opcode 6500
Q500:
mov r8,r0
tst #2,r0
bf bcc_w3882
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3883
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3883:
jmp @r4
mov r0,r2
.align 5
bcc_w3882:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3884
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3884:
jmp @r4
mov r0,r2
! Opcodes 6501 - 65FF
Q501:
mov r8,r0
tst #2,r0
bf bcc_b3885
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3886
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3886:
jmp @r4
mov r0,r2
.align 5
bcc_b3885:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3887
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3887:
jmp @r4
mov r0,r2
! Opcode 6600
Q600:
tst r3,r3
bf bcc_w3888
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3889
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3889:
jmp @r4
mov r0,r2
.align 5
bcc_w3888:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3890
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3890:
jmp @r4
mov r0,r2
! Opcodes 6601 - 66FF
Q601:
tst r3,r3
bf bcc_b3891
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3892
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3892:
jmp @r4
mov r0,r2
.align 5
bcc_b3891:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3893
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3893:
jmp @r4
mov r0,r2
! Opcode 6700
Q700:
tst r3,r3
bt bcc_w3894
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3895
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3895:
jmp @r4
mov r0,r2
.align 5
bcc_w3894:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3896
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3896:
jmp @r4
mov r0,r2
! Opcodes 6701 - 67FF
Q701:
tst r3,r3
bt bcc_b3897
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3898
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3898:
jmp @r4
mov r0,r2
.align 5
bcc_b3897:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3899
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3899:
jmp @r4
mov r0,r2
! Opcode 6800
Q800:
mov r8,r0
tst #4,r0
bt bcc_w3900
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3901
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3901:
jmp @r4
mov r0,r2
.align 5
bcc_w3900:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3902
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3902:
jmp @r4
mov r0,r2
! Opcodes 6801 - 68FF
Q801:
mov r8,r0
tst #4,r0
bt bcc_b3903
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3904
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3904:
jmp @r4
mov r0,r2
.align 5
bcc_b3903:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3905
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3905:
jmp @r4
mov r0,r2
! Opcode 6900
Q900:
mov r8,r0
tst #4,r0
bf bcc_w3906
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3907
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3907:
jmp @r4
mov r0,r2
.align 5
bcc_w3906:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3908
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3908:
jmp @r4
mov r0,r2
! Opcodes 6901 - 69FF
Q901:
mov r8,r0
tst #4,r0
bf bcc_b3909
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3910
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3910:
jmp @r4
mov r0,r2
.align 5
bcc_b3909:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3911
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3911:
jmp @r4
mov r0,r2
! Opcode 6A00
QA00:
mov r8,r0
tst #1,r0
bt bcc_w3912
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3913
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3913:
jmp @r4
mov r0,r2
.align 5
bcc_w3912:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3914
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3914:
jmp @r4
mov r0,r2
! Opcodes 6A01 - 6AFF
QA01:
mov r8,r0
tst #1,r0
bt bcc_b3915
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3916
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3916:
jmp @r4
mov r0,r2
.align 5
bcc_b3915:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3917
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3917:
jmp @r4
mov r0,r2
! Opcode 6B00
QB00:
mov r8,r0
tst #1,r0
bf bcc_w3918
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3919
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3919:
jmp @r4
mov r0,r2
.align 5
bcc_w3918:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3920
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3920:
jmp @r4
mov r0,r2
! Opcodes 6B01 - 6BFF
QB01:
mov r8,r0
tst #1,r0
bf bcc_b3921
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3922
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3922:
jmp @r4
mov r0,r2
.align 5
bcc_b3921:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3923
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3923:
jmp @r4
mov r0,r2
! Opcode 6C00
QC00:
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
bf bcc_w3924
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3925
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3925:
jmp @r4
mov r0,r2
.align 5
bcc_w3924:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3926
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3926:
jmp @r4
mov r0,r2
! Opcodes 6C01 - 6CFF
QC01:
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
bf bcc_b3927
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3928
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3928:
jmp @r4
mov r0,r2
.align 5
bcc_b3927:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3929
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3929:
jmp @r4
mov r0,r2
! Opcode 6D00
QD00:
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
bt bcc_w3930
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3931
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3931:
jmp @r4
mov r0,r2
.align 5
bcc_w3930:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3932
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3932:
jmp @r4
mov r0,r2
! Opcodes 6D01 - 6DFF
QD01:
mov r8,r0
shlr2 r0
xor r8,r0
shlr r0
bt bcc_b3933
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3934
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3934:
jmp @r4
mov r0,r2
.align 5
bcc_b3933:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3935
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3935:
jmp @r4
mov r0,r2
! Opcode 6E00
QE00:
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
bt bcc_w3936
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3937
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3937:
jmp @r4
mov r0,r2
.align 5
bcc_w3936:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3938
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3938:
jmp @r4
mov r0,r2
! Opcodes 6E01 - 6EFF
QE01:
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
bt bcc_b3939
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3940
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3940:
jmp @r4
mov r0,r2
.align 5
bcc_b3939:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3941
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3941:
jmp @r4
mov r0,r2
! Opcode 6F00
QF00:
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
bf bcc_w3942
add #2,r6
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3943
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3943:
jmp @r4
mov r0,r2
.align 5
bcc_w3942:
mov.w @r6,r0
add r0,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3944
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3944:
jmp @r4
mov r0,r2
! Opcodes 6F01 - 6FFF
QF01:
mov r8,r0
shlr2 r0
tst r3,r3
xor r8,r0
addc r0,r0
tst #3,r0
bf bcc_b3945
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3946
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3946:
jmp @r4
mov r0,r2
.align 5
bcc_b3945:
shlr2 r2
exts.b r2,r2
add r2,r6
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3947
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3947:
jmp @r4
mov r0,r2
! Opcodes 7000 - 70FF
R000:
shlr2 r2
exts.b r2,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3948
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3948:
jmp @r4
mov r0,r2
! Opcodes 7200 - 72FF
R200:
shlr2 r2
exts.b r2,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3949
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3949:
jmp @r4
mov r0,r2
! Opcodes 7400 - 74FF
R400:
shlr2 r2
exts.b r2,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3950
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3950:
jmp @r4
mov r0,r2
! Opcodes 7600 - 76FF
R600:
shlr2 r2
exts.b r2,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3951
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3951:
jmp @r4
mov r0,r2
! Opcodes 7800 - 78FF
R800:
shlr2 r2
exts.b r2,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3952
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3952:
jmp @r4
mov r0,r2
! Opcodes 7A00 - 7AFF
RA00:
shlr2 r2
exts.b r2,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3953
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3953:
jmp @r4
mov r0,r2
! Opcodes 7C00 - 7CFF
RC00:
shlr2 r2
exts.b r2,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3954
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3954:
jmp @r4
mov r0,r2
! Opcodes 7E00 - 7EFF
RE00:
shlr2 r2
exts.b r2,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3955
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3955:
jmp @r4
mov r0,r2
! Opcodes 8000 - 8007
S000:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3956
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3956:
jmp @r4
mov r0,r2
! Opcodes 8010 - 8017
S010:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3957
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3957:
jmp @r4
mov r0,r2
! Opcodes 8018 - 801F
S018:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3958
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3958:
jmp @r4
mov r0,r2
! Opcodes 8020 - 8027
S020:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3959
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3959:
jmp @r4
mov r0,r2
! Opcodes 8028 - 802F
S028:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3960
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3960:
jmp @r4
mov r0,r2
! Opcodes 8030 - 8037
S030:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3961
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3961:
jmp @r4
mov r0,r2
! Opcode 8038
S038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3962
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3962:
jmp @r4
mov r0,r2
! Opcode 8039
S039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3963
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3963:
jmp @r4
mov r0,r2
! Opcode 803A
S03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3964
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3964:
jmp @r4
mov r0,r2
! Opcode 803B
S03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3965
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3965:
jmp @r4
mov r0,r2
! Opcode 803C
S03C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r1
or r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3966
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3966:
jmp @r4
mov r0,r2
! Opcodes 8040 - 8047
S040:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3967
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3967:
jmp @r4
mov r0,r2
! Opcodes 8050 - 8057
S050:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3968
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3968:
jmp @r4
mov r0,r2
! Opcodes 8058 - 805F
S058:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3969
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3969:
jmp @r4
mov r0,r2
! Opcodes 8060 - 8067
S060:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3970
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3970:
jmp @r4
mov r0,r2
! Opcodes 8068 - 806F
S068:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3971
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3971:
jmp @r4
mov r0,r2
! Opcodes 8070 - 8077
S070:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3972
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3972:
jmp @r4
mov r0,r2
! Opcode 8078
S078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3973
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3973:
jmp @r4
mov r0,r2
! Opcode 8079
S079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3974
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3974:
jmp @r4
mov r0,r2
! Opcode 807A
S07A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3975
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3975:
jmp @r4
mov r0,r2
! Opcode 807B
S07B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3976
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3976:
jmp @r4
mov r0,r2
! Opcode 807C
S07C:
mov.w @r6+,r3
mov.w @r13,r1
or r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3977
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3977:
jmp @r4
mov r0,r2
! Opcodes 8080 - 8087
S080:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3978
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3978:
jmp @r4
mov r0,r2
! Opcodes 8090 - 8097
S090:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3979
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3979:
jmp @r4
mov r0,r2
! Opcodes 8098 - 809F
S098:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3980
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3980:
jmp @r4
mov r0,r2
! Opcodes 80A0 - 80A7
S0A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3981
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3981:
jmp @r4
mov r0,r2
! Opcodes 80A8 - 80AF
S0A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3982
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3982:
jmp @r4
mov r0,r2
! Opcodes 80B0 - 80B7
S0B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3983
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3983:
jmp @r4
mov r0,r2
! Opcode 80B8
S0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3984
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3984:
jmp @r4
mov r0,r2
! Opcode 80B9
S0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3985
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3985:
jmp @r4
mov r0,r2
! Opcode 80BA
S0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3986
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3986:
jmp @r4
mov r0,r2
! Opcode 80BB
S0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3987
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3987:
jmp @r4
mov r0,r2
! Opcode 80BC
S0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @r13,r1
or r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3988
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3988:
jmp @r4
mov r0,r2
! Opcodes 80C0 - 80C7
S0C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln3989
cmp/hs r3,r1
bt ln3990
mov #15,r4
mov r1,r0
dutloop3989:
bt subd3989
cmp/hs r3,r0
bt/s subhd3989
dt r7
bra divutend3989
dt r7
subhd3989:
bra divutend3989
sub r3,r0
subd3989:
sub r8,r0
divutend3989:
dt r4
bf/s dutloop3989
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3991
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3991:
jmp @r4
mov r0,r2
.align 5
ln3990:
mov #0x8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3992
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3992:
jmp @r4
mov r0,r2
.align 5
ln3989:
mov.l g2_except_addr3989,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr3989,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3993
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3993:
jmp @r4
mov r0,r2
.align 2
g2_except_addr3989: .long group_2_exception
bf_addr3989: .long basefunction
! Opcodes 80D0 - 80D7
S0D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln3994
cmp/hs r3,r1
bt ln3995
mov #15,r4
mov r1,r0
dutloop3994:
bt subd3994
cmp/hs r3,r0
bt/s subhd3994
dt r7
bra divutend3994
dt r7
subhd3994:
bra divutend3994
sub r3,r0
subd3994:
sub r8,r0
divutend3994:
dt r4
bf/s dutloop3994
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3996
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3996:
jmp @r4
mov r0,r2
.align 5
ln3995:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3997
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3997:
jmp @r4
mov r0,r2
.align 5
ln3994:
mov.l g2_except_addr3994,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr3994,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl3998
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl3998:
jmp @r4
mov r0,r2
.align 2
g2_except_addr3994: .long group_2_exception
bf_addr3994: .long basefunction
! Opcodes 80D8 - 80DF
S0D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln3999
cmp/hs r3,r1
bt ln4000
mov #15,r4
mov r1,r0
dutloop3999:
bt subd3999
cmp/hs r3,r0
bt/s subhd3999
dt r7
bra divutend3999
dt r7
subhd3999:
bra divutend3999
sub r3,r0
subd3999:
sub r8,r0
divutend3999:
dt r4
bf/s dutloop3999
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4001
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4001:
jmp @r4
mov r0,r2
.align 5
ln4000:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4002
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4002:
jmp @r4
mov r0,r2
.align 5
ln3999:
mov.l g2_except_addr3999,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr3999,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4003
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4003:
jmp @r4
mov r0,r2
.align 2
g2_except_addr3999: .long group_2_exception
bf_addr3999: .long basefunction
! Opcodes 80E0 - 80E7
S0E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4004
cmp/hs r3,r1
bt ln4005
mov #15,r4
mov r1,r0
dutloop4004:
bt subd4004
cmp/hs r3,r0
bt/s subhd4004
dt r7
bra divutend4004
dt r7
subhd4004:
bra divutend4004
sub r3,r0
subd4004:
sub r8,r0
divutend4004:
dt r4
bf/s dutloop4004
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4006
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4006:
jmp @r4
mov r0,r2
.align 5
ln4005:
mov #0x8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4007
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4007:
jmp @r4
mov r0,r2
.align 5
ln4004:
mov.l g2_except_addr4004,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4004,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4008
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4008:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4004: .long group_2_exception
bf_addr4004: .long basefunction
! Opcodes 80E8 - 80EF
S0E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4009
cmp/hs r3,r1
bt ln4010
mov #15,r4
mov r1,r0
dutloop4009:
bt subd4009
cmp/hs r3,r0
bt/s subhd4009
dt r7
bra divutend4009
dt r7
subhd4009:
bra divutend4009
sub r3,r0
subd4009:
sub r8,r0
divutend4009:
dt r4
bf/s dutloop4009
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4011
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4011:
jmp @r4
mov r0,r2
.align 5
ln4010:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4012
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4012:
jmp @r4
mov r0,r2
.align 5
ln4009:
mov.l g2_except_addr4009,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4009,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4013
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4013:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4009: .long group_2_exception
bf_addr4009: .long basefunction
! Opcodes 80F0 - 80F7
S0F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4014
cmp/hs r3,r1
bt ln4015
mov #15,r4
mov r1,r0
dutloop4014:
bt subd4014
cmp/hs r3,r0
bt/s subhd4014
dt r7
bra divutend4014
dt r7
subhd4014:
bra divutend4014
sub r3,r0
subd4014:
sub r8,r0
divutend4014:
dt r4
bf/s dutloop4014
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4016
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4016:
jmp @r4
mov r0,r2
.align 5
ln4015:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4017
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4017:
jmp @r4
mov r0,r2
.align 5
ln4014:
mov.l g2_except_addr4014,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4014,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4018
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4018:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4014: .long group_2_exception
bf_addr4014: .long basefunction
! Opcode 80F8
S0F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4019
cmp/hs r3,r1
bt ln4020
mov #15,r4
mov r1,r0
dutloop4019:
bt subd4019
cmp/hs r3,r0
bt/s subhd4019
dt r7
bra divutend4019
dt r7
subhd4019:
bra divutend4019
sub r3,r0
subd4019:
sub r8,r0
divutend4019:
dt r4
bf/s dutloop4019
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4021
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4021:
jmp @r4
mov r0,r2
.align 5
ln4020:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4022
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4022:
jmp @r4
mov r0,r2
.align 5
ln4019:
mov.l g2_except_addr4019,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4019,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4023
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4023:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4019: .long group_2_exception
bf_addr4019: .long basefunction
! Opcode 80F9
S0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4024
cmp/hs r3,r1
bt ln4025
mov #15,r4
mov r1,r0
dutloop4024:
bt subd4024
cmp/hs r3,r0
bt/s subhd4024
dt r7
bra divutend4024
dt r7
subhd4024:
bra divutend4024
sub r3,r0
subd4024:
sub r8,r0
divutend4024:
dt r4
bf/s dutloop4024
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4026
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4026:
jmp @r4
mov r0,r2
.align 5
ln4025:
mov #0x8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4027
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4027:
jmp @r4
mov r0,r2
.align 5
ln4024:
mov.l g2_except_addr4024,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4024,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4028
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4028:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4024: .long group_2_exception
bf_addr4024: .long basefunction
! Opcode 80FA
S0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4029
cmp/hs r3,r1
bt ln4030
mov #15,r4
mov r1,r0
dutloop4029:
bt subd4029
cmp/hs r3,r0
bt/s subhd4029
dt r7
bra divutend4029
dt r7
subhd4029:
bra divutend4029
sub r3,r0
subd4029:
sub r8,r0
divutend4029:
dt r4
bf/s dutloop4029
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4031
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4031:
jmp @r4
mov r0,r2
.align 5
ln4030:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4032
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4032:
jmp @r4
mov r0,r2
.align 5
ln4029:
mov.l g2_except_addr4029,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4029,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4033
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4033:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4029: .long group_2_exception
bf_addr4029: .long basefunction
! Opcode 80FB
S0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4034
cmp/hs r3,r1
bt ln4035
mov #15,r4
mov r1,r0
dutloop4034:
bt subd4034
cmp/hs r3,r0
bt/s subhd4034
dt r7
bra divutend4034
dt r7
subhd4034:
bra divutend4034
sub r3,r0
subd4034:
sub r8,r0
divutend4034:
dt r4
bf/s dutloop4034
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4036
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4036:
jmp @r4
mov r0,r2
.align 5
ln4035:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4037
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4037:
jmp @r4
mov r0,r2
.align 5
ln4034:
mov.l g2_except_addr4034,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4034,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4038
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4038:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4034: .long group_2_exception
bf_addr4034: .long basefunction
! Opcode 80FC
S0FC:
mov.w @r6+,r3
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4039
cmp/hs r3,r1
bt ln4040
mov #15,r4
mov r1,r0
dutloop4039:
bt subd4039
cmp/hs r3,r0
bt/s subhd4039
dt r7
bra divutend4039
dt r7
subhd4039:
bra divutend4039
sub r3,r0
subd4039:
sub r8,r0
divutend4039:
dt r4
bf/s dutloop4039
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4041
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4041:
jmp @r4
mov r0,r2
.align 5
ln4040:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4042
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4042:
jmp @r4
mov r0,r2
.align 5
ln4039:
mov.l g2_except_addr4039,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4039,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4043
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4043:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4039: .long group_2_exception
bf_addr4039: .long basefunction
! Opcodes 8100 - 8107
S100:
and r1,r2
mov.l r3,@-r15
mov.b @r13,r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4044
add #-6,r8
.nonibadd4044:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4044
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4044:
exts.b r3,r3
mov r9,r8
mov.b r3,@r13
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4045
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4045:
jmp @r4
mov r0,r2
! Opcodes 8108 - 810F
S108:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(32,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4046
add #-6,r8
.nonibadd4046:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4046
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4046:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4047
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4047:
jmp @r4
mov r0,r2
! Opcodes 8110 - 8117
S110:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4048
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4048:
jmp @r4
mov r0,r2
! Opcodes 8118 - 811F
S118:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4049
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4049:
jmp @r4
mov r0,r2
! Opcodes 8120 - 8127
S120:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4050
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4050:
jmp @r4
mov r0,r2
! Opcodes 8128 - 812F
S128:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4051
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4051:
jmp @r4
mov r0,r2
! Opcodes 8130 - 8137
S130:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4052
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4052:
jmp @r4
mov r0,r2
! Opcode 8138
S138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4053
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4053:
jmp @r4
mov r0,r2
! Opcode 8139
S139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4054
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4054:
jmp @r4
mov r0,r2
! Opcodes 8150 - 8157
S150:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4055
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4055:
jmp @r4
mov r0,r2
! Opcodes 8158 - 815F
S158:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4056
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4056:
jmp @r4
mov r0,r2
! Opcodes 8160 - 8167
S160:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4057
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4057:
jmp @r4
mov r0,r2
! Opcodes 8168 - 816F
S168:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4058
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4058:
jmp @r4
mov r0,r2
! Opcodes 8170 - 8177
S170:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4059
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4059:
jmp @r4
mov r0,r2
! Opcode 8178
S178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4060
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4060:
jmp @r4
mov r0,r2
! Opcode 8179
S179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4061
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4061:
jmp @r4
mov r0,r2
! Opcodes 8190 - 8197
S190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4062
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4062:
jmp @r4
mov r0,r2
! Opcodes 8198 - 819F
S198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4063
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4063:
jmp @r4
mov r0,r2
! Opcodes 81A0 - 81A7
S1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4064
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4064:
jmp @r4
mov r0,r2
! Opcodes 81A8 - 81AF
S1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4065
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4065:
jmp @r4
mov r0,r2
! Opcodes 81B0 - 81B7
S1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4066
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4066:
jmp @r4
mov r0,r2
! Opcode 81B8
S1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4067
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4067:
jmp @r4
mov r0,r2
! Opcode 81B9
S1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4068
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4068:
jmp @r4
mov r0,r2
! Opcodes 81C0 - 81C7
S1C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4069
cmp/pz r3
bt/s noidivis4069
mov r3,r2
neg r2,r2
noidivis4069:
cmp/pz r1
bt/s noidivid4069
mov r1,r0
neg r0,r0
noidivid4069:
cmp/hs r2,r0
bt ln4070
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-11,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4071
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4071:
jmp @r4
mov r0,r2
.align 5
ln4070:
mov #0x8,r8
mov.w @r6+,r0
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4072
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4072:
jmp @r4
mov r0,r2
.align 5
ln4069:
mov.l g2_except_addr4069,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4069,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4073
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4073:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4069: .long group_2_exception
bf_addr4069: .long basefunction
! Opcodes 81D0 - 81D7
S1D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4074
cmp/pz r3
bt/s noidivis4074
mov r3,r2
neg r2,r2
noidivis4074:
cmp/pz r1
bt/s noidivid4074
mov r1,r0
neg r0,r0
noidivid4074:
cmp/hs r2,r0
bt ln4075
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4076
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4076:
jmp @r4
mov r0,r2
.align 5
ln4075:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4077
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4077:
jmp @r4
mov r0,r2
.align 5
ln4074:
mov.l g2_except_addr4074,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4074,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4078
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4078:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4074: .long group_2_exception
bf_addr4074: .long basefunction
! Opcodes 81D8 - 81DF
S1D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4079
cmp/pz r3
bt/s noidivis4079
mov r3,r2
neg r2,r2
noidivis4079:
cmp/pz r1
bt/s noidivid4079
mov r1,r0
neg r0,r0
noidivid4079:
cmp/hs r2,r0
bt ln4080
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4081
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4081:
jmp @r4
mov r0,r2
.align 5
ln4080:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4082
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4082:
jmp @r4
mov r0,r2
.align 5
ln4079:
mov.l g2_except_addr4079,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4079,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4083
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4083:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4079: .long group_2_exception
bf_addr4079: .long basefunction
! Opcodes 81E0 - 81E7
S1E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4084
cmp/pz r3
bt/s noidivis4084
mov r3,r2
neg r2,r2
noidivis4084:
cmp/pz r1
bt/s noidivid4084
mov r1,r0
neg r0,r0
noidivid4084:
cmp/hs r2,r0
bt ln4085
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4086
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4086:
jmp @r4
mov r0,r2
.align 5
ln4085:
mov #0x8,r8
mov.w @r6+,r0
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4087
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4087:
jmp @r4
mov r0,r2
.align 5
ln4084:
mov.l g2_except_addr4084,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4084,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4088
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4088:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4084: .long group_2_exception
bf_addr4084: .long basefunction
! Opcodes 81E8 - 81EF
S1E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4089
cmp/pz r3
bt/s noidivis4089
mov r3,r2
neg r2,r2
noidivis4089:
cmp/pz r1
bt/s noidivid4089
mov r1,r0
neg r0,r0
noidivid4089:
cmp/hs r2,r0
bt ln4090
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4091
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4091:
jmp @r4
mov r0,r2
.align 5
ln4090:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4092
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4092:
jmp @r4
mov r0,r2
.align 5
ln4089:
mov.l g2_except_addr4089,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4089,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4093
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4093:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4089: .long group_2_exception
bf_addr4089: .long basefunction
! Opcodes 81F0 - 81F7
S1F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4094
cmp/pz r3
bt/s noidivis4094
mov r3,r2
neg r2,r2
noidivis4094:
cmp/pz r1
bt/s noidivid4094
mov r1,r0
neg r0,r0
noidivid4094:
cmp/hs r2,r0
bt ln4095
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4096
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4096:
jmp @r4
mov r0,r2
.align 5
ln4095:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4097
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4097:
jmp @r4
mov r0,r2
.align 5
ln4094:
mov.l g2_except_addr4094,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4094,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4098
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4098:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4094: .long group_2_exception
bf_addr4094: .long basefunction
! Opcode 81F8
S1F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4099
cmp/pz r3
bt/s noidivis4099
mov r3,r2
neg r2,r2
noidivis4099:
cmp/pz r1
bt/s noidivid4099
mov r1,r0
neg r0,r0
noidivid4099:
cmp/hs r2,r0
bt ln4100
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4101
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4101:
jmp @r4
mov r0,r2
.align 5
ln4100:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4102
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4102:
jmp @r4
mov r0,r2
.align 5
ln4099:
mov.l g2_except_addr4099,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4099,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4103
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4103:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4099: .long group_2_exception
bf_addr4099: .long basefunction
! Opcode 81F9
S1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4104
cmp/pz r3
bt/s noidivis4104
mov r3,r2
neg r2,r2
noidivis4104:
cmp/pz r1
bt/s noidivid4104
mov r1,r0
neg r0,r0
noidivid4104:
cmp/hs r2,r0
bt ln4105
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4106
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4106:
jmp @r4
mov r0,r2
.align 5
ln4105:
mov #0x8,r8
mov.w @r6+,r0
add #-29,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4107
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4107:
jmp @r4
mov r0,r2
.align 5
ln4104:
mov.l g2_except_addr4104,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4104,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4108
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4108:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4104: .long group_2_exception
bf_addr4104: .long basefunction
! Opcode 81FA
S1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4109
cmp/pz r3
bt/s noidivis4109
mov r3,r2
neg r2,r2
noidivis4109:
cmp/pz r1
bt/s noidivid4109
mov r1,r0
neg r0,r0
noidivid4109:
cmp/hs r2,r0
bt ln4110
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4111
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4111:
jmp @r4
mov r0,r2
.align 5
ln4110:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4112
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4112:
jmp @r4
mov r0,r2
.align 5
ln4109:
mov.l g2_except_addr4109,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4109,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4113
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4113:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4109: .long group_2_exception
bf_addr4109: .long basefunction
! Opcode 81FB
S1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4114
cmp/pz r3
bt/s noidivis4114
mov r3,r2
neg r2,r2
noidivis4114:
cmp/pz r1
bt/s noidivid4114
mov r1,r0
neg r0,r0
noidivid4114:
cmp/hs r2,r0
bt ln4115
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4116
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4116:
jmp @r4
mov r0,r2
.align 5
ln4115:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4117
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4117:
jmp @r4
mov r0,r2
.align 5
ln4114:
mov.l g2_except_addr4114,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4114,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4118
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4118:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4114: .long group_2_exception
bf_addr4114: .long basefunction
! Opcode 81FC
S1FC:
mov.w @r6+,r3
mov.l @r13,r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4119
cmp/pz r3
bt/s noidivis4119
mov r3,r2
neg r2,r2
noidivis4119:
cmp/pz r1
bt/s noidivid4119
mov r1,r0
neg r0,r0
noidivid4119:
cmp/hs r2,r0
bt ln4120
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4121
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4121:
jmp @r4
mov r0,r2
.align 5
ln4120:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4122
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4122:
jmp @r4
mov r0,r2
.align 5
ln4119:
mov.l g2_except_addr4119,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4119,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4123
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4123:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4119: .long group_2_exception
bf_addr4119: .long basefunction
! Opcodes 8200 - 8207
S200:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4124
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4124:
jmp @r4
mov r0,r2
! Opcodes 8210 - 8217
S210:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4125
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4125:
jmp @r4
mov r0,r2
! Opcodes 8218 - 821F
S218:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4126
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4126:
jmp @r4
mov r0,r2
! Opcodes 8220 - 8227
S220:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4127
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4127:
jmp @r4
mov r0,r2
! Opcodes 8228 - 822F
S228:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4128
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4128:
jmp @r4
mov r0,r2
! Opcodes 8230 - 8237
S230:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4129
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4129:
jmp @r4
mov r0,r2
! Opcode 8238
S238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4130
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4130:
jmp @r4
mov r0,r2
! Opcode 8239
S239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4131
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4131:
jmp @r4
mov r0,r2
! Opcode 823A
S23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4132
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4132:
jmp @r4
mov r0,r2
! Opcode 823B
S23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4133
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4133:
jmp @r4
mov r0,r2
! Opcode 823C
S23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4134
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4134:
jmp @r4
mov r0,r2
! Opcodes 8240 - 8247
S240:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4135
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4135:
jmp @r4
mov r0,r2
! Opcodes 8250 - 8257
S250:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4136
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4136:
jmp @r4
mov r0,r2
! Opcodes 8258 - 825F
S258:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4137
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4137:
jmp @r4
mov r0,r2
! Opcodes 8260 - 8267
S260:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4138
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4138:
jmp @r4
mov r0,r2
! Opcodes 8268 - 826F
S268:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4139
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4139:
jmp @r4
mov r0,r2
! Opcodes 8270 - 8277
S270:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4140
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4140:
jmp @r4
mov r0,r2
! Opcode 8278
S278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4141
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4141:
jmp @r4
mov r0,r2
! Opcode 8279
S279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4142
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4142:
jmp @r4
mov r0,r2
! Opcode 827A
S27A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4143
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4143:
jmp @r4
mov r0,r2
! Opcode 827B
S27B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4144
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4144:
jmp @r4
mov r0,r2
! Opcode 827C
S27C:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4145
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4145:
jmp @r4
mov r0,r2
! Opcodes 8280 - 8287
S280:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4146
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4146:
jmp @r4
mov r0,r2
! Opcodes 8290 - 8297
S290:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4147
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4147:
jmp @r4
mov r0,r2
! Opcodes 8298 - 829F
S298:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4148
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4148:
jmp @r4
mov r0,r2
! Opcodes 82A0 - 82A7
S2A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4149
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4149:
jmp @r4
mov r0,r2
! Opcodes 82A8 - 82AF
S2A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4150
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4150:
jmp @r4
mov r0,r2
! Opcodes 82B0 - 82B7
S2B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4151
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4151:
jmp @r4
mov r0,r2
! Opcode 82B8
S2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4152
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4152:
jmp @r4
mov r0,r2
! Opcode 82B9
S2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4153
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4153:
jmp @r4
mov r0,r2
! Opcode 82BA
S2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4154
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4154:
jmp @r4
mov r0,r2
! Opcode 82BB
S2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4155
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4155:
jmp @r4
mov r0,r2
! Opcode 82BC
S2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(4,r13),r1
or r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4156
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4156:
jmp @r4
mov r0,r2
! Opcodes 82C0 - 82C7
S2C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4157
cmp/hs r3,r1
bt ln4158
mov #15,r4
mov r1,r0
dutloop4157:
bt subd4157
cmp/hs r3,r0
bt/s subhd4157
dt r7
bra divutend4157
dt r7
subhd4157:
bra divutend4157
sub r3,r0
subd4157:
sub r8,r0
divutend4157:
dt r4
bf/s dutloop4157
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4159
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4159:
jmp @r4
mov r0,r2
.align 5
ln4158:
mov #0x8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4160
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4160:
jmp @r4
mov r0,r2
.align 5
ln4157:
mov.l g2_except_addr4157,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4157,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4161
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4161:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4157: .long group_2_exception
bf_addr4157: .long basefunction
! Opcodes 82D0 - 82D7
S2D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4162
cmp/hs r3,r1
bt ln4163
mov #15,r4
mov r1,r0
dutloop4162:
bt subd4162
cmp/hs r3,r0
bt/s subhd4162
dt r7
bra divutend4162
dt r7
subhd4162:
bra divutend4162
sub r3,r0
subd4162:
sub r8,r0
divutend4162:
dt r4
bf/s dutloop4162
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4164
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4164:
jmp @r4
mov r0,r2
.align 5
ln4163:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4165
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4165:
jmp @r4
mov r0,r2
.align 5
ln4162:
mov.l g2_except_addr4162,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4162,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4166
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4166:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4162: .long group_2_exception
bf_addr4162: .long basefunction
! Opcodes 82D8 - 82DF
S2D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4167
cmp/hs r3,r1
bt ln4168
mov #15,r4
mov r1,r0
dutloop4167:
bt subd4167
cmp/hs r3,r0
bt/s subhd4167
dt r7
bra divutend4167
dt r7
subhd4167:
bra divutend4167
sub r3,r0
subd4167:
sub r8,r0
divutend4167:
dt r4
bf/s dutloop4167
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4169
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4169:
jmp @r4
mov r0,r2
.align 5
ln4168:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4170
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4170:
jmp @r4
mov r0,r2
.align 5
ln4167:
mov.l g2_except_addr4167,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4167,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4171
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4171:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4167: .long group_2_exception
bf_addr4167: .long basefunction
! Opcodes 82E0 - 82E7
S2E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4172
cmp/hs r3,r1
bt ln4173
mov #15,r4
mov r1,r0
dutloop4172:
bt subd4172
cmp/hs r3,r0
bt/s subhd4172
dt r7
bra divutend4172
dt r7
subhd4172:
bra divutend4172
sub r3,r0
subd4172:
sub r8,r0
divutend4172:
dt r4
bf/s dutloop4172
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4174
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4174:
jmp @r4
mov r0,r2
.align 5
ln4173:
mov #0x8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4175
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4175:
jmp @r4
mov r0,r2
.align 5
ln4172:
mov.l g2_except_addr4172,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4172,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4176
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4176:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4172: .long group_2_exception
bf_addr4172: .long basefunction
! Opcodes 82E8 - 82EF
S2E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4177
cmp/hs r3,r1
bt ln4178
mov #15,r4
mov r1,r0
dutloop4177:
bt subd4177
cmp/hs r3,r0
bt/s subhd4177
dt r7
bra divutend4177
dt r7
subhd4177:
bra divutend4177
sub r3,r0
subd4177:
sub r8,r0
divutend4177:
dt r4
bf/s dutloop4177
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4179
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4179:
jmp @r4
mov r0,r2
.align 5
ln4178:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4180
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4180:
jmp @r4
mov r0,r2
.align 5
ln4177:
mov.l g2_except_addr4177,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4177,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4181
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4181:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4177: .long group_2_exception
bf_addr4177: .long basefunction
! Opcodes 82F0 - 82F7
S2F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4182
cmp/hs r3,r1
bt ln4183
mov #15,r4
mov r1,r0
dutloop4182:
bt subd4182
cmp/hs r3,r0
bt/s subhd4182
dt r7
bra divutend4182
dt r7
subhd4182:
bra divutend4182
sub r3,r0
subd4182:
sub r8,r0
divutend4182:
dt r4
bf/s dutloop4182
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4184
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4184:
jmp @r4
mov r0,r2
.align 5
ln4183:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4185
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4185:
jmp @r4
mov r0,r2
.align 5
ln4182:
mov.l g2_except_addr4182,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4182,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4186
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4186:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4182: .long group_2_exception
bf_addr4182: .long basefunction
! Opcode 82F8
S2F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4187
cmp/hs r3,r1
bt ln4188
mov #15,r4
mov r1,r0
dutloop4187:
bt subd4187
cmp/hs r3,r0
bt/s subhd4187
dt r7
bra divutend4187
dt r7
subhd4187:
bra divutend4187
sub r3,r0
subd4187:
sub r8,r0
divutend4187:
dt r4
bf/s dutloop4187
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4189
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4189:
jmp @r4
mov r0,r2
.align 5
ln4188:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4190
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4190:
jmp @r4
mov r0,r2
.align 5
ln4187:
mov.l g2_except_addr4187,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4187,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4191
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4191:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4187: .long group_2_exception
bf_addr4187: .long basefunction
! Opcode 82F9
S2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4192
cmp/hs r3,r1
bt ln4193
mov #15,r4
mov r1,r0
dutloop4192:
bt subd4192
cmp/hs r3,r0
bt/s subhd4192
dt r7
bra divutend4192
dt r7
subhd4192:
bra divutend4192
sub r3,r0
subd4192:
sub r8,r0
divutend4192:
dt r4
bf/s dutloop4192
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4194
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4194:
jmp @r4
mov r0,r2
.align 5
ln4193:
mov #0x8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4195
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4195:
jmp @r4
mov r0,r2
.align 5
ln4192:
mov.l g2_except_addr4192,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4192,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4196
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4196:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4192: .long group_2_exception
bf_addr4192: .long basefunction
! Opcode 82FA
S2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4197
cmp/hs r3,r1
bt ln4198
mov #15,r4
mov r1,r0
dutloop4197:
bt subd4197
cmp/hs r3,r0
bt/s subhd4197
dt r7
bra divutend4197
dt r7
subhd4197:
bra divutend4197
sub r3,r0
subd4197:
sub r8,r0
divutend4197:
dt r4
bf/s dutloop4197
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4199
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4199:
jmp @r4
mov r0,r2
.align 5
ln4198:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4200
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4200:
jmp @r4
mov r0,r2
.align 5
ln4197:
mov.l g2_except_addr4197,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4197,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4201
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4201:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4197: .long group_2_exception
bf_addr4197: .long basefunction
! Opcode 82FB
S2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4202
cmp/hs r3,r1
bt ln4203
mov #15,r4
mov r1,r0
dutloop4202:
bt subd4202
cmp/hs r3,r0
bt/s subhd4202
dt r7
bra divutend4202
dt r7
subhd4202:
bra divutend4202
sub r3,r0
subd4202:
sub r8,r0
divutend4202:
dt r4
bf/s dutloop4202
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4204
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4204:
jmp @r4
mov r0,r2
.align 5
ln4203:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4205
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4205:
jmp @r4
mov r0,r2
.align 5
ln4202:
mov.l g2_except_addr4202,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4202,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4206
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4206:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4202: .long group_2_exception
bf_addr4202: .long basefunction
! Opcode 82FC
S2FC:
mov.w @r6+,r3
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4207
cmp/hs r3,r1
bt ln4208
mov #15,r4
mov r1,r0
dutloop4207:
bt subd4207
cmp/hs r3,r0
bt/s subhd4207
dt r7
bra divutend4207
dt r7
subhd4207:
bra divutend4207
sub r3,r0
subd4207:
sub r8,r0
divutend4207:
dt r4
bf/s dutloop4207
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4209
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4209:
jmp @r4
mov r0,r2
.align 5
ln4208:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4210
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4210:
jmp @r4
mov r0,r2
.align 5
ln4207:
mov.l g2_except_addr4207,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4207,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4211
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4211:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4207: .long group_2_exception
bf_addr4207: .long basefunction
! Opcodes 8300 - 8307
S300:
and r1,r2
mov.l r3,@-r15
mov #4,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4212
add #-6,r8
.nonibadd4212:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4212
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4212:
exts.b r3,r3
mov r9,r8
mov #4,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4213
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4213:
jmp @r4
mov r0,r2
! Opcodes 8308 - 830F
S308:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(36,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4214
add #-6,r8
.nonibadd4214:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4214
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4214:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4215
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4215:
jmp @r4
mov r0,r2
! Opcodes 8310 - 8317
S310:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4216
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4216:
jmp @r4
mov r0,r2
! Opcodes 8318 - 831F
S318:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4217
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4217:
jmp @r4
mov r0,r2
! Opcodes 8320 - 8327
S320:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4218
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4218:
jmp @r4
mov r0,r2
! Opcodes 8328 - 832F
S328:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4219
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4219:
jmp @r4
mov r0,r2
! Opcodes 8330 - 8337
S330:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4220
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4220:
jmp @r4
mov r0,r2
! Opcode 8338
S338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4221
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4221:
jmp @r4
mov r0,r2
! Opcode 8339
S339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4222
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4222:
jmp @r4
mov r0,r2
! Opcodes 8350 - 8357
S350:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4223
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4223:
jmp @r4
mov r0,r2
! Opcodes 8358 - 835F
S358:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4224
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4224:
jmp @r4
mov r0,r2
! Opcodes 8360 - 8367
S360:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4225
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4225:
jmp @r4
mov r0,r2
! Opcodes 8368 - 836F
S368:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4226
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4226:
jmp @r4
mov r0,r2
! Opcodes 8370 - 8377
S370:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4227
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4227:
jmp @r4
mov r0,r2
! Opcode 8378
S378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4228
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4228:
jmp @r4
mov r0,r2
! Opcode 8379
S379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4229
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4229:
jmp @r4
mov r0,r2
! Opcodes 8390 - 8397
S390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4230
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4230:
jmp @r4
mov r0,r2
! Opcodes 8398 - 839F
S398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4231
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4231:
jmp @r4
mov r0,r2
! Opcodes 83A0 - 83A7
S3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4232
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4232:
jmp @r4
mov r0,r2
! Opcodes 83A8 - 83AF
S3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4233
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4233:
jmp @r4
mov r0,r2
! Opcodes 83B0 - 83B7
S3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4234
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4234:
jmp @r4
mov r0,r2
! Opcode 83B8
S3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4235
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4235:
jmp @r4
mov r0,r2
! Opcode 83B9
S3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4236
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4236:
jmp @r4
mov r0,r2
! Opcodes 83C0 - 83C7
S3C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4237
cmp/pz r3
bt/s noidivis4237
mov r3,r2
neg r2,r2
noidivis4237:
cmp/pz r1
bt/s noidivid4237
mov r1,r0
neg r0,r0
noidivid4237:
cmp/hs r2,r0
bt ln4238
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-11,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4239
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4239:
jmp @r4
mov r0,r2
.align 5
ln4238:
mov #0x8,r8
mov.w @r6+,r0
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4240
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4240:
jmp @r4
mov r0,r2
.align 5
ln4237:
mov.l g2_except_addr4237,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4237,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4241
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4241:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4237: .long group_2_exception
bf_addr4237: .long basefunction
! Opcodes 83D0 - 83D7
S3D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4242
cmp/pz r3
bt/s noidivis4242
mov r3,r2
neg r2,r2
noidivis4242:
cmp/pz r1
bt/s noidivid4242
mov r1,r0
neg r0,r0
noidivid4242:
cmp/hs r2,r0
bt ln4243
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4244
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4244:
jmp @r4
mov r0,r2
.align 5
ln4243:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4245
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4245:
jmp @r4
mov r0,r2
.align 5
ln4242:
mov.l g2_except_addr4242,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4242,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4246
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4246:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4242: .long group_2_exception
bf_addr4242: .long basefunction
! Opcodes 83D8 - 83DF
S3D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4247
cmp/pz r3
bt/s noidivis4247
mov r3,r2
neg r2,r2
noidivis4247:
cmp/pz r1
bt/s noidivid4247
mov r1,r0
neg r0,r0
noidivid4247:
cmp/hs r2,r0
bt ln4248
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4249
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4249:
jmp @r4
mov r0,r2
.align 5
ln4248:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4250
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4250:
jmp @r4
mov r0,r2
.align 5
ln4247:
mov.l g2_except_addr4247,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4247,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4251
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4251:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4247: .long group_2_exception
bf_addr4247: .long basefunction
! Opcodes 83E0 - 83E7
S3E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4252
cmp/pz r3
bt/s noidivis4252
mov r3,r2
neg r2,r2
noidivis4252:
cmp/pz r1
bt/s noidivid4252
mov r1,r0
neg r0,r0
noidivid4252:
cmp/hs r2,r0
bt ln4253
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4254
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4254:
jmp @r4
mov r0,r2
.align 5
ln4253:
mov #0x8,r8
mov.w @r6+,r0
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4255
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4255:
jmp @r4
mov r0,r2
.align 5
ln4252:
mov.l g2_except_addr4252,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4252,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4256
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4256:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4252: .long group_2_exception
bf_addr4252: .long basefunction
! Opcodes 83E8 - 83EF
S3E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4257
cmp/pz r3
bt/s noidivis4257
mov r3,r2
neg r2,r2
noidivis4257:
cmp/pz r1
bt/s noidivid4257
mov r1,r0
neg r0,r0
noidivid4257:
cmp/hs r2,r0
bt ln4258
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4259
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4259:
jmp @r4
mov r0,r2
.align 5
ln4258:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4260
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4260:
jmp @r4
mov r0,r2
.align 5
ln4257:
mov.l g2_except_addr4257,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4257,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4261
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4261:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4257: .long group_2_exception
bf_addr4257: .long basefunction
! Opcodes 83F0 - 83F7
S3F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4262
cmp/pz r3
bt/s noidivis4262
mov r3,r2
neg r2,r2
noidivis4262:
cmp/pz r1
bt/s noidivid4262
mov r1,r0
neg r0,r0
noidivid4262:
cmp/hs r2,r0
bt ln4263
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4264
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4264:
jmp @r4
mov r0,r2
.align 5
ln4263:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4265
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4265:
jmp @r4
mov r0,r2
.align 5
ln4262:
mov.l g2_except_addr4262,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4262,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4266
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4266:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4262: .long group_2_exception
bf_addr4262: .long basefunction
! Opcode 83F8
S3F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4267
cmp/pz r3
bt/s noidivis4267
mov r3,r2
neg r2,r2
noidivis4267:
cmp/pz r1
bt/s noidivid4267
mov r1,r0
neg r0,r0
noidivid4267:
cmp/hs r2,r0
bt ln4268
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4269
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4269:
jmp @r4
mov r0,r2
.align 5
ln4268:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4270
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4270:
jmp @r4
mov r0,r2
.align 5
ln4267:
mov.l g2_except_addr4267,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4267,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4271
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4271:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4267: .long group_2_exception
bf_addr4267: .long basefunction
! Opcode 83F9
S3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4272
cmp/pz r3
bt/s noidivis4272
mov r3,r2
neg r2,r2
noidivis4272:
cmp/pz r1
bt/s noidivid4272
mov r1,r0
neg r0,r0
noidivid4272:
cmp/hs r2,r0
bt ln4273
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4274
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4274:
jmp @r4
mov r0,r2
.align 5
ln4273:
mov #0x8,r8
mov.w @r6+,r0
add #-29,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4275
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4275:
jmp @r4
mov r0,r2
.align 5
ln4272:
mov.l g2_except_addr4272,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4272,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4276
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4276:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4272: .long group_2_exception
bf_addr4272: .long basefunction
! Opcode 83FA
S3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4277
cmp/pz r3
bt/s noidivis4277
mov r3,r2
neg r2,r2
noidivis4277:
cmp/pz r1
bt/s noidivid4277
mov r1,r0
neg r0,r0
noidivid4277:
cmp/hs r2,r0
bt ln4278
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4279
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4279:
jmp @r4
mov r0,r2
.align 5
ln4278:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4280
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4280:
jmp @r4
mov r0,r2
.align 5
ln4277:
mov.l g2_except_addr4277,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4277,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4281
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4281:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4277: .long group_2_exception
bf_addr4277: .long basefunction
! Opcode 83FB
S3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4282
cmp/pz r3
bt/s noidivis4282
mov r3,r2
neg r2,r2
noidivis4282:
cmp/pz r1
bt/s noidivid4282
mov r1,r0
neg r0,r0
noidivid4282:
cmp/hs r2,r0
bt ln4283
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4284
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4284:
jmp @r4
mov r0,r2
.align 5
ln4283:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4285
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4285:
jmp @r4
mov r0,r2
.align 5
ln4282:
mov.l g2_except_addr4282,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4282,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4286
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4286:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4282: .long group_2_exception
bf_addr4282: .long basefunction
! Opcode 83FC
S3FC:
mov.w @r6+,r3
mov.l @(4,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4287
cmp/pz r3
bt/s noidivis4287
mov r3,r2
neg r2,r2
noidivis4287:
cmp/pz r1
bt/s noidivid4287
mov r1,r0
neg r0,r0
noidivid4287:
cmp/hs r2,r0
bt ln4288
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(4,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4289
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4289:
jmp @r4
mov r0,r2
.align 5
ln4288:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4290
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4290:
jmp @r4
mov r0,r2
.align 5
ln4287:
mov.l g2_except_addr4287,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4287,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4291
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4291:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4287: .long group_2_exception
bf_addr4287: .long basefunction
! Opcodes 8400 - 8407
S400:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4292
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4292:
jmp @r4
mov r0,r2
! Opcodes 8410 - 8417
S410:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4293
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4293:
jmp @r4
mov r0,r2
! Opcodes 8418 - 841F
S418:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4294
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4294:
jmp @r4
mov r0,r2
! Opcodes 8420 - 8427
S420:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4295
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4295:
jmp @r4
mov r0,r2
! Opcodes 8428 - 842F
S428:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4296
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4296:
jmp @r4
mov r0,r2
! Opcodes 8430 - 8437
S430:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4297
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4297:
jmp @r4
mov r0,r2
! Opcode 8438
S438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4298
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4298:
jmp @r4
mov r0,r2
! Opcode 8439
S439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4299
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4299:
jmp @r4
mov r0,r2
! Opcode 843A
S43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4300
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4300:
jmp @r4
mov r0,r2
! Opcode 843B
S43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4301
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4301:
jmp @r4
mov r0,r2
! Opcode 843C
S43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4302
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4302:
jmp @r4
mov r0,r2
! Opcodes 8440 - 8447
S440:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4303
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4303:
jmp @r4
mov r0,r2
! Opcodes 8450 - 8457
S450:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4304
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4304:
jmp @r4
mov r0,r2
! Opcodes 8458 - 845F
S458:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4305
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4305:
jmp @r4
mov r0,r2
! Opcodes 8460 - 8467
S460:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4306
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4306:
jmp @r4
mov r0,r2
! Opcodes 8468 - 846F
S468:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4307
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4307:
jmp @r4
mov r0,r2
! Opcodes 8470 - 8477
S470:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4308
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4308:
jmp @r4
mov r0,r2
! Opcode 8478
S478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4309
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4309:
jmp @r4
mov r0,r2
! Opcode 8479
S479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4310
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4310:
jmp @r4
mov r0,r2
! Opcode 847A
S47A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4311
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4311:
jmp @r4
mov r0,r2
! Opcode 847B
S47B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4312
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4312:
jmp @r4
mov r0,r2
! Opcode 847C
S47C:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4313
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4313:
jmp @r4
mov r0,r2
! Opcodes 8480 - 8487
S480:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4314
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4314:
jmp @r4
mov r0,r2
! Opcodes 8490 - 8497
S490:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4315
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4315:
jmp @r4
mov r0,r2
! Opcodes 8498 - 849F
S498:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4316
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4316:
jmp @r4
mov r0,r2
! Opcodes 84A0 - 84A7
S4A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4317
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4317:
jmp @r4
mov r0,r2
! Opcodes 84A8 - 84AF
S4A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4318
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4318:
jmp @r4
mov r0,r2
! Opcodes 84B0 - 84B7
S4B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4319
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4319:
jmp @r4
mov r0,r2
! Opcode 84B8
S4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4320
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4320:
jmp @r4
mov r0,r2
! Opcode 84B9
S4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4321
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4321:
jmp @r4
mov r0,r2
! Opcode 84BA
S4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4322
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4322:
jmp @r4
mov r0,r2
! Opcode 84BB
S4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4323
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4323:
jmp @r4
mov r0,r2
! Opcode 84BC
S4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(8,r13),r1
or r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4324
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4324:
jmp @r4
mov r0,r2
! Opcodes 84C0 - 84C7
S4C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4325
cmp/hs r3,r1
bt ln4326
mov #15,r4
mov r1,r0
dutloop4325:
bt subd4325
cmp/hs r3,r0
bt/s subhd4325
dt r7
bra divutend4325
dt r7
subhd4325:
bra divutend4325
sub r3,r0
subd4325:
sub r8,r0
divutend4325:
dt r4
bf/s dutloop4325
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4327
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4327:
jmp @r4
mov r0,r2
.align 5
ln4326:
mov #0x8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4328
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4328:
jmp @r4
mov r0,r2
.align 5
ln4325:
mov.l g2_except_addr4325,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4325,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4329
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4329:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4325: .long group_2_exception
bf_addr4325: .long basefunction
! Opcodes 84D0 - 84D7
S4D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4330
cmp/hs r3,r1
bt ln4331
mov #15,r4
mov r1,r0
dutloop4330:
bt subd4330
cmp/hs r3,r0
bt/s subhd4330
dt r7
bra divutend4330
dt r7
subhd4330:
bra divutend4330
sub r3,r0
subd4330:
sub r8,r0
divutend4330:
dt r4
bf/s dutloop4330
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4332
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4332:
jmp @r4
mov r0,r2
.align 5
ln4331:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4333
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4333:
jmp @r4
mov r0,r2
.align 5
ln4330:
mov.l g2_except_addr4330,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4330,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4334
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4334:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4330: .long group_2_exception
bf_addr4330: .long basefunction
! Opcodes 84D8 - 84DF
S4D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4335
cmp/hs r3,r1
bt ln4336
mov #15,r4
mov r1,r0
dutloop4335:
bt subd4335
cmp/hs r3,r0
bt/s subhd4335
dt r7
bra divutend4335
dt r7
subhd4335:
bra divutend4335
sub r3,r0
subd4335:
sub r8,r0
divutend4335:
dt r4
bf/s dutloop4335
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4337
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4337:
jmp @r4
mov r0,r2
.align 5
ln4336:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4338
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4338:
jmp @r4
mov r0,r2
.align 5
ln4335:
mov.l g2_except_addr4335,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4335,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4339
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4339:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4335: .long group_2_exception
bf_addr4335: .long basefunction
! Opcodes 84E0 - 84E7
S4E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4340
cmp/hs r3,r1
bt ln4341
mov #15,r4
mov r1,r0
dutloop4340:
bt subd4340
cmp/hs r3,r0
bt/s subhd4340
dt r7
bra divutend4340
dt r7
subhd4340:
bra divutend4340
sub r3,r0
subd4340:
sub r8,r0
divutend4340:
dt r4
bf/s dutloop4340
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4342
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4342:
jmp @r4
mov r0,r2
.align 5
ln4341:
mov #0x8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4343
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4343:
jmp @r4
mov r0,r2
.align 5
ln4340:
mov.l g2_except_addr4340,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4340,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4344
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4344:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4340: .long group_2_exception
bf_addr4340: .long basefunction
! Opcodes 84E8 - 84EF
S4E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4345
cmp/hs r3,r1
bt ln4346
mov #15,r4
mov r1,r0
dutloop4345:
bt subd4345
cmp/hs r3,r0
bt/s subhd4345
dt r7
bra divutend4345
dt r7
subhd4345:
bra divutend4345
sub r3,r0
subd4345:
sub r8,r0
divutend4345:
dt r4
bf/s dutloop4345
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4347
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4347:
jmp @r4
mov r0,r2
.align 5
ln4346:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4348
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4348:
jmp @r4
mov r0,r2
.align 5
ln4345:
mov.l g2_except_addr4345,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4345,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4349
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4349:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4345: .long group_2_exception
bf_addr4345: .long basefunction
! Opcodes 84F0 - 84F7
S4F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4350
cmp/hs r3,r1
bt ln4351
mov #15,r4
mov r1,r0
dutloop4350:
bt subd4350
cmp/hs r3,r0
bt/s subhd4350
dt r7
bra divutend4350
dt r7
subhd4350:
bra divutend4350
sub r3,r0
subd4350:
sub r8,r0
divutend4350:
dt r4
bf/s dutloop4350
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4352
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4352:
jmp @r4
mov r0,r2
.align 5
ln4351:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4353
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4353:
jmp @r4
mov r0,r2
.align 5
ln4350:
mov.l g2_except_addr4350,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4350,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4354
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4354:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4350: .long group_2_exception
bf_addr4350: .long basefunction
! Opcode 84F8
S4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4355
cmp/hs r3,r1
bt ln4356
mov #15,r4
mov r1,r0
dutloop4355:
bt subd4355
cmp/hs r3,r0
bt/s subhd4355
dt r7
bra divutend4355
dt r7
subhd4355:
bra divutend4355
sub r3,r0
subd4355:
sub r8,r0
divutend4355:
dt r4
bf/s dutloop4355
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4357
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4357:
jmp @r4
mov r0,r2
.align 5
ln4356:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4358
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4358:
jmp @r4
mov r0,r2
.align 5
ln4355:
mov.l g2_except_addr4355,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4355,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4359
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4359:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4355: .long group_2_exception
bf_addr4355: .long basefunction
! Opcode 84F9
S4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4360
cmp/hs r3,r1
bt ln4361
mov #15,r4
mov r1,r0
dutloop4360:
bt subd4360
cmp/hs r3,r0
bt/s subhd4360
dt r7
bra divutend4360
dt r7
subhd4360:
bra divutend4360
sub r3,r0
subd4360:
sub r8,r0
divutend4360:
dt r4
bf/s dutloop4360
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4362
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4362:
jmp @r4
mov r0,r2
.align 5
ln4361:
mov #0x8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4363
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4363:
jmp @r4
mov r0,r2
.align 5
ln4360:
mov.l g2_except_addr4360,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4360,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4364
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4364:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4360: .long group_2_exception
bf_addr4360: .long basefunction
! Opcode 84FA
S4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4365
cmp/hs r3,r1
bt ln4366
mov #15,r4
mov r1,r0
dutloop4365:
bt subd4365
cmp/hs r3,r0
bt/s subhd4365
dt r7
bra divutend4365
dt r7
subhd4365:
bra divutend4365
sub r3,r0
subd4365:
sub r8,r0
divutend4365:
dt r4
bf/s dutloop4365
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4367
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4367:
jmp @r4
mov r0,r2
.align 5
ln4366:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4368
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4368:
jmp @r4
mov r0,r2
.align 5
ln4365:
mov.l g2_except_addr4365,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4365,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4369
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4369:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4365: .long group_2_exception
bf_addr4365: .long basefunction
! Opcode 84FB
S4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4370
cmp/hs r3,r1
bt ln4371
mov #15,r4
mov r1,r0
dutloop4370:
bt subd4370
cmp/hs r3,r0
bt/s subhd4370
dt r7
bra divutend4370
dt r7
subhd4370:
bra divutend4370
sub r3,r0
subd4370:
sub r8,r0
divutend4370:
dt r4
bf/s dutloop4370
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4372
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4372:
jmp @r4
mov r0,r2
.align 5
ln4371:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4373
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4373:
jmp @r4
mov r0,r2
.align 5
ln4370:
mov.l g2_except_addr4370,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4370,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4374
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4374:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4370: .long group_2_exception
bf_addr4370: .long basefunction
! Opcode 84FC
S4FC:
mov.w @r6+,r3
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4375
cmp/hs r3,r1
bt ln4376
mov #15,r4
mov r1,r0
dutloop4375:
bt subd4375
cmp/hs r3,r0
bt/s subhd4375
dt r7
bra divutend4375
dt r7
subhd4375:
bra divutend4375
sub r3,r0
subd4375:
sub r8,r0
divutend4375:
dt r4
bf/s dutloop4375
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4377
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4377:
jmp @r4
mov r0,r2
.align 5
ln4376:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4378
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4378:
jmp @r4
mov r0,r2
.align 5
ln4375:
mov.l g2_except_addr4375,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4375,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4379
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4379:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4375: .long group_2_exception
bf_addr4375: .long basefunction
! Opcodes 8500 - 8507
S500:
and r1,r2
mov.l r3,@-r15
mov #8,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4380
add #-6,r8
.nonibadd4380:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4380
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4380:
exts.b r3,r3
mov r9,r8
mov #8,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4381
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4381:
jmp @r4
mov r0,r2
! Opcodes 8508 - 850F
S508:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(40,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4382
add #-6,r8
.nonibadd4382:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4382
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4382:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4383
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4383:
jmp @r4
mov r0,r2
! Opcodes 8510 - 8517
S510:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4384
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4384:
jmp @r4
mov r0,r2
! Opcodes 8518 - 851F
S518:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4385
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4385:
jmp @r4
mov r0,r2
! Opcodes 8520 - 8527
S520:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4386
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4386:
jmp @r4
mov r0,r2
! Opcodes 8528 - 852F
S528:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4387
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4387:
jmp @r4
mov r0,r2
! Opcodes 8530 - 8537
S530:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4388
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4388:
jmp @r4
mov r0,r2
! Opcode 8538
S538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4389
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4389:
jmp @r4
mov r0,r2
! Opcode 8539
S539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4390
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4390:
jmp @r4
mov r0,r2
! Opcodes 8550 - 8557
S550:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4391
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4391:
jmp @r4
mov r0,r2
! Opcodes 8558 - 855F
S558:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4392
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4392:
jmp @r4
mov r0,r2
! Opcodes 8560 - 8567
S560:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4393
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4393:
jmp @r4
mov r0,r2
! Opcodes 8568 - 856F
S568:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4394
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4394:
jmp @r4
mov r0,r2
! Opcodes 8570 - 8577
S570:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4395
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4395:
jmp @r4
mov r0,r2
! Opcode 8578
S578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4396
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4396:
jmp @r4
mov r0,r2
! Opcode 8579
S579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4397
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4397:
jmp @r4
mov r0,r2
! Opcodes 8590 - 8597
S590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4398
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4398:
jmp @r4
mov r0,r2
! Opcodes 8598 - 859F
S598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4399
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4399:
jmp @r4
mov r0,r2
! Opcodes 85A0 - 85A7
S5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4400
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4400:
jmp @r4
mov r0,r2
! Opcodes 85A8 - 85AF
S5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4401
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4401:
jmp @r4
mov r0,r2
! Opcodes 85B0 - 85B7
S5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4402
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4402:
jmp @r4
mov r0,r2
! Opcode 85B8
S5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4403
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4403:
jmp @r4
mov r0,r2
! Opcode 85B9
S5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4404
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4404:
jmp @r4
mov r0,r2
! Opcodes 85C0 - 85C7
S5C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4405
cmp/pz r3
bt/s noidivis4405
mov r3,r2
neg r2,r2
noidivis4405:
cmp/pz r1
bt/s noidivid4405
mov r1,r0
neg r0,r0
noidivid4405:
cmp/hs r2,r0
bt ln4406
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-11,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4407
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4407:
jmp @r4
mov r0,r2
.align 5
ln4406:
mov #0x8,r8
mov.w @r6+,r0
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4408
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4408:
jmp @r4
mov r0,r2
.align 5
ln4405:
mov.l g2_except_addr4405,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4405,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4409
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4409:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4405: .long group_2_exception
bf_addr4405: .long basefunction
! Opcodes 85D0 - 85D7
S5D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4410
cmp/pz r3
bt/s noidivis4410
mov r3,r2
neg r2,r2
noidivis4410:
cmp/pz r1
bt/s noidivid4410
mov r1,r0
neg r0,r0
noidivid4410:
cmp/hs r2,r0
bt ln4411
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4412
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4412:
jmp @r4
mov r0,r2
.align 5
ln4411:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4413
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4413:
jmp @r4
mov r0,r2
.align 5
ln4410:
mov.l g2_except_addr4410,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4410,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4414
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4414:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4410: .long group_2_exception
bf_addr4410: .long basefunction
! Opcodes 85D8 - 85DF
S5D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4415
cmp/pz r3
bt/s noidivis4415
mov r3,r2
neg r2,r2
noidivis4415:
cmp/pz r1
bt/s noidivid4415
mov r1,r0
neg r0,r0
noidivid4415:
cmp/hs r2,r0
bt ln4416
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4417
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4417:
jmp @r4
mov r0,r2
.align 5
ln4416:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4418
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4418:
jmp @r4
mov r0,r2
.align 5
ln4415:
mov.l g2_except_addr4415,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4415,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4419
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4419:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4415: .long group_2_exception
bf_addr4415: .long basefunction
! Opcodes 85E0 - 85E7
S5E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4420
cmp/pz r3
bt/s noidivis4420
mov r3,r2
neg r2,r2
noidivis4420:
cmp/pz r1
bt/s noidivid4420
mov r1,r0
neg r0,r0
noidivid4420:
cmp/hs r2,r0
bt ln4421
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4422
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4422:
jmp @r4
mov r0,r2
.align 5
ln4421:
mov #0x8,r8
mov.w @r6+,r0
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4423
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4423:
jmp @r4
mov r0,r2
.align 5
ln4420:
mov.l g2_except_addr4420,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4420,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4424
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4424:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4420: .long group_2_exception
bf_addr4420: .long basefunction
! Opcodes 85E8 - 85EF
S5E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4425
cmp/pz r3
bt/s noidivis4425
mov r3,r2
neg r2,r2
noidivis4425:
cmp/pz r1
bt/s noidivid4425
mov r1,r0
neg r0,r0
noidivid4425:
cmp/hs r2,r0
bt ln4426
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4427
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4427:
jmp @r4
mov r0,r2
.align 5
ln4426:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4428
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4428:
jmp @r4
mov r0,r2
.align 5
ln4425:
mov.l g2_except_addr4425,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4425,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4429
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4429:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4425: .long group_2_exception
bf_addr4425: .long basefunction
! Opcodes 85F0 - 85F7
S5F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4430
cmp/pz r3
bt/s noidivis4430
mov r3,r2
neg r2,r2
noidivis4430:
cmp/pz r1
bt/s noidivid4430
mov r1,r0
neg r0,r0
noidivid4430:
cmp/hs r2,r0
bt ln4431
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4432
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4432:
jmp @r4
mov r0,r2
.align 5
ln4431:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4433
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4433:
jmp @r4
mov r0,r2
.align 5
ln4430:
mov.l g2_except_addr4430,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4430,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4434
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4434:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4430: .long group_2_exception
bf_addr4430: .long basefunction
! Opcode 85F8
S5F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4435
cmp/pz r3
bt/s noidivis4435
mov r3,r2
neg r2,r2
noidivis4435:
cmp/pz r1
bt/s noidivid4435
mov r1,r0
neg r0,r0
noidivid4435:
cmp/hs r2,r0
bt ln4436
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4437
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4437:
jmp @r4
mov r0,r2
.align 5
ln4436:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4438
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4438:
jmp @r4
mov r0,r2
.align 5
ln4435:
mov.l g2_except_addr4435,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4435,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4439
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4439:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4435: .long group_2_exception
bf_addr4435: .long basefunction
! Opcode 85F9
S5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4440
cmp/pz r3
bt/s noidivis4440
mov r3,r2
neg r2,r2
noidivis4440:
cmp/pz r1
bt/s noidivid4440
mov r1,r0
neg r0,r0
noidivid4440:
cmp/hs r2,r0
bt ln4441
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4442
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4442:
jmp @r4
mov r0,r2
.align 5
ln4441:
mov #0x8,r8
mov.w @r6+,r0
add #-29,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4443
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4443:
jmp @r4
mov r0,r2
.align 5
ln4440:
mov.l g2_except_addr4440,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4440,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4444
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4444:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4440: .long group_2_exception
bf_addr4440: .long basefunction
! Opcode 85FA
S5FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4445
cmp/pz r3
bt/s noidivis4445
mov r3,r2
neg r2,r2
noidivis4445:
cmp/pz r1
bt/s noidivid4445
mov r1,r0
neg r0,r0
noidivid4445:
cmp/hs r2,r0
bt ln4446
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4447
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4447:
jmp @r4
mov r0,r2
.align 5
ln4446:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4448
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4448:
jmp @r4
mov r0,r2
.align 5
ln4445:
mov.l g2_except_addr4445,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4445,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4449
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4449:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4445: .long group_2_exception
bf_addr4445: .long basefunction
! Opcode 85FB
S5FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4450
cmp/pz r3
bt/s noidivis4450
mov r3,r2
neg r2,r2
noidivis4450:
cmp/pz r1
bt/s noidivid4450
mov r1,r0
neg r0,r0
noidivid4450:
cmp/hs r2,r0
bt ln4451
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4452
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4452:
jmp @r4
mov r0,r2
.align 5
ln4451:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4453
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4453:
jmp @r4
mov r0,r2
.align 5
ln4450:
mov.l g2_except_addr4450,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4450,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4454
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4454:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4450: .long group_2_exception
bf_addr4450: .long basefunction
! Opcode 85FC
S5FC:
mov.w @r6+,r3
mov.l @(8,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4455
cmp/pz r3
bt/s noidivis4455
mov r3,r2
neg r2,r2
noidivis4455:
cmp/pz r1
bt/s noidivid4455
mov r1,r0
neg r0,r0
noidivid4455:
cmp/hs r2,r0
bt ln4456
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(8,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4457
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4457:
jmp @r4
mov r0,r2
.align 5
ln4456:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4458
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4458:
jmp @r4
mov r0,r2
.align 5
ln4455:
mov.l g2_except_addr4455,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4455,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4459
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4459:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4455: .long group_2_exception
bf_addr4455: .long basefunction
! Opcodes 8600 - 8607
S600:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4460
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4460:
jmp @r4
mov r0,r2
! Opcodes 8610 - 8617
S610:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4461
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4461:
jmp @r4
mov r0,r2
! Opcodes 8618 - 861F
S618:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4462
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4462:
jmp @r4
mov r0,r2
! Opcodes 8620 - 8627
S620:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4463
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4463:
jmp @r4
mov r0,r2
! Opcodes 8628 - 862F
S628:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4464
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4464:
jmp @r4
mov r0,r2
! Opcodes 8630 - 8637
S630:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4465
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4465:
jmp @r4
mov r0,r2
! Opcode 8638
S638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4466
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4466:
jmp @r4
mov r0,r2
! Opcode 8639
S639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4467
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4467:
jmp @r4
mov r0,r2
! Opcode 863A
S63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4468
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4468:
jmp @r4
mov r0,r2
! Opcode 863B
S63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4469
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4469:
jmp @r4
mov r0,r2
! Opcode 863C
S63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4470
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4470:
jmp @r4
mov r0,r2
! Opcodes 8640 - 8647
S640:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4471
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4471:
jmp @r4
mov r0,r2
! Opcodes 8650 - 8657
S650:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4472
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4472:
jmp @r4
mov r0,r2
! Opcodes 8658 - 865F
S658:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4473
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4473:
jmp @r4
mov r0,r2
! Opcodes 8660 - 8667
S660:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4474
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4474:
jmp @r4
mov r0,r2
! Opcodes 8668 - 866F
S668:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4475
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4475:
jmp @r4
mov r0,r2
! Opcodes 8670 - 8677
S670:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4476
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4476:
jmp @r4
mov r0,r2
! Opcode 8678
S678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4477
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4477:
jmp @r4
mov r0,r2
! Opcode 8679
S679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4478
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4478:
jmp @r4
mov r0,r2
! Opcode 867A
S67A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4479
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4479:
jmp @r4
mov r0,r2
! Opcode 867B
S67B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4480
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4480:
jmp @r4
mov r0,r2
! Opcode 867C
S67C:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4481
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4481:
jmp @r4
mov r0,r2
! Opcodes 8680 - 8687
S680:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4482
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4482:
jmp @r4
mov r0,r2
! Opcodes 8690 - 8697
S690:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4483
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4483:
jmp @r4
mov r0,r2
! Opcodes 8698 - 869F
S698:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4484
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4484:
jmp @r4
mov r0,r2
! Opcodes 86A0 - 86A7
S6A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4485
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4485:
jmp @r4
mov r0,r2
! Opcodes 86A8 - 86AF
S6A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4486
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4486:
jmp @r4
mov r0,r2
! Opcodes 86B0 - 86B7
S6B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4487
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4487:
jmp @r4
mov r0,r2
! Opcode 86B8
S6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4488
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4488:
jmp @r4
mov r0,r2
! Opcode 86B9
S6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4489
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4489:
jmp @r4
mov r0,r2
! Opcode 86BA
S6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4490
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4490:
jmp @r4
mov r0,r2
! Opcode 86BB
S6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4491
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4491:
jmp @r4
mov r0,r2
! Opcode 86BC
S6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(12,r13),r1
or r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4492
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4492:
jmp @r4
mov r0,r2
! Opcodes 86C0 - 86C7
S6C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4493
cmp/hs r3,r1
bt ln4494
mov #15,r4
mov r1,r0
dutloop4493:
bt subd4493
cmp/hs r3,r0
bt/s subhd4493
dt r7
bra divutend4493
dt r7
subhd4493:
bra divutend4493
sub r3,r0
subd4493:
sub r8,r0
divutend4493:
dt r4
bf/s dutloop4493
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4495
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4495:
jmp @r4
mov r0,r2
.align 5
ln4494:
mov #0x8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4496
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4496:
jmp @r4
mov r0,r2
.align 5
ln4493:
mov.l g2_except_addr4493,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4493,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4497
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4497:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4493: .long group_2_exception
bf_addr4493: .long basefunction
! Opcodes 86D0 - 86D7
S6D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4498
cmp/hs r3,r1
bt ln4499
mov #15,r4
mov r1,r0
dutloop4498:
bt subd4498
cmp/hs r3,r0
bt/s subhd4498
dt r7
bra divutend4498
dt r7
subhd4498:
bra divutend4498
sub r3,r0
subd4498:
sub r8,r0
divutend4498:
dt r4
bf/s dutloop4498
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4500
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4500:
jmp @r4
mov r0,r2
.align 5
ln4499:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4501
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4501:
jmp @r4
mov r0,r2
.align 5
ln4498:
mov.l g2_except_addr4498,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4498,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4502
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4502:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4498: .long group_2_exception
bf_addr4498: .long basefunction
! Opcodes 86D8 - 86DF
S6D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4503
cmp/hs r3,r1
bt ln4504
mov #15,r4
mov r1,r0
dutloop4503:
bt subd4503
cmp/hs r3,r0
bt/s subhd4503
dt r7
bra divutend4503
dt r7
subhd4503:
bra divutend4503
sub r3,r0
subd4503:
sub r8,r0
divutend4503:
dt r4
bf/s dutloop4503
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4505
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4505:
jmp @r4
mov r0,r2
.align 5
ln4504:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4506
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4506:
jmp @r4
mov r0,r2
.align 5
ln4503:
mov.l g2_except_addr4503,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4503,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4507
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4507:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4503: .long group_2_exception
bf_addr4503: .long basefunction
! Opcodes 86E0 - 86E7
S6E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4508
cmp/hs r3,r1
bt ln4509
mov #15,r4
mov r1,r0
dutloop4508:
bt subd4508
cmp/hs r3,r0
bt/s subhd4508
dt r7
bra divutend4508
dt r7
subhd4508:
bra divutend4508
sub r3,r0
subd4508:
sub r8,r0
divutend4508:
dt r4
bf/s dutloop4508
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4510
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4510:
jmp @r4
mov r0,r2
.align 5
ln4509:
mov #0x8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4511
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4511:
jmp @r4
mov r0,r2
.align 5
ln4508:
mov.l g2_except_addr4508,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4508,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4512
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4512:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4508: .long group_2_exception
bf_addr4508: .long basefunction
! Opcodes 86E8 - 86EF
S6E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4513
cmp/hs r3,r1
bt ln4514
mov #15,r4
mov r1,r0
dutloop4513:
bt subd4513
cmp/hs r3,r0
bt/s subhd4513
dt r7
bra divutend4513
dt r7
subhd4513:
bra divutend4513
sub r3,r0
subd4513:
sub r8,r0
divutend4513:
dt r4
bf/s dutloop4513
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4515
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4515:
jmp @r4
mov r0,r2
.align 5
ln4514:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4516
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4516:
jmp @r4
mov r0,r2
.align 5
ln4513:
mov.l g2_except_addr4513,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4513,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4517
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4517:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4513: .long group_2_exception
bf_addr4513: .long basefunction
! Opcodes 86F0 - 86F7
S6F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4518
cmp/hs r3,r1
bt ln4519
mov #15,r4
mov r1,r0
dutloop4518:
bt subd4518
cmp/hs r3,r0
bt/s subhd4518
dt r7
bra divutend4518
dt r7
subhd4518:
bra divutend4518
sub r3,r0
subd4518:
sub r8,r0
divutend4518:
dt r4
bf/s dutloop4518
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4520
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4520:
jmp @r4
mov r0,r2
.align 5
ln4519:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4521
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4521:
jmp @r4
mov r0,r2
.align 5
ln4518:
mov.l g2_except_addr4518,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4518,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4522
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4522:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4518: .long group_2_exception
bf_addr4518: .long basefunction
! Opcode 86F8
S6F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4523
cmp/hs r3,r1
bt ln4524
mov #15,r4
mov r1,r0
dutloop4523:
bt subd4523
cmp/hs r3,r0
bt/s subhd4523
dt r7
bra divutend4523
dt r7
subhd4523:
bra divutend4523
sub r3,r0
subd4523:
sub r8,r0
divutend4523:
dt r4
bf/s dutloop4523
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4525
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4525:
jmp @r4
mov r0,r2
.align 5
ln4524:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4526
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4526:
jmp @r4
mov r0,r2
.align 5
ln4523:
mov.l g2_except_addr4523,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4523,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4527
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4527:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4523: .long group_2_exception
bf_addr4523: .long basefunction
! Opcode 86F9
S6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4528
cmp/hs r3,r1
bt ln4529
mov #15,r4
mov r1,r0
dutloop4528:
bt subd4528
cmp/hs r3,r0
bt/s subhd4528
dt r7
bra divutend4528
dt r7
subhd4528:
bra divutend4528
sub r3,r0
subd4528:
sub r8,r0
divutend4528:
dt r4
bf/s dutloop4528
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4530
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4530:
jmp @r4
mov r0,r2
.align 5
ln4529:
mov #0x8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4531
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4531:
jmp @r4
mov r0,r2
.align 5
ln4528:
mov.l g2_except_addr4528,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4528,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4532
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4532:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4528: .long group_2_exception
bf_addr4528: .long basefunction
! Opcode 86FA
S6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4533
cmp/hs r3,r1
bt ln4534
mov #15,r4
mov r1,r0
dutloop4533:
bt subd4533
cmp/hs r3,r0
bt/s subhd4533
dt r7
bra divutend4533
dt r7
subhd4533:
bra divutend4533
sub r3,r0
subd4533:
sub r8,r0
divutend4533:
dt r4
bf/s dutloop4533
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4535
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4535:
jmp @r4
mov r0,r2
.align 5
ln4534:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4536
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4536:
jmp @r4
mov r0,r2
.align 5
ln4533:
mov.l g2_except_addr4533,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4533,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4537
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4537:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4533: .long group_2_exception
bf_addr4533: .long basefunction
! Opcode 86FB
S6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4538
cmp/hs r3,r1
bt ln4539
mov #15,r4
mov r1,r0
dutloop4538:
bt subd4538
cmp/hs r3,r0
bt/s subhd4538
dt r7
bra divutend4538
dt r7
subhd4538:
bra divutend4538
sub r3,r0
subd4538:
sub r8,r0
divutend4538:
dt r4
bf/s dutloop4538
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4540
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4540:
jmp @r4
mov r0,r2
.align 5
ln4539:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4541
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4541:
jmp @r4
mov r0,r2
.align 5
ln4538:
mov.l g2_except_addr4538,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4538,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4542
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4542:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4538: .long group_2_exception
bf_addr4538: .long basefunction
! Opcode 86FC
S6FC:
mov.w @r6+,r3
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4543
cmp/hs r3,r1
bt ln4544
mov #15,r4
mov r1,r0
dutloop4543:
bt subd4543
cmp/hs r3,r0
bt/s subhd4543
dt r7
bra divutend4543
dt r7
subhd4543:
bra divutend4543
sub r3,r0
subd4543:
sub r8,r0
divutend4543:
dt r4
bf/s dutloop4543
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4545
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4545:
jmp @r4
mov r0,r2
.align 5
ln4544:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4546
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4546:
jmp @r4
mov r0,r2
.align 5
ln4543:
mov.l g2_except_addr4543,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4543,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4547
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4547:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4543: .long group_2_exception
bf_addr4543: .long basefunction
! Opcodes 8700 - 8707
S700:
and r1,r2
mov.l r3,@-r15
mov #12,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4548
add #-6,r8
.nonibadd4548:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4548
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4548:
exts.b r3,r3
mov r9,r8
mov #12,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4549
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4549:
jmp @r4
mov r0,r2
! Opcodes 8708 - 870F
S708:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(44,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4550
add #-6,r8
.nonibadd4550:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4550
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4550:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4551
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4551:
jmp @r4
mov r0,r2
! Opcodes 8710 - 8717
S710:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4552
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4552:
jmp @r4
mov r0,r2
! Opcodes 8718 - 871F
S718:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4553
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4553:
jmp @r4
mov r0,r2
! Opcodes 8720 - 8727
S720:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4554
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4554:
jmp @r4
mov r0,r2
! Opcodes 8728 - 872F
S728:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4555
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4555:
jmp @r4
mov r0,r2
! Opcodes 8730 - 8737
S730:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4556
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4556:
jmp @r4
mov r0,r2
! Opcode 8738
S738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4557
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4557:
jmp @r4
mov r0,r2
! Opcode 8739
S739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4558
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4558:
jmp @r4
mov r0,r2
! Opcodes 8750 - 8757
S750:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4559
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4559:
jmp @r4
mov r0,r2
! Opcodes 8758 - 875F
S758:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4560
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4560:
jmp @r4
mov r0,r2
! Opcodes 8760 - 8767
S760:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4561
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4561:
jmp @r4
mov r0,r2
! Opcodes 8768 - 876F
S768:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4562
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4562:
jmp @r4
mov r0,r2
! Opcodes 8770 - 8777
S770:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4563
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4563:
jmp @r4
mov r0,r2
! Opcode 8778
S778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4564
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4564:
jmp @r4
mov r0,r2
! Opcode 8779
S779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4565
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4565:
jmp @r4
mov r0,r2
! Opcodes 8790 - 8797
S790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4566
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4566:
jmp @r4
mov r0,r2
! Opcodes 8798 - 879F
S798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4567
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4567:
jmp @r4
mov r0,r2
! Opcodes 87A0 - 87A7
S7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4568
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4568:
jmp @r4
mov r0,r2
! Opcodes 87A8 - 87AF
S7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4569
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4569:
jmp @r4
mov r0,r2
! Opcodes 87B0 - 87B7
S7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4570
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4570:
jmp @r4
mov r0,r2
! Opcode 87B8
S7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4571
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4571:
jmp @r4
mov r0,r2
! Opcode 87B9
S7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4572
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4572:
jmp @r4
mov r0,r2
! Opcodes 87C0 - 87C7
S7C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4573
cmp/pz r3
bt/s noidivis4573
mov r3,r2
neg r2,r2
noidivis4573:
cmp/pz r1
bt/s noidivid4573
mov r1,r0
neg r0,r0
noidivid4573:
cmp/hs r2,r0
bt ln4574
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-11,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4575
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4575:
jmp @r4
mov r0,r2
.align 5
ln4574:
mov #0x8,r8
mov.w @r6+,r0
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4576
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4576:
jmp @r4
mov r0,r2
.align 5
ln4573:
mov.l g2_except_addr4573,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4573,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4577
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4577:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4573: .long group_2_exception
bf_addr4573: .long basefunction
! Opcodes 87D0 - 87D7
S7D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4578
cmp/pz r3
bt/s noidivis4578
mov r3,r2
neg r2,r2
noidivis4578:
cmp/pz r1
bt/s noidivid4578
mov r1,r0
neg r0,r0
noidivid4578:
cmp/hs r2,r0
bt ln4579
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4580
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4580:
jmp @r4
mov r0,r2
.align 5
ln4579:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4581
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4581:
jmp @r4
mov r0,r2
.align 5
ln4578:
mov.l g2_except_addr4578,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4578,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4582
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4582:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4578: .long group_2_exception
bf_addr4578: .long basefunction
! Opcodes 87D8 - 87DF
S7D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4583
cmp/pz r3
bt/s noidivis4583
mov r3,r2
neg r2,r2
noidivis4583:
cmp/pz r1
bt/s noidivid4583
mov r1,r0
neg r0,r0
noidivid4583:
cmp/hs r2,r0
bt ln4584
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4585
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4585:
jmp @r4
mov r0,r2
.align 5
ln4584:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4586
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4586:
jmp @r4
mov r0,r2
.align 5
ln4583:
mov.l g2_except_addr4583,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4583,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4587
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4587:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4583: .long group_2_exception
bf_addr4583: .long basefunction
! Opcodes 87E0 - 87E7
S7E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4588
cmp/pz r3
bt/s noidivis4588
mov r3,r2
neg r2,r2
noidivis4588:
cmp/pz r1
bt/s noidivid4588
mov r1,r0
neg r0,r0
noidivid4588:
cmp/hs r2,r0
bt ln4589
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4590
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4590:
jmp @r4
mov r0,r2
.align 5
ln4589:
mov #0x8,r8
mov.w @r6+,r0
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4591
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4591:
jmp @r4
mov r0,r2
.align 5
ln4588:
mov.l g2_except_addr4588,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4588,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4592
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4592:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4588: .long group_2_exception
bf_addr4588: .long basefunction
! Opcodes 87E8 - 87EF
S7E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4593
cmp/pz r3
bt/s noidivis4593
mov r3,r2
neg r2,r2
noidivis4593:
cmp/pz r1
bt/s noidivid4593
mov r1,r0
neg r0,r0
noidivid4593:
cmp/hs r2,r0
bt ln4594
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4595
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4595:
jmp @r4
mov r0,r2
.align 5
ln4594:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4596
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4596:
jmp @r4
mov r0,r2
.align 5
ln4593:
mov.l g2_except_addr4593,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4593,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4597
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4597:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4593: .long group_2_exception
bf_addr4593: .long basefunction
! Opcodes 87F0 - 87F7
S7F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4598
cmp/pz r3
bt/s noidivis4598
mov r3,r2
neg r2,r2
noidivis4598:
cmp/pz r1
bt/s noidivid4598
mov r1,r0
neg r0,r0
noidivid4598:
cmp/hs r2,r0
bt ln4599
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4600
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4600:
jmp @r4
mov r0,r2
.align 5
ln4599:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4601
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4601:
jmp @r4
mov r0,r2
.align 5
ln4598:
mov.l g2_except_addr4598,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4598,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4602
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4602:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4598: .long group_2_exception
bf_addr4598: .long basefunction
! Opcode 87F8
S7F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4603
cmp/pz r3
bt/s noidivis4603
mov r3,r2
neg r2,r2
noidivis4603:
cmp/pz r1
bt/s noidivid4603
mov r1,r0
neg r0,r0
noidivid4603:
cmp/hs r2,r0
bt ln4604
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4605
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4605:
jmp @r4
mov r0,r2
.align 5
ln4604:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4606
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4606:
jmp @r4
mov r0,r2
.align 5
ln4603:
mov.l g2_except_addr4603,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4603,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4607
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4607:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4603: .long group_2_exception
bf_addr4603: .long basefunction
! Opcode 87F9
S7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4608
cmp/pz r3
bt/s noidivis4608
mov r3,r2
neg r2,r2
noidivis4608:
cmp/pz r1
bt/s noidivid4608
mov r1,r0
neg r0,r0
noidivid4608:
cmp/hs r2,r0
bt ln4609
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4610
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4610:
jmp @r4
mov r0,r2
.align 5
ln4609:
mov #0x8,r8
mov.w @r6+,r0
add #-29,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4611
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4611:
jmp @r4
mov r0,r2
.align 5
ln4608:
mov.l g2_except_addr4608,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4608,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4612
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4612:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4608: .long group_2_exception
bf_addr4608: .long basefunction
! Opcode 87FA
S7FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4613
cmp/pz r3
bt/s noidivis4613
mov r3,r2
neg r2,r2
noidivis4613:
cmp/pz r1
bt/s noidivid4613
mov r1,r0
neg r0,r0
noidivid4613:
cmp/hs r2,r0
bt ln4614
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4615
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4615:
jmp @r4
mov r0,r2
.align 5
ln4614:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4616
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4616:
jmp @r4
mov r0,r2
.align 5
ln4613:
mov.l g2_except_addr4613,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4613,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4617
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4617:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4613: .long group_2_exception
bf_addr4613: .long basefunction
! Opcode 87FB
S7FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4618
cmp/pz r3
bt/s noidivis4618
mov r3,r2
neg r2,r2
noidivis4618:
cmp/pz r1
bt/s noidivid4618
mov r1,r0
neg r0,r0
noidivid4618:
cmp/hs r2,r0
bt ln4619
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4620
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4620:
jmp @r4
mov r0,r2
.align 5
ln4619:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4621
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4621:
jmp @r4
mov r0,r2
.align 5
ln4618:
mov.l g2_except_addr4618,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4618,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4622
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4622:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4618: .long group_2_exception
bf_addr4618: .long basefunction
! Opcode 87FC
S7FC:
mov.w @r6+,r3
mov.l @(12,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4623
cmp/pz r3
bt/s noidivis4623
mov r3,r2
neg r2,r2
noidivis4623:
cmp/pz r1
bt/s noidivid4623
mov r1,r0
neg r0,r0
noidivid4623:
cmp/hs r2,r0
bt ln4624
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(12,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4625
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4625:
jmp @r4
mov r0,r2
.align 5
ln4624:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4626
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4626:
jmp @r4
mov r0,r2
.align 5
ln4623:
mov.l g2_except_addr4623,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4623,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4627
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4627:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4623: .long group_2_exception
bf_addr4623: .long basefunction
! Opcodes 8800 - 8807
S800:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4628
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4628:
jmp @r4
mov r0,r2
! Opcodes 8810 - 8817
S810:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4629
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4629:
jmp @r4
mov r0,r2
! Opcodes 8818 - 881F
S818:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4630
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4630:
jmp @r4
mov r0,r2
! Opcodes 8820 - 8827
S820:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4631
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4631:
jmp @r4
mov r0,r2
! Opcodes 8828 - 882F
S828:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4632
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4632:
jmp @r4
mov r0,r2
! Opcodes 8830 - 8837
S830:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4633
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4633:
jmp @r4
mov r0,r2
! Opcode 8838
S838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4634
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4634:
jmp @r4
mov r0,r2
! Opcode 8839
S839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4635
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4635:
jmp @r4
mov r0,r2
! Opcode 883A
S83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4636
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4636:
jmp @r4
mov r0,r2
! Opcode 883B
S83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4637
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4637:
jmp @r4
mov r0,r2
! Opcode 883C
S83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4638
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4638:
jmp @r4
mov r0,r2
! Opcodes 8840 - 8847
S840:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4639
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4639:
jmp @r4
mov r0,r2
! Opcodes 8850 - 8857
S850:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4640
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4640:
jmp @r4
mov r0,r2
! Opcodes 8858 - 885F
S858:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4641
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4641:
jmp @r4
mov r0,r2
! Opcodes 8860 - 8867
S860:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4642
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4642:
jmp @r4
mov r0,r2
! Opcodes 8868 - 886F
S868:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4643
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4643:
jmp @r4
mov r0,r2
! Opcodes 8870 - 8877
S870:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4644
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4644:
jmp @r4
mov r0,r2
! Opcode 8878
S878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4645
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4645:
jmp @r4
mov r0,r2
! Opcode 8879
S879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4646
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4646:
jmp @r4
mov r0,r2
! Opcode 887A
S87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4647
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4647:
jmp @r4
mov r0,r2
! Opcode 887B
S87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4648
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4648:
jmp @r4
mov r0,r2
! Opcode 887C
S87C:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4649
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4649:
jmp @r4
mov r0,r2
! Opcodes 8880 - 8887
S880:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4650
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4650:
jmp @r4
mov r0,r2
! Opcodes 8890 - 8897
S890:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4651
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4651:
jmp @r4
mov r0,r2
! Opcodes 8898 - 889F
S898:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4652
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4652:
jmp @r4
mov r0,r2
! Opcodes 88A0 - 88A7
S8A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4653
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4653:
jmp @r4
mov r0,r2
! Opcodes 88A8 - 88AF
S8A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4654
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4654:
jmp @r4
mov r0,r2
! Opcodes 88B0 - 88B7
S8B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4655
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4655:
jmp @r4
mov r0,r2
! Opcode 88B8
S8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4656
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4656:
jmp @r4
mov r0,r2
! Opcode 88B9
S8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4657
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4657:
jmp @r4
mov r0,r2
! Opcode 88BA
S8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4658
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4658:
jmp @r4
mov r0,r2
! Opcode 88BB
S8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4659
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4659:
jmp @r4
mov r0,r2
! Opcode 88BC
S8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(16,r13),r1
or r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4660
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4660:
jmp @r4
mov r0,r2
! Opcodes 88C0 - 88C7
S8C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4661
cmp/hs r3,r1
bt ln4662
mov #15,r4
mov r1,r0
dutloop4661:
bt subd4661
cmp/hs r3,r0
bt/s subhd4661
dt r7
bra divutend4661
dt r7
subhd4661:
bra divutend4661
sub r3,r0
subd4661:
sub r8,r0
divutend4661:
dt r4
bf/s dutloop4661
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4663
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4663:
jmp @r4
mov r0,r2
.align 5
ln4662:
mov #0x8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4664
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4664:
jmp @r4
mov r0,r2
.align 5
ln4661:
mov.l g2_except_addr4661,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4661,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4665
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4665:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4661: .long group_2_exception
bf_addr4661: .long basefunction
! Opcodes 88D0 - 88D7
S8D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4666
cmp/hs r3,r1
bt ln4667
mov #15,r4
mov r1,r0
dutloop4666:
bt subd4666
cmp/hs r3,r0
bt/s subhd4666
dt r7
bra divutend4666
dt r7
subhd4666:
bra divutend4666
sub r3,r0
subd4666:
sub r8,r0
divutend4666:
dt r4
bf/s dutloop4666
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4668
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4668:
jmp @r4
mov r0,r2
.align 5
ln4667:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4669
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4669:
jmp @r4
mov r0,r2
.align 5
ln4666:
mov.l g2_except_addr4666,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4666,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4670
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4670:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4666: .long group_2_exception
bf_addr4666: .long basefunction
! Opcodes 88D8 - 88DF
S8D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4671
cmp/hs r3,r1
bt ln4672
mov #15,r4
mov r1,r0
dutloop4671:
bt subd4671
cmp/hs r3,r0
bt/s subhd4671
dt r7
bra divutend4671
dt r7
subhd4671:
bra divutend4671
sub r3,r0
subd4671:
sub r8,r0
divutend4671:
dt r4
bf/s dutloop4671
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4673
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4673:
jmp @r4
mov r0,r2
.align 5
ln4672:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4674
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4674:
jmp @r4
mov r0,r2
.align 5
ln4671:
mov.l g2_except_addr4671,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4671,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4675
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4675:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4671: .long group_2_exception
bf_addr4671: .long basefunction
! Opcodes 88E0 - 88E7
S8E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4676
cmp/hs r3,r1
bt ln4677
mov #15,r4
mov r1,r0
dutloop4676:
bt subd4676
cmp/hs r3,r0
bt/s subhd4676
dt r7
bra divutend4676
dt r7
subhd4676:
bra divutend4676
sub r3,r0
subd4676:
sub r8,r0
divutend4676:
dt r4
bf/s dutloop4676
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4678
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4678:
jmp @r4
mov r0,r2
.align 5
ln4677:
mov #0x8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4679
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4679:
jmp @r4
mov r0,r2
.align 5
ln4676:
mov.l g2_except_addr4676,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4676,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4680
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4680:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4676: .long group_2_exception
bf_addr4676: .long basefunction
! Opcodes 88E8 - 88EF
S8E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4681
cmp/hs r3,r1
bt ln4682
mov #15,r4
mov r1,r0
dutloop4681:
bt subd4681
cmp/hs r3,r0
bt/s subhd4681
dt r7
bra divutend4681
dt r7
subhd4681:
bra divutend4681
sub r3,r0
subd4681:
sub r8,r0
divutend4681:
dt r4
bf/s dutloop4681
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4683
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4683:
jmp @r4
mov r0,r2
.align 5
ln4682:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4684
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4684:
jmp @r4
mov r0,r2
.align 5
ln4681:
mov.l g2_except_addr4681,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4681,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4685
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4685:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4681: .long group_2_exception
bf_addr4681: .long basefunction
! Opcodes 88F0 - 88F7
S8F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4686
cmp/hs r3,r1
bt ln4687
mov #15,r4
mov r1,r0
dutloop4686:
bt subd4686
cmp/hs r3,r0
bt/s subhd4686
dt r7
bra divutend4686
dt r7
subhd4686:
bra divutend4686
sub r3,r0
subd4686:
sub r8,r0
divutend4686:
dt r4
bf/s dutloop4686
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4688
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4688:
jmp @r4
mov r0,r2
.align 5
ln4687:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4689
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4689:
jmp @r4
mov r0,r2
.align 5
ln4686:
mov.l g2_except_addr4686,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4686,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4690
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4690:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4686: .long group_2_exception
bf_addr4686: .long basefunction
! Opcode 88F8
S8F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4691
cmp/hs r3,r1
bt ln4692
mov #15,r4
mov r1,r0
dutloop4691:
bt subd4691
cmp/hs r3,r0
bt/s subhd4691
dt r7
bra divutend4691
dt r7
subhd4691:
bra divutend4691
sub r3,r0
subd4691:
sub r8,r0
divutend4691:
dt r4
bf/s dutloop4691
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4693
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4693:
jmp @r4
mov r0,r2
.align 5
ln4692:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4694
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4694:
jmp @r4
mov r0,r2
.align 5
ln4691:
mov.l g2_except_addr4691,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4691,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4695
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4695:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4691: .long group_2_exception
bf_addr4691: .long basefunction
! Opcode 88F9
S8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4696
cmp/hs r3,r1
bt ln4697
mov #15,r4
mov r1,r0
dutloop4696:
bt subd4696
cmp/hs r3,r0
bt/s subhd4696
dt r7
bra divutend4696
dt r7
subhd4696:
bra divutend4696
sub r3,r0
subd4696:
sub r8,r0
divutend4696:
dt r4
bf/s dutloop4696
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4698
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4698:
jmp @r4
mov r0,r2
.align 5
ln4697:
mov #0x8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4699
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4699:
jmp @r4
mov r0,r2
.align 5
ln4696:
mov.l g2_except_addr4696,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4696,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4700
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4700:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4696: .long group_2_exception
bf_addr4696: .long basefunction
! Opcode 88FA
S8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4701
cmp/hs r3,r1
bt ln4702
mov #15,r4
mov r1,r0
dutloop4701:
bt subd4701
cmp/hs r3,r0
bt/s subhd4701
dt r7
bra divutend4701
dt r7
subhd4701:
bra divutend4701
sub r3,r0
subd4701:
sub r8,r0
divutend4701:
dt r4
bf/s dutloop4701
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4703
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4703:
jmp @r4
mov r0,r2
.align 5
ln4702:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4704
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4704:
jmp @r4
mov r0,r2
.align 5
ln4701:
mov.l g2_except_addr4701,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4701,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4705
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4705:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4701: .long group_2_exception
bf_addr4701: .long basefunction
! Opcode 88FB
S8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4706
cmp/hs r3,r1
bt ln4707
mov #15,r4
mov r1,r0
dutloop4706:
bt subd4706
cmp/hs r3,r0
bt/s subhd4706
dt r7
bra divutend4706
dt r7
subhd4706:
bra divutend4706
sub r3,r0
subd4706:
sub r8,r0
divutend4706:
dt r4
bf/s dutloop4706
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4708
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4708:
jmp @r4
mov r0,r2
.align 5
ln4707:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4709
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4709:
jmp @r4
mov r0,r2
.align 5
ln4706:
mov.l g2_except_addr4706,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4706,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4710
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4710:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4706: .long group_2_exception
bf_addr4706: .long basefunction
! Opcode 88FC
S8FC:
mov.w @r6+,r3
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4711
cmp/hs r3,r1
bt ln4712
mov #15,r4
mov r1,r0
dutloop4711:
bt subd4711
cmp/hs r3,r0
bt/s subhd4711
dt r7
bra divutend4711
dt r7
subhd4711:
bra divutend4711
sub r3,r0
subd4711:
sub r8,r0
divutend4711:
dt r4
bf/s dutloop4711
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4713
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4713:
jmp @r4
mov r0,r2
.align 5
ln4712:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4714
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4714:
jmp @r4
mov r0,r2
.align 5
ln4711:
mov.l g2_except_addr4711,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4711,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4715
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4715:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4711: .long group_2_exception
bf_addr4711: .long basefunction
! Opcodes 8900 - 8907
S900:
and r1,r2
mov.l r3,@-r15
mov #16,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4716
add #-6,r8
.nonibadd4716:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4716
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4716:
exts.b r3,r3
mov r9,r8
mov #16,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4717
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4717:
jmp @r4
mov r0,r2
! Opcodes 8908 - 890F
S908:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(48,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4718
add #-6,r8
.nonibadd4718:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4718
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4718:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4719
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4719:
jmp @r4
mov r0,r2
! Opcodes 8910 - 8917
S910:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4720
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4720:
jmp @r4
mov r0,r2
! Opcodes 8918 - 891F
S918:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4721
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4721:
jmp @r4
mov r0,r2
! Opcodes 8920 - 8927
S920:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4722
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4722:
jmp @r4
mov r0,r2
! Opcodes 8928 - 892F
S928:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4723
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4723:
jmp @r4
mov r0,r2
! Opcodes 8930 - 8937
S930:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4724
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4724:
jmp @r4
mov r0,r2
! Opcode 8938
S938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4725
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4725:
jmp @r4
mov r0,r2
! Opcode 8939
S939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4726
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4726:
jmp @r4
mov r0,r2
! Opcodes 8950 - 8957
S950:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4727
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4727:
jmp @r4
mov r0,r2
! Opcodes 8958 - 895F
S958:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4728
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4728:
jmp @r4
mov r0,r2
! Opcodes 8960 - 8967
S960:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4729
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4729:
jmp @r4
mov r0,r2
! Opcodes 8968 - 896F
S968:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4730
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4730:
jmp @r4
mov r0,r2
! Opcodes 8970 - 8977
S970:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4731
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4731:
jmp @r4
mov r0,r2
! Opcode 8978
S978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4732
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4732:
jmp @r4
mov r0,r2
! Opcode 8979
S979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4733
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4733:
jmp @r4
mov r0,r2
! Opcodes 8990 - 8997
S990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4734
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4734:
jmp @r4
mov r0,r2
! Opcodes 8998 - 899F
S998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4735
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4735:
jmp @r4
mov r0,r2
! Opcodes 89A0 - 89A7
S9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4736
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4736:
jmp @r4
mov r0,r2
! Opcodes 89A8 - 89AF
S9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4737
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4737:
jmp @r4
mov r0,r2
! Opcodes 89B0 - 89B7
S9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4738
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4738:
jmp @r4
mov r0,r2
! Opcode 89B8
S9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4739
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4739:
jmp @r4
mov r0,r2
! Opcode 89B9
S9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4740
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4740:
jmp @r4
mov r0,r2
! Opcodes 89C0 - 89C7
S9C0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4741
cmp/pz r3
bt/s noidivis4741
mov r3,r2
neg r2,r2
noidivis4741:
cmp/pz r1
bt/s noidivid4741
mov r1,r0
neg r0,r0
noidivid4741:
cmp/hs r2,r0
bt ln4742
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-11,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4743
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4743:
jmp @r4
mov r0,r2
.align 5
ln4742:
mov #0x8,r8
mov.w @r6+,r0
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4744
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4744:
jmp @r4
mov r0,r2
.align 5
ln4741:
mov.l g2_except_addr4741,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4741,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4745
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4745:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4741: .long group_2_exception
bf_addr4741: .long basefunction
! Opcodes 89D0 - 89D7
S9D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4746
cmp/pz r3
bt/s noidivis4746
mov r3,r2
neg r2,r2
noidivis4746:
cmp/pz r1
bt/s noidivid4746
mov r1,r0
neg r0,r0
noidivid4746:
cmp/hs r2,r0
bt ln4747
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4748
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4748:
jmp @r4
mov r0,r2
.align 5
ln4747:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4749
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4749:
jmp @r4
mov r0,r2
.align 5
ln4746:
mov.l g2_except_addr4746,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4746,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4750
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4750:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4746: .long group_2_exception
bf_addr4746: .long basefunction
! Opcodes 89D8 - 89DF
S9D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4751
cmp/pz r3
bt/s noidivis4751
mov r3,r2
neg r2,r2
noidivis4751:
cmp/pz r1
bt/s noidivid4751
mov r1,r0
neg r0,r0
noidivid4751:
cmp/hs r2,r0
bt ln4752
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4753
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4753:
jmp @r4
mov r0,r2
.align 5
ln4752:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4754
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4754:
jmp @r4
mov r0,r2
.align 5
ln4751:
mov.l g2_except_addr4751,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4751,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4755
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4755:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4751: .long group_2_exception
bf_addr4751: .long basefunction
! Opcodes 89E0 - 89E7
S9E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4756
cmp/pz r3
bt/s noidivis4756
mov r3,r2
neg r2,r2
noidivis4756:
cmp/pz r1
bt/s noidivid4756
mov r1,r0
neg r0,r0
noidivid4756:
cmp/hs r2,r0
bt ln4757
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4758
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4758:
jmp @r4
mov r0,r2
.align 5
ln4757:
mov #0x8,r8
mov.w @r6+,r0
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4759
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4759:
jmp @r4
mov r0,r2
.align 5
ln4756:
mov.l g2_except_addr4756,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4756,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4760
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4760:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4756: .long group_2_exception
bf_addr4756: .long basefunction
! Opcodes 89E8 - 89EF
S9E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4761
cmp/pz r3
bt/s noidivis4761
mov r3,r2
neg r2,r2
noidivis4761:
cmp/pz r1
bt/s noidivid4761
mov r1,r0
neg r0,r0
noidivid4761:
cmp/hs r2,r0
bt ln4762
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4763
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4763:
jmp @r4
mov r0,r2
.align 5
ln4762:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4764
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4764:
jmp @r4
mov r0,r2
.align 5
ln4761:
mov.l g2_except_addr4761,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4761,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4765
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4765:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4761: .long group_2_exception
bf_addr4761: .long basefunction
! Opcodes 89F0 - 89F7
S9F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4766
cmp/pz r3
bt/s noidivis4766
mov r3,r2
neg r2,r2
noidivis4766:
cmp/pz r1
bt/s noidivid4766
mov r1,r0
neg r0,r0
noidivid4766:
cmp/hs r2,r0
bt ln4767
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4768
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4768:
jmp @r4
mov r0,r2
.align 5
ln4767:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4769
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4769:
jmp @r4
mov r0,r2
.align 5
ln4766:
mov.l g2_except_addr4766,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4766,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4770
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4770:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4766: .long group_2_exception
bf_addr4766: .long basefunction
! Opcode 89F8
S9F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4771
cmp/pz r3
bt/s noidivis4771
mov r3,r2
neg r2,r2
noidivis4771:
cmp/pz r1
bt/s noidivid4771
mov r1,r0
neg r0,r0
noidivid4771:
cmp/hs r2,r0
bt ln4772
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4773
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4773:
jmp @r4
mov r0,r2
.align 5
ln4772:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4774
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4774:
jmp @r4
mov r0,r2
.align 5
ln4771:
mov.l g2_except_addr4771,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4771,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4775
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4775:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4771: .long group_2_exception
bf_addr4771: .long basefunction
! Opcode 89F9
S9F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4776
cmp/pz r3
bt/s noidivis4776
mov r3,r2
neg r2,r2
noidivis4776:
cmp/pz r1
bt/s noidivid4776
mov r1,r0
neg r0,r0
noidivid4776:
cmp/hs r2,r0
bt ln4777
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4778
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4778:
jmp @r4
mov r0,r2
.align 5
ln4777:
mov #0x8,r8
mov.w @r6+,r0
add #-29,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4779
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4779:
jmp @r4
mov r0,r2
.align 5
ln4776:
mov.l g2_except_addr4776,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4776,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4780
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4780:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4776: .long group_2_exception
bf_addr4776: .long basefunction
! Opcode 89FA
S9FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4781
cmp/pz r3
bt/s noidivis4781
mov r3,r2
neg r2,r2
noidivis4781:
cmp/pz r1
bt/s noidivid4781
mov r1,r0
neg r0,r0
noidivid4781:
cmp/hs r2,r0
bt ln4782
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4783
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4783:
jmp @r4
mov r0,r2
.align 5
ln4782:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4784
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4784:
jmp @r4
mov r0,r2
.align 5
ln4781:
mov.l g2_except_addr4781,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4781,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4785
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4785:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4781: .long group_2_exception
bf_addr4781: .long basefunction
! Opcode 89FB
S9FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4786
cmp/pz r3
bt/s noidivis4786
mov r3,r2
neg r2,r2
noidivis4786:
cmp/pz r1
bt/s noidivid4786
mov r1,r0
neg r0,r0
noidivid4786:
cmp/hs r2,r0
bt ln4787
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4788
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4788:
jmp @r4
mov r0,r2
.align 5
ln4787:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4789
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4789:
jmp @r4
mov r0,r2
.align 5
ln4786:
mov.l g2_except_addr4786,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4786,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4790
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4790:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4786: .long group_2_exception
bf_addr4786: .long basefunction
! Opcode 89FC
S9FC:
mov.w @r6+,r3
mov.l @(16,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4791
cmp/pz r3
bt/s noidivis4791
mov r3,r2
neg r2,r2
noidivis4791:
cmp/pz r1
bt/s noidivid4791
mov r1,r0
neg r0,r0
noidivid4791:
cmp/hs r2,r0
bt ln4792
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(16,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4793
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4793:
jmp @r4
mov r0,r2
.align 5
ln4792:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4794
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4794:
jmp @r4
mov r0,r2
.align 5
ln4791:
mov.l g2_except_addr4791,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4791,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4795
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4795:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4791: .long group_2_exception
bf_addr4791: .long basefunction
! Opcodes 8A00 - 8A07
SA00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4796
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4796:
jmp @r4
mov r0,r2
! Opcodes 8A10 - 8A17
SA10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4797
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4797:
jmp @r4
mov r0,r2
! Opcodes 8A18 - 8A1F
SA18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4798
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4798:
jmp @r4
mov r0,r2
! Opcodes 8A20 - 8A27
SA20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4799
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4799:
jmp @r4
mov r0,r2
! Opcodes 8A28 - 8A2F
SA28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4800
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4800:
jmp @r4
mov r0,r2
! Opcodes 8A30 - 8A37
SA30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4801
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4801:
jmp @r4
mov r0,r2
! Opcode 8A38
SA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4802
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4802:
jmp @r4
mov r0,r2
! Opcode 8A39
SA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4803
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4803:
jmp @r4
mov r0,r2
! Opcode 8A3A
SA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4804
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4804:
jmp @r4
mov r0,r2
! Opcode 8A3B
SA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4805
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4805:
jmp @r4
mov r0,r2
! Opcode 8A3C
SA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4806
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4806:
jmp @r4
mov r0,r2
! Opcodes 8A40 - 8A47
SA40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4807
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4807:
jmp @r4
mov r0,r2
! Opcodes 8A50 - 8A57
SA50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4808
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4808:
jmp @r4
mov r0,r2
! Opcodes 8A58 - 8A5F
SA58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4809
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4809:
jmp @r4
mov r0,r2
! Opcodes 8A60 - 8A67
SA60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4810
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4810:
jmp @r4
mov r0,r2
! Opcodes 8A68 - 8A6F
SA68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4811
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4811:
jmp @r4
mov r0,r2
! Opcodes 8A70 - 8A77
SA70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4812
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4812:
jmp @r4
mov r0,r2
! Opcode 8A78
SA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4813
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4813:
jmp @r4
mov r0,r2
! Opcode 8A79
SA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4814
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4814:
jmp @r4
mov r0,r2
! Opcode 8A7A
SA7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4815
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4815:
jmp @r4
mov r0,r2
! Opcode 8A7B
SA7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4816
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4816:
jmp @r4
mov r0,r2
! Opcode 8A7C
SA7C:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4817
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4817:
jmp @r4
mov r0,r2
! Opcodes 8A80 - 8A87
SA80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4818
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4818:
jmp @r4
mov r0,r2
! Opcodes 8A90 - 8A97
SA90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4819
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4819:
jmp @r4
mov r0,r2
! Opcodes 8A98 - 8A9F
SA98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4820
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4820:
jmp @r4
mov r0,r2
! Opcodes 8AA0 - 8AA7
SAA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4821
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4821:
jmp @r4
mov r0,r2
! Opcodes 8AA8 - 8AAF
SAA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4822
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4822:
jmp @r4
mov r0,r2
! Opcodes 8AB0 - 8AB7
SAB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4823
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4823:
jmp @r4
mov r0,r2
! Opcode 8AB8
SAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4824
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4824:
jmp @r4
mov r0,r2
! Opcode 8AB9
SAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4825
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4825:
jmp @r4
mov r0,r2
! Opcode 8ABA
SABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4826
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4826:
jmp @r4
mov r0,r2
! Opcode 8ABB
SABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4827
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4827:
jmp @r4
mov r0,r2
! Opcode 8ABC
SABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(20,r13),r1
or r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4828
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4828:
jmp @r4
mov r0,r2
! Opcodes 8AC0 - 8AC7
SAC0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4829
cmp/hs r3,r1
bt ln4830
mov #15,r4
mov r1,r0
dutloop4829:
bt subd4829
cmp/hs r3,r0
bt/s subhd4829
dt r7
bra divutend4829
dt r7
subhd4829:
bra divutend4829
sub r3,r0
subd4829:
sub r8,r0
divutend4829:
dt r4
bf/s dutloop4829
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4831
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4831:
jmp @r4
mov r0,r2
.align 5
ln4830:
mov #0x8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4832
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4832:
jmp @r4
mov r0,r2
.align 5
ln4829:
mov.l g2_except_addr4829,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4829,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4833
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4833:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4829: .long group_2_exception
bf_addr4829: .long basefunction
! Opcodes 8AD0 - 8AD7
SAD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4834
cmp/hs r3,r1
bt ln4835
mov #15,r4
mov r1,r0
dutloop4834:
bt subd4834
cmp/hs r3,r0
bt/s subhd4834
dt r7
bra divutend4834
dt r7
subhd4834:
bra divutend4834
sub r3,r0
subd4834:
sub r8,r0
divutend4834:
dt r4
bf/s dutloop4834
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4836
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4836:
jmp @r4
mov r0,r2
.align 5
ln4835:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4837
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4837:
jmp @r4
mov r0,r2
.align 5
ln4834:
mov.l g2_except_addr4834,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4834,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4838
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4838:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4834: .long group_2_exception
bf_addr4834: .long basefunction
! Opcodes 8AD8 - 8ADF
SAD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4839
cmp/hs r3,r1
bt ln4840
mov #15,r4
mov r1,r0
dutloop4839:
bt subd4839
cmp/hs r3,r0
bt/s subhd4839
dt r7
bra divutend4839
dt r7
subhd4839:
bra divutend4839
sub r3,r0
subd4839:
sub r8,r0
divutend4839:
dt r4
bf/s dutloop4839
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4841
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4841:
jmp @r4
mov r0,r2
.align 5
ln4840:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4842
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4842:
jmp @r4
mov r0,r2
.align 5
ln4839:
mov.l g2_except_addr4839,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4839,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4843
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4843:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4839: .long group_2_exception
bf_addr4839: .long basefunction
! Opcodes 8AE0 - 8AE7
SAE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4844
cmp/hs r3,r1
bt ln4845
mov #15,r4
mov r1,r0
dutloop4844:
bt subd4844
cmp/hs r3,r0
bt/s subhd4844
dt r7
bra divutend4844
dt r7
subhd4844:
bra divutend4844
sub r3,r0
subd4844:
sub r8,r0
divutend4844:
dt r4
bf/s dutloop4844
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4846
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4846:
jmp @r4
mov r0,r2
.align 5
ln4845:
mov #0x8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4847
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4847:
jmp @r4
mov r0,r2
.align 5
ln4844:
mov.l g2_except_addr4844,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4844,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4848
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4848:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4844: .long group_2_exception
bf_addr4844: .long basefunction
! Opcodes 8AE8 - 8AEF
SAE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4849
cmp/hs r3,r1
bt ln4850
mov #15,r4
mov r1,r0
dutloop4849:
bt subd4849
cmp/hs r3,r0
bt/s subhd4849
dt r7
bra divutend4849
dt r7
subhd4849:
bra divutend4849
sub r3,r0
subd4849:
sub r8,r0
divutend4849:
dt r4
bf/s dutloop4849
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4851
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4851:
jmp @r4
mov r0,r2
.align 5
ln4850:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4852
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4852:
jmp @r4
mov r0,r2
.align 5
ln4849:
mov.l g2_except_addr4849,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4849,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4853
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4853:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4849: .long group_2_exception
bf_addr4849: .long basefunction
! Opcodes 8AF0 - 8AF7
SAF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4854
cmp/hs r3,r1
bt ln4855
mov #15,r4
mov r1,r0
dutloop4854:
bt subd4854
cmp/hs r3,r0
bt/s subhd4854
dt r7
bra divutend4854
dt r7
subhd4854:
bra divutend4854
sub r3,r0
subd4854:
sub r8,r0
divutend4854:
dt r4
bf/s dutloop4854
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4856
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4856:
jmp @r4
mov r0,r2
.align 5
ln4855:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4857
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4857:
jmp @r4
mov r0,r2
.align 5
ln4854:
mov.l g2_except_addr4854,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4854,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4858
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4858:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4854: .long group_2_exception
bf_addr4854: .long basefunction
! Opcode 8AF8
SAF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4859
cmp/hs r3,r1
bt ln4860
mov #15,r4
mov r1,r0
dutloop4859:
bt subd4859
cmp/hs r3,r0
bt/s subhd4859
dt r7
bra divutend4859
dt r7
subhd4859:
bra divutend4859
sub r3,r0
subd4859:
sub r8,r0
divutend4859:
dt r4
bf/s dutloop4859
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4861
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4861:
jmp @r4
mov r0,r2
.align 5
ln4860:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4862
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4862:
jmp @r4
mov r0,r2
.align 5
ln4859:
mov.l g2_except_addr4859,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4859,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4863
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4863:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4859: .long group_2_exception
bf_addr4859: .long basefunction
! Opcode 8AF9
SAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4864
cmp/hs r3,r1
bt ln4865
mov #15,r4
mov r1,r0
dutloop4864:
bt subd4864
cmp/hs r3,r0
bt/s subhd4864
dt r7
bra divutend4864
dt r7
subhd4864:
bra divutend4864
sub r3,r0
subd4864:
sub r8,r0
divutend4864:
dt r4
bf/s dutloop4864
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4866
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4866:
jmp @r4
mov r0,r2
.align 5
ln4865:
mov #0x8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4867
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4867:
jmp @r4
mov r0,r2
.align 5
ln4864:
mov.l g2_except_addr4864,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4864,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4868
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4868:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4864: .long group_2_exception
bf_addr4864: .long basefunction
! Opcode 8AFA
SAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4869
cmp/hs r3,r1
bt ln4870
mov #15,r4
mov r1,r0
dutloop4869:
bt subd4869
cmp/hs r3,r0
bt/s subhd4869
dt r7
bra divutend4869
dt r7
subhd4869:
bra divutend4869
sub r3,r0
subd4869:
sub r8,r0
divutend4869:
dt r4
bf/s dutloop4869
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4871
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4871:
jmp @r4
mov r0,r2
.align 5
ln4870:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4872
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4872:
jmp @r4
mov r0,r2
.align 5
ln4869:
mov.l g2_except_addr4869,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4869,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4873
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4873:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4869: .long group_2_exception
bf_addr4869: .long basefunction
! Opcode 8AFB
SAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4874
cmp/hs r3,r1
bt ln4875
mov #15,r4
mov r1,r0
dutloop4874:
bt subd4874
cmp/hs r3,r0
bt/s subhd4874
dt r7
bra divutend4874
dt r7
subhd4874:
bra divutend4874
sub r3,r0
subd4874:
sub r8,r0
divutend4874:
dt r4
bf/s dutloop4874
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4876
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4876:
jmp @r4
mov r0,r2
.align 5
ln4875:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4877
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4877:
jmp @r4
mov r0,r2
.align 5
ln4874:
mov.l g2_except_addr4874,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4874,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4878
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4878:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4874: .long group_2_exception
bf_addr4874: .long basefunction
! Opcode 8AFC
SAFC:
mov.w @r6+,r3
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4879
cmp/hs r3,r1
bt ln4880
mov #15,r4
mov r1,r0
dutloop4879:
bt subd4879
cmp/hs r3,r0
bt/s subhd4879
dt r7
bra divutend4879
dt r7
subhd4879:
bra divutend4879
sub r3,r0
subd4879:
sub r8,r0
divutend4879:
dt r4
bf/s dutloop4879
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4881
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4881:
jmp @r4
mov r0,r2
.align 5
ln4880:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4882
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4882:
jmp @r4
mov r0,r2
.align 5
ln4879:
mov.l g2_except_addr4879,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4879,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4883
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4883:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4879: .long group_2_exception
bf_addr4879: .long basefunction
! Opcodes 8B00 - 8B07
SB00:
and r1,r2
mov.l r3,@-r15
mov #20,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4884
add #-6,r8
.nonibadd4884:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4884
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4884:
exts.b r3,r3
mov r9,r8
mov #20,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4885
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4885:
jmp @r4
mov r0,r2
! Opcodes 8B08 - 8B0F
SB08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(52,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd4886
add #-6,r8
.nonibadd4886:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop4886
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop4886:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4887
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4887:
jmp @r4
mov r0,r2
! Opcodes 8B10 - 8B17
SB10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4888
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4888:
jmp @r4
mov r0,r2
! Opcodes 8B18 - 8B1F
SB18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4889
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4889:
jmp @r4
mov r0,r2
! Opcodes 8B20 - 8B27
SB20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4890
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4890:
jmp @r4
mov r0,r2
! Opcodes 8B28 - 8B2F
SB28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4891
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4891:
jmp @r4
mov r0,r2
! Opcodes 8B30 - 8B37
SB30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4892
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4892:
jmp @r4
mov r0,r2
! Opcode 8B38
SB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4893
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4893:
jmp @r4
mov r0,r2
! Opcode 8B39
SB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4894
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4894:
jmp @r4
mov r0,r2
! Opcodes 8B50 - 8B57
SB50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4895
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4895:
jmp @r4
mov r0,r2
! Opcodes 8B58 - 8B5F
SB58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4896
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4896:
jmp @r4
mov r0,r2
! Opcodes 8B60 - 8B67
SB60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4897
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4897:
jmp @r4
mov r0,r2
! Opcodes 8B68 - 8B6F
SB68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4898
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4898:
jmp @r4
mov r0,r2
! Opcodes 8B70 - 8B77
SB70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4899
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4899:
jmp @r4
mov r0,r2
! Opcode 8B78
SB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4900
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4900:
jmp @r4
mov r0,r2
! Opcode 8B79
SB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4901
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4901:
jmp @r4
mov r0,r2
! Opcodes 8B90 - 8B97
SB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4902
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4902:
jmp @r4
mov r0,r2
! Opcodes 8B98 - 8B9F
SB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4903
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4903:
jmp @r4
mov r0,r2
! Opcodes 8BA0 - 8BA7
SBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4904
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4904:
jmp @r4
mov r0,r2
! Opcodes 8BA8 - 8BAF
SBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4905
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4905:
jmp @r4
mov r0,r2
! Opcodes 8BB0 - 8BB7
SBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4906
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4906:
jmp @r4
mov r0,r2
! Opcode 8BB8
SBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4907
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4907:
jmp @r4
mov r0,r2
! Opcode 8BB9
SBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4908
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4908:
jmp @r4
mov r0,r2
! Opcodes 8BC0 - 8BC7
SBC0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4909
cmp/pz r3
bt/s noidivis4909
mov r3,r2
neg r2,r2
noidivis4909:
cmp/pz r1
bt/s noidivid4909
mov r1,r0
neg r0,r0
noidivid4909:
cmp/hs r2,r0
bt ln4910
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-11,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4911
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4911:
jmp @r4
mov r0,r2
.align 5
ln4910:
mov #0x8,r8
mov.w @r6+,r0
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4912
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4912:
jmp @r4
mov r0,r2
.align 5
ln4909:
mov.l g2_except_addr4909,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4909,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4913
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4913:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4909: .long group_2_exception
bf_addr4909: .long basefunction
! Opcodes 8BD0 - 8BD7
SBD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4914
cmp/pz r3
bt/s noidivis4914
mov r3,r2
neg r2,r2
noidivis4914:
cmp/pz r1
bt/s noidivid4914
mov r1,r0
neg r0,r0
noidivid4914:
cmp/hs r2,r0
bt ln4915
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4916
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4916:
jmp @r4
mov r0,r2
.align 5
ln4915:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4917
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4917:
jmp @r4
mov r0,r2
.align 5
ln4914:
mov.l g2_except_addr4914,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4914,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4918
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4918:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4914: .long group_2_exception
bf_addr4914: .long basefunction
! Opcodes 8BD8 - 8BDF
SBD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4919
cmp/pz r3
bt/s noidivis4919
mov r3,r2
neg r2,r2
noidivis4919:
cmp/pz r1
bt/s noidivid4919
mov r1,r0
neg r0,r0
noidivid4919:
cmp/hs r2,r0
bt ln4920
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4921
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4921:
jmp @r4
mov r0,r2
.align 5
ln4920:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4922
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4922:
jmp @r4
mov r0,r2
.align 5
ln4919:
mov.l g2_except_addr4919,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4919,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4923
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4923:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4919: .long group_2_exception
bf_addr4919: .long basefunction
! Opcodes 8BE0 - 8BE7
SBE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4924
cmp/pz r3
bt/s noidivis4924
mov r3,r2
neg r2,r2
noidivis4924:
cmp/pz r1
bt/s noidivid4924
mov r1,r0
neg r0,r0
noidivid4924:
cmp/hs r2,r0
bt ln4925
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4926
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4926:
jmp @r4
mov r0,r2
.align 5
ln4925:
mov #0x8,r8
mov.w @r6+,r0
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4927
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4927:
jmp @r4
mov r0,r2
.align 5
ln4924:
mov.l g2_except_addr4924,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4924,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4928
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4928:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4924: .long group_2_exception
bf_addr4924: .long basefunction
! Opcodes 8BE8 - 8BEF
SBE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4929
cmp/pz r3
bt/s noidivis4929
mov r3,r2
neg r2,r2
noidivis4929:
cmp/pz r1
bt/s noidivid4929
mov r1,r0
neg r0,r0
noidivid4929:
cmp/hs r2,r0
bt ln4930
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4931
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4931:
jmp @r4
mov r0,r2
.align 5
ln4930:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4932
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4932:
jmp @r4
mov r0,r2
.align 5
ln4929:
mov.l g2_except_addr4929,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4929,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4933
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4933:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4929: .long group_2_exception
bf_addr4929: .long basefunction
! Opcodes 8BF0 - 8BF7
SBF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4934
cmp/pz r3
bt/s noidivis4934
mov r3,r2
neg r2,r2
noidivis4934:
cmp/pz r1
bt/s noidivid4934
mov r1,r0
neg r0,r0
noidivid4934:
cmp/hs r2,r0
bt ln4935
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4936
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4936:
jmp @r4
mov r0,r2
.align 5
ln4935:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4937
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4937:
jmp @r4
mov r0,r2
.align 5
ln4934:
mov.l g2_except_addr4934,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4934,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4938
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4938:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4934: .long group_2_exception
bf_addr4934: .long basefunction
! Opcode 8BF8
SBF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4939
cmp/pz r3
bt/s noidivis4939
mov r3,r2
neg r2,r2
noidivis4939:
cmp/pz r1
bt/s noidivid4939
mov r1,r0
neg r0,r0
noidivid4939:
cmp/hs r2,r0
bt ln4940
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4941
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4941:
jmp @r4
mov r0,r2
.align 5
ln4940:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4942
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4942:
jmp @r4
mov r0,r2
.align 5
ln4939:
mov.l g2_except_addr4939,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4939,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4943
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4943:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4939: .long group_2_exception
bf_addr4939: .long basefunction
! Opcode 8BF9
SBF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4944
cmp/pz r3
bt/s noidivis4944
mov r3,r2
neg r2,r2
noidivis4944:
cmp/pz r1
bt/s noidivid4944
mov r1,r0
neg r0,r0
noidivid4944:
cmp/hs r2,r0
bt ln4945
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4946
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4946:
jmp @r4
mov r0,r2
.align 5
ln4945:
mov #0x8,r8
mov.w @r6+,r0
add #-29,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4947
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4947:
jmp @r4
mov r0,r2
.align 5
ln4944:
mov.l g2_except_addr4944,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4944,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4948
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4948:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4944: .long group_2_exception
bf_addr4944: .long basefunction
! Opcode 8BFA
SBFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4949
cmp/pz r3
bt/s noidivis4949
mov r3,r2
neg r2,r2
noidivis4949:
cmp/pz r1
bt/s noidivid4949
mov r1,r0
neg r0,r0
noidivid4949:
cmp/hs r2,r0
bt ln4950
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4951
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4951:
jmp @r4
mov r0,r2
.align 5
ln4950:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4952
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4952:
jmp @r4
mov r0,r2
.align 5
ln4949:
mov.l g2_except_addr4949,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4949,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4953
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4953:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4949: .long group_2_exception
bf_addr4949: .long basefunction
! Opcode 8BFB
SBFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4954
cmp/pz r3
bt/s noidivis4954
mov r3,r2
neg r2,r2
noidivis4954:
cmp/pz r1
bt/s noidivid4954
mov r1,r0
neg r0,r0
noidivid4954:
cmp/hs r2,r0
bt ln4955
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4956
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4956:
jmp @r4
mov r0,r2
.align 5
ln4955:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4957
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4957:
jmp @r4
mov r0,r2
.align 5
ln4954:
mov.l g2_except_addr4954,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4954,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4958
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4958:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4954: .long group_2_exception
bf_addr4954: .long basefunction
! Opcode 8BFC
SBFC:
mov.w @r6+,r3
mov.l @(20,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4959
cmp/pz r3
bt/s noidivis4959
mov r3,r2
neg r2,r2
noidivis4959:
cmp/pz r1
bt/s noidivid4959
mov r1,r0
neg r0,r0
noidivid4959:
cmp/hs r2,r0
bt ln4960
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(20,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4961
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4961:
jmp @r4
mov r0,r2
.align 5
ln4960:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4962
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4962:
jmp @r4
mov r0,r2
.align 5
ln4959:
mov.l g2_except_addr4959,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4959,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4963
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4963:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4959: .long group_2_exception
bf_addr4959: .long basefunction
! Opcodes 8C00 - 8C07
SC00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4964
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4964:
jmp @r4
mov r0,r2
! Opcodes 8C10 - 8C17
SC10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4965
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4965:
jmp @r4
mov r0,r2
! Opcodes 8C18 - 8C1F
SC18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4966
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4966:
jmp @r4
mov r0,r2
! Opcodes 8C20 - 8C27
SC20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4967
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4967:
jmp @r4
mov r0,r2
! Opcodes 8C28 - 8C2F
SC28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4968
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4968:
jmp @r4
mov r0,r2
! Opcodes 8C30 - 8C37
SC30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4969
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4969:
jmp @r4
mov r0,r2
! Opcode 8C38
SC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4970
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4970:
jmp @r4
mov r0,r2
! Opcode 8C39
SC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4971
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4971:
jmp @r4
mov r0,r2
! Opcode 8C3A
SC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4972
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4972:
jmp @r4
mov r0,r2
! Opcode 8C3B
SC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4973
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4973:
jmp @r4
mov r0,r2
! Opcode 8C3C
SC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4974
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4974:
jmp @r4
mov r0,r2
! Opcodes 8C40 - 8C47
SC40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4975
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4975:
jmp @r4
mov r0,r2
! Opcodes 8C50 - 8C57
SC50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4976
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4976:
jmp @r4
mov r0,r2
! Opcodes 8C58 - 8C5F
SC58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4977
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4977:
jmp @r4
mov r0,r2
! Opcodes 8C60 - 8C67
SC60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4978
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4978:
jmp @r4
mov r0,r2
! Opcodes 8C68 - 8C6F
SC68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4979
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4979:
jmp @r4
mov r0,r2
! Opcodes 8C70 - 8C77
SC70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4980
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4980:
jmp @r4
mov r0,r2
! Opcode 8C78
SC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4981
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4981:
jmp @r4
mov r0,r2
! Opcode 8C79
SC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4982
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4982:
jmp @r4
mov r0,r2
! Opcode 8C7A
SC7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4983
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4983:
jmp @r4
mov r0,r2
! Opcode 8C7B
SC7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4984
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4984:
jmp @r4
mov r0,r2
! Opcode 8C7C
SC7C:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4985
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4985:
jmp @r4
mov r0,r2
! Opcodes 8C80 - 8C87
SC80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4986
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4986:
jmp @r4
mov r0,r2
! Opcodes 8C90 - 8C97
SC90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4987
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4987:
jmp @r4
mov r0,r2
! Opcodes 8C98 - 8C9F
SC98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4988
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4988:
jmp @r4
mov r0,r2
! Opcodes 8CA0 - 8CA7
SCA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4989
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4989:
jmp @r4
mov r0,r2
! Opcodes 8CA8 - 8CAF
SCA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4990
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4990:
jmp @r4
mov r0,r2
! Opcodes 8CB0 - 8CB7
SCB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4991
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4991:
jmp @r4
mov r0,r2
! Opcode 8CB8
SCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4992
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4992:
jmp @r4
mov r0,r2
! Opcode 8CB9
SCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4993
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4993:
jmp @r4
mov r0,r2
! Opcode 8CBA
SCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4994
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4994:
jmp @r4
mov r0,r2
! Opcode 8CBB
SCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4995
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4995:
jmp @r4
mov r0,r2
! Opcode 8CBC
SCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(24,r13),r1
or r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4996
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4996:
jmp @r4
mov r0,r2
! Opcodes 8CC0 - 8CC7
SCC0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln4997
cmp/hs r3,r1
bt ln4998
mov #15,r4
mov r1,r0
dutloop4997:
bt subd4997
cmp/hs r3,r0
bt/s subhd4997
dt r7
bra divutend4997
dt r7
subhd4997:
bra divutend4997
sub r3,r0
subd4997:
sub r8,r0
divutend4997:
dt r4
bf/s dutloop4997
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl4999
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl4999:
jmp @r4
mov r0,r2
.align 5
ln4998:
mov #0x8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5000
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5000:
jmp @r4
mov r0,r2
.align 5
ln4997:
mov.l g2_except_addr4997,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr4997,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5001
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5001:
jmp @r4
mov r0,r2
.align 2
g2_except_addr4997: .long group_2_exception
bf_addr4997: .long basefunction
! Opcodes 8CD0 - 8CD7
SCD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5002
cmp/hs r3,r1
bt ln5003
mov #15,r4
mov r1,r0
dutloop5002:
bt subd5002
cmp/hs r3,r0
bt/s subhd5002
dt r7
bra divutend5002
dt r7
subhd5002:
bra divutend5002
sub r3,r0
subd5002:
sub r8,r0
divutend5002:
dt r4
bf/s dutloop5002
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5004
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5004:
jmp @r4
mov r0,r2
.align 5
ln5003:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5005
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5005:
jmp @r4
mov r0,r2
.align 5
ln5002:
mov.l g2_except_addr5002,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5002,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5006
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5006:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5002: .long group_2_exception
bf_addr5002: .long basefunction
! Opcodes 8CD8 - 8CDF
SCD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5007
cmp/hs r3,r1
bt ln5008
mov #15,r4
mov r1,r0
dutloop5007:
bt subd5007
cmp/hs r3,r0
bt/s subhd5007
dt r7
bra divutend5007
dt r7
subhd5007:
bra divutend5007
sub r3,r0
subd5007:
sub r8,r0
divutend5007:
dt r4
bf/s dutloop5007
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5009
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5009:
jmp @r4
mov r0,r2
.align 5
ln5008:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5010
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5010:
jmp @r4
mov r0,r2
.align 5
ln5007:
mov.l g2_except_addr5007,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5007,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5011
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5011:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5007: .long group_2_exception
bf_addr5007: .long basefunction
! Opcodes 8CE0 - 8CE7
SCE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5012
cmp/hs r3,r1
bt ln5013
mov #15,r4
mov r1,r0
dutloop5012:
bt subd5012
cmp/hs r3,r0
bt/s subhd5012
dt r7
bra divutend5012
dt r7
subhd5012:
bra divutend5012
sub r3,r0
subd5012:
sub r8,r0
divutend5012:
dt r4
bf/s dutloop5012
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5014
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5014:
jmp @r4
mov r0,r2
.align 5
ln5013:
mov #0x8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5015
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5015:
jmp @r4
mov r0,r2
.align 5
ln5012:
mov.l g2_except_addr5012,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5012,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5016
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5016:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5012: .long group_2_exception
bf_addr5012: .long basefunction
! Opcodes 8CE8 - 8CEF
SCE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5017
cmp/hs r3,r1
bt ln5018
mov #15,r4
mov r1,r0
dutloop5017:
bt subd5017
cmp/hs r3,r0
bt/s subhd5017
dt r7
bra divutend5017
dt r7
subhd5017:
bra divutend5017
sub r3,r0
subd5017:
sub r8,r0
divutend5017:
dt r4
bf/s dutloop5017
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5019
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5019:
jmp @r4
mov r0,r2
.align 5
ln5018:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5020
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5020:
jmp @r4
mov r0,r2
.align 5
ln5017:
mov.l g2_except_addr5017,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5017,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5021
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5021:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5017: .long group_2_exception
bf_addr5017: .long basefunction
! Opcodes 8CF0 - 8CF7
SCF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5022
cmp/hs r3,r1
bt ln5023
mov #15,r4
mov r1,r0
dutloop5022:
bt subd5022
cmp/hs r3,r0
bt/s subhd5022
dt r7
bra divutend5022
dt r7
subhd5022:
bra divutend5022
sub r3,r0
subd5022:
sub r8,r0
divutend5022:
dt r4
bf/s dutloop5022
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5024
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5024:
jmp @r4
mov r0,r2
.align 5
ln5023:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5025
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5025:
jmp @r4
mov r0,r2
.align 5
ln5022:
mov.l g2_except_addr5022,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5022,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5026
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5026:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5022: .long group_2_exception
bf_addr5022: .long basefunction
! Opcode 8CF8
SCF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5027
cmp/hs r3,r1
bt ln5028
mov #15,r4
mov r1,r0
dutloop5027:
bt subd5027
cmp/hs r3,r0
bt/s subhd5027
dt r7
bra divutend5027
dt r7
subhd5027:
bra divutend5027
sub r3,r0
subd5027:
sub r8,r0
divutend5027:
dt r4
bf/s dutloop5027
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5029
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5029:
jmp @r4
mov r0,r2
.align 5
ln5028:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5030
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5030:
jmp @r4
mov r0,r2
.align 5
ln5027:
mov.l g2_except_addr5027,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5027,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5031
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5031:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5027: .long group_2_exception
bf_addr5027: .long basefunction
! Opcode 8CF9
SCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5032
cmp/hs r3,r1
bt ln5033
mov #15,r4
mov r1,r0
dutloop5032:
bt subd5032
cmp/hs r3,r0
bt/s subhd5032
dt r7
bra divutend5032
dt r7
subhd5032:
bra divutend5032
sub r3,r0
subd5032:
sub r8,r0
divutend5032:
dt r4
bf/s dutloop5032
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5034
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5034:
jmp @r4
mov r0,r2
.align 5
ln5033:
mov #0x8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5035
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5035:
jmp @r4
mov r0,r2
.align 5
ln5032:
mov.l g2_except_addr5032,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5032,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5036
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5036:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5032: .long group_2_exception
bf_addr5032: .long basefunction
! Opcode 8CFA
SCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5037
cmp/hs r3,r1
bt ln5038
mov #15,r4
mov r1,r0
dutloop5037:
bt subd5037
cmp/hs r3,r0
bt/s subhd5037
dt r7
bra divutend5037
dt r7
subhd5037:
bra divutend5037
sub r3,r0
subd5037:
sub r8,r0
divutend5037:
dt r4
bf/s dutloop5037
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5039
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5039:
jmp @r4
mov r0,r2
.align 5
ln5038:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5040
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5040:
jmp @r4
mov r0,r2
.align 5
ln5037:
mov.l g2_except_addr5037,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5037,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5041
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5041:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5037: .long group_2_exception
bf_addr5037: .long basefunction
! Opcode 8CFB
SCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5042
cmp/hs r3,r1
bt ln5043
mov #15,r4
mov r1,r0
dutloop5042:
bt subd5042
cmp/hs r3,r0
bt/s subhd5042
dt r7
bra divutend5042
dt r7
subhd5042:
bra divutend5042
sub r3,r0
subd5042:
sub r8,r0
divutend5042:
dt r4
bf/s dutloop5042
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5044
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5044:
jmp @r4
mov r0,r2
.align 5
ln5043:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5045
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5045:
jmp @r4
mov r0,r2
.align 5
ln5042:
mov.l g2_except_addr5042,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5042,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5046
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5046:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5042: .long group_2_exception
bf_addr5042: .long basefunction
! Opcode 8CFC
SCFC:
mov.w @r6+,r3
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5047
cmp/hs r3,r1
bt ln5048
mov #15,r4
mov r1,r0
dutloop5047:
bt subd5047
cmp/hs r3,r0
bt/s subhd5047
dt r7
bra divutend5047
dt r7
subhd5047:
bra divutend5047
sub r3,r0
subd5047:
sub r8,r0
divutend5047:
dt r4
bf/s dutloop5047
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5049
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5049:
jmp @r4
mov r0,r2
.align 5
ln5048:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5050
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5050:
jmp @r4
mov r0,r2
.align 5
ln5047:
mov.l g2_except_addr5047,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5047,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5051
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5051:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5047: .long group_2_exception
bf_addr5047: .long basefunction
! Opcodes 8D00 - 8D07
SD00:
and r1,r2
mov.l r3,@-r15
mov #24,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd5052
add #-6,r8
.nonibadd5052:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop5052
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop5052:
exts.b r3,r3
mov r9,r8
mov #24,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5053
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5053:
jmp @r4
mov r0,r2
! Opcodes 8D08 - 8D0F
SD08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(56,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd5054
add #-6,r8
.nonibadd5054:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop5054
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop5054:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5055
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5055:
jmp @r4
mov r0,r2
! Opcodes 8D10 - 8D17
SD10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5056
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5056:
jmp @r4
mov r0,r2
! Opcodes 8D18 - 8D1F
SD18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5057
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5057:
jmp @r4
mov r0,r2
! Opcodes 8D20 - 8D27
SD20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5058
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5058:
jmp @r4
mov r0,r2
! Opcodes 8D28 - 8D2F
SD28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5059
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5059:
jmp @r4
mov r0,r2
! Opcodes 8D30 - 8D37
SD30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5060
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5060:
jmp @r4
mov r0,r2
! Opcode 8D38
SD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5061
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5061:
jmp @r4
mov r0,r2
! Opcode 8D39
SD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5062
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5062:
jmp @r4
mov r0,r2
! Opcodes 8D50 - 8D57
SD50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5063
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5063:
jmp @r4
mov r0,r2
! Opcodes 8D58 - 8D5F
SD58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5064
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5064:
jmp @r4
mov r0,r2
! Opcodes 8D60 - 8D67
SD60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5065
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5065:
jmp @r4
mov r0,r2
! Opcodes 8D68 - 8D6F
SD68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5066
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5066:
jmp @r4
mov r0,r2
! Opcodes 8D70 - 8D77
SD70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5067
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5067:
jmp @r4
mov r0,r2
! Opcode 8D78
SD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5068
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5068:
jmp @r4
mov r0,r2
! Opcode 8D79
SD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5069
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5069:
jmp @r4
mov r0,r2
! Opcodes 8D90 - 8D97
SD90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5070
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5070:
jmp @r4
mov r0,r2
! Opcodes 8D98 - 8D9F
SD98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5071
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5071:
jmp @r4
mov r0,r2
! Opcodes 8DA0 - 8DA7
SDA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5072
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5072:
jmp @r4
mov r0,r2
! Opcodes 8DA8 - 8DAF
SDA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5073
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5073:
jmp @r4
mov r0,r2
! Opcodes 8DB0 - 8DB7
SDB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5074
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5074:
jmp @r4
mov r0,r2
! Opcode 8DB8
SDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5075
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5075:
jmp @r4
mov r0,r2
! Opcode 8DB9
SDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5076
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5076:
jmp @r4
mov r0,r2
! Opcodes 8DC0 - 8DC7
SDC0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5077
cmp/pz r3
bt/s noidivis5077
mov r3,r2
neg r2,r2
noidivis5077:
cmp/pz r1
bt/s noidivid5077
mov r1,r0
neg r0,r0
noidivid5077:
cmp/hs r2,r0
bt ln5078
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-11,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5079
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5079:
jmp @r4
mov r0,r2
.align 5
ln5078:
mov #0x8,r8
mov.w @r6+,r0
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5080
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5080:
jmp @r4
mov r0,r2
.align 5
ln5077:
mov.l g2_except_addr5077,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5077,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5081
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5081:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5077: .long group_2_exception
bf_addr5077: .long basefunction
! Opcodes 8DD0 - 8DD7
SDD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5082
cmp/pz r3
bt/s noidivis5082
mov r3,r2
neg r2,r2
noidivis5082:
cmp/pz r1
bt/s noidivid5082
mov r1,r0
neg r0,r0
noidivid5082:
cmp/hs r2,r0
bt ln5083
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5084
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5084:
jmp @r4
mov r0,r2
.align 5
ln5083:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5085
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5085:
jmp @r4
mov r0,r2
.align 5
ln5082:
mov.l g2_except_addr5082,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5082,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5086
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5086:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5082: .long group_2_exception
bf_addr5082: .long basefunction
! Opcodes 8DD8 - 8DDF
SDD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5087
cmp/pz r3
bt/s noidivis5087
mov r3,r2
neg r2,r2
noidivis5087:
cmp/pz r1
bt/s noidivid5087
mov r1,r0
neg r0,r0
noidivid5087:
cmp/hs r2,r0
bt ln5088
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5089
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5089:
jmp @r4
mov r0,r2
.align 5
ln5088:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5090
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5090:
jmp @r4
mov r0,r2
.align 5
ln5087:
mov.l g2_except_addr5087,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5087,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5091
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5091:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5087: .long group_2_exception
bf_addr5087: .long basefunction
! Opcodes 8DE0 - 8DE7
SDE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5092
cmp/pz r3
bt/s noidivis5092
mov r3,r2
neg r2,r2
noidivis5092:
cmp/pz r1
bt/s noidivid5092
mov r1,r0
neg r0,r0
noidivid5092:
cmp/hs r2,r0
bt ln5093
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5094
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5094:
jmp @r4
mov r0,r2
.align 5
ln5093:
mov #0x8,r8
mov.w @r6+,r0
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5095
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5095:
jmp @r4
mov r0,r2
.align 5
ln5092:
mov.l g2_except_addr5092,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5092,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5096
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5096:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5092: .long group_2_exception
bf_addr5092: .long basefunction
! Opcodes 8DE8 - 8DEF
SDE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5097
cmp/pz r3
bt/s noidivis5097
mov r3,r2
neg r2,r2
noidivis5097:
cmp/pz r1
bt/s noidivid5097
mov r1,r0
neg r0,r0
noidivid5097:
cmp/hs r2,r0
bt ln5098
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5099
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5099:
jmp @r4
mov r0,r2
.align 5
ln5098:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5100
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5100:
jmp @r4
mov r0,r2
.align 5
ln5097:
mov.l g2_except_addr5097,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5097,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5101
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5101:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5097: .long group_2_exception
bf_addr5097: .long basefunction
! Opcodes 8DF0 - 8DF7
SDF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5102
cmp/pz r3
bt/s noidivis5102
mov r3,r2
neg r2,r2
noidivis5102:
cmp/pz r1
bt/s noidivid5102
mov r1,r0
neg r0,r0
noidivid5102:
cmp/hs r2,r0
bt ln5103
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5104
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5104:
jmp @r4
mov r0,r2
.align 5
ln5103:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5105
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5105:
jmp @r4
mov r0,r2
.align 5
ln5102:
mov.l g2_except_addr5102,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5102,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5106
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5106:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5102: .long group_2_exception
bf_addr5102: .long basefunction
! Opcode 8DF8
SDF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5107
cmp/pz r3
bt/s noidivis5107
mov r3,r2
neg r2,r2
noidivis5107:
cmp/pz r1
bt/s noidivid5107
mov r1,r0
neg r0,r0
noidivid5107:
cmp/hs r2,r0
bt ln5108
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5109
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5109:
jmp @r4
mov r0,r2
.align 5
ln5108:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5110
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5110:
jmp @r4
mov r0,r2
.align 5
ln5107:
mov.l g2_except_addr5107,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5107,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5111
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5111:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5107: .long group_2_exception
bf_addr5107: .long basefunction
! Opcode 8DF9
SDF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5112
cmp/pz r3
bt/s noidivis5112
mov r3,r2
neg r2,r2
noidivis5112:
cmp/pz r1
bt/s noidivid5112
mov r1,r0
neg r0,r0
noidivid5112:
cmp/hs r2,r0
bt ln5113
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5114
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5114:
jmp @r4
mov r0,r2
.align 5
ln5113:
mov #0x8,r8
mov.w @r6+,r0
add #-29,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5115
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5115:
jmp @r4
mov r0,r2
.align 5
ln5112:
mov.l g2_except_addr5112,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5112,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5116
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5116:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5112: .long group_2_exception
bf_addr5112: .long basefunction
! Opcode 8DFA
SDFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5117
cmp/pz r3
bt/s noidivis5117
mov r3,r2
neg r2,r2
noidivis5117:
cmp/pz r1
bt/s noidivid5117
mov r1,r0
neg r0,r0
noidivid5117:
cmp/hs r2,r0
bt ln5118
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5119
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5119:
jmp @r4
mov r0,r2
.align 5
ln5118:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5120
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5120:
jmp @r4
mov r0,r2
.align 5
ln5117:
mov.l g2_except_addr5117,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5117,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5121
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5121:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5117: .long group_2_exception
bf_addr5117: .long basefunction
! Opcode 8DFB
SDFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5122
cmp/pz r3
bt/s noidivis5122
mov r3,r2
neg r2,r2
noidivis5122:
cmp/pz r1
bt/s noidivid5122
mov r1,r0
neg r0,r0
noidivid5122:
cmp/hs r2,r0
bt ln5123
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5124
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5124:
jmp @r4
mov r0,r2
.align 5
ln5123:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5125
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5125:
jmp @r4
mov r0,r2
.align 5
ln5122:
mov.l g2_except_addr5122,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5122,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5126
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5126:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5122: .long group_2_exception
bf_addr5122: .long basefunction
! Opcode 8DFC
SDFC:
mov.w @r6+,r3
mov.l @(24,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5127
cmp/pz r3
bt/s noidivis5127
mov r3,r2
neg r2,r2
noidivis5127:
cmp/pz r1
bt/s noidivid5127
mov r1,r0
neg r0,r0
noidivid5127:
cmp/hs r2,r0
bt ln5128
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(24,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5129
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5129:
jmp @r4
mov r0,r2
.align 5
ln5128:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5130
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5130:
jmp @r4
mov r0,r2
.align 5
ln5127:
mov.l g2_except_addr5127,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5127,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5131
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5131:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5127: .long group_2_exception
bf_addr5127: .long basefunction
! Opcodes 8E00 - 8E07
SE00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5132
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5132:
jmp @r4
mov r0,r2
! Opcodes 8E10 - 8E17
SE10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5133
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5133:
jmp @r4
mov r0,r2
! Opcodes 8E18 - 8E1F
SE18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5134
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5134:
jmp @r4
mov r0,r2
! Opcodes 8E20 - 8E27
SE20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5135
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5135:
jmp @r4
mov r0,r2
! Opcodes 8E28 - 8E2F
SE28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5136
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5136:
jmp @r4
mov r0,r2
! Opcodes 8E30 - 8E37
SE30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5137
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5137:
jmp @r4
mov r0,r2
! Opcode 8E38
SE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5138
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5138:
jmp @r4
mov r0,r2
! Opcode 8E39
SE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5139
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5139:
jmp @r4
mov r0,r2
! Opcode 8E3A
SE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5140
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5140:
jmp @r4
mov r0,r2
! Opcode 8E3B
SE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5141
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5141:
jmp @r4
mov r0,r2
! Opcode 8E3C
SE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5142
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5142:
jmp @r4
mov r0,r2
! Opcodes 8E40 - 8E47
SE40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5143
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5143:
jmp @r4
mov r0,r2
! Opcodes 8E50 - 8E57
SE50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5144
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5144:
jmp @r4
mov r0,r2
! Opcodes 8E58 - 8E5F
SE58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5145
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5145:
jmp @r4
mov r0,r2
! Opcodes 8E60 - 8E67
SE60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5146
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5146:
jmp @r4
mov r0,r2
! Opcodes 8E68 - 8E6F
SE68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5147
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5147:
jmp @r4
mov r0,r2
! Opcodes 8E70 - 8E77
SE70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5148
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5148:
jmp @r4
mov r0,r2
! Opcode 8E78
SE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5149
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5149:
jmp @r4
mov r0,r2
! Opcode 8E79
SE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5150
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5150:
jmp @r4
mov r0,r2
! Opcode 8E7A
SE7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5151
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5151:
jmp @r4
mov r0,r2
! Opcode 8E7B
SE7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5152
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5152:
jmp @r4
mov r0,r2
! Opcode 8E7C
SE7C:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5153
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5153:
jmp @r4
mov r0,r2
! Opcodes 8E80 - 8E87
SE80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5154
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5154:
jmp @r4
mov r0,r2
! Opcodes 8E90 - 8E97
SE90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5155
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5155:
jmp @r4
mov r0,r2
! Opcodes 8E98 - 8E9F
SE98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5156
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5156:
jmp @r4
mov r0,r2
! Opcodes 8EA0 - 8EA7
SEA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5157
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5157:
jmp @r4
mov r0,r2
! Opcodes 8EA8 - 8EAF
SEA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5158
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5158:
jmp @r4
mov r0,r2
! Opcodes 8EB0 - 8EB7
SEB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5159
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5159:
jmp @r4
mov r0,r2
! Opcode 8EB8
SEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5160
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5160:
jmp @r4
mov r0,r2
! Opcode 8EB9
SEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5161
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5161:
jmp @r4
mov r0,r2
! Opcode 8EBA
SEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5162
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5162:
jmp @r4
mov r0,r2
! Opcode 8EBB
SEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5163
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5163:
jmp @r4
mov r0,r2
! Opcode 8EBC
SEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(28,r13),r1
or r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5164
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5164:
jmp @r4
mov r0,r2
! Opcodes 8EC0 - 8EC7
SEC0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5165
cmp/hs r3,r1
bt ln5166
mov #15,r4
mov r1,r0
dutloop5165:
bt subd5165
cmp/hs r3,r0
bt/s subhd5165
dt r7
bra divutend5165
dt r7
subhd5165:
bra divutend5165
sub r3,r0
subd5165:
sub r8,r0
divutend5165:
dt r4
bf/s dutloop5165
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5167
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5167:
jmp @r4
mov r0,r2
.align 5
ln5166:
mov #0x8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5168
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5168:
jmp @r4
mov r0,r2
.align 5
ln5165:
mov.l g2_except_addr5165,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5165,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5169
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5169:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5165: .long group_2_exception
bf_addr5165: .long basefunction
! Opcodes 8ED0 - 8ED7
SED0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5170
cmp/hs r3,r1
bt ln5171
mov #15,r4
mov r1,r0
dutloop5170:
bt subd5170
cmp/hs r3,r0
bt/s subhd5170
dt r7
bra divutend5170
dt r7
subhd5170:
bra divutend5170
sub r3,r0
subd5170:
sub r8,r0
divutend5170:
dt r4
bf/s dutloop5170
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5172
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5172:
jmp @r4
mov r0,r2
.align 5
ln5171:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5173
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5173:
jmp @r4
mov r0,r2
.align 5
ln5170:
mov.l g2_except_addr5170,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5170,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5174
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5174:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5170: .long group_2_exception
bf_addr5170: .long basefunction
! Opcodes 8ED8 - 8EDF
SED8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5175
cmp/hs r3,r1
bt ln5176
mov #15,r4
mov r1,r0
dutloop5175:
bt subd5175
cmp/hs r3,r0
bt/s subhd5175
dt r7
bra divutend5175
dt r7
subhd5175:
bra divutend5175
sub r3,r0
subd5175:
sub r8,r0
divutend5175:
dt r4
bf/s dutloop5175
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5177
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5177:
jmp @r4
mov r0,r2
.align 5
ln5176:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5178
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5178:
jmp @r4
mov r0,r2
.align 5
ln5175:
mov.l g2_except_addr5175,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5175,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5179
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5179:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5175: .long group_2_exception
bf_addr5175: .long basefunction
! Opcodes 8EE0 - 8EE7
SEE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5180
cmp/hs r3,r1
bt ln5181
mov #15,r4
mov r1,r0
dutloop5180:
bt subd5180
cmp/hs r3,r0
bt/s subhd5180
dt r7
bra divutend5180
dt r7
subhd5180:
bra divutend5180
sub r3,r0
subd5180:
sub r8,r0
divutend5180:
dt r4
bf/s dutloop5180
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5182
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5182:
jmp @r4
mov r0,r2
.align 5
ln5181:
mov #0x8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5183
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5183:
jmp @r4
mov r0,r2
.align 5
ln5180:
mov.l g2_except_addr5180,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5180,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5184
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5184:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5180: .long group_2_exception
bf_addr5180: .long basefunction
! Opcodes 8EE8 - 8EEF
SEE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5185
cmp/hs r3,r1
bt ln5186
mov #15,r4
mov r1,r0
dutloop5185:
bt subd5185
cmp/hs r3,r0
bt/s subhd5185
dt r7
bra divutend5185
dt r7
subhd5185:
bra divutend5185
sub r3,r0
subd5185:
sub r8,r0
divutend5185:
dt r4
bf/s dutloop5185
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5187
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5187:
jmp @r4
mov r0,r2
.align 5
ln5186:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5188
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5188:
jmp @r4
mov r0,r2
.align 5
ln5185:
mov.l g2_except_addr5185,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5185,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5189
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5189:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5185: .long group_2_exception
bf_addr5185: .long basefunction
! Opcodes 8EF0 - 8EF7
SEF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5190
cmp/hs r3,r1
bt ln5191
mov #15,r4
mov r1,r0
dutloop5190:
bt subd5190
cmp/hs r3,r0
bt/s subhd5190
dt r7
bra divutend5190
dt r7
subhd5190:
bra divutend5190
sub r3,r0
subd5190:
sub r8,r0
divutend5190:
dt r4
bf/s dutloop5190
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5192
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5192:
jmp @r4
mov r0,r2
.align 5
ln5191:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5193
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5193:
jmp @r4
mov r0,r2
.align 5
ln5190:
mov.l g2_except_addr5190,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5190,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5194
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5194:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5190: .long group_2_exception
bf_addr5190: .long basefunction
! Opcode 8EF8
SEF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5195
cmp/hs r3,r1
bt ln5196
mov #15,r4
mov r1,r0
dutloop5195:
bt subd5195
cmp/hs r3,r0
bt/s subhd5195
dt r7
bra divutend5195
dt r7
subhd5195:
bra divutend5195
sub r3,r0
subd5195:
sub r8,r0
divutend5195:
dt r4
bf/s dutloop5195
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5197
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5197:
jmp @r4
mov r0,r2
.align 5
ln5196:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5198
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5198:
jmp @r4
mov r0,r2
.align 5
ln5195:
mov.l g2_except_addr5195,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5195,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5199
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5199:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5195: .long group_2_exception
bf_addr5195: .long basefunction
! Opcode 8EF9
SEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5200
cmp/hs r3,r1
bt ln5201
mov #15,r4
mov r1,r0
dutloop5200:
bt subd5200
cmp/hs r3,r0
bt/s subhd5200
dt r7
bra divutend5200
dt r7
subhd5200:
bra divutend5200
sub r3,r0
subd5200:
sub r8,r0
divutend5200:
dt r4
bf/s dutloop5200
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5202
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5202:
jmp @r4
mov r0,r2
.align 5
ln5201:
mov #0x8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5203
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5203:
jmp @r4
mov r0,r2
.align 5
ln5200:
mov.l g2_except_addr5200,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5200,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5204
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5204:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5200: .long group_2_exception
bf_addr5200: .long basefunction
! Opcode 8EFA
SEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5205
cmp/hs r3,r1
bt ln5206
mov #15,r4
mov r1,r0
dutloop5205:
bt subd5205
cmp/hs r3,r0
bt/s subhd5205
dt r7
bra divutend5205
dt r7
subhd5205:
bra divutend5205
sub r3,r0
subd5205:
sub r8,r0
divutend5205:
dt r4
bf/s dutloop5205
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5207
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5207:
jmp @r4
mov r0,r2
.align 5
ln5206:
mov #0x8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5208
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5208:
jmp @r4
mov r0,r2
.align 5
ln5205:
mov.l g2_except_addr5205,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5205,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5209
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5209:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5205: .long group_2_exception
bf_addr5205: .long basefunction
! Opcode 8EFB
SEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5210
cmp/hs r3,r1
bt ln5211
mov #15,r4
mov r1,r0
dutloop5210:
bt subd5210
cmp/hs r3,r0
bt/s subhd5210
dt r7
bra divutend5210
dt r7
subhd5210:
bra divutend5210
sub r3,r0
subd5210:
sub r8,r0
divutend5210:
dt r4
bf/s dutloop5210
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5212
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5212:
jmp @r4
mov r0,r2
.align 5
ln5211:
mov #0x8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5213
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5213:
jmp @r4
mov r0,r2
.align 5
ln5210:
mov.l g2_except_addr5210,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5210,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5214
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5214:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5210: .long group_2_exception
bf_addr5210: .long basefunction
! Opcode 8EFC
SEFC:
mov.w @r6+,r3
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5215
cmp/hs r3,r1
bt ln5216
mov #15,r4
mov r1,r0
dutloop5215:
bt subd5215
cmp/hs r3,r0
bt/s subhd5215
dt r7
bra divutend5215
dt r7
subhd5215:
bra divutend5215
sub r3,r0
subd5215:
sub r8,r0
divutend5215:
dt r4
bf/s dutloop5215
shll r0
mov r1,r0
div0u
.rept 16
div1 r3,r1
.endr
rotcl r1
extu.w r1,r3
mulu.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5217
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5217:
jmp @r4
mov r0,r2
.align 5
ln5216:
mov #0x8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5218
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5218:
jmp @r4
mov r0,r2
.align 5
ln5215:
mov.l g2_except_addr5215,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5215,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5219
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5219:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5215: .long group_2_exception
bf_addr5215: .long basefunction
! Opcodes 8F00 - 8F07
SF00:
and r1,r2
mov.l r3,@-r15
mov #28,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd5220
add #-6,r8
.nonibadd5220:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop5220
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop5220:
exts.b r3,r3
mov r9,r8
mov #28,r0
mov.b r3,@(r0,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5221
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5221:
jmp @r4
mov r0,r2
! Opcodes 8F08 - 8F0F
SF08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
subc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd5222
add #-6,r8
.nonibadd5222:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
sub r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop5222
mov #0xA0,r0
extu.b r0,r0
add r0,r3
.endop5222:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5223
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5223:
jmp @r4
mov r0,r2
! Opcodes 8F10 - 8F17
SF10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5224
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5224:
jmp @r4
mov r0,r2
! Opcodes 8F18 - 8F1F
SF18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5225
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5225:
jmp @r4
mov r0,r2
! Opcodes 8F20 - 8F27
SF20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5226
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5226:
jmp @r4
mov r0,r2
! Opcodes 8F28 - 8F2F
SF28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5227
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5227:
jmp @r4
mov r0,r2
! Opcodes 8F30 - 8F37
SF30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5228
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5228:
jmp @r4
mov r0,r2
! Opcode 8F38
SF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5229
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5229:
jmp @r4
mov r0,r2
! Opcode 8F39
SF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
or r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5230
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5230:
jmp @r4
mov r0,r2
! Opcodes 8F50 - 8F57
SF50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5231
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5231:
jmp @r4
mov r0,r2
! Opcodes 8F58 - 8F5F
SF58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5232
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5232:
jmp @r4
mov r0,r2
! Opcodes 8F60 - 8F67
SF60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5233
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5233:
jmp @r4
mov r0,r2
! Opcodes 8F68 - 8F6F
SF68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5234
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5234:
jmp @r4
mov r0,r2
! Opcodes 8F70 - 8F77
SF70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5235
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5235:
jmp @r4
mov r0,r2
! Opcode 8F78
SF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5236
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5236:
jmp @r4
mov r0,r2
! Opcode 8F79
SF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
or r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5237
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5237:
jmp @r4
mov r0,r2
! Opcodes 8F90 - 8F97
SF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5238
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5238:
jmp @r4
mov r0,r2
! Opcodes 8F98 - 8F9F
SF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5239
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5239:
jmp @r4
mov r0,r2
! Opcodes 8FA0 - 8FA7
SFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5240
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5240:
jmp @r4
mov r0,r2
! Opcodes 8FA8 - 8FAF
SFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5241
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5241:
jmp @r4
mov r0,r2
! Opcodes 8FB0 - 8FB7
SFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5242
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5242:
jmp @r4
mov r0,r2
! Opcode 8FB8
SFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5243
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5243:
jmp @r4
mov r0,r2
! Opcode 8FB9
SFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
or r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5244
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5244:
jmp @r4
mov r0,r2
! Opcodes 8FC0 - 8FC7
SFC0:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5245
cmp/pz r3
bt/s noidivis5245
mov r3,r2
neg r2,r2
noidivis5245:
cmp/pz r1
bt/s noidivid5245
mov r1,r0
neg r0,r0
noidivid5245:
cmp/hs r2,r0
bt ln5246
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-11,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5247
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5247:
jmp @r4
mov r0,r2
.align 5
ln5246:
mov #0x8,r8
mov.w @r6+,r0
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5248
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5248:
jmp @r4
mov r0,r2
.align 5
ln5245:
mov.l g2_except_addr5245,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5245,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5249
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5249:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5245: .long group_2_exception
bf_addr5245: .long basefunction
! Opcodes 8FD0 - 8FD7
SFD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5250
cmp/pz r3
bt/s noidivis5250
mov r3,r2
neg r2,r2
noidivis5250:
cmp/pz r1
bt/s noidivid5250
mov r1,r0
neg r0,r0
noidivid5250:
cmp/hs r2,r0
bt ln5251
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5252
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5252:
jmp @r4
mov r0,r2
.align 5
ln5251:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5253
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5253:
jmp @r4
mov r0,r2
.align 5
ln5250:
mov.l g2_except_addr5250,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5250,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5254
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5254:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5250: .long group_2_exception
bf_addr5250: .long basefunction
! Opcodes 8FD8 - 8FDF
SFD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5255
cmp/pz r3
bt/s noidivis5255
mov r3,r2
neg r2,r2
noidivis5255:
cmp/pz r1
bt/s noidivid5255
mov r1,r0
neg r0,r0
noidivid5255:
cmp/hs r2,r0
bt ln5256
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5257
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5257:
jmp @r4
mov r0,r2
.align 5
ln5256:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5258
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5258:
jmp @r4
mov r0,r2
.align 5
ln5255:
mov.l g2_except_addr5255,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5255,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5259
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5259:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5255: .long group_2_exception
bf_addr5255: .long basefunction
! Opcodes 8FE0 - 8FE7
SFE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5260
cmp/pz r3
bt/s noidivis5260
mov r3,r2
neg r2,r2
noidivis5260:
cmp/pz r1
bt/s noidivid5260
mov r1,r0
neg r0,r0
noidivid5260:
cmp/hs r2,r0
bt ln5261
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-17,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5262
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5262:
jmp @r4
mov r0,r2
.align 5
ln5261:
mov #0x8,r8
mov.w @r6+,r0
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5263
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5263:
jmp @r4
mov r0,r2
.align 5
ln5260:
mov.l g2_except_addr5260,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5260,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5264
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5264:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5260: .long group_2_exception
bf_addr5260: .long basefunction
! Opcodes 8FE8 - 8FEF
SFE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5265
cmp/pz r3
bt/s noidivis5265
mov r3,r2
neg r2,r2
noidivis5265:
cmp/pz r1
bt/s noidivid5265
mov r1,r0
neg r0,r0
noidivid5265:
cmp/hs r2,r0
bt ln5266
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5267
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5267:
jmp @r4
mov r0,r2
.align 5
ln5266:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5268
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5268:
jmp @r4
mov r0,r2
.align 5
ln5265:
mov.l g2_except_addr5265,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5265,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5269
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5269:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5265: .long group_2_exception
bf_addr5265: .long basefunction
! Opcodes 8FF0 - 8FF7
SFF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5270
cmp/pz r3
bt/s noidivis5270
mov r3,r2
neg r2,r2
noidivis5270:
cmp/pz r1
bt/s noidivid5270
mov r1,r0
neg r0,r0
noidivid5270:
cmp/hs r2,r0
bt ln5271
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5272
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5272:
jmp @r4
mov r0,r2
.align 5
ln5271:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5273
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5273:
jmp @r4
mov r0,r2
.align 5
ln5270:
mov.l g2_except_addr5270,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5270,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5274
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5274:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5270: .long group_2_exception
bf_addr5270: .long basefunction
! Opcode 8FF8
SFF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5275
cmp/pz r3
bt/s noidivis5275
mov r3,r2
neg r2,r2
noidivis5275:
cmp/pz r1
bt/s noidivid5275
mov r1,r0
neg r0,r0
noidivid5275:
cmp/hs r2,r0
bt ln5276
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5277
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5277:
jmp @r4
mov r0,r2
.align 5
ln5276:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5278
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5278:
jmp @r4
mov r0,r2
.align 5
ln5275:
mov.l g2_except_addr5275,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5275,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5279
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5279:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5275: .long group_2_exception
bf_addr5275: .long basefunction
! Opcode 8FF9
SFF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5280
cmp/pz r3
bt/s noidivis5280
mov r3,r2
neg r2,r2
noidivis5280:
cmp/pz r1
bt/s noidivid5280
mov r1,r0
neg r0,r0
noidivid5280:
cmp/hs r2,r0
bt ln5281
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-23,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5282
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5282:
jmp @r4
mov r0,r2
.align 5
ln5281:
mov #0x8,r8
mov.w @r6+,r0
add #-29,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5283
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5283:
jmp @r4
mov r0,r2
.align 5
ln5280:
mov.l g2_except_addr5280,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5280,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5284
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5284:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5280: .long group_2_exception
bf_addr5280: .long basefunction
! Opcode 8FFA
SFFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5285
cmp/pz r3
bt/s noidivis5285
mov r3,r2
neg r2,r2
noidivis5285:
cmp/pz r1
bt/s noidivid5285
mov r1,r0
neg r0,r0
noidivid5285:
cmp/hs r2,r0
bt ln5286
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-19,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5287
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5287:
jmp @r4
mov r0,r2
.align 5
ln5286:
mov #0x8,r8
mov.w @r6+,r0
add #-25,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5288
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5288:
jmp @r4
mov r0,r2
.align 5
ln5285:
mov.l g2_except_addr5285,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5285,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5289
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5289:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5285: .long group_2_exception
bf_addr5285: .long basefunction
! Opcode 8FFB
SFFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5290
cmp/pz r3
bt/s noidivis5290
mov r3,r2
neg r2,r2
noidivis5290:
cmp/pz r1
bt/s noidivid5290
mov r1,r0
neg r0,r0
noidivid5290:
cmp/hs r2,r0
bt ln5291
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5292
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5292:
jmp @r4
mov r0,r2
.align 5
ln5291:
mov #0x8,r8
mov.w @r6+,r0
add #-27,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5293
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5293:
jmp @r4
mov r0,r2
.align 5
ln5290:
mov.l g2_except_addr5290,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5290,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5294
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5294:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5290: .long group_2_exception
bf_addr5290: .long basefunction
! Opcode 8FFC
SFFC:
mov.w @r6+,r3
mov.l @(28,r13),r1
mov r3,r8
shll16 r3
tst r3,r3
bt ln5295
cmp/pz r3
bt/s noidivis5295
mov r3,r2
neg r2,r2
noidivis5295:
cmp/pz r1
bt/s noidivid5295
mov r1,r0
neg r0,r0
noidivid5295:
cmp/hs r2,r0
bt ln5296
mov r1,r0
mov #0,r2
rotl r0
subc r2,r1
rotr r0
div0s r3,r1
.rept 16
div1 r3,r1
.endr
exts.w r1,r3
rotcl r3
addc r2,r3
extu.w r3,r3
muls.w r3,r8
sts macl,r8
sub r8,r0
shll16 r0
or r0,r3
mov.l r3,@(28,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-128,r7
add #-15,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5297
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5297:
jmp @r4
mov r0,r2
.align 5
ln5296:
mov #0x8,r8
mov.w @r6+,r0
add #-21,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5298
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5298:
jmp @r4
mov r0,r2
.align 5
ln5295:
mov.l g2_except_addr5295,r0
jsr @r0
mov #0x14,r4
mov.l bf_addr5295,r0
jsr @r0
nop
add r5,r6
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5299
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5299:
jmp @r4
mov r0,r2
.align 2
g2_except_addr5295: .long group_2_exception
bf_addr5295: .long basefunction
! Opcodes 9000 - 9007
T000:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5300
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5300:
jmp @r4
mov r0,r2
! Opcodes 9008 - 900F
T008:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5301
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5301:
jmp @r4
mov r0,r2
! Opcodes 9010 - 9017
T010:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5302
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5302:
jmp @r4
mov r0,r2
! Opcodes 9018 - 901F
T018:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5303
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5303:
jmp @r4
mov r0,r2
! Opcodes 9020 - 9027
T020:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5304
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5304:
jmp @r4
mov r0,r2
! Opcodes 9028 - 902F
T028:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5305
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5305:
jmp @r4
mov r0,r2
! Opcodes 9030 - 9037
T030:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5306
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5306:
jmp @r4
mov r0,r2
! Opcode 9038
T038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5307
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5307:
jmp @r4
mov r0,r2
! Opcode 9039
T039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5308
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5308:
jmp @r4
mov r0,r2
! Opcode 903A
T03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5309
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5309:
jmp @r4
mov r0,r2
! Opcode 903B
T03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5310
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5310:
jmp @r4
mov r0,r2
! Opcode 903C
T03C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5311
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5311:
jmp @r4
mov r0,r2
! Opcodes 9040 - 9047
T040:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5312
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5312:
jmp @r4
mov r0,r2
! Opcodes 9048 - 904F
T048:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5313
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5313:
jmp @r4
mov r0,r2
! Opcodes 9050 - 9057
T050:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5314
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5314:
jmp @r4
mov r0,r2
! Opcodes 9058 - 905F
T058:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5315
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5315:
jmp @r4
mov r0,r2
! Opcodes 9060 - 9067
T060:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5316
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5316:
jmp @r4
mov r0,r2
! Opcodes 9068 - 906F
T068:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5317
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5317:
jmp @r4
mov r0,r2
! Opcodes 9070 - 9077
T070:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5318
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5318:
jmp @r4
mov r0,r2
! Opcode 9078
T078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5319
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5319:
jmp @r4
mov r0,r2
! Opcode 9079
T079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5320
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5320:
jmp @r4
mov r0,r2
! Opcode 907A
T07A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5321
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5321:
jmp @r4
mov r0,r2
! Opcode 907B
T07B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5322
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5322:
jmp @r4
mov r0,r2
! Opcode 907C
T07C:
mov.w @r6+,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5323
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5323:
jmp @r4
mov r0,r2
! Opcodes 9080 - 9087
T080:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5324
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5324:
jmp @r4
mov r0,r2
! Opcodes 9088 - 908F
T088:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5325
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5325:
jmp @r4
mov r0,r2
! Opcodes 9090 - 9097
T090:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5326
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5326:
jmp @r4
mov r0,r2
! Opcodes 9098 - 909F
T098:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5327
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5327:
jmp @r4
mov r0,r2
! Opcodes 90A0 - 90A7
T0A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5328
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5328:
jmp @r4
mov r0,r2
! Opcodes 90A8 - 90AF
T0A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5329
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5329:
jmp @r4
mov r0,r2
! Opcodes 90B0 - 90B7
T0B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5330
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5330:
jmp @r4
mov r0,r2
! Opcode 90B8
T0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5331
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5331:
jmp @r4
mov r0,r2
! Opcode 90B9
T0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5332
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5332:
jmp @r4
mov r0,r2
! Opcode 90BA
T0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5333
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5333:
jmp @r4
mov r0,r2
! Opcode 90BB
T0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5334
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5334:
jmp @r4
mov r0,r2
! Opcode 90BC
T0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5335
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5335:
jmp @r4
mov r0,r2
! Opcodes 90C0 - 90C7
T0C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5336
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5336:
jmp @r4
mov r0,r2
! Opcodes 90C8 - 90CF
T0C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5337
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5337:
jmp @r4
mov r0,r2
! Opcodes 90D0 - 90D7
T0D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5338
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5338:
jmp @r4
mov r0,r2
! Opcodes 90D8 - 90DF
T0D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5339
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5339:
jmp @r4
mov r0,r2
! Opcodes 90E0 - 90E7
T0E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5340
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5340:
jmp @r4
mov r0,r2
! Opcodes 90E8 - 90EF
T0E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5341
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5341:
jmp @r4
mov r0,r2
! Opcodes 90F0 - 90F7
T0F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5342
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5342:
jmp @r4
mov r0,r2
! Opcode 90F8
T0F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5343
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5343:
jmp @r4
mov r0,r2
! Opcode 90F9
T0F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5344
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5344:
jmp @r4
mov r0,r2
! Opcode 90FA
T0FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5345
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5345:
jmp @r4
mov r0,r2
! Opcode 90FB
T0FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5346
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5346:
jmp @r4
mov r0,r2
! Opcode 90FC
T0FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5347
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5347:
jmp @r4
mov r0,r2
! Opcodes 9100 - 9107
T100:
and r1,r2
mov r3,r4
mov.b @r13,r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.b r3,@r13
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5349
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5349:
jmp @r4
mov r0,r2
! Opcodes 9108 - 910F
T108:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(32,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5351
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5351:
jmp @r4
mov r0,r2
! Opcodes 9110 - 9117
T110:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5352
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5352:
jmp @r4
mov r0,r2
! Opcodes 9118 - 911F
T118:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5353
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5353:
jmp @r4
mov r0,r2
! Opcodes 9120 - 9127
T120:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5354
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5354:
jmp @r4
mov r0,r2
! Opcodes 9128 - 912F
T128:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5355
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5355:
jmp @r4
mov r0,r2
! Opcodes 9130 - 9137
T130:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5356
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5356:
jmp @r4
mov r0,r2
! Opcode 9138
T138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5357
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5357:
jmp @r4
mov r0,r2
! Opcode 9139
T139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5358
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5358:
jmp @r4
mov r0,r2
! Opcodes 9140 - 9147
T140:
and r1,r2
mov r3,r4
mov.w @r13,r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.w r3,@r13
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5360
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5360:
jmp @r4
mov r0,r2
! Opcodes 9148 - 914F
T148:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(32,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5362
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5362:
jmp @r4
mov r0,r2
! Opcodes 9150 - 9157
T150:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5363
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5363:
jmp @r4
mov r0,r2
! Opcodes 9158 - 915F
T158:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5364
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5364:
jmp @r4
mov r0,r2
! Opcodes 9160 - 9167
T160:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5365
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5365:
jmp @r4
mov r0,r2
! Opcodes 9168 - 916F
T168:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5366
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5366:
jmp @r4
mov r0,r2
! Opcodes 9170 - 9177
T170:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5367
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5367:
jmp @r4
mov r0,r2
! Opcode 9178
T178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5368
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5368:
jmp @r4
mov r0,r2
! Opcode 9179
T179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5369
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5369:
jmp @r4
mov r0,r2
! Opcodes 9180 - 9187
T180:
and r1,r2
mov r3,r4
mov.l @r13,r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@r13
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5371
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5371:
jmp @r4
mov r0,r2
! Opcodes 9188 - 918F
T188:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(32,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5373
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5373:
jmp @r4
mov r0,r2
! Opcodes 9190 - 9197
T190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5374
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5374:
jmp @r4
mov r0,r2
! Opcodes 9198 - 919F
T198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5375
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5375:
jmp @r4
mov r0,r2
! Opcodes 91A0 - 91A7
T1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5376
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5376:
jmp @r4
mov r0,r2
! Opcodes 91A8 - 91AF
T1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5377
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5377:
jmp @r4
mov r0,r2
! Opcodes 91B0 - 91B7
T1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5378
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5378:
jmp @r4
mov r0,r2
! Opcode 91B8
T1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5379
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5379:
jmp @r4
mov r0,r2
! Opcode 91B9
T1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5380
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5380:
jmp @r4
mov r0,r2
! Opcodes 91C0 - 91C7
T1C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5381
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5381:
jmp @r4
mov r0,r2
! Opcodes 91C8 - 91CF
T1C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5382
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5382:
jmp @r4
mov r0,r2
! Opcodes 91D0 - 91D7
T1D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5383
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5383:
jmp @r4
mov r0,r2
! Opcodes 91D8 - 91DF
T1D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5384
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5384:
jmp @r4
mov r0,r2
! Opcodes 91E0 - 91E7
T1E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5385
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5385:
jmp @r4
mov r0,r2
! Opcodes 91E8 - 91EF
T1E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5386
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5386:
jmp @r4
mov r0,r2
! Opcodes 91F0 - 91F7
T1F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5387
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5387:
jmp @r4
mov r0,r2
! Opcode 91F8
T1F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5388
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5388:
jmp @r4
mov r0,r2
! Opcode 91F9
T1F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5389
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5389:
jmp @r4
mov r0,r2
! Opcode 91FA
T1FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5390
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5390:
jmp @r4
mov r0,r2
! Opcode 91FB
T1FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5391
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5391:
jmp @r4
mov r0,r2
! Opcode 91FC
T1FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r1
sub r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5392
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5392:
jmp @r4
mov r0,r2
! Opcodes 9200 - 9207
T200:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5393
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5393:
jmp @r4
mov r0,r2
! Opcodes 9208 - 920F
T208:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5394
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5394:
jmp @r4
mov r0,r2
! Opcodes 9210 - 9217
T210:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5395
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5395:
jmp @r4
mov r0,r2
! Opcodes 9218 - 921F
T218:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5396
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5396:
jmp @r4
mov r0,r2
! Opcodes 9220 - 9227
T220:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5397
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5397:
jmp @r4
mov r0,r2
! Opcodes 9228 - 922F
T228:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5398
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5398:
jmp @r4
mov r0,r2
! Opcodes 9230 - 9237
T230:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5399
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5399:
jmp @r4
mov r0,r2
! Opcode 9238
T238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5400
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5400:
jmp @r4
mov r0,r2
! Opcode 9239
T239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5401
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5401:
jmp @r4
mov r0,r2
! Opcode 923A
T23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5402
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5402:
jmp @r4
mov r0,r2
! Opcode 923B
T23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5403
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5403:
jmp @r4
mov r0,r2
! Opcode 923C
T23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5404
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5404:
jmp @r4
mov r0,r2
! Opcodes 9240 - 9247
T240:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5405
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5405:
jmp @r4
mov r0,r2
! Opcodes 9248 - 924F
T248:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5406
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5406:
jmp @r4
mov r0,r2
! Opcodes 9250 - 9257
T250:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5407
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5407:
jmp @r4
mov r0,r2
! Opcodes 9258 - 925F
T258:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5408
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5408:
jmp @r4
mov r0,r2
! Opcodes 9260 - 9267
T260:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5409
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5409:
jmp @r4
mov r0,r2
! Opcodes 9268 - 926F
T268:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5410
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5410:
jmp @r4
mov r0,r2
! Opcodes 9270 - 9277
T270:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5411
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5411:
jmp @r4
mov r0,r2
! Opcode 9278
T278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5412
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5412:
jmp @r4
mov r0,r2
! Opcode 9279
T279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5413
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5413:
jmp @r4
mov r0,r2
! Opcode 927A
T27A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5414
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5414:
jmp @r4
mov r0,r2
! Opcode 927B
T27B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5415
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5415:
jmp @r4
mov r0,r2
! Opcode 927C
T27C:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5416
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5416:
jmp @r4
mov r0,r2
! Opcodes 9280 - 9287
T280:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5417
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5417:
jmp @r4
mov r0,r2
! Opcodes 9288 - 928F
T288:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5418
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5418:
jmp @r4
mov r0,r2
! Opcodes 9290 - 9297
T290:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5419
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5419:
jmp @r4
mov r0,r2
! Opcodes 9298 - 929F
T298:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5420
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5420:
jmp @r4
mov r0,r2
! Opcodes 92A0 - 92A7
T2A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5421
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5421:
jmp @r4
mov r0,r2
! Opcodes 92A8 - 92AF
T2A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5422
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5422:
jmp @r4
mov r0,r2
! Opcodes 92B0 - 92B7
T2B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5423
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5423:
jmp @r4
mov r0,r2
! Opcode 92B8
T2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5424
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5424:
jmp @r4
mov r0,r2
! Opcode 92B9
T2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5425
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5425:
jmp @r4
mov r0,r2
! Opcode 92BA
T2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5426
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5426:
jmp @r4
mov r0,r2
! Opcode 92BB
T2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5427
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5427:
jmp @r4
mov r0,r2
! Opcode 92BC
T2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5428
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5428:
jmp @r4
mov r0,r2
! Opcodes 92C0 - 92C7
T2C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5429
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5429:
jmp @r4
mov r0,r2
! Opcodes 92C8 - 92CF
T2C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5430
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5430:
jmp @r4
mov r0,r2
! Opcodes 92D0 - 92D7
T2D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5431
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5431:
jmp @r4
mov r0,r2
! Opcodes 92D8 - 92DF
T2D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5432
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5432:
jmp @r4
mov r0,r2
! Opcodes 92E0 - 92E7
T2E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5433
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5433:
jmp @r4
mov r0,r2
! Opcodes 92E8 - 92EF
T2E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5434
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5434:
jmp @r4
mov r0,r2
! Opcodes 92F0 - 92F7
T2F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5435
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5435:
jmp @r4
mov r0,r2
! Opcode 92F8
T2F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5436
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5436:
jmp @r4
mov r0,r2
! Opcode 92F9
T2F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5437
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5437:
jmp @r4
mov r0,r2
! Opcode 92FA
T2FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5438
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5438:
jmp @r4
mov r0,r2
! Opcode 92FB
T2FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5439
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5439:
jmp @r4
mov r0,r2
! Opcode 92FC
T2FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5440
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5440:
jmp @r4
mov r0,r2
! Opcodes 9300 - 9307
T300:
and r1,r2
mov r3,r4
mov #4,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5442
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5442:
jmp @r4
mov r0,r2
! Opcodes 9308 - 930F
T308:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(36,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5444
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5444:
jmp @r4
mov r0,r2
! Opcodes 9310 - 9317
T310:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5445
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5445:
jmp @r4
mov r0,r2
! Opcodes 9318 - 931F
T318:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5446
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5446:
jmp @r4
mov r0,r2
! Opcodes 9320 - 9327
T320:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5447
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5447:
jmp @r4
mov r0,r2
! Opcodes 9328 - 932F
T328:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5448
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5448:
jmp @r4
mov r0,r2
! Opcodes 9330 - 9337
T330:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5449
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5449:
jmp @r4
mov r0,r2
! Opcode 9338
T338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5450
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5450:
jmp @r4
mov r0,r2
! Opcode 9339
T339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5451
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5451:
jmp @r4
mov r0,r2
! Opcodes 9340 - 9347
T340:
and r1,r2
mov r3,r4
mov #4,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5453
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5453:
jmp @r4
mov r0,r2
! Opcodes 9348 - 934F
T348:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(36,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5455
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5455:
jmp @r4
mov r0,r2
! Opcodes 9350 - 9357
T350:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5456
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5456:
jmp @r4
mov r0,r2
! Opcodes 9358 - 935F
T358:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5457
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5457:
jmp @r4
mov r0,r2
! Opcodes 9360 - 9367
T360:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5458
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5458:
jmp @r4
mov r0,r2
! Opcodes 9368 - 936F
T368:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5459
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5459:
jmp @r4
mov r0,r2
! Opcodes 9370 - 9377
T370:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5460
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5460:
jmp @r4
mov r0,r2
! Opcode 9378
T378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5461
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5461:
jmp @r4
mov r0,r2
! Opcode 9379
T379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5462
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5462:
jmp @r4
mov r0,r2
! Opcodes 9380 - 9387
T380:
and r1,r2
mov r3,r4
mov.l @(4,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(4,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5464
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5464:
jmp @r4
mov r0,r2
! Opcodes 9388 - 938F
T388:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(36,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5466
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5466:
jmp @r4
mov r0,r2
! Opcodes 9390 - 9397
T390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5467
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5467:
jmp @r4
mov r0,r2
! Opcodes 9398 - 939F
T398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5468
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5468:
jmp @r4
mov r0,r2
! Opcodes 93A0 - 93A7
T3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5469
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5469:
jmp @r4
mov r0,r2
! Opcodes 93A8 - 93AF
T3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5470
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5470:
jmp @r4
mov r0,r2
! Opcodes 93B0 - 93B7
T3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5471
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5471:
jmp @r4
mov r0,r2
! Opcode 93B8
T3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5472
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5472:
jmp @r4
mov r0,r2
! Opcode 93B9
T3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5473
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5473:
jmp @r4
mov r0,r2
! Opcodes 93C0 - 93C7
T3C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5474
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5474:
jmp @r4
mov r0,r2
! Opcodes 93C8 - 93CF
T3C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5475
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5475:
jmp @r4
mov r0,r2
! Opcodes 93D0 - 93D7
T3D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5476
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5476:
jmp @r4
mov r0,r2
! Opcodes 93D8 - 93DF
T3D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5477
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5477:
jmp @r4
mov r0,r2
! Opcodes 93E0 - 93E7
T3E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5478
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5478:
jmp @r4
mov r0,r2
! Opcodes 93E8 - 93EF
T3E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5479
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5479:
jmp @r4
mov r0,r2
! Opcodes 93F0 - 93F7
T3F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5480
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5480:
jmp @r4
mov r0,r2
! Opcode 93F8
T3F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5481
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5481:
jmp @r4
mov r0,r2
! Opcode 93F9
T3F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5482
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5482:
jmp @r4
mov r0,r2
! Opcode 93FA
T3FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5483
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5483:
jmp @r4
mov r0,r2
! Opcode 93FB
T3FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5484
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5484:
jmp @r4
mov r0,r2
! Opcode 93FC
T3FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r1
sub r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5485
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5485:
jmp @r4
mov r0,r2
! Opcodes 9400 - 9407
T400:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5486
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5486:
jmp @r4
mov r0,r2
! Opcodes 9408 - 940F
T408:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5487
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5487:
jmp @r4
mov r0,r2
! Opcodes 9410 - 9417
T410:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5488
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5488:
jmp @r4
mov r0,r2
! Opcodes 9418 - 941F
T418:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5489
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5489:
jmp @r4
mov r0,r2
! Opcodes 9420 - 9427
T420:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5490
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5490:
jmp @r4
mov r0,r2
! Opcodes 9428 - 942F
T428:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5491
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5491:
jmp @r4
mov r0,r2
! Opcodes 9430 - 9437
T430:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5492
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5492:
jmp @r4
mov r0,r2
! Opcode 9438
T438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5493
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5493:
jmp @r4
mov r0,r2
! Opcode 9439
T439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5494
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5494:
jmp @r4
mov r0,r2
! Opcode 943A
T43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5495
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5495:
jmp @r4
mov r0,r2
! Opcode 943B
T43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5496
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5496:
jmp @r4
mov r0,r2
! Opcode 943C
T43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5497
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5497:
jmp @r4
mov r0,r2
! Opcodes 9440 - 9447
T440:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5498
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5498:
jmp @r4
mov r0,r2
! Opcodes 9448 - 944F
T448:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5499
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5499:
jmp @r4
mov r0,r2
! Opcodes 9450 - 9457
T450:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5500
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5500:
jmp @r4
mov r0,r2
! Opcodes 9458 - 945F
T458:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5501
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5501:
jmp @r4
mov r0,r2
! Opcodes 9460 - 9467
T460:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5502
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5502:
jmp @r4
mov r0,r2
! Opcodes 9468 - 946F
T468:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5503
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5503:
jmp @r4
mov r0,r2
! Opcodes 9470 - 9477
T470:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5504
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5504:
jmp @r4
mov r0,r2
! Opcode 9478
T478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5505
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5505:
jmp @r4
mov r0,r2
! Opcode 9479
T479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5506
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5506:
jmp @r4
mov r0,r2
! Opcode 947A
T47A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5507
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5507:
jmp @r4
mov r0,r2
! Opcode 947B
T47B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5508
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5508:
jmp @r4
mov r0,r2
! Opcode 947C
T47C:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5509
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5509:
jmp @r4
mov r0,r2
! Opcodes 9480 - 9487
T480:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5510
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5510:
jmp @r4
mov r0,r2
! Opcodes 9488 - 948F
T488:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5511
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5511:
jmp @r4
mov r0,r2
! Opcodes 9490 - 9497
T490:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5512
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5512:
jmp @r4
mov r0,r2
! Opcodes 9498 - 949F
T498:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5513
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5513:
jmp @r4
mov r0,r2
! Opcodes 94A0 - 94A7
T4A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5514
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5514:
jmp @r4
mov r0,r2
! Opcodes 94A8 - 94AF
T4A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5515
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5515:
jmp @r4
mov r0,r2
! Opcodes 94B0 - 94B7
T4B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5516
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5516:
jmp @r4
mov r0,r2
! Opcode 94B8
T4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5517
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5517:
jmp @r4
mov r0,r2
! Opcode 94B9
T4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5518
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5518:
jmp @r4
mov r0,r2
! Opcode 94BA
T4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5519
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5519:
jmp @r4
mov r0,r2
! Opcode 94BB
T4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5520
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5520:
jmp @r4
mov r0,r2
! Opcode 94BC
T4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5521
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5521:
jmp @r4
mov r0,r2
! Opcodes 94C0 - 94C7
T4C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5522
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5522:
jmp @r4
mov r0,r2
! Opcodes 94C8 - 94CF
T4C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5523
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5523:
jmp @r4
mov r0,r2
! Opcodes 94D0 - 94D7
T4D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5524
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5524:
jmp @r4
mov r0,r2
! Opcodes 94D8 - 94DF
T4D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5525
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5525:
jmp @r4
mov r0,r2
! Opcodes 94E0 - 94E7
T4E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5526
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5526:
jmp @r4
mov r0,r2
! Opcodes 94E8 - 94EF
T4E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5527
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5527:
jmp @r4
mov r0,r2
! Opcodes 94F0 - 94F7
T4F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5528
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5528:
jmp @r4
mov r0,r2
! Opcode 94F8
T4F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5529
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5529:
jmp @r4
mov r0,r2
! Opcode 94F9
T4F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5530
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5530:
jmp @r4
mov r0,r2
! Opcode 94FA
T4FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5531
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5531:
jmp @r4
mov r0,r2
! Opcode 94FB
T4FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5532
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5532:
jmp @r4
mov r0,r2
! Opcode 94FC
T4FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5533
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5533:
jmp @r4
mov r0,r2
! Opcodes 9500 - 9507
T500:
and r1,r2
mov r3,r4
mov #8,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5535
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5535:
jmp @r4
mov r0,r2
! Opcodes 9508 - 950F
T508:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(40,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5537
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5537:
jmp @r4
mov r0,r2
! Opcodes 9510 - 9517
T510:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5538
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5538:
jmp @r4
mov r0,r2
! Opcodes 9518 - 951F
T518:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5539
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5539:
jmp @r4
mov r0,r2
! Opcodes 9520 - 9527
T520:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5540
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5540:
jmp @r4
mov r0,r2
! Opcodes 9528 - 952F
T528:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5541
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5541:
jmp @r4
mov r0,r2
! Opcodes 9530 - 9537
T530:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5542
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5542:
jmp @r4
mov r0,r2
! Opcode 9538
T538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5543
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5543:
jmp @r4
mov r0,r2
! Opcode 9539
T539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5544
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5544:
jmp @r4
mov r0,r2
! Opcodes 9540 - 9547
T540:
and r1,r2
mov r3,r4
mov #8,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5546
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5546:
jmp @r4
mov r0,r2
! Opcodes 9548 - 954F
T548:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(40,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5548
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5548:
jmp @r4
mov r0,r2
! Opcodes 9550 - 9557
T550:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5549
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5549:
jmp @r4
mov r0,r2
! Opcodes 9558 - 955F
T558:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5550
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5550:
jmp @r4
mov r0,r2
! Opcodes 9560 - 9567
T560:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5551
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5551:
jmp @r4
mov r0,r2
! Opcodes 9568 - 956F
T568:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5552
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5552:
jmp @r4
mov r0,r2
! Opcodes 9570 - 9577
T570:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5553
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5553:
jmp @r4
mov r0,r2
! Opcode 9578
T578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5554
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5554:
jmp @r4
mov r0,r2
! Opcode 9579
T579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5555
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5555:
jmp @r4
mov r0,r2
! Opcodes 9580 - 9587
T580:
and r1,r2
mov r3,r4
mov.l @(8,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(8,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5557
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5557:
jmp @r4
mov r0,r2
! Opcodes 9588 - 958F
T588:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(40,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5559
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5559:
jmp @r4
mov r0,r2
! Opcodes 9590 - 9597
T590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5560
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5560:
jmp @r4
mov r0,r2
! Opcodes 9598 - 959F
T598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5561
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5561:
jmp @r4
mov r0,r2
! Opcodes 95A0 - 95A7
T5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5562
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5562:
jmp @r4
mov r0,r2
! Opcodes 95A8 - 95AF
T5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5563
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5563:
jmp @r4
mov r0,r2
! Opcodes 95B0 - 95B7
T5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5564
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5564:
jmp @r4
mov r0,r2
! Opcode 95B8
T5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5565
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5565:
jmp @r4
mov r0,r2
! Opcode 95B9
T5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5566
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5566:
jmp @r4
mov r0,r2
! Opcodes 95C0 - 95C7
T5C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5567
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5567:
jmp @r4
mov r0,r2
! Opcodes 95C8 - 95CF
T5C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5568
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5568:
jmp @r4
mov r0,r2
! Opcodes 95D0 - 95D7
T5D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5569
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5569:
jmp @r4
mov r0,r2
! Opcodes 95D8 - 95DF
T5D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5570
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5570:
jmp @r4
mov r0,r2
! Opcodes 95E0 - 95E7
T5E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5571
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5571:
jmp @r4
mov r0,r2
! Opcodes 95E8 - 95EF
T5E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5572
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5572:
jmp @r4
mov r0,r2
! Opcodes 95F0 - 95F7
T5F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5573
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5573:
jmp @r4
mov r0,r2
! Opcode 95F8
T5F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5574
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5574:
jmp @r4
mov r0,r2
! Opcode 95F9
T5F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5575
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5575:
jmp @r4
mov r0,r2
! Opcode 95FA
T5FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5576
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5576:
jmp @r4
mov r0,r2
! Opcode 95FB
T5FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5577
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5577:
jmp @r4
mov r0,r2
! Opcode 95FC
T5FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r1
sub r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5578
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5578:
jmp @r4
mov r0,r2
! Opcodes 9600 - 9607
T600:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5579
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5579:
jmp @r4
mov r0,r2
! Opcodes 9608 - 960F
T608:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5580
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5580:
jmp @r4
mov r0,r2
! Opcodes 9610 - 9617
T610:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5581
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5581:
jmp @r4
mov r0,r2
! Opcodes 9618 - 961F
T618:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5582
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5582:
jmp @r4
mov r0,r2
! Opcodes 9620 - 9627
T620:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5583
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5583:
jmp @r4
mov r0,r2
! Opcodes 9628 - 962F
T628:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5584
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5584:
jmp @r4
mov r0,r2
! Opcodes 9630 - 9637
T630:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5585
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5585:
jmp @r4
mov r0,r2
! Opcode 9638
T638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5586
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5586:
jmp @r4
mov r0,r2
! Opcode 9639
T639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5587
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5587:
jmp @r4
mov r0,r2
! Opcode 963A
T63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5588
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5588:
jmp @r4
mov r0,r2
! Opcode 963B
T63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5589
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5589:
jmp @r4
mov r0,r2
! Opcode 963C
T63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5590
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5590:
jmp @r4
mov r0,r2
! Opcodes 9640 - 9647
T640:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5591
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5591:
jmp @r4
mov r0,r2
! Opcodes 9648 - 964F
T648:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5592
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5592:
jmp @r4
mov r0,r2
! Opcodes 9650 - 9657
T650:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5593
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5593:
jmp @r4
mov r0,r2
! Opcodes 9658 - 965F
T658:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5594
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5594:
jmp @r4
mov r0,r2
! Opcodes 9660 - 9667
T660:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5595
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5595:
jmp @r4
mov r0,r2
! Opcodes 9668 - 966F
T668:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5596
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5596:
jmp @r4
mov r0,r2
! Opcodes 9670 - 9677
T670:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5597
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5597:
jmp @r4
mov r0,r2
! Opcode 9678
T678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5598
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5598:
jmp @r4
mov r0,r2
! Opcode 9679
T679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5599
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5599:
jmp @r4
mov r0,r2
! Opcode 967A
T67A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5600
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5600:
jmp @r4
mov r0,r2
! Opcode 967B
T67B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5601
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5601:
jmp @r4
mov r0,r2
! Opcode 967C
T67C:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5602
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5602:
jmp @r4
mov r0,r2
! Opcodes 9680 - 9687
T680:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5603
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5603:
jmp @r4
mov r0,r2
! Opcodes 9688 - 968F
T688:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5604
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5604:
jmp @r4
mov r0,r2
! Opcodes 9690 - 9697
T690:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5605
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5605:
jmp @r4
mov r0,r2
! Opcodes 9698 - 969F
T698:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5606
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5606:
jmp @r4
mov r0,r2
! Opcodes 96A0 - 96A7
T6A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5607
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5607:
jmp @r4
mov r0,r2
! Opcodes 96A8 - 96AF
T6A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5608
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5608:
jmp @r4
mov r0,r2
! Opcodes 96B0 - 96B7
T6B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5609
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5609:
jmp @r4
mov r0,r2
! Opcode 96B8
T6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5610
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5610:
jmp @r4
mov r0,r2
! Opcode 96B9
T6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5611
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5611:
jmp @r4
mov r0,r2
! Opcode 96BA
T6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5612
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5612:
jmp @r4
mov r0,r2
! Opcode 96BB
T6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5613
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5613:
jmp @r4
mov r0,r2
! Opcode 96BC
T6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5614
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5614:
jmp @r4
mov r0,r2
! Opcodes 96C0 - 96C7
T6C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5615
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5615:
jmp @r4
mov r0,r2
! Opcodes 96C8 - 96CF
T6C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5616
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5616:
jmp @r4
mov r0,r2
! Opcodes 96D0 - 96D7
T6D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5617
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5617:
jmp @r4
mov r0,r2
! Opcodes 96D8 - 96DF
T6D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5618
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5618:
jmp @r4
mov r0,r2
! Opcodes 96E0 - 96E7
T6E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5619
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5619:
jmp @r4
mov r0,r2
! Opcodes 96E8 - 96EF
T6E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5620
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5620:
jmp @r4
mov r0,r2
! Opcodes 96F0 - 96F7
T6F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5621
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5621:
jmp @r4
mov r0,r2
! Opcode 96F8
T6F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5622
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5622:
jmp @r4
mov r0,r2
! Opcode 96F9
T6F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5623
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5623:
jmp @r4
mov r0,r2
! Opcode 96FA
T6FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5624
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5624:
jmp @r4
mov r0,r2
! Opcode 96FB
T6FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5625
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5625:
jmp @r4
mov r0,r2
! Opcode 96FC
T6FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5626
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5626:
jmp @r4
mov r0,r2
! Opcodes 9700 - 9707
T700:
and r1,r2
mov r3,r4
mov #12,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5628
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5628:
jmp @r4
mov r0,r2
! Opcodes 9708 - 970F
T708:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(44,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5630
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5630:
jmp @r4
mov r0,r2
! Opcodes 9710 - 9717
T710:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5631
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5631:
jmp @r4
mov r0,r2
! Opcodes 9718 - 971F
T718:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5632
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5632:
jmp @r4
mov r0,r2
! Opcodes 9720 - 9727
T720:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5633
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5633:
jmp @r4
mov r0,r2
! Opcodes 9728 - 972F
T728:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5634
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5634:
jmp @r4
mov r0,r2
! Opcodes 9730 - 9737
T730:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5635
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5635:
jmp @r4
mov r0,r2
! Opcode 9738
T738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5636
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5636:
jmp @r4
mov r0,r2
! Opcode 9739
T739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5637
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5637:
jmp @r4
mov r0,r2
! Opcodes 9740 - 9747
T740:
and r1,r2
mov r3,r4
mov #12,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5639
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5639:
jmp @r4
mov r0,r2
! Opcodes 9748 - 974F
T748:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(44,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5641
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5641:
jmp @r4
mov r0,r2
! Opcodes 9750 - 9757
T750:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5642
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5642:
jmp @r4
mov r0,r2
! Opcodes 9758 - 975F
T758:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5643
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5643:
jmp @r4
mov r0,r2
! Opcodes 9760 - 9767
T760:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5644
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5644:
jmp @r4
mov r0,r2
! Opcodes 9768 - 976F
T768:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5645
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5645:
jmp @r4
mov r0,r2
! Opcodes 9770 - 9777
T770:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5646
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5646:
jmp @r4
mov r0,r2
! Opcode 9778
T778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5647
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5647:
jmp @r4
mov r0,r2
! Opcode 9779
T779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5648
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5648:
jmp @r4
mov r0,r2
! Opcodes 9780 - 9787
T780:
and r1,r2
mov r3,r4
mov.l @(12,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(12,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5650
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5650:
jmp @r4
mov r0,r2
! Opcodes 9788 - 978F
T788:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(44,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5652
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5652:
jmp @r4
mov r0,r2
! Opcodes 9790 - 9797
T790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5653
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5653:
jmp @r4
mov r0,r2
! Opcodes 9798 - 979F
T798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5654
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5654:
jmp @r4
mov r0,r2
! Opcodes 97A0 - 97A7
T7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5655
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5655:
jmp @r4
mov r0,r2
! Opcodes 97A8 - 97AF
T7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5656
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5656:
jmp @r4
mov r0,r2
! Opcodes 97B0 - 97B7
T7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5657
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5657:
jmp @r4
mov r0,r2
! Opcode 97B8
T7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5658
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5658:
jmp @r4
mov r0,r2
! Opcode 97B9
T7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5659
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5659:
jmp @r4
mov r0,r2
! Opcodes 97C0 - 97C7
T7C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5660
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5660:
jmp @r4
mov r0,r2
! Opcodes 97C8 - 97CF
T7C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5661
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5661:
jmp @r4
mov r0,r2
! Opcodes 97D0 - 97D7
T7D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5662
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5662:
jmp @r4
mov r0,r2
! Opcodes 97D8 - 97DF
T7D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5663
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5663:
jmp @r4
mov r0,r2
! Opcodes 97E0 - 97E7
T7E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5664
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5664:
jmp @r4
mov r0,r2
! Opcodes 97E8 - 97EF
T7E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5665
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5665:
jmp @r4
mov r0,r2
! Opcodes 97F0 - 97F7
T7F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5666
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5666:
jmp @r4
mov r0,r2
! Opcode 97F8
T7F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5667
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5667:
jmp @r4
mov r0,r2
! Opcode 97F9
T7F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5668
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5668:
jmp @r4
mov r0,r2
! Opcode 97FA
T7FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5669
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5669:
jmp @r4
mov r0,r2
! Opcode 97FB
T7FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5670
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5670:
jmp @r4
mov r0,r2
! Opcode 97FC
T7FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r1
sub r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5671
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5671:
jmp @r4
mov r0,r2
! Opcodes 9800 - 9807
T800:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5672
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5672:
jmp @r4
mov r0,r2
! Opcodes 9808 - 980F
T808:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5673
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5673:
jmp @r4
mov r0,r2
! Opcodes 9810 - 9817
T810:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5674
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5674:
jmp @r4
mov r0,r2
! Opcodes 9818 - 981F
T818:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5675
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5675:
jmp @r4
mov r0,r2
! Opcodes 9820 - 9827
T820:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5676
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5676:
jmp @r4
mov r0,r2
! Opcodes 9828 - 982F
T828:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5677
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5677:
jmp @r4
mov r0,r2
! Opcodes 9830 - 9837
T830:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5678
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5678:
jmp @r4
mov r0,r2
! Opcode 9838
T838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5679
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5679:
jmp @r4
mov r0,r2
! Opcode 9839
T839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5680
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5680:
jmp @r4
mov r0,r2
! Opcode 983A
T83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5681
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5681:
jmp @r4
mov r0,r2
! Opcode 983B
T83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5682
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5682:
jmp @r4
mov r0,r2
! Opcode 983C
T83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5683
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5683:
jmp @r4
mov r0,r2
! Opcodes 9840 - 9847
T840:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5684
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5684:
jmp @r4
mov r0,r2
! Opcodes 9848 - 984F
T848:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5685
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5685:
jmp @r4
mov r0,r2
! Opcodes 9850 - 9857
T850:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5686
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5686:
jmp @r4
mov r0,r2
! Opcodes 9858 - 985F
T858:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5687
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5687:
jmp @r4
mov r0,r2
! Opcodes 9860 - 9867
T860:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5688
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5688:
jmp @r4
mov r0,r2
! Opcodes 9868 - 986F
T868:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5689
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5689:
jmp @r4
mov r0,r2
! Opcodes 9870 - 9877
T870:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5690
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5690:
jmp @r4
mov r0,r2
! Opcode 9878
T878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5691
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5691:
jmp @r4
mov r0,r2
! Opcode 9879
T879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5692
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5692:
jmp @r4
mov r0,r2
! Opcode 987A
T87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5693
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5693:
jmp @r4
mov r0,r2
! Opcode 987B
T87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5694
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5694:
jmp @r4
mov r0,r2
! Opcode 987C
T87C:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5695
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5695:
jmp @r4
mov r0,r2
! Opcodes 9880 - 9887
T880:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5696
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5696:
jmp @r4
mov r0,r2
! Opcodes 9888 - 988F
T888:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5697
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5697:
jmp @r4
mov r0,r2
! Opcodes 9890 - 9897
T890:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5698
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5698:
jmp @r4
mov r0,r2
! Opcodes 9898 - 989F
T898:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5699
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5699:
jmp @r4
mov r0,r2
! Opcodes 98A0 - 98A7
T8A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5700
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5700:
jmp @r4
mov r0,r2
! Opcodes 98A8 - 98AF
T8A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5701
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5701:
jmp @r4
mov r0,r2
! Opcodes 98B0 - 98B7
T8B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5702
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5702:
jmp @r4
mov r0,r2
! Opcode 98B8
T8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5703
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5703:
jmp @r4
mov r0,r2
! Opcode 98B9
T8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5704
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5704:
jmp @r4
mov r0,r2
! Opcode 98BA
T8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5705
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5705:
jmp @r4
mov r0,r2
! Opcode 98BB
T8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5706
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5706:
jmp @r4
mov r0,r2
! Opcode 98BC
T8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5707
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5707:
jmp @r4
mov r0,r2
! Opcodes 98C0 - 98C7
T8C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5708
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5708:
jmp @r4
mov r0,r2
! Opcodes 98C8 - 98CF
T8C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5709
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5709:
jmp @r4
mov r0,r2
! Opcodes 98D0 - 98D7
T8D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5710
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5710:
jmp @r4
mov r0,r2
! Opcodes 98D8 - 98DF
T8D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5711
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5711:
jmp @r4
mov r0,r2
! Opcodes 98E0 - 98E7
T8E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5712
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5712:
jmp @r4
mov r0,r2
! Opcodes 98E8 - 98EF
T8E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5713
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5713:
jmp @r4
mov r0,r2
! Opcodes 98F0 - 98F7
T8F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5714
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5714:
jmp @r4
mov r0,r2
! Opcode 98F8
T8F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5715
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5715:
jmp @r4
mov r0,r2
! Opcode 98F9
T8F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5716
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5716:
jmp @r4
mov r0,r2
! Opcode 98FA
T8FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5717
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5717:
jmp @r4
mov r0,r2
! Opcode 98FB
T8FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5718
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5718:
jmp @r4
mov r0,r2
! Opcode 98FC
T8FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5719
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5719:
jmp @r4
mov r0,r2
! Opcodes 9900 - 9907
T900:
and r1,r2
mov r3,r4
mov #16,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5721
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5721:
jmp @r4
mov r0,r2
! Opcodes 9908 - 990F
T908:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(48,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5723
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5723:
jmp @r4
mov r0,r2
! Opcodes 9910 - 9917
T910:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5724
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5724:
jmp @r4
mov r0,r2
! Opcodes 9918 - 991F
T918:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5725
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5725:
jmp @r4
mov r0,r2
! Opcodes 9920 - 9927
T920:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5726
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5726:
jmp @r4
mov r0,r2
! Opcodes 9928 - 992F
T928:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5727
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5727:
jmp @r4
mov r0,r2
! Opcodes 9930 - 9937
T930:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5728
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5728:
jmp @r4
mov r0,r2
! Opcode 9938
T938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5729
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5729:
jmp @r4
mov r0,r2
! Opcode 9939
T939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5730
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5730:
jmp @r4
mov r0,r2
! Opcodes 9940 - 9947
T940:
and r1,r2
mov r3,r4
mov #16,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5732
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5732:
jmp @r4
mov r0,r2
! Opcodes 9948 - 994F
T948:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(48,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5734
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5734:
jmp @r4
mov r0,r2
! Opcodes 9950 - 9957
T950:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5735
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5735:
jmp @r4
mov r0,r2
! Opcodes 9958 - 995F
T958:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5736
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5736:
jmp @r4
mov r0,r2
! Opcodes 9960 - 9967
T960:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5737
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5737:
jmp @r4
mov r0,r2
! Opcodes 9968 - 996F
T968:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5738
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5738:
jmp @r4
mov r0,r2
! Opcodes 9970 - 9977
T970:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5739
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5739:
jmp @r4
mov r0,r2
! Opcode 9978
T978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5740
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5740:
jmp @r4
mov r0,r2
! Opcode 9979
T979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5741
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5741:
jmp @r4
mov r0,r2
! Opcodes 9980 - 9987
T980:
and r1,r2
mov r3,r4
mov.l @(16,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(16,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5743
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5743:
jmp @r4
mov r0,r2
! Opcodes 9988 - 998F
T988:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(48,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5745
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5745:
jmp @r4
mov r0,r2
! Opcodes 9990 - 9997
T990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5746
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5746:
jmp @r4
mov r0,r2
! Opcodes 9998 - 999F
T998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5747
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5747:
jmp @r4
mov r0,r2
! Opcodes 99A0 - 99A7
T9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5748
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5748:
jmp @r4
mov r0,r2
! Opcodes 99A8 - 99AF
T9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5749
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5749:
jmp @r4
mov r0,r2
! Opcodes 99B0 - 99B7
T9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5750
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5750:
jmp @r4
mov r0,r2
! Opcode 99B8
T9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5751
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5751:
jmp @r4
mov r0,r2
! Opcode 99B9
T9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5752
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5752:
jmp @r4
mov r0,r2
! Opcodes 99C0 - 99C7
T9C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5753
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5753:
jmp @r4
mov r0,r2
! Opcodes 99C8 - 99CF
T9C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5754
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5754:
jmp @r4
mov r0,r2
! Opcodes 99D0 - 99D7
T9D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5755
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5755:
jmp @r4
mov r0,r2
! Opcodes 99D8 - 99DF
T9D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5756
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5756:
jmp @r4
mov r0,r2
! Opcodes 99E0 - 99E7
T9E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5757
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5757:
jmp @r4
mov r0,r2
! Opcodes 99E8 - 99EF
T9E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5758
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5758:
jmp @r4
mov r0,r2
! Opcodes 99F0 - 99F7
T9F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5759
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5759:
jmp @r4
mov r0,r2
! Opcode 99F8
T9F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5760
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5760:
jmp @r4
mov r0,r2
! Opcode 99F9
T9F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5761
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5761:
jmp @r4
mov r0,r2
! Opcode 99FA
T9FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5762
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5762:
jmp @r4
mov r0,r2
! Opcode 99FB
T9FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5763
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5763:
jmp @r4
mov r0,r2
! Opcode 99FC
T9FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r1
sub r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5764
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5764:
jmp @r4
mov r0,r2
! Opcodes 9A00 - 9A07
TA00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5765
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5765:
jmp @r4
mov r0,r2
! Opcodes 9A08 - 9A0F
TA08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5766
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5766:
jmp @r4
mov r0,r2
! Opcodes 9A10 - 9A17
TA10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5767
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5767:
jmp @r4
mov r0,r2
! Opcodes 9A18 - 9A1F
TA18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5768
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5768:
jmp @r4
mov r0,r2
! Opcodes 9A20 - 9A27
TA20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5769
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5769:
jmp @r4
mov r0,r2
! Opcodes 9A28 - 9A2F
TA28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5770
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5770:
jmp @r4
mov r0,r2
! Opcodes 9A30 - 9A37
TA30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5771
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5771:
jmp @r4
mov r0,r2
! Opcode 9A38
TA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5772
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5772:
jmp @r4
mov r0,r2
! Opcode 9A39
TA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5773
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5773:
jmp @r4
mov r0,r2
! Opcode 9A3A
TA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5774
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5774:
jmp @r4
mov r0,r2
! Opcode 9A3B
TA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5775
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5775:
jmp @r4
mov r0,r2
! Opcode 9A3C
TA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5776
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5776:
jmp @r4
mov r0,r2
! Opcodes 9A40 - 9A47
TA40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5777
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5777:
jmp @r4
mov r0,r2
! Opcodes 9A48 - 9A4F
TA48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5778
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5778:
jmp @r4
mov r0,r2
! Opcodes 9A50 - 9A57
TA50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5779
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5779:
jmp @r4
mov r0,r2
! Opcodes 9A58 - 9A5F
TA58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5780
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5780:
jmp @r4
mov r0,r2
! Opcodes 9A60 - 9A67
TA60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5781
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5781:
jmp @r4
mov r0,r2
! Opcodes 9A68 - 9A6F
TA68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5782
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5782:
jmp @r4
mov r0,r2
! Opcodes 9A70 - 9A77
TA70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5783
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5783:
jmp @r4
mov r0,r2
! Opcode 9A78
TA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5784
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5784:
jmp @r4
mov r0,r2
! Opcode 9A79
TA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5785
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5785:
jmp @r4
mov r0,r2
! Opcode 9A7A
TA7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5786
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5786:
jmp @r4
mov r0,r2
! Opcode 9A7B
TA7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5787
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5787:
jmp @r4
mov r0,r2
! Opcode 9A7C
TA7C:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5788
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5788:
jmp @r4
mov r0,r2
! Opcodes 9A80 - 9A87
TA80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5789
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5789:
jmp @r4
mov r0,r2
! Opcodes 9A88 - 9A8F
TA88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5790
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5790:
jmp @r4
mov r0,r2
! Opcodes 9A90 - 9A97
TA90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5791
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5791:
jmp @r4
mov r0,r2
! Opcodes 9A98 - 9A9F
TA98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5792
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5792:
jmp @r4
mov r0,r2
! Opcodes 9AA0 - 9AA7
TAA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5793
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5793:
jmp @r4
mov r0,r2
! Opcodes 9AA8 - 9AAF
TAA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5794
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5794:
jmp @r4
mov r0,r2
! Opcodes 9AB0 - 9AB7
TAB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5795
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5795:
jmp @r4
mov r0,r2
! Opcode 9AB8
TAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5796
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5796:
jmp @r4
mov r0,r2
! Opcode 9AB9
TAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5797
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5797:
jmp @r4
mov r0,r2
! Opcode 9ABA
TABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5798
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5798:
jmp @r4
mov r0,r2
! Opcode 9ABB
TABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5799
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5799:
jmp @r4
mov r0,r2
! Opcode 9ABC
TABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5800
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5800:
jmp @r4
mov r0,r2
! Opcodes 9AC0 - 9AC7
TAC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5801
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5801:
jmp @r4
mov r0,r2
! Opcodes 9AC8 - 9ACF
TAC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5802
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5802:
jmp @r4
mov r0,r2
! Opcodes 9AD0 - 9AD7
TAD0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5803
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5803:
jmp @r4
mov r0,r2
! Opcodes 9AD8 - 9ADF
TAD8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5804
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5804:
jmp @r4
mov r0,r2
! Opcodes 9AE0 - 9AE7
TAE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5805
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5805:
jmp @r4
mov r0,r2
! Opcodes 9AE8 - 9AEF
TAE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5806
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5806:
jmp @r4
mov r0,r2
! Opcodes 9AF0 - 9AF7
TAF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5807
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5807:
jmp @r4
mov r0,r2
! Opcode 9AF8
TAF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5808
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5808:
jmp @r4
mov r0,r2
! Opcode 9AF9
TAF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5809
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5809:
jmp @r4
mov r0,r2
! Opcode 9AFA
TAFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5810
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5810:
jmp @r4
mov r0,r2
! Opcode 9AFB
TAFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5811
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5811:
jmp @r4
mov r0,r2
! Opcode 9AFC
TAFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5812
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5812:
jmp @r4
mov r0,r2
! Opcodes 9B00 - 9B07
TB00:
and r1,r2
mov r3,r4
mov #20,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5814
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5814:
jmp @r4
mov r0,r2
! Opcodes 9B08 - 9B0F
TB08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(52,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5816
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5816:
jmp @r4
mov r0,r2
! Opcodes 9B10 - 9B17
TB10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5817
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5817:
jmp @r4
mov r0,r2
! Opcodes 9B18 - 9B1F
TB18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5818
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5818:
jmp @r4
mov r0,r2
! Opcodes 9B20 - 9B27
TB20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5819
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5819:
jmp @r4
mov r0,r2
! Opcodes 9B28 - 9B2F
TB28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5820
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5820:
jmp @r4
mov r0,r2
! Opcodes 9B30 - 9B37
TB30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5821
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5821:
jmp @r4
mov r0,r2
! Opcode 9B38
TB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5822
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5822:
jmp @r4
mov r0,r2
! Opcode 9B39
TB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5823
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5823:
jmp @r4
mov r0,r2
! Opcodes 9B40 - 9B47
TB40:
and r1,r2
mov r3,r4
mov #20,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5825
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5825:
jmp @r4
mov r0,r2
! Opcodes 9B48 - 9B4F
TB48:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(52,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5827
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5827:
jmp @r4
mov r0,r2
! Opcodes 9B50 - 9B57
TB50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5828
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5828:
jmp @r4
mov r0,r2
! Opcodes 9B58 - 9B5F
TB58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5829
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5829:
jmp @r4
mov r0,r2
! Opcodes 9B60 - 9B67
TB60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5830
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5830:
jmp @r4
mov r0,r2
! Opcodes 9B68 - 9B6F
TB68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5831
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5831:
jmp @r4
mov r0,r2
! Opcodes 9B70 - 9B77
TB70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5832
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5832:
jmp @r4
mov r0,r2
! Opcode 9B78
TB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5833
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5833:
jmp @r4
mov r0,r2
! Opcode 9B79
TB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5834
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5834:
jmp @r4
mov r0,r2
! Opcodes 9B80 - 9B87
TB80:
and r1,r2
mov r3,r4
mov.l @(20,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(20,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5836
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5836:
jmp @r4
mov r0,r2
! Opcodes 9B88 - 9B8F
TB88:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(52,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5838
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5838:
jmp @r4
mov r0,r2
! Opcodes 9B90 - 9B97
TB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5839
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5839:
jmp @r4
mov r0,r2
! Opcodes 9B98 - 9B9F
TB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5840
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5840:
jmp @r4
mov r0,r2
! Opcodes 9BA0 - 9BA7
TBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5841
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5841:
jmp @r4
mov r0,r2
! Opcodes 9BA8 - 9BAF
TBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5842
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5842:
jmp @r4
mov r0,r2
! Opcodes 9BB0 - 9BB7
TBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5843
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5843:
jmp @r4
mov r0,r2
! Opcode 9BB8
TBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5844
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5844:
jmp @r4
mov r0,r2
! Opcode 9BB9
TBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5845
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5845:
jmp @r4
mov r0,r2
! Opcodes 9BC0 - 9BC7
TBC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5846
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5846:
jmp @r4
mov r0,r2
! Opcodes 9BC8 - 9BCF
TBC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5847
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5847:
jmp @r4
mov r0,r2
! Opcodes 9BD0 - 9BD7
TBD0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5848
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5848:
jmp @r4
mov r0,r2
! Opcodes 9BD8 - 9BDF
TBD8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5849
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5849:
jmp @r4
mov r0,r2
! Opcodes 9BE0 - 9BE7
TBE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5850
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5850:
jmp @r4
mov r0,r2
! Opcodes 9BE8 - 9BEF
TBE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5851
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5851:
jmp @r4
mov r0,r2
! Opcodes 9BF0 - 9BF7
TBF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5852
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5852:
jmp @r4
mov r0,r2
! Opcode 9BF8
TBF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5853
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5853:
jmp @r4
mov r0,r2
! Opcode 9BF9
TBF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5854
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5854:
jmp @r4
mov r0,r2
! Opcode 9BFA
TBFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5855
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5855:
jmp @r4
mov r0,r2
! Opcode 9BFB
TBFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5856
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5856:
jmp @r4
mov r0,r2
! Opcode 9BFC
TBFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r1
sub r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5857
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5857:
jmp @r4
mov r0,r2
! Opcodes 9C00 - 9C07
TC00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5858
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5858:
jmp @r4
mov r0,r2
! Opcodes 9C08 - 9C0F
TC08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5859
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5859:
jmp @r4
mov r0,r2
! Opcodes 9C10 - 9C17
TC10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5860
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5860:
jmp @r4
mov r0,r2
! Opcodes 9C18 - 9C1F
TC18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5861
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5861:
jmp @r4
mov r0,r2
! Opcodes 9C20 - 9C27
TC20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5862
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5862:
jmp @r4
mov r0,r2
! Opcodes 9C28 - 9C2F
TC28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5863
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5863:
jmp @r4
mov r0,r2
! Opcodes 9C30 - 9C37
TC30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5864
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5864:
jmp @r4
mov r0,r2
! Opcode 9C38
TC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5865
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5865:
jmp @r4
mov r0,r2
! Opcode 9C39
TC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5866
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5866:
jmp @r4
mov r0,r2
! Opcode 9C3A
TC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5867
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5867:
jmp @r4
mov r0,r2
! Opcode 9C3B
TC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5868
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5868:
jmp @r4
mov r0,r2
! Opcode 9C3C
TC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5869
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5869:
jmp @r4
mov r0,r2
! Opcodes 9C40 - 9C47
TC40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5870
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5870:
jmp @r4
mov r0,r2
! Opcodes 9C48 - 9C4F
TC48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5871
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5871:
jmp @r4
mov r0,r2
! Opcodes 9C50 - 9C57
TC50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5872
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5872:
jmp @r4
mov r0,r2
! Opcodes 9C58 - 9C5F
TC58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5873
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5873:
jmp @r4
mov r0,r2
! Opcodes 9C60 - 9C67
TC60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5874
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5874:
jmp @r4
mov r0,r2
! Opcodes 9C68 - 9C6F
TC68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5875
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5875:
jmp @r4
mov r0,r2
! Opcodes 9C70 - 9C77
TC70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5876
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5876:
jmp @r4
mov r0,r2
! Opcode 9C78
TC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5877
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5877:
jmp @r4
mov r0,r2
! Opcode 9C79
TC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5878
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5878:
jmp @r4
mov r0,r2
! Opcode 9C7A
TC7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5879
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5879:
jmp @r4
mov r0,r2
! Opcode 9C7B
TC7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5880
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5880:
jmp @r4
mov r0,r2
! Opcode 9C7C
TC7C:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5881
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5881:
jmp @r4
mov r0,r2
! Opcodes 9C80 - 9C87
TC80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5882
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5882:
jmp @r4
mov r0,r2
! Opcodes 9C88 - 9C8F
TC88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5883
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5883:
jmp @r4
mov r0,r2
! Opcodes 9C90 - 9C97
TC90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5884
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5884:
jmp @r4
mov r0,r2
! Opcodes 9C98 - 9C9F
TC98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5885
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5885:
jmp @r4
mov r0,r2
! Opcodes 9CA0 - 9CA7
TCA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5886
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5886:
jmp @r4
mov r0,r2
! Opcodes 9CA8 - 9CAF
TCA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5887
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5887:
jmp @r4
mov r0,r2
! Opcodes 9CB0 - 9CB7
TCB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5888
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5888:
jmp @r4
mov r0,r2
! Opcode 9CB8
TCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5889
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5889:
jmp @r4
mov r0,r2
! Opcode 9CB9
TCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5890
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5890:
jmp @r4
mov r0,r2
! Opcode 9CBA
TCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5891
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5891:
jmp @r4
mov r0,r2
! Opcode 9CBB
TCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5892
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5892:
jmp @r4
mov r0,r2
! Opcode 9CBC
TCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5893
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5893:
jmp @r4
mov r0,r2
! Opcodes 9CC0 - 9CC7
TCC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5894
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5894:
jmp @r4
mov r0,r2
! Opcodes 9CC8 - 9CCF
TCC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5895
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5895:
jmp @r4
mov r0,r2
! Opcodes 9CD0 - 9CD7
TCD0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5896
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5896:
jmp @r4
mov r0,r2
! Opcodes 9CD8 - 9CDF
TCD8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5897
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5897:
jmp @r4
mov r0,r2
! Opcodes 9CE0 - 9CE7
TCE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5898
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5898:
jmp @r4
mov r0,r2
! Opcodes 9CE8 - 9CEF
TCE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5899
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5899:
jmp @r4
mov r0,r2
! Opcodes 9CF0 - 9CF7
TCF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5900
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5900:
jmp @r4
mov r0,r2
! Opcode 9CF8
TCF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5901
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5901:
jmp @r4
mov r0,r2
! Opcode 9CF9
TCF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5902
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5902:
jmp @r4
mov r0,r2
! Opcode 9CFA
TCFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5903
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5903:
jmp @r4
mov r0,r2
! Opcode 9CFB
TCFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5904
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5904:
jmp @r4
mov r0,r2
! Opcode 9CFC
TCFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5905
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5905:
jmp @r4
mov r0,r2
! Opcodes 9D00 - 9D07
TD00:
and r1,r2
mov r3,r4
mov #24,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5907
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5907:
jmp @r4
mov r0,r2
! Opcodes 9D08 - 9D0F
TD08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(56,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5909
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5909:
jmp @r4
mov r0,r2
! Opcodes 9D10 - 9D17
TD10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5910
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5910:
jmp @r4
mov r0,r2
! Opcodes 9D18 - 9D1F
TD18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5911
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5911:
jmp @r4
mov r0,r2
! Opcodes 9D20 - 9D27
TD20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5912
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5912:
jmp @r4
mov r0,r2
! Opcodes 9D28 - 9D2F
TD28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5913
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5913:
jmp @r4
mov r0,r2
! Opcodes 9D30 - 9D37
TD30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5914
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5914:
jmp @r4
mov r0,r2
! Opcode 9D38
TD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5915
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5915:
jmp @r4
mov r0,r2
! Opcode 9D39
TD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5916
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5916:
jmp @r4
mov r0,r2
! Opcodes 9D40 - 9D47
TD40:
and r1,r2
mov r3,r4
mov #24,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5918
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5918:
jmp @r4
mov r0,r2
! Opcodes 9D48 - 9D4F
TD48:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(56,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5920
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5920:
jmp @r4
mov r0,r2
! Opcodes 9D50 - 9D57
TD50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5921
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5921:
jmp @r4
mov r0,r2
! Opcodes 9D58 - 9D5F
TD58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5922
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5922:
jmp @r4
mov r0,r2
! Opcodes 9D60 - 9D67
TD60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5923
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5923:
jmp @r4
mov r0,r2
! Opcodes 9D68 - 9D6F
TD68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5924
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5924:
jmp @r4
mov r0,r2
! Opcodes 9D70 - 9D77
TD70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5925
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5925:
jmp @r4
mov r0,r2
! Opcode 9D78
TD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5926
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5926:
jmp @r4
mov r0,r2
! Opcode 9D79
TD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5927
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5927:
jmp @r4
mov r0,r2
! Opcodes 9D80 - 9D87
TD80:
and r1,r2
mov r3,r4
mov.l @(24,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(24,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5929
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5929:
jmp @r4
mov r0,r2
! Opcodes 9D88 - 9D8F
TD88:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(56,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5931
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5931:
jmp @r4
mov r0,r2
! Opcodes 9D90 - 9D97
TD90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5932
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5932:
jmp @r4
mov r0,r2
! Opcodes 9D98 - 9D9F
TD98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5933
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5933:
jmp @r4
mov r0,r2
! Opcodes 9DA0 - 9DA7
TDA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5934
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5934:
jmp @r4
mov r0,r2
! Opcodes 9DA8 - 9DAF
TDA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5935
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5935:
jmp @r4
mov r0,r2
! Opcodes 9DB0 - 9DB7
TDB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5936
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5936:
jmp @r4
mov r0,r2
! Opcode 9DB8
TDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5937
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5937:
jmp @r4
mov r0,r2
! Opcode 9DB9
TDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5938
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5938:
jmp @r4
mov r0,r2
! Opcodes 9DC0 - 9DC7
TDC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5939
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5939:
jmp @r4
mov r0,r2
! Opcodes 9DC8 - 9DCF
TDC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5940
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5940:
jmp @r4
mov r0,r2
! Opcodes 9DD0 - 9DD7
TDD0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5941
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5941:
jmp @r4
mov r0,r2
! Opcodes 9DD8 - 9DDF
TDD8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5942
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5942:
jmp @r4
mov r0,r2
! Opcodes 9DE0 - 9DE7
TDE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5943
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5943:
jmp @r4
mov r0,r2
! Opcodes 9DE8 - 9DEF
TDE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5944
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5944:
jmp @r4
mov r0,r2
! Opcodes 9DF0 - 9DF7
TDF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5945
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5945:
jmp @r4
mov r0,r2
! Opcode 9DF8
TDF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5946
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5946:
jmp @r4
mov r0,r2
! Opcode 9DF9
TDF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5947
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5947:
jmp @r4
mov r0,r2
! Opcode 9DFA
TDFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5948
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5948:
jmp @r4
mov r0,r2
! Opcode 9DFB
TDFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5949
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5949:
jmp @r4
mov r0,r2
! Opcode 9DFC
TDFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r1
sub r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5950
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5950:
jmp @r4
mov r0,r2
! Opcodes 9E00 - 9E07
TE00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5951
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5951:
jmp @r4
mov r0,r2
! Opcodes 9E08 - 9E0F
TE08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5952
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5952:
jmp @r4
mov r0,r2
! Opcodes 9E10 - 9E17
TE10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5953
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5953:
jmp @r4
mov r0,r2
! Opcodes 9E18 - 9E1F
TE18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5954
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5954:
jmp @r4
mov r0,r2
! Opcodes 9E20 - 9E27
TE20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5955
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5955:
jmp @r4
mov r0,r2
! Opcodes 9E28 - 9E2F
TE28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5956
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5956:
jmp @r4
mov r0,r2
! Opcodes 9E30 - 9E37
TE30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5957
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5957:
jmp @r4
mov r0,r2
! Opcode 9E38
TE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5958
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5958:
jmp @r4
mov r0,r2
! Opcode 9E39
TE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5959
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5959:
jmp @r4
mov r0,r2
! Opcode 9E3A
TE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5960
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5960:
jmp @r4
mov r0,r2
! Opcode 9E3B
TE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5961
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5961:
jmp @r4
mov r0,r2
! Opcode 9E3C
TE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5962
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5962:
jmp @r4
mov r0,r2
! Opcodes 9E40 - 9E47
TE40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5963
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5963:
jmp @r4
mov r0,r2
! Opcodes 9E48 - 9E4F
TE48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5964
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5964:
jmp @r4
mov r0,r2
! Opcodes 9E50 - 9E57
TE50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5965
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5965:
jmp @r4
mov r0,r2
! Opcodes 9E58 - 9E5F
TE58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5966
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5966:
jmp @r4
mov r0,r2
! Opcodes 9E60 - 9E67
TE60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5967
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5967:
jmp @r4
mov r0,r2
! Opcodes 9E68 - 9E6F
TE68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5968
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5968:
jmp @r4
mov r0,r2
! Opcodes 9E70 - 9E77
TE70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5969
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5969:
jmp @r4
mov r0,r2
! Opcode 9E78
TE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5970
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5970:
jmp @r4
mov r0,r2
! Opcode 9E79
TE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5971
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5971:
jmp @r4
mov r0,r2
! Opcode 9E7A
TE7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5972
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5972:
jmp @r4
mov r0,r2
! Opcode 9E7B
TE7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5973
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5973:
jmp @r4
mov r0,r2
! Opcode 9E7C
TE7C:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5974
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5974:
jmp @r4
mov r0,r2
! Opcodes 9E80 - 9E87
TE80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5975
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5975:
jmp @r4
mov r0,r2
! Opcodes 9E88 - 9E8F
TE88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5976
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5976:
jmp @r4
mov r0,r2
! Opcodes 9E90 - 9E97
TE90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5977
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5977:
jmp @r4
mov r0,r2
! Opcodes 9E98 - 9E9F
TE98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5978
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5978:
jmp @r4
mov r0,r2
! Opcodes 9EA0 - 9EA7
TEA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5979
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5979:
jmp @r4
mov r0,r2
! Opcodes 9EA8 - 9EAF
TEA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5980
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5980:
jmp @r4
mov r0,r2
! Opcodes 9EB0 - 9EB7
TEB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5981
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5981:
jmp @r4
mov r0,r2
! Opcode 9EB8
TEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5982
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5982:
jmp @r4
mov r0,r2
! Opcode 9EB9
TEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5983
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5983:
jmp @r4
mov r0,r2
! Opcode 9EBA
TEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5984
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5984:
jmp @r4
mov r0,r2
! Opcode 9EBB
TEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5985
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5985:
jmp @r4
mov r0,r2
! Opcode 9EBC
TEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5986
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5986:
jmp @r4
mov r0,r2
! Opcodes 9EC0 - 9EC7
TEC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5987
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5987:
jmp @r4
mov r0,r2
! Opcodes 9EC8 - 9ECF
TEC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5988
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5988:
jmp @r4
mov r0,r2
! Opcodes 9ED0 - 9ED7
TED0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5989
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5989:
jmp @r4
mov r0,r2
! Opcodes 9ED8 - 9EDF
TED8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5990
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5990:
jmp @r4
mov r0,r2
! Opcodes 9EE0 - 9EE7
TEE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5991
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5991:
jmp @r4
mov r0,r2
! Opcodes 9EE8 - 9EEF
TEE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5992
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5992:
jmp @r4
mov r0,r2
! Opcodes 9EF0 - 9EF7
TEF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5993
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5993:
jmp @r4
mov r0,r2
! Opcode 9EF8
TEF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5994
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5994:
jmp @r4
mov r0,r2
! Opcode 9EF9
TEF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5995
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5995:
jmp @r4
mov r0,r2
! Opcode 9EFA
TEFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5996
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5996:
jmp @r4
mov r0,r2
! Opcode 9EFB
TEFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5997
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5997:
jmp @r4
mov r0,r2
! Opcode 9EFC
TEFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl5998
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl5998:
jmp @r4
mov r0,r2
! Opcodes 9F00 - 9F07
TF00:
and r1,r2
mov r3,r4
mov #28,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6000
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6000:
jmp @r4
mov r0,r2
! Opcodes 9F08 - 9F0F
TF08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6002
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6002:
jmp @r4
mov r0,r2
! Opcodes 9F10 - 9F17
TF10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6003
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6003:
jmp @r4
mov r0,r2
! Opcodes 9F18 - 9F1F
TF18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6004
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6004:
jmp @r4
mov r0,r2
! Opcodes 9F20 - 9F27
TF20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6005
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6005:
jmp @r4
mov r0,r2
! Opcodes 9F28 - 9F2F
TF28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6006
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6006:
jmp @r4
mov r0,r2
! Opcodes 9F30 - 9F37
TF30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6007
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6007:
jmp @r4
mov r0,r2
! Opcode 9F38
TF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6008
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6008:
jmp @r4
mov r0,r2
! Opcode 9F39
TF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6009
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6009:
jmp @r4
mov r0,r2
! Opcodes 9F40 - 9F47
TF40:
and r1,r2
mov r3,r4
mov #28,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6011
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6011:
jmp @r4
mov r0,r2
! Opcodes 9F48 - 9F4F
TF48:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6013
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6013:
jmp @r4
mov r0,r2
! Opcodes 9F50 - 9F57
TF50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6014
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6014:
jmp @r4
mov r0,r2
! Opcodes 9F58 - 9F5F
TF58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6015
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6015:
jmp @r4
mov r0,r2
! Opcodes 9F60 - 9F67
TF60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6016
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6016:
jmp @r4
mov r0,r2
! Opcodes 9F68 - 9F6F
TF68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6017
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6017:
jmp @r4
mov r0,r2
! Opcodes 9F70 - 9F77
TF70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6018
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6018:
jmp @r4
mov r0,r2
! Opcode 9F78
TF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6019
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6019:
jmp @r4
mov r0,r2
! Opcode 9F79
TF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6020
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6020:
jmp @r4
mov r0,r2
! Opcodes 9F80 - 9F87
TF80:
and r1,r2
mov r3,r4
mov.l @(28,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(28,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6022
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6022:
jmp @r4
mov r0,r2
! Opcodes 9F88 - 9F8F
TF88:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(60,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
subc r1,r3
movt r9
clrt
subc r8,r3
movt r3
or r3,r9
subv r8,r0
movt r3
subv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6024
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6024:
jmp @r4
mov r0,r2
! Opcodes 9F90 - 9F97
TF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6025
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6025:
jmp @r4
mov r0,r2
! Opcodes 9F98 - 9F9F
TF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6026
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6026:
jmp @r4
mov r0,r2
! Opcodes 9FA0 - 9FA7
TFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6027
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6027:
jmp @r4
mov r0,r2
! Opcodes 9FA8 - 9FAF
TFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6028
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6028:
jmp @r4
mov r0,r2
! Opcodes 9FB0 - 9FB7
TFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6029
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6029:
jmp @r4
mov r0,r2
! Opcode 9FB8
TFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6030
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6030:
jmp @r4
mov r0,r2
! Opcode 9FB9
TFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
subv r1,r0
movt r8
clrt
subc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6031
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6031:
jmp @r4
mov r0,r2
! Opcodes 9FC0 - 9FC7
TFC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6032
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6032:
jmp @r4
mov r0,r2
! Opcodes 9FC8 - 9FCF
TFC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6033
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6033:
jmp @r4
mov r0,r2
! Opcodes 9FD0 - 9FD7
TFD0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6034
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6034:
jmp @r4
mov r0,r2
! Opcodes 9FD8 - 9FDF
TFD8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6035
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6035:
jmp @r4
mov r0,r2
! Opcodes 9FE0 - 9FE7
TFE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6036
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6036:
jmp @r4
mov r0,r2
! Opcodes 9FE8 - 9FEF
TFE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6037
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6037:
jmp @r4
mov r0,r2
! Opcodes 9FF0 - 9FF7
TFF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6038
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6038:
jmp @r4
mov r0,r2
! Opcode 9FF8
TFF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6039
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6039:
jmp @r4
mov r0,r2
! Opcode 9FF9
TFF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6040
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6040:
jmp @r4
mov r0,r2
! Opcode 9FFA
TFFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6041
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6041:
jmp @r4
mov r0,r2
! Opcode 9FFB
TFFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6042
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6042:
jmp @r4
mov r0,r2
! Opcode 9FFC
TFFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r1
sub r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6043
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6043:
jmp @r4
mov r0,r2
! Opcodes A000 - AFFF
U000:
mov.l r3,@-r15
mov.l g1_except_addr6044,r0
add #-2,r6
jsr @r0
mov #0x28,r4
mov.l bf_addr6044,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6045
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6045:
jmp @r4
mov r0,r2
.align 2
g1_except_addr6044: .long group_1_exception
bf_addr6044: .long basefunction
! Opcodes B000 - B007
V000:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6046
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6046:
jmp @r4
mov r0,r2
! Opcodes B008 - B00F
V008:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6047
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6047:
jmp @r4
mov r0,r2
! Opcodes B010 - B017
V010:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6048
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6048:
jmp @r4
mov r0,r2
! Opcodes B018 - B01F
V018:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6049
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6049:
jmp @r4
mov r0,r2
! Opcodes B020 - B027
V020:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6050
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6050:
jmp @r4
mov r0,r2
! Opcodes B028 - B02F
V028:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6051
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6051:
jmp @r4
mov r0,r2
! Opcodes B030 - B037
V030:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6052
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6052:
jmp @r4
mov r0,r2
! Opcode B038
V038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6053
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6053:
jmp @r4
mov r0,r2
! Opcode B039
V039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6054
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6054:
jmp @r4
mov r0,r2
! Opcode B03A
V03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6055
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6055:
jmp @r4
mov r0,r2
! Opcode B03B
V03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6056
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6056:
jmp @r4
mov r0,r2
! Opcode B03C
V03C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6057
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6057:
jmp @r4
mov r0,r2
! Opcodes B040 - B047
V040:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6058
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6058:
jmp @r4
mov r0,r2
! Opcodes B048 - B04F
V048:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6059
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6059:
jmp @r4
mov r0,r2
! Opcodes B050 - B057
V050:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6060
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6060:
jmp @r4
mov r0,r2
! Opcodes B058 - B05F
V058:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6061
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6061:
jmp @r4
mov r0,r2
! Opcodes B060 - B067
V060:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6062
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6062:
jmp @r4
mov r0,r2
! Opcodes B068 - B06F
V068:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6063
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6063:
jmp @r4
mov r0,r2
! Opcodes B070 - B077
V070:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6064
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6064:
jmp @r4
mov r0,r2
! Opcode B078
V078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6065
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6065:
jmp @r4
mov r0,r2
! Opcode B079
V079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6066
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6066:
jmp @r4
mov r0,r2
! Opcode B07A
V07A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6067
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6067:
jmp @r4
mov r0,r2
! Opcode B07B
V07B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6068
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6068:
jmp @r4
mov r0,r2
! Opcode B07C
V07C:
mov.w @r6+,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6069
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6069:
jmp @r4
mov r0,r2
! Opcodes B080 - B087
V080:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6070
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6070:
jmp @r4
mov r0,r2
! Opcodes B088 - B08F
V088:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6071
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6071:
jmp @r4
mov r0,r2
! Opcodes B090 - B097
V090:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6072
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6072:
jmp @r4
mov r0,r2
! Opcodes B098 - B09F
V098:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6073
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6073:
jmp @r4
mov r0,r2
! Opcodes B0A0 - B0A7
V0A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6074
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6074:
jmp @r4
mov r0,r2
! Opcodes B0A8 - B0AF
V0A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6075
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6075:
jmp @r4
mov r0,r2
! Opcodes B0B0 - B0B7
V0B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6076
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6076:
jmp @r4
mov r0,r2
! Opcode B0B8
V0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6077
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6077:
jmp @r4
mov r0,r2
! Opcode B0B9
V0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6078
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6078:
jmp @r4
mov r0,r2
! Opcode B0BA
V0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6079
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6079:
jmp @r4
mov r0,r2
! Opcode B0BB
V0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6080
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6080:
jmp @r4
mov r0,r2
! Opcode B0BC
V0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @r13,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6081
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6081:
jmp @r4
mov r0,r2
! Opcodes B0C0 - B0C7
V0C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6082
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6082:
jmp @r4
mov r0,r2
! Opcodes B0C8 - B0CF
V0C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6083
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6083:
jmp @r4
mov r0,r2
! Opcodes B0D0 - B0D7
V0D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6084
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6084:
jmp @r4
mov r0,r2
! Opcodes B0D8 - B0DF
V0D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6085
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6085:
jmp @r4
mov r0,r2
! Opcodes B0E0 - B0E7
V0E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6086
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6086:
jmp @r4
mov r0,r2
! Opcodes B0E8 - B0EF
V0E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6087
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6087:
jmp @r4
mov r0,r2
! Opcodes B0F0 - B0F7
V0F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6088
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6088:
jmp @r4
mov r0,r2
! Opcode B0F8
V0F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6089
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6089:
jmp @r4
mov r0,r2
! Opcode B0F9
V0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6090
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6090:
jmp @r4
mov r0,r2
! Opcode B0FA
V0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6091
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6091:
jmp @r4
mov r0,r2
! Opcode B0FB
V0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6092
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6092:
jmp @r4
mov r0,r2
! Opcode B0FC
V0FC:
mov.w @r6+,r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6093
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6093:
jmp @r4
mov r0,r2
! Opcodes B100 - B107
V100:
and r1,r2
mov r2,r0
mov.b @(r0,r13),r3
mov.b @r13,r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6094
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6094:
jmp @r4
mov r0,r2
! Opcodes B108 - B10F
V108:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(32,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6095
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6095:
jmp @r4
mov r0,r2
! Opcodes B110 - B117
V110:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6096
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6096:
jmp @r4
mov r0,r2
! Opcodes B118 - B11F
V118:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6097
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6097:
jmp @r4
mov r0,r2
! Opcodes B120 - B127
V120:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6098
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6098:
jmp @r4
mov r0,r2
! Opcodes B128 - B12F
V128:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6099
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6099:
jmp @r4
mov r0,r2
! Opcodes B130 - B137
V130:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6100
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6100:
jmp @r4
mov r0,r2
! Opcode B138
V138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6101
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6101:
jmp @r4
mov r0,r2
! Opcode B139
V139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6102
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6102:
jmp @r4
mov r0,r2
! Opcodes B140 - B147
V140:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov.w @r13,r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6103
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6103:
jmp @r4
mov r0,r2
! Opcodes B148 - B14F
V148:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(32,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6104
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6104:
jmp @r4
mov r0,r2
! Opcodes B150 - B157
V150:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6105
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6105:
jmp @r4
mov r0,r2
! Opcodes B158 - B15F
V158:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6106
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6106:
jmp @r4
mov r0,r2
! Opcodes B160 - B167
V160:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6107
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6107:
jmp @r4
mov r0,r2
! Opcodes B168 - B16F
V168:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6108
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6108:
jmp @r4
mov r0,r2
! Opcodes B170 - B177
V170:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6109
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6109:
jmp @r4
mov r0,r2
! Opcode B178
V178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6110
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6110:
jmp @r4
mov r0,r2
! Opcode B179
V179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6111
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6111:
jmp @r4
mov r0,r2
! Opcodes B180 - B187
V180:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @r13,r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6112
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6112:
jmp @r4
mov r0,r2
! Opcodes B188 - B18F
V188:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(32,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(32,r13)
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6113
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6113:
jmp @r4
mov r0,r2
! Opcodes B190 - B197
V190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6114
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6114:
jmp @r4
mov r0,r2
! Opcodes B198 - B19F
V198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6115
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6115:
jmp @r4
mov r0,r2
! Opcodes B1A0 - B1A7
V1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6116
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6116:
jmp @r4
mov r0,r2
! Opcodes B1A8 - B1AF
V1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6117
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6117:
jmp @r4
mov r0,r2
! Opcodes B1B0 - B1B7
V1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6118
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6118:
jmp @r4
mov r0,r2
! Opcode B1B8
V1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6119
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6119:
jmp @r4
mov r0,r2
! Opcode B1B9
V1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6120
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6120:
jmp @r4
mov r0,r2
! Opcodes B1C0 - B1C7
V1C0:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6121
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6121:
jmp @r4
mov r0,r2
! Opcodes B1C8 - B1CF
V1C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6122
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6122:
jmp @r4
mov r0,r2
! Opcodes B1D0 - B1D7
V1D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6123
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6123:
jmp @r4
mov r0,r2
! Opcodes B1D8 - B1DF
V1D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6124
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6124:
jmp @r4
mov r0,r2
! Opcodes B1E0 - B1E7
V1E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6125
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6125:
jmp @r4
mov r0,r2
! Opcodes B1E8 - B1EF
V1E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6126
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6126:
jmp @r4
mov r0,r2
! Opcodes B1F0 - B1F7
V1F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6127
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6127:
jmp @r4
mov r0,r2
! Opcode B1F8
V1F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6128
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6128:
jmp @r4
mov r0,r2
! Opcode B1F9
V1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6129
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6129:
jmp @r4
mov r0,r2
! Opcode B1FA
V1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6130
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6130:
jmp @r4
mov r0,r2
! Opcode B1FB
V1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6131
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6131:
jmp @r4
mov r0,r2
! Opcode B1FC
V1FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6132
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6132:
jmp @r4
mov r0,r2
! Opcodes B200 - B207
V200:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6133
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6133:
jmp @r4
mov r0,r2
! Opcodes B208 - B20F
V208:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6134
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6134:
jmp @r4
mov r0,r2
! Opcodes B210 - B217
V210:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6135
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6135:
jmp @r4
mov r0,r2
! Opcodes B218 - B21F
V218:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6136
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6136:
jmp @r4
mov r0,r2
! Opcodes B220 - B227
V220:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6137
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6137:
jmp @r4
mov r0,r2
! Opcodes B228 - B22F
V228:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6138
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6138:
jmp @r4
mov r0,r2
! Opcodes B230 - B237
V230:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6139
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6139:
jmp @r4
mov r0,r2
! Opcode B238
V238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6140
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6140:
jmp @r4
mov r0,r2
! Opcode B239
V239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6141
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6141:
jmp @r4
mov r0,r2
! Opcode B23A
V23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6142
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6142:
jmp @r4
mov r0,r2
! Opcode B23B
V23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6143
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6143:
jmp @r4
mov r0,r2
! Opcode B23C
V23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6144
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6144:
jmp @r4
mov r0,r2
! Opcodes B240 - B247
V240:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6145
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6145:
jmp @r4
mov r0,r2
! Opcodes B248 - B24F
V248:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6146
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6146:
jmp @r4
mov r0,r2
! Opcodes B250 - B257
V250:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6147
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6147:
jmp @r4
mov r0,r2
! Opcodes B258 - B25F
V258:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6148
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6148:
jmp @r4
mov r0,r2
! Opcodes B260 - B267
V260:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6149
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6149:
jmp @r4
mov r0,r2
! Opcodes B268 - B26F
V268:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6150
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6150:
jmp @r4
mov r0,r2
! Opcodes B270 - B277
V270:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6151
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6151:
jmp @r4
mov r0,r2
! Opcode B278
V278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6152
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6152:
jmp @r4
mov r0,r2
! Opcode B279
V279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6153
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6153:
jmp @r4
mov r0,r2
! Opcode B27A
V27A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6154
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6154:
jmp @r4
mov r0,r2
! Opcode B27B
V27B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6155
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6155:
jmp @r4
mov r0,r2
! Opcode B27C
V27C:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6156
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6156:
jmp @r4
mov r0,r2
! Opcodes B280 - B287
V280:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6157
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6157:
jmp @r4
mov r0,r2
! Opcodes B288 - B28F
V288:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6158
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6158:
jmp @r4
mov r0,r2
! Opcodes B290 - B297
V290:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6159
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6159:
jmp @r4
mov r0,r2
! Opcodes B298 - B29F
V298:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6160
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6160:
jmp @r4
mov r0,r2
! Opcodes B2A0 - B2A7
V2A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6161
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6161:
jmp @r4
mov r0,r2
! Opcodes B2A8 - B2AF
V2A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6162
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6162:
jmp @r4
mov r0,r2
! Opcodes B2B0 - B2B7
V2B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6163
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6163:
jmp @r4
mov r0,r2
! Opcode B2B8
V2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6164
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6164:
jmp @r4
mov r0,r2
! Opcode B2B9
V2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6165
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6165:
jmp @r4
mov r0,r2
! Opcode B2BA
V2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6166
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6166:
jmp @r4
mov r0,r2
! Opcode B2BB
V2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6167
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6167:
jmp @r4
mov r0,r2
! Opcode B2BC
V2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(4,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6168
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6168:
jmp @r4
mov r0,r2
! Opcodes B2C0 - B2C7
V2C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6169
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6169:
jmp @r4
mov r0,r2
! Opcodes B2C8 - B2CF
V2C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6170
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6170:
jmp @r4
mov r0,r2
! Opcodes B2D0 - B2D7
V2D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6171
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6171:
jmp @r4
mov r0,r2
! Opcodes B2D8 - B2DF
V2D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6172
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6172:
jmp @r4
mov r0,r2
! Opcodes B2E0 - B2E7
V2E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6173
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6173:
jmp @r4
mov r0,r2
! Opcodes B2E8 - B2EF
V2E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6174
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6174:
jmp @r4
mov r0,r2
! Opcodes B2F0 - B2F7
V2F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6175
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6175:
jmp @r4
mov r0,r2
! Opcode B2F8
V2F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6176
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6176:
jmp @r4
mov r0,r2
! Opcode B2F9
V2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6177
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6177:
jmp @r4
mov r0,r2
! Opcode B2FA
V2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6178
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6178:
jmp @r4
mov r0,r2
! Opcode B2FB
V2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6179
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6179:
jmp @r4
mov r0,r2
! Opcode B2FC
V2FC:
mov.w @r6+,r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6180
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6180:
jmp @r4
mov r0,r2
! Opcodes B300 - B307
V300:
and r1,r2
mov r2,r0
mov.b @(r0,r13),r3
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6181
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6181:
jmp @r4
mov r0,r2
! Opcodes B308 - B30F
V308:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(36,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6182
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6182:
jmp @r4
mov r0,r2
! Opcodes B310 - B317
V310:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6183
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6183:
jmp @r4
mov r0,r2
! Opcodes B318 - B31F
V318:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6184
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6184:
jmp @r4
mov r0,r2
! Opcodes B320 - B327
V320:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6185
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6185:
jmp @r4
mov r0,r2
! Opcodes B328 - B32F
V328:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6186
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6186:
jmp @r4
mov r0,r2
! Opcodes B330 - B337
V330:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6187
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6187:
jmp @r4
mov r0,r2
! Opcode B338
V338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6188
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6188:
jmp @r4
mov r0,r2
! Opcode B339
V339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6189
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6189:
jmp @r4
mov r0,r2
! Opcodes B340 - B347
V340:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6190
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6190:
jmp @r4
mov r0,r2
! Opcodes B348 - B34F
V348:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(36,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6191
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6191:
jmp @r4
mov r0,r2
! Opcodes B350 - B357
V350:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6192
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6192:
jmp @r4
mov r0,r2
! Opcodes B358 - B35F
V358:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6193
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6193:
jmp @r4
mov r0,r2
! Opcodes B360 - B367
V360:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6194
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6194:
jmp @r4
mov r0,r2
! Opcodes B368 - B36F
V368:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6195
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6195:
jmp @r4
mov r0,r2
! Opcodes B370 - B377
V370:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6196
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6196:
jmp @r4
mov r0,r2
! Opcode B378
V378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6197
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6197:
jmp @r4
mov r0,r2
! Opcode B379
V379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6198
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6198:
jmp @r4
mov r0,r2
! Opcodes B380 - B387
V380:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(4,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6199
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6199:
jmp @r4
mov r0,r2
! Opcodes B388 - B38F
V388:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(36,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(36,r13)
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6200
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6200:
jmp @r4
mov r0,r2
! Opcodes B390 - B397
V390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6201
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6201:
jmp @r4
mov r0,r2
! Opcodes B398 - B39F
V398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6202
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6202:
jmp @r4
mov r0,r2
! Opcodes B3A0 - B3A7
V3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6203
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6203:
jmp @r4
mov r0,r2
! Opcodes B3A8 - B3AF
V3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6204
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6204:
jmp @r4
mov r0,r2
! Opcodes B3B0 - B3B7
V3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6205
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6205:
jmp @r4
mov r0,r2
! Opcode B3B8
V3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6206
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6206:
jmp @r4
mov r0,r2
! Opcode B3B9
V3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6207
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6207:
jmp @r4
mov r0,r2
! Opcodes B3C0 - B3C7
V3C0:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6208
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6208:
jmp @r4
mov r0,r2
! Opcodes B3C8 - B3CF
V3C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6209
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6209:
jmp @r4
mov r0,r2
! Opcodes B3D0 - B3D7
V3D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6210
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6210:
jmp @r4
mov r0,r2
! Opcodes B3D8 - B3DF
V3D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6211
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6211:
jmp @r4
mov r0,r2
! Opcodes B3E0 - B3E7
V3E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6212
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6212:
jmp @r4
mov r0,r2
! Opcodes B3E8 - B3EF
V3E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6213
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6213:
jmp @r4
mov r0,r2
! Opcodes B3F0 - B3F7
V3F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6214
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6214:
jmp @r4
mov r0,r2
! Opcode B3F8
V3F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6215
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6215:
jmp @r4
mov r0,r2
! Opcode B3F9
V3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6216
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6216:
jmp @r4
mov r0,r2
! Opcode B3FA
V3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6217
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6217:
jmp @r4
mov r0,r2
! Opcode B3FB
V3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6218
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6218:
jmp @r4
mov r0,r2
! Opcode B3FC
V3FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6219
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6219:
jmp @r4
mov r0,r2
! Opcodes B400 - B407
V400:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6220
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6220:
jmp @r4
mov r0,r2
! Opcodes B408 - B40F
V408:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6221
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6221:
jmp @r4
mov r0,r2
! Opcodes B410 - B417
V410:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6222
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6222:
jmp @r4
mov r0,r2
! Opcodes B418 - B41F
V418:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6223
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6223:
jmp @r4
mov r0,r2
! Opcodes B420 - B427
V420:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6224
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6224:
jmp @r4
mov r0,r2
! Opcodes B428 - B42F
V428:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6225
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6225:
jmp @r4
mov r0,r2
! Opcodes B430 - B437
V430:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6226
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6226:
jmp @r4
mov r0,r2
! Opcode B438
V438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6227
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6227:
jmp @r4
mov r0,r2
! Opcode B439
V439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6228
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6228:
jmp @r4
mov r0,r2
! Opcode B43A
V43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6229
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6229:
jmp @r4
mov r0,r2
! Opcode B43B
V43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6230
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6230:
jmp @r4
mov r0,r2
! Opcode B43C
V43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6231
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6231:
jmp @r4
mov r0,r2
! Opcodes B440 - B447
V440:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6232
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6232:
jmp @r4
mov r0,r2
! Opcodes B448 - B44F
V448:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6233
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6233:
jmp @r4
mov r0,r2
! Opcodes B450 - B457
V450:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6234
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6234:
jmp @r4
mov r0,r2
! Opcodes B458 - B45F
V458:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6235
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6235:
jmp @r4
mov r0,r2
! Opcodes B460 - B467
V460:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6236
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6236:
jmp @r4
mov r0,r2
! Opcodes B468 - B46F
V468:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6237
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6237:
jmp @r4
mov r0,r2
! Opcodes B470 - B477
V470:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6238
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6238:
jmp @r4
mov r0,r2
! Opcode B478
V478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6239
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6239:
jmp @r4
mov r0,r2
! Opcode B479
V479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6240
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6240:
jmp @r4
mov r0,r2
! Opcode B47A
V47A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6241
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6241:
jmp @r4
mov r0,r2
! Opcode B47B
V47B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6242
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6242:
jmp @r4
mov r0,r2
! Opcode B47C
V47C:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6243
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6243:
jmp @r4
mov r0,r2
! Opcodes B480 - B487
V480:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6244
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6244:
jmp @r4
mov r0,r2
! Opcodes B488 - B48F
V488:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6245
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6245:
jmp @r4
mov r0,r2
! Opcodes B490 - B497
V490:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6246
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6246:
jmp @r4
mov r0,r2
! Opcodes B498 - B49F
V498:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6247
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6247:
jmp @r4
mov r0,r2
! Opcodes B4A0 - B4A7
V4A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6248
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6248:
jmp @r4
mov r0,r2
! Opcodes B4A8 - B4AF
V4A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6249
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6249:
jmp @r4
mov r0,r2
! Opcodes B4B0 - B4B7
V4B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6250
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6250:
jmp @r4
mov r0,r2
! Opcode B4B8
V4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6251
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6251:
jmp @r4
mov r0,r2
! Opcode B4B9
V4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6252
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6252:
jmp @r4
mov r0,r2
! Opcode B4BA
V4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6253
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6253:
jmp @r4
mov r0,r2
! Opcode B4BB
V4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6254
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6254:
jmp @r4
mov r0,r2
! Opcode B4BC
V4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(8,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6255
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6255:
jmp @r4
mov r0,r2
! Opcodes B4C0 - B4C7
V4C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6256
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6256:
jmp @r4
mov r0,r2
! Opcodes B4C8 - B4CF
V4C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6257
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6257:
jmp @r4
mov r0,r2
! Opcodes B4D0 - B4D7
V4D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6258
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6258:
jmp @r4
mov r0,r2
! Opcodes B4D8 - B4DF
V4D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6259
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6259:
jmp @r4
mov r0,r2
! Opcodes B4E0 - B4E7
V4E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6260
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6260:
jmp @r4
mov r0,r2
! Opcodes B4E8 - B4EF
V4E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6261
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6261:
jmp @r4
mov r0,r2
! Opcodes B4F0 - B4F7
V4F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6262
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6262:
jmp @r4
mov r0,r2
! Opcode B4F8
V4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6263
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6263:
jmp @r4
mov r0,r2
! Opcode B4F9
V4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6264
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6264:
jmp @r4
mov r0,r2
! Opcode B4FA
V4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6265
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6265:
jmp @r4
mov r0,r2
! Opcode B4FB
V4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6266
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6266:
jmp @r4
mov r0,r2
! Opcode B4FC
V4FC:
mov.w @r6+,r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6267
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6267:
jmp @r4
mov r0,r2
! Opcodes B500 - B507
V500:
and r1,r2
mov r2,r0
mov.b @(r0,r13),r3
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6268
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6268:
jmp @r4
mov r0,r2
! Opcodes B508 - B50F
V508:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(40,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6269
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6269:
jmp @r4
mov r0,r2
! Opcodes B510 - B517
V510:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6270
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6270:
jmp @r4
mov r0,r2
! Opcodes B518 - B51F
V518:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6271
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6271:
jmp @r4
mov r0,r2
! Opcodes B520 - B527
V520:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6272
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6272:
jmp @r4
mov r0,r2
! Opcodes B528 - B52F
V528:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6273
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6273:
jmp @r4
mov r0,r2
! Opcodes B530 - B537
V530:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6274
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6274:
jmp @r4
mov r0,r2
! Opcode B538
V538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6275
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6275:
jmp @r4
mov r0,r2
! Opcode B539
V539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6276
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6276:
jmp @r4
mov r0,r2
! Opcodes B540 - B547
V540:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6277
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6277:
jmp @r4
mov r0,r2
! Opcodes B548 - B54F
V548:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(40,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6278
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6278:
jmp @r4
mov r0,r2
! Opcodes B550 - B557
V550:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6279
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6279:
jmp @r4
mov r0,r2
! Opcodes B558 - B55F
V558:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6280
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6280:
jmp @r4
mov r0,r2
! Opcodes B560 - B567
V560:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6281
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6281:
jmp @r4
mov r0,r2
! Opcodes B568 - B56F
V568:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6282
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6282:
jmp @r4
mov r0,r2
! Opcodes B570 - B577
V570:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6283
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6283:
jmp @r4
mov r0,r2
! Opcode B578
V578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6284
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6284:
jmp @r4
mov r0,r2
! Opcode B579
V579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6285
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6285:
jmp @r4
mov r0,r2
! Opcodes B580 - B587
V580:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(8,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6286
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6286:
jmp @r4
mov r0,r2
! Opcodes B588 - B58F
V588:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(40,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(40,r13)
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6287
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6287:
jmp @r4
mov r0,r2
! Opcodes B590 - B597
V590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6288
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6288:
jmp @r4
mov r0,r2
! Opcodes B598 - B59F
V598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6289
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6289:
jmp @r4
mov r0,r2
! Opcodes B5A0 - B5A7
V5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6290
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6290:
jmp @r4
mov r0,r2
! Opcodes B5A8 - B5AF
V5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6291
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6291:
jmp @r4
mov r0,r2
! Opcodes B5B0 - B5B7
V5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6292
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6292:
jmp @r4
mov r0,r2
! Opcode B5B8
V5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6293
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6293:
jmp @r4
mov r0,r2
! Opcode B5B9
V5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6294
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6294:
jmp @r4
mov r0,r2
! Opcodes B5C0 - B5C7
V5C0:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6295
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6295:
jmp @r4
mov r0,r2
! Opcodes B5C8 - B5CF
V5C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6296
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6296:
jmp @r4
mov r0,r2
! Opcodes B5D0 - B5D7
V5D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6297
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6297:
jmp @r4
mov r0,r2
! Opcodes B5D8 - B5DF
V5D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6298
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6298:
jmp @r4
mov r0,r2
! Opcodes B5E0 - B5E7
V5E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6299
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6299:
jmp @r4
mov r0,r2
! Opcodes B5E8 - B5EF
V5E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6300
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6300:
jmp @r4
mov r0,r2
! Opcodes B5F0 - B5F7
V5F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6301
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6301:
jmp @r4
mov r0,r2
! Opcode B5F8
V5F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6302
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6302:
jmp @r4
mov r0,r2
! Opcode B5F9
V5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6303
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6303:
jmp @r4
mov r0,r2
! Opcode B5FA
V5FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6304
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6304:
jmp @r4
mov r0,r2
! Opcode B5FB
V5FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6305
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6305:
jmp @r4
mov r0,r2
! Opcode B5FC
V5FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6306
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6306:
jmp @r4
mov r0,r2
! Opcodes B600 - B607
V600:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6307
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6307:
jmp @r4
mov r0,r2
! Opcodes B608 - B60F
V608:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6308
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6308:
jmp @r4
mov r0,r2
! Opcodes B610 - B617
V610:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6309
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6309:
jmp @r4
mov r0,r2
! Opcodes B618 - B61F
V618:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6310
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6310:
jmp @r4
mov r0,r2
! Opcodes B620 - B627
V620:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6311
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6311:
jmp @r4
mov r0,r2
! Opcodes B628 - B62F
V628:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6312
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6312:
jmp @r4
mov r0,r2
! Opcodes B630 - B637
V630:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6313
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6313:
jmp @r4
mov r0,r2
! Opcode B638
V638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6314
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6314:
jmp @r4
mov r0,r2
! Opcode B639
V639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6315
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6315:
jmp @r4
mov r0,r2
! Opcode B63A
V63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6316
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6316:
jmp @r4
mov r0,r2
! Opcode B63B
V63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6317
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6317:
jmp @r4
mov r0,r2
! Opcode B63C
V63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6318
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6318:
jmp @r4
mov r0,r2
! Opcodes B640 - B647
V640:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6319
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6319:
jmp @r4
mov r0,r2
! Opcodes B648 - B64F
V648:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6320
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6320:
jmp @r4
mov r0,r2
! Opcodes B650 - B657
V650:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6321
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6321:
jmp @r4
mov r0,r2
! Opcodes B658 - B65F
V658:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6322
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6322:
jmp @r4
mov r0,r2
! Opcodes B660 - B667
V660:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6323
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6323:
jmp @r4
mov r0,r2
! Opcodes B668 - B66F
V668:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6324
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6324:
jmp @r4
mov r0,r2
! Opcodes B670 - B677
V670:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6325
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6325:
jmp @r4
mov r0,r2
! Opcode B678
V678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6326
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6326:
jmp @r4
mov r0,r2
! Opcode B679
V679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6327
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6327:
jmp @r4
mov r0,r2
! Opcode B67A
V67A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6328
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6328:
jmp @r4
mov r0,r2
! Opcode B67B
V67B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6329
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6329:
jmp @r4
mov r0,r2
! Opcode B67C
V67C:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6330
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6330:
jmp @r4
mov r0,r2
! Opcodes B680 - B687
V680:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6331
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6331:
jmp @r4
mov r0,r2
! Opcodes B688 - B68F
V688:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6332
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6332:
jmp @r4
mov r0,r2
! Opcodes B690 - B697
V690:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6333
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6333:
jmp @r4
mov r0,r2
! Opcodes B698 - B69F
V698:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6334
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6334:
jmp @r4
mov r0,r2
! Opcodes B6A0 - B6A7
V6A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6335
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6335:
jmp @r4
mov r0,r2
! Opcodes B6A8 - B6AF
V6A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6336
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6336:
jmp @r4
mov r0,r2
! Opcodes B6B0 - B6B7
V6B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6337
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6337:
jmp @r4
mov r0,r2
! Opcode B6B8
V6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6338
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6338:
jmp @r4
mov r0,r2
! Opcode B6B9
V6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6339
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6339:
jmp @r4
mov r0,r2
! Opcode B6BA
V6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6340
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6340:
jmp @r4
mov r0,r2
! Opcode B6BB
V6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6341
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6341:
jmp @r4
mov r0,r2
! Opcode B6BC
V6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(12,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6342
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6342:
jmp @r4
mov r0,r2
! Opcodes B6C0 - B6C7
V6C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6343
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6343:
jmp @r4
mov r0,r2
! Opcodes B6C8 - B6CF
V6C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6344
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6344:
jmp @r4
mov r0,r2
! Opcodes B6D0 - B6D7
V6D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6345
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6345:
jmp @r4
mov r0,r2
! Opcodes B6D8 - B6DF
V6D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6346
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6346:
jmp @r4
mov r0,r2
! Opcodes B6E0 - B6E7
V6E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6347
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6347:
jmp @r4
mov r0,r2
! Opcodes B6E8 - B6EF
V6E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6348
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6348:
jmp @r4
mov r0,r2
! Opcodes B6F0 - B6F7
V6F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6349
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6349:
jmp @r4
mov r0,r2
! Opcode B6F8
V6F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6350
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6350:
jmp @r4
mov r0,r2
! Opcode B6F9
V6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6351
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6351:
jmp @r4
mov r0,r2
! Opcode B6FA
V6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6352
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6352:
jmp @r4
mov r0,r2
! Opcode B6FB
V6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6353
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6353:
jmp @r4
mov r0,r2
! Opcode B6FC
V6FC:
mov.w @r6+,r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6354
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6354:
jmp @r4
mov r0,r2
! Opcodes B700 - B707
V700:
and r1,r2
mov r2,r0
mov.b @(r0,r13),r3
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6355
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6355:
jmp @r4
mov r0,r2
! Opcodes B708 - B70F
V708:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(44,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6356
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6356:
jmp @r4
mov r0,r2
! Opcodes B710 - B717
V710:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6357
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6357:
jmp @r4
mov r0,r2
! Opcodes B718 - B71F
V718:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6358
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6358:
jmp @r4
mov r0,r2
! Opcodes B720 - B727
V720:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6359
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6359:
jmp @r4
mov r0,r2
! Opcodes B728 - B72F
V728:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6360
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6360:
jmp @r4
mov r0,r2
! Opcodes B730 - B737
V730:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6361
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6361:
jmp @r4
mov r0,r2
! Opcode B738
V738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6362
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6362:
jmp @r4
mov r0,r2
! Opcode B739
V739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6363
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6363:
jmp @r4
mov r0,r2
! Opcodes B740 - B747
V740:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6364
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6364:
jmp @r4
mov r0,r2
! Opcodes B748 - B74F
V748:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(44,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6365
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6365:
jmp @r4
mov r0,r2
! Opcodes B750 - B757
V750:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6366
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6366:
jmp @r4
mov r0,r2
! Opcodes B758 - B75F
V758:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6367
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6367:
jmp @r4
mov r0,r2
! Opcodes B760 - B767
V760:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6368
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6368:
jmp @r4
mov r0,r2
! Opcodes B768 - B76F
V768:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6369
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6369:
jmp @r4
mov r0,r2
! Opcodes B770 - B777
V770:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6370
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6370:
jmp @r4
mov r0,r2
! Opcode B778
V778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6371
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6371:
jmp @r4
mov r0,r2
! Opcode B779
V779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6372
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6372:
jmp @r4
mov r0,r2
! Opcodes B780 - B787
V780:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(12,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6373
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6373:
jmp @r4
mov r0,r2
! Opcodes B788 - B78F
V788:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(44,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(44,r13)
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6374
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6374:
jmp @r4
mov r0,r2
! Opcodes B790 - B797
V790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6375
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6375:
jmp @r4
mov r0,r2
! Opcodes B798 - B79F
V798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6376
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6376:
jmp @r4
mov r0,r2
! Opcodes B7A0 - B7A7
V7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6377
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6377:
jmp @r4
mov r0,r2
! Opcodes B7A8 - B7AF
V7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6378
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6378:
jmp @r4
mov r0,r2
! Opcodes B7B0 - B7B7
V7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6379
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6379:
jmp @r4
mov r0,r2
! Opcode B7B8
V7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6380
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6380:
jmp @r4
mov r0,r2
! Opcode B7B9
V7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6381
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6381:
jmp @r4
mov r0,r2
! Opcodes B7C0 - B7C7
V7C0:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6382
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6382:
jmp @r4
mov r0,r2
! Opcodes B7C8 - B7CF
V7C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6383
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6383:
jmp @r4
mov r0,r2
! Opcodes B7D0 - B7D7
V7D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6384
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6384:
jmp @r4
mov r0,r2
! Opcodes B7D8 - B7DF
V7D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6385
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6385:
jmp @r4
mov r0,r2
! Opcodes B7E0 - B7E7
V7E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6386
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6386:
jmp @r4
mov r0,r2
! Opcodes B7E8 - B7EF
V7E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6387
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6387:
jmp @r4
mov r0,r2
! Opcodes B7F0 - B7F7
V7F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6388
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6388:
jmp @r4
mov r0,r2
! Opcode B7F8
V7F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6389
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6389:
jmp @r4
mov r0,r2
! Opcode B7F9
V7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6390
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6390:
jmp @r4
mov r0,r2
! Opcode B7FA
V7FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6391
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6391:
jmp @r4
mov r0,r2
! Opcode B7FB
V7FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6392
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6392:
jmp @r4
mov r0,r2
! Opcode B7FC
V7FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6393
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6393:
jmp @r4
mov r0,r2
! Opcodes B800 - B807
V800:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6394
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6394:
jmp @r4
mov r0,r2
! Opcodes B808 - B80F
V808:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6395
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6395:
jmp @r4
mov r0,r2
! Opcodes B810 - B817
V810:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6396
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6396:
jmp @r4
mov r0,r2
! Opcodes B818 - B81F
V818:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6397
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6397:
jmp @r4
mov r0,r2
! Opcodes B820 - B827
V820:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6398
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6398:
jmp @r4
mov r0,r2
! Opcodes B828 - B82F
V828:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6399
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6399:
jmp @r4
mov r0,r2
! Opcodes B830 - B837
V830:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6400
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6400:
jmp @r4
mov r0,r2
! Opcode B838
V838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6401
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6401:
jmp @r4
mov r0,r2
! Opcode B839
V839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6402
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6402:
jmp @r4
mov r0,r2
! Opcode B83A
V83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6403
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6403:
jmp @r4
mov r0,r2
! Opcode B83B
V83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6404
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6404:
jmp @r4
mov r0,r2
! Opcode B83C
V83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6405
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6405:
jmp @r4
mov r0,r2
! Opcodes B840 - B847
V840:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6406
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6406:
jmp @r4
mov r0,r2
! Opcodes B848 - B84F
V848:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6407
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6407:
jmp @r4
mov r0,r2
! Opcodes B850 - B857
V850:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6408
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6408:
jmp @r4
mov r0,r2
! Opcodes B858 - B85F
V858:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6409
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6409:
jmp @r4
mov r0,r2
! Opcodes B860 - B867
V860:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6410
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6410:
jmp @r4
mov r0,r2
! Opcodes B868 - B86F
V868:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6411
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6411:
jmp @r4
mov r0,r2
! Opcodes B870 - B877
V870:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6412
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6412:
jmp @r4
mov r0,r2
! Opcode B878
V878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6413
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6413:
jmp @r4
mov r0,r2
! Opcode B879
V879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6414
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6414:
jmp @r4
mov r0,r2
! Opcode B87A
V87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6415
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6415:
jmp @r4
mov r0,r2
! Opcode B87B
V87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6416
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6416:
jmp @r4
mov r0,r2
! Opcode B87C
V87C:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6417
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6417:
jmp @r4
mov r0,r2
! Opcodes B880 - B887
V880:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6418
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6418:
jmp @r4
mov r0,r2
! Opcodes B888 - B88F
V888:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6419
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6419:
jmp @r4
mov r0,r2
! Opcodes B890 - B897
V890:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6420
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6420:
jmp @r4
mov r0,r2
! Opcodes B898 - B89F
V898:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6421
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6421:
jmp @r4
mov r0,r2
! Opcodes B8A0 - B8A7
V8A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6422
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6422:
jmp @r4
mov r0,r2
! Opcodes B8A8 - B8AF
V8A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6423
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6423:
jmp @r4
mov r0,r2
! Opcodes B8B0 - B8B7
V8B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6424
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6424:
jmp @r4
mov r0,r2
! Opcode B8B8
V8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6425
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6425:
jmp @r4
mov r0,r2
! Opcode B8B9
V8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6426
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6426:
jmp @r4
mov r0,r2
! Opcode B8BA
V8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6427
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6427:
jmp @r4
mov r0,r2
! Opcode B8BB
V8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6428
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6428:
jmp @r4
mov r0,r2
! Opcode B8BC
V8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(16,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6429
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6429:
jmp @r4
mov r0,r2
! Opcodes B8C0 - B8C7
V8C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6430
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6430:
jmp @r4
mov r0,r2
! Opcodes B8C8 - B8CF
V8C8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6431
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6431:
jmp @r4
mov r0,r2
! Opcodes B8D0 - B8D7
V8D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6432
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6432:
jmp @r4
mov r0,r2
! Opcodes B8D8 - B8DF
V8D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6433
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6433:
jmp @r4
mov r0,r2
! Opcodes B8E0 - B8E7
V8E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6434
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6434:
jmp @r4
mov r0,r2
! Opcodes B8E8 - B8EF
V8E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6435
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6435:
jmp @r4
mov r0,r2
! Opcodes B8F0 - B8F7
V8F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6436
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6436:
jmp @r4
mov r0,r2
! Opcode B8F8
V8F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6437
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6437:
jmp @r4
mov r0,r2
! Opcode B8F9
V8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6438
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6438:
jmp @r4
mov r0,r2
! Opcode B8FA
V8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6439
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6439:
jmp @r4
mov r0,r2
! Opcode B8FB
V8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6440
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6440:
jmp @r4
mov r0,r2
! Opcode B8FC
V8FC:
mov.w @r6+,r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6441
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6441:
jmp @r4
mov r0,r2
! Opcodes B900 - B907
V900:
and r1,r2
mov r2,r0
mov.b @(r0,r13),r3
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6442
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6442:
jmp @r4
mov r0,r2
! Opcodes B908 - B90F
V908:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(48,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6443
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6443:
jmp @r4
mov r0,r2
! Opcodes B910 - B917
V910:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6444
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6444:
jmp @r4
mov r0,r2
! Opcodes B918 - B91F
V918:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6445
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6445:
jmp @r4
mov r0,r2
! Opcodes B920 - B927
V920:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6446
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6446:
jmp @r4
mov r0,r2
! Opcodes B928 - B92F
V928:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6447
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6447:
jmp @r4
mov r0,r2
! Opcodes B930 - B937
V930:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6448
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6448:
jmp @r4
mov r0,r2
! Opcode B938
V938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6449
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6449:
jmp @r4
mov r0,r2
! Opcode B939
V939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6450
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6450:
jmp @r4
mov r0,r2
! Opcodes B940 - B947
V940:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6451
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6451:
jmp @r4
mov r0,r2
! Opcodes B948 - B94F
V948:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(48,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6452
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6452:
jmp @r4
mov r0,r2
! Opcodes B950 - B957
V950:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6453
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6453:
jmp @r4
mov r0,r2
! Opcodes B958 - B95F
V958:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6454
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6454:
jmp @r4
mov r0,r2
! Opcodes B960 - B967
V960:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6455
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6455:
jmp @r4
mov r0,r2
! Opcodes B968 - B96F
V968:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6456
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6456:
jmp @r4
mov r0,r2
! Opcodes B970 - B977
V970:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6457
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6457:
jmp @r4
mov r0,r2
! Opcode B978
V978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6458
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6458:
jmp @r4
mov r0,r2
! Opcode B979
V979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6459
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6459:
jmp @r4
mov r0,r2
! Opcodes B980 - B987
V980:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(16,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6460
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6460:
jmp @r4
mov r0,r2
! Opcodes B988 - B98F
V988:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(48,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(48,r13)
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6461
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6461:
jmp @r4
mov r0,r2
! Opcodes B990 - B997
V990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6462
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6462:
jmp @r4
mov r0,r2
! Opcodes B998 - B99F
V998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6463
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6463:
jmp @r4
mov r0,r2
! Opcodes B9A0 - B9A7
V9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6464
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6464:
jmp @r4
mov r0,r2
! Opcodes B9A8 - B9AF
V9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6465
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6465:
jmp @r4
mov r0,r2
! Opcodes B9B0 - B9B7
V9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6466
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6466:
jmp @r4
mov r0,r2
! Opcode B9B8
V9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6467
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6467:
jmp @r4
mov r0,r2
! Opcode B9B9
V9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6468
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6468:
jmp @r4
mov r0,r2
! Opcodes B9C0 - B9C7
V9C0:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6469
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6469:
jmp @r4
mov r0,r2
! Opcodes B9C8 - B9CF
V9C8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6470
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6470:
jmp @r4
mov r0,r2
! Opcodes B9D0 - B9D7
V9D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6471
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6471:
jmp @r4
mov r0,r2
! Opcodes B9D8 - B9DF
V9D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6472
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6472:
jmp @r4
mov r0,r2
! Opcodes B9E0 - B9E7
V9E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6473
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6473:
jmp @r4
mov r0,r2
! Opcodes B9E8 - B9EF
V9E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6474
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6474:
jmp @r4
mov r0,r2
! Opcodes B9F0 - B9F7
V9F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6475
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6475:
jmp @r4
mov r0,r2
! Opcode B9F8
V9F8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6476
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6476:
jmp @r4
mov r0,r2
! Opcode B9F9
V9F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6477
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6477:
jmp @r4
mov r0,r2
! Opcode B9FA
V9FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6478
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6478:
jmp @r4
mov r0,r2
! Opcode B9FB
V9FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6479
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6479:
jmp @r4
mov r0,r2
! Opcode B9FC
V9FC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6480
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6480:
jmp @r4
mov r0,r2
! Opcodes BA00 - BA07
VA00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6481
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6481:
jmp @r4
mov r0,r2
! Opcodes BA08 - BA0F
VA08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6482
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6482:
jmp @r4
mov r0,r2
! Opcodes BA10 - BA17
VA10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6483
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6483:
jmp @r4
mov r0,r2
! Opcodes BA18 - BA1F
VA18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6484
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6484:
jmp @r4
mov r0,r2
! Opcodes BA20 - BA27
VA20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6485
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6485:
jmp @r4
mov r0,r2
! Opcodes BA28 - BA2F
VA28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6486
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6486:
jmp @r4
mov r0,r2
! Opcodes BA30 - BA37
VA30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6487
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6487:
jmp @r4
mov r0,r2
! Opcode BA38
VA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6488
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6488:
jmp @r4
mov r0,r2
! Opcode BA39
VA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6489
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6489:
jmp @r4
mov r0,r2
! Opcode BA3A
VA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6490
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6490:
jmp @r4
mov r0,r2
! Opcode BA3B
VA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6491
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6491:
jmp @r4
mov r0,r2
! Opcode BA3C
VA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6492
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6492:
jmp @r4
mov r0,r2
! Opcodes BA40 - BA47
VA40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6493
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6493:
jmp @r4
mov r0,r2
! Opcodes BA48 - BA4F
VA48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6494
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6494:
jmp @r4
mov r0,r2
! Opcodes BA50 - BA57
VA50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6495
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6495:
jmp @r4
mov r0,r2
! Opcodes BA58 - BA5F
VA58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6496
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6496:
jmp @r4
mov r0,r2
! Opcodes BA60 - BA67
VA60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6497
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6497:
jmp @r4
mov r0,r2
! Opcodes BA68 - BA6F
VA68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6498
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6498:
jmp @r4
mov r0,r2
! Opcodes BA70 - BA77
VA70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6499
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6499:
jmp @r4
mov r0,r2
! Opcode BA78
VA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6500
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6500:
jmp @r4
mov r0,r2
! Opcode BA79
VA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6501
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6501:
jmp @r4
mov r0,r2
! Opcode BA7A
VA7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6502
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6502:
jmp @r4
mov r0,r2
! Opcode BA7B
VA7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6503
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6503:
jmp @r4
mov r0,r2
! Opcode BA7C
VA7C:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6504
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6504:
jmp @r4
mov r0,r2
! Opcodes BA80 - BA87
VA80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6505
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6505:
jmp @r4
mov r0,r2
! Opcodes BA88 - BA8F
VA88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6506
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6506:
jmp @r4
mov r0,r2
! Opcodes BA90 - BA97
VA90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6507
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6507:
jmp @r4
mov r0,r2
! Opcodes BA98 - BA9F
VA98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6508
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6508:
jmp @r4
mov r0,r2
! Opcodes BAA0 - BAA7
VAA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6509
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6509:
jmp @r4
mov r0,r2
! Opcodes BAA8 - BAAF
VAA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6510
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6510:
jmp @r4
mov r0,r2
! Opcodes BAB0 - BAB7
VAB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6511
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6511:
jmp @r4
mov r0,r2
! Opcode BAB8
VAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6512
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6512:
jmp @r4
mov r0,r2
! Opcode BAB9
VAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6513
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6513:
jmp @r4
mov r0,r2
! Opcode BABA
VABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6514
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6514:
jmp @r4
mov r0,r2
! Opcode BABB
VABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6515
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6515:
jmp @r4
mov r0,r2
! Opcode BABC
VABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(20,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6516
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6516:
jmp @r4
mov r0,r2
! Opcodes BAC0 - BAC7
VAC0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6517
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6517:
jmp @r4
mov r0,r2
! Opcodes BAC8 - BACF
VAC8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6518
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6518:
jmp @r4
mov r0,r2
! Opcodes BAD0 - BAD7
VAD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6519
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6519:
jmp @r4
mov r0,r2
! Opcodes BAD8 - BADF
VAD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6520
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6520:
jmp @r4
mov r0,r2
! Opcodes BAE0 - BAE7
VAE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6521
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6521:
jmp @r4
mov r0,r2
! Opcodes BAE8 - BAEF
VAE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6522
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6522:
jmp @r4
mov r0,r2
! Opcodes BAF0 - BAF7
VAF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6523
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6523:
jmp @r4
mov r0,r2
! Opcode BAF8
VAF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6524
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6524:
jmp @r4
mov r0,r2
! Opcode BAF9
VAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6525
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6525:
jmp @r4
mov r0,r2
! Opcode BAFA
VAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6526
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6526:
jmp @r4
mov r0,r2
! Opcode BAFB
VAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6527
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6527:
jmp @r4
mov r0,r2
! Opcode BAFC
VAFC:
mov.w @r6+,r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6528
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6528:
jmp @r4
mov r0,r2
! Opcodes BB00 - BB07
VB00:
and r1,r2
mov r2,r0
mov.b @(r0,r13),r3
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6529
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6529:
jmp @r4
mov r0,r2
! Opcodes BB08 - BB0F
VB08:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(52,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6530
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6530:
jmp @r4
mov r0,r2
! Opcodes BB10 - BB17
VB10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6531
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6531:
jmp @r4
mov r0,r2
! Opcodes BB18 - BB1F
VB18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6532
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6532:
jmp @r4
mov r0,r2
! Opcodes BB20 - BB27
VB20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6533
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6533:
jmp @r4
mov r0,r2
! Opcodes BB28 - BB2F
VB28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6534
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6534:
jmp @r4
mov r0,r2
! Opcodes BB30 - BB37
VB30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6535
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6535:
jmp @r4
mov r0,r2
! Opcode BB38
VB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6536
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6536:
jmp @r4
mov r0,r2
! Opcode BB39
VB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6537
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6537:
jmp @r4
mov r0,r2
! Opcodes BB40 - BB47
VB40:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6538
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6538:
jmp @r4
mov r0,r2
! Opcodes BB48 - BB4F
VB48:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(52,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6539
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6539:
jmp @r4
mov r0,r2
! Opcodes BB50 - BB57
VB50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6540
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6540:
jmp @r4
mov r0,r2
! Opcodes BB58 - BB5F
VB58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6541
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6541:
jmp @r4
mov r0,r2
! Opcodes BB60 - BB67
VB60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6542
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6542:
jmp @r4
mov r0,r2
! Opcodes BB68 - BB6F
VB68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6543
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6543:
jmp @r4
mov r0,r2
! Opcodes BB70 - BB77
VB70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6544
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6544:
jmp @r4
mov r0,r2
! Opcode BB78
VB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6545
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6545:
jmp @r4
mov r0,r2
! Opcode BB79
VB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6546
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6546:
jmp @r4
mov r0,r2
! Opcodes BB80 - BB87
VB80:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(20,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6547
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6547:
jmp @r4
mov r0,r2
! Opcodes BB88 - BB8F
VB88:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(52,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(52,r13)
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6548
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6548:
jmp @r4
mov r0,r2
! Opcodes BB90 - BB97
VB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6549
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6549:
jmp @r4
mov r0,r2
! Opcodes BB98 - BB9F
VB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6550
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6550:
jmp @r4
mov r0,r2
! Opcodes BBA0 - BBA7
VBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6551
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6551:
jmp @r4
mov r0,r2
! Opcodes BBA8 - BBAF
VBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6552
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6552:
jmp @r4
mov r0,r2
! Opcodes BBB0 - BBB7
VBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6553
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6553:
jmp @r4
mov r0,r2
! Opcode BBB8
VBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6554
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6554:
jmp @r4
mov r0,r2
! Opcode BBB9
VBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6555
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6555:
jmp @r4
mov r0,r2
! Opcodes BBC0 - BBC7
VBC0:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6556
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6556:
jmp @r4
mov r0,r2
! Opcodes BBC8 - BBCF
VBC8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6557
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6557:
jmp @r4
mov r0,r2
! Opcodes BBD0 - BBD7
VBD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6558
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6558:
jmp @r4
mov r0,r2
! Opcodes BBD8 - BBDF
VBD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6559
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6559:
jmp @r4
mov r0,r2
! Opcodes BBE0 - BBE7
VBE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6560
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6560:
jmp @r4
mov r0,r2
! Opcodes BBE8 - BBEF
VBE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6561
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6561:
jmp @r4
mov r0,r2
! Opcodes BBF0 - BBF7
VBF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6562
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6562:
jmp @r4
mov r0,r2
! Opcode BBF8
VBF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6563
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6563:
jmp @r4
mov r0,r2
! Opcode BBF9
VBF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6564
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6564:
jmp @r4
mov r0,r2
! Opcode BBFA
VBFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6565
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6565:
jmp @r4
mov r0,r2
! Opcode BBFB
VBFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6566
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6566:
jmp @r4
mov r0,r2
! Opcode BBFC
VBFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6567
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6567:
jmp @r4
mov r0,r2
! Opcodes BC00 - BC07
VC00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6568
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6568:
jmp @r4
mov r0,r2
! Opcodes BC08 - BC0F
VC08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6569
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6569:
jmp @r4
mov r0,r2
! Opcodes BC10 - BC17
VC10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6570
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6570:
jmp @r4
mov r0,r2
! Opcodes BC18 - BC1F
VC18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6571
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6571:
jmp @r4
mov r0,r2
! Opcodes BC20 - BC27
VC20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6572
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6572:
jmp @r4
mov r0,r2
! Opcodes BC28 - BC2F
VC28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6573
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6573:
jmp @r4
mov r0,r2
! Opcodes BC30 - BC37
VC30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6574
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6574:
jmp @r4
mov r0,r2
! Opcode BC38
VC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6575
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6575:
jmp @r4
mov r0,r2
! Opcode BC39
VC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6576
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6576:
jmp @r4
mov r0,r2
! Opcode BC3A
VC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6577
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6577:
jmp @r4
mov r0,r2
! Opcode BC3B
VC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6578
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6578:
jmp @r4
mov r0,r2
! Opcode BC3C
VC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6579
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6579:
jmp @r4
mov r0,r2
! Opcodes BC40 - BC47
VC40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6580
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6580:
jmp @r4
mov r0,r2
! Opcodes BC48 - BC4F
VC48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6581
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6581:
jmp @r4
mov r0,r2
! Opcodes BC50 - BC57
VC50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6582
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6582:
jmp @r4
mov r0,r2
! Opcodes BC58 - BC5F
VC58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6583
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6583:
jmp @r4
mov r0,r2
! Opcodes BC60 - BC67
VC60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6584
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6584:
jmp @r4
mov r0,r2
! Opcodes BC68 - BC6F
VC68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6585
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6585:
jmp @r4
mov r0,r2
! Opcodes BC70 - BC77
VC70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6586
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6586:
jmp @r4
mov r0,r2
! Opcode BC78
VC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6587
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6587:
jmp @r4
mov r0,r2
! Opcode BC79
VC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6588
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6588:
jmp @r4
mov r0,r2
! Opcode BC7A
VC7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6589
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6589:
jmp @r4
mov r0,r2
! Opcode BC7B
VC7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6590
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6590:
jmp @r4
mov r0,r2
! Opcode BC7C
VC7C:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6591
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6591:
jmp @r4
mov r0,r2
! Opcodes BC80 - BC87
VC80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6592
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6592:
jmp @r4
mov r0,r2
! Opcodes BC88 - BC8F
VC88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6593
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6593:
jmp @r4
mov r0,r2
! Opcodes BC90 - BC97
VC90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6594
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6594:
jmp @r4
mov r0,r2
! Opcodes BC98 - BC9F
VC98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6595
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6595:
jmp @r4
mov r0,r2
! Opcodes BCA0 - BCA7
VCA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6596
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6596:
jmp @r4
mov r0,r2
! Opcodes BCA8 - BCAF
VCA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6597
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6597:
jmp @r4
mov r0,r2
! Opcodes BCB0 - BCB7
VCB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6598
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6598:
jmp @r4
mov r0,r2
! Opcode BCB8
VCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6599
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6599:
jmp @r4
mov r0,r2
! Opcode BCB9
VCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6600
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6600:
jmp @r4
mov r0,r2
! Opcode BCBA
VCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6601
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6601:
jmp @r4
mov r0,r2
! Opcode BCBB
VCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6602
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6602:
jmp @r4
mov r0,r2
! Opcode BCBC
VCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(24,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6603
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6603:
jmp @r4
mov r0,r2
! Opcodes BCC0 - BCC7
VCC0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6604
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6604:
jmp @r4
mov r0,r2
! Opcodes BCC8 - BCCF
VCC8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6605
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6605:
jmp @r4
mov r0,r2
! Opcodes BCD0 - BCD7
VCD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6606
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6606:
jmp @r4
mov r0,r2
! Opcodes BCD8 - BCDF
VCD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6607
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6607:
jmp @r4
mov r0,r2
! Opcodes BCE0 - BCE7
VCE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6608
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6608:
jmp @r4
mov r0,r2
! Opcodes BCE8 - BCEF
VCE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6609
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6609:
jmp @r4
mov r0,r2
! Opcodes BCF0 - BCF7
VCF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6610
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6610:
jmp @r4
mov r0,r2
! Opcode BCF8
VCF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6611
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6611:
jmp @r4
mov r0,r2
! Opcode BCF9
VCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6612
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6612:
jmp @r4
mov r0,r2
! Opcode BCFA
VCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6613
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6613:
jmp @r4
mov r0,r2
! Opcode BCFB
VCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6614
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6614:
jmp @r4
mov r0,r2
! Opcode BCFC
VCFC:
mov.w @r6+,r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6615
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6615:
jmp @r4
mov r0,r2
! Opcodes BD00 - BD07
VD00:
and r1,r2
mov r2,r0
mov.b @(r0,r13),r3
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6616
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6616:
jmp @r4
mov r0,r2
! Opcodes BD08 - BD0F
VD08:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #1,r4
mov.l r4,@(56,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6617
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6617:
jmp @r4
mov r0,r2
! Opcodes BD10 - BD17
VD10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6618
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6618:
jmp @r4
mov r0,r2
! Opcodes BD18 - BD1F
VD18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6619
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6619:
jmp @r4
mov r0,r2
! Opcodes BD20 - BD27
VD20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6620
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6620:
jmp @r4
mov r0,r2
! Opcodes BD28 - BD2F
VD28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6621
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6621:
jmp @r4
mov r0,r2
! Opcodes BD30 - BD37
VD30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6622
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6622:
jmp @r4
mov r0,r2
! Opcode BD38
VD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6623
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6623:
jmp @r4
mov r0,r2
! Opcode BD39
VD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6624
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6624:
jmp @r4
mov r0,r2
! Opcodes BD40 - BD47
VD40:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6625
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6625:
jmp @r4
mov r0,r2
! Opcodes BD48 - BD4F
VD48:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(56,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6626
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6626:
jmp @r4
mov r0,r2
! Opcodes BD50 - BD57
VD50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6627
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6627:
jmp @r4
mov r0,r2
! Opcodes BD58 - BD5F
VD58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6628
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6628:
jmp @r4
mov r0,r2
! Opcodes BD60 - BD67
VD60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6629
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6629:
jmp @r4
mov r0,r2
! Opcodes BD68 - BD6F
VD68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6630
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6630:
jmp @r4
mov r0,r2
! Opcodes BD70 - BD77
VD70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6631
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6631:
jmp @r4
mov r0,r2
! Opcode BD78
VD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6632
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6632:
jmp @r4
mov r0,r2
! Opcode BD79
VD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6633
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6633:
jmp @r4
mov r0,r2
! Opcodes BD80 - BD87
VD80:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(24,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6634
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6634:
jmp @r4
mov r0,r2
! Opcodes BD88 - BD8F
VD88:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(56,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(56,r13)
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6635
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6635:
jmp @r4
mov r0,r2
! Opcodes BD90 - BD97
VD90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6636
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6636:
jmp @r4
mov r0,r2
! Opcodes BD98 - BD9F
VD98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6637
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6637:
jmp @r4
mov r0,r2
! Opcodes BDA0 - BDA7
VDA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6638
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6638:
jmp @r4
mov r0,r2
! Opcodes BDA8 - BDAF
VDA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6639
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6639:
jmp @r4
mov r0,r2
! Opcodes BDB0 - BDB7
VDB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6640
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6640:
jmp @r4
mov r0,r2
! Opcode BDB8
VDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6641
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6641:
jmp @r4
mov r0,r2
! Opcode BDB9
VDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6642
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6642:
jmp @r4
mov r0,r2
! Opcodes BDC0 - BDC7
VDC0:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6643
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6643:
jmp @r4
mov r0,r2
! Opcodes BDC8 - BDCF
VDC8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6644
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6644:
jmp @r4
mov r0,r2
! Opcodes BDD0 - BDD7
VDD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6645
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6645:
jmp @r4
mov r0,r2
! Opcodes BDD8 - BDDF
VDD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6646
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6646:
jmp @r4
mov r0,r2
! Opcodes BDE0 - BDE7
VDE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6647
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6647:
jmp @r4
mov r0,r2
! Opcodes BDE8 - BDEF
VDE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6648
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6648:
jmp @r4
mov r0,r2
! Opcodes BDF0 - BDF7
VDF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6649
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6649:
jmp @r4
mov r0,r2
! Opcode BDF8
VDF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6650
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6650:
jmp @r4
mov r0,r2
! Opcode BDF9
VDF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6651
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6651:
jmp @r4
mov r0,r2
! Opcode BDFA
VDFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6652
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6652:
jmp @r4
mov r0,r2
! Opcode BDFB
VDFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6653
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6653:
jmp @r4
mov r0,r2
! Opcode BDFC
VDFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6654
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6654:
jmp @r4
mov r0,r2
! Opcodes BE00 - BE07
VE00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6655
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6655:
jmp @r4
mov r0,r2
! Opcodes BE08 - BE0F
VE08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6656
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6656:
jmp @r4
mov r0,r2
! Opcodes BE10 - BE17
VE10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6657
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6657:
jmp @r4
mov r0,r2
! Opcodes BE18 - BE1F
VE18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6658
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6658:
jmp @r4
mov r0,r2
! Opcodes BE20 - BE27
VE20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6659
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6659:
jmp @r4
mov r0,r2
! Opcodes BE28 - BE2F
VE28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6660
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6660:
jmp @r4
mov r0,r2
! Opcodes BE30 - BE37
VE30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6661
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6661:
jmp @r4
mov r0,r2
! Opcode BE38
VE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6662
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6662:
jmp @r4
mov r0,r2
! Opcode BE39
VE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6663
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6663:
jmp @r4
mov r0,r2
! Opcode BE3A
VE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6664
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6664:
jmp @r4
mov r0,r2
! Opcode BE3B
VE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6665
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6665:
jmp @r4
mov r0,r2
! Opcode BE3C
VE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-24,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6666
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6666:
jmp @r4
mov r0,r2
! Opcodes BE40 - BE47
VE40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6667
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6667:
jmp @r4
mov r0,r2
! Opcodes BE48 - BE4F
VE48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6668
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6668:
jmp @r4
mov r0,r2
! Opcodes BE50 - BE57
VE50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6669
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6669:
jmp @r4
mov r0,r2
! Opcodes BE58 - BE5F
VE58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6670
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6670:
jmp @r4
mov r0,r2
! Opcodes BE60 - BE67
VE60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6671
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6671:
jmp @r4
mov r0,r2
! Opcodes BE68 - BE6F
VE68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6672
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6672:
jmp @r4
mov r0,r2
! Opcodes BE70 - BE77
VE70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6673
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6673:
jmp @r4
mov r0,r2
! Opcode BE78
VE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6674
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6674:
jmp @r4
mov r0,r2
! Opcode BE79
VE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6675
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6675:
jmp @r4
mov r0,r2
! Opcode BE7A
VE7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6676
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6676:
jmp @r4
mov r0,r2
! Opcode BE7B
VE7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6677
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6677:
jmp @r4
mov r0,r2
! Opcode BE7C
VE7C:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
mov #-16,r0
shad r0,r1
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6678
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6678:
jmp @r4
mov r0,r2
! Opcodes BE80 - BE87
VE80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6679
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6679:
jmp @r4
mov r0,r2
! Opcodes BE88 - BE8F
VE88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6680
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6680:
jmp @r4
mov r0,r2
! Opcodes BE90 - BE97
VE90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6681
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6681:
jmp @r4
mov r0,r2
! Opcodes BE98 - BE9F
VE98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6682
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6682:
jmp @r4
mov r0,r2
! Opcodes BEA0 - BEA7
VEA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6683
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6683:
jmp @r4
mov r0,r2
! Opcodes BEA8 - BEAF
VEA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6684
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6684:
jmp @r4
mov r0,r2
! Opcodes BEB0 - BEB7
VEB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6685
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6685:
jmp @r4
mov r0,r2
! Opcode BEB8
VEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6686
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6686:
jmp @r4
mov r0,r2
! Opcode BEB9
VEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6687
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6687:
jmp @r4
mov r0,r2
! Opcode BEBA
VEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6688
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6688:
jmp @r4
mov r0,r2
! Opcode BEBB
VEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6689
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6689:
jmp @r4
mov r0,r2
! Opcode BEBC
VEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(28,r13),r1
mov r1,r0
subv r3,r0
movt r8
clrt
subc r3,r1
addc r8,r8
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6690
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6690:
jmp @r4
mov r0,r2
! Opcodes BEC0 - BEC7
VEC0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6691
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6691:
jmp @r4
mov r0,r2
! Opcodes BEC8 - BECF
VEC8:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6692
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6692:
jmp @r4
mov r0,r2
! Opcodes BED0 - BED7
VED0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6693
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6693:
jmp @r4
mov r0,r2
! Opcodes BED8 - BEDF
VED8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6694
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6694:
jmp @r4
mov r0,r2
! Opcodes BEE0 - BEE7
VEE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6695
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6695:
jmp @r4
mov r0,r2
! Opcodes BEE8 - BEEF
VEE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6696
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6696:
jmp @r4
mov r0,r2
! Opcodes BEF0 - BEF7
VEF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6697
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6697:
jmp @r4
mov r0,r2
! Opcode BEF8
VEF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6698
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6698:
jmp @r4
mov r0,r2
! Opcode BEF9
VEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6699
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6699:
jmp @r4
mov r0,r2
! Opcode BEFA
VEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6700
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6700:
jmp @r4
mov r0,r2
! Opcode BEFB
VEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6701
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6701:
jmp @r4
mov r0,r2
! Opcode BEFC
VEFC:
mov.w @r6+,r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6702
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6702:
jmp @r4
mov r0,r2
! Opcodes BF00 - BF07
VF00:
and r1,r2
mov r2,r0
mov.b @(r0,r13),r3
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.b r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6703
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6703:
jmp @r4
mov r0,r2
! Opcodes BF08 - BF0F
VF08:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
mov #24,r0
shld r0,r2
shld r0,r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-24,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6704
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6704:
jmp @r4
mov r0,r2
! Opcodes BF10 - BF17
VF10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6705
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6705:
jmp @r4
mov r0,r2
! Opcodes BF18 - BF1F
VF18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6706
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6706:
jmp @r4
mov r0,r2
! Opcodes BF20 - BF27
VF20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6707
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6707:
jmp @r4
mov r0,r2
! Opcodes BF28 - BF2F
VF28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6708
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6708:
jmp @r4
mov r0,r2
! Opcodes BF30 - BF37
VF30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6709
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6709:
jmp @r4
mov r0,r2
! Opcode BF38
VF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6710
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6710:
jmp @r4
mov r0,r2
! Opcode BF39
VF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
xor r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6711
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6711:
jmp @r4
mov r0,r2
! Opcodes BF40 - BF47
VF40:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov r2,r0
mov.w r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6712
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6712:
jmp @r4
mov r0,r2
! Opcodes BF48 - BF4F
VF48:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov.l r4,@(60,r13)
shll16 r2
shll16 r3
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
mov #-16,r0
shad r0,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6713
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6713:
jmp @r4
mov r0,r2
! Opcodes BF50 - BF57
VF50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6714
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6714:
jmp @r4
mov r0,r2
! Opcodes BF58 - BF5F
VF58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6715
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6715:
jmp @r4
mov r0,r2
! Opcodes BF60 - BF67
VF60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6716
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6716:
jmp @r4
mov r0,r2
! Opcodes BF68 - BF6F
VF68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6717
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6717:
jmp @r4
mov r0,r2
! Opcodes BF70 - BF77
VF70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6718
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6718:
jmp @r4
mov r0,r2
! Opcode BF78
VF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6719
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6719:
jmp @r4
mov r0,r2
! Opcode BF79
VF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
xor r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6720
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6720:
jmp @r4
mov r0,r2
! Opcodes BF80 - BF87
VF80:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(28,r13),r1
xor r1,r3
mov r2,r0
mov.l r3,@(r0,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6721
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6721:
jmp @r4
mov r0,r2
! Opcodes BF88 - BF8F
VF88:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r2
mov.l @(60,r13),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov.l r4,@(60,r13)
mov r3,r0
subv r2,r0
movt r8
clrt
subc r2,r3
addc r8,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6722
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6722:
jmp @r4
mov r0,r2
! Opcodes BF90 - BF97
VF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6723
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6723:
jmp @r4
mov r0,r2
! Opcodes BF98 - BF9F
VF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6724
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6724:
jmp @r4
mov r0,r2
! Opcodes BFA0 - BFA7
VFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6725
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6725:
jmp @r4
mov r0,r2
! Opcodes BFA8 - BFAF
VFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6726
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6726:
jmp @r4
mov r0,r2
! Opcodes BFB0 - BFB7
VFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6727
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6727:
jmp @r4
mov r0,r2
! Opcode BFB8
VFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6728
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6728:
jmp @r4
mov r0,r2
! Opcode BFB9
VFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
xor r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6729
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6729:
jmp @r4
mov r0,r2
! Opcodes BFC0 - BFC7
VFC0:
and r1,r2
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6730
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6730:
jmp @r4
mov r0,r2
! Opcodes BFC8 - BFCF
VFC8:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6731
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6731:
jmp @r4
mov r0,r2
! Opcodes BFD0 - BFD7
VFD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6732
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6732:
jmp @r4
mov r0,r2
! Opcodes BFD8 - BFDF
VFD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6733
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6733:
jmp @r4
mov r0,r2
! Opcodes BFE0 - BFE7
VFE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6734
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6734:
jmp @r4
mov r0,r2
! Opcodes BFE8 - BFEF
VFE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6735
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6735:
jmp @r4
mov r0,r2
! Opcodes BFF0 - BFF7
VFF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6736
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6736:
jmp @r4
mov r0,r2
! Opcode BFF8
VFF8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6737
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6737:
jmp @r4
mov r0,r2
! Opcode BFF9
VFF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6738
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6738:
jmp @r4
mov r0,r2
! Opcode BFFA
VFFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6739
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6739:
jmp @r4
mov r0,r2
! Opcode BFFB
VFFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6740
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6740:
jmp @r4
mov r0,r2
! Opcode BFFC
VFFC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r1
mov r1,r0
subv r3,r1
movt r8
clrt
subc r3,r0
addc r8,r8
rotl r0
addc r8,r8
mov r0,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6741
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6741:
jmp @r4
mov r0,r2
! Opcodes C000 - C007
W000:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6742
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6742:
jmp @r4
mov r0,r2
! Opcodes C010 - C017
W010:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6743
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6743:
jmp @r4
mov r0,r2
! Opcodes C018 - C01F
W018:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6744
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6744:
jmp @r4
mov r0,r2
! Opcodes C020 - C027
W020:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6745
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6745:
jmp @r4
mov r0,r2
! Opcodes C028 - C02F
W028:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6746
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6746:
jmp @r4
mov r0,r2
! Opcodes C030 - C037
W030:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6747
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6747:
jmp @r4
mov r0,r2
! Opcode C038
W038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6748
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6748:
jmp @r4
mov r0,r2
! Opcode C039
W039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6749
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6749:
jmp @r4
mov r0,r2
! Opcode C03A
W03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6750
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6750:
jmp @r4
mov r0,r2
! Opcode C03B
W03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6751
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6751:
jmp @r4
mov r0,r2
! Opcode C03C
W03C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r1
and r1,r3
mov.b r3,@r13
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6752
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6752:
jmp @r4
mov r0,r2
! Opcodes C040 - C047
W040:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6753
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6753:
jmp @r4
mov r0,r2
! Opcodes C050 - C057
W050:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6754
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6754:
jmp @r4
mov r0,r2
! Opcodes C058 - C05F
W058:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6755
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6755:
jmp @r4
mov r0,r2
! Opcodes C060 - C067
W060:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6756
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6756:
jmp @r4
mov r0,r2
! Opcodes C068 - C06F
W068:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6757
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6757:
jmp @r4
mov r0,r2
! Opcodes C070 - C077
W070:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6758
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6758:
jmp @r4
mov r0,r2
! Opcode C078
W078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6759
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6759:
jmp @r4
mov r0,r2
! Opcode C079
W079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6760
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6760:
jmp @r4
mov r0,r2
! Opcode C07A
W07A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6761
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6761:
jmp @r4
mov r0,r2
! Opcode C07B
W07B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6762
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6762:
jmp @r4
mov r0,r2
! Opcode C07C
W07C:
mov.w @r6+,r3
mov.w @r13,r1
and r1,r3
mov.w r3,@r13
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6763
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6763:
jmp @r4
mov r0,r2
! Opcodes C080 - C087
W080:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6764
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6764:
jmp @r4
mov r0,r2
! Opcodes C090 - C097
W090:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6765
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6765:
jmp @r4
mov r0,r2
! Opcodes C098 - C09F
W098:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6766
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6766:
jmp @r4
mov r0,r2
! Opcodes C0A0 - C0A7
W0A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6767
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6767:
jmp @r4
mov r0,r2
! Opcodes C0A8 - C0AF
W0A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6768
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6768:
jmp @r4
mov r0,r2
! Opcodes C0B0 - C0B7
W0B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6769
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6769:
jmp @r4
mov r0,r2
! Opcode C0B8
W0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6770
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6770:
jmp @r4
mov r0,r2
! Opcode C0B9
W0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6771
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6771:
jmp @r4
mov r0,r2
! Opcode C0BA
W0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6772
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6772:
jmp @r4
mov r0,r2
! Opcode C0BB
W0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6773
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6773:
jmp @r4
mov r0,r2
! Opcode C0BC
W0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @r13,r1
and r1,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6774
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6774:
jmp @r4
mov r0,r2
! Opcodes C0C0 - C0C7
W0C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6775:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6775
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6776
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6776:
jmp @r4
mov r0,r2
! Opcodes C0D0 - C0D7
W0D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6777:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6777
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6778
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6778:
jmp @r4
mov r0,r2
! Opcodes C0D8 - C0DF
W0D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6779:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6779
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6780
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6780:
jmp @r4
mov r0,r2
! Opcodes C0E0 - C0E7
W0E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6781:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6781
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6782
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6782:
jmp @r4
mov r0,r2
! Opcodes C0E8 - C0EF
W0E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6783:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6783
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6784
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6784:
jmp @r4
mov r0,r2
! Opcodes C0F0 - C0F7
W0F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6785:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6785
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6786
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6786:
jmp @r4
mov r0,r2
! Opcode C0F8
W0F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6787:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6787
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6788
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6788:
jmp @r4
mov r0,r2
! Opcode C0F9
W0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6789:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6789
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6790
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6790:
jmp @r4
mov r0,r2
! Opcode C0FA
W0FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6791:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6791
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6792
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6792:
jmp @r4
mov r0,r2
! Opcode C0FB
W0FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6793:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6793
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6794
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6794:
jmp @r4
mov r0,r2
! Opcode C0FC
W0FC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6795:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6795
sub r0,r7
sub r0,r7
mov.w @r13,r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6796
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6796:
jmp @r4
mov r0,r2
! Opcodes C100 - C107
W100:
and r1,r2
mov r3,r4
mov.b @r13,r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd6797
add #6,r8
.nonibadd6797:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop6797
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop6797:
exts.b r3,r3
mov r9,r8
mov.b r3,@r13
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6798
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6798:
jmp @r4
mov r0,r2
! Opcodes C108 - C10F
W108:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(32,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd6799
add #6,r8
.nonibadd6799:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop6799
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop6799:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6800
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6800:
jmp @r4
mov r0,r2
! Opcodes C110 - C117
W110:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6801
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6801:
jmp @r4
mov r0,r2
! Opcodes C118 - C11F
W118:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6802
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6802:
jmp @r4
mov r0,r2
! Opcodes C120 - C127
W120:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6803
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6803:
jmp @r4
mov r0,r2
! Opcodes C128 - C12F
W128:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6804
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6804:
jmp @r4
mov r0,r2
! Opcodes C130 - C137
W130:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6805
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6805:
jmp @r4
mov r0,r2
! Opcode C138
W138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6806
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6806:
jmp @r4
mov r0,r2
! Opcode C139
W139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6807
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6807:
jmp @r4
mov r0,r2
! Opcodes C140 - C147
W140:
and r1,r2
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @r13,r3
mov.l r3,@r2
mov.l r1,@r13
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6808
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6808:
jmp @r4
mov r0,r2
! Opcodes C148 - C14F
W148:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(32,r13),r3
mov.l r3,@r2
mov.l r1,@(32,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6809
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6809:
jmp @r4
mov r0,r2
! Opcodes C150 - C157
W150:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6810
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6810:
jmp @r4
mov r0,r2
! Opcodes C158 - C15F
W158:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6811
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6811:
jmp @r4
mov r0,r2
! Opcodes C160 - C167
W160:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6812
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6812:
jmp @r4
mov r0,r2
! Opcodes C168 - C16F
W168:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6813
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6813:
jmp @r4
mov r0,r2
! Opcodes C170 - C177
W170:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6814
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6814:
jmp @r4
mov r0,r2
! Opcode C178
W178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6815
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6815:
jmp @r4
mov r0,r2
! Opcode C179
W179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6816
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6816:
jmp @r4
mov r0,r2
! Opcodes C188 - C18F
W188:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @r13,r3
mov.l r3,@r2
mov.l r1,@r13
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6817
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6817:
jmp @r4
mov r0,r2
! Opcodes C190 - C197
W190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6818
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6818:
jmp @r4
mov r0,r2
! Opcodes C198 - C19F
W198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6819
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6819:
jmp @r4
mov r0,r2
! Opcodes C1A0 - C1A7
W1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6820
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6820:
jmp @r4
mov r0,r2
! Opcodes C1A8 - C1AF
W1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6821
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6821:
jmp @r4
mov r0,r2
! Opcodes C1B0 - C1B7
W1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6822
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6822:
jmp @r4
mov r0,r2
! Opcode C1B8
W1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6823
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6823:
jmp @r4
mov r0,r2
! Opcode C1B9
W1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6824
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6824:
jmp @r4
mov r0,r2
! Opcodes C1C0 - C1C7
W1C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6825:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6825
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6826
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6826:
jmp @r4
mov r0,r2
! Opcodes C1D0 - C1D7
W1D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6827:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6827
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6828
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6828:
jmp @r4
mov r0,r2
! Opcodes C1D8 - C1DF
W1D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6829:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6829
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6830
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6830:
jmp @r4
mov r0,r2
! Opcodes C1E0 - C1E7
W1E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6831:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6831
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6832
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6832:
jmp @r4
mov r0,r2
! Opcodes C1E8 - C1EF
W1E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6833:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6833
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6834
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6834:
jmp @r4
mov r0,r2
! Opcodes C1F0 - C1F7
W1F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6835:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6835
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6836
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6836:
jmp @r4
mov r0,r2
! Opcode C1F8
W1F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6837:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6837
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6838
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6838:
jmp @r4
mov r0,r2
! Opcode C1F9
W1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6839:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6839
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6840
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6840:
jmp @r4
mov r0,r2
! Opcode C1FA
W1FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6841:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6841
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6842
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6842:
jmp @r4
mov r0,r2
! Opcode C1FB
W1FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6843:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6843
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6844
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6844:
jmp @r4
mov r0,r2
! Opcode C1FC
W1FC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6845:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6845
sub r0,r7
sub r0,r7
mov.w @r13,r1
muls.w r1,r3
sts macl,r3
mov.l r3,@r13
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6846
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6846:
jmp @r4
mov r0,r2
! Opcodes C200 - C207
W200:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6847
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6847:
jmp @r4
mov r0,r2
! Opcodes C210 - C217
W210:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6848
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6848:
jmp @r4
mov r0,r2
! Opcodes C218 - C21F
W218:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6849
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6849:
jmp @r4
mov r0,r2
! Opcodes C220 - C227
W220:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6850
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6850:
jmp @r4
mov r0,r2
! Opcodes C228 - C22F
W228:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6851
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6851:
jmp @r4
mov r0,r2
! Opcodes C230 - C237
W230:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6852
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6852:
jmp @r4
mov r0,r2
! Opcode C238
W238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6853
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6853:
jmp @r4
mov r0,r2
! Opcode C239
W239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6854
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6854:
jmp @r4
mov r0,r2
! Opcode C23A
W23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6855
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6855:
jmp @r4
mov r0,r2
! Opcode C23B
W23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6856
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6856:
jmp @r4
mov r0,r2
! Opcode C23C
W23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov #4,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6857
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6857:
jmp @r4
mov r0,r2
! Opcodes C240 - C247
W240:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6858
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6858:
jmp @r4
mov r0,r2
! Opcodes C250 - C257
W250:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6859
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6859:
jmp @r4
mov r0,r2
! Opcodes C258 - C25F
W258:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6860
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6860:
jmp @r4
mov r0,r2
! Opcodes C260 - C267
W260:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6861
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6861:
jmp @r4
mov r0,r2
! Opcodes C268 - C26F
W268:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6862
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6862:
jmp @r4
mov r0,r2
! Opcodes C270 - C277
W270:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6863
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6863:
jmp @r4
mov r0,r2
! Opcode C278
W278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6864
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6864:
jmp @r4
mov r0,r2
! Opcode C279
W279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6865
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6865:
jmp @r4
mov r0,r2
! Opcode C27A
W27A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6866
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6866:
jmp @r4
mov r0,r2
! Opcode C27B
W27B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6867
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6867:
jmp @r4
mov r0,r2
! Opcode C27C
W27C:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov #4,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6868
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6868:
jmp @r4
mov r0,r2
! Opcodes C280 - C287
W280:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6869
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6869:
jmp @r4
mov r0,r2
! Opcodes C290 - C297
W290:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6870
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6870:
jmp @r4
mov r0,r2
! Opcodes C298 - C29F
W298:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6871
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6871:
jmp @r4
mov r0,r2
! Opcodes C2A0 - C2A7
W2A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6872
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6872:
jmp @r4
mov r0,r2
! Opcodes C2A8 - C2AF
W2A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6873
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6873:
jmp @r4
mov r0,r2
! Opcodes C2B0 - C2B7
W2B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6874
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6874:
jmp @r4
mov r0,r2
! Opcode C2B8
W2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6875
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6875:
jmp @r4
mov r0,r2
! Opcode C2B9
W2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6876
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6876:
jmp @r4
mov r0,r2
! Opcode C2BA
W2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6877
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6877:
jmp @r4
mov r0,r2
! Opcode C2BB
W2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6878
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6878:
jmp @r4
mov r0,r2
! Opcode C2BC
W2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(4,r13),r1
and r1,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6879
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6879:
jmp @r4
mov r0,r2
! Opcodes C2C0 - C2C7
W2C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6880:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6880
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6881
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6881:
jmp @r4
mov r0,r2
! Opcodes C2D0 - C2D7
W2D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6882:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6882
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6883
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6883:
jmp @r4
mov r0,r2
! Opcodes C2D8 - C2DF
W2D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6884:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6884
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6885
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6885:
jmp @r4
mov r0,r2
! Opcodes C2E0 - C2E7
W2E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6886:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6886
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6887
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6887:
jmp @r4
mov r0,r2
! Opcodes C2E8 - C2EF
W2E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6888:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6888
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6889
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6889:
jmp @r4
mov r0,r2
! Opcodes C2F0 - C2F7
W2F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6890:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6890
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6891
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6891:
jmp @r4
mov r0,r2
! Opcode C2F8
W2F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6892:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6892
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6893
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6893:
jmp @r4
mov r0,r2
! Opcode C2F9
W2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6894:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6894
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6895
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6895:
jmp @r4
mov r0,r2
! Opcode C2FA
W2FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6896:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6896
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6897
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6897:
jmp @r4
mov r0,r2
! Opcode C2FB
W2FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6898:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6898
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6899
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6899:
jmp @r4
mov r0,r2
! Opcode C2FC
W2FC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6900:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6900
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6901
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6901:
jmp @r4
mov r0,r2
! Opcodes C300 - C307
W300:
and r1,r2
mov r3,r4
mov #4,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd6902
add #6,r8
.nonibadd6902:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop6902
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop6902:
exts.b r3,r3
mov r9,r8
mov #4,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6903
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6903:
jmp @r4
mov r0,r2
! Opcodes C308 - C30F
W308:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(36,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd6904
add #6,r8
.nonibadd6904:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop6904
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop6904:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6905
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6905:
jmp @r4
mov r0,r2
! Opcodes C310 - C317
W310:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6906
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6906:
jmp @r4
mov r0,r2
! Opcodes C318 - C31F
W318:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6907
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6907:
jmp @r4
mov r0,r2
! Opcodes C320 - C327
W320:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6908
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6908:
jmp @r4
mov r0,r2
! Opcodes C328 - C32F
W328:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6909
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6909:
jmp @r4
mov r0,r2
! Opcodes C330 - C337
W330:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6910
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6910:
jmp @r4
mov r0,r2
! Opcode C338
W338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6911
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6911:
jmp @r4
mov r0,r2
! Opcode C339
W339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6912
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6912:
jmp @r4
mov r0,r2
! Opcodes C340 - C347
W340:
and r1,r2
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(4,r13),r3
mov.l r3,@r2
mov.l r1,@(4,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6913
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6913:
jmp @r4
mov r0,r2
! Opcodes C348 - C34F
W348:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(36,r13),r3
mov.l r3,@r2
mov.l r1,@(36,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6914
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6914:
jmp @r4
mov r0,r2
! Opcodes C350 - C357
W350:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6915
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6915:
jmp @r4
mov r0,r2
! Opcodes C358 - C35F
W358:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6916
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6916:
jmp @r4
mov r0,r2
! Opcodes C360 - C367
W360:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6917
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6917:
jmp @r4
mov r0,r2
! Opcodes C368 - C36F
W368:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6918
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6918:
jmp @r4
mov r0,r2
! Opcodes C370 - C377
W370:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6919
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6919:
jmp @r4
mov r0,r2
! Opcode C378
W378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6920
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6920:
jmp @r4
mov r0,r2
! Opcode C379
W379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6921
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6921:
jmp @r4
mov r0,r2
! Opcodes C388 - C38F
W388:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(4,r13),r3
mov.l r3,@r2
mov.l r1,@(4,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6922
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6922:
jmp @r4
mov r0,r2
! Opcodes C390 - C397
W390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6923
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6923:
jmp @r4
mov r0,r2
! Opcodes C398 - C39F
W398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6924
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6924:
jmp @r4
mov r0,r2
! Opcodes C3A0 - C3A7
W3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6925
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6925:
jmp @r4
mov r0,r2
! Opcodes C3A8 - C3AF
W3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6926
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6926:
jmp @r4
mov r0,r2
! Opcodes C3B0 - C3B7
W3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6927
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6927:
jmp @r4
mov r0,r2
! Opcode C3B8
W3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6928
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6928:
jmp @r4
mov r0,r2
! Opcode C3B9
W3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6929
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6929:
jmp @r4
mov r0,r2
! Opcodes C3C0 - C3C7
W3C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6930:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6930
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6931
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6931:
jmp @r4
mov r0,r2
! Opcodes C3D0 - C3D7
W3D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6932:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6932
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6933
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6933:
jmp @r4
mov r0,r2
! Opcodes C3D8 - C3DF
W3D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6934:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6934
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6935
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6935:
jmp @r4
mov r0,r2
! Opcodes C3E0 - C3E7
W3E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6936:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6936
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6937
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6937:
jmp @r4
mov r0,r2
! Opcodes C3E8 - C3EF
W3E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6938:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6938
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6939
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6939:
jmp @r4
mov r0,r2
! Opcodes C3F0 - C3F7
W3F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6940:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6940
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6941
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6941:
jmp @r4
mov r0,r2
! Opcode C3F8
W3F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6942:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6942
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6943
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6943:
jmp @r4
mov r0,r2
! Opcode C3F9
W3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6944:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6944
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6945
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6945:
jmp @r4
mov r0,r2
! Opcode C3FA
W3FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6946:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6946
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6947
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6947:
jmp @r4
mov r0,r2
! Opcode C3FB
W3FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6948:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6948
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6949
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6949:
jmp @r4
mov r0,r2
! Opcode C3FC
W3FC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln6950:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln6950
sub r0,r7
sub r0,r7
mov #4,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(4,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6951
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6951:
jmp @r4
mov r0,r2
! Opcodes C400 - C407
W400:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6952
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6952:
jmp @r4
mov r0,r2
! Opcodes C410 - C417
W410:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6953
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6953:
jmp @r4
mov r0,r2
! Opcodes C418 - C41F
W418:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6954
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6954:
jmp @r4
mov r0,r2
! Opcodes C420 - C427
W420:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6955
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6955:
jmp @r4
mov r0,r2
! Opcodes C428 - C42F
W428:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6956
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6956:
jmp @r4
mov r0,r2
! Opcodes C430 - C437
W430:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6957
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6957:
jmp @r4
mov r0,r2
! Opcode C438
W438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6958
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6958:
jmp @r4
mov r0,r2
! Opcode C439
W439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6959
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6959:
jmp @r4
mov r0,r2
! Opcode C43A
W43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6960
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6960:
jmp @r4
mov r0,r2
! Opcode C43B
W43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6961
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6961:
jmp @r4
mov r0,r2
! Opcode C43C
W43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov #8,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6962
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6962:
jmp @r4
mov r0,r2
! Opcodes C440 - C447
W440:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6963
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6963:
jmp @r4
mov r0,r2
! Opcodes C450 - C457
W450:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6964
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6964:
jmp @r4
mov r0,r2
! Opcodes C458 - C45F
W458:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6965
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6965:
jmp @r4
mov r0,r2
! Opcodes C460 - C467
W460:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6966
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6966:
jmp @r4
mov r0,r2
! Opcodes C468 - C46F
W468:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6967
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6967:
jmp @r4
mov r0,r2
! Opcodes C470 - C477
W470:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6968
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6968:
jmp @r4
mov r0,r2
! Opcode C478
W478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6969
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6969:
jmp @r4
mov r0,r2
! Opcode C479
W479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6970
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6970:
jmp @r4
mov r0,r2
! Opcode C47A
W47A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6971
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6971:
jmp @r4
mov r0,r2
! Opcode C47B
W47B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6972
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6972:
jmp @r4
mov r0,r2
! Opcode C47C
W47C:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov #8,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6973
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6973:
jmp @r4
mov r0,r2
! Opcodes C480 - C487
W480:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6974
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6974:
jmp @r4
mov r0,r2
! Opcodes C490 - C497
W490:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6975
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6975:
jmp @r4
mov r0,r2
! Opcodes C498 - C49F
W498:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6976
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6976:
jmp @r4
mov r0,r2
! Opcodes C4A0 - C4A7
W4A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6977
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6977:
jmp @r4
mov r0,r2
! Opcodes C4A8 - C4AF
W4A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6978
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6978:
jmp @r4
mov r0,r2
! Opcodes C4B0 - C4B7
W4B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6979
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6979:
jmp @r4
mov r0,r2
! Opcode C4B8
W4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6980
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6980:
jmp @r4
mov r0,r2
! Opcode C4B9
W4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6981
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6981:
jmp @r4
mov r0,r2
! Opcode C4BA
W4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6982
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6982:
jmp @r4
mov r0,r2
! Opcode C4BB
W4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6983
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6983:
jmp @r4
mov r0,r2
! Opcode C4BC
W4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(8,r13),r1
and r1,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6984
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6984:
jmp @r4
mov r0,r2
! Opcodes C4C0 - C4C7
W4C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6985:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6985
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6986
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6986:
jmp @r4
mov r0,r2
! Opcodes C4D0 - C4D7
W4D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6987:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6987
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6988
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6988:
jmp @r4
mov r0,r2
! Opcodes C4D8 - C4DF
W4D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6989:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6989
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6990
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6990:
jmp @r4
mov r0,r2
! Opcodes C4E0 - C4E7
W4E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6991:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6991
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6992
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6992:
jmp @r4
mov r0,r2
! Opcodes C4E8 - C4EF
W4E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6993:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6993
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6994
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6994:
jmp @r4
mov r0,r2
! Opcodes C4F0 - C4F7
W4F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6995:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6995
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6996
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6996:
jmp @r4
mov r0,r2
! Opcode C4F8
W4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6997:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6997
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl6998
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl6998:
jmp @r4
mov r0,r2
! Opcode C4F9
W4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln6999:
shlr r1
addc r4,r0
cmp/pl r1
bt ln6999
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7000
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7000:
jmp @r4
mov r0,r2
! Opcode C4FA
W4FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7001:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7001
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7002
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7002:
jmp @r4
mov r0,r2
! Opcode C4FB
W4FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7003:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7003
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7004
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7004:
jmp @r4
mov r0,r2
! Opcode C4FC
W4FC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7005:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7005
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7006
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7006:
jmp @r4
mov r0,r2
! Opcodes C500 - C507
W500:
and r1,r2
mov r3,r4
mov #8,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7007
add #6,r8
.nonibadd7007:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7007
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7007:
exts.b r3,r3
mov r9,r8
mov #8,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7008
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7008:
jmp @r4
mov r0,r2
! Opcodes C508 - C50F
W508:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(40,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7009
add #6,r8
.nonibadd7009:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7009
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7009:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7010
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7010:
jmp @r4
mov r0,r2
! Opcodes C510 - C517
W510:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7011
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7011:
jmp @r4
mov r0,r2
! Opcodes C518 - C51F
W518:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7012
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7012:
jmp @r4
mov r0,r2
! Opcodes C520 - C527
W520:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7013
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7013:
jmp @r4
mov r0,r2
! Opcodes C528 - C52F
W528:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7014
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7014:
jmp @r4
mov r0,r2
! Opcodes C530 - C537
W530:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7015
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7015:
jmp @r4
mov r0,r2
! Opcode C538
W538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7016
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7016:
jmp @r4
mov r0,r2
! Opcode C539
W539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7017
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7017:
jmp @r4
mov r0,r2
! Opcodes C540 - C547
W540:
and r1,r2
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(8,r13),r3
mov.l r3,@r2
mov.l r1,@(8,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7018
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7018:
jmp @r4
mov r0,r2
! Opcodes C548 - C54F
W548:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(40,r13),r3
mov.l r3,@r2
mov.l r1,@(40,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7019
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7019:
jmp @r4
mov r0,r2
! Opcodes C550 - C557
W550:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7020
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7020:
jmp @r4
mov r0,r2
! Opcodes C558 - C55F
W558:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7021
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7021:
jmp @r4
mov r0,r2
! Opcodes C560 - C567
W560:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7022
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7022:
jmp @r4
mov r0,r2
! Opcodes C568 - C56F
W568:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7023
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7023:
jmp @r4
mov r0,r2
! Opcodes C570 - C577
W570:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7024
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7024:
jmp @r4
mov r0,r2
! Opcode C578
W578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7025
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7025:
jmp @r4
mov r0,r2
! Opcode C579
W579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7026
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7026:
jmp @r4
mov r0,r2
! Opcodes C588 - C58F
W588:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(8,r13),r3
mov.l r3,@r2
mov.l r1,@(8,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7027
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7027:
jmp @r4
mov r0,r2
! Opcodes C590 - C597
W590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7028
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7028:
jmp @r4
mov r0,r2
! Opcodes C598 - C59F
W598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7029
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7029:
jmp @r4
mov r0,r2
! Opcodes C5A0 - C5A7
W5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7030
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7030:
jmp @r4
mov r0,r2
! Opcodes C5A8 - C5AF
W5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7031
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7031:
jmp @r4
mov r0,r2
! Opcodes C5B0 - C5B7
W5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7032
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7032:
jmp @r4
mov r0,r2
! Opcode C5B8
W5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7033
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7033:
jmp @r4
mov r0,r2
! Opcode C5B9
W5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7034
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7034:
jmp @r4
mov r0,r2
! Opcodes C5C0 - C5C7
W5C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7035:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7035
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7036
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7036:
jmp @r4
mov r0,r2
! Opcodes C5D0 - C5D7
W5D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7037:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7037
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7038
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7038:
jmp @r4
mov r0,r2
! Opcodes C5D8 - C5DF
W5D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7039:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7039
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7040
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7040:
jmp @r4
mov r0,r2
! Opcodes C5E0 - C5E7
W5E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7041:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7041
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7042
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7042:
jmp @r4
mov r0,r2
! Opcodes C5E8 - C5EF
W5E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7043:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7043
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7044
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7044:
jmp @r4
mov r0,r2
! Opcodes C5F0 - C5F7
W5F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7045:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7045
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7046
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7046:
jmp @r4
mov r0,r2
! Opcode C5F8
W5F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7047:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7047
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7048
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7048:
jmp @r4
mov r0,r2
! Opcode C5F9
W5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7049:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7049
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7050
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7050:
jmp @r4
mov r0,r2
! Opcode C5FA
W5FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7051:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7051
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7052
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7052:
jmp @r4
mov r0,r2
! Opcode C5FB
W5FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7053:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7053
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7054
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7054:
jmp @r4
mov r0,r2
! Opcode C5FC
W5FC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7055:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7055
sub r0,r7
sub r0,r7
mov #8,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(8,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7056
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7056:
jmp @r4
mov r0,r2
! Opcodes C600 - C607
W600:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7057
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7057:
jmp @r4
mov r0,r2
! Opcodes C610 - C617
W610:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7058
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7058:
jmp @r4
mov r0,r2
! Opcodes C618 - C61F
W618:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7059
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7059:
jmp @r4
mov r0,r2
! Opcodes C620 - C627
W620:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7060
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7060:
jmp @r4
mov r0,r2
! Opcodes C628 - C62F
W628:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7061
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7061:
jmp @r4
mov r0,r2
! Opcodes C630 - C637
W630:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7062
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7062:
jmp @r4
mov r0,r2
! Opcode C638
W638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7063
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7063:
jmp @r4
mov r0,r2
! Opcode C639
W639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7064
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7064:
jmp @r4
mov r0,r2
! Opcode C63A
W63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7065
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7065:
jmp @r4
mov r0,r2
! Opcode C63B
W63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7066
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7066:
jmp @r4
mov r0,r2
! Opcode C63C
W63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov #12,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7067
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7067:
jmp @r4
mov r0,r2
! Opcodes C640 - C647
W640:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7068
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7068:
jmp @r4
mov r0,r2
! Opcodes C650 - C657
W650:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7069
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7069:
jmp @r4
mov r0,r2
! Opcodes C658 - C65F
W658:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7070
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7070:
jmp @r4
mov r0,r2
! Opcodes C660 - C667
W660:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7071
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7071:
jmp @r4
mov r0,r2
! Opcodes C668 - C66F
W668:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7072
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7072:
jmp @r4
mov r0,r2
! Opcodes C670 - C677
W670:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7073
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7073:
jmp @r4
mov r0,r2
! Opcode C678
W678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7074
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7074:
jmp @r4
mov r0,r2
! Opcode C679
W679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7075
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7075:
jmp @r4
mov r0,r2
! Opcode C67A
W67A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7076
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7076:
jmp @r4
mov r0,r2
! Opcode C67B
W67B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7077
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7077:
jmp @r4
mov r0,r2
! Opcode C67C
W67C:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov #12,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7078
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7078:
jmp @r4
mov r0,r2
! Opcodes C680 - C687
W680:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7079
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7079:
jmp @r4
mov r0,r2
! Opcodes C690 - C697
W690:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7080
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7080:
jmp @r4
mov r0,r2
! Opcodes C698 - C69F
W698:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7081
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7081:
jmp @r4
mov r0,r2
! Opcodes C6A0 - C6A7
W6A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7082
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7082:
jmp @r4
mov r0,r2
! Opcodes C6A8 - C6AF
W6A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7083
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7083:
jmp @r4
mov r0,r2
! Opcodes C6B0 - C6B7
W6B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7084
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7084:
jmp @r4
mov r0,r2
! Opcode C6B8
W6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7085
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7085:
jmp @r4
mov r0,r2
! Opcode C6B9
W6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7086
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7086:
jmp @r4
mov r0,r2
! Opcode C6BA
W6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7087
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7087:
jmp @r4
mov r0,r2
! Opcode C6BB
W6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7088
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7088:
jmp @r4
mov r0,r2
! Opcode C6BC
W6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(12,r13),r1
and r1,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7089
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7089:
jmp @r4
mov r0,r2
! Opcodes C6C0 - C6C7
W6C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7090:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7090
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7091
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7091:
jmp @r4
mov r0,r2
! Opcodes C6D0 - C6D7
W6D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7092:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7092
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7093
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7093:
jmp @r4
mov r0,r2
! Opcodes C6D8 - C6DF
W6D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7094:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7094
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7095
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7095:
jmp @r4
mov r0,r2
! Opcodes C6E0 - C6E7
W6E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7096:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7096
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7097
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7097:
jmp @r4
mov r0,r2
! Opcodes C6E8 - C6EF
W6E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7098:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7098
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7099
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7099:
jmp @r4
mov r0,r2
! Opcodes C6F0 - C6F7
W6F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7100:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7100
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7101
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7101:
jmp @r4
mov r0,r2
! Opcode C6F8
W6F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7102:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7102
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7103
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7103:
jmp @r4
mov r0,r2
! Opcode C6F9
W6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7104:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7104
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7105
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7105:
jmp @r4
mov r0,r2
! Opcode C6FA
W6FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7106:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7106
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7107
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7107:
jmp @r4
mov r0,r2
! Opcode C6FB
W6FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7108:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7108
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7109
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7109:
jmp @r4
mov r0,r2
! Opcode C6FC
W6FC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7110:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7110
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7111
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7111:
jmp @r4
mov r0,r2
! Opcodes C700 - C707
W700:
and r1,r2
mov r3,r4
mov #12,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7112
add #6,r8
.nonibadd7112:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7112
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7112:
exts.b r3,r3
mov r9,r8
mov #12,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7113
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7113:
jmp @r4
mov r0,r2
! Opcodes C708 - C70F
W708:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(44,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7114
add #6,r8
.nonibadd7114:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7114
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7114:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7115
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7115:
jmp @r4
mov r0,r2
! Opcodes C710 - C717
W710:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7116
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7116:
jmp @r4
mov r0,r2
! Opcodes C718 - C71F
W718:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7117
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7117:
jmp @r4
mov r0,r2
! Opcodes C720 - C727
W720:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7118
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7118:
jmp @r4
mov r0,r2
! Opcodes C728 - C72F
W728:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7119
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7119:
jmp @r4
mov r0,r2
! Opcodes C730 - C737
W730:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7120
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7120:
jmp @r4
mov r0,r2
! Opcode C738
W738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7121
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7121:
jmp @r4
mov r0,r2
! Opcode C739
W739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7122
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7122:
jmp @r4
mov r0,r2
! Opcodes C740 - C747
W740:
and r1,r2
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(12,r13),r3
mov.l r3,@r2
mov.l r1,@(12,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7123
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7123:
jmp @r4
mov r0,r2
! Opcodes C748 - C74F
W748:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(44,r13),r3
mov.l r3,@r2
mov.l r1,@(44,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7124
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7124:
jmp @r4
mov r0,r2
! Opcodes C750 - C757
W750:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7125
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7125:
jmp @r4
mov r0,r2
! Opcodes C758 - C75F
W758:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7126
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7126:
jmp @r4
mov r0,r2
! Opcodes C760 - C767
W760:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7127
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7127:
jmp @r4
mov r0,r2
! Opcodes C768 - C76F
W768:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7128
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7128:
jmp @r4
mov r0,r2
! Opcodes C770 - C777
W770:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7129
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7129:
jmp @r4
mov r0,r2
! Opcode C778
W778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7130
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7130:
jmp @r4
mov r0,r2
! Opcode C779
W779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7131
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7131:
jmp @r4
mov r0,r2
! Opcodes C788 - C78F
W788:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(12,r13),r3
mov.l r3,@r2
mov.l r1,@(12,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7132
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7132:
jmp @r4
mov r0,r2
! Opcodes C790 - C797
W790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7133
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7133:
jmp @r4
mov r0,r2
! Opcodes C798 - C79F
W798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7134
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7134:
jmp @r4
mov r0,r2
! Opcodes C7A0 - C7A7
W7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7135
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7135:
jmp @r4
mov r0,r2
! Opcodes C7A8 - C7AF
W7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7136
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7136:
jmp @r4
mov r0,r2
! Opcodes C7B0 - C7B7
W7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7137
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7137:
jmp @r4
mov r0,r2
! Opcode C7B8
W7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7138
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7138:
jmp @r4
mov r0,r2
! Opcode C7B9
W7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7139
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7139:
jmp @r4
mov r0,r2
! Opcodes C7C0 - C7C7
W7C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7140:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7140
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7141
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7141:
jmp @r4
mov r0,r2
! Opcodes C7D0 - C7D7
W7D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7142:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7142
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7143
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7143:
jmp @r4
mov r0,r2
! Opcodes C7D8 - C7DF
W7D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7144:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7144
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7145
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7145:
jmp @r4
mov r0,r2
! Opcodes C7E0 - C7E7
W7E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7146:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7146
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7147
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7147:
jmp @r4
mov r0,r2
! Opcodes C7E8 - C7EF
W7E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7148:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7148
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7149
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7149:
jmp @r4
mov r0,r2
! Opcodes C7F0 - C7F7
W7F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7150:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7150
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7151
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7151:
jmp @r4
mov r0,r2
! Opcode C7F8
W7F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7152:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7152
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7153
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7153:
jmp @r4
mov r0,r2
! Opcode C7F9
W7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7154:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7154
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7155
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7155:
jmp @r4
mov r0,r2
! Opcode C7FA
W7FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7156:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7156
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7157
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7157:
jmp @r4
mov r0,r2
! Opcode C7FB
W7FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7158:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7158
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7159
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7159:
jmp @r4
mov r0,r2
! Opcode C7FC
W7FC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7160:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7160
sub r0,r7
sub r0,r7
mov #12,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(12,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7161
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7161:
jmp @r4
mov r0,r2
! Opcodes C800 - C807
W800:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7162
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7162:
jmp @r4
mov r0,r2
! Opcodes C810 - C817
W810:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7163
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7163:
jmp @r4
mov r0,r2
! Opcodes C818 - C81F
W818:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7164
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7164:
jmp @r4
mov r0,r2
! Opcodes C820 - C827
W820:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7165
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7165:
jmp @r4
mov r0,r2
! Opcodes C828 - C82F
W828:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7166
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7166:
jmp @r4
mov r0,r2
! Opcodes C830 - C837
W830:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7167
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7167:
jmp @r4
mov r0,r2
! Opcode C838
W838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7168
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7168:
jmp @r4
mov r0,r2
! Opcode C839
W839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7169
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7169:
jmp @r4
mov r0,r2
! Opcode C83A
W83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7170
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7170:
jmp @r4
mov r0,r2
! Opcode C83B
W83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7171
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7171:
jmp @r4
mov r0,r2
! Opcode C83C
W83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov #16,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7172
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7172:
jmp @r4
mov r0,r2
! Opcodes C840 - C847
W840:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7173
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7173:
jmp @r4
mov r0,r2
! Opcodes C850 - C857
W850:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7174
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7174:
jmp @r4
mov r0,r2
! Opcodes C858 - C85F
W858:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7175
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7175:
jmp @r4
mov r0,r2
! Opcodes C860 - C867
W860:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7176
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7176:
jmp @r4
mov r0,r2
! Opcodes C868 - C86F
W868:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7177
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7177:
jmp @r4
mov r0,r2
! Opcodes C870 - C877
W870:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7178
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7178:
jmp @r4
mov r0,r2
! Opcode C878
W878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7179
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7179:
jmp @r4
mov r0,r2
! Opcode C879
W879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7180
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7180:
jmp @r4
mov r0,r2
! Opcode C87A
W87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7181
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7181:
jmp @r4
mov r0,r2
! Opcode C87B
W87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7182
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7182:
jmp @r4
mov r0,r2
! Opcode C87C
W87C:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov #16,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7183
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7183:
jmp @r4
mov r0,r2
! Opcodes C880 - C887
W880:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7184
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7184:
jmp @r4
mov r0,r2
! Opcodes C890 - C897
W890:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7185
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7185:
jmp @r4
mov r0,r2
! Opcodes C898 - C89F
W898:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7186
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7186:
jmp @r4
mov r0,r2
! Opcodes C8A0 - C8A7
W8A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7187
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7187:
jmp @r4
mov r0,r2
! Opcodes C8A8 - C8AF
W8A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7188
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7188:
jmp @r4
mov r0,r2
! Opcodes C8B0 - C8B7
W8B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7189
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7189:
jmp @r4
mov r0,r2
! Opcode C8B8
W8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7190
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7190:
jmp @r4
mov r0,r2
! Opcode C8B9
W8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7191
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7191:
jmp @r4
mov r0,r2
! Opcode C8BA
W8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7192
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7192:
jmp @r4
mov r0,r2
! Opcode C8BB
W8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7193
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7193:
jmp @r4
mov r0,r2
! Opcode C8BC
W8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(16,r13),r1
and r1,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7194
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7194:
jmp @r4
mov r0,r2
! Opcodes C8C0 - C8C7
W8C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7195:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7195
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7196
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7196:
jmp @r4
mov r0,r2
! Opcodes C8D0 - C8D7
W8D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7197:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7197
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7198
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7198:
jmp @r4
mov r0,r2
! Opcodes C8D8 - C8DF
W8D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7199:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7199
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7200
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7200:
jmp @r4
mov r0,r2
! Opcodes C8E0 - C8E7
W8E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7201:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7201
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7202
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7202:
jmp @r4
mov r0,r2
! Opcodes C8E8 - C8EF
W8E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7203:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7203
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7204
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7204:
jmp @r4
mov r0,r2
! Opcodes C8F0 - C8F7
W8F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7205:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7205
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7206
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7206:
jmp @r4
mov r0,r2
! Opcode C8F8
W8F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7207:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7207
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7208
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7208:
jmp @r4
mov r0,r2
! Opcode C8F9
W8F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7209:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7209
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7210
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7210:
jmp @r4
mov r0,r2
! Opcode C8FA
W8FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7211:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7211
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7212
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7212:
jmp @r4
mov r0,r2
! Opcode C8FB
W8FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7213:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7213
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7214
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7214:
jmp @r4
mov r0,r2
! Opcode C8FC
W8FC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7215:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7215
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7216
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7216:
jmp @r4
mov r0,r2
! Opcodes C900 - C907
W900:
and r1,r2
mov r3,r4
mov #16,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7217
add #6,r8
.nonibadd7217:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7217
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7217:
exts.b r3,r3
mov r9,r8
mov #16,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7218
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7218:
jmp @r4
mov r0,r2
! Opcodes C908 - C90F
W908:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(48,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7219
add #6,r8
.nonibadd7219:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7219
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7219:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7220
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7220:
jmp @r4
mov r0,r2
! Opcodes C910 - C917
W910:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7221
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7221:
jmp @r4
mov r0,r2
! Opcodes C918 - C91F
W918:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7222
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7222:
jmp @r4
mov r0,r2
! Opcodes C920 - C927
W920:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7223
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7223:
jmp @r4
mov r0,r2
! Opcodes C928 - C92F
W928:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7224
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7224:
jmp @r4
mov r0,r2
! Opcodes C930 - C937
W930:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7225
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7225:
jmp @r4
mov r0,r2
! Opcode C938
W938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7226
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7226:
jmp @r4
mov r0,r2
! Opcode C939
W939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7227
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7227:
jmp @r4
mov r0,r2
! Opcodes C940 - C947
W940:
and r1,r2
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(16,r13),r3
mov.l r3,@r2
mov.l r1,@(16,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7228
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7228:
jmp @r4
mov r0,r2
! Opcodes C948 - C94F
W948:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(48,r13),r3
mov.l r3,@r2
mov.l r1,@(48,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7229
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7229:
jmp @r4
mov r0,r2
! Opcodes C950 - C957
W950:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7230
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7230:
jmp @r4
mov r0,r2
! Opcodes C958 - C95F
W958:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7231
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7231:
jmp @r4
mov r0,r2
! Opcodes C960 - C967
W960:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7232
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7232:
jmp @r4
mov r0,r2
! Opcodes C968 - C96F
W968:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7233
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7233:
jmp @r4
mov r0,r2
! Opcodes C970 - C977
W970:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7234
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7234:
jmp @r4
mov r0,r2
! Opcode C978
W978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7235
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7235:
jmp @r4
mov r0,r2
! Opcode C979
W979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7236
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7236:
jmp @r4
mov r0,r2
! Opcodes C988 - C98F
W988:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(16,r13),r3
mov.l r3,@r2
mov.l r1,@(16,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7237
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7237:
jmp @r4
mov r0,r2
! Opcodes C990 - C997
W990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7238
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7238:
jmp @r4
mov r0,r2
! Opcodes C998 - C99F
W998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7239
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7239:
jmp @r4
mov r0,r2
! Opcodes C9A0 - C9A7
W9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7240
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7240:
jmp @r4
mov r0,r2
! Opcodes C9A8 - C9AF
W9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7241
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7241:
jmp @r4
mov r0,r2
! Opcodes C9B0 - C9B7
W9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7242
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7242:
jmp @r4
mov r0,r2
! Opcode C9B8
W9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7243
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7243:
jmp @r4
mov r0,r2
! Opcode C9B9
W9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7244
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7244:
jmp @r4
mov r0,r2
! Opcodes C9C0 - C9C7
W9C0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7245:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7245
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7246
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7246:
jmp @r4
mov r0,r2
! Opcodes C9D0 - C9D7
W9D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7247:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7247
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7248
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7248:
jmp @r4
mov r0,r2
! Opcodes C9D8 - C9DF
W9D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7249:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7249
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7250
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7250:
jmp @r4
mov r0,r2
! Opcodes C9E0 - C9E7
W9E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7251:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7251
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7252
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7252:
jmp @r4
mov r0,r2
! Opcodes C9E8 - C9EF
W9E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7253:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7253
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7254
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7254:
jmp @r4
mov r0,r2
! Opcodes C9F0 - C9F7
W9F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7255:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7255
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7256
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7256:
jmp @r4
mov r0,r2
! Opcode C9F8
W9F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7257:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7257
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7258
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7258:
jmp @r4
mov r0,r2
! Opcode C9F9
W9F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7259:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7259
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7260
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7260:
jmp @r4
mov r0,r2
! Opcode C9FA
W9FA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7261:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7261
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7262
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7262:
jmp @r4
mov r0,r2
! Opcode C9FB
W9FB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7263:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7263
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7264
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7264:
jmp @r4
mov r0,r2
! Opcode C9FC
W9FC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7265:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7265
sub r0,r7
sub r0,r7
mov #16,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(16,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7266
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7266:
jmp @r4
mov r0,r2
! Opcodes CA00 - CA07
WA00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7267
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7267:
jmp @r4
mov r0,r2
! Opcodes CA10 - CA17
WA10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7268
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7268:
jmp @r4
mov r0,r2
! Opcodes CA18 - CA1F
WA18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7269
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7269:
jmp @r4
mov r0,r2
! Opcodes CA20 - CA27
WA20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7270
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7270:
jmp @r4
mov r0,r2
! Opcodes CA28 - CA2F
WA28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7271
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7271:
jmp @r4
mov r0,r2
! Opcodes CA30 - CA37
WA30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7272
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7272:
jmp @r4
mov r0,r2
! Opcode CA38
WA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7273
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7273:
jmp @r4
mov r0,r2
! Opcode CA39
WA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7274
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7274:
jmp @r4
mov r0,r2
! Opcode CA3A
WA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7275
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7275:
jmp @r4
mov r0,r2
! Opcode CA3B
WA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7276
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7276:
jmp @r4
mov r0,r2
! Opcode CA3C
WA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov #20,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7277
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7277:
jmp @r4
mov r0,r2
! Opcodes CA40 - CA47
WA40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7278
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7278:
jmp @r4
mov r0,r2
! Opcodes CA50 - CA57
WA50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7279
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7279:
jmp @r4
mov r0,r2
! Opcodes CA58 - CA5F
WA58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7280
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7280:
jmp @r4
mov r0,r2
! Opcodes CA60 - CA67
WA60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7281
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7281:
jmp @r4
mov r0,r2
! Opcodes CA68 - CA6F
WA68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7282
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7282:
jmp @r4
mov r0,r2
! Opcodes CA70 - CA77
WA70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7283
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7283:
jmp @r4
mov r0,r2
! Opcode CA78
WA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7284
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7284:
jmp @r4
mov r0,r2
! Opcode CA79
WA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7285
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7285:
jmp @r4
mov r0,r2
! Opcode CA7A
WA7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7286
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7286:
jmp @r4
mov r0,r2
! Opcode CA7B
WA7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7287
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7287:
jmp @r4
mov r0,r2
! Opcode CA7C
WA7C:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov #20,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7288
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7288:
jmp @r4
mov r0,r2
! Opcodes CA80 - CA87
WA80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7289
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7289:
jmp @r4
mov r0,r2
! Opcodes CA90 - CA97
WA90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7290
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7290:
jmp @r4
mov r0,r2
! Opcodes CA98 - CA9F
WA98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7291
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7291:
jmp @r4
mov r0,r2
! Opcodes CAA0 - CAA7
WAA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7292
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7292:
jmp @r4
mov r0,r2
! Opcodes CAA8 - CAAF
WAA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7293
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7293:
jmp @r4
mov r0,r2
! Opcodes CAB0 - CAB7
WAB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7294
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7294:
jmp @r4
mov r0,r2
! Opcode CAB8
WAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7295
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7295:
jmp @r4
mov r0,r2
! Opcode CAB9
WAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7296
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7296:
jmp @r4
mov r0,r2
! Opcode CABA
WABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7297
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7297:
jmp @r4
mov r0,r2
! Opcode CABB
WABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7298
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7298:
jmp @r4
mov r0,r2
! Opcode CABC
WABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(20,r13),r1
and r1,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7299
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7299:
jmp @r4
mov r0,r2
! Opcodes CAC0 - CAC7
WAC0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7300:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7300
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7301
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7301:
jmp @r4
mov r0,r2
! Opcodes CAD0 - CAD7
WAD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7302:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7302
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7303
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7303:
jmp @r4
mov r0,r2
! Opcodes CAD8 - CADF
WAD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7304:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7304
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7305
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7305:
jmp @r4
mov r0,r2
! Opcodes CAE0 - CAE7
WAE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7306:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7306
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7307
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7307:
jmp @r4
mov r0,r2
! Opcodes CAE8 - CAEF
WAE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7308:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7308
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7309
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7309:
jmp @r4
mov r0,r2
! Opcodes CAF0 - CAF7
WAF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7310:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7310
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7311
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7311:
jmp @r4
mov r0,r2
! Opcode CAF8
WAF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7312:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7312
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7313
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7313:
jmp @r4
mov r0,r2
! Opcode CAF9
WAF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7314:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7314
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7315
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7315:
jmp @r4
mov r0,r2
! Opcode CAFA
WAFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7316:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7316
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7317
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7317:
jmp @r4
mov r0,r2
! Opcode CAFB
WAFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7318:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7318
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7319
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7319:
jmp @r4
mov r0,r2
! Opcode CAFC
WAFC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7320:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7320
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7321
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7321:
jmp @r4
mov r0,r2
! Opcodes CB00 - CB07
WB00:
and r1,r2
mov r3,r4
mov #20,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7322
add #6,r8
.nonibadd7322:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7322
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7322:
exts.b r3,r3
mov r9,r8
mov #20,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7323
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7323:
jmp @r4
mov r0,r2
! Opcodes CB08 - CB0F
WB08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(52,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7324
add #6,r8
.nonibadd7324:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7324
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7324:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7325
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7325:
jmp @r4
mov r0,r2
! Opcodes CB10 - CB17
WB10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7326
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7326:
jmp @r4
mov r0,r2
! Opcodes CB18 - CB1F
WB18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7327
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7327:
jmp @r4
mov r0,r2
! Opcodes CB20 - CB27
WB20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7328
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7328:
jmp @r4
mov r0,r2
! Opcodes CB28 - CB2F
WB28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7329
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7329:
jmp @r4
mov r0,r2
! Opcodes CB30 - CB37
WB30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7330
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7330:
jmp @r4
mov r0,r2
! Opcode CB38
WB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7331
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7331:
jmp @r4
mov r0,r2
! Opcode CB39
WB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7332
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7332:
jmp @r4
mov r0,r2
! Opcodes CB40 - CB47
WB40:
and r1,r2
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(20,r13),r3
mov.l r3,@r2
mov.l r1,@(20,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7333
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7333:
jmp @r4
mov r0,r2
! Opcodes CB48 - CB4F
WB48:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(52,r13),r3
mov.l r3,@r2
mov.l r1,@(52,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7334
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7334:
jmp @r4
mov r0,r2
! Opcodes CB50 - CB57
WB50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7335
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7335:
jmp @r4
mov r0,r2
! Opcodes CB58 - CB5F
WB58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7336
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7336:
jmp @r4
mov r0,r2
! Opcodes CB60 - CB67
WB60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7337
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7337:
jmp @r4
mov r0,r2
! Opcodes CB68 - CB6F
WB68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7338
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7338:
jmp @r4
mov r0,r2
! Opcodes CB70 - CB77
WB70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7339
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7339:
jmp @r4
mov r0,r2
! Opcode CB78
WB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7340
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7340:
jmp @r4
mov r0,r2
! Opcode CB79
WB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7341
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7341:
jmp @r4
mov r0,r2
! Opcodes CB88 - CB8F
WB88:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(20,r13),r3
mov.l r3,@r2
mov.l r1,@(20,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7342
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7342:
jmp @r4
mov r0,r2
! Opcodes CB90 - CB97
WB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7343
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7343:
jmp @r4
mov r0,r2
! Opcodes CB98 - CB9F
WB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7344
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7344:
jmp @r4
mov r0,r2
! Opcodes CBA0 - CBA7
WBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7345
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7345:
jmp @r4
mov r0,r2
! Opcodes CBA8 - CBAF
WBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7346
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7346:
jmp @r4
mov r0,r2
! Opcodes CBB0 - CBB7
WBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7347
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7347:
jmp @r4
mov r0,r2
! Opcode CBB8
WBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7348
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7348:
jmp @r4
mov r0,r2
! Opcode CBB9
WBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7349
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7349:
jmp @r4
mov r0,r2
! Opcodes CBC0 - CBC7
WBC0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7350:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7350
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7351
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7351:
jmp @r4
mov r0,r2
! Opcodes CBD0 - CBD7
WBD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7352:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7352
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7353
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7353:
jmp @r4
mov r0,r2
! Opcodes CBD8 - CBDF
WBD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7354:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7354
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7355
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7355:
jmp @r4
mov r0,r2
! Opcodes CBE0 - CBE7
WBE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7356:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7356
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7357
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7357:
jmp @r4
mov r0,r2
! Opcodes CBE8 - CBEF
WBE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7358:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7358
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7359
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7359:
jmp @r4
mov r0,r2
! Opcodes CBF0 - CBF7
WBF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7360:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7360
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7361
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7361:
jmp @r4
mov r0,r2
! Opcode CBF8
WBF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7362:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7362
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7363
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7363:
jmp @r4
mov r0,r2
! Opcode CBF9
WBF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7364:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7364
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7365
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7365:
jmp @r4
mov r0,r2
! Opcode CBFA
WBFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7366:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7366
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7367
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7367:
jmp @r4
mov r0,r2
! Opcode CBFB
WBFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7368:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7368
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7369
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7369:
jmp @r4
mov r0,r2
! Opcode CBFC
WBFC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7370:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7370
sub r0,r7
sub r0,r7
mov #20,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(20,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7371
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7371:
jmp @r4
mov r0,r2
! Opcodes CC00 - CC07
WC00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7372
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7372:
jmp @r4
mov r0,r2
! Opcodes CC10 - CC17
WC10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7373
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7373:
jmp @r4
mov r0,r2
! Opcodes CC18 - CC1F
WC18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7374
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7374:
jmp @r4
mov r0,r2
! Opcodes CC20 - CC27
WC20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7375
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7375:
jmp @r4
mov r0,r2
! Opcodes CC28 - CC2F
WC28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7376
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7376:
jmp @r4
mov r0,r2
! Opcodes CC30 - CC37
WC30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7377
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7377:
jmp @r4
mov r0,r2
! Opcode CC38
WC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7378
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7378:
jmp @r4
mov r0,r2
! Opcode CC39
WC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7379
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7379:
jmp @r4
mov r0,r2
! Opcode CC3A
WC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7380
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7380:
jmp @r4
mov r0,r2
! Opcode CC3B
WC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7381
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7381:
jmp @r4
mov r0,r2
! Opcode CC3C
WC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov #24,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7382
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7382:
jmp @r4
mov r0,r2
! Opcodes CC40 - CC47
WC40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7383
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7383:
jmp @r4
mov r0,r2
! Opcodes CC50 - CC57
WC50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7384
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7384:
jmp @r4
mov r0,r2
! Opcodes CC58 - CC5F
WC58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7385
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7385:
jmp @r4
mov r0,r2
! Opcodes CC60 - CC67
WC60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7386
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7386:
jmp @r4
mov r0,r2
! Opcodes CC68 - CC6F
WC68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7387
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7387:
jmp @r4
mov r0,r2
! Opcodes CC70 - CC77
WC70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7388
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7388:
jmp @r4
mov r0,r2
! Opcode CC78
WC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7389
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7389:
jmp @r4
mov r0,r2
! Opcode CC79
WC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7390
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7390:
jmp @r4
mov r0,r2
! Opcode CC7A
WC7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7391
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7391:
jmp @r4
mov r0,r2
! Opcode CC7B
WC7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7392
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7392:
jmp @r4
mov r0,r2
! Opcode CC7C
WC7C:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov #24,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7393
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7393:
jmp @r4
mov r0,r2
! Opcodes CC80 - CC87
WC80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7394
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7394:
jmp @r4
mov r0,r2
! Opcodes CC90 - CC97
WC90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7395
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7395:
jmp @r4
mov r0,r2
! Opcodes CC98 - CC9F
WC98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7396
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7396:
jmp @r4
mov r0,r2
! Opcodes CCA0 - CCA7
WCA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7397
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7397:
jmp @r4
mov r0,r2
! Opcodes CCA8 - CCAF
WCA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7398
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7398:
jmp @r4
mov r0,r2
! Opcodes CCB0 - CCB7
WCB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7399
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7399:
jmp @r4
mov r0,r2
! Opcode CCB8
WCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7400
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7400:
jmp @r4
mov r0,r2
! Opcode CCB9
WCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7401
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7401:
jmp @r4
mov r0,r2
! Opcode CCBA
WCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7402
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7402:
jmp @r4
mov r0,r2
! Opcode CCBB
WCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7403
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7403:
jmp @r4
mov r0,r2
! Opcode CCBC
WCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(24,r13),r1
and r1,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7404
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7404:
jmp @r4
mov r0,r2
! Opcodes CCC0 - CCC7
WCC0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7405:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7405
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7406
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7406:
jmp @r4
mov r0,r2
! Opcodes CCD0 - CCD7
WCD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7407:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7407
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7408
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7408:
jmp @r4
mov r0,r2
! Opcodes CCD8 - CCDF
WCD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7409:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7409
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7410
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7410:
jmp @r4
mov r0,r2
! Opcodes CCE0 - CCE7
WCE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7411:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7411
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7412
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7412:
jmp @r4
mov r0,r2
! Opcodes CCE8 - CCEF
WCE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7413:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7413
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7414
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7414:
jmp @r4
mov r0,r2
! Opcodes CCF0 - CCF7
WCF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7415:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7415
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7416
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7416:
jmp @r4
mov r0,r2
! Opcode CCF8
WCF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7417:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7417
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7418
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7418:
jmp @r4
mov r0,r2
! Opcode CCF9
WCF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7419:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7419
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7420
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7420:
jmp @r4
mov r0,r2
! Opcode CCFA
WCFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7421:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7421
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7422
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7422:
jmp @r4
mov r0,r2
! Opcode CCFB
WCFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7423:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7423
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7424
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7424:
jmp @r4
mov r0,r2
! Opcode CCFC
WCFC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7425:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7425
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7426
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7426:
jmp @r4
mov r0,r2
! Opcodes CD00 - CD07
WD00:
and r1,r2
mov r3,r4
mov #24,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7427
add #6,r8
.nonibadd7427:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7427
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7427:
exts.b r3,r3
mov r9,r8
mov #24,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7428
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7428:
jmp @r4
mov r0,r2
! Opcodes CD08 - CD0F
WD08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(56,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7429
add #6,r8
.nonibadd7429:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7429
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7429:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7430
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7430:
jmp @r4
mov r0,r2
! Opcodes CD10 - CD17
WD10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7431
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7431:
jmp @r4
mov r0,r2
! Opcodes CD18 - CD1F
WD18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7432
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7432:
jmp @r4
mov r0,r2
! Opcodes CD20 - CD27
WD20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7433
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7433:
jmp @r4
mov r0,r2
! Opcodes CD28 - CD2F
WD28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7434
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7434:
jmp @r4
mov r0,r2
! Opcodes CD30 - CD37
WD30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7435
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7435:
jmp @r4
mov r0,r2
! Opcode CD38
WD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7436
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7436:
jmp @r4
mov r0,r2
! Opcode CD39
WD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7437
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7437:
jmp @r4
mov r0,r2
! Opcodes CD40 - CD47
WD40:
and r1,r2
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(24,r13),r3
mov.l r3,@r2
mov.l r1,@(24,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7438
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7438:
jmp @r4
mov r0,r2
! Opcodes CD48 - CD4F
WD48:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(56,r13),r3
mov.l r3,@r2
mov.l r1,@(56,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7439
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7439:
jmp @r4
mov r0,r2
! Opcodes CD50 - CD57
WD50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7440
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7440:
jmp @r4
mov r0,r2
! Opcodes CD58 - CD5F
WD58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7441
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7441:
jmp @r4
mov r0,r2
! Opcodes CD60 - CD67
WD60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7442
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7442:
jmp @r4
mov r0,r2
! Opcodes CD68 - CD6F
WD68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7443
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7443:
jmp @r4
mov r0,r2
! Opcodes CD70 - CD77
WD70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7444
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7444:
jmp @r4
mov r0,r2
! Opcode CD78
WD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7445
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7445:
jmp @r4
mov r0,r2
! Opcode CD79
WD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7446
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7446:
jmp @r4
mov r0,r2
! Opcodes CD88 - CD8F
WD88:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(24,r13),r3
mov.l r3,@r2
mov.l r1,@(24,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7447
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7447:
jmp @r4
mov r0,r2
! Opcodes CD90 - CD97
WD90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7448
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7448:
jmp @r4
mov r0,r2
! Opcodes CD98 - CD9F
WD98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7449
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7449:
jmp @r4
mov r0,r2
! Opcodes CDA0 - CDA7
WDA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7450
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7450:
jmp @r4
mov r0,r2
! Opcodes CDA8 - CDAF
WDA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7451
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7451:
jmp @r4
mov r0,r2
! Opcodes CDB0 - CDB7
WDB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7452
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7452:
jmp @r4
mov r0,r2
! Opcode CDB8
WDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7453
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7453:
jmp @r4
mov r0,r2
! Opcode CDB9
WDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7454
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7454:
jmp @r4
mov r0,r2
! Opcodes CDC0 - CDC7
WDC0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7455:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7455
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7456
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7456:
jmp @r4
mov r0,r2
! Opcodes CDD0 - CDD7
WDD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7457:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7457
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7458
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7458:
jmp @r4
mov r0,r2
! Opcodes CDD8 - CDDF
WDD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7459:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7459
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7460
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7460:
jmp @r4
mov r0,r2
! Opcodes CDE0 - CDE7
WDE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7461:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7461
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7462
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7462:
jmp @r4
mov r0,r2
! Opcodes CDE8 - CDEF
WDE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7463:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7463
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7464
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7464:
jmp @r4
mov r0,r2
! Opcodes CDF0 - CDF7
WDF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7465:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7465
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7466
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7466:
jmp @r4
mov r0,r2
! Opcode CDF8
WDF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7467:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7467
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7468
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7468:
jmp @r4
mov r0,r2
! Opcode CDF9
WDF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7469:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7469
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7470
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7470:
jmp @r4
mov r0,r2
! Opcode CDFA
WDFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7471:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7471
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7472
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7472:
jmp @r4
mov r0,r2
! Opcode CDFB
WDFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7473:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7473
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7474
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7474:
jmp @r4
mov r0,r2
! Opcode CDFC
WDFC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7475:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7475
sub r0,r7
sub r0,r7
mov #24,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(24,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7476
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7476:
jmp @r4
mov r0,r2
! Opcodes CE00 - CE07
WE00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7477
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7477:
jmp @r4
mov r0,r2
! Opcodes CE10 - CE17
WE10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7478
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7478:
jmp @r4
mov r0,r2
! Opcodes CE18 - CE1F
WE18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7479
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7479:
jmp @r4
mov r0,r2
! Opcodes CE20 - CE27
WE20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7480
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7480:
jmp @r4
mov r0,r2
! Opcodes CE28 - CE2F
WE28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7481
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7481:
jmp @r4
mov r0,r2
! Opcodes CE30 - CE37
WE30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7482
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7482:
jmp @r4
mov r0,r2
! Opcode CE38
WE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7483
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7483:
jmp @r4
mov r0,r2
! Opcode CE39
WE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7484
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7484:
jmp @r4
mov r0,r2
! Opcode CE3A
WE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7485
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7485:
jmp @r4
mov r0,r2
! Opcode CE3B
WE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7486
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7486:
jmp @r4
mov r0,r2
! Opcode CE3C
WE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov #28,r0
mov.b r3,@(r0,r13)
exts.b r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7487
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7487:
jmp @r4
mov r0,r2
! Opcodes CE40 - CE47
WE40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7488
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7488:
jmp @r4
mov r0,r2
! Opcodes CE50 - CE57
WE50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7489
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7489:
jmp @r4
mov r0,r2
! Opcodes CE58 - CE5F
WE58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7490
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7490:
jmp @r4
mov r0,r2
! Opcodes CE60 - CE67
WE60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7491
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7491:
jmp @r4
mov r0,r2
! Opcodes CE68 - CE6F
WE68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7492
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7492:
jmp @r4
mov r0,r2
! Opcodes CE70 - CE77
WE70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7493
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7493:
jmp @r4
mov r0,r2
! Opcode CE78
WE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7494
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7494:
jmp @r4
mov r0,r2
! Opcode CE79
WE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7495
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7495:
jmp @r4
mov r0,r2
! Opcode CE7A
WE7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7496
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7496:
jmp @r4
mov r0,r2
! Opcode CE7B
WE7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7497
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7497:
jmp @r4
mov r0,r2
! Opcode CE7C
WE7C:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov #28,r0
mov.w r3,@(r0,r13)
exts.w r3,r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7498
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7498:
jmp @r4
mov r0,r2
! Opcodes CE80 - CE87
WE80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7499
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7499:
jmp @r4
mov r0,r2
! Opcodes CE90 - CE97
WE90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7500
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7500:
jmp @r4
mov r0,r2
! Opcodes CE98 - CE9F
WE98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7501
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7501:
jmp @r4
mov r0,r2
! Opcodes CEA0 - CEA7
WEA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7502
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7502:
jmp @r4
mov r0,r2
! Opcodes CEA8 - CEAF
WEA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7503
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7503:
jmp @r4
mov r0,r2
! Opcodes CEB0 - CEB7
WEB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7504
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7504:
jmp @r4
mov r0,r2
! Opcode CEB8
WEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7505
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7505:
jmp @r4
mov r0,r2
! Opcode CEB9
WEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7506
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7506:
jmp @r4
mov r0,r2
! Opcode CEBA
WEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7507
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7507:
jmp @r4
mov r0,r2
! Opcode CEBB
WEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7508
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7508:
jmp @r4
mov r0,r2
! Opcode CEBC
WEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(28,r13),r1
and r1,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7509
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7509:
jmp @r4
mov r0,r2
! Opcodes CEC0 - CEC7
WEC0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7510:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7510
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7511
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7511:
jmp @r4
mov r0,r2
! Opcodes CED0 - CED7
WED0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7512:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7512
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7513
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7513:
jmp @r4
mov r0,r2
! Opcodes CED8 - CEDF
WED8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7514:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7514
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7515
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7515:
jmp @r4
mov r0,r2
! Opcodes CEE0 - CEE7
WEE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7516:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7516
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7517
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7517:
jmp @r4
mov r0,r2
! Opcodes CEE8 - CEEF
WEE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7518:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7518
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7519
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7519:
jmp @r4
mov r0,r2
! Opcodes CEF0 - CEF7
WEF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7520:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7520
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7521
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7521:
jmp @r4
mov r0,r2
! Opcode CEF8
WEF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7522:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7522
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7523
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7523:
jmp @r4
mov r0,r2
! Opcode CEF9
WEF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7524:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7524
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7525
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7525:
jmp @r4
mov r0,r2
! Opcode CEFA
WEFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7526:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7526
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7527
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7527:
jmp @r4
mov r0,r2
! Opcode CEFB
WEFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7528:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7528
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7529
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7529:
jmp @r4
mov r0,r2
! Opcode CEFC
WEFC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
extu.w r1,r1
ln7530:
shlr r1
addc r4,r0
cmp/pl r1
bt ln7530
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
mulu.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7531
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7531:
jmp @r4
mov r0,r2
! Opcodes CF00 - CF07
WF00:
and r1,r2
mov r3,r4
mov #28,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7532
add #6,r8
.nonibadd7532:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7532
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7532:
exts.b r3,r3
mov r9,r8
mov #28,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7533
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7533:
jmp @r4
mov r0,r2
! Opcodes CF08 - CF0F
WF08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l r3,@-r15
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r15+,r1
mov #0x0F,r0
and r1,r0
mov #0x0F,r8
and r3,r8
cmp/pl r9
addc r0,r8
mov #9,r0
cmp/hi r0,r8
bf .nonibadd7534
add #6,r8
.nonibadd7534:
mov r3,r0
and #0xF0,r0
mov r0,r3
mov r1,r0
and #0xF0,r0
add r0,r3
add r8,r3
mov #0x99,r0
extu.b r0,r0
cmp/hi r0,r3
movt r9
bf .endop7534
mov #0xA0,r0
extu.b r0,r0
sub r0,r3
.endop7534:
exts.b r3,r3
mov r9,r8
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7535
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7535:
jmp @r4
mov r0,r2
! Opcodes CF10 - CF17
WF10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7536
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7536:
jmp @r4
mov r0,r2
! Opcodes CF18 - CF1F
WF18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7537
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7537:
jmp @r4
mov r0,r2
! Opcodes CF20 - CF27
WF20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7538
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7538:
jmp @r4
mov r0,r2
! Opcodes CF28 - CF2F
WF28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7539
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7539:
jmp @r4
mov r0,r2
! Opcodes CF30 - CF37
WF30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7540
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7540:
jmp @r4
mov r0,r2
! Opcode CF38
WF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7541
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7541:
jmp @r4
mov r0,r2
! Opcode CF39
WF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
and r1,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7542
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7542:
jmp @r4
mov r0,r2
! Opcodes CF40 - CF47
WF40:
and r1,r2
mov r3,r4
add r13,r2
mov.l @r2,r1
mov.l @(28,r13),r3
mov.l r3,@r2
mov.l r1,@(28,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7543
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7543:
jmp @r4
mov r0,r2
! Opcodes CF48 - CF4F
WF48:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(60,r13),r3
mov.l r3,@r2
mov.l r1,@(60,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7544
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7544:
jmp @r4
mov r0,r2
! Opcodes CF50 - CF57
WF50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7545
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7545:
jmp @r4
mov r0,r2
! Opcodes CF58 - CF5F
WF58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7546
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7546:
jmp @r4
mov r0,r2
! Opcodes CF60 - CF67
WF60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7547
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7547:
jmp @r4
mov r0,r2
! Opcodes CF68 - CF6F
WF68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7548
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7548:
jmp @r4
mov r0,r2
! Opcodes CF70 - CF77
WF70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7549
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7549:
jmp @r4
mov r0,r2
! Opcode CF78
WF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7550
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7550:
jmp @r4
mov r0,r2
! Opcode CF79
WF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
and r1,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7551
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7551:
jmp @r4
mov r0,r2
! Opcodes CF88 - CF8F
WF88:
and r1,r2
mov r3,r4
add r14,r2
mov.l @r2,r1
mov.l @(28,r13),r3
mov.l r3,@r2
mov.l r1,@(28,r13)
mov r4,r3
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7552
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7552:
jmp @r4
mov r0,r2
! Opcodes CF90 - CF97
WF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7553
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7553:
jmp @r4
mov r0,r2
! Opcodes CF98 - CF9F
WF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7554
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7554:
jmp @r4
mov r0,r2
! Opcodes CFA0 - CFA7
WFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
movt r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7555
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7555:
jmp @r4
mov r0,r2
! Opcodes CFA8 - CFAF
WFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7556
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7556:
jmp @r4
mov r0,r2
! Opcodes CFB0 - CFB7
WFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7557
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7557:
jmp @r4
mov r0,r2
! Opcode CFB8
WFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7558
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7558:
jmp @r4
mov r0,r2
! Opcode CFB9
WFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
and r1,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7559
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7559:
jmp @r4
mov r0,r2
! Opcodes CFC0 - CFC7
WFC0:
and r1,r2
mov r2,r0
mov.w @(r0,r13),r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7560:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7560
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-38,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7561
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7561:
jmp @r4
mov r0,r2
! Opcodes CFD0 - CFD7
WFD0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7562:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7562
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7563
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7563:
jmp @r4
mov r0,r2
! Opcodes CFD8 - CFDF
WFD8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7564:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7564
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7565
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7565:
jmp @r4
mov r0,r2
! Opcodes CFE0 - CFE7
WFE0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7566:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7566
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-44,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7567
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7567:
jmp @r4
mov r0,r2
! Opcodes CFE8 - CFEF
WFE8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7568:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7568
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7569
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7569:
jmp @r4
mov r0,r2
! Opcodes CFF0 - CFF7
WFF0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7570:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7570
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7571
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7571:
jmp @r4
mov r0,r2
! Opcode CFF8
WFF8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7572:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7572
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7573
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7573:
jmp @r4
mov r0,r2
! Opcode CFF9
WFF9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7574:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7574
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-50,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7575
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7575:
jmp @r4
mov r0,r2
! Opcode CFFA
WFFA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7576:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7576
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-46,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7577
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7577:
jmp @r4
mov r0,r2
! Opcode CFFB
WFFB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7578:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7578
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-48,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7579
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7579:
jmp @r4
mov r0,r2
! Opcode CFFC
WFFC:
mov.w @r6+,r3
mov #0,r0
mov r3,r1
mov r0,r4
mov r0,r2
mov #16,r8
ln7580:
shlr r1
movt r2
xor r2,r4
and r8,r4
add r4,r0
movt r4
dt r8
bf ln7580
sub r0,r7
sub r0,r7
mov #28,r0
mov.w @(r0,r13),r1
muls.w r1,r3
sts macl,r3
mov.l r3,@(28,r13)
rotl r3
movt r8
mov.w @r6+,r0
add #-42,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7581
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7581:
jmp @r4
mov r0,r2
! Opcodes D000 - D007
X000:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7582
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7582:
jmp @r4
mov r0,r2
! Opcodes D008 - D00F
X008:
and r1,r2
add r13,r2
mov.b @r2,r3
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7583
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7583:
jmp @r4
mov r0,r2
! Opcodes D010 - D017
X010:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7584
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7584:
jmp @r4
mov r0,r2
! Opcodes D018 - D01F
X018:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7585
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7585:
jmp @r4
mov r0,r2
! Opcodes D020 - D027
X020:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7586
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7586:
jmp @r4
mov r0,r2
! Opcodes D028 - D02F
X028:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7587
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7587:
jmp @r4
mov r0,r2
! Opcodes D030 - D037
X030:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7588
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7588:
jmp @r4
mov r0,r2
! Opcode D038
X038:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7589
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7589:
jmp @r4
mov r0,r2
! Opcode D039
X039:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7590
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7590:
jmp @r4
mov r0,r2
! Opcode D03A
X03A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7591
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7591:
jmp @r4
mov r0,r2
! Opcode D03B
X03B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7592
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7592:
jmp @r4
mov r0,r2
! Opcode D03C
X03C:
mov.b @r6,r3
add #2,r6
mov.b @r13,r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov.b r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7593
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7593:
jmp @r4
mov r0,r2
! Opcodes D040 - D047
X040:
and r1,r2
add r13,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7594
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7594:
jmp @r4
mov r0,r2
! Opcodes D048 - D04F
X048:
and r1,r2
add r14,r2
mov.w @r2,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7595
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7595:
jmp @r4
mov r0,r2
! Opcodes D050 - D057
X050:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7596
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7596:
jmp @r4
mov r0,r2
! Opcodes D058 - D05F
X058:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7597
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7597:
jmp @r4
mov r0,r2
! Opcodes D060 - D067
X060:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7598
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7598:
jmp @r4
mov r0,r2
! Opcodes D068 - D06F
X068:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7599
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7599:
jmp @r4
mov r0,r2
! Opcodes D070 - D077
X070:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7600
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7600:
jmp @r4
mov r0,r2
! Opcode D078
X078:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7601
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7601:
jmp @r4
mov r0,r2
! Opcode D079
X079:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7602
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7602:
jmp @r4
mov r0,r2
! Opcode D07A
X07A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7603
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7603:
jmp @r4
mov r0,r2
! Opcode D07B
X07B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7604
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7604:
jmp @r4
mov r0,r2
! Opcode D07C
X07C:
mov.w @r6+,r3
mov.w @r13,r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov.w r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7605
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7605:
jmp @r4
mov r0,r2
! Opcodes D080 - D087
X080:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7606
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7606:
jmp @r4
mov r0,r2
! Opcodes D088 - D08F
X088:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7607
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7607:
jmp @r4
mov r0,r2
! Opcodes D090 - D097
X090:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7608
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7608:
jmp @r4
mov r0,r2
! Opcodes D098 - D09F
X098:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7609
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7609:
jmp @r4
mov r0,r2
! Opcodes D0A0 - D0A7
X0A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7610
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7610:
jmp @r4
mov r0,r2
! Opcodes D0A8 - D0AF
X0A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7611
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7611:
jmp @r4
mov r0,r2
! Opcodes D0B0 - D0B7
X0B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7612
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7612:
jmp @r4
mov r0,r2
! Opcode D0B8
X0B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7613
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7613:
jmp @r4
mov r0,r2
! Opcode D0B9
X0B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7614
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7614:
jmp @r4
mov r0,r2
! Opcode D0BA
X0BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7615
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7615:
jmp @r4
mov r0,r2
! Opcode D0BB
X0BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7616
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7616:
jmp @r4
mov r0,r2
! Opcode D0BC
X0BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @r13,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@r13
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7617
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7617:
jmp @r4
mov r0,r2
! Opcodes D0C0 - D0C7
X0C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7618
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7618:
jmp @r4
mov r0,r2
! Opcodes D0C8 - D0CF
X0C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7619
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7619:
jmp @r4
mov r0,r2
! Opcodes D0D0 - D0D7
X0D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7620
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7620:
jmp @r4
mov r0,r2
! Opcodes D0D8 - D0DF
X0D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7621
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7621:
jmp @r4
mov r0,r2
! Opcodes D0E0 - D0E7
X0E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7622
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7622:
jmp @r4
mov r0,r2
! Opcodes D0E8 - D0EF
X0E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7623
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7623:
jmp @r4
mov r0,r2
! Opcodes D0F0 - D0F7
X0F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7624
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7624:
jmp @r4
mov r0,r2
! Opcode D0F8
X0F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7625
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7625:
jmp @r4
mov r0,r2
! Opcode D0F9
X0F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7626
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7626:
jmp @r4
mov r0,r2
! Opcode D0FA
X0FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7627
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7627:
jmp @r4
mov r0,r2
! Opcode D0FB
X0FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7628
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7628:
jmp @r4
mov r0,r2
! Opcode D0FC
X0FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7629
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7629:
jmp @r4
mov r0,r2
! Opcodes D100 - D107
X100:
and r1,r2
mov r3,r4
mov.b @r13,r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.b r3,@r13
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7631
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7631:
jmp @r4
mov r0,r2
! Opcodes D108 - D10F
X108:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(32,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7633
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7633:
jmp @r4
mov r0,r2
! Opcodes D110 - D117
X110:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7634
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7634:
jmp @r4
mov r0,r2
! Opcodes D118 - D11F
X118:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7635
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7635:
jmp @r4
mov r0,r2
! Opcodes D120 - D127
X120:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7636
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7636:
jmp @r4
mov r0,r2
! Opcodes D128 - D12F
X128:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7637
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7637:
jmp @r4
mov r0,r2
! Opcodes D130 - D137
X130:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7638
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7638:
jmp @r4
mov r0,r2
! Opcode D138
X138:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7639
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7639:
jmp @r4
mov r0,r2
! Opcode D139
X139:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.b @r13,r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7640
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7640:
jmp @r4
mov r0,r2
! Opcodes D140 - D147
X140:
and r1,r2
mov r3,r4
mov.w @r13,r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.w r3,@r13
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7642
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7642:
jmp @r4
mov r0,r2
! Opcodes D148 - D14F
X148:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(32,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7644
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7644:
jmp @r4
mov r0,r2
! Opcodes D150 - D157
X150:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7645
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7645:
jmp @r4
mov r0,r2
! Opcodes D158 - D15F
X158:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7646
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7646:
jmp @r4
mov r0,r2
! Opcodes D160 - D167
X160:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7647
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7647:
jmp @r4
mov r0,r2
! Opcodes D168 - D16F
X168:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7648
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7648:
jmp @r4
mov r0,r2
! Opcodes D170 - D177
X170:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7649
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7649:
jmp @r4
mov r0,r2
! Opcode D178
X178:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7650
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7650:
jmp @r4
mov r0,r2
! Opcode D179
X179:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.w @r13,r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7651
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7651:
jmp @r4
mov r0,r2
! Opcodes D180 - D187
X180:
and r1,r2
mov r3,r4
mov.l @r13,r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@r13
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7653
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7653:
jmp @r4
mov r0,r2
! Opcodes D188 - D18F
X188:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(32,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(32,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7655
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7655:
jmp @r4
mov r0,r2
! Opcodes D190 - D197
X190:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7656
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7656:
jmp @r4
mov r0,r2
! Opcodes D198 - D19F
X198:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7657
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7657:
jmp @r4
mov r0,r2
! Opcodes D1A0 - D1A7
X1A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7658
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7658:
jmp @r4
mov r0,r2
! Opcodes D1A8 - D1AF
X1A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7659
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7659:
jmp @r4
mov r0,r2
! Opcodes D1B0 - D1B7
X1B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7660
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7660:
jmp @r4
mov r0,r2
! Opcode D1B8
X1B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7661
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7661:
jmp @r4
mov r0,r2
! Opcode D1B9
X1B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @r13,r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7662
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7662:
jmp @r4
mov r0,r2
! Opcodes D1C0 - D1C7
X1C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7663
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7663:
jmp @r4
mov r0,r2
! Opcodes D1C8 - D1CF
X1C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7664
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7664:
jmp @r4
mov r0,r2
! Opcodes D1D0 - D1D7
X1D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7665
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7665:
jmp @r4
mov r0,r2
! Opcodes D1D8 - D1DF
X1D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7666
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7666:
jmp @r4
mov r0,r2
! Opcodes D1E0 - D1E7
X1E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7667
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7667:
jmp @r4
mov r0,r2
! Opcodes D1E8 - D1EF
X1E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7668
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7668:
jmp @r4
mov r0,r2
! Opcodes D1F0 - D1F7
X1F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7669
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7669:
jmp @r4
mov r0,r2
! Opcode D1F8
X1F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7670
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7670:
jmp @r4
mov r0,r2
! Opcode D1F9
X1F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7671
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7671:
jmp @r4
mov r0,r2
! Opcode D1FA
X1FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7672
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7672:
jmp @r4
mov r0,r2
! Opcode D1FB
X1FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7673
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7673:
jmp @r4
mov r0,r2
! Opcode D1FC
X1FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(32,r13),r1
add r3,r1
mov.l r1,@(32,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7674
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7674:
jmp @r4
mov r0,r2
! Opcodes D200 - D207
X200:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7675
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7675:
jmp @r4
mov r0,r2
! Opcodes D208 - D20F
X208:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7676
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7676:
jmp @r4
mov r0,r2
! Opcodes D210 - D217
X210:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7677
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7677:
jmp @r4
mov r0,r2
! Opcodes D218 - D21F
X218:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7678
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7678:
jmp @r4
mov r0,r2
! Opcodes D220 - D227
X220:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7679
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7679:
jmp @r4
mov r0,r2
! Opcodes D228 - D22F
X228:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7680
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7680:
jmp @r4
mov r0,r2
! Opcodes D230 - D237
X230:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7681
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7681:
jmp @r4
mov r0,r2
! Opcode D238
X238:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7682
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7682:
jmp @r4
mov r0,r2
! Opcode D239
X239:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7683
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7683:
jmp @r4
mov r0,r2
! Opcode D23A
X23A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7684
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7684:
jmp @r4
mov r0,r2
! Opcode D23B
X23B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7685
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7685:
jmp @r4
mov r0,r2
! Opcode D23C
X23C:
mov.b @r6,r3
add #2,r6
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #4,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7686
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7686:
jmp @r4
mov r0,r2
! Opcodes D240 - D247
X240:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7687
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7687:
jmp @r4
mov r0,r2
! Opcodes D248 - D24F
X248:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7688
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7688:
jmp @r4
mov r0,r2
! Opcodes D250 - D257
X250:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7689
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7689:
jmp @r4
mov r0,r2
! Opcodes D258 - D25F
X258:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7690
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7690:
jmp @r4
mov r0,r2
! Opcodes D260 - D267
X260:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7691
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7691:
jmp @r4
mov r0,r2
! Opcodes D268 - D26F
X268:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7692
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7692:
jmp @r4
mov r0,r2
! Opcodes D270 - D277
X270:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7693
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7693:
jmp @r4
mov r0,r2
! Opcode D278
X278:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7694
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7694:
jmp @r4
mov r0,r2
! Opcode D279
X279:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7695
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7695:
jmp @r4
mov r0,r2
! Opcode D27A
X27A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7696
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7696:
jmp @r4
mov r0,r2
! Opcode D27B
X27B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7697
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7697:
jmp @r4
mov r0,r2
! Opcode D27C
X27C:
mov.w @r6+,r3
mov #4,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #4,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7698
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7698:
jmp @r4
mov r0,r2
! Opcodes D280 - D287
X280:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7699
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7699:
jmp @r4
mov r0,r2
! Opcodes D288 - D28F
X288:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7700
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7700:
jmp @r4
mov r0,r2
! Opcodes D290 - D297
X290:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7701
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7701:
jmp @r4
mov r0,r2
! Opcodes D298 - D29F
X298:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7702
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7702:
jmp @r4
mov r0,r2
! Opcodes D2A0 - D2A7
X2A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7703
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7703:
jmp @r4
mov r0,r2
! Opcodes D2A8 - D2AF
X2A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7704
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7704:
jmp @r4
mov r0,r2
! Opcodes D2B0 - D2B7
X2B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7705
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7705:
jmp @r4
mov r0,r2
! Opcode D2B8
X2B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7706
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7706:
jmp @r4
mov r0,r2
! Opcode D2B9
X2B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7707
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7707:
jmp @r4
mov r0,r2
! Opcode D2BA
X2BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7708
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7708:
jmp @r4
mov r0,r2
! Opcode D2BB
X2BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7709
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7709:
jmp @r4
mov r0,r2
! Opcode D2BC
X2BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(4,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(4,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7710
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7710:
jmp @r4
mov r0,r2
! Opcodes D2C0 - D2C7
X2C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7711
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7711:
jmp @r4
mov r0,r2
! Opcodes D2C8 - D2CF
X2C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7712
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7712:
jmp @r4
mov r0,r2
! Opcodes D2D0 - D2D7
X2D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7713
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7713:
jmp @r4
mov r0,r2
! Opcodes D2D8 - D2DF
X2D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7714
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7714:
jmp @r4
mov r0,r2
! Opcodes D2E0 - D2E7
X2E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7715
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7715:
jmp @r4
mov r0,r2
! Opcodes D2E8 - D2EF
X2E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7716
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7716:
jmp @r4
mov r0,r2
! Opcodes D2F0 - D2F7
X2F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7717
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7717:
jmp @r4
mov r0,r2
! Opcode D2F8
X2F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7718
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7718:
jmp @r4
mov r0,r2
! Opcode D2F9
X2F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7719
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7719:
jmp @r4
mov r0,r2
! Opcode D2FA
X2FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7720
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7720:
jmp @r4
mov r0,r2
! Opcode D2FB
X2FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7721
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7721:
jmp @r4
mov r0,r2
! Opcode D2FC
X2FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7722
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7722:
jmp @r4
mov r0,r2
! Opcodes D300 - D307
X300:
and r1,r2
mov r3,r4
mov #4,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #4,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7724
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7724:
jmp @r4
mov r0,r2
! Opcodes D308 - D30F
X308:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(36,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7726
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7726:
jmp @r4
mov r0,r2
! Opcodes D310 - D317
X310:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7727
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7727:
jmp @r4
mov r0,r2
! Opcodes D318 - D31F
X318:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7728
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7728:
jmp @r4
mov r0,r2
! Opcodes D320 - D327
X320:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7729
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7729:
jmp @r4
mov r0,r2
! Opcodes D328 - D32F
X328:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7730
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7730:
jmp @r4
mov r0,r2
! Opcodes D330 - D337
X330:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7731
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7731:
jmp @r4
mov r0,r2
! Opcode D338
X338:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7732
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7732:
jmp @r4
mov r0,r2
! Opcode D339
X339:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7733
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7733:
jmp @r4
mov r0,r2
! Opcodes D340 - D347
X340:
and r1,r2
mov r3,r4
mov #4,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #4,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7735
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7735:
jmp @r4
mov r0,r2
! Opcodes D348 - D34F
X348:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(36,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7737
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7737:
jmp @r4
mov r0,r2
! Opcodes D350 - D357
X350:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7738
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7738:
jmp @r4
mov r0,r2
! Opcodes D358 - D35F
X358:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7739
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7739:
jmp @r4
mov r0,r2
! Opcodes D360 - D367
X360:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7740
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7740:
jmp @r4
mov r0,r2
! Opcodes D368 - D36F
X368:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7741
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7741:
jmp @r4
mov r0,r2
! Opcodes D370 - D377
X370:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7742
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7742:
jmp @r4
mov r0,r2
! Opcode D378
X378:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7743
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7743:
jmp @r4
mov r0,r2
! Opcode D379
X379:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #4,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7744
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7744:
jmp @r4
mov r0,r2
! Opcodes D380 - D387
X380:
and r1,r2
mov r3,r4
mov.l @(4,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(4,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7746
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7746:
jmp @r4
mov r0,r2
! Opcodes D388 - D38F
X388:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(36,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(36,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7748
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7748:
jmp @r4
mov r0,r2
! Opcodes D390 - D397
X390:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7749
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7749:
jmp @r4
mov r0,r2
! Opcodes D398 - D39F
X398:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7750
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7750:
jmp @r4
mov r0,r2
! Opcodes D3A0 - D3A7
X3A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7751
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7751:
jmp @r4
mov r0,r2
! Opcodes D3A8 - D3AF
X3A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7752
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7752:
jmp @r4
mov r0,r2
! Opcodes D3B0 - D3B7
X3B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7753
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7753:
jmp @r4
mov r0,r2
! Opcode D3B8
X3B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7754
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7754:
jmp @r4
mov r0,r2
! Opcode D3B9
X3B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(4,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7755
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7755:
jmp @r4
mov r0,r2
! Opcodes D3C0 - D3C7
X3C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7756
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7756:
jmp @r4
mov r0,r2
! Opcodes D3C8 - D3CF
X3C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7757
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7757:
jmp @r4
mov r0,r2
! Opcodes D3D0 - D3D7
X3D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7758
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7758:
jmp @r4
mov r0,r2
! Opcodes D3D8 - D3DF
X3D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7759
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7759:
jmp @r4
mov r0,r2
! Opcodes D3E0 - D3E7
X3E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7760
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7760:
jmp @r4
mov r0,r2
! Opcodes D3E8 - D3EF
X3E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7761
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7761:
jmp @r4
mov r0,r2
! Opcodes D3F0 - D3F7
X3F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7762
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7762:
jmp @r4
mov r0,r2
! Opcode D3F8
X3F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7763
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7763:
jmp @r4
mov r0,r2
! Opcode D3F9
X3F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7764
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7764:
jmp @r4
mov r0,r2
! Opcode D3FA
X3FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7765
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7765:
jmp @r4
mov r0,r2
! Opcode D3FB
X3FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7766
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7766:
jmp @r4
mov r0,r2
! Opcode D3FC
X3FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(36,r13),r1
add r3,r1
mov.l r1,@(36,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7767
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7767:
jmp @r4
mov r0,r2
! Opcodes D400 - D407
X400:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7768
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7768:
jmp @r4
mov r0,r2
! Opcodes D408 - D40F
X408:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7769
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7769:
jmp @r4
mov r0,r2
! Opcodes D410 - D417
X410:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7770
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7770:
jmp @r4
mov r0,r2
! Opcodes D418 - D41F
X418:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7771
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7771:
jmp @r4
mov r0,r2
! Opcodes D420 - D427
X420:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7772
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7772:
jmp @r4
mov r0,r2
! Opcodes D428 - D42F
X428:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7773
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7773:
jmp @r4
mov r0,r2
! Opcodes D430 - D437
X430:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7774
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7774:
jmp @r4
mov r0,r2
! Opcode D438
X438:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7775
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7775:
jmp @r4
mov r0,r2
! Opcode D439
X439:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7776
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7776:
jmp @r4
mov r0,r2
! Opcode D43A
X43A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7777
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7777:
jmp @r4
mov r0,r2
! Opcode D43B
X43B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7778
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7778:
jmp @r4
mov r0,r2
! Opcode D43C
X43C:
mov.b @r6,r3
add #2,r6
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #8,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7779
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7779:
jmp @r4
mov r0,r2
! Opcodes D440 - D447
X440:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7780
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7780:
jmp @r4
mov r0,r2
! Opcodes D448 - D44F
X448:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7781
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7781:
jmp @r4
mov r0,r2
! Opcodes D450 - D457
X450:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7782
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7782:
jmp @r4
mov r0,r2
! Opcodes D458 - D45F
X458:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7783
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7783:
jmp @r4
mov r0,r2
! Opcodes D460 - D467
X460:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7784
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7784:
jmp @r4
mov r0,r2
! Opcodes D468 - D46F
X468:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7785
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7785:
jmp @r4
mov r0,r2
! Opcodes D470 - D477
X470:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7786
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7786:
jmp @r4
mov r0,r2
! Opcode D478
X478:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7787
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7787:
jmp @r4
mov r0,r2
! Opcode D479
X479:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7788
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7788:
jmp @r4
mov r0,r2
! Opcode D47A
X47A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7789
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7789:
jmp @r4
mov r0,r2
! Opcode D47B
X47B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7790
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7790:
jmp @r4
mov r0,r2
! Opcode D47C
X47C:
mov.w @r6+,r3
mov #8,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #8,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7791
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7791:
jmp @r4
mov r0,r2
! Opcodes D480 - D487
X480:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7792
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7792:
jmp @r4
mov r0,r2
! Opcodes D488 - D48F
X488:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7793
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7793:
jmp @r4
mov r0,r2
! Opcodes D490 - D497
X490:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7794
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7794:
jmp @r4
mov r0,r2
! Opcodes D498 - D49F
X498:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7795
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7795:
jmp @r4
mov r0,r2
! Opcodes D4A0 - D4A7
X4A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7796
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7796:
jmp @r4
mov r0,r2
! Opcodes D4A8 - D4AF
X4A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7797
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7797:
jmp @r4
mov r0,r2
! Opcodes D4B0 - D4B7
X4B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7798
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7798:
jmp @r4
mov r0,r2
! Opcode D4B8
X4B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7799
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7799:
jmp @r4
mov r0,r2
! Opcode D4B9
X4B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7800
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7800:
jmp @r4
mov r0,r2
! Opcode D4BA
X4BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7801
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7801:
jmp @r4
mov r0,r2
! Opcode D4BB
X4BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7802
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7802:
jmp @r4
mov r0,r2
! Opcode D4BC
X4BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(8,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(8,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7803
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7803:
jmp @r4
mov r0,r2
! Opcodes D4C0 - D4C7
X4C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7804
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7804:
jmp @r4
mov r0,r2
! Opcodes D4C8 - D4CF
X4C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7805
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7805:
jmp @r4
mov r0,r2
! Opcodes D4D0 - D4D7
X4D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7806
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7806:
jmp @r4
mov r0,r2
! Opcodes D4D8 - D4DF
X4D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7807
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7807:
jmp @r4
mov r0,r2
! Opcodes D4E0 - D4E7
X4E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7808
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7808:
jmp @r4
mov r0,r2
! Opcodes D4E8 - D4EF
X4E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7809
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7809:
jmp @r4
mov r0,r2
! Opcodes D4F0 - D4F7
X4F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7810
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7810:
jmp @r4
mov r0,r2
! Opcode D4F8
X4F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7811
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7811:
jmp @r4
mov r0,r2
! Opcode D4F9
X4F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7812
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7812:
jmp @r4
mov r0,r2
! Opcode D4FA
X4FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7813
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7813:
jmp @r4
mov r0,r2
! Opcode D4FB
X4FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7814
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7814:
jmp @r4
mov r0,r2
! Opcode D4FC
X4FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7815
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7815:
jmp @r4
mov r0,r2
! Opcodes D500 - D507
X500:
and r1,r2
mov r3,r4
mov #8,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #8,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7817
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7817:
jmp @r4
mov r0,r2
! Opcodes D508 - D50F
X508:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(40,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7819
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7819:
jmp @r4
mov r0,r2
! Opcodes D510 - D517
X510:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7820
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7820:
jmp @r4
mov r0,r2
! Opcodes D518 - D51F
X518:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7821
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7821:
jmp @r4
mov r0,r2
! Opcodes D520 - D527
X520:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7822
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7822:
jmp @r4
mov r0,r2
! Opcodes D528 - D52F
X528:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7823
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7823:
jmp @r4
mov r0,r2
! Opcodes D530 - D537
X530:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7824
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7824:
jmp @r4
mov r0,r2
! Opcode D538
X538:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7825
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7825:
jmp @r4
mov r0,r2
! Opcode D539
X539:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7826
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7826:
jmp @r4
mov r0,r2
! Opcodes D540 - D547
X540:
and r1,r2
mov r3,r4
mov #8,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #8,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7828
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7828:
jmp @r4
mov r0,r2
! Opcodes D548 - D54F
X548:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(40,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7830
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7830:
jmp @r4
mov r0,r2
! Opcodes D550 - D557
X550:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7831
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7831:
jmp @r4
mov r0,r2
! Opcodes D558 - D55F
X558:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7832
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7832:
jmp @r4
mov r0,r2
! Opcodes D560 - D567
X560:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7833
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7833:
jmp @r4
mov r0,r2
! Opcodes D568 - D56F
X568:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7834
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7834:
jmp @r4
mov r0,r2
! Opcodes D570 - D577
X570:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7835
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7835:
jmp @r4
mov r0,r2
! Opcode D578
X578:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7836
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7836:
jmp @r4
mov r0,r2
! Opcode D579
X579:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #8,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7837
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7837:
jmp @r4
mov r0,r2
! Opcodes D580 - D587
X580:
and r1,r2
mov r3,r4
mov.l @(8,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(8,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7839
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7839:
jmp @r4
mov r0,r2
! Opcodes D588 - D58F
X588:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(40,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(40,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7841
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7841:
jmp @r4
mov r0,r2
! Opcodes D590 - D597
X590:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7842
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7842:
jmp @r4
mov r0,r2
! Opcodes D598 - D59F
X598:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7843
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7843:
jmp @r4
mov r0,r2
! Opcodes D5A0 - D5A7
X5A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7844
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7844:
jmp @r4
mov r0,r2
! Opcodes D5A8 - D5AF
X5A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7845
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7845:
jmp @r4
mov r0,r2
! Opcodes D5B0 - D5B7
X5B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7846
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7846:
jmp @r4
mov r0,r2
! Opcode D5B8
X5B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7847
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7847:
jmp @r4
mov r0,r2
! Opcode D5B9
X5B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(8,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7848
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7848:
jmp @r4
mov r0,r2
! Opcodes D5C0 - D5C7
X5C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7849
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7849:
jmp @r4
mov r0,r2
! Opcodes D5C8 - D5CF
X5C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7850
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7850:
jmp @r4
mov r0,r2
! Opcodes D5D0 - D5D7
X5D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7851
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7851:
jmp @r4
mov r0,r2
! Opcodes D5D8 - D5DF
X5D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7852
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7852:
jmp @r4
mov r0,r2
! Opcodes D5E0 - D5E7
X5E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7853
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7853:
jmp @r4
mov r0,r2
! Opcodes D5E8 - D5EF
X5E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7854
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7854:
jmp @r4
mov r0,r2
! Opcodes D5F0 - D5F7
X5F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7855
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7855:
jmp @r4
mov r0,r2
! Opcode D5F8
X5F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7856
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7856:
jmp @r4
mov r0,r2
! Opcode D5F9
X5F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7857
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7857:
jmp @r4
mov r0,r2
! Opcode D5FA
X5FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7858
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7858:
jmp @r4
mov r0,r2
! Opcode D5FB
X5FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7859
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7859:
jmp @r4
mov r0,r2
! Opcode D5FC
X5FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(40,r13),r1
add r3,r1
mov.l r1,@(40,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7860
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7860:
jmp @r4
mov r0,r2
! Opcodes D600 - D607
X600:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7861
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7861:
jmp @r4
mov r0,r2
! Opcodes D608 - D60F
X608:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7862
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7862:
jmp @r4
mov r0,r2
! Opcodes D610 - D617
X610:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7863
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7863:
jmp @r4
mov r0,r2
! Opcodes D618 - D61F
X618:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7864
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7864:
jmp @r4
mov r0,r2
! Opcodes D620 - D627
X620:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7865
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7865:
jmp @r4
mov r0,r2
! Opcodes D628 - D62F
X628:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7866
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7866:
jmp @r4
mov r0,r2
! Opcodes D630 - D637
X630:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7867
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7867:
jmp @r4
mov r0,r2
! Opcode D638
X638:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7868
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7868:
jmp @r4
mov r0,r2
! Opcode D639
X639:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7869
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7869:
jmp @r4
mov r0,r2
! Opcode D63A
X63A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7870
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7870:
jmp @r4
mov r0,r2
! Opcode D63B
X63B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7871
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7871:
jmp @r4
mov r0,r2
! Opcode D63C
X63C:
mov.b @r6,r3
add #2,r6
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #12,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7872
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7872:
jmp @r4
mov r0,r2
! Opcodes D640 - D647
X640:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7873
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7873:
jmp @r4
mov r0,r2
! Opcodes D648 - D64F
X648:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7874
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7874:
jmp @r4
mov r0,r2
! Opcodes D650 - D657
X650:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7875
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7875:
jmp @r4
mov r0,r2
! Opcodes D658 - D65F
X658:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7876
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7876:
jmp @r4
mov r0,r2
! Opcodes D660 - D667
X660:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7877
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7877:
jmp @r4
mov r0,r2
! Opcodes D668 - D66F
X668:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7878
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7878:
jmp @r4
mov r0,r2
! Opcodes D670 - D677
X670:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7879
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7879:
jmp @r4
mov r0,r2
! Opcode D678
X678:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7880
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7880:
jmp @r4
mov r0,r2
! Opcode D679
X679:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7881
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7881:
jmp @r4
mov r0,r2
! Opcode D67A
X67A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7882
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7882:
jmp @r4
mov r0,r2
! Opcode D67B
X67B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7883
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7883:
jmp @r4
mov r0,r2
! Opcode D67C
X67C:
mov.w @r6+,r3
mov #12,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #12,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7884
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7884:
jmp @r4
mov r0,r2
! Opcodes D680 - D687
X680:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7885
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7885:
jmp @r4
mov r0,r2
! Opcodes D688 - D68F
X688:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7886
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7886:
jmp @r4
mov r0,r2
! Opcodes D690 - D697
X690:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7887
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7887:
jmp @r4
mov r0,r2
! Opcodes D698 - D69F
X698:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7888
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7888:
jmp @r4
mov r0,r2
! Opcodes D6A0 - D6A7
X6A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7889
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7889:
jmp @r4
mov r0,r2
! Opcodes D6A8 - D6AF
X6A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7890
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7890:
jmp @r4
mov r0,r2
! Opcodes D6B0 - D6B7
X6B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7891
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7891:
jmp @r4
mov r0,r2
! Opcode D6B8
X6B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7892
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7892:
jmp @r4
mov r0,r2
! Opcode D6B9
X6B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7893
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7893:
jmp @r4
mov r0,r2
! Opcode D6BA
X6BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7894
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7894:
jmp @r4
mov r0,r2
! Opcode D6BB
X6BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7895
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7895:
jmp @r4
mov r0,r2
! Opcode D6BC
X6BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(12,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(12,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7896
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7896:
jmp @r4
mov r0,r2
! Opcodes D6C0 - D6C7
X6C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7897
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7897:
jmp @r4
mov r0,r2
! Opcodes D6C8 - D6CF
X6C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7898
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7898:
jmp @r4
mov r0,r2
! Opcodes D6D0 - D6D7
X6D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7899
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7899:
jmp @r4
mov r0,r2
! Opcodes D6D8 - D6DF
X6D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7900
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7900:
jmp @r4
mov r0,r2
! Opcodes D6E0 - D6E7
X6E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7901
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7901:
jmp @r4
mov r0,r2
! Opcodes D6E8 - D6EF
X6E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7902
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7902:
jmp @r4
mov r0,r2
! Opcodes D6F0 - D6F7
X6F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7903
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7903:
jmp @r4
mov r0,r2
! Opcode D6F8
X6F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7904
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7904:
jmp @r4
mov r0,r2
! Opcode D6F9
X6F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7905
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7905:
jmp @r4
mov r0,r2
! Opcode D6FA
X6FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7906
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7906:
jmp @r4
mov r0,r2
! Opcode D6FB
X6FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7907
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7907:
jmp @r4
mov r0,r2
! Opcode D6FC
X6FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7908
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7908:
jmp @r4
mov r0,r2
! Opcodes D700 - D707
X700:
and r1,r2
mov r3,r4
mov #12,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #12,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7910
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7910:
jmp @r4
mov r0,r2
! Opcodes D708 - D70F
X708:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(44,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7912
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7912:
jmp @r4
mov r0,r2
! Opcodes D710 - D717
X710:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7913
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7913:
jmp @r4
mov r0,r2
! Opcodes D718 - D71F
X718:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7914
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7914:
jmp @r4
mov r0,r2
! Opcodes D720 - D727
X720:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7915
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7915:
jmp @r4
mov r0,r2
! Opcodes D728 - D72F
X728:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7916
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7916:
jmp @r4
mov r0,r2
! Opcodes D730 - D737
X730:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7917
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7917:
jmp @r4
mov r0,r2
! Opcode D738
X738:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7918
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7918:
jmp @r4
mov r0,r2
! Opcode D739
X739:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7919
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7919:
jmp @r4
mov r0,r2
! Opcodes D740 - D747
X740:
and r1,r2
mov r3,r4
mov #12,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #12,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7921
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7921:
jmp @r4
mov r0,r2
! Opcodes D748 - D74F
X748:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(44,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7923
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7923:
jmp @r4
mov r0,r2
! Opcodes D750 - D757
X750:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7924
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7924:
jmp @r4
mov r0,r2
! Opcodes D758 - D75F
X758:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7925
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7925:
jmp @r4
mov r0,r2
! Opcodes D760 - D767
X760:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7926
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7926:
jmp @r4
mov r0,r2
! Opcodes D768 - D76F
X768:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7927
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7927:
jmp @r4
mov r0,r2
! Opcodes D770 - D777
X770:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7928
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7928:
jmp @r4
mov r0,r2
! Opcode D778
X778:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7929
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7929:
jmp @r4
mov r0,r2
! Opcode D779
X779:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #12,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7930
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7930:
jmp @r4
mov r0,r2
! Opcodes D780 - D787
X780:
and r1,r2
mov r3,r4
mov.l @(12,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(12,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7932
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7932:
jmp @r4
mov r0,r2
! Opcodes D788 - D78F
X788:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(44,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(44,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7934
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7934:
jmp @r4
mov r0,r2
! Opcodes D790 - D797
X790:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7935
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7935:
jmp @r4
mov r0,r2
! Opcodes D798 - D79F
X798:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7936
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7936:
jmp @r4
mov r0,r2
! Opcodes D7A0 - D7A7
X7A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7937
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7937:
jmp @r4
mov r0,r2
! Opcodes D7A8 - D7AF
X7A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7938
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7938:
jmp @r4
mov r0,r2
! Opcodes D7B0 - D7B7
X7B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7939
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7939:
jmp @r4
mov r0,r2
! Opcode D7B8
X7B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7940
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7940:
jmp @r4
mov r0,r2
! Opcode D7B9
X7B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(12,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7941
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7941:
jmp @r4
mov r0,r2
! Opcodes D7C0 - D7C7
X7C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7942
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7942:
jmp @r4
mov r0,r2
! Opcodes D7C8 - D7CF
X7C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7943
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7943:
jmp @r4
mov r0,r2
! Opcodes D7D0 - D7D7
X7D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7944
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7944:
jmp @r4
mov r0,r2
! Opcodes D7D8 - D7DF
X7D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7945
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7945:
jmp @r4
mov r0,r2
! Opcodes D7E0 - D7E7
X7E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7946
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7946:
jmp @r4
mov r0,r2
! Opcodes D7E8 - D7EF
X7E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7947
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7947:
jmp @r4
mov r0,r2
! Opcodes D7F0 - D7F7
X7F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7948
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7948:
jmp @r4
mov r0,r2
! Opcode D7F8
X7F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7949
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7949:
jmp @r4
mov r0,r2
! Opcode D7F9
X7F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7950
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7950:
jmp @r4
mov r0,r2
! Opcode D7FA
X7FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7951
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7951:
jmp @r4
mov r0,r2
! Opcode D7FB
X7FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7952
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7952:
jmp @r4
mov r0,r2
! Opcode D7FC
X7FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(44,r13),r1
add r3,r1
mov.l r1,@(44,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7953
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7953:
jmp @r4
mov r0,r2
! Opcodes D800 - D807
X800:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7954
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7954:
jmp @r4
mov r0,r2
! Opcodes D808 - D80F
X808:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7955
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7955:
jmp @r4
mov r0,r2
! Opcodes D810 - D817
X810:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7956
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7956:
jmp @r4
mov r0,r2
! Opcodes D818 - D81F
X818:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7957
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7957:
jmp @r4
mov r0,r2
! Opcodes D820 - D827
X820:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7958
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7958:
jmp @r4
mov r0,r2
! Opcodes D828 - D82F
X828:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7959
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7959:
jmp @r4
mov r0,r2
! Opcodes D830 - D837
X830:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7960
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7960:
jmp @r4
mov r0,r2
! Opcode D838
X838:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7961
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7961:
jmp @r4
mov r0,r2
! Opcode D839
X839:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7962
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7962:
jmp @r4
mov r0,r2
! Opcode D83A
X83A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7963
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7963:
jmp @r4
mov r0,r2
! Opcode D83B
X83B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7964
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7964:
jmp @r4
mov r0,r2
! Opcode D83C
X83C:
mov.b @r6,r3
add #2,r6
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #16,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7965
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7965:
jmp @r4
mov r0,r2
! Opcodes D840 - D847
X840:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7966
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7966:
jmp @r4
mov r0,r2
! Opcodes D848 - D84F
X848:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7967
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7967:
jmp @r4
mov r0,r2
! Opcodes D850 - D857
X850:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7968
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7968:
jmp @r4
mov r0,r2
! Opcodes D858 - D85F
X858:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7969
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7969:
jmp @r4
mov r0,r2
! Opcodes D860 - D867
X860:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7970
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7970:
jmp @r4
mov r0,r2
! Opcodes D868 - D86F
X868:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7971
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7971:
jmp @r4
mov r0,r2
! Opcodes D870 - D877
X870:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7972
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7972:
jmp @r4
mov r0,r2
! Opcode D878
X878:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7973
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7973:
jmp @r4
mov r0,r2
! Opcode D879
X879:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7974
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7974:
jmp @r4
mov r0,r2
! Opcode D87A
X87A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7975
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7975:
jmp @r4
mov r0,r2
! Opcode D87B
X87B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7976
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7976:
jmp @r4
mov r0,r2
! Opcode D87C
X87C:
mov.w @r6+,r3
mov #16,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #16,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7977
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7977:
jmp @r4
mov r0,r2
! Opcodes D880 - D887
X880:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7978
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7978:
jmp @r4
mov r0,r2
! Opcodes D888 - D88F
X888:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7979
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7979:
jmp @r4
mov r0,r2
! Opcodes D890 - D897
X890:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7980
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7980:
jmp @r4
mov r0,r2
! Opcodes D898 - D89F
X898:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7981
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7981:
jmp @r4
mov r0,r2
! Opcodes D8A0 - D8A7
X8A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7982
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7982:
jmp @r4
mov r0,r2
! Opcodes D8A8 - D8AF
X8A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7983
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7983:
jmp @r4
mov r0,r2
! Opcodes D8B0 - D8B7
X8B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7984
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7984:
jmp @r4
mov r0,r2
! Opcode D8B8
X8B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7985
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7985:
jmp @r4
mov r0,r2
! Opcode D8B9
X8B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7986
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7986:
jmp @r4
mov r0,r2
! Opcode D8BA
X8BA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7987
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7987:
jmp @r4
mov r0,r2
! Opcode D8BB
X8BB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7988
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7988:
jmp @r4
mov r0,r2
! Opcode D8BC
X8BC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(16,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(16,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7989
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7989:
jmp @r4
mov r0,r2
! Opcodes D8C0 - D8C7
X8C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7990
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7990:
jmp @r4
mov r0,r2
! Opcodes D8C8 - D8CF
X8C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7991
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7991:
jmp @r4
mov r0,r2
! Opcodes D8D0 - D8D7
X8D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7992
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7992:
jmp @r4
mov r0,r2
! Opcodes D8D8 - D8DF
X8D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7993
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7993:
jmp @r4
mov r0,r2
! Opcodes D8E0 - D8E7
X8E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7994
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7994:
jmp @r4
mov r0,r2
! Opcodes D8E8 - D8EF
X8E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7995
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7995:
jmp @r4
mov r0,r2
! Opcodes D8F0 - D8F7
X8F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7996
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7996:
jmp @r4
mov r0,r2
! Opcode D8F8
X8F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7997
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7997:
jmp @r4
mov r0,r2
! Opcode D8F9
X8F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7998
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7998:
jmp @r4
mov r0,r2
! Opcode D8FA
X8FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl7999
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl7999:
jmp @r4
mov r0,r2
! Opcode D8FB
X8FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8000
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8000:
jmp @r4
mov r0,r2
! Opcode D8FC
X8FC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8001
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8001:
jmp @r4
mov r0,r2
! Opcodes D900 - D907
X900:
and r1,r2
mov r3,r4
mov #16,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #16,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8003
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8003:
jmp @r4
mov r0,r2
! Opcodes D908 - D90F
X908:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(48,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8005
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8005:
jmp @r4
mov r0,r2
! Opcodes D910 - D917
X910:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8006
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8006:
jmp @r4
mov r0,r2
! Opcodes D918 - D91F
X918:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8007
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8007:
jmp @r4
mov r0,r2
! Opcodes D920 - D927
X920:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8008
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8008:
jmp @r4
mov r0,r2
! Opcodes D928 - D92F
X928:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8009
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8009:
jmp @r4
mov r0,r2
! Opcodes D930 - D937
X930:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8010
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8010:
jmp @r4
mov r0,r2
! Opcode D938
X938:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8011
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8011:
jmp @r4
mov r0,r2
! Opcode D939
X939:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8012
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8012:
jmp @r4
mov r0,r2
! Opcodes D940 - D947
X940:
and r1,r2
mov r3,r4
mov #16,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #16,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8014
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8014:
jmp @r4
mov r0,r2
! Opcodes D948 - D94F
X948:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(48,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8016
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8016:
jmp @r4
mov r0,r2
! Opcodes D950 - D957
X950:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8017
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8017:
jmp @r4
mov r0,r2
! Opcodes D958 - D95F
X958:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8018
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8018:
jmp @r4
mov r0,r2
! Opcodes D960 - D967
X960:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8019
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8019:
jmp @r4
mov r0,r2
! Opcodes D968 - D96F
X968:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8020
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8020:
jmp @r4
mov r0,r2
! Opcodes D970 - D977
X970:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8021
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8021:
jmp @r4
mov r0,r2
! Opcode D978
X978:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8022
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8022:
jmp @r4
mov r0,r2
! Opcode D979
X979:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #16,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8023
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8023:
jmp @r4
mov r0,r2
! Opcodes D980 - D987
X980:
and r1,r2
mov r3,r4
mov.l @(16,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(16,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8025
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8025:
jmp @r4
mov r0,r2
! Opcodes D988 - D98F
X988:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(48,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(48,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8027
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8027:
jmp @r4
mov r0,r2
! Opcodes D990 - D997
X990:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8028
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8028:
jmp @r4
mov r0,r2
! Opcodes D998 - D99F
X998:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8029
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8029:
jmp @r4
mov r0,r2
! Opcodes D9A0 - D9A7
X9A0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8030
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8030:
jmp @r4
mov r0,r2
! Opcodes D9A8 - D9AF
X9A8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8031
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8031:
jmp @r4
mov r0,r2
! Opcodes D9B0 - D9B7
X9B0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8032
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8032:
jmp @r4
mov r0,r2
! Opcode D9B8
X9B8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8033
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8033:
jmp @r4
mov r0,r2
! Opcode D9B9
X9B9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(16,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8034
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8034:
jmp @r4
mov r0,r2
! Opcodes D9C0 - D9C7
X9C0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8035
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8035:
jmp @r4
mov r0,r2
! Opcodes D9C8 - D9CF
X9C8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8036
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8036:
jmp @r4
mov r0,r2
! Opcodes D9D0 - D9D7
X9D0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8037
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8037:
jmp @r4
mov r0,r2
! Opcodes D9D8 - D9DF
X9D8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8038
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8038:
jmp @r4
mov r0,r2
! Opcodes D9E0 - D9E7
X9E0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8039
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8039:
jmp @r4
mov r0,r2
! Opcodes D9E8 - D9EF
X9E8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8040
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8040:
jmp @r4
mov r0,r2
! Opcodes D9F0 - D9F7
X9F0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8041
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8041:
jmp @r4
mov r0,r2
! Opcode D9F8
X9F8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8042
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8042:
jmp @r4
mov r0,r2
! Opcode D9F9
X9F9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8043
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8043:
jmp @r4
mov r0,r2
! Opcode D9FA
X9FA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8044
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8044:
jmp @r4
mov r0,r2
! Opcode D9FB
X9FB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8045
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8045:
jmp @r4
mov r0,r2
! Opcode D9FC
X9FC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(48,r13),r1
add r3,r1
mov.l r1,@(48,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8046
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8046:
jmp @r4
mov r0,r2
! Opcodes DA00 - DA07
XA00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8047
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8047:
jmp @r4
mov r0,r2
! Opcodes DA08 - DA0F
XA08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8048
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8048:
jmp @r4
mov r0,r2
! Opcodes DA10 - DA17
XA10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8049
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8049:
jmp @r4
mov r0,r2
! Opcodes DA18 - DA1F
XA18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8050
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8050:
jmp @r4
mov r0,r2
! Opcodes DA20 - DA27
XA20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8051
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8051:
jmp @r4
mov r0,r2
! Opcodes DA28 - DA2F
XA28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8052
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8052:
jmp @r4
mov r0,r2
! Opcodes DA30 - DA37
XA30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8053
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8053:
jmp @r4
mov r0,r2
! Opcode DA38
XA38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8054
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8054:
jmp @r4
mov r0,r2
! Opcode DA39
XA39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8055
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8055:
jmp @r4
mov r0,r2
! Opcode DA3A
XA3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8056
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8056:
jmp @r4
mov r0,r2
! Opcode DA3B
XA3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8057
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8057:
jmp @r4
mov r0,r2
! Opcode DA3C
XA3C:
mov.b @r6,r3
add #2,r6
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #20,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8058
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8058:
jmp @r4
mov r0,r2
! Opcodes DA40 - DA47
XA40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8059
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8059:
jmp @r4
mov r0,r2
! Opcodes DA48 - DA4F
XA48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8060
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8060:
jmp @r4
mov r0,r2
! Opcodes DA50 - DA57
XA50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8061
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8061:
jmp @r4
mov r0,r2
! Opcodes DA58 - DA5F
XA58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8062
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8062:
jmp @r4
mov r0,r2
! Opcodes DA60 - DA67
XA60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8063
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8063:
jmp @r4
mov r0,r2
! Opcodes DA68 - DA6F
XA68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8064
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8064:
jmp @r4
mov r0,r2
! Opcodes DA70 - DA77
XA70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8065
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8065:
jmp @r4
mov r0,r2
! Opcode DA78
XA78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8066
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8066:
jmp @r4
mov r0,r2
! Opcode DA79
XA79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8067
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8067:
jmp @r4
mov r0,r2
! Opcode DA7A
XA7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8068
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8068:
jmp @r4
mov r0,r2
! Opcode DA7B
XA7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8069
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8069:
jmp @r4
mov r0,r2
! Opcode DA7C
XA7C:
mov.w @r6+,r3
mov #20,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #20,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8070
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8070:
jmp @r4
mov r0,r2
! Opcodes DA80 - DA87
XA80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8071
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8071:
jmp @r4
mov r0,r2
! Opcodes DA88 - DA8F
XA88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8072
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8072:
jmp @r4
mov r0,r2
! Opcodes DA90 - DA97
XA90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8073
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8073:
jmp @r4
mov r0,r2
! Opcodes DA98 - DA9F
XA98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8074
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8074:
jmp @r4
mov r0,r2
! Opcodes DAA0 - DAA7
XAA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8075
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8075:
jmp @r4
mov r0,r2
! Opcodes DAA8 - DAAF
XAA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8076
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8076:
jmp @r4
mov r0,r2
! Opcodes DAB0 - DAB7
XAB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8077
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8077:
jmp @r4
mov r0,r2
! Opcode DAB8
XAB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8078
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8078:
jmp @r4
mov r0,r2
! Opcode DAB9
XAB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8079
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8079:
jmp @r4
mov r0,r2
! Opcode DABA
XABA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8080
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8080:
jmp @r4
mov r0,r2
! Opcode DABB
XABB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8081
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8081:
jmp @r4
mov r0,r2
! Opcode DABC
XABC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(20,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(20,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8082
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8082:
jmp @r4
mov r0,r2
! Opcodes DAC0 - DAC7
XAC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8083
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8083:
jmp @r4
mov r0,r2
! Opcodes DAC8 - DACF
XAC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8084
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8084:
jmp @r4
mov r0,r2
! Opcodes DAD0 - DAD7
XAD0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8085
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8085:
jmp @r4
mov r0,r2
! Opcodes DAD8 - DADF
XAD8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8086
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8086:
jmp @r4
mov r0,r2
! Opcodes DAE0 - DAE7
XAE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8087
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8087:
jmp @r4
mov r0,r2
! Opcodes DAE8 - DAEF
XAE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8088
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8088:
jmp @r4
mov r0,r2
! Opcodes DAF0 - DAF7
XAF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8089
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8089:
jmp @r4
mov r0,r2
! Opcode DAF8
XAF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8090
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8090:
jmp @r4
mov r0,r2
! Opcode DAF9
XAF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8091
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8091:
jmp @r4
mov r0,r2
! Opcode DAFA
XAFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8092
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8092:
jmp @r4
mov r0,r2
! Opcode DAFB
XAFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8093
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8093:
jmp @r4
mov r0,r2
! Opcode DAFC
XAFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8094
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8094:
jmp @r4
mov r0,r2
! Opcodes DB00 - DB07
XB00:
and r1,r2
mov r3,r4
mov #20,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #20,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8096
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8096:
jmp @r4
mov r0,r2
! Opcodes DB08 - DB0F
XB08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(52,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8098
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8098:
jmp @r4
mov r0,r2
! Opcodes DB10 - DB17
XB10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8099
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8099:
jmp @r4
mov r0,r2
! Opcodes DB18 - DB1F
XB18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8100
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8100:
jmp @r4
mov r0,r2
! Opcodes DB20 - DB27
XB20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8101
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8101:
jmp @r4
mov r0,r2
! Opcodes DB28 - DB2F
XB28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8102
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8102:
jmp @r4
mov r0,r2
! Opcodes DB30 - DB37
XB30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8103
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8103:
jmp @r4
mov r0,r2
! Opcode DB38
XB38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8104
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8104:
jmp @r4
mov r0,r2
! Opcode DB39
XB39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8105
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8105:
jmp @r4
mov r0,r2
! Opcodes DB40 - DB47
XB40:
and r1,r2
mov r3,r4
mov #20,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #20,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8107
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8107:
jmp @r4
mov r0,r2
! Opcodes DB48 - DB4F
XB48:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(52,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8109
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8109:
jmp @r4
mov r0,r2
! Opcodes DB50 - DB57
XB50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8110
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8110:
jmp @r4
mov r0,r2
! Opcodes DB58 - DB5F
XB58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8111
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8111:
jmp @r4
mov r0,r2
! Opcodes DB60 - DB67
XB60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8112
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8112:
jmp @r4
mov r0,r2
! Opcodes DB68 - DB6F
XB68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8113
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8113:
jmp @r4
mov r0,r2
! Opcodes DB70 - DB77
XB70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8114
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8114:
jmp @r4
mov r0,r2
! Opcode DB78
XB78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8115
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8115:
jmp @r4
mov r0,r2
! Opcode DB79
XB79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #20,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8116
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8116:
jmp @r4
mov r0,r2
! Opcodes DB80 - DB87
XB80:
and r1,r2
mov r3,r4
mov.l @(20,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(20,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8118
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8118:
jmp @r4
mov r0,r2
! Opcodes DB88 - DB8F
XB88:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(52,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(52,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8120
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8120:
jmp @r4
mov r0,r2
! Opcodes DB90 - DB97
XB90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8121
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8121:
jmp @r4
mov r0,r2
! Opcodes DB98 - DB9F
XB98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8122
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8122:
jmp @r4
mov r0,r2
! Opcodes DBA0 - DBA7
XBA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8123
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8123:
jmp @r4
mov r0,r2
! Opcodes DBA8 - DBAF
XBA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8124
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8124:
jmp @r4
mov r0,r2
! Opcodes DBB0 - DBB7
XBB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8125
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8125:
jmp @r4
mov r0,r2
! Opcode DBB8
XBB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8126
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8126:
jmp @r4
mov r0,r2
! Opcode DBB9
XBB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(20,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8127
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8127:
jmp @r4
mov r0,r2
! Opcodes DBC0 - DBC7
XBC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8128
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8128:
jmp @r4
mov r0,r2
! Opcodes DBC8 - DBCF
XBC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8129
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8129:
jmp @r4
mov r0,r2
! Opcodes DBD0 - DBD7
XBD0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8130
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8130:
jmp @r4
mov r0,r2
! Opcodes DBD8 - DBDF
XBD8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8131
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8131:
jmp @r4
mov r0,r2
! Opcodes DBE0 - DBE7
XBE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8132
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8132:
jmp @r4
mov r0,r2
! Opcodes DBE8 - DBEF
XBE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8133
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8133:
jmp @r4
mov r0,r2
! Opcodes DBF0 - DBF7
XBF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8134
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8134:
jmp @r4
mov r0,r2
! Opcode DBF8
XBF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8135
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8135:
jmp @r4
mov r0,r2
! Opcode DBF9
XBF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8136
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8136:
jmp @r4
mov r0,r2
! Opcode DBFA
XBFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8137
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8137:
jmp @r4
mov r0,r2
! Opcode DBFB
XBFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8138
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8138:
jmp @r4
mov r0,r2
! Opcode DBFC
XBFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(52,r13),r1
add r3,r1
mov.l r1,@(52,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8139
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8139:
jmp @r4
mov r0,r2
! Opcodes DC00 - DC07
XC00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8140
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8140:
jmp @r4
mov r0,r2
! Opcodes DC08 - DC0F
XC08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8141
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8141:
jmp @r4
mov r0,r2
! Opcodes DC10 - DC17
XC10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8142
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8142:
jmp @r4
mov r0,r2
! Opcodes DC18 - DC1F
XC18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8143
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8143:
jmp @r4
mov r0,r2
! Opcodes DC20 - DC27
XC20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8144
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8144:
jmp @r4
mov r0,r2
! Opcodes DC28 - DC2F
XC28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8145
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8145:
jmp @r4
mov r0,r2
! Opcodes DC30 - DC37
XC30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8146
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8146:
jmp @r4
mov r0,r2
! Opcode DC38
XC38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8147
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8147:
jmp @r4
mov r0,r2
! Opcode DC39
XC39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8148
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8148:
jmp @r4
mov r0,r2
! Opcode DC3A
XC3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8149
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8149:
jmp @r4
mov r0,r2
! Opcode DC3B
XC3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8150
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8150:
jmp @r4
mov r0,r2
! Opcode DC3C
XC3C:
mov.b @r6,r3
add #2,r6
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #24,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8151
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8151:
jmp @r4
mov r0,r2
! Opcodes DC40 - DC47
XC40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8152
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8152:
jmp @r4
mov r0,r2
! Opcodes DC48 - DC4F
XC48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8153
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8153:
jmp @r4
mov r0,r2
! Opcodes DC50 - DC57
XC50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8154
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8154:
jmp @r4
mov r0,r2
! Opcodes DC58 - DC5F
XC58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8155
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8155:
jmp @r4
mov r0,r2
! Opcodes DC60 - DC67
XC60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8156
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8156:
jmp @r4
mov r0,r2
! Opcodes DC68 - DC6F
XC68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8157
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8157:
jmp @r4
mov r0,r2
! Opcodes DC70 - DC77
XC70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8158
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8158:
jmp @r4
mov r0,r2
! Opcode DC78
XC78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8159
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8159:
jmp @r4
mov r0,r2
! Opcode DC79
XC79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8160
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8160:
jmp @r4
mov r0,r2
! Opcode DC7A
XC7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8161
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8161:
jmp @r4
mov r0,r2
! Opcode DC7B
XC7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8162
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8162:
jmp @r4
mov r0,r2
! Opcode DC7C
XC7C:
mov.w @r6+,r3
mov #24,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #24,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8163
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8163:
jmp @r4
mov r0,r2
! Opcodes DC80 - DC87
XC80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8164
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8164:
jmp @r4
mov r0,r2
! Opcodes DC88 - DC8F
XC88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8165
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8165:
jmp @r4
mov r0,r2
! Opcodes DC90 - DC97
XC90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8166
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8166:
jmp @r4
mov r0,r2
! Opcodes DC98 - DC9F
XC98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8167
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8167:
jmp @r4
mov r0,r2
! Opcodes DCA0 - DCA7
XCA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8168
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8168:
jmp @r4
mov r0,r2
! Opcodes DCA8 - DCAF
XCA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8169
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8169:
jmp @r4
mov r0,r2
! Opcodes DCB0 - DCB7
XCB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8170
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8170:
jmp @r4
mov r0,r2
! Opcode DCB8
XCB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8171
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8171:
jmp @r4
mov r0,r2
! Opcode DCB9
XCB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8172
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8172:
jmp @r4
mov r0,r2
! Opcode DCBA
XCBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8173
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8173:
jmp @r4
mov r0,r2
! Opcode DCBB
XCBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8174
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8174:
jmp @r4
mov r0,r2
! Opcode DCBC
XCBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(24,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(24,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8175
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8175:
jmp @r4
mov r0,r2
! Opcodes DCC0 - DCC7
XCC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8176
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8176:
jmp @r4
mov r0,r2
! Opcodes DCC8 - DCCF
XCC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8177
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8177:
jmp @r4
mov r0,r2
! Opcodes DCD0 - DCD7
XCD0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8178
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8178:
jmp @r4
mov r0,r2
! Opcodes DCD8 - DCDF
XCD8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8179
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8179:
jmp @r4
mov r0,r2
! Opcodes DCE0 - DCE7
XCE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8180
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8180:
jmp @r4
mov r0,r2
! Opcodes DCE8 - DCEF
XCE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8181
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8181:
jmp @r4
mov r0,r2
! Opcodes DCF0 - DCF7
XCF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8182
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8182:
jmp @r4
mov r0,r2
! Opcode DCF8
XCF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8183
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8183:
jmp @r4
mov r0,r2
! Opcode DCF9
XCF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8184
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8184:
jmp @r4
mov r0,r2
! Opcode DCFA
XCFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8185
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8185:
jmp @r4
mov r0,r2
! Opcode DCFB
XCFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8186
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8186:
jmp @r4
mov r0,r2
! Opcode DCFC
XCFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8187
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8187:
jmp @r4
mov r0,r2
! Opcodes DD00 - DD07
XD00:
and r1,r2
mov r3,r4
mov #24,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #24,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8189
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8189:
jmp @r4
mov r0,r2
! Opcodes DD08 - DD0F
XD08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(56,r13),r4
dt r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8191
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8191:
jmp @r4
mov r0,r2
! Opcodes DD10 - DD17
XD10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8192
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8192:
jmp @r4
mov r0,r2
! Opcodes DD18 - DD1F
XD18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8193
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8193:
jmp @r4
mov r0,r2
! Opcodes DD20 - DD27
XD20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8194
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8194:
jmp @r4
mov r0,r2
! Opcodes DD28 - DD2F
XD28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8195
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8195:
jmp @r4
mov r0,r2
! Opcodes DD30 - DD37
XD30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8196
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8196:
jmp @r4
mov r0,r2
! Opcode DD38
XD38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8197
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8197:
jmp @r4
mov r0,r2
! Opcode DD39
XD39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8198
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8198:
jmp @r4
mov r0,r2
! Opcodes DD40 - DD47
XD40:
and r1,r2
mov r3,r4
mov #24,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #24,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8200
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8200:
jmp @r4
mov r0,r2
! Opcodes DD48 - DD4F
XD48:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(56,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8202
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8202:
jmp @r4
mov r0,r2
! Opcodes DD50 - DD57
XD50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8203
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8203:
jmp @r4
mov r0,r2
! Opcodes DD58 - DD5F
XD58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8204
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8204:
jmp @r4
mov r0,r2
! Opcodes DD60 - DD67
XD60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8205
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8205:
jmp @r4
mov r0,r2
! Opcodes DD68 - DD6F
XD68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8206
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8206:
jmp @r4
mov r0,r2
! Opcodes DD70 - DD77
XD70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8207
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8207:
jmp @r4
mov r0,r2
! Opcode DD78
XD78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8208
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8208:
jmp @r4
mov r0,r2
! Opcode DD79
XD79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #24,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8209
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8209:
jmp @r4
mov r0,r2
! Opcodes DD80 - DD87
XD80:
and r1,r2
mov r3,r4
mov.l @(24,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(24,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8211
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8211:
jmp @r4
mov r0,r2
! Opcodes DD88 - DD8F
XD88:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(56,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(56,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8213
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8213:
jmp @r4
mov r0,r2
! Opcodes DD90 - DD97
XD90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8214
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8214:
jmp @r4
mov r0,r2
! Opcodes DD98 - DD9F
XD98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8215
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8215:
jmp @r4
mov r0,r2
! Opcodes DDA0 - DDA7
XDA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8216
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8216:
jmp @r4
mov r0,r2
! Opcodes DDA8 - DDAF
XDA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8217
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8217:
jmp @r4
mov r0,r2
! Opcodes DDB0 - DDB7
XDB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8218
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8218:
jmp @r4
mov r0,r2
! Opcode DDB8
XDB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8219
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8219:
jmp @r4
mov r0,r2
! Opcode DDB9
XDB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(24,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8220
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8220:
jmp @r4
mov r0,r2
! Opcodes DDC0 - DDC7
XDC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8221
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8221:
jmp @r4
mov r0,r2
! Opcodes DDC8 - DDCF
XDC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8222
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8222:
jmp @r4
mov r0,r2
! Opcodes DDD0 - DDD7
XDD0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8223
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8223:
jmp @r4
mov r0,r2
! Opcodes DDD8 - DDDF
XDD8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8224
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8224:
jmp @r4
mov r0,r2
! Opcodes DDE0 - DDE7
XDE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8225
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8225:
jmp @r4
mov r0,r2
! Opcodes DDE8 - DDEF
XDE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8226
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8226:
jmp @r4
mov r0,r2
! Opcodes DDF0 - DDF7
XDF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8227
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8227:
jmp @r4
mov r0,r2
! Opcode DDF8
XDF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8228
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8228:
jmp @r4
mov r0,r2
! Opcode DDF9
XDF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8229
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8229:
jmp @r4
mov r0,r2
! Opcode DDFA
XDFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8230
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8230:
jmp @r4
mov r0,r2
! Opcode DDFB
XDFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8231
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8231:
jmp @r4
mov r0,r2
! Opcode DDFC
XDFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(56,r13),r1
add r3,r1
mov.l r1,@(56,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8232
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8232:
jmp @r4
mov r0,r2
! Opcodes DE00 - DE07
XE00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8233
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8233:
jmp @r4
mov r0,r2
! Opcodes DE08 - DE0F
XE08:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8234
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8234:
jmp @r4
mov r0,r2
! Opcodes DE10 - DE17
XE10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8235
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8235:
jmp @r4
mov r0,r2
! Opcodes DE18 - DE1F
XE18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8236
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8236:
jmp @r4
mov r0,r2
! Opcodes DE20 - DE27
XE20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8237
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8237:
jmp @r4
mov r0,r2
! Opcodes DE28 - DE2F
XE28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8238
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8238:
jmp @r4
mov r0,r2
! Opcodes DE30 - DE37
XE30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8239
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8239:
jmp @r4
mov r0,r2
! Opcode DE38
XE38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8240
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8240:
jmp @r4
mov r0,r2
! Opcode DE39
XE39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8241
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8241:
jmp @r4
mov r0,r2
! Opcode DE3A
XE3A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8242
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8242:
jmp @r4
mov r0,r2
! Opcode DE3B
XE3B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8243
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8243:
jmp @r4
mov r0,r2
! Opcode DE3C
XE3C:
mov.b @r6,r3
add #2,r6
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r3
shld r0,r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-24,r0
shad r0,r1
mov #28,r0
mov.b r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8244
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8244:
jmp @r4
mov r0,r2
! Opcodes DE40 - DE47
XE40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8245
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8245:
jmp @r4
mov r0,r2
! Opcodes DE48 - DE4F
XE48:
and r1,r2
add r14,r2
mov.w @r2,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8246
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8246:
jmp @r4
mov r0,r2
! Opcodes DE50 - DE57
XE50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8247
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8247:
jmp @r4
mov r0,r2
! Opcodes DE58 - DE5F
XE58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8248
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8248:
jmp @r4
mov r0,r2
! Opcodes DE60 - DE67
XE60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8249
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8249:
jmp @r4
mov r0,r2
! Opcodes DE68 - DE6F
XE68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8250
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8250:
jmp @r4
mov r0,r2
! Opcodes DE70 - DE77
XE70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8251
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8251:
jmp @r4
mov r0,r2
! Opcode DE78
XE78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8252
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8252:
jmp @r4
mov r0,r2
! Opcode DE79
XE79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8253
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8253:
jmp @r4
mov r0,r2
! Opcode DE7A
XE7A:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8254
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8254:
jmp @r4
mov r0,r2
! Opcode DE7B
XE7B:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8255
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8255:
jmp @r4
mov r0,r2
! Opcode DE7C
XE7C:
mov.w @r6+,r3
mov #28,r0
mov.w @(r0,r13),r1
shll16 r3
shll16 r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov #-16,r0
shad r0,r1
mov #28,r0
mov.w r1,@(r0,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8256
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8256:
jmp @r4
mov r0,r2
! Opcodes DE80 - DE87
XE80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8257
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8257:
jmp @r4
mov r0,r2
! Opcodes DE88 - DE8F
XE88:
and r1,r2
add r14,r2
mov.l @r2,r3
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8258
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8258:
jmp @r4
mov r0,r2
! Opcodes DE90 - DE97
XE90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8259
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8259:
jmp @r4
mov r0,r2
! Opcodes DE98 - DE9F
XE98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8260
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8260:
jmp @r4
mov r0,r2
! Opcodes DEA0 - DEA7
XEA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8261
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8261:
jmp @r4
mov r0,r2
! Opcodes DEA8 - DEAF
XEA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8262
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8262:
jmp @r4
mov r0,r2
! Opcodes DEB0 - DEB7
XEB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8263
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8263:
jmp @r4
mov r0,r2
! Opcode DEB8
XEB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8264
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8264:
jmp @r4
mov r0,r2
! Opcode DEB9
XEB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8265
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8265:
jmp @r4
mov r0,r2
! Opcode DEBA
XEBA:
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8266
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8266:
jmp @r4
mov r0,r2
! Opcode DEBB
XEBB:
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8267
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8267:
jmp @r4
mov r0,r2
! Opcode DEBC
XEBC:
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(28,r13),r1
mov r1,r0
addv r3,r0
movt r8
clrt
addc r3,r1
movt r9
addc r8,r8
mov.l r1,@(28,r13)
rotl r1
addc r8,r8
mov r1,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8268
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8268:
jmp @r4
mov r0,r2
! Opcodes DEC0 - DEC7
XEC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.w @(r0,r13),r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8269
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8269:
jmp @r4
mov r0,r2
! Opcodes DEC8 - DECF
XEC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.w @r2,r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8270
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8270:
jmp @r4
mov r0,r2
! Opcodes DED0 - DED7
XED0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8271
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8271:
jmp @r4
mov r0,r2
! Opcodes DED8 - DEDF
XED8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8272
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8272:
jmp @r4
mov r0,r2
! Opcodes DEE0 - DEE7
XEE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8273
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8273:
jmp @r4
mov r0,r2
! Opcodes DEE8 - DEEF
XEE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8274
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8274:
jmp @r4
mov r0,r2
! Opcodes DEF0 - DEF7
XEF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8275
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8275:
jmp @r4
mov r0,r2
! Opcode DEF8
XEF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8276
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8276:
jmp @r4
mov r0,r2
! Opcode DEF9
XEF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8277
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8277:
jmp @r4
mov r0,r2
! Opcode DEFA
XEFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8278
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8278:
jmp @r4
mov r0,r2
! Opcode DEFB
XEFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8279
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8279:
jmp @r4
mov r0,r2
! Opcode DEFC
XEFC:
mov.l r3,@-r15
mov.w @r6+,r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8280
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8280:
jmp @r4
mov r0,r2
! Opcodes DF00 - DF07
XF00:
and r1,r2
mov r3,r4
mov #28,r0
mov.b @(r0,r13),r3
mov r2,r0
mov.b @(r0,r13),r1
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov #28,r0
mov.b r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8282
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8282:
jmp @r4
mov r0,r2
! Opcodes DF08 - DF0F
XF08:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov #24,r0
shld r0,r1
shld r0,r3
shld r0,r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8284
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8284:
jmp @r4
mov r0,r2
! Opcodes DF10 - DF17
XF10:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8285
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8285:
jmp @r4
mov r0,r2
! Opcodes DF18 - DF1F
XF18:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
cmp/eq r0,r2
mov #1,r0
addc r0,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8286
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8286:
jmp @r4
mov r0,r2
! Opcodes DF20 - DF27
XF20:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov #28,r0
cmp/eq r0,r2
mov #1,r0
subc r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8287
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8287:
jmp @r4
mov r0,r2
! Opcodes DF28 - DF2F
XF28:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8288
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8288:
jmp @r4
mov r0,r2
! Opcodes DF30 - DF37
XF30:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8289
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8289:
jmp @r4
mov r0,r2
! Opcode DF38
XF38:
mov.w @r6+,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8290
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8290:
jmp @r4
mov r0,r2
! Opcode DF39
XF39:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rb_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.b @(r0,r13),r1
mov #24,r0
shld r0,r1
shld r0,r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-24,r0
shad r0,r3
mov.l @(wb_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8291
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8291:
jmp @r4
mov r0,r2
! Opcodes DF40 - DF47
XF40:
and r1,r2
mov r3,r4
mov #28,r0
mov.w @(r0,r13),r3
mov r2,r0
mov.w @(r0,r13),r1
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov #28,r0
mov.w r3,@(r0,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-4,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8293
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8293:
jmp @r4
mov r0,r2
! Opcodes DF48 - DF4F
XF48:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(60,r13),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
shll16 r1
shll16 r3
shll16 r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8295
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8295:
jmp @r4
mov r0,r2
! Opcodes DF50 - DF57
XF50:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8296
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8296:
jmp @r4
mov r0,r2
! Opcodes DF58 - DF5F
XF58:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8297
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8297:
jmp @r4
mov r0,r2
! Opcodes DF60 - DF67
XF60:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8298
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8298:
jmp @r4
mov r0,r2
! Opcodes DF68 - DF6F
XF68:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8299
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8299:
jmp @r4
mov r0,r2
! Opcodes DF70 - DF77
XF70:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8300
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8300:
jmp @r4
mov r0,r2
! Opcode DF78
XF78:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8301
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8301:
jmp @r4
mov r0,r2
! Opcode DF79
XF79:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
mov #28,r0
mov.w @(r0,r13),r1
shll16 r1
shll16 r3
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov #-16,r0
shad r0,r3
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8302
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8302:
jmp @r4
mov r0,r2
! Opcodes DF80 - DF87
XF80:
and r1,r2
mov r3,r4
mov.l @(28,r13),r3
mov r2,r0
mov.l @(r0,r13),r1
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l r3,@(28,r13)
mov r4,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8304
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8304:
jmp @r4
mov r0,r2
! Opcodes DF88 - DF8F
XF88:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov r3,r1
mov.l @(60,r13),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
movt r8
mov r3,r0
clrt
addc r1,r3
movt r9
clrt
addc r8,r3
movt r3
or r3,r9
addv r8,r0
movt r3
addv r1,r0
movt r8
or r3,r8
cmp/pl r9
addc r8,r8
mov r0,r3
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l r4,@(60,r13)
mov.l @r15+,r2
rotl r3
addc r8,r8
or r2,r3
mov.w @r6+,r0
add #-30,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8306
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8306:
jmp @r4
mov r0,r2
! Opcodes DF90 - DF97
XF90:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8307
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8307:
jmp @r4
mov r0,r2
! Opcodes DF98 - DF9F
XF98:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8308
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8308:
jmp @r4
mov r0,r2
! Opcodes DFA0 - DFA7
XFA0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8309
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8309:
jmp @r4
mov r0,r2
! Opcodes DFA8 - DFAF
XFA8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8310
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8310:
jmp @r4
mov r0,r2
! Opcodes DFB0 - DFB7
XFB0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-26,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8311
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8311:
jmp @r4
mov r0,r2
! Opcode DFB8
XFB8:
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8312
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8312:
jmp @r4
mov r0,r2
! Opcode DFB9
XFB9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(28,r13),r1
mov r3,r0
addv r1,r0
movt r8
clrt
addc r1,r3
movt r9
addc r8,r8
mov.l @(wl_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-28,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8313
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8313:
jmp @r4
mov r0,r2
! Opcodes DFC0 - DFC7
XFC0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r13),r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8314
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8314:
jmp @r4
mov r0,r2
! Opcodes DFC8 - DFCF
XFC8:
and r1,r2
mov.l r3,@-r15
add r14,r2
mov.l @r2,r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8315
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8315:
jmp @r4
mov r0,r2
! Opcodes DFD0 - DFD7
XFD0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8316
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8316:
jmp @r4
mov r0,r2
! Opcodes DFD8 - DFDF
XFD8:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
add #4,r4
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8317
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8317:
jmp @r4
mov r0,r2
! Opcodes DFE0 - DFE7
XFE0:
and r1,r2
mov.l r3,@-r15
mov r2,r0
mov.l @(r0,r14),r4
add #-4,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8318
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8318:
jmp @r4
mov r0,r2
! Opcodes DFE8 - DFEF
XFE8:
and r1,r2
mov.l r3,@-r15
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8319
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8319:
jmp @r4
mov r0,r2
! Opcodes DFF0 - DFF7
XFF0:
and r1,r2
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8320
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8320:
jmp @r4
mov r0,r2
! Opcode DFF8
XFF8:
mov.l r3,@-r15
mov.w @r6+,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8321
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8321:
jmp @r4
mov r0,r2
! Opcode DFF9
XFF9:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8322
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8322:
jmp @r4
mov r0,r2
! Opcode DFFA
XFFA:
mov.l r3,@-r15
mov r6,r0
mov.w @r6+,r4
sub r5,r0
add r0,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8323
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8323:
jmp @r4
mov r0,r2
! Opcode DFFB
XFFB:
mov.l r3,@-r15
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
add r6,r4
sub r5,r4
add #-2,r4
mov.l @(rl_addr-fetch_idx,r11),r0
jsr @r0
nop
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8324
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8324:
jmp @r4
mov r0,r2
! Opcode DFFC
XFFC:
mov.l r3,@-r15
mov.w @r6+,r0
mov.w @r6+,r3
shll16 r3
xtrct r0,r3
mov.l @(60,r13),r1
add r3,r1
mov.l r1,@(60,r13)
mov.l @r15+,r3
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8325
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8325:
jmp @r4
mov r0,r2
! Opcodes E000 - E007
Y000:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #-7,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8328
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8328:
jmp @r4
mov r0,r2
! Opcodes E008 - E00F
Y008:
and r1,r2
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-7,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8331
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8331:
jmp @r4
mov r0,r2
! Opcodes E010 - E017
Y010:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #8,r0
extu.b r3,r3
ln8333:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln8333
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8334
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8334:
jmp @r4
mov r0,r2
! Opcodes E018 - E01F
Y018:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #8,r0
extu.b r3,r3
ln8336:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln8336
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8337
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8337:
jmp @r4
mov r0,r2
! Opcodes E020 - E027
Y020:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8338
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8339
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8339:
jmp @r4
mov r0,r2
ln8338:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8338
mov r1,r0
nobitover8338:
add r13,r2
mov.b @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8341
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8341:
jmp @r4
mov r0,r2
! Opcodes E028 - E02F
Y028:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8342
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8343
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8343:
jmp @r4
mov r0,r2
ln8342:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8342
mov r1,r0
nobitover8342:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8345
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8345:
jmp @r4
mov r0,r2
! Opcodes E030 - E037
Y030:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8346
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8347
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8347:
jmp @r4
mov r0,r2
ln8346:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln8348:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln8348
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8349
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8349:
jmp @r4
mov r0,r2
! Opcodes E038 - E03F
Y038:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8350
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8351
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8351:
jmp @r4
mov r0,r2
ln8350:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln8352:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln8352
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8353
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8353:
jmp @r4
mov r0,r2
! Opcodes E040 - E047
Y040:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #-7,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8356
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8356:
jmp @r4
mov r0,r2
! Opcodes E048 - E04F
Y048:
and r1,r2
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-7,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8359
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8359:
jmp @r4
mov r0,r2
! Opcodes E050 - E057
Y050:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #8,r0
extu.w r3,r3
ln8361:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln8361
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8362
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8362:
jmp @r4
mov r0,r2
! Opcodes E058 - E05F
Y058:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #8,r0
extu.w r3,r3
ln8364:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln8364
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8365
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8365:
jmp @r4
mov r0,r2
! Opcodes E060 - E067
Y060:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8366
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8367
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8367:
jmp @r4
mov r0,r2
ln8366:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8366
mov r1,r0
nobitover8366:
add r13,r2
mov.w @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8369
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8369:
jmp @r4
mov r0,r2
! Opcodes E068 - E06F
Y068:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8370
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8371
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8371:
jmp @r4
mov r0,r2
ln8370:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8370
mov r1,r0
nobitover8370:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8373
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8373:
jmp @r4
mov r0,r2
! Opcodes E070 - E077
Y070:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8374
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8375
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8375:
jmp @r4
mov r0,r2
ln8374:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln8376:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln8376
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8377
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8377:
jmp @r4
mov r0,r2
! Opcodes E078 - E07F
Y078:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8378
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8379
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8379:
jmp @r4
mov r0,r2
ln8378:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln8380:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln8380
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8381
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8381:
jmp @r4
mov r0,r2
! Opcodes E080 - E087
Y080:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-7,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8384
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8384:
jmp @r4
mov r0,r2
! Opcodes E088 - E08F
Y088:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-7,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8387
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8387:
jmp @r4
mov r0,r2
! Opcodes E090 - E097
Y090:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #8,r0
ln8389:
rotcr r3
movt r8
dt r0
bf/s ln8389
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8390
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8390:
jmp @r4
mov r0,r2
! Opcodes E098 - E09F
Y098:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #8,r0
ln8392:
rotr r3
movt r8
dt r0
bf ln8392
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8393
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8393:
jmp @r4
mov r0,r2
! Opcodes E0A0 - E0A7
Y0A0:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8394
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8395
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8395:
jmp @r4
mov r0,r2
ln8394:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8394
mov r1,r0
nobitover8394:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8397
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8397:
jmp @r4
mov r0,r2
! Opcodes E0A8 - E0AF
Y0A8:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8398
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8399
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8399:
jmp @r4
mov r0,r2
ln8398:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8398
mov r1,r0
nobitover8398:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8401
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8401:
jmp @r4
mov r0,r2
! Opcodes E0B0 - E0B7
Y0B0:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8402
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8403
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8403:
jmp @r4
mov r0,r2
ln8402:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln8404:
rotcr r3
movt r8
dt r0
bf/s ln8404
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8405
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8405:
jmp @r4
mov r0,r2
! Opcodes E0B8 - E0BF
Y0B8:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8406
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8407
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8407:
jmp @r4
mov r0,r2
ln8406:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln8408:
rotr r3
movt r8
dt r0
bf ln8408
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8409
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8409:
jmp @r4
mov r0,r2
! Opcodes E0D0 - E0D7
Y0D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shar r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8410
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8410:
jmp @r4
mov r0,r2
! Opcodes E0D8 - E0DF
Y0D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shar r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8411
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8411:
jmp @r4
mov r0,r2
! Opcodes E0E0 - E0E7
Y0E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shar r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8412
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8412:
jmp @r4
mov r0,r2
! Opcodes E0E8 - E0EF
Y0E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shar r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8413
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8413:
jmp @r4
mov r0,r2
! Opcodes E0F0 - E0F7
Y0F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shar r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8414
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8414:
jmp @r4
mov r0,r2
! Opcode E0F8
Y0F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shar r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8415
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8415:
jmp @r4
mov r0,r2
! Opcode E0F9
Y0F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shar r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8416
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8416:
jmp @r4
mov r0,r2
! Opcodes E100 - E107
Y100:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8419
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8419:
jmp @r4
mov r0,r2
! Opcodes E108 - E10F
Y108:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #7,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8422
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8422:
jmp @r4
mov r0,r2
! Opcodes E110 - E117
Y110:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #8,r0
ln8424:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln8424
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8425
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8425:
jmp @r4
mov r0,r2
! Opcodes E118 - E11F
Y118:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #8,r0
ln8427:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln8427
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8428
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8428:
jmp @r4
mov r0,r2
! Opcodes E120 - E127
Y120:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8429
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8430
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8430:
jmp @r4
mov r0,r2
ln8429:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8429
mov r1,r0
nobitover8429:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln8431:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln8431
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8432
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8432:
jmp @r4
mov r0,r2
! Opcodes E128 - E12F
Y128:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8433
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8434
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8434:
jmp @r4
mov r0,r2
ln8433:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8433
mov r1,r0
nobitover8433:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8436
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8436:
jmp @r4
mov r0,r2
! Opcodes E130 - E137
Y130:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8437
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8438
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8438:
jmp @r4
mov r0,r2
ln8437:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln8439:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln8439
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8440
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8440:
jmp @r4
mov r0,r2
! Opcodes E138 - E13F
Y138:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8441
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8442
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8442:
jmp @r4
mov r0,r2
ln8441:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln8443:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln8443
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8444
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8444:
jmp @r4
mov r0,r2
! Opcodes E140 - E147
Y140:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8447
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8447:
jmp @r4
mov r0,r2
! Opcodes E148 - E14F
Y148:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #7,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8450
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8450:
jmp @r4
mov r0,r2
! Opcodes E150 - E157
Y150:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #8,r0
ln8452:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln8452
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8453
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8453:
jmp @r4
mov r0,r2
! Opcodes E158 - E15F
Y158:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #8,r0
ln8455:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln8455
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8456
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8456:
jmp @r4
mov r0,r2
! Opcodes E160 - E167
Y160:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8457
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8458
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8458:
jmp @r4
mov r0,r2
ln8457:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8457
mov r1,r0
nobitover8457:
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln8459:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln8459
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8460
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8460:
jmp @r4
mov r0,r2
! Opcodes E168 - E16F
Y168:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8461
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8462
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8462:
jmp @r4
mov r0,r2
ln8461:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8461
mov r1,r0
nobitover8461:
add r13,r2
mov.w @r2,r3
shll16 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8464
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8464:
jmp @r4
mov r0,r2
! Opcodes E170 - E177
Y170:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8465
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8466
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8466:
jmp @r4
mov r0,r2
ln8465:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln8467:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln8467
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8468
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8468:
jmp @r4
mov r0,r2
! Opcodes E178 - E17F
Y178:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8469
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8470
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8470:
jmp @r4
mov r0,r2
ln8469:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln8471:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln8471
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8472
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8472:
jmp @r4
mov r0,r2
! Opcodes E180 - E187
Y180:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8475
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8475:
jmp @r4
mov r0,r2
! Opcodes E188 - E18F
Y188:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #7,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8478
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8478:
jmp @r4
mov r0,r2
! Opcodes E190 - E197
Y190:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #8,r0
ln8480:
rotcl r3
movt r8
dt r0
bf/s ln8480
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8481
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8481:
jmp @r4
mov r0,r2
! Opcodes E198 - E19F
Y198:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #8,r0
ln8483:
rotl r3
movt r8
dt r0
bf ln8483
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-24,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8484
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8484:
jmp @r4
mov r0,r2
! Opcodes E1A0 - E1A7
Y1A0:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8485
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8486
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8486:
jmp @r4
mov r0,r2
ln8485:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8485
mov r1,r0
nobitover8485:
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln8487:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln8487
cmp/pl r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8488
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8488:
jmp @r4
mov r0,r2
! Opcodes E1A8 - E1AF
Y1A8:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8489
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8490
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8490:
jmp @r4
mov r0,r2
ln8489:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8489
mov r1,r0
nobitover8489:
add r13,r2
mov.l @r2,r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8492
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8492:
jmp @r4
mov r0,r2
! Opcodes E1B0 - E1B7
Y1B0:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8493
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8494
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8494:
jmp @r4
mov r0,r2
ln8493:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln8495:
rotcl r3
movt r8
dt r0
bf/s ln8495
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8496
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8496:
jmp @r4
mov r0,r2
! Opcodes E1B8 - E1BF
Y1B8:
and r1,r2
mov.l @r13,r0
and #0x3F,r0
tst r0,r0
bf ln8497
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8498
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8498:
jmp @r4
mov r0,r2
ln8497:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln8499:
rotl r3
movt r8
dt r0
bf ln8499
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8500
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8500:
jmp @r4
mov r0,r2
! Opcodes E1D0 - E1D7
Y1D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8501
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8501:
jmp @r4
mov r0,r2
! Opcodes E1D8 - E1DF
Y1D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8502
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8502:
jmp @r4
mov r0,r2
! Opcodes E1E0 - E1E7
Y1E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8503
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8503:
jmp @r4
mov r0,r2
! Opcodes E1E8 - E1EF
Y1E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8504
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8504:
jmp @r4
mov r0,r2
! Opcodes E1F0 - E1F7
Y1F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8505
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8505:
jmp @r4
mov r0,r2
! Opcode E1F8
Y1F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8506
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8506:
jmp @r4
mov r0,r2
! Opcode E1F9
Y1F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shal r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
mov r3,r0
shll r0
movt r0
xor r8,r0
shll r0
or r0,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8507
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8507:
jmp @r4
mov r0,r2
! Opcodes E200 - E207
Y200:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8510
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8510:
jmp @r4
mov r0,r2
! Opcodes E208 - E20F
Y208:
and r1,r2
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8513
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8513:
jmp @r4
mov r0,r2
! Opcodes E210 - E217
Y210:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #1,r0
extu.b r3,r3
ln8515:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln8515
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8516
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8516:
jmp @r4
mov r0,r2
! Opcodes E218 - E21F
Y218:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #1,r0
extu.b r3,r3
ln8518:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln8518
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8519
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8519:
jmp @r4
mov r0,r2
! Opcodes E220 - E227
Y220:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8520
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8521
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8521:
jmp @r4
mov r0,r2
ln8520:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8520
mov r1,r0
nobitover8520:
add r13,r2
mov.b @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8523
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8523:
jmp @r4
mov r0,r2
! Opcodes E228 - E22F
Y228:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8524
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8525
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8525:
jmp @r4
mov r0,r2
ln8524:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8524
mov r1,r0
nobitover8524:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8527
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8527:
jmp @r4
mov r0,r2
! Opcodes E230 - E237
Y230:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8528
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8529
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8529:
jmp @r4
mov r0,r2
ln8528:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln8530:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln8530
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8531
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8531:
jmp @r4
mov r0,r2
! Opcodes E238 - E23F
Y238:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8532
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8533
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8533:
jmp @r4
mov r0,r2
ln8532:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln8534:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln8534
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8535
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8535:
jmp @r4
mov r0,r2
! Opcodes E240 - E247
Y240:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8538
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8538:
jmp @r4
mov r0,r2
! Opcodes E248 - E24F
Y248:
and r1,r2
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8541
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8541:
jmp @r4
mov r0,r2
! Opcodes E250 - E257
Y250:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #1,r0
extu.w r3,r3
ln8543:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln8543
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8544
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8544:
jmp @r4
mov r0,r2
! Opcodes E258 - E25F
Y258:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #1,r0
extu.w r3,r3
ln8546:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln8546
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8547
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8547:
jmp @r4
mov r0,r2
! Opcodes E260 - E267
Y260:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8548
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8549
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8549:
jmp @r4
mov r0,r2
ln8548:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8548
mov r1,r0
nobitover8548:
add r13,r2
mov.w @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8551
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8551:
jmp @r4
mov r0,r2
! Opcodes E268 - E26F
Y268:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8552
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8553
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8553:
jmp @r4
mov r0,r2
ln8552:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8552
mov r1,r0
nobitover8552:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8555
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8555:
jmp @r4
mov r0,r2
! Opcodes E270 - E277
Y270:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8556
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8557
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8557:
jmp @r4
mov r0,r2
ln8556:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln8558:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln8558
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8559
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8559:
jmp @r4
mov r0,r2
! Opcodes E278 - E27F
Y278:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8560
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8561
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8561:
jmp @r4
mov r0,r2
ln8560:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln8562:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln8562
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8563
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8563:
jmp @r4
mov r0,r2
! Opcodes E280 - E287
Y280:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8566
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8566:
jmp @r4
mov r0,r2
! Opcodes E288 - E28F
Y288:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8569
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8569:
jmp @r4
mov r0,r2
! Opcodes E290 - E297
Y290:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #1,r0
ln8571:
rotcr r3
movt r8
dt r0
bf/s ln8571
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8572
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8572:
jmp @r4
mov r0,r2
! Opcodes E298 - E29F
Y298:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #1,r0
ln8574:
rotr r3
movt r8
dt r0
bf ln8574
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8575
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8575:
jmp @r4
mov r0,r2
! Opcodes E2A0 - E2A7
Y2A0:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8576
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8577
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8577:
jmp @r4
mov r0,r2
ln8576:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8576
mov r1,r0
nobitover8576:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8579
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8579:
jmp @r4
mov r0,r2
! Opcodes E2A8 - E2AF
Y2A8:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8580
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8581
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8581:
jmp @r4
mov r0,r2
ln8580:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8580
mov r1,r0
nobitover8580:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8583
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8583:
jmp @r4
mov r0,r2
! Opcodes E2B0 - E2B7
Y2B0:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8584
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8585
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8585:
jmp @r4
mov r0,r2
ln8584:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln8586:
rotcr r3
movt r8
dt r0
bf/s ln8586
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8587
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8587:
jmp @r4
mov r0,r2
! Opcodes E2B8 - E2BF
Y2B8:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8588
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8589
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8589:
jmp @r4
mov r0,r2
ln8588:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln8590:
rotr r3
movt r8
dt r0
bf ln8590
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8591
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8591:
jmp @r4
mov r0,r2
! Opcodes E2D0 - E2D7
Y2D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8592
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8592:
jmp @r4
mov r0,r2
! Opcodes E2D8 - E2DF
Y2D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8593
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8593:
jmp @r4
mov r0,r2
! Opcodes E2E0 - E2E7
Y2E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8594
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8594:
jmp @r4
mov r0,r2
! Opcodes E2E8 - E2EF
Y2E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8595
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8595:
jmp @r4
mov r0,r2
! Opcodes E2F0 - E2F7
Y2F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8596
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8596:
jmp @r4
mov r0,r2
! Opcode E2F8
Y2F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8597
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8597:
jmp @r4
mov r0,r2
! Opcode E2F9
Y2F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
shlr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8598
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8598:
jmp @r4
mov r0,r2
! Opcodes E300 - E307
Y300:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
addv r3,r3
movt r8
shal r1
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8601
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8601:
jmp @r4
mov r0,r2
! Opcodes E308 - E30F
Y308:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8604
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8604:
jmp @r4
mov r0,r2
! Opcodes E310 - E317
Y310:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #1,r0
ln8606:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln8606
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8607
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8607:
jmp @r4
mov r0,r2
! Opcodes E318 - E31F
Y318:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #1,r0
ln8609:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln8609
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8610
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8610:
jmp @r4
mov r0,r2
! Opcodes E320 - E327
Y320:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8611
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8612
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8612:
jmp @r4
mov r0,r2
ln8611:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8611
mov r1,r0
nobitover8611:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln8613:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln8613
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8614
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8614:
jmp @r4
mov r0,r2
! Opcodes E328 - E32F
Y328:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8615
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8616
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8616:
jmp @r4
mov r0,r2
ln8615:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8615
mov r1,r0
nobitover8615:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8618
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8618:
jmp @r4
mov r0,r2
! Opcodes E330 - E337
Y330:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8619
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8620
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8620:
jmp @r4
mov r0,r2
ln8619:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln8621:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln8621
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8622
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8622:
jmp @r4
mov r0,r2
! Opcodes E338 - E33F
Y338:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8623
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8624
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8624:
jmp @r4
mov r0,r2
ln8623:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln8625:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln8625
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8626
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8626:
jmp @r4
mov r0,r2
! Opcodes E340 - E347
Y340:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
addv r3,r3
movt r8
shal r1
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8629
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8629:
jmp @r4
mov r0,r2
! Opcodes E348 - E34F
Y348:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8632
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8632:
jmp @r4
mov r0,r2
! Opcodes E350 - E357
Y350:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #1,r0
ln8634:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln8634
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8635
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8635:
jmp @r4
mov r0,r2
! Opcodes E358 - E35F
Y358:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #1,r0
ln8637:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln8637
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8638
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8638:
jmp @r4
mov r0,r2
! Opcodes E360 - E367
Y360:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8639
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8640
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8640:
jmp @r4
mov r0,r2
ln8639:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8639
mov r1,r0
nobitover8639:
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln8641:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln8641
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8642
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8642:
jmp @r4
mov r0,r2
! Opcodes E368 - E36F
Y368:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8643
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8644
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8644:
jmp @r4
mov r0,r2
ln8643:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8643
mov r1,r0
nobitover8643:
add r13,r2
mov.w @r2,r3
shll16 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8646
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8646:
jmp @r4
mov r0,r2
! Opcodes E370 - E377
Y370:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8647
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8648
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8648:
jmp @r4
mov r0,r2
ln8647:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln8649:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln8649
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8650
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8650:
jmp @r4
mov r0,r2
! Opcodes E378 - E37F
Y378:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8651
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8652
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8652:
jmp @r4
mov r0,r2
ln8651:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln8653:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln8653
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8654
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8654:
jmp @r4
mov r0,r2
! Opcodes E380 - E387
Y380:
and r1,r2
add r13,r2
mov.l @r2,r3
mov r3,r1
addv r3,r3
movt r8
shal r1
movt r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8657
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8657:
jmp @r4
mov r0,r2
! Opcodes E388 - E38F
Y388:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8660
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8660:
jmp @r4
mov r0,r2
! Opcodes E390 - E397
Y390:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #1,r0
ln8662:
rotcl r3
movt r8
dt r0
bf/s ln8662
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8663
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8663:
jmp @r4
mov r0,r2
! Opcodes E398 - E39F
Y398:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #1,r0
ln8665:
rotl r3
movt r8
dt r0
bf ln8665
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8666
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8666:
jmp @r4
mov r0,r2
! Opcodes E3A0 - E3A7
Y3A0:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8667
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8668
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8668:
jmp @r4
mov r0,r2
ln8667:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8667
mov r1,r0
nobitover8667:
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln8669:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln8669
cmp/pl r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8670
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8670:
jmp @r4
mov r0,r2
! Opcodes E3A8 - E3AF
Y3A8:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8671
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8672
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8672:
jmp @r4
mov r0,r2
ln8671:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8671
mov r1,r0
nobitover8671:
add r13,r2
mov.l @r2,r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8674
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8674:
jmp @r4
mov r0,r2
! Opcodes E3B0 - E3B7
Y3B0:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8675
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8676
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8676:
jmp @r4
mov r0,r2
ln8675:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln8677:
rotcl r3
movt r8
dt r0
bf/s ln8677
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8678
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8678:
jmp @r4
mov r0,r2
! Opcodes E3B8 - E3BF
Y3B8:
and r1,r2
mov.l @(4,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8679
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8680
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8680:
jmp @r4
mov r0,r2
ln8679:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln8681:
rotl r3
movt r8
dt r0
bf ln8681
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8682
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8682:
jmp @r4
mov r0,r2
! Opcodes E3D0 - E3D7
Y3D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8683
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8683:
jmp @r4
mov r0,r2
! Opcodes E3D8 - E3DF
Y3D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8684
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8684:
jmp @r4
mov r0,r2
! Opcodes E3E0 - E3E7
Y3E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8685
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8685:
jmp @r4
mov r0,r2
! Opcodes E3E8 - E3EF
Y3E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8686
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8686:
jmp @r4
mov r0,r2
! Opcodes E3F0 - E3F7
Y3F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8687
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8687:
jmp @r4
mov r0,r2
! Opcode E3F8
Y3F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8688
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8688:
jmp @r4
mov r0,r2
! Opcode E3F9
Y3F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shll r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8689
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8689:
jmp @r4
mov r0,r2
! Opcodes E400 - E407
Y400:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #-1,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8692
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8692:
jmp @r4
mov r0,r2
! Opcodes E408 - E40F
Y408:
and r1,r2
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-1,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8695
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8695:
jmp @r4
mov r0,r2
! Opcodes E410 - E417
Y410:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #2,r0
extu.b r3,r3
ln8697:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln8697
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8698
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8698:
jmp @r4
mov r0,r2
! Opcodes E418 - E41F
Y418:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #2,r0
extu.b r3,r3
ln8700:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln8700
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8701
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8701:
jmp @r4
mov r0,r2
! Opcodes E420 - E427
Y420:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8702
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8703
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8703:
jmp @r4
mov r0,r2
ln8702:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8702
mov r1,r0
nobitover8702:
add r13,r2
mov.b @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8705
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8705:
jmp @r4
mov r0,r2
! Opcodes E428 - E42F
Y428:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8706
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8707
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8707:
jmp @r4
mov r0,r2
ln8706:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8706
mov r1,r0
nobitover8706:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8709
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8709:
jmp @r4
mov r0,r2
! Opcodes E430 - E437
Y430:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8710
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8711
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8711:
jmp @r4
mov r0,r2
ln8710:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln8712:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln8712
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8713
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8713:
jmp @r4
mov r0,r2
! Opcodes E438 - E43F
Y438:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8714
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8715
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8715:
jmp @r4
mov r0,r2
ln8714:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln8716:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln8716
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8717
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8717:
jmp @r4
mov r0,r2
! Opcodes E440 - E447
Y440:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #-1,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8720
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8720:
jmp @r4
mov r0,r2
! Opcodes E448 - E44F
Y448:
and r1,r2
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-1,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8723
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8723:
jmp @r4
mov r0,r2
! Opcodes E450 - E457
Y450:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #2,r0
extu.w r3,r3
ln8725:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln8725
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8726
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8726:
jmp @r4
mov r0,r2
! Opcodes E458 - E45F
Y458:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #2,r0
extu.w r3,r3
ln8728:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln8728
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8729
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8729:
jmp @r4
mov r0,r2
! Opcodes E460 - E467
Y460:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8730
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8731
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8731:
jmp @r4
mov r0,r2
ln8730:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8730
mov r1,r0
nobitover8730:
add r13,r2
mov.w @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8733
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8733:
jmp @r4
mov r0,r2
! Opcodes E468 - E46F
Y468:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8734
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8735
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8735:
jmp @r4
mov r0,r2
ln8734:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8734
mov r1,r0
nobitover8734:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8737
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8737:
jmp @r4
mov r0,r2
! Opcodes E470 - E477
Y470:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8738
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8739
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8739:
jmp @r4
mov r0,r2
ln8738:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln8740:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln8740
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8741
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8741:
jmp @r4
mov r0,r2
! Opcodes E478 - E47F
Y478:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8742
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8743
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8743:
jmp @r4
mov r0,r2
ln8742:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln8744:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln8744
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8745
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8745:
jmp @r4
mov r0,r2
! Opcodes E480 - E487
Y480:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-1,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8748
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8748:
jmp @r4
mov r0,r2
! Opcodes E488 - E48F
Y488:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-1,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8751
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8751:
jmp @r4
mov r0,r2
! Opcodes E490 - E497
Y490:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #2,r0
ln8753:
rotcr r3
movt r8
dt r0
bf/s ln8753
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8754
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8754:
jmp @r4
mov r0,r2
! Opcodes E498 - E49F
Y498:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #2,r0
ln8756:
rotr r3
movt r8
dt r0
bf ln8756
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8757
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8757:
jmp @r4
mov r0,r2
! Opcodes E4A0 - E4A7
Y4A0:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8758
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8759
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8759:
jmp @r4
mov r0,r2
ln8758:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8758
mov r1,r0
nobitover8758:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8761
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8761:
jmp @r4
mov r0,r2
! Opcodes E4A8 - E4AF
Y4A8:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8762
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8763
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8763:
jmp @r4
mov r0,r2
ln8762:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8762
mov r1,r0
nobitover8762:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8765
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8765:
jmp @r4
mov r0,r2
! Opcodes E4B0 - E4B7
Y4B0:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8766
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8767
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8767:
jmp @r4
mov r0,r2
ln8766:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln8768:
rotcr r3
movt r8
dt r0
bf/s ln8768
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8769
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8769:
jmp @r4
mov r0,r2
! Opcodes E4B8 - E4BF
Y4B8:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8770
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8771
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8771:
jmp @r4
mov r0,r2
ln8770:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln8772:
rotr r3
movt r8
dt r0
bf ln8772
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8773
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8773:
jmp @r4
mov r0,r2
! Opcodes E4D0 - E4D7
Y4D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8774
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8774:
jmp @r4
mov r0,r2
! Opcodes E4D8 - E4DF
Y4D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8775
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8775:
jmp @r4
mov r0,r2
! Opcodes E4E0 - E4E7
Y4E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8776
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8776:
jmp @r4
mov r0,r2
! Opcodes E4E8 - E4EF
Y4E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8777
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8777:
jmp @r4
mov r0,r2
! Opcodes E4F0 - E4F7
Y4F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8778
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8778:
jmp @r4
mov r0,r2
! Opcode E4F8
Y4F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8779
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8779:
jmp @r4
mov r0,r2
! Opcode E4F9
Y4F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
extu.w r3,r3
rotcr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8780
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8780:
jmp @r4
mov r0,r2
! Opcodes E500 - E507
Y500:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8783
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8783:
jmp @r4
mov r0,r2
! Opcodes E508 - E50F
Y508:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #1,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8786
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8786:
jmp @r4
mov r0,r2
! Opcodes E510 - E517
Y510:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #2,r0
ln8788:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln8788
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8789
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8789:
jmp @r4
mov r0,r2
! Opcodes E518 - E51F
Y518:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #2,r0
ln8791:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln8791
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8792
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8792:
jmp @r4
mov r0,r2
! Opcodes E520 - E527
Y520:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8793
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8794
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8794:
jmp @r4
mov r0,r2
ln8793:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8793
mov r1,r0
nobitover8793:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln8795:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln8795
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8796
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8796:
jmp @r4
mov r0,r2
! Opcodes E528 - E52F
Y528:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8797
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8798
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8798:
jmp @r4
mov r0,r2
ln8797:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8797
mov r1,r0
nobitover8797:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8800
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8800:
jmp @r4
mov r0,r2
! Opcodes E530 - E537
Y530:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8801
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8802
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8802:
jmp @r4
mov r0,r2
ln8801:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln8803:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln8803
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8804
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8804:
jmp @r4
mov r0,r2
! Opcodes E538 - E53F
Y538:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8805
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8806
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8806:
jmp @r4
mov r0,r2
ln8805:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln8807:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln8807
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8808
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8808:
jmp @r4
mov r0,r2
! Opcodes E540 - E547
Y540:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8811
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8811:
jmp @r4
mov r0,r2
! Opcodes E548 - E54F
Y548:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #1,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8814
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8814:
jmp @r4
mov r0,r2
! Opcodes E550 - E557
Y550:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #2,r0
ln8816:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln8816
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8817
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8817:
jmp @r4
mov r0,r2
! Opcodes E558 - E55F
Y558:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #2,r0
ln8819:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln8819
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-10,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8820
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8820:
jmp @r4
mov r0,r2
! Opcodes E560 - E567
Y560:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8821
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8822
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8822:
jmp @r4
mov r0,r2
ln8821:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8821
mov r1,r0
nobitover8821:
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln8823:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln8823
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8824
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8824:
jmp @r4
mov r0,r2
! Opcodes E568 - E56F
Y568:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8825
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8826
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8826:
jmp @r4
mov r0,r2
ln8825:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8825
mov r1,r0
nobitover8825:
add r13,r2
mov.w @r2,r3
shll16 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8828
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8828:
jmp @r4
mov r0,r2
! Opcodes E570 - E577
Y570:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8829
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8830
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8830:
jmp @r4
mov r0,r2
ln8829:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln8831:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln8831
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8832
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8832:
jmp @r4
mov r0,r2
! Opcodes E578 - E57F
Y578:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8833
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8834
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8834:
jmp @r4
mov r0,r2
ln8833:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln8835:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln8835
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8836
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8836:
jmp @r4
mov r0,r2
! Opcodes E580 - E587
Y580:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8839
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8839:
jmp @r4
mov r0,r2
! Opcodes E588 - E58F
Y588:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #1,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8842
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8842:
jmp @r4
mov r0,r2
! Opcodes E590 - E597
Y590:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #2,r0
ln8844:
rotcl r3
movt r8
dt r0
bf/s ln8844
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8845
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8845:
jmp @r4
mov r0,r2
! Opcodes E598 - E59F
Y598:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #2,r0
ln8847:
rotl r3
movt r8
dt r0
bf ln8847
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8848
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8848:
jmp @r4
mov r0,r2
! Opcodes E5A0 - E5A7
Y5A0:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8849
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8850
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8850:
jmp @r4
mov r0,r2
ln8849:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8849
mov r1,r0
nobitover8849:
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln8851:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln8851
cmp/pl r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8852
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8852:
jmp @r4
mov r0,r2
! Opcodes E5A8 - E5AF
Y5A8:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8853
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8854
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8854:
jmp @r4
mov r0,r2
ln8853:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8853
mov r1,r0
nobitover8853:
add r13,r2
mov.l @r2,r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8856
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8856:
jmp @r4
mov r0,r2
! Opcodes E5B0 - E5B7
Y5B0:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8857
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8858
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8858:
jmp @r4
mov r0,r2
ln8857:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln8859:
rotcl r3
movt r8
dt r0
bf/s ln8859
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8860
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8860:
jmp @r4
mov r0,r2
! Opcodes E5B8 - E5BF
Y5B8:
and r1,r2
mov.l @(8,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8861
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8862
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8862:
jmp @r4
mov r0,r2
ln8861:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln8863:
rotl r3
movt r8
dt r0
bf ln8863
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8864
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8864:
jmp @r4
mov r0,r2
! Opcodes E5D0 - E5D7
Y5D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8865
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8865:
jmp @r4
mov r0,r2
! Opcodes E5D8 - E5DF
Y5D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8866
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8866:
jmp @r4
mov r0,r2
! Opcodes E5E0 - E5E7
Y5E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8867
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8867:
jmp @r4
mov r0,r2
! Opcodes E5E8 - E5EF
Y5E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8868
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8868:
jmp @r4
mov r0,r2
! Opcodes E5F0 - E5F7
Y5F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8869
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8869:
jmp @r4
mov r0,r2
! Opcode E5F8
Y5F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8870
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8870:
jmp @r4
mov r0,r2
! Opcode E5F9
Y5F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
shlr r9
rotcl r3
movt r8
movt r9
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8871
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8871:
jmp @r4
mov r0,r2
! Opcodes E600 - E607
Y600:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #-2,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8874
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8874:
jmp @r4
mov r0,r2
! Opcodes E608 - E60F
Y608:
and r1,r2
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-2,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8877
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8877:
jmp @r4
mov r0,r2
! Opcodes E610 - E617
Y610:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #3,r0
extu.b r3,r3
ln8879:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln8879
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8880
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8880:
jmp @r4
mov r0,r2
! Opcodes E618 - E61F
Y618:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #3,r0
extu.b r3,r3
ln8882:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln8882
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8883
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8883:
jmp @r4
mov r0,r2
! Opcodes E620 - E627
Y620:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8884
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8885
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8885:
jmp @r4
mov r0,r2
ln8884:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8884
mov r1,r0
nobitover8884:
add r13,r2
mov.b @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8887
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8887:
jmp @r4
mov r0,r2
! Opcodes E628 - E62F
Y628:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8888
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8889
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8889:
jmp @r4
mov r0,r2
ln8888:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8888
mov r1,r0
nobitover8888:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8891
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8891:
jmp @r4
mov r0,r2
! Opcodes E630 - E637
Y630:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8892
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8893
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8893:
jmp @r4
mov r0,r2
ln8892:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln8894:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln8894
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8895
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8895:
jmp @r4
mov r0,r2
! Opcodes E638 - E63F
Y638:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8896
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8897
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8897:
jmp @r4
mov r0,r2
ln8896:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln8898:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln8898
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8899
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8899:
jmp @r4
mov r0,r2
! Opcodes E640 - E647
Y640:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #-2,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8902
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8902:
jmp @r4
mov r0,r2
! Opcodes E648 - E64F
Y648:
and r1,r2
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-2,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8905
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8905:
jmp @r4
mov r0,r2
! Opcodes E650 - E657
Y650:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #3,r0
extu.w r3,r3
ln8907:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln8907
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8908
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8908:
jmp @r4
mov r0,r2
! Opcodes E658 - E65F
Y658:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #3,r0
extu.w r3,r3
ln8910:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln8910
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8911
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8911:
jmp @r4
mov r0,r2
! Opcodes E660 - E667
Y660:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8912
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8913
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8913:
jmp @r4
mov r0,r2
ln8912:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8912
mov r1,r0
nobitover8912:
add r13,r2
mov.w @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8915
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8915:
jmp @r4
mov r0,r2
! Opcodes E668 - E66F
Y668:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8916
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8917
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8917:
jmp @r4
mov r0,r2
ln8916:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8916
mov r1,r0
nobitover8916:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8919
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8919:
jmp @r4
mov r0,r2
! Opcodes E670 - E677
Y670:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8920
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8921
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8921:
jmp @r4
mov r0,r2
ln8920:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln8922:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln8922
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8923
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8923:
jmp @r4
mov r0,r2
! Opcodes E678 - E67F
Y678:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8924
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8925
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8925:
jmp @r4
mov r0,r2
ln8924:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln8926:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln8926
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8927
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8927:
jmp @r4
mov r0,r2
! Opcodes E680 - E687
Y680:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-2,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8930
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8930:
jmp @r4
mov r0,r2
! Opcodes E688 - E68F
Y688:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-2,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8933
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8933:
jmp @r4
mov r0,r2
! Opcodes E690 - E697
Y690:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #3,r0
ln8935:
rotcr r3
movt r8
dt r0
bf/s ln8935
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8936
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8936:
jmp @r4
mov r0,r2
! Opcodes E698 - E69F
Y698:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #3,r0
ln8938:
rotr r3
movt r8
dt r0
bf ln8938
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8939
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8939:
jmp @r4
mov r0,r2
! Opcodes E6A0 - E6A7
Y6A0:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8940
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8941
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8941:
jmp @r4
mov r0,r2
ln8940:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8940
mov r1,r0
nobitover8940:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8943
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8943:
jmp @r4
mov r0,r2
! Opcodes E6A8 - E6AF
Y6A8:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8944
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8945
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8945:
jmp @r4
mov r0,r2
ln8944:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8944
mov r1,r0
nobitover8944:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8947
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8947:
jmp @r4
mov r0,r2
! Opcodes E6B0 - E6B7
Y6B0:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8948
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8949
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8949:
jmp @r4
mov r0,r2
ln8948:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln8950:
rotcr r3
movt r8
dt r0
bf/s ln8950
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8951
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8951:
jmp @r4
mov r0,r2
! Opcodes E6B8 - E6BF
Y6B8:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8952
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8953
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8953:
jmp @r4
mov r0,r2
ln8952:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln8954:
rotr r3
movt r8
dt r0
bf ln8954
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8955
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8955:
jmp @r4
mov r0,r2
! Opcodes E6D0 - E6D7
Y6D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8956
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8956:
jmp @r4
mov r0,r2
! Opcodes E6D8 - E6DF
Y6D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8957
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8957:
jmp @r4
mov r0,r2
! Opcodes E6E0 - E6E7
Y6E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8958
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8958:
jmp @r4
mov r0,r2
! Opcodes E6E8 - E6EF
Y6E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8959
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8959:
jmp @r4
mov r0,r2
! Opcodes E6F0 - E6F7
Y6F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8960
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8960:
jmp @r4
mov r0,r2
! Opcode E6F8
Y6F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8961
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8961:
jmp @r4
mov r0,r2
! Opcode E6F9
Y6F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
extu.w r3,r3
rotr r3
mov r3,r0
shlr16 r0
or r0,r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8962
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8962:
jmp @r4
mov r0,r2
! Opcodes E700 - E707
Y700:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8965
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8965:
jmp @r4
mov r0,r2
! Opcodes E708 - E70F
Y708:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #2,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8968
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8968:
jmp @r4
mov r0,r2
! Opcodes E710 - E717
Y710:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #3,r0
ln8970:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln8970
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8971
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8971:
jmp @r4
mov r0,r2
! Opcodes E718 - E71F
Y718:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #3,r0
ln8973:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln8973
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8974
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8974:
jmp @r4
mov r0,r2
! Opcodes E720 - E727
Y720:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8975
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8976
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8976:
jmp @r4
mov r0,r2
ln8975:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8975
mov r1,r0
nobitover8975:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln8977:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln8977
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8978
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8978:
jmp @r4
mov r0,r2
! Opcodes E728 - E72F
Y728:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8979
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8980
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8980:
jmp @r4
mov r0,r2
ln8979:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover8979
mov r1,r0
nobitover8979:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8982
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8982:
jmp @r4
mov r0,r2
! Opcodes E730 - E737
Y730:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8983
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8984
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8984:
jmp @r4
mov r0,r2
ln8983:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln8985:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln8985
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8986
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8986:
jmp @r4
mov r0,r2
! Opcodes E738 - E73F
Y738:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln8987
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8988
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8988:
jmp @r4
mov r0,r2
ln8987:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln8989:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln8989
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8990
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8990:
jmp @r4
mov r0,r2
! Opcodes E740 - E747
Y740:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8993
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8993:
jmp @r4
mov r0,r2
! Opcodes E748 - E74F
Y748:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #2,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8996
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8996:
jmp @r4
mov r0,r2
! Opcodes E750 - E757
Y750:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #3,r0
ln8998:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln8998
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl8999
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl8999:
jmp @r4
mov r0,r2
! Opcodes E758 - E75F
Y758:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #3,r0
ln9001:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln9001
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9002
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9002:
jmp @r4
mov r0,r2
! Opcodes E760 - E767
Y760:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9003
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9004
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9004:
jmp @r4
mov r0,r2
ln9003:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9003
mov r1,r0
nobitover9003:
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln9005:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9005
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9006
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9006:
jmp @r4
mov r0,r2
! Opcodes E768 - E76F
Y768:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9007
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9008
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9008:
jmp @r4
mov r0,r2
ln9007:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9007
mov r1,r0
nobitover9007:
add r13,r2
mov.w @r2,r3
shll16 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9010
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9010:
jmp @r4
mov r0,r2
! Opcodes E770 - E777
Y770:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9011
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9012
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9012:
jmp @r4
mov r0,r2
ln9011:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln9013:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln9013
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9014
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9014:
jmp @r4
mov r0,r2
! Opcodes E778 - E77F
Y778:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9015
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9016
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9016:
jmp @r4
mov r0,r2
ln9015:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln9017:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln9017
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9018
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9018:
jmp @r4
mov r0,r2
! Opcodes E780 - E787
Y780:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9021
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9021:
jmp @r4
mov r0,r2
! Opcodes E788 - E78F
Y788:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #2,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9024
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9024:
jmp @r4
mov r0,r2
! Opcodes E790 - E797
Y790:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #3,r0
ln9026:
rotcl r3
movt r8
dt r0
bf/s ln9026
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9027
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9027:
jmp @r4
mov r0,r2
! Opcodes E798 - E79F
Y798:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #3,r0
ln9029:
rotl r3
movt r8
dt r0
bf ln9029
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9030
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9030:
jmp @r4
mov r0,r2
! Opcodes E7A0 - E7A7
Y7A0:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9031
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9032
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9032:
jmp @r4
mov r0,r2
ln9031:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9031
mov r1,r0
nobitover9031:
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln9033:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9033
cmp/pl r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9034
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9034:
jmp @r4
mov r0,r2
! Opcodes E7A8 - E7AF
Y7A8:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9035
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9036
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9036:
jmp @r4
mov r0,r2
ln9035:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9035
mov r1,r0
nobitover9035:
add r13,r2
mov.l @r2,r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9038
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9038:
jmp @r4
mov r0,r2
! Opcodes E7B0 - E7B7
Y7B0:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9039
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9040
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9040:
jmp @r4
mov r0,r2
ln9039:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln9041:
rotcl r3
movt r8
dt r0
bf/s ln9041
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9042
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9042:
jmp @r4
mov r0,r2
! Opcodes E7B8 - E7BF
Y7B8:
and r1,r2
mov.l @(12,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9043
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9044
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9044:
jmp @r4
mov r0,r2
ln9043:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln9045:
rotl r3
movt r8
dt r0
bf ln9045
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9046
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9046:
jmp @r4
mov r0,r2
! Opcodes E7D0 - E7D7
Y7D0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9047
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9047:
jmp @r4
mov r0,r2
! Opcodes E7D8 - E7DF
Y7D8:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
add #2,r4
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-12,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9048
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9048:
jmp @r4
mov r0,r2
! Opcodes E7E0 - E7E7
Y7E0:
and r1,r2
mov r2,r0
mov.l @(r0,r14),r4
add #-2,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
mov r2,r0
mov.l r4,@(r0,r14)
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9049
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9049:
jmp @r4
mov r0,r2
! Opcodes E7E8 - E7EF
Y7E8:
and r1,r2
mov.w @r6+,r4
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9050
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9050:
jmp @r4
mov r0,r2
! Opcodes E7F0 - E7F7
Y7F0:
and r1,r2
mov.l @(decode_extw_addr-fetch_idx,r11),r4
jsr @r4
nop
mov r2,r0
mov.l @(r0,r14),r1
add r1,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9051
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9051:
jmp @r4
mov r0,r2
! Opcode E7F8
Y7F8:
mov.w @r6+,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9052
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9052:
jmp @r4
mov r0,r2
! Opcode E7F9
Y7F9:
mov.w @r6+,r0
mov.w @r6+,r4
shll16 r4
xtrct r0,r4
mov.l @(rw_addr-fetch_idx,r11),r0
jsr @r0
nop
rotl r3
movt r8
mov.l @(ww_addr-fetch_idx,r11),r0
jsr @r0
nop
exts.w r3,r3
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9053
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9053:
jmp @r4
mov r0,r2
! Opcodes E800 - E807
Y800:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #-3,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9056
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9056:
jmp @r4
mov r0,r2
! Opcodes E808 - E80F
Y808:
and r1,r2
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-3,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9059
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9059:
jmp @r4
mov r0,r2
! Opcodes E810 - E817
Y810:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #4,r0
extu.b r3,r3
ln9061:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln9061
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9062
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9062:
jmp @r4
mov r0,r2
! Opcodes E818 - E81F
Y818:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #4,r0
extu.b r3,r3
ln9064:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln9064
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9065
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9065:
jmp @r4
mov r0,r2
! Opcodes E820 - E827
Y820:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9066
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9067
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9067:
jmp @r4
mov r0,r2
ln9066:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9066
mov r1,r0
nobitover9066:
add r13,r2
mov.b @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9069
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9069:
jmp @r4
mov r0,r2
! Opcodes E828 - E82F
Y828:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9070
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9071
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9071:
jmp @r4
mov r0,r2
ln9070:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9070
mov r1,r0
nobitover9070:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9073
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9073:
jmp @r4
mov r0,r2
! Opcodes E830 - E837
Y830:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9074
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9075
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9075:
jmp @r4
mov r0,r2
ln9074:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln9076:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln9076
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9077
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9077:
jmp @r4
mov r0,r2
! Opcodes E838 - E83F
Y838:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9078
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9079
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9079:
jmp @r4
mov r0,r2
ln9078:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln9080:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln9080
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9081
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9081:
jmp @r4
mov r0,r2
! Opcodes E840 - E847
Y840:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #-3,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9084
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9084:
jmp @r4
mov r0,r2
! Opcodes E848 - E84F
Y848:
and r1,r2
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-3,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9087
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9087:
jmp @r4
mov r0,r2
! Opcodes E850 - E857
Y850:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #4,r0
extu.w r3,r3
ln9089:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln9089
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9090
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9090:
jmp @r4
mov r0,r2
! Opcodes E858 - E85F
Y858:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #4,r0
extu.w r3,r3
ln9092:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln9092
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9093
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9093:
jmp @r4
mov r0,r2
! Opcodes E860 - E867
Y860:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9094
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9095
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9095:
jmp @r4
mov r0,r2
ln9094:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9094
mov r1,r0
nobitover9094:
add r13,r2
mov.w @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9097
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9097:
jmp @r4
mov r0,r2
! Opcodes E868 - E86F
Y868:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9098
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9099
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9099:
jmp @r4
mov r0,r2
ln9098:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9098
mov r1,r0
nobitover9098:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9101
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9101:
jmp @r4
mov r0,r2
! Opcodes E870 - E877
Y870:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9102
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9103
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9103:
jmp @r4
mov r0,r2
ln9102:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln9104:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln9104
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9105
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9105:
jmp @r4
mov r0,r2
! Opcodes E878 - E87F
Y878:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9106
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9107
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9107:
jmp @r4
mov r0,r2
ln9106:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln9108:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln9108
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9109
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9109:
jmp @r4
mov r0,r2
! Opcodes E880 - E887
Y880:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-3,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9112
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9112:
jmp @r4
mov r0,r2
! Opcodes E888 - E88F
Y888:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-3,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9115
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9115:
jmp @r4
mov r0,r2
! Opcodes E890 - E897
Y890:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #4,r0
ln9117:
rotcr r3
movt r8
dt r0
bf/s ln9117
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9118
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9118:
jmp @r4
mov r0,r2
! Opcodes E898 - E89F
Y898:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #4,r0
ln9120:
rotr r3
movt r8
dt r0
bf ln9120
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9121
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9121:
jmp @r4
mov r0,r2
! Opcodes E8A0 - E8A7
Y8A0:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9122
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9123
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9123:
jmp @r4
mov r0,r2
ln9122:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9122
mov r1,r0
nobitover9122:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9125
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9125:
jmp @r4
mov r0,r2
! Opcodes E8A8 - E8AF
Y8A8:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9126
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9127
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9127:
jmp @r4
mov r0,r2
ln9126:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9126
mov r1,r0
nobitover9126:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9129
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9129:
jmp @r4
mov r0,r2
! Opcodes E8B0 - E8B7
Y8B0:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9130
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9131
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9131:
jmp @r4
mov r0,r2
ln9130:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln9132:
rotcr r3
movt r8
dt r0
bf/s ln9132
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9133
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9133:
jmp @r4
mov r0,r2
! Opcodes E8B8 - E8BF
Y8B8:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9134
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9135
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9135:
jmp @r4
mov r0,r2
ln9134:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln9136:
rotr r3
movt r8
dt r0
bf ln9136
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9137
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9137:
jmp @r4
mov r0,r2
! Opcodes E900 - E907
Y900:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9140
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9140:
jmp @r4
mov r0,r2
! Opcodes E908 - E90F
Y908:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #3,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9143
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9143:
jmp @r4
mov r0,r2
! Opcodes E910 - E917
Y910:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #4,r0
ln9145:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln9145
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9146
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9146:
jmp @r4
mov r0,r2
! Opcodes E918 - E91F
Y918:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #4,r0
ln9148:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln9148
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9149
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9149:
jmp @r4
mov r0,r2
! Opcodes E920 - E927
Y920:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9150
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9151
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9151:
jmp @r4
mov r0,r2
ln9150:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9150
mov r1,r0
nobitover9150:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln9152:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9152
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9153
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9153:
jmp @r4
mov r0,r2
! Opcodes E928 - E92F
Y928:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9154
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9155
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9155:
jmp @r4
mov r0,r2
ln9154:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9154
mov r1,r0
nobitover9154:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9157
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9157:
jmp @r4
mov r0,r2
! Opcodes E930 - E937
Y930:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9158
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9159
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9159:
jmp @r4
mov r0,r2
ln9158:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln9160:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln9160
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9161
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9161:
jmp @r4
mov r0,r2
! Opcodes E938 - E93F
Y938:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9162
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9163
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9163:
jmp @r4
mov r0,r2
ln9162:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln9164:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln9164
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9165
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9165:
jmp @r4
mov r0,r2
! Opcodes E940 - E947
Y940:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9168
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9168:
jmp @r4
mov r0,r2
! Opcodes E948 - E94F
Y948:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #3,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9171
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9171:
jmp @r4
mov r0,r2
! Opcodes E950 - E957
Y950:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #4,r0
ln9173:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln9173
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9174
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9174:
jmp @r4
mov r0,r2
! Opcodes E958 - E95F
Y958:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #4,r0
ln9176:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln9176
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-14,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9177
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9177:
jmp @r4
mov r0,r2
! Opcodes E960 - E967
Y960:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9178
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9179
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9179:
jmp @r4
mov r0,r2
ln9178:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9178
mov r1,r0
nobitover9178:
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln9180:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9180
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9181
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9181:
jmp @r4
mov r0,r2
! Opcodes E968 - E96F
Y968:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9182
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9183
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9183:
jmp @r4
mov r0,r2
ln9182:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9182
mov r1,r0
nobitover9182:
add r13,r2
mov.w @r2,r3
shll16 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9185
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9185:
jmp @r4
mov r0,r2
! Opcodes E970 - E977
Y970:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9186
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9187
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9187:
jmp @r4
mov r0,r2
ln9186:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln9188:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln9188
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9189
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9189:
jmp @r4
mov r0,r2
! Opcodes E978 - E97F
Y978:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9190
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9191
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9191:
jmp @r4
mov r0,r2
ln9190:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln9192:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln9192
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9193
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9193:
jmp @r4
mov r0,r2
! Opcodes E980 - E987
Y980:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9196
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9196:
jmp @r4
mov r0,r2
! Opcodes E988 - E98F
Y988:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #3,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9199
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9199:
jmp @r4
mov r0,r2
! Opcodes E990 - E997
Y990:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #4,r0
ln9201:
rotcl r3
movt r8
dt r0
bf/s ln9201
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9202
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9202:
jmp @r4
mov r0,r2
! Opcodes E998 - E99F
Y998:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #4,r0
ln9204:
rotl r3
movt r8
dt r0
bf ln9204
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9205
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9205:
jmp @r4
mov r0,r2
! Opcodes E9A0 - E9A7
Y9A0:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9206
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9207
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9207:
jmp @r4
mov r0,r2
ln9206:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9206
mov r1,r0
nobitover9206:
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln9208:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9208
cmp/pl r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9209
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9209:
jmp @r4
mov r0,r2
! Opcodes E9A8 - E9AF
Y9A8:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9210
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9211
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9211:
jmp @r4
mov r0,r2
ln9210:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9210
mov r1,r0
nobitover9210:
add r13,r2
mov.l @r2,r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9213
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9213:
jmp @r4
mov r0,r2
! Opcodes E9B0 - E9B7
Y9B0:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9214
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9215
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9215:
jmp @r4
mov r0,r2
ln9214:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln9216:
rotcl r3
movt r8
dt r0
bf/s ln9216
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9217
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9217:
jmp @r4
mov r0,r2
! Opcodes E9B8 - E9BF
Y9B8:
and r1,r2
mov.l @(16,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9218
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9219
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9219:
jmp @r4
mov r0,r2
ln9218:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln9220:
rotl r3
movt r8
dt r0
bf ln9220
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9221
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9221:
jmp @r4
mov r0,r2
! Opcodes EA00 - EA07
YA00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #-4,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9224
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9224:
jmp @r4
mov r0,r2
! Opcodes EA08 - EA0F
YA08:
and r1,r2
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-4,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9227
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9227:
jmp @r4
mov r0,r2
! Opcodes EA10 - EA17
YA10:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #5,r0
extu.b r3,r3
ln9229:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln9229
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9230
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9230:
jmp @r4
mov r0,r2
! Opcodes EA18 - EA1F
YA18:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #5,r0
extu.b r3,r3
ln9232:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln9232
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9233
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9233:
jmp @r4
mov r0,r2
! Opcodes EA20 - EA27
YA20:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9234
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9235
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9235:
jmp @r4
mov r0,r2
ln9234:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9234
mov r1,r0
nobitover9234:
add r13,r2
mov.b @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9237
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9237:
jmp @r4
mov r0,r2
! Opcodes EA28 - EA2F
YA28:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9238
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9239
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9239:
jmp @r4
mov r0,r2
ln9238:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9238
mov r1,r0
nobitover9238:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9241
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9241:
jmp @r4
mov r0,r2
! Opcodes EA30 - EA37
YA30:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9242
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9243
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9243:
jmp @r4
mov r0,r2
ln9242:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln9244:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln9244
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9245
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9245:
jmp @r4
mov r0,r2
! Opcodes EA38 - EA3F
YA38:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9246
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9247
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9247:
jmp @r4
mov r0,r2
ln9246:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln9248:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln9248
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9249
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9249:
jmp @r4
mov r0,r2
! Opcodes EA40 - EA47
YA40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #-4,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9252
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9252:
jmp @r4
mov r0,r2
! Opcodes EA48 - EA4F
YA48:
and r1,r2
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-4,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9255
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9255:
jmp @r4
mov r0,r2
! Opcodes EA50 - EA57
YA50:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #5,r0
extu.w r3,r3
ln9257:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln9257
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9258
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9258:
jmp @r4
mov r0,r2
! Opcodes EA58 - EA5F
YA58:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #5,r0
extu.w r3,r3
ln9260:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln9260
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9261
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9261:
jmp @r4
mov r0,r2
! Opcodes EA60 - EA67
YA60:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9262
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9263
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9263:
jmp @r4
mov r0,r2
ln9262:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9262
mov r1,r0
nobitover9262:
add r13,r2
mov.w @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9265
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9265:
jmp @r4
mov r0,r2
! Opcodes EA68 - EA6F
YA68:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9266
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9267
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9267:
jmp @r4
mov r0,r2
ln9266:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9266
mov r1,r0
nobitover9266:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9269
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9269:
jmp @r4
mov r0,r2
! Opcodes EA70 - EA77
YA70:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9270
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9271
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9271:
jmp @r4
mov r0,r2
ln9270:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln9272:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln9272
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9273
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9273:
jmp @r4
mov r0,r2
! Opcodes EA78 - EA7F
YA78:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9274
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9275
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9275:
jmp @r4
mov r0,r2
ln9274:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln9276:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln9276
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9277
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9277:
jmp @r4
mov r0,r2
! Opcodes EA80 - EA87
YA80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-4,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9280
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9280:
jmp @r4
mov r0,r2
! Opcodes EA88 - EA8F
YA88:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-4,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9283
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9283:
jmp @r4
mov r0,r2
! Opcodes EA90 - EA97
YA90:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #5,r0
ln9285:
rotcr r3
movt r8
dt r0
bf/s ln9285
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9286
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9286:
jmp @r4
mov r0,r2
! Opcodes EA98 - EA9F
YA98:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #5,r0
ln9288:
rotr r3
movt r8
dt r0
bf ln9288
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9289
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9289:
jmp @r4
mov r0,r2
! Opcodes EAA0 - EAA7
YAA0:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9290
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9291
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9291:
jmp @r4
mov r0,r2
ln9290:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9290
mov r1,r0
nobitover9290:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9293
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9293:
jmp @r4
mov r0,r2
! Opcodes EAA8 - EAAF
YAA8:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9294
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9295
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9295:
jmp @r4
mov r0,r2
ln9294:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9294
mov r1,r0
nobitover9294:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9297
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9297:
jmp @r4
mov r0,r2
! Opcodes EAB0 - EAB7
YAB0:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9298
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9299
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9299:
jmp @r4
mov r0,r2
ln9298:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln9300:
rotcr r3
movt r8
dt r0
bf/s ln9300
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9301
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9301:
jmp @r4
mov r0,r2
! Opcodes EAB8 - EABF
YAB8:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9302
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9303
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9303:
jmp @r4
mov r0,r2
ln9302:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln9304:
rotr r3
movt r8
dt r0
bf ln9304
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9305
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9305:
jmp @r4
mov r0,r2
! Opcodes EB00 - EB07
YB00:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9308
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9308:
jmp @r4
mov r0,r2
! Opcodes EB08 - EB0F
YB08:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #4,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9311
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9311:
jmp @r4
mov r0,r2
! Opcodes EB10 - EB17
YB10:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #5,r0
ln9313:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln9313
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9314
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9314:
jmp @r4
mov r0,r2
! Opcodes EB18 - EB1F
YB18:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #5,r0
ln9316:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln9316
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9317
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9317:
jmp @r4
mov r0,r2
! Opcodes EB20 - EB27
YB20:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9318
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9319
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9319:
jmp @r4
mov r0,r2
ln9318:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9318
mov r1,r0
nobitover9318:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln9320:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9320
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9321
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9321:
jmp @r4
mov r0,r2
! Opcodes EB28 - EB2F
YB28:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9322
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9323
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9323:
jmp @r4
mov r0,r2
ln9322:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9322
mov r1,r0
nobitover9322:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9325
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9325:
jmp @r4
mov r0,r2
! Opcodes EB30 - EB37
YB30:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9326
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9327
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9327:
jmp @r4
mov r0,r2
ln9326:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln9328:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln9328
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9329
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9329:
jmp @r4
mov r0,r2
! Opcodes EB38 - EB3F
YB38:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9330
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9331
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9331:
jmp @r4
mov r0,r2
ln9330:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln9332:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln9332
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9333
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9333:
jmp @r4
mov r0,r2
! Opcodes EB40 - EB47
YB40:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9336
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9336:
jmp @r4
mov r0,r2
! Opcodes EB48 - EB4F
YB48:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #4,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9339
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9339:
jmp @r4
mov r0,r2
! Opcodes EB50 - EB57
YB50:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #5,r0
ln9341:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln9341
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9342
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9342:
jmp @r4
mov r0,r2
! Opcodes EB58 - EB5F
YB58:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #5,r0
ln9344:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln9344
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-16,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9345
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9345:
jmp @r4
mov r0,r2
! Opcodes EB60 - EB67
YB60:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9346
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9347
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9347:
jmp @r4
mov r0,r2
ln9346:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9346
mov r1,r0
nobitover9346:
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln9348:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9348
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9349
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9349:
jmp @r4
mov r0,r2
! Opcodes EB68 - EB6F
YB68:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9350
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9351
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9351:
jmp @r4
mov r0,r2
ln9350:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9350
mov r1,r0
nobitover9350:
add r13,r2
mov.w @r2,r3
shll16 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9353
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9353:
jmp @r4
mov r0,r2
! Opcodes EB70 - EB77
YB70:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9354
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9355
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9355:
jmp @r4
mov r0,r2
ln9354:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln9356:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln9356
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9357
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9357:
jmp @r4
mov r0,r2
! Opcodes EB78 - EB7F
YB78:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9358
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9359
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9359:
jmp @r4
mov r0,r2
ln9358:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln9360:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln9360
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9361
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9361:
jmp @r4
mov r0,r2
! Opcodes EB80 - EB87
YB80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9364
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9364:
jmp @r4
mov r0,r2
! Opcodes EB88 - EB8F
YB88:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #4,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9367
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9367:
jmp @r4
mov r0,r2
! Opcodes EB90 - EB97
YB90:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #5,r0
ln9369:
rotcl r3
movt r8
dt r0
bf/s ln9369
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9370
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9370:
jmp @r4
mov r0,r2
! Opcodes EB98 - EB9F
YB98:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #5,r0
ln9372:
rotl r3
movt r8
dt r0
bf ln9372
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9373
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9373:
jmp @r4
mov r0,r2
! Opcodes EBA0 - EBA7
YBA0:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9374
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9375
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9375:
jmp @r4
mov r0,r2
ln9374:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9374
mov r1,r0
nobitover9374:
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln9376:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9376
cmp/pl r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9377
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9377:
jmp @r4
mov r0,r2
! Opcodes EBA8 - EBAF
YBA8:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9378
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9379
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9379:
jmp @r4
mov r0,r2
ln9378:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9378
mov r1,r0
nobitover9378:
add r13,r2
mov.l @r2,r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9381
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9381:
jmp @r4
mov r0,r2
! Opcodes EBB0 - EBB7
YBB0:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9382
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9383
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9383:
jmp @r4
mov r0,r2
ln9382:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln9384:
rotcl r3
movt r8
dt r0
bf/s ln9384
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9385
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9385:
jmp @r4
mov r0,r2
! Opcodes EBB8 - EBBF
YBB8:
and r1,r2
mov.l @(20,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9386
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9387
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9387:
jmp @r4
mov r0,r2
ln9386:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln9388:
rotl r3
movt r8
dt r0
bf ln9388
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9389
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9389:
jmp @r4
mov r0,r2
! Opcodes EC00 - EC07
YC00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #-5,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9392
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9392:
jmp @r4
mov r0,r2
! Opcodes EC08 - EC0F
YC08:
and r1,r2
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-5,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9395
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9395:
jmp @r4
mov r0,r2
! Opcodes EC10 - EC17
YC10:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #6,r0
extu.b r3,r3
ln9397:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln9397
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9398
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9398:
jmp @r4
mov r0,r2
! Opcodes EC18 - EC1F
YC18:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #6,r0
extu.b r3,r3
ln9400:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln9400
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9401
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9401:
jmp @r4
mov r0,r2
! Opcodes EC20 - EC27
YC20:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9402
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9403
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9403:
jmp @r4
mov r0,r2
ln9402:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9402
mov r1,r0
nobitover9402:
add r13,r2
mov.b @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9405
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9405:
jmp @r4
mov r0,r2
! Opcodes EC28 - EC2F
YC28:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9406
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9407
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9407:
jmp @r4
mov r0,r2
ln9406:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9406
mov r1,r0
nobitover9406:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9409
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9409:
jmp @r4
mov r0,r2
! Opcodes EC30 - EC37
YC30:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9410
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9411
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9411:
jmp @r4
mov r0,r2
ln9410:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln9412:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln9412
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9413
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9413:
jmp @r4
mov r0,r2
! Opcodes EC38 - EC3F
YC38:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9414
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9415
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9415:
jmp @r4
mov r0,r2
ln9414:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln9416:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln9416
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9417
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9417:
jmp @r4
mov r0,r2
! Opcodes EC40 - EC47
YC40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #-5,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9420
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9420:
jmp @r4
mov r0,r2
! Opcodes EC48 - EC4F
YC48:
and r1,r2
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-5,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9423
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9423:
jmp @r4
mov r0,r2
! Opcodes EC50 - EC57
YC50:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #6,r0
extu.w r3,r3
ln9425:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln9425
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9426
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9426:
jmp @r4
mov r0,r2
! Opcodes EC58 - EC5F
YC58:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #6,r0
extu.w r3,r3
ln9428:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln9428
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9429
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9429:
jmp @r4
mov r0,r2
! Opcodes EC60 - EC67
YC60:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9430
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9431
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9431:
jmp @r4
mov r0,r2
ln9430:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9430
mov r1,r0
nobitover9430:
add r13,r2
mov.w @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9433
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9433:
jmp @r4
mov r0,r2
! Opcodes EC68 - EC6F
YC68:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9434
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9435
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9435:
jmp @r4
mov r0,r2
ln9434:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9434
mov r1,r0
nobitover9434:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9437
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9437:
jmp @r4
mov r0,r2
! Opcodes EC70 - EC77
YC70:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9438
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9439
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9439:
jmp @r4
mov r0,r2
ln9438:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln9440:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln9440
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9441
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9441:
jmp @r4
mov r0,r2
! Opcodes EC78 - EC7F
YC78:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9442
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9443
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9443:
jmp @r4
mov r0,r2
ln9442:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln9444:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln9444
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9445
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9445:
jmp @r4
mov r0,r2
! Opcodes EC80 - EC87
YC80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-5,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9448
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9448:
jmp @r4
mov r0,r2
! Opcodes EC88 - EC8F
YC88:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-5,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9451
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9451:
jmp @r4
mov r0,r2
! Opcodes EC90 - EC97
YC90:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #6,r0
ln9453:
rotcr r3
movt r8
dt r0
bf/s ln9453
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9454
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9454:
jmp @r4
mov r0,r2
! Opcodes EC98 - EC9F
YC98:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #6,r0
ln9456:
rotr r3
movt r8
dt r0
bf ln9456
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9457
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9457:
jmp @r4
mov r0,r2
! Opcodes ECA0 - ECA7
YCA0:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9458
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9459
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9459:
jmp @r4
mov r0,r2
ln9458:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9458
mov r1,r0
nobitover9458:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9461
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9461:
jmp @r4
mov r0,r2
! Opcodes ECA8 - ECAF
YCA8:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9462
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9463
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9463:
jmp @r4
mov r0,r2
ln9462:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9462
mov r1,r0
nobitover9462:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9465
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9465:
jmp @r4
mov r0,r2
! Opcodes ECB0 - ECB7
YCB0:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9466
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9467
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9467:
jmp @r4
mov r0,r2
ln9466:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln9468:
rotcr r3
movt r8
dt r0
bf/s ln9468
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9469
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9469:
jmp @r4
mov r0,r2
! Opcodes ECB8 - ECBF
YCB8:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9470
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9471
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9471:
jmp @r4
mov r0,r2
ln9470:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln9472:
rotr r3
movt r8
dt r0
bf ln9472
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9473
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9473:
jmp @r4
mov r0,r2
! Opcodes ED00 - ED07
YD00:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9476
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9476:
jmp @r4
mov r0,r2
! Opcodes ED08 - ED0F
YD08:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #5,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9479
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9479:
jmp @r4
mov r0,r2
! Opcodes ED10 - ED17
YD10:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #6,r0
ln9481:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln9481
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9482
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9482:
jmp @r4
mov r0,r2
! Opcodes ED18 - ED1F
YD18:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #6,r0
ln9484:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln9484
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9485
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9485:
jmp @r4
mov r0,r2
! Opcodes ED20 - ED27
YD20:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9486
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9487
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9487:
jmp @r4
mov r0,r2
ln9486:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9486
mov r1,r0
nobitover9486:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln9488:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9488
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9489
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9489:
jmp @r4
mov r0,r2
! Opcodes ED28 - ED2F
YD28:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9490
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9491
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9491:
jmp @r4
mov r0,r2
ln9490:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9490
mov r1,r0
nobitover9490:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9493
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9493:
jmp @r4
mov r0,r2
! Opcodes ED30 - ED37
YD30:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9494
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9495
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9495:
jmp @r4
mov r0,r2
ln9494:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln9496:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln9496
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9497
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9497:
jmp @r4
mov r0,r2
! Opcodes ED38 - ED3F
YD38:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9498
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9499
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9499:
jmp @r4
mov r0,r2
ln9498:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln9500:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln9500
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9501
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9501:
jmp @r4
mov r0,r2
! Opcodes ED40 - ED47
YD40:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9504
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9504:
jmp @r4
mov r0,r2
! Opcodes ED48 - ED4F
YD48:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #5,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9507
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9507:
jmp @r4
mov r0,r2
! Opcodes ED50 - ED57
YD50:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #6,r0
ln9509:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln9509
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9510
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9510:
jmp @r4
mov r0,r2
! Opcodes ED58 - ED5F
YD58:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #6,r0
ln9512:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln9512
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-18,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9513
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9513:
jmp @r4
mov r0,r2
! Opcodes ED60 - ED67
YD60:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9514
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9515
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9515:
jmp @r4
mov r0,r2
ln9514:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9514
mov r1,r0
nobitover9514:
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln9516:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9516
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9517
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9517:
jmp @r4
mov r0,r2
! Opcodes ED68 - ED6F
YD68:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9518
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9519
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9519:
jmp @r4
mov r0,r2
ln9518:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9518
mov r1,r0
nobitover9518:
add r13,r2
mov.w @r2,r3
shll16 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9521
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9521:
jmp @r4
mov r0,r2
! Opcodes ED70 - ED77
YD70:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9522
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9523
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9523:
jmp @r4
mov r0,r2
ln9522:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln9524:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln9524
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9525
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9525:
jmp @r4
mov r0,r2
! Opcodes ED78 - ED7F
YD78:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9526
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9527
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9527:
jmp @r4
mov r0,r2
ln9526:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln9528:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln9528
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9529
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9529:
jmp @r4
mov r0,r2
! Opcodes ED80 - ED87
YD80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9532
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9532:
jmp @r4
mov r0,r2
! Opcodes ED88 - ED8F
YD88:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #5,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9535
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9535:
jmp @r4
mov r0,r2
! Opcodes ED90 - ED97
YD90:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #6,r0
ln9537:
rotcl r3
movt r8
dt r0
bf/s ln9537
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9538
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9538:
jmp @r4
mov r0,r2
! Opcodes ED98 - ED9F
YD98:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #6,r0
ln9540:
rotl r3
movt r8
dt r0
bf ln9540
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9541
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9541:
jmp @r4
mov r0,r2
! Opcodes EDA0 - EDA7
YDA0:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9542
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9543
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9543:
jmp @r4
mov r0,r2
ln9542:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9542
mov r1,r0
nobitover9542:
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln9544:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9544
cmp/pl r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9545
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9545:
jmp @r4
mov r0,r2
! Opcodes EDA8 - EDAF
YDA8:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9546
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9547
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9547:
jmp @r4
mov r0,r2
ln9546:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9546
mov r1,r0
nobitover9546:
add r13,r2
mov.l @r2,r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9549
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9549:
jmp @r4
mov r0,r2
! Opcodes EDB0 - EDB7
YDB0:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9550
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9551
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9551:
jmp @r4
mov r0,r2
ln9550:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln9552:
rotcl r3
movt r8
dt r0
bf/s ln9552
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9553
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9553:
jmp @r4
mov r0,r2
! Opcodes EDB8 - EDBF
YDB8:
and r1,r2
mov.l @(24,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9554
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9555
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9555:
jmp @r4
mov r0,r2
ln9554:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln9556:
rotl r3
movt r8
dt r0
bf ln9556
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9557
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9557:
jmp @r4
mov r0,r2
! Opcodes EE00 - EE07
YE00:
and r1,r2
add r13,r2
mov.b @r2,r3
mov #-6,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9560
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9560:
jmp @r4
mov r0,r2
! Opcodes EE08 - EE0F
YE08:
and r1,r2
add r13,r2
mov.b @r2,r3
extu.b r3,r3
mov #-6,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9563
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9563:
jmp @r4
mov r0,r2
! Opcodes EE10 - EE17
YE10:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #7,r0
extu.b r3,r3
ln9565:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln9565
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9566
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9566:
jmp @r4
mov r0,r2
! Opcodes EE18 - EE1F
YE18:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #7,r0
extu.b r3,r3
ln9568:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln9568
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9569
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9569:
jmp @r4
mov r0,r2
! Opcodes EE20 - EE27
YE20:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9570
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9571
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9571:
jmp @r4
mov r0,r2
ln9570:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9570
mov r1,r0
nobitover9570:
add r13,r2
mov.b @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9573
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9573:
jmp @r4
mov r0,r2
! Opcodes EE28 - EE2F
YE28:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9574
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9575
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9575:
jmp @r4
mov r0,r2
ln9574:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9574
mov r1,r0
nobitover9574:
add r13,r2
mov.b @r2,r3
extu.b r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9577
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9577:
jmp @r4
mov r0,r2
! Opcodes EE30 - EE37
YE30:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9578
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9579
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9579:
jmp @r4
mov r0,r2
ln9578:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
extu.b r3,r3
ln9580:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf/s ln9580
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9581
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9581:
jmp @r4
mov r0,r2
! Opcodes EE38 - EE3F
YE38:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9582
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9583
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9583:
jmp @r4
mov r0,r2
ln9582:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
extu.b r3,r3
ln9584:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
shlr8 r1
or r1,r3
bf ln9584
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9585
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9585:
jmp @r4
mov r0,r2
! Opcodes EE40 - EE47
YE40:
and r1,r2
add r13,r2
mov.w @r2,r3
mov #-6,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9588
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9588:
jmp @r4
mov r0,r2
! Opcodes EE48 - EE4F
YE48:
and r1,r2
add r13,r2
mov.w @r2,r3
extu.w r3,r3
mov #-6,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9591
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9591:
jmp @r4
mov r0,r2
! Opcodes EE50 - EE57
YE50:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #7,r0
extu.w r3,r3
ln9593:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln9593
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9594
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9594:
jmp @r4
mov r0,r2
! Opcodes EE58 - EE5F
YE58:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #7,r0
extu.w r3,r3
ln9596:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln9596
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9597
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9597:
jmp @r4
mov r0,r2
! Opcodes EE60 - EE67
YE60:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9598
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9599
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9599:
jmp @r4
mov r0,r2
ln9598:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9598
mov r1,r0
nobitover9598:
add r13,r2
mov.w @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9601
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9601:
jmp @r4
mov r0,r2
! Opcodes EE68 - EE6F
YE68:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9602
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9603
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9603:
jmp @r4
mov r0,r2
ln9602:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9602
mov r1,r0
nobitover9602:
add r13,r2
mov.w @r2,r3
extu.w r3,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9605
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9605:
jmp @r4
mov r0,r2
! Opcodes EE70 - EE77
YE70:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9606
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9607
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9607:
jmp @r4
mov r0,r2
ln9606:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
extu.w r3,r3
ln9608:
rotcr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf/s ln9608
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9609
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9609:
jmp @r4
mov r0,r2
! Opcodes EE78 - EE7F
YE78:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9610
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9611
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9611:
jmp @r4
mov r0,r2
ln9610:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
extu.w r3,r3
ln9612:
rotr r3
movt r8
dt r0
mov r3,r1
shlr16 r1
or r1,r3
bf ln9612
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9613
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9613:
jmp @r4
mov r0,r2
! Opcodes EE80 - EE87
YE80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-6,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9616
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9616:
jmp @r4
mov r0,r2
! Opcodes EE88 - EE8F
YE88:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #-6,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9619
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9619:
jmp @r4
mov r0,r2
! Opcodes EE90 - EE97
YE90:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #7,r0
ln9621:
rotcr r3
movt r8
dt r0
bf/s ln9621
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9622
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9622:
jmp @r4
mov r0,r2
! Opcodes EE98 - EE9F
YE98:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #7,r0
ln9624:
rotr r3
movt r8
dt r0
bf ln9624
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9625
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9625:
jmp @r4
mov r0,r2
! Opcodes EEA0 - EEA7
YEA0:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9626
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9627
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9627:
jmp @r4
mov r0,r2
ln9626:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9626
mov r1,r0
nobitover9626:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shad r0,r3
shar r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9629
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9629:
jmp @r4
mov r0,r2
! Opcodes EEA8 - EEAF
YEA8:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9630
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9631
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9631:
jmp @r4
mov r0,r2
ln9630:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9630
mov r1,r0
nobitover9630:
add r13,r2
mov.l @r2,r3
dt r0
neg r0,r0
shld r0,r3
shlr r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9633
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9633:
jmp @r4
mov r0,r2
! Opcodes EEB0 - EEB7
YEB0:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9634
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9635
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9635:
jmp @r4
mov r0,r2
ln9634:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln9636:
rotcr r3
movt r8
dt r0
bf/s ln9636
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9637
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9637:
jmp @r4
mov r0,r2
! Opcodes EEB8 - EEBF
YEB8:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9638
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9639
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9639:
jmp @r4
mov r0,r2
ln9638:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln9640:
rotr r3
movt r8
dt r0
bf ln9640
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9641
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9641:
jmp @r4
mov r0,r2
! Opcodes EF00 - EF07
YF00:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9644
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9644:
jmp @r4
mov r0,r2
! Opcodes EF08 - EF0F
YF08:
and r1,r2
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov #6,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9647
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9647:
jmp @r4
mov r0,r2
! Opcodes EF10 - EF17
YF10:
and r1,r2
add r13,r2
mov.b @r2,r3
cmp/pl r9
mov #7,r0
ln9649:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln9649
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9650
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9650:
jmp @r4
mov r0,r2
! Opcodes EF18 - EF1F
YF18:
and r1,r2
add r13,r2
mov.b @r2,r3
clrt
mov #7,r0
ln9652:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln9652
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9653
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9653:
jmp @r4
mov r0,r2
! Opcodes EF20 - EF27
YF20:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9654
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9655
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9655:
jmp @r4
mov r0,r2
ln9654:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9654
mov r1,r0
nobitover9654:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
mov r3,r1
mov #0,r8
ln9656:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9656
cmp/pl r9
rotcl r8
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9657
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9657:
jmp @r4
mov r0,r2
! Opcodes EF28 - EF2F
YF28:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9658
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9659
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9659:
jmp @r4
mov r0,r2
ln9658:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9658
mov r1,r0
nobitover9658:
add r13,r2
mov.b @r2,r3
shll16 r3
shll8 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-24,r0
shad r0,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9661
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9661:
jmp @r4
mov r0,r2
! Opcodes EF30 - EF37
YF30:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9662
mov r2,r0
mov.b @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9663
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9663:
jmp @r4
mov r0,r2
ln9662:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
cmp/pl r9
ln9664:
rotcl r3
movt r8
dt r0
exts.b r3,r3
bf/s ln9664
cmp/pl r8
mov r8,r9
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9665
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9665:
jmp @r4
mov r0,r2
! Opcodes EF38 - EF3F
YF38:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9666
mov r2,r0
mov.b @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9667
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9667:
jmp @r4
mov r0,r2
ln9666:
sub r0,r7
sub r0,r7
add r13,r2
mov.b @r2,r3
clrt
ln9668:
rotl r3
movt r8
dt r0
exts.b r3,r3
bf ln9668
exts.b r3,r3
mov.b r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9669
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9669:
jmp @r4
mov r0,r2
! Opcodes EF40 - EF47
YF40:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9672
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9672:
jmp @r4
mov r0,r2
! Opcodes EF48 - EF4F
YF48:
and r1,r2
add r13,r2
mov.w @r2,r3
shll16 r3
mov #6,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9675
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9675:
jmp @r4
mov r0,r2
! Opcodes EF50 - EF57
YF50:
and r1,r2
add r13,r2
mov.w @r2,r3
cmp/pl r9
mov #7,r0
ln9677:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln9677
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9678
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9678:
jmp @r4
mov r0,r2
! Opcodes EF58 - EF5F
YF58:
and r1,r2
add r13,r2
mov.w @r2,r3
clrt
mov #7,r0
ln9680:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln9680
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-20,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9681
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9681:
jmp @r4
mov r0,r2
! Opcodes EF60 - EF67
YF60:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9682
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9683
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9683:
jmp @r4
mov r0,r2
ln9682:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9682
mov r1,r0
nobitover9682:
add r13,r2
mov.w @r2,r3
shll16 r3
mov r3,r1
mov #0,r8
ln9684:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9684
cmp/pl r9
rotcl r8
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9685
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9685:
jmp @r4
mov r0,r2
! Opcodes EF68 - EF6F
YF68:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9686
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9687
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9687:
jmp @r4
mov r0,r2
ln9686:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9686
mov r1,r0
nobitover9686:
add r13,r2
mov.w @r2,r3
shll16 r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov #-16,r0
shad r0,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9689
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9689:
jmp @r4
mov r0,r2
! Opcodes EF70 - EF77
YF70:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9690
mov r2,r0
mov.w @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9691
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9691:
jmp @r4
mov r0,r2
ln9690:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
cmp/pl r9
ln9692:
rotcl r3
movt r8
dt r0
exts.w r3,r3
bf/s ln9692
cmp/pl r8
mov r8,r9
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9693
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9693:
jmp @r4
mov r0,r2
! Opcodes EF78 - EF7F
YF78:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9694
mov r2,r0
mov.w @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9695
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9695:
jmp @r4
mov r0,r2
ln9694:
sub r0,r7
sub r0,r7
add r13,r2
mov.w @r2,r3
clrt
ln9696:
rotl r3
movt r8
dt r0
exts.w r3,r3
bf ln9696
exts.w r3,r3
mov.w r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-6,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9697
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9697:
jmp @r4
mov r0,r2
! Opcodes EF80 - EF87
YF80:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #0,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
addv r3,r3
movt r9
or r9,r8
mov r3,r0
addv r3,r3
movt r9
or r9,r8
shll r0
movt r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9700
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9700:
jmp @r4
mov r0,r2
! Opcodes EF88 - EF8F
YF88:
and r1,r2
add r13,r2
mov.l @r2,r3
mov #6,r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9703
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9703:
jmp @r4
mov r0,r2
! Opcodes EF90 - EF97
YF90:
and r1,r2
add r13,r2
mov.l @r2,r3
cmp/pl r9
mov #7,r0
ln9705:
rotcl r3
movt r8
dt r0
bf/s ln9705
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9706
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9706:
jmp @r4
mov r0,r2
! Opcodes EF98 - EF9F
YF98:
and r1,r2
add r13,r2
mov.l @r2,r3
clrt
mov #7,r0
ln9708:
rotl r3
movt r8
dt r0
bf ln9708
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-22,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9709
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9709:
jmp @r4
mov r0,r2
! Opcodes EFA0 - EFA7
YFA0:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9710
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9711
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9711:
jmp @r4
mov r0,r2
ln9710:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9710
mov r1,r0
nobitover9710:
add r13,r2
mov.l @r2,r3
mov r3,r1
mov #0,r8
ln9712:
addv r3,r3
movt r9
or r9,r8
shal r1
movt r9
dt r0
bf ln9712
cmp/pl r9
rotcl r8
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9713
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9713:
jmp @r4
mov r0,r2
! Opcodes EFA8 - EFAF
YFA8:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9714
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9715
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9715:
jmp @r4
mov r0,r2
ln9714:
sub r0,r7
sub r0,r7
mov #32,r1
cmp/hi r1,r0
bf nobitover9714
mov r1,r0
nobitover9714:
add r13,r2
mov.l @r2,r3
dt r0
shld r0,r3
shll r3
movt r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9717
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9717:
jmp @r4
mov r0,r2
! Opcodes EFB0 - EFB7
YFB0:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9718
mov r2,r0
mov.l @(r0,r13),r3
mov r9,r8
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9719
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9719:
jmp @r4
mov r0,r2
ln9718:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
cmp/pl r9
ln9720:
rotcl r3
movt r8
dt r0
bf/s ln9720
cmp/pl r8
mov r8,r9
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9721
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9721:
jmp @r4
mov r0,r2
! Opcodes EFB8 - EFBF
YFB8:
and r1,r2
mov.l @(28,r13),r0
and #0x3F,r0
tst r0,r0
bf ln9722
mov r2,r0
mov.l @(r0,r13),r3
rotl r3
movt r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9723
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9723:
jmp @r4
mov r0,r2
ln9722:
sub r0,r7
sub r0,r7
add r13,r2
mov.l @r2,r3
clrt
ln9724:
rotl r3
movt r8
dt r0
bf ln9724
mov.l r3,@r2
rotl r3
addc r8,r8
mov.w @r6+,r0
add #-8,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9725
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9725:
jmp @r4
mov r0,r2
! Opcodes F000 - FFFF
Z000:
mov.l r3,@-r15
mov.l g1_except_addr9726,r0
add #-2,r6
jsr @r0
mov #0x2C,r4
mov.l bf_addr9726,r0
jsr @r0
nop
add r5,r6
mov.l @r15+,r3
mov.w @r6+,r0
add #-34,r7
mov #0x1C,r1
cmp/pl r7
shll2 r0
mov.l @(r0,r12),r4
bt fdl9727
mov.l @(execexit_addr-areg,r14),r1
jmp @r1
add #-2,r6
fdl9727:
jmp @r4
mov r0,r2
.align 2
g1_except_addr9726: .long group_1_exception
bf_addr9726: .long basefunction
.data
.rept 131072
 .byte 0
 .endr
jmptbl:
.rept 131072
 .byte 0
 .endr
.align 2
jmptblcomp:
.long K000-top+117440512
.long r_illegal-top+117440512
.long K010-top+117440512
.long K018-top+117440512
.long K020-top+117440512
.long K028-top+117440512
.long K030-top+117440512
.long K038-top
.long K039-top
.long r_illegal-top+16777216
.long K03C-top
.long r_illegal-top+33554432
.long K040-top+117440512
.long r_illegal-top+117440512
.long K050-top+117440512
.long K058-top+117440512
.long K060-top+117440512
.long K068-top+117440512
.long K070-top+117440512
.long K078-top
.long K079-top
.long r_illegal-top+16777216
.long K07C-top
.long r_illegal-top+33554432
.long K080-top+117440512
.long r_illegal-top+117440512
.long K090-top+117440512
.long K098-top+117440512
.long K0A0-top+117440512
.long K0A8-top+117440512
.long K0B0-top+117440512
.long K0B8-top
.long K0B9-top
.long r_illegal-top+1157627904
.long K100-top+117440512
.long K108-top+117440512
.long K110-top+117440512
.long K118-top+117440512
.long K120-top+117440512
.long K128-top+117440512
.long K130-top+117440512
.long K138-top
.long K139-top
.long K13A-top
.long K13B-top
.long K13C-top
.long r_illegal-top+33554432
.long K140-top+117440512
.long K148-top+117440512
.long K150-top+117440512
.long K158-top+117440512
.long K160-top+117440512
.long K168-top+117440512
.long K170-top+117440512
.long K178-top
.long K179-top
.long r_illegal-top+83886080
.long K180-top+117440512
.long K188-top+117440512
.long K190-top+117440512
.long K198-top+117440512
.long K1A0-top+117440512
.long K1A8-top+117440512
.long K1B0-top+117440512
.long K1B8-top
.long K1B9-top
.long r_illegal-top+83886080
.long K1C0-top+117440512
.long K1C8-top+117440512
.long K1D0-top+117440512
.long K1D8-top+117440512
.long K1E0-top+117440512
.long K1E8-top+117440512
.long K1F0-top+117440512
.long K1F8-top
.long K1F9-top
.long r_illegal-top+83886080
.long K200-top+117440512
.long r_illegal-top+117440512
.long K210-top+117440512
.long K218-top+117440512
.long K220-top+117440512
.long K228-top+117440512
.long K230-top+117440512
.long K238-top
.long K239-top
.long r_illegal-top+16777216
.long K23C-top
.long r_illegal-top+33554432
.long K240-top+117440512
.long r_illegal-top+117440512
.long K250-top+117440512
.long K258-top+117440512
.long K260-top+117440512
.long K268-top+117440512
.long K270-top+117440512
.long K278-top
.long K279-top
.long r_illegal-top+16777216
.long K27C-top
.long r_illegal-top+33554432
.long K280-top+117440512
.long r_illegal-top+117440512
.long K290-top+117440512
.long K298-top+117440512
.long K2A0-top+117440512
.long K2A8-top+117440512
.long K2B0-top+117440512
.long K2B8-top
.long K2B9-top
.long r_illegal-top+1157627904
.long K300-top+117440512
.long K308-top+117440512
.long K310-top+117440512
.long K318-top+117440512
.long K320-top+117440512
.long K328-top+117440512
.long K330-top+117440512
.long K338-top
.long K339-top
.long K33A-top
.long K33B-top
.long K33C-top
.long r_illegal-top+33554432
.long K340-top+117440512
.long K348-top+117440512
.long K350-top+117440512
.long K358-top+117440512
.long K360-top+117440512
.long K368-top+117440512
.long K370-top+117440512
.long K378-top
.long K379-top
.long r_illegal-top+83886080
.long K380-top+117440512
.long K388-top+117440512
.long K390-top+117440512
.long K398-top+117440512
.long K3A0-top+117440512
.long K3A8-top+117440512
.long K3B0-top+117440512
.long K3B8-top
.long K3B9-top
.long r_illegal-top+83886080
.long K3C0-top+117440512
.long K3C8-top+117440512
.long K3D0-top+117440512
.long K3D8-top+117440512
.long K3E0-top+117440512
.long K3E8-top+117440512
.long K3F0-top+117440512
.long K3F8-top
.long K3F9-top
.long r_illegal-top+83886080
.long K400-top+117440512
.long r_illegal-top+117440512
.long K410-top+117440512
.long K418-top+117440512
.long K420-top+117440512
.long K428-top+117440512
.long K430-top+117440512
.long K438-top
.long K439-top
.long r_illegal-top+83886080
.long K440-top+117440512
.long r_illegal-top+117440512
.long K450-top+117440512
.long K458-top+117440512
.long K460-top+117440512
.long K468-top+117440512
.long K470-top+117440512
.long K478-top
.long K479-top
.long r_illegal-top+83886080
.long K480-top+117440512
.long r_illegal-top+117440512
.long K490-top+117440512
.long K498-top+117440512
.long K4A0-top+117440512
.long K4A8-top+117440512
.long K4B0-top+117440512
.long K4B8-top
.long K4B9-top
.long r_illegal-top+1157627904
.long K500-top+117440512
.long K508-top+117440512
.long K510-top+117440512
.long K518-top+117440512
.long K520-top+117440512
.long K528-top+117440512
.long K530-top+117440512
.long K538-top
.long K539-top
.long K53A-top
.long K53B-top
.long K53C-top
.long r_illegal-top+33554432
.long K540-top+117440512
.long K548-top+117440512
.long K550-top+117440512
.long K558-top+117440512
.long K560-top+117440512
.long K568-top+117440512
.long K570-top+117440512
.long K578-top
.long K579-top
.long r_illegal-top+83886080
.long K580-top+117440512
.long K588-top+117440512
.long K590-top+117440512
.long K598-top+117440512
.long K5A0-top+117440512
.long K5A8-top+117440512
.long K5B0-top+117440512
.long K5B8-top
.long K5B9-top
.long r_illegal-top+83886080
.long K5C0-top+117440512
.long K5C8-top+117440512
.long K5D0-top+117440512
.long K5D8-top+117440512
.long K5E0-top+117440512
.long K5E8-top+117440512
.long K5F0-top+117440512
.long K5F8-top
.long K5F9-top
.long r_illegal-top+83886080
.long K600-top+117440512
.long r_illegal-top+117440512
.long K610-top+117440512
.long K618-top+117440512
.long K620-top+117440512
.long K628-top+117440512
.long K630-top+117440512
.long K638-top
.long K639-top
.long r_illegal-top+83886080
.long K640-top+117440512
.long r_illegal-top+117440512
.long K650-top+117440512
.long K658-top+117440512
.long K660-top+117440512
.long K668-top+117440512
.long K670-top+117440512
.long K678-top
.long K679-top
.long r_illegal-top+83886080
.long K680-top+117440512
.long r_illegal-top+117440512
.long K690-top+117440512
.long K698-top+117440512
.long K6A0-top+117440512
.long K6A8-top+117440512
.long K6B0-top+117440512
.long K6B8-top
.long K6B9-top
.long r_illegal-top+1157627904
.long K700-top+117440512
.long K708-top+117440512
.long K710-top+117440512
.long K718-top+117440512
.long K720-top+117440512
.long K728-top+117440512
.long K730-top+117440512
.long K738-top
.long K739-top
.long K73A-top
.long K73B-top
.long K73C-top
.long r_illegal-top+33554432
.long K740-top+117440512
.long K748-top+117440512
.long K750-top+117440512
.long K758-top+117440512
.long K760-top+117440512
.long K768-top+117440512
.long K770-top+117440512
.long K778-top
.long K779-top
.long r_illegal-top+83886080
.long K780-top+117440512
.long K788-top+117440512
.long K790-top+117440512
.long K798-top+117440512
.long K7A0-top+117440512
.long K7A8-top+117440512
.long K7B0-top+117440512
.long K7B8-top
.long K7B9-top
.long r_illegal-top+83886080
.long K7C0-top+117440512
.long K7C8-top+117440512
.long K7D0-top+117440512
.long K7D8-top+117440512
.long K7E0-top+117440512
.long K7E8-top+117440512
.long K7F0-top+117440512
.long K7F8-top
.long K7F9-top
.long r_illegal-top+83886080
.long K800-top+117440512
.long r_illegal-top+117440512
.long K810-top+117440512
.long K818-top+117440512
.long K820-top+117440512
.long K828-top+117440512
.long K830-top+117440512
.long K838-top
.long K839-top
.long K83A-top
.long K83B-top
.long K83C-top
.long r_illegal-top+33554432
.long K840-top+117440512
.long r_illegal-top+117440512
.long K850-top+117440512
.long K858-top+117440512
.long K860-top+117440512
.long K868-top+117440512
.long K870-top+117440512
.long K878-top
.long K879-top
.long r_illegal-top+83886080
.long K880-top+117440512
.long r_illegal-top+117440512
.long K890-top+117440512
.long K898-top+117440512
.long K8A0-top+117440512
.long K8A8-top+117440512
.long K8B0-top+117440512
.long K8B8-top
.long K8B9-top
.long r_illegal-top+83886080
.long K8C0-top+117440512
.long r_illegal-top+117440512
.long K8D0-top+117440512
.long K8D8-top+117440512
.long K8E0-top+117440512
.long K8E8-top+117440512
.long K8F0-top+117440512
.long K8F8-top
.long K8F9-top
.long r_illegal-top+83886080
.long K900-top+117440512
.long K908-top+117440512
.long K910-top+117440512
.long K918-top+117440512
.long K920-top+117440512
.long K928-top+117440512
.long K930-top+117440512
.long K938-top
.long K939-top
.long K93A-top
.long K93B-top
.long K93C-top
.long r_illegal-top+33554432
.long K940-top+117440512
.long K948-top+117440512
.long K950-top+117440512
.long K958-top+117440512
.long K960-top+117440512
.long K968-top+117440512
.long K970-top+117440512
.long K978-top
.long K979-top
.long r_illegal-top+83886080
.long K980-top+117440512
.long K988-top+117440512
.long K990-top+117440512
.long K998-top+117440512
.long K9A0-top+117440512
.long K9A8-top+117440512
.long K9B0-top+117440512
.long K9B8-top
.long K9B9-top
.long r_illegal-top+83886080
.long K9C0-top+117440512
.long K9C8-top+117440512
.long K9D0-top+117440512
.long K9D8-top+117440512
.long K9E0-top+117440512
.long K9E8-top+117440512
.long K9F0-top+117440512
.long K9F8-top
.long K9F9-top
.long r_illegal-top+83886080
.long KA00-top+117440512
.long r_illegal-top+117440512
.long KA10-top+117440512
.long KA18-top+117440512
.long KA20-top+117440512
.long KA28-top+117440512
.long KA30-top+117440512
.long KA38-top
.long KA39-top
.long r_illegal-top+16777216
.long KA3C-top
.long r_illegal-top+33554432
.long KA40-top+117440512
.long r_illegal-top+117440512
.long KA50-top+117440512
.long KA58-top+117440512
.long KA60-top+117440512
.long KA68-top+117440512
.long KA70-top+117440512
.long KA78-top
.long KA79-top
.long r_illegal-top+16777216
.long KA7C-top
.long r_illegal-top+33554432
.long KA80-top+117440512
.long r_illegal-top+117440512
.long KA90-top+117440512
.long KA98-top+117440512
.long KAA0-top+117440512
.long KAA8-top+117440512
.long KAB0-top+117440512
.long KAB8-top
.long KAB9-top
.long r_illegal-top+1157627904
.long KB00-top+117440512
.long KB08-top+117440512
.long KB10-top+117440512
.long KB18-top+117440512
.long KB20-top+117440512
.long KB28-top+117440512
.long KB30-top+117440512
.long KB38-top
.long KB39-top
.long KB3A-top
.long KB3B-top
.long KB3C-top
.long r_illegal-top+33554432
.long KB40-top+117440512
.long KB48-top+117440512
.long KB50-top+117440512
.long KB58-top+117440512
.long KB60-top+117440512
.long KB68-top+117440512
.long KB70-top+117440512
.long KB78-top
.long KB79-top
.long r_illegal-top+83886080
.long KB80-top+117440512
.long KB88-top+117440512
.long KB90-top+117440512
.long KB98-top+117440512
.long KBA0-top+117440512
.long KBA8-top+117440512
.long KBB0-top+117440512
.long KBB8-top
.long KBB9-top
.long r_illegal-top+83886080
.long KBC0-top+117440512
.long KBC8-top+117440512
.long KBD0-top+117440512
.long KBD8-top+117440512
.long KBE0-top+117440512
.long KBE8-top+117440512
.long KBF0-top+117440512
.long KBF8-top
.long KBF9-top
.long r_illegal-top+83886080
.long KC00-top+117440512
.long r_illegal-top+117440512
.long KC10-top+117440512
.long KC18-top+117440512
.long KC20-top+117440512
.long KC28-top+117440512
.long KC30-top+117440512
.long KC38-top
.long KC39-top
.long r_illegal-top+83886080
.long KC40-top+117440512
.long r_illegal-top+117440512
.long KC50-top+117440512
.long KC58-top+117440512
.long KC60-top+117440512
.long KC68-top+117440512
.long KC70-top+117440512
.long KC78-top
.long KC79-top
.long r_illegal-top+83886080
.long KC80-top+117440512
.long r_illegal-top+117440512
.long KC90-top+117440512
.long KC98-top+117440512
.long KCA0-top+117440512
.long KCA8-top+117440512
.long KCB0-top+117440512
.long KCB8-top
.long KCB9-top
.long r_illegal-top+1157627904
.long KD00-top+117440512
.long KD08-top+117440512
.long KD10-top+117440512
.long KD18-top+117440512
.long KD20-top+117440512
.long KD28-top+117440512
.long KD30-top+117440512
.long KD38-top
.long KD39-top
.long KD3A-top
.long KD3B-top
.long KD3C-top
.long r_illegal-top+33554432
.long KD40-top+117440512
.long KD48-top+117440512
.long KD50-top+117440512
.long KD58-top+117440512
.long KD60-top+117440512
.long KD68-top+117440512
.long KD70-top+117440512
.long KD78-top
.long KD79-top
.long r_illegal-top+83886080
.long KD80-top+117440512
.long KD88-top+117440512
.long KD90-top+117440512
.long KD98-top+117440512
.long KDA0-top+117440512
.long KDA8-top+117440512
.long KDB0-top+117440512
.long KDB8-top
.long KDB9-top
.long r_illegal-top+83886080
.long KDC0-top+117440512
.long KDC8-top+117440512
.long KDD0-top+117440512
.long KDD8-top+117440512
.long KDE0-top+117440512
.long KDE8-top+117440512
.long KDF0-top+117440512
.long KDF8-top
.long KDF9-top
.long r_illegal-top+4278190080
.long r_illegal-top+83886080
.long KF00-top+117440512
.long KF08-top+117440512
.long KF10-top+117440512
.long KF18-top+117440512
.long KF20-top+117440512
.long KF28-top+117440512
.long KF30-top+117440512
.long KF38-top
.long KF39-top
.long KF3A-top
.long KF3B-top
.long KF3C-top
.long r_illegal-top+33554432
.long KF40-top+117440512
.long KF48-top+117440512
.long KF50-top+117440512
.long KF58-top+117440512
.long KF60-top+117440512
.long KF68-top+117440512
.long KF70-top+117440512
.long KF78-top
.long KF79-top
.long r_illegal-top+83886080
.long KF80-top+117440512
.long KF88-top+117440512
.long KF90-top+117440512
.long KF98-top+117440512
.long KFA0-top+117440512
.long KFA8-top+117440512
.long KFB0-top+117440512
.long KFB8-top
.long KFB9-top
.long r_illegal-top+83886080
.long KFC0-top+117440512
.long KFC8-top+117440512
.long KFD0-top+117440512
.long KFD8-top+117440512
.long KFE0-top+117440512
.long KFE8-top+117440512
.long KFF0-top+117440512
.long KFF8-top
.long KFF9-top
.long r_illegal-top+83886080
.long L000-top+117440512
.long L008-top+117440512
.long L010-top+117440512
.long L018-top+117440512
.long L020-top+117440512
.long L028-top+117440512
.long L030-top+117440512
.long L038-top
.long L039-top
.long L03A-top
.long L03B-top
.long L03C-top
.long r_illegal-top+1107296256
.long L080-top+117440512
.long L088-top+117440512
.long L090-top+117440512
.long L098-top+117440512
.long L0A0-top+117440512
.long L0A8-top+117440512
.long L0B0-top+117440512
.long L0B8-top
.long L0B9-top
.long L0BA-top
.long L0BB-top
.long L0BC-top
.long r_illegal-top+33554432
.long L0C0-top+117440512
.long L0C8-top+117440512
.long L0D0-top+117440512
.long L0D8-top+117440512
.long L0E0-top+117440512
.long L0E8-top+117440512
.long L0F0-top+117440512
.long L0F8-top
.long L0F9-top
.long L0FA-top
.long L0FB-top
.long L0FC-top
.long r_illegal-top+33554432
.long L100-top+117440512
.long L108-top+117440512
.long L110-top+117440512
.long L118-top+117440512
.long L120-top+117440512
.long L128-top+117440512
.long L130-top+117440512
.long L138-top
.long L139-top
.long L13A-top
.long L13B-top
.long L13C-top
.long r_illegal-top+33554432
.long L140-top+117440512
.long L148-top+117440512
.long L150-top+117440512
.long L158-top+117440512
.long L160-top+117440512
.long L168-top+117440512
.long L170-top+117440512
.long L178-top
.long L179-top
.long L17A-top
.long L17B-top
.long L17C-top
.long r_illegal-top+33554432
.long L180-top+117440512
.long L188-top+117440512
.long L190-top+117440512
.long L198-top+117440512
.long L1A0-top+117440512
.long L1A8-top+117440512
.long L1B0-top+117440512
.long L1B8-top
.long L1B9-top
.long L1BA-top
.long L1BB-top
.long L1BC-top
.long r_illegal-top+33554432
.long L1C0-top+117440512
.long L1C8-top+117440512
.long L1D0-top+117440512
.long L1D8-top+117440512
.long L1E0-top+117440512
.long L1E8-top+117440512
.long L1F0-top+117440512
.long L1F8-top
.long L1F9-top
.long L1FA-top
.long L1FB-top
.long L1FC-top
.long r_illegal-top+33554432
.long L200-top+117440512
.long L208-top+117440512
.long L210-top+117440512
.long L218-top+117440512
.long L220-top+117440512
.long L228-top+117440512
.long L230-top+117440512
.long L238-top
.long L239-top
.long L23A-top
.long L23B-top
.long L23C-top
.long r_illegal-top+1107296256
.long L280-top+117440512
.long L288-top+117440512
.long L290-top+117440512
.long L298-top+117440512
.long L2A0-top+117440512
.long L2A8-top+117440512
.long L2B0-top+117440512
.long L2B8-top
.long L2B9-top
.long L2BA-top
.long L2BB-top
.long L2BC-top
.long r_illegal-top+33554432
.long L2C0-top+117440512
.long L2C8-top+117440512
.long L2D0-top+117440512
.long L2D8-top+117440512
.long L2E0-top+117440512
.long L2E8-top+117440512
.long L2F0-top+117440512
.long L2F8-top
.long L2F9-top
.long L2FA-top
.long L2FB-top
.long L2FC-top
.long r_illegal-top+33554432
.long L300-top+117440512
.long L308-top+117440512
.long L310-top+117440512
.long L318-top+117440512
.long L320-top+117440512
.long L328-top+117440512
.long L330-top+117440512
.long L338-top
.long L339-top
.long L33A-top
.long L33B-top
.long L33C-top
.long r_illegal-top+33554432
.long L340-top+117440512
.long L348-top+117440512
.long L350-top+117440512
.long L358-top+117440512
.long L360-top+117440512
.long L368-top+117440512
.long L370-top+117440512
.long L378-top
.long L379-top
.long L37A-top
.long L37B-top
.long L37C-top
.long r_illegal-top+33554432
.long L380-top+117440512
.long L388-top+117440512
.long L390-top+117440512
.long L398-top+117440512
.long L3A0-top+117440512
.long L3A8-top+117440512
.long L3B0-top+117440512
.long L3B8-top
.long L3B9-top
.long L3BA-top
.long L3BB-top
.long L3BC-top
.long r_illegal-top+33554432
.long L3C0-top+117440512
.long L3C8-top+117440512
.long L3D0-top+117440512
.long L3D8-top+117440512
.long L3E0-top+117440512
.long L3E8-top+117440512
.long L3F0-top+117440512
.long L3F8-top
.long L3F9-top
.long L3FA-top
.long L3FB-top
.long L3FC-top
.long r_illegal-top+33554432
.long L400-top+117440512
.long L408-top+117440512
.long L410-top+117440512
.long L418-top+117440512
.long L420-top+117440512
.long L428-top+117440512
.long L430-top+117440512
.long L438-top
.long L439-top
.long L43A-top
.long L43B-top
.long L43C-top
.long r_illegal-top+1107296256
.long L480-top+117440512
.long L488-top+117440512
.long L490-top+117440512
.long L498-top+117440512
.long L4A0-top+117440512
.long L4A8-top+117440512
.long L4B0-top+117440512
.long L4B8-top
.long L4B9-top
.long L4BA-top
.long L4BB-top
.long L4BC-top
.long r_illegal-top+33554432
.long L4C0-top+117440512
.long L4C8-top+117440512
.long L4D0-top+117440512
.long L4D8-top+117440512
.long L4E0-top+117440512
.long L4E8-top+117440512
.long L4F0-top+117440512
.long L4F8-top
.long L4F9-top
.long L4FA-top
.long L4FB-top
.long L4FC-top
.long r_illegal-top+33554432
.long L500-top+117440512
.long L508-top+117440512
.long L510-top+117440512
.long L518-top+117440512
.long L520-top+117440512
.long L528-top+117440512
.long L530-top+117440512
.long L538-top
.long L539-top
.long L53A-top
.long L53B-top
.long L53C-top
.long r_illegal-top+33554432
.long L540-top+117440512
.long L548-top+117440512
.long L550-top+117440512
.long L558-top+117440512
.long L560-top+117440512
.long L568-top+117440512
.long L570-top+117440512
.long L578-top
.long L579-top
.long L57A-top
.long L57B-top
.long L57C-top
.long r_illegal-top+33554432
.long L580-top+117440512
.long L588-top+117440512
.long L590-top+117440512
.long L598-top+117440512
.long L5A0-top+117440512
.long L5A8-top+117440512
.long L5B0-top+117440512
.long L5B8-top
.long L5B9-top
.long L5BA-top
.long L5BB-top
.long L5BC-top
.long r_illegal-top+1107296256
.long L600-top+117440512
.long L608-top+117440512
.long L610-top+117440512
.long L618-top+117440512
.long L620-top+117440512
.long L628-top+117440512
.long L630-top+117440512
.long L638-top
.long L639-top
.long L63A-top
.long L63B-top
.long L63C-top
.long r_illegal-top+1107296256
.long L680-top+117440512
.long L688-top+117440512
.long L690-top+117440512
.long L698-top+117440512
.long L6A0-top+117440512
.long L6A8-top+117440512
.long L6B0-top+117440512
.long L6B8-top
.long L6B9-top
.long L6BA-top
.long L6BB-top
.long L6BC-top
.long r_illegal-top+33554432
.long L6C0-top+117440512
.long L6C8-top+117440512
.long L6D0-top+117440512
.long L6D8-top+117440512
.long L6E0-top+117440512
.long L6E8-top+117440512
.long L6F0-top+117440512
.long L6F8-top
.long L6F9-top
.long L6FA-top
.long L6FB-top
.long L6FC-top
.long r_illegal-top+33554432
.long L700-top+117440512
.long L708-top+117440512
.long L710-top+117440512
.long L718-top+117440512
.long L720-top+117440512
.long L728-top+117440512
.long L730-top+117440512
.long L738-top
.long L739-top
.long L73A-top
.long L73B-top
.long L73C-top
.long r_illegal-top+33554432
.long L740-top+117440512
.long L748-top+117440512
.long L750-top+117440512
.long L758-top+117440512
.long L760-top+117440512
.long L768-top+117440512
.long L770-top+117440512
.long L778-top
.long L779-top
.long L77A-top
.long L77B-top
.long L77C-top
.long r_illegal-top+33554432
.long L780-top+117440512
.long L788-top+117440512
.long L790-top+117440512
.long L798-top+117440512
.long L7A0-top+117440512
.long L7A8-top+117440512
.long L7B0-top+117440512
.long L7B8-top
.long L7B9-top
.long L7BA-top
.long L7BB-top
.long L7BC-top
.long r_illegal-top+1107296256
.long L800-top+117440512
.long L808-top+117440512
.long L810-top+117440512
.long L818-top+117440512
.long L820-top+117440512
.long L828-top+117440512
.long L830-top+117440512
.long L838-top
.long L839-top
.long L83A-top
.long L83B-top
.long L83C-top
.long r_illegal-top+1107296256
.long L880-top+117440512
.long L888-top+117440512
.long L890-top+117440512
.long L898-top+117440512
.long L8A0-top+117440512
.long L8A8-top+117440512
.long L8B0-top+117440512
.long L8B8-top
.long L8B9-top
.long L8BA-top
.long L8BB-top
.long L8BC-top
.long r_illegal-top+33554432
.long L8C0-top+117440512
.long L8C8-top+117440512
.long L8D0-top+117440512
.long L8D8-top+117440512
.long L8E0-top+117440512
.long L8E8-top+117440512
.long L8F0-top+117440512
.long L8F8-top
.long L8F9-top
.long L8FA-top
.long L8FB-top
.long L8FC-top
.long r_illegal-top+33554432
.long L900-top+117440512
.long L908-top+117440512
.long L910-top+117440512
.long L918-top+117440512
.long L920-top+117440512
.long L928-top+117440512
.long L930-top+117440512
.long L938-top
.long L939-top
.long L93A-top
.long L93B-top
.long L93C-top
.long r_illegal-top+33554432
.long L940-top+117440512
.long L948-top+117440512
.long L950-top+117440512
.long L958-top+117440512
.long L960-top+117440512
.long L968-top+117440512
.long L970-top+117440512
.long L978-top
.long L979-top
.long L97A-top
.long L97B-top
.long L97C-top
.long r_illegal-top+33554432
.long L980-top+117440512
.long L988-top+117440512
.long L990-top+117440512
.long L998-top+117440512
.long L9A0-top+117440512
.long L9A8-top+117440512
.long L9B0-top+117440512
.long L9B8-top
.long L9B9-top
.long L9BA-top
.long L9BB-top
.long L9BC-top
.long r_illegal-top+1107296256
.long LA00-top+117440512
.long LA08-top+117440512
.long LA10-top+117440512
.long LA18-top+117440512
.long LA20-top+117440512
.long LA28-top+117440512
.long LA30-top+117440512
.long LA38-top
.long LA39-top
.long LA3A-top
.long LA3B-top
.long LA3C-top
.long r_illegal-top+1107296256
.long LA80-top+117440512
.long LA88-top+117440512
.long LA90-top+117440512
.long LA98-top+117440512
.long LAA0-top+117440512
.long LAA8-top+117440512
.long LAB0-top+117440512
.long LAB8-top
.long LAB9-top
.long LABA-top
.long LABB-top
.long LABC-top
.long r_illegal-top+33554432
.long LAC0-top+117440512
.long LAC8-top+117440512
.long LAD0-top+117440512
.long LAD8-top+117440512
.long LAE0-top+117440512
.long LAE8-top+117440512
.long LAF0-top+117440512
.long LAF8-top
.long LAF9-top
.long LAFA-top
.long LAFB-top
.long LAFC-top
.long r_illegal-top+33554432
.long LB00-top+117440512
.long LB08-top+117440512
.long LB10-top+117440512
.long LB18-top+117440512
.long LB20-top+117440512
.long LB28-top+117440512
.long LB30-top+117440512
.long LB38-top
.long LB39-top
.long LB3A-top
.long LB3B-top
.long LB3C-top
.long r_illegal-top+33554432
.long LB40-top+117440512
.long LB48-top+117440512
.long LB50-top+117440512
.long LB58-top+117440512
.long LB60-top+117440512
.long LB68-top+117440512
.long LB70-top+117440512
.long LB78-top
.long LB79-top
.long LB7A-top
.long LB7B-top
.long LB7C-top
.long r_illegal-top+33554432
.long LB80-top+117440512
.long LB88-top+117440512
.long LB90-top+117440512
.long LB98-top+117440512
.long LBA0-top+117440512
.long LBA8-top+117440512
.long LBB0-top+117440512
.long LBB8-top
.long LBB9-top
.long LBBA-top
.long LBBB-top
.long LBBC-top
.long r_illegal-top+1107296256
.long LC00-top+117440512
.long LC08-top+117440512
.long LC10-top+117440512
.long LC18-top+117440512
.long LC20-top+117440512
.long LC28-top+117440512
.long LC30-top+117440512
.long LC38-top
.long LC39-top
.long LC3A-top
.long LC3B-top
.long LC3C-top
.long r_illegal-top+1107296256
.long LC80-top+117440512
.long LC88-top+117440512
.long LC90-top+117440512
.long LC98-top+117440512
.long LCA0-top+117440512
.long LCA8-top+117440512
.long LCB0-top+117440512
.long LCB8-top
.long LCB9-top
.long LCBA-top
.long LCBB-top
.long LCBC-top
.long r_illegal-top+33554432
.long LCC0-top+117440512
.long LCC8-top+117440512
.long LCD0-top+117440512
.long LCD8-top+117440512
.long LCE0-top+117440512
.long LCE8-top+117440512
.long LCF0-top+117440512
.long LCF8-top
.long LCF9-top
.long LCFA-top
.long LCFB-top
.long LCFC-top
.long r_illegal-top+33554432
.long LD00-top+117440512
.long LD08-top+117440512
.long LD10-top+117440512
.long LD18-top+117440512
.long LD20-top+117440512
.long LD28-top+117440512
.long LD30-top+117440512
.long LD38-top
.long LD39-top
.long LD3A-top
.long LD3B-top
.long LD3C-top
.long r_illegal-top+33554432
.long LD40-top+117440512
.long LD48-top+117440512
.long LD50-top+117440512
.long LD58-top+117440512
.long LD60-top+117440512
.long LD68-top+117440512
.long LD70-top+117440512
.long LD78-top
.long LD79-top
.long LD7A-top
.long LD7B-top
.long LD7C-top
.long r_illegal-top+33554432
.long LD80-top+117440512
.long LD88-top+117440512
.long LD90-top+117440512
.long LD98-top+117440512
.long LDA0-top+117440512
.long LDA8-top+117440512
.long LDB0-top+117440512
.long LDB8-top
.long LDB9-top
.long LDBA-top
.long LDBB-top
.long LDBC-top
.long r_illegal-top+1107296256
.long LE00-top+117440512
.long LE08-top+117440512
.long LE10-top+117440512
.long LE18-top+117440512
.long LE20-top+117440512
.long LE28-top+117440512
.long LE30-top+117440512
.long LE38-top
.long LE39-top
.long LE3A-top
.long LE3B-top
.long LE3C-top
.long r_illegal-top+1107296256
.long LE80-top+117440512
.long LE88-top+117440512
.long LE90-top+117440512
.long LE98-top+117440512
.long LEA0-top+117440512
.long LEA8-top+117440512
.long LEB0-top+117440512
.long LEB8-top
.long LEB9-top
.long LEBA-top
.long LEBB-top
.long LEBC-top
.long r_illegal-top+33554432
.long LEC0-top+117440512
.long LEC8-top+117440512
.long LED0-top+117440512
.long LED8-top+117440512
.long LEE0-top+117440512
.long LEE8-top+117440512
.long LEF0-top+117440512
.long LEF8-top
.long LEF9-top
.long LEFA-top
.long LEFB-top
.long LEFC-top
.long r_illegal-top+33554432
.long LF00-top+117440512
.long LF08-top+117440512
.long LF10-top+117440512
.long LF18-top+117440512
.long LF20-top+117440512
.long LF28-top+117440512
.long LF30-top+117440512
.long LF38-top
.long LF39-top
.long LF3A-top
.long LF3B-top
.long LF3C-top
.long r_illegal-top+33554432
.long LF40-top+117440512
.long LF48-top+117440512
.long LF50-top+117440512
.long LF58-top+117440512
.long LF60-top+117440512
.long LF68-top+117440512
.long LF70-top+117440512
.long LF78-top
.long LF79-top
.long LF7A-top
.long LF7B-top
.long LF7C-top
.long r_illegal-top+33554432
.long LF80-top+117440512
.long LF88-top+117440512
.long LF90-top+117440512
.long LF98-top+117440512
.long LFA0-top+117440512
.long LFA8-top+117440512
.long LFB0-top+117440512
.long LFB8-top
.long LFB9-top
.long LFBA-top
.long LFBB-top
.long LFBC-top
.long r_illegal-top+1107296256
.long M000-top+117440512
.long M008-top+117440512
.long M010-top+117440512
.long M018-top+117440512
.long M020-top+117440512
.long M028-top+117440512
.long M030-top+117440512
.long M038-top
.long M039-top
.long M03A-top
.long M03B-top
.long M03C-top
.long r_illegal-top+33554432
.long M040-top+117440512
.long M048-top+117440512
.long M050-top+117440512
.long M058-top+117440512
.long M060-top+117440512
.long M068-top+117440512
.long M070-top+117440512
.long M078-top
.long M079-top
.long M07A-top
.long M07B-top
.long M07C-top
.long r_illegal-top+33554432
.long M080-top+117440512
.long M088-top+117440512
.long M090-top+117440512
.long M098-top+117440512
.long M0A0-top+117440512
.long M0A8-top+117440512
.long M0B0-top+117440512
.long M0B8-top
.long M0B9-top
.long M0BA-top
.long M0BB-top
.long M0BC-top
.long r_illegal-top+33554432
.long M0C0-top+117440512
.long M0C8-top+117440512
.long M0D0-top+117440512
.long M0D8-top+117440512
.long M0E0-top+117440512
.long M0E8-top+117440512
.long M0F0-top+117440512
.long M0F8-top
.long M0F9-top
.long M0FA-top
.long M0FB-top
.long M0FC-top
.long r_illegal-top+33554432
.long M100-top+117440512
.long M108-top+117440512
.long M110-top+117440512
.long M118-top+117440512
.long M120-top+117440512
.long M128-top+117440512
.long M130-top+117440512
.long M138-top
.long M139-top
.long M13A-top
.long M13B-top
.long M13C-top
.long r_illegal-top+33554432
.long M140-top+117440512
.long M148-top+117440512
.long M150-top+117440512
.long M158-top+117440512
.long M160-top+117440512
.long M168-top+117440512
.long M170-top+117440512
.long M178-top
.long M179-top
.long M17A-top
.long M17B-top
.long M17C-top
.long r_illegal-top+33554432
.long M180-top+117440512
.long M188-top+117440512
.long M190-top+117440512
.long M198-top+117440512
.long M1A0-top+117440512
.long M1A8-top+117440512
.long M1B0-top+117440512
.long M1B8-top
.long M1B9-top
.long M1BA-top
.long M1BB-top
.long M1BC-top
.long r_illegal-top+33554432
.long M1C0-top+117440512
.long M1C8-top+117440512
.long M1D0-top+117440512
.long M1D8-top+117440512
.long M1E0-top+117440512
.long M1E8-top+117440512
.long M1F0-top+117440512
.long M1F8-top
.long M1F9-top
.long M1FA-top
.long M1FB-top
.long M1FC-top
.long r_illegal-top+33554432
.long M200-top+117440512
.long M208-top+117440512
.long M210-top+117440512
.long M218-top+117440512
.long M220-top+117440512
.long M228-top+117440512
.long M230-top+117440512
.long M238-top
.long M239-top
.long M23A-top
.long M23B-top
.long M23C-top
.long r_illegal-top+33554432
.long M240-top+117440512
.long M248-top+117440512
.long M250-top+117440512
.long M258-top+117440512
.long M260-top+117440512
.long M268-top+117440512
.long M270-top+117440512
.long M278-top
.long M279-top
.long M27A-top
.long M27B-top
.long M27C-top
.long r_illegal-top+33554432
.long M280-top+117440512
.long M288-top+117440512
.long M290-top+117440512
.long M298-top+117440512
.long M2A0-top+117440512
.long M2A8-top+117440512
.long M2B0-top+117440512
.long M2B8-top
.long M2B9-top
.long M2BA-top
.long M2BB-top
.long M2BC-top
.long r_illegal-top+33554432
.long M2C0-top+117440512
.long M2C8-top+117440512
.long M2D0-top+117440512
.long M2D8-top+117440512
.long M2E0-top+117440512
.long M2E8-top+117440512
.long M2F0-top+117440512
.long M2F8-top
.long M2F9-top
.long M2FA-top
.long M2FB-top
.long M2FC-top
.long r_illegal-top+33554432
.long M300-top+117440512
.long M308-top+117440512
.long M310-top+117440512
.long M318-top+117440512
.long M320-top+117440512
.long M328-top+117440512
.long M330-top+117440512
.long M338-top
.long M339-top
.long M33A-top
.long M33B-top
.long M33C-top
.long r_illegal-top+33554432
.long M340-top+117440512
.long M348-top+117440512
.long M350-top+117440512
.long M358-top+117440512
.long M360-top+117440512
.long M368-top+117440512
.long M370-top+117440512
.long M378-top
.long M379-top
.long M37A-top
.long M37B-top
.long M37C-top
.long r_illegal-top+33554432
.long M380-top+117440512
.long M388-top+117440512
.long M390-top+117440512
.long M398-top+117440512
.long M3A0-top+117440512
.long M3A8-top+117440512
.long M3B0-top+117440512
.long M3B8-top
.long M3B9-top
.long M3BA-top
.long M3BB-top
.long M3BC-top
.long r_illegal-top+33554432
.long M3C0-top+117440512
.long M3C8-top+117440512
.long M3D0-top+117440512
.long M3D8-top+117440512
.long M3E0-top+117440512
.long M3E8-top+117440512
.long M3F0-top+117440512
.long M3F8-top
.long M3F9-top
.long M3FA-top
.long M3FB-top
.long M3FC-top
.long r_illegal-top+33554432
.long M400-top+117440512
.long M408-top+117440512
.long M410-top+117440512
.long M418-top+117440512
.long M420-top+117440512
.long M428-top+117440512
.long M430-top+117440512
.long M438-top
.long M439-top
.long M43A-top
.long M43B-top
.long M43C-top
.long r_illegal-top+33554432
.long M440-top+117440512
.long M448-top+117440512
.long M450-top+117440512
.long M458-top+117440512
.long M460-top+117440512
.long M468-top+117440512
.long M470-top+117440512
.long M478-top
.long M479-top
.long M47A-top
.long M47B-top
.long M47C-top
.long r_illegal-top+33554432
.long M480-top+117440512
.long M488-top+117440512
.long M490-top+117440512
.long M498-top+117440512
.long M4A0-top+117440512
.long M4A8-top+117440512
.long M4B0-top+117440512
.long M4B8-top
.long M4B9-top
.long M4BA-top
.long M4BB-top
.long M4BC-top
.long r_illegal-top+33554432
.long M4C0-top+117440512
.long M4C8-top+117440512
.long M4D0-top+117440512
.long M4D8-top+117440512
.long M4E0-top+117440512
.long M4E8-top+117440512
.long M4F0-top+117440512
.long M4F8-top
.long M4F9-top
.long M4FA-top
.long M4FB-top
.long M4FC-top
.long r_illegal-top+33554432
.long M500-top+117440512
.long M508-top+117440512
.long M510-top+117440512
.long M518-top+117440512
.long M520-top+117440512
.long M528-top+117440512
.long M530-top+117440512
.long M538-top
.long M539-top
.long M53A-top
.long M53B-top
.long M53C-top
.long r_illegal-top+33554432
.long M540-top+117440512
.long M548-top+117440512
.long M550-top+117440512
.long M558-top+117440512
.long M560-top+117440512
.long M568-top+117440512
.long M570-top+117440512
.long M578-top
.long M579-top
.long M57A-top
.long M57B-top
.long M57C-top
.long r_illegal-top+33554432
.long M580-top+117440512
.long M588-top+117440512
.long M590-top+117440512
.long M598-top+117440512
.long M5A0-top+117440512
.long M5A8-top+117440512
.long M5B0-top+117440512
.long M5B8-top
.long M5B9-top
.long M5BA-top
.long M5BB-top
.long M5BC-top
.long r_illegal-top+1107296256
.long M600-top+117440512
.long M608-top+117440512
.long M610-top+117440512
.long M618-top+117440512
.long M620-top+117440512
.long M628-top+117440512
.long M630-top+117440512
.long M638-top
.long M639-top
.long M63A-top
.long M63B-top
.long M63C-top
.long r_illegal-top+33554432
.long M640-top+117440512
.long M648-top+117440512
.long M650-top+117440512
.long M658-top+117440512
.long M660-top+117440512
.long M668-top+117440512
.long M670-top+117440512
.long M678-top
.long M679-top
.long M67A-top
.long M67B-top
.long M67C-top
.long r_illegal-top+33554432
.long M680-top+117440512
.long M688-top+117440512
.long M690-top+117440512
.long M698-top+117440512
.long M6A0-top+117440512
.long M6A8-top+117440512
.long M6B0-top+117440512
.long M6B8-top
.long M6B9-top
.long M6BA-top
.long M6BB-top
.long M6BC-top
.long r_illegal-top+33554432
.long M6C0-top+117440512
.long M6C8-top+117440512
.long M6D0-top+117440512
.long M6D8-top+117440512
.long M6E0-top+117440512
.long M6E8-top+117440512
.long M6F0-top+117440512
.long M6F8-top
.long M6F9-top
.long M6FA-top
.long M6FB-top
.long M6FC-top
.long r_illegal-top+33554432
.long M700-top+117440512
.long M708-top+117440512
.long M710-top+117440512
.long M718-top+117440512
.long M720-top+117440512
.long M728-top+117440512
.long M730-top+117440512
.long M738-top
.long M739-top
.long M73A-top
.long M73B-top
.long M73C-top
.long r_illegal-top+33554432
.long M740-top+117440512
.long M748-top+117440512
.long M750-top+117440512
.long M758-top+117440512
.long M760-top+117440512
.long M768-top+117440512
.long M770-top+117440512
.long M778-top
.long M779-top
.long M77A-top
.long M77B-top
.long M77C-top
.long r_illegal-top+33554432
.long M780-top+117440512
.long M788-top+117440512
.long M790-top+117440512
.long M798-top+117440512
.long M7A0-top+117440512
.long M7A8-top+117440512
.long M7B0-top+117440512
.long M7B8-top
.long M7B9-top
.long M7BA-top
.long M7BB-top
.long M7BC-top
.long r_illegal-top+1107296256
.long M800-top+117440512
.long M808-top+117440512
.long M810-top+117440512
.long M818-top+117440512
.long M820-top+117440512
.long M828-top+117440512
.long M830-top+117440512
.long M838-top
.long M839-top
.long M83A-top
.long M83B-top
.long M83C-top
.long r_illegal-top+33554432
.long M840-top+117440512
.long M848-top+117440512
.long M850-top+117440512
.long M858-top+117440512
.long M860-top+117440512
.long M868-top+117440512
.long M870-top+117440512
.long M878-top
.long M879-top
.long M87A-top
.long M87B-top
.long M87C-top
.long r_illegal-top+33554432
.long M880-top+117440512
.long M888-top+117440512
.long M890-top+117440512
.long M898-top+117440512
.long M8A0-top+117440512
.long M8A8-top+117440512
.long M8B0-top+117440512
.long M8B8-top
.long M8B9-top
.long M8BA-top
.long M8BB-top
.long M8BC-top
.long r_illegal-top+33554432
.long M8C0-top+117440512
.long M8C8-top+117440512
.long M8D0-top+117440512
.long M8D8-top+117440512
.long M8E0-top+117440512
.long M8E8-top+117440512
.long M8F0-top+117440512
.long M8F8-top
.long M8F9-top
.long M8FA-top
.long M8FB-top
.long M8FC-top
.long r_illegal-top+33554432
.long M900-top+117440512
.long M908-top+117440512
.long M910-top+117440512
.long M918-top+117440512
.long M920-top+117440512
.long M928-top+117440512
.long M930-top+117440512
.long M938-top
.long M939-top
.long M93A-top
.long M93B-top
.long M93C-top
.long r_illegal-top+33554432
.long M940-top+117440512
.long M948-top+117440512
.long M950-top+117440512
.long M958-top+117440512
.long M960-top+117440512
.long M968-top+117440512
.long M970-top+117440512
.long M978-top
.long M979-top
.long M97A-top
.long M97B-top
.long M97C-top
.long r_illegal-top+33554432
.long M980-top+117440512
.long M988-top+117440512
.long M990-top+117440512
.long M998-top+117440512
.long M9A0-top+117440512
.long M9A8-top+117440512
.long M9B0-top+117440512
.long M9B8-top
.long M9B9-top
.long M9BA-top
.long M9BB-top
.long M9BC-top
.long r_illegal-top+1107296256
.long MA00-top+117440512
.long MA08-top+117440512
.long MA10-top+117440512
.long MA18-top+117440512
.long MA20-top+117440512
.long MA28-top+117440512
.long MA30-top+117440512
.long MA38-top
.long MA39-top
.long MA3A-top
.long MA3B-top
.long MA3C-top
.long r_illegal-top+33554432
.long MA40-top+117440512
.long MA48-top+117440512
.long MA50-top+117440512
.long MA58-top+117440512
.long MA60-top+117440512
.long MA68-top+117440512
.long MA70-top+117440512
.long MA78-top
.long MA79-top
.long MA7A-top
.long MA7B-top
.long MA7C-top
.long r_illegal-top+33554432
.long MA80-top+117440512
.long MA88-top+117440512
.long MA90-top+117440512
.long MA98-top+117440512
.long MAA0-top+117440512
.long MAA8-top+117440512
.long MAB0-top+117440512
.long MAB8-top
.long MAB9-top
.long MABA-top
.long MABB-top
.long MABC-top
.long r_illegal-top+33554432
.long MAC0-top+117440512
.long MAC8-top+117440512
.long MAD0-top+117440512
.long MAD8-top+117440512
.long MAE0-top+117440512
.long MAE8-top+117440512
.long MAF0-top+117440512
.long MAF8-top
.long MAF9-top
.long MAFA-top
.long MAFB-top
.long MAFC-top
.long r_illegal-top+33554432
.long MB00-top+117440512
.long MB08-top+117440512
.long MB10-top+117440512
.long MB18-top+117440512
.long MB20-top+117440512
.long MB28-top+117440512
.long MB30-top+117440512
.long MB38-top
.long MB39-top
.long MB3A-top
.long MB3B-top
.long MB3C-top
.long r_illegal-top+33554432
.long MB40-top+117440512
.long MB48-top+117440512
.long MB50-top+117440512
.long MB58-top+117440512
.long MB60-top+117440512
.long MB68-top+117440512
.long MB70-top+117440512
.long MB78-top
.long MB79-top
.long MB7A-top
.long MB7B-top
.long MB7C-top
.long r_illegal-top+33554432
.long MB80-top+117440512
.long MB88-top+117440512
.long MB90-top+117440512
.long MB98-top+117440512
.long MBA0-top+117440512
.long MBA8-top+117440512
.long MBB0-top+117440512
.long MBB8-top
.long MBB9-top
.long MBBA-top
.long MBBB-top
.long MBBC-top
.long r_illegal-top+1107296256
.long MC00-top+117440512
.long MC08-top+117440512
.long MC10-top+117440512
.long MC18-top+117440512
.long MC20-top+117440512
.long MC28-top+117440512
.long MC30-top+117440512
.long MC38-top
.long MC39-top
.long MC3A-top
.long MC3B-top
.long MC3C-top
.long r_illegal-top+33554432
.long MC40-top+117440512
.long MC48-top+117440512
.long MC50-top+117440512
.long MC58-top+117440512
.long MC60-top+117440512
.long MC68-top+117440512
.long MC70-top+117440512
.long MC78-top
.long MC79-top
.long MC7A-top
.long MC7B-top
.long MC7C-top
.long r_illegal-top+33554432
.long MC80-top+117440512
.long MC88-top+117440512
.long MC90-top+117440512
.long MC98-top+117440512
.long MCA0-top+117440512
.long MCA8-top+117440512
.long MCB0-top+117440512
.long MCB8-top
.long MCB9-top
.long MCBA-top
.long MCBB-top
.long MCBC-top
.long r_illegal-top+33554432
.long MCC0-top+117440512
.long MCC8-top+117440512
.long MCD0-top+117440512
.long MCD8-top+117440512
.long MCE0-top+117440512
.long MCE8-top+117440512
.long MCF0-top+117440512
.long MCF8-top
.long MCF9-top
.long MCFA-top
.long MCFB-top
.long MCFC-top
.long r_illegal-top+33554432
.long MD00-top+117440512
.long MD08-top+117440512
.long MD10-top+117440512
.long MD18-top+117440512
.long MD20-top+117440512
.long MD28-top+117440512
.long MD30-top+117440512
.long MD38-top
.long MD39-top
.long MD3A-top
.long MD3B-top
.long MD3C-top
.long r_illegal-top+33554432
.long MD40-top+117440512
.long MD48-top+117440512
.long MD50-top+117440512
.long MD58-top+117440512
.long MD60-top+117440512
.long MD68-top+117440512
.long MD70-top+117440512
.long MD78-top
.long MD79-top
.long MD7A-top
.long MD7B-top
.long MD7C-top
.long r_illegal-top+33554432
.long MD80-top+117440512
.long MD88-top+117440512
.long MD90-top+117440512
.long MD98-top+117440512
.long MDA0-top+117440512
.long MDA8-top+117440512
.long MDB0-top+117440512
.long MDB8-top
.long MDB9-top
.long MDBA-top
.long MDBB-top
.long MDBC-top
.long r_illegal-top+1107296256
.long ME00-top+117440512
.long ME08-top+117440512
.long ME10-top+117440512
.long ME18-top+117440512
.long ME20-top+117440512
.long ME28-top+117440512
.long ME30-top+117440512
.long ME38-top
.long ME39-top
.long ME3A-top
.long ME3B-top
.long ME3C-top
.long r_illegal-top+33554432
.long ME40-top+117440512
.long ME48-top+117440512
.long ME50-top+117440512
.long ME58-top+117440512
.long ME60-top+117440512
.long ME68-top+117440512
.long ME70-top+117440512
.long ME78-top
.long ME79-top
.long ME7A-top
.long ME7B-top
.long ME7C-top
.long r_illegal-top+33554432
.long ME80-top+117440512
.long ME88-top+117440512
.long ME90-top+117440512
.long ME98-top+117440512
.long MEA0-top+117440512
.long MEA8-top+117440512
.long MEB0-top+117440512
.long MEB8-top
.long MEB9-top
.long MEBA-top
.long MEBB-top
.long MEBC-top
.long r_illegal-top+33554432
.long MEC0-top+117440512
.long MEC8-top+117440512
.long MED0-top+117440512
.long MED8-top+117440512
.long MEE0-top+117440512
.long MEE8-top+117440512
.long MEF0-top+117440512
.long MEF8-top
.long MEF9-top
.long MEFA-top
.long MEFB-top
.long MEFC-top
.long r_illegal-top+33554432
.long MF00-top+117440512
.long MF08-top+117440512
.long MF10-top+117440512
.long MF18-top+117440512
.long MF20-top+117440512
.long MF28-top+117440512
.long MF30-top+117440512
.long MF38-top
.long MF39-top
.long MF3A-top
.long MF3B-top
.long MF3C-top
.long r_illegal-top+33554432
.long MF40-top+117440512
.long MF48-top+117440512
.long MF50-top+117440512
.long MF58-top+117440512
.long MF60-top+117440512
.long MF68-top+117440512
.long MF70-top+117440512
.long MF78-top
.long MF79-top
.long MF7A-top
.long MF7B-top
.long MF7C-top
.long r_illegal-top+33554432
.long MF80-top+117440512
.long MF88-top+117440512
.long MF90-top+117440512
.long MF98-top+117440512
.long MFA0-top+117440512
.long MFA8-top+117440512
.long MFB0-top+117440512
.long MFB8-top
.long MFB9-top
.long MFBA-top
.long MFBB-top
.long MFBC-top
.long r_illegal-top+1107296256
.long N000-top+117440512
.long N008-top+117440512
.long N010-top+117440512
.long N018-top+117440512
.long N020-top+117440512
.long N028-top+117440512
.long N030-top+117440512
.long N038-top
.long N039-top
.long N03A-top
.long N03B-top
.long N03C-top
.long r_illegal-top+33554432
.long N040-top+117440512
.long N048-top+117440512
.long N050-top+117440512
.long N058-top+117440512
.long N060-top+117440512
.long N068-top+117440512
.long N070-top+117440512
.long N078-top
.long N079-top
.long N07A-top
.long N07B-top
.long N07C-top
.long r_illegal-top+33554432
.long N080-top+117440512
.long N088-top+117440512
.long N090-top+117440512
.long N098-top+117440512
.long N0A0-top+117440512
.long N0A8-top+117440512
.long N0B0-top+117440512
.long N0B8-top
.long N0B9-top
.long N0BA-top
.long N0BB-top
.long N0BC-top
.long r_illegal-top+33554432
.long N0C0-top+117440512
.long N0C8-top+117440512
.long N0D0-top+117440512
.long N0D8-top+117440512
.long N0E0-top+117440512
.long N0E8-top+117440512
.long N0F0-top+117440512
.long N0F8-top
.long N0F9-top
.long N0FA-top
.long N0FB-top
.long N0FC-top
.long r_illegal-top+33554432
.long N100-top+117440512
.long N108-top+117440512
.long N110-top+117440512
.long N118-top+117440512
.long N120-top+117440512
.long N128-top+117440512
.long N130-top+117440512
.long N138-top
.long N139-top
.long N13A-top
.long N13B-top
.long N13C-top
.long r_illegal-top+33554432
.long N140-top+117440512
.long N148-top+117440512
.long N150-top+117440512
.long N158-top+117440512
.long N160-top+117440512
.long N168-top+117440512
.long N170-top+117440512
.long N178-top
.long N179-top
.long N17A-top
.long N17B-top
.long N17C-top
.long r_illegal-top+33554432
.long N180-top+117440512
.long N188-top+117440512
.long N190-top+117440512
.long N198-top+117440512
.long N1A0-top+117440512
.long N1A8-top+117440512
.long N1B0-top+117440512
.long N1B8-top
.long N1B9-top
.long N1BA-top
.long N1BB-top
.long N1BC-top
.long r_illegal-top+33554432
.long N1C0-top+117440512
.long N1C8-top+117440512
.long N1D0-top+117440512
.long N1D8-top+117440512
.long N1E0-top+117440512
.long N1E8-top+117440512
.long N1F0-top+117440512
.long N1F8-top
.long N1F9-top
.long N1FA-top
.long N1FB-top
.long N1FC-top
.long r_illegal-top+33554432
.long N200-top+117440512
.long N208-top+117440512
.long N210-top+117440512
.long N218-top+117440512
.long N220-top+117440512
.long N228-top+117440512
.long N230-top+117440512
.long N238-top
.long N239-top
.long N23A-top
.long N23B-top
.long N23C-top
.long r_illegal-top+33554432
.long N240-top+117440512
.long N248-top+117440512
.long N250-top+117440512
.long N258-top+117440512
.long N260-top+117440512
.long N268-top+117440512
.long N270-top+117440512
.long N278-top
.long N279-top
.long N27A-top
.long N27B-top
.long N27C-top
.long r_illegal-top+33554432
.long N280-top+117440512
.long N288-top+117440512
.long N290-top+117440512
.long N298-top+117440512
.long N2A0-top+117440512
.long N2A8-top+117440512
.long N2B0-top+117440512
.long N2B8-top
.long N2B9-top
.long N2BA-top
.long N2BB-top
.long N2BC-top
.long r_illegal-top+33554432
.long N2C0-top+117440512
.long N2C8-top+117440512
.long N2D0-top+117440512
.long N2D8-top+117440512
.long N2E0-top+117440512
.long N2E8-top+117440512
.long N2F0-top+117440512
.long N2F8-top
.long N2F9-top
.long N2FA-top
.long N2FB-top
.long N2FC-top
.long r_illegal-top+33554432
.long N300-top+117440512
.long N308-top+117440512
.long N310-top+117440512
.long N318-top+117440512
.long N320-top+117440512
.long N328-top+117440512
.long N330-top+117440512
.long N338-top
.long N339-top
.long N33A-top
.long N33B-top
.long N33C-top
.long r_illegal-top+33554432
.long N340-top+117440512
.long N348-top+117440512
.long N350-top+117440512
.long N358-top+117440512
.long N360-top+117440512
.long N368-top+117440512
.long N370-top+117440512
.long N378-top
.long N379-top
.long N37A-top
.long N37B-top
.long N37C-top
.long r_illegal-top+33554432
.long N380-top+117440512
.long N388-top+117440512
.long N390-top+117440512
.long N398-top+117440512
.long N3A0-top+117440512
.long N3A8-top+117440512
.long N3B0-top+117440512
.long N3B8-top
.long N3B9-top
.long N3BA-top
.long N3BB-top
.long N3BC-top
.long r_illegal-top+33554432
.long N3C0-top+117440512
.long N3C8-top+117440512
.long N3D0-top+117440512
.long N3D8-top+117440512
.long N3E0-top+117440512
.long N3E8-top+117440512
.long N3F0-top+117440512
.long N3F8-top
.long N3F9-top
.long N3FA-top
.long N3FB-top
.long N3FC-top
.long r_illegal-top+33554432
.long N400-top+117440512
.long N408-top+117440512
.long N410-top+117440512
.long N418-top+117440512
.long N420-top+117440512
.long N428-top+117440512
.long N430-top+117440512
.long N438-top
.long N439-top
.long N43A-top
.long N43B-top
.long N43C-top
.long r_illegal-top+33554432
.long N440-top+117440512
.long N448-top+117440512
.long N450-top+117440512
.long N458-top+117440512
.long N460-top+117440512
.long N468-top+117440512
.long N470-top+117440512
.long N478-top
.long N479-top
.long N47A-top
.long N47B-top
.long N47C-top
.long r_illegal-top+33554432
.long N480-top+117440512
.long N488-top+117440512
.long N490-top+117440512
.long N498-top+117440512
.long N4A0-top+117440512
.long N4A8-top+117440512
.long N4B0-top+117440512
.long N4B8-top
.long N4B9-top
.long N4BA-top
.long N4BB-top
.long N4BC-top
.long r_illegal-top+33554432
.long N4C0-top+117440512
.long N4C8-top+117440512
.long N4D0-top+117440512
.long N4D8-top+117440512
.long N4E0-top+117440512
.long N4E8-top+117440512
.long N4F0-top+117440512
.long N4F8-top
.long N4F9-top
.long N4FA-top
.long N4FB-top
.long N4FC-top
.long r_illegal-top+33554432
.long N500-top+117440512
.long N508-top+117440512
.long N510-top+117440512
.long N518-top+117440512
.long N520-top+117440512
.long N528-top+117440512
.long N530-top+117440512
.long N538-top
.long N539-top
.long N53A-top
.long N53B-top
.long N53C-top
.long r_illegal-top+33554432
.long N540-top+117440512
.long N548-top+117440512
.long N550-top+117440512
.long N558-top+117440512
.long N560-top+117440512
.long N568-top+117440512
.long N570-top+117440512
.long N578-top
.long N579-top
.long N57A-top
.long N57B-top
.long N57C-top
.long r_illegal-top+33554432
.long N580-top+117440512
.long N588-top+117440512
.long N590-top+117440512
.long N598-top+117440512
.long N5A0-top+117440512
.long N5A8-top+117440512
.long N5B0-top+117440512
.long N5B8-top
.long N5B9-top
.long N5BA-top
.long N5BB-top
.long N5BC-top
.long r_illegal-top+1107296256
.long N600-top+117440512
.long N608-top+117440512
.long N610-top+117440512
.long N618-top+117440512
.long N620-top+117440512
.long N628-top+117440512
.long N630-top+117440512
.long N638-top
.long N639-top
.long N63A-top
.long N63B-top
.long N63C-top
.long r_illegal-top+33554432
.long N640-top+117440512
.long N648-top+117440512
.long N650-top+117440512
.long N658-top+117440512
.long N660-top+117440512
.long N668-top+117440512
.long N670-top+117440512
.long N678-top
.long N679-top
.long N67A-top
.long N67B-top
.long N67C-top
.long r_illegal-top+33554432
.long N680-top+117440512
.long N688-top+117440512
.long N690-top+117440512
.long N698-top+117440512
.long N6A0-top+117440512
.long N6A8-top+117440512
.long N6B0-top+117440512
.long N6B8-top
.long N6B9-top
.long N6BA-top
.long N6BB-top
.long N6BC-top
.long r_illegal-top+33554432
.long N6C0-top+117440512
.long N6C8-top+117440512
.long N6D0-top+117440512
.long N6D8-top+117440512
.long N6E0-top+117440512
.long N6E8-top+117440512
.long N6F0-top+117440512
.long N6F8-top
.long N6F9-top
.long N6FA-top
.long N6FB-top
.long N6FC-top
.long r_illegal-top+33554432
.long N700-top+117440512
.long N708-top+117440512
.long N710-top+117440512
.long N718-top+117440512
.long N720-top+117440512
.long N728-top+117440512
.long N730-top+117440512
.long N738-top
.long N739-top
.long N73A-top
.long N73B-top
.long N73C-top
.long r_illegal-top+33554432
.long N740-top+117440512
.long N748-top+117440512
.long N750-top+117440512
.long N758-top+117440512
.long N760-top+117440512
.long N768-top+117440512
.long N770-top+117440512
.long N778-top
.long N779-top
.long N77A-top
.long N77B-top
.long N77C-top
.long r_illegal-top+33554432
.long N780-top+117440512
.long N788-top+117440512
.long N790-top+117440512
.long N798-top+117440512
.long N7A0-top+117440512
.long N7A8-top+117440512
.long N7B0-top+117440512
.long N7B8-top
.long N7B9-top
.long N7BA-top
.long N7BB-top
.long N7BC-top
.long r_illegal-top+1107296256
.long N800-top+117440512
.long N808-top+117440512
.long N810-top+117440512
.long N818-top+117440512
.long N820-top+117440512
.long N828-top+117440512
.long N830-top+117440512
.long N838-top
.long N839-top
.long N83A-top
.long N83B-top
.long N83C-top
.long r_illegal-top+33554432
.long N840-top+117440512
.long N848-top+117440512
.long N850-top+117440512
.long N858-top+117440512
.long N860-top+117440512
.long N868-top+117440512
.long N870-top+117440512
.long N878-top
.long N879-top
.long N87A-top
.long N87B-top
.long N87C-top
.long r_illegal-top+33554432
.long N880-top+117440512
.long N888-top+117440512
.long N890-top+117440512
.long N898-top+117440512
.long N8A0-top+117440512
.long N8A8-top+117440512
.long N8B0-top+117440512
.long N8B8-top
.long N8B9-top
.long N8BA-top
.long N8BB-top
.long N8BC-top
.long r_illegal-top+33554432
.long N8C0-top+117440512
.long N8C8-top+117440512
.long N8D0-top+117440512
.long N8D8-top+117440512
.long N8E0-top+117440512
.long N8E8-top+117440512
.long N8F0-top+117440512
.long N8F8-top
.long N8F9-top
.long N8FA-top
.long N8FB-top
.long N8FC-top
.long r_illegal-top+33554432
.long N900-top+117440512
.long N908-top+117440512
.long N910-top+117440512
.long N918-top+117440512
.long N920-top+117440512
.long N928-top+117440512
.long N930-top+117440512
.long N938-top
.long N939-top
.long N93A-top
.long N93B-top
.long N93C-top
.long r_illegal-top+33554432
.long N940-top+117440512
.long N948-top+117440512
.long N950-top+117440512
.long N958-top+117440512
.long N960-top+117440512
.long N968-top+117440512
.long N970-top+117440512
.long N978-top
.long N979-top
.long N97A-top
.long N97B-top
.long N97C-top
.long r_illegal-top+33554432
.long N980-top+117440512
.long N988-top+117440512
.long N990-top+117440512
.long N998-top+117440512
.long N9A0-top+117440512
.long N9A8-top+117440512
.long N9B0-top+117440512
.long N9B8-top
.long N9B9-top
.long N9BA-top
.long N9BB-top
.long N9BC-top
.long r_illegal-top+1107296256
.long NA00-top+117440512
.long NA08-top+117440512
.long NA10-top+117440512
.long NA18-top+117440512
.long NA20-top+117440512
.long NA28-top+117440512
.long NA30-top+117440512
.long NA38-top
.long NA39-top
.long NA3A-top
.long NA3B-top
.long NA3C-top
.long r_illegal-top+33554432
.long NA40-top+117440512
.long NA48-top+117440512
.long NA50-top+117440512
.long NA58-top+117440512
.long NA60-top+117440512
.long NA68-top+117440512
.long NA70-top+117440512
.long NA78-top
.long NA79-top
.long NA7A-top
.long NA7B-top
.long NA7C-top
.long r_illegal-top+33554432
.long NA80-top+117440512
.long NA88-top+117440512
.long NA90-top+117440512
.long NA98-top+117440512
.long NAA0-top+117440512
.long NAA8-top+117440512
.long NAB0-top+117440512
.long NAB8-top
.long NAB9-top
.long NABA-top
.long NABB-top
.long NABC-top
.long r_illegal-top+33554432
.long NAC0-top+117440512
.long NAC8-top+117440512
.long NAD0-top+117440512
.long NAD8-top+117440512
.long NAE0-top+117440512
.long NAE8-top+117440512
.long NAF0-top+117440512
.long NAF8-top
.long NAF9-top
.long NAFA-top
.long NAFB-top
.long NAFC-top
.long r_illegal-top+33554432
.long NB00-top+117440512
.long NB08-top+117440512
.long NB10-top+117440512
.long NB18-top+117440512
.long NB20-top+117440512
.long NB28-top+117440512
.long NB30-top+117440512
.long NB38-top
.long NB39-top
.long NB3A-top
.long NB3B-top
.long NB3C-top
.long r_illegal-top+33554432
.long NB40-top+117440512
.long NB48-top+117440512
.long NB50-top+117440512
.long NB58-top+117440512
.long NB60-top+117440512
.long NB68-top+117440512
.long NB70-top+117440512
.long NB78-top
.long NB79-top
.long NB7A-top
.long NB7B-top
.long NB7C-top
.long r_illegal-top+33554432
.long NB80-top+117440512
.long NB88-top+117440512
.long NB90-top+117440512
.long NB98-top+117440512
.long NBA0-top+117440512
.long NBA8-top+117440512
.long NBB0-top+117440512
.long NBB8-top
.long NBB9-top
.long NBBA-top
.long NBBB-top
.long NBBC-top
.long r_illegal-top+1107296256
.long NC00-top+117440512
.long NC08-top+117440512
.long NC10-top+117440512
.long NC18-top+117440512
.long NC20-top+117440512
.long NC28-top+117440512
.long NC30-top+117440512
.long NC38-top
.long NC39-top
.long NC3A-top
.long NC3B-top
.long NC3C-top
.long r_illegal-top+33554432
.long NC40-top+117440512
.long NC48-top+117440512
.long NC50-top+117440512
.long NC58-top+117440512
.long NC60-top+117440512
.long NC68-top+117440512
.long NC70-top+117440512
.long NC78-top
.long NC79-top
.long NC7A-top
.long NC7B-top
.long NC7C-top
.long r_illegal-top+33554432
.long NC80-top+117440512
.long NC88-top+117440512
.long NC90-top+117440512
.long NC98-top+117440512
.long NCA0-top+117440512
.long NCA8-top+117440512
.long NCB0-top+117440512
.long NCB8-top
.long NCB9-top
.long NCBA-top
.long NCBB-top
.long NCBC-top
.long r_illegal-top+33554432
.long NCC0-top+117440512
.long NCC8-top+117440512
.long NCD0-top+117440512
.long NCD8-top+117440512
.long NCE0-top+117440512
.long NCE8-top+117440512
.long NCF0-top+117440512
.long NCF8-top
.long NCF9-top
.long NCFA-top
.long NCFB-top
.long NCFC-top
.long r_illegal-top+33554432
.long ND00-top+117440512
.long ND08-top+117440512
.long ND10-top+117440512
.long ND18-top+117440512
.long ND20-top+117440512
.long ND28-top+117440512
.long ND30-top+117440512
.long ND38-top
.long ND39-top
.long ND3A-top
.long ND3B-top
.long ND3C-top
.long r_illegal-top+33554432
.long ND40-top+117440512
.long ND48-top+117440512
.long ND50-top+117440512
.long ND58-top+117440512
.long ND60-top+117440512
.long ND68-top+117440512
.long ND70-top+117440512
.long ND78-top
.long ND79-top
.long ND7A-top
.long ND7B-top
.long ND7C-top
.long r_illegal-top+33554432
.long ND80-top+117440512
.long ND88-top+117440512
.long ND90-top+117440512
.long ND98-top+117440512
.long NDA0-top+117440512
.long NDA8-top+117440512
.long NDB0-top+117440512
.long NDB8-top
.long NDB9-top
.long NDBA-top
.long NDBB-top
.long NDBC-top
.long r_illegal-top+1107296256
.long NE00-top+117440512
.long NE08-top+117440512
.long NE10-top+117440512
.long NE18-top+117440512
.long NE20-top+117440512
.long NE28-top+117440512
.long NE30-top+117440512
.long NE38-top
.long NE39-top
.long NE3A-top
.long NE3B-top
.long NE3C-top
.long r_illegal-top+33554432
.long NE40-top+117440512
.long NE48-top+117440512
.long NE50-top+117440512
.long NE58-top+117440512
.long NE60-top+117440512
.long NE68-top+117440512
.long NE70-top+117440512
.long NE78-top
.long NE79-top
.long NE7A-top
.long NE7B-top
.long NE7C-top
.long r_illegal-top+33554432
.long NE80-top+117440512
.long NE88-top+117440512
.long NE90-top+117440512
.long NE98-top+117440512
.long NEA0-top+117440512
.long NEA8-top+117440512
.long NEB0-top+117440512
.long NEB8-top
.long NEB9-top
.long NEBA-top
.long NEBB-top
.long NEBC-top
.long r_illegal-top+33554432
.long NEC0-top+117440512
.long NEC8-top+117440512
.long NED0-top+117440512
.long NED8-top+117440512
.long NEE0-top+117440512
.long NEE8-top+117440512
.long NEF0-top+117440512
.long NEF8-top
.long NEF9-top
.long NEFA-top
.long NEFB-top
.long NEFC-top
.long r_illegal-top+33554432
.long NF00-top+117440512
.long NF08-top+117440512
.long NF10-top+117440512
.long NF18-top+117440512
.long NF20-top+117440512
.long NF28-top+117440512
.long NF30-top+117440512
.long NF38-top
.long NF39-top
.long NF3A-top
.long NF3B-top
.long NF3C-top
.long r_illegal-top+33554432
.long NF40-top+117440512
.long NF48-top+117440512
.long NF50-top+117440512
.long NF58-top+117440512
.long NF60-top+117440512
.long NF68-top+117440512
.long NF70-top+117440512
.long NF78-top
.long NF79-top
.long NF7A-top
.long NF7B-top
.long NF7C-top
.long r_illegal-top+33554432
.long NF80-top+117440512
.long NF88-top+117440512
.long NF90-top+117440512
.long NF98-top+117440512
.long NFA0-top+117440512
.long NFA8-top+117440512
.long NFB0-top+117440512
.long NFB8-top
.long NFB9-top
.long NFBA-top
.long NFBB-top
.long NFBC-top
.long r_illegal-top+1107296256
.long O000-top+117440512
.long r_illegal-top+117440512
.long O010-top+117440512
.long O018-top+117440512
.long O020-top+117440512
.long O028-top+117440512
.long O030-top+117440512
.long O038-top
.long O039-top
.long r_illegal-top+83886080
.long O040-top+117440512
.long r_illegal-top+117440512
.long O050-top+117440512
.long O058-top+117440512
.long O060-top+117440512
.long O068-top+117440512
.long O070-top+117440512
.long O078-top
.long O079-top
.long r_illegal-top+83886080
.long O080-top+117440512
.long r_illegal-top+117440512
.long O090-top+117440512
.long O098-top+117440512
.long O0A0-top+117440512
.long O0A8-top+117440512
.long O0B0-top+117440512
.long O0B8-top
.long O0B9-top
.long r_illegal-top+83886080
.long O0C0-top+117440512
.long r_illegal-top+117440512
.long O0D0-top+117440512
.long O0D8-top+117440512
.long O0E0-top+117440512
.long O0E8-top+117440512
.long O0F0-top+117440512
.long O0F8-top
.long O0F9-top
.long r_illegal-top+2231369728
.long O180-top+117440512
.long r_illegal-top+117440512
.long O190-top+117440512
.long O198-top+117440512
.long O1A0-top+117440512
.long O1A8-top+117440512
.long O1B0-top+117440512
.long O1B8-top
.long O1B9-top
.long O1BA-top
.long O1BB-top
.long O1BC-top
.long r_illegal-top+301989888
.long O1D0-top+117440512
.long r_illegal-top+251658240
.long O1E8-top+117440512
.long O1F0-top+117440512
.long O1F8-top
.long O1F9-top
.long O1FA-top
.long O1FB-top
.long r_illegal-top+50331648
.long O200-top+117440512
.long r_illegal-top+117440512
.long O210-top+117440512
.long O218-top+117440512
.long O220-top+117440512
.long O228-top+117440512
.long O230-top+117440512
.long O238-top
.long O239-top
.long r_illegal-top+83886080
.long O240-top+117440512
.long r_illegal-top+117440512
.long O250-top+117440512
.long O258-top+117440512
.long O260-top+117440512
.long O268-top+117440512
.long O270-top+117440512
.long O278-top
.long O279-top
.long r_illegal-top+83886080
.long O280-top+117440512
.long r_illegal-top+117440512
.long O290-top+117440512
.long O298-top+117440512
.long O2A0-top+117440512
.long O2A8-top+117440512
.long O2B0-top+117440512
.long O2B8-top
.long O2B9-top
.long r_illegal-top+3305111552
.long O380-top+117440512
.long r_illegal-top+117440512
.long O390-top+117440512
.long O398-top+117440512
.long O3A0-top+117440512
.long O3A8-top+117440512
.long O3B0-top+117440512
.long O3B8-top
.long O3B9-top
.long O3BA-top
.long O3BB-top
.long O3BC-top
.long r_illegal-top+301989888
.long O3D0-top+117440512
.long r_illegal-top+251658240
.long O3E8-top+117440512
.long O3F0-top+117440512
.long O3F8-top
.long O3F9-top
.long O3FA-top
.long O3FB-top
.long r_illegal-top+50331648
.long O400-top+117440512
.long r_illegal-top+117440512
.long O410-top+117440512
.long O418-top+117440512
.long O420-top+117440512
.long O428-top+117440512
.long O430-top+117440512
.long O438-top
.long O439-top
.long r_illegal-top+83886080
.long O440-top+117440512
.long r_illegal-top+117440512
.long O450-top+117440512
.long O458-top+117440512
.long O460-top+117440512
.long O468-top+117440512
.long O470-top+117440512
.long O478-top
.long O479-top
.long r_illegal-top+83886080
.long O480-top+117440512
.long r_illegal-top+117440512
.long O490-top+117440512
.long O498-top+117440512
.long O4A0-top+117440512
.long O4A8-top+117440512
.long O4B0-top+117440512
.long O4B8-top
.long O4B9-top
.long r_illegal-top+83886080
.long O4C0-top+117440512
.long r_illegal-top+117440512
.long O4D0-top+117440512
.long O4D8-top+117440512
.long O4E0-top+117440512
.long O4E8-top+117440512
.long O4F0-top+117440512
.long O4F8-top
.long O4F9-top
.long O4FA-top
.long O4FB-top
.long O4FC-top
.long r_illegal-top+2181038080
.long O580-top+117440512
.long r_illegal-top+117440512
.long O590-top+117440512
.long O598-top+117440512
.long O5A0-top+117440512
.long O5A8-top+117440512
.long O5B0-top+117440512
.long O5B8-top
.long O5B9-top
.long O5BA-top
.long O5BB-top
.long O5BC-top
.long r_illegal-top+301989888
.long O5D0-top+117440512
.long r_illegal-top+251658240
.long O5E8-top+117440512
.long O5F0-top+117440512
.long O5F8-top
.long O5F9-top
.long O5FA-top
.long O5FB-top
.long r_illegal-top+50331648
.long O600-top+117440512
.long r_illegal-top+117440512
.long O610-top+117440512
.long O618-top+117440512
.long O620-top+117440512
.long O628-top+117440512
.long O630-top+117440512
.long O638-top
.long O639-top
.long r_illegal-top+83886080
.long O640-top+117440512
.long r_illegal-top+117440512
.long O650-top+117440512
.long O658-top+117440512
.long O660-top+117440512
.long O668-top+117440512
.long O670-top+117440512
.long O678-top
.long O679-top
.long r_illegal-top+83886080
.long O680-top+117440512
.long r_illegal-top+117440512
.long O690-top+117440512
.long O698-top+117440512
.long O6A0-top+117440512
.long O6A8-top+117440512
.long O6B0-top+117440512
.long O6B8-top
.long O6B9-top
.long r_illegal-top+83886080
.long O6C0-top+117440512
.long r_illegal-top+117440512
.long O6D0-top+117440512
.long O6D8-top+117440512
.long O6E0-top+117440512
.long O6E8-top+117440512
.long O6F0-top+117440512
.long O6F8-top
.long O6F9-top
.long O6FA-top
.long O6FB-top
.long O6FC-top
.long r_illegal-top+2181038080
.long O780-top+117440512
.long r_illegal-top+117440512
.long O790-top+117440512
.long O798-top+117440512
.long O7A0-top+117440512
.long O7A8-top+117440512
.long O7B0-top+117440512
.long O7B8-top
.long O7B9-top
.long O7BA-top
.long O7BB-top
.long O7BC-top
.long r_illegal-top+301989888
.long O7D0-top+117440512
.long r_illegal-top+251658240
.long O7E8-top+117440512
.long O7F0-top+117440512
.long O7F8-top
.long O7F9-top
.long O7FA-top
.long O7FB-top
.long r_illegal-top+50331648
.long O800-top+117440512
.long r_illegal-top+117440512
.long O810-top+117440512
.long O818-top+117440512
.long O820-top+117440512
.long O828-top+117440512
.long O830-top+117440512
.long O838-top
.long O839-top
.long r_illegal-top+83886080
.long O840-top+117440512
.long r_illegal-top+117440512
.long O850-top+117440512
.long r_illegal-top+251658240
.long O868-top+117440512
.long O870-top+117440512
.long O878-top
.long O879-top
.long O87A-top
.long O87B-top
.long r_illegal-top+50331648
.long O880-top+117440512
.long r_illegal-top+117440512
.long O890-top+117440512
.long r_illegal-top+117440512
.long O8A0-top+117440512
.long O8A8-top+117440512
.long O8B0-top+117440512
.long O8B8-top
.long O8B9-top
.long r_illegal-top+83886080
.long O8C0-top+117440512
.long r_illegal-top+117440512
.long O8D0-top+117440512
.long r_illegal-top+117440512
.long O8E0-top+117440512
.long O8E8-top+117440512
.long O8F0-top+117440512
.long O8F8-top
.long O8F9-top
.long r_illegal-top+2231369728
.long O980-top+117440512
.long r_illegal-top+117440512
.long O990-top+117440512
.long O998-top+117440512
.long O9A0-top+117440512
.long O9A8-top+117440512
.long O9B0-top+117440512
.long O9B8-top
.long O9B9-top
.long O9BA-top
.long O9BB-top
.long O9BC-top
.long r_illegal-top+301989888
.long O9D0-top+117440512
.long r_illegal-top+251658240
.long O9E8-top+117440512
.long O9F0-top+117440512
.long O9F8-top
.long O9F9-top
.long O9FA-top
.long O9FB-top
.long r_illegal-top+50331648
.long OA00-top+117440512
.long r_illegal-top+117440512
.long OA10-top+117440512
.long OA18-top+117440512
.long OA20-top+117440512
.long OA28-top+117440512
.long OA30-top+117440512
.long OA38-top
.long OA39-top
.long r_illegal-top+83886080
.long OA40-top+117440512
.long r_illegal-top+117440512
.long OA50-top+117440512
.long OA58-top+117440512
.long OA60-top+117440512
.long OA68-top+117440512
.long OA70-top+117440512
.long OA78-top
.long OA79-top
.long r_illegal-top+83886080
.long OA80-top+117440512
.long r_illegal-top+117440512
.long OA90-top+117440512
.long OA98-top+117440512
.long OAA0-top+117440512
.long OAA8-top+117440512
.long OAB0-top+117440512
.long OAB8-top
.long OAB9-top
.long r_illegal-top+83886080
.long OAC0-top+117440512
.long r_illegal-top+117440512
.long OAD0-top+117440512
.long OAD8-top+117440512
.long OAE0-top+117440512
.long OAE8-top+117440512
.long OAF0-top+117440512
.long OAF8-top
.long OAF9-top
.long OAFA-top
.long OAFB-top
.long OAFC-top
.long r_illegal-top+2181038080
.long OB80-top+117440512
.long r_illegal-top+117440512
.long OB90-top+117440512
.long OB98-top+117440512
.long OBA0-top+117440512
.long OBA8-top+117440512
.long OBB0-top+117440512
.long OBB8-top
.long OBB9-top
.long OBBA-top
.long OBBB-top
.long OBBC-top
.long r_illegal-top+301989888
.long OBD0-top+117440512
.long r_illegal-top+251658240
.long OBE8-top+117440512
.long OBF0-top+117440512
.long OBF8-top
.long OBF9-top
.long OBFA-top
.long OBFB-top
.long r_illegal-top+2466250752
.long OC90-top+117440512
.long OC98-top+117440512
.long r_illegal-top+117440512
.long OCA8-top+117440512
.long OCB0-top+117440512
.long OCB8-top
.long OCB9-top
.long OCBA-top
.long OCBB-top
.long r_illegal-top+318767104
.long OCD0-top+117440512
.long OCD8-top+117440512
.long r_illegal-top+117440512
.long OCE8-top+117440512
.long OCF0-top+117440512
.long OCF8-top
.long OCF9-top
.long OCFA-top
.long OCFB-top
.long r_illegal-top+2197815296
.long OD80-top+117440512
.long r_illegal-top+117440512
.long OD90-top+117440512
.long OD98-top+117440512
.long ODA0-top+117440512
.long ODA8-top+117440512
.long ODB0-top+117440512
.long ODB8-top
.long ODB9-top
.long ODBA-top
.long ODBB-top
.long ODBC-top
.long r_illegal-top+301989888
.long ODD0-top+117440512
.long r_illegal-top+251658240
.long ODE8-top+117440512
.long ODF0-top+117440512
.long ODF8-top
.long ODF9-top
.long ODFA-top
.long ODFB-top
.long r_illegal-top+1124073472
.long OE40-top+251658240
.long OE50-top+117440512
.long OE58-top+117440512
.long OE60-top+117440512
.long OE68-top+117440512
.long OE70-top
.long OE71-top
.long OE72-top
.long OE73-top
.long r_illegal-top
.long OE75-top
.long OE76-top
.long OE77-top
.long r_illegal-top+385875968
.long OE90-top+117440512
.long r_illegal-top+251658240
.long OEA8-top+117440512
.long OEB0-top+117440512
.long OEB8-top
.long OEB9-top
.long OEBA-top
.long OEBB-top
.long r_illegal-top+318767104
.long OED0-top+117440512
.long r_illegal-top+251658240
.long OEE8-top+117440512
.long OEF0-top+117440512
.long OEF8-top
.long OEF9-top
.long OEFA-top
.long OEFB-top
.long r_illegal-top+2197815296
.long OF80-top+117440512
.long r_illegal-top+117440512
.long OF90-top+117440512
.long OF98-top+117440512
.long OFA0-top+117440512
.long OFA8-top+117440512
.long OFB0-top+117440512
.long OFB8-top
.long OFB9-top
.long OFBA-top
.long OFBB-top
.long OFBC-top
.long r_illegal-top+301989888
.long OFD0-top+117440512
.long r_illegal-top+251658240
.long OFE8-top+117440512
.long OFF0-top+117440512
.long OFF8-top
.long OFF9-top
.long OFFA-top
.long OFFB-top
.long r_illegal-top+50331648
.long P000-top+117440512
.long P008-top+117440512
.long P010-top+117440512
.long P018-top+117440512
.long P020-top+117440512
.long P028-top+117440512
.long P030-top+117440512
.long P038-top
.long P039-top
.long r_illegal-top+83886080
.long P040-top+117440512
.long P048-top+117440512
.long P050-top+117440512
.long P058-top+117440512
.long P060-top+117440512
.long P068-top+117440512
.long P070-top+117440512
.long P078-top
.long P079-top
.long r_illegal-top+83886080
.long P080-top+117440512
.long P088-top+117440512
.long P090-top+117440512
.long P098-top+117440512
.long P0A0-top+117440512
.long P0A8-top+117440512
.long P0B0-top+117440512
.long P0B8-top
.long P0B9-top
.long r_illegal-top+83886080
.long P0C0-top+117440512
.long P0C8-top+117440512
.long P0D0-top+117440512
.long P0D8-top+117440512
.long P0E0-top+117440512
.long P0E8-top+117440512
.long P0F0-top+117440512
.long P0F8-top
.long P0F9-top
.long r_illegal-top+83886080
.long P100-top+117440512
.long P108-top+117440512
.long P110-top+117440512
.long P118-top+117440512
.long P120-top+117440512
.long P128-top+117440512
.long P130-top+117440512
.long P138-top
.long P139-top
.long r_illegal-top+83886080
.long P140-top+117440512
.long P148-top+117440512
.long P150-top+117440512
.long P158-top+117440512
.long P160-top+117440512
.long P168-top+117440512
.long P170-top+117440512
.long P178-top
.long P179-top
.long r_illegal-top+83886080
.long P180-top+117440512
.long P188-top+117440512
.long P190-top+117440512
.long P198-top+117440512
.long P1A0-top+117440512
.long P1A8-top+117440512
.long P1B0-top+117440512
.long P1B8-top
.long P1B9-top
.long r_illegal-top+83886080
.long P1C0-top+117440512
.long P1C8-top+117440512
.long P1D0-top+117440512
.long P1D8-top+117440512
.long P1E0-top+117440512
.long P1E8-top+117440512
.long P1F0-top+117440512
.long P1F8-top
.long P1F9-top
.long r_illegal-top+83886080
.long P200-top+117440512
.long P208-top+117440512
.long P210-top+117440512
.long P218-top+117440512
.long P220-top+117440512
.long P228-top+117440512
.long P230-top+117440512
.long P238-top
.long P239-top
.long r_illegal-top+83886080
.long P240-top+117440512
.long P248-top+117440512
.long P250-top+117440512
.long P258-top+117440512
.long P260-top+117440512
.long P268-top+117440512
.long P270-top+117440512
.long P278-top
.long P279-top
.long r_illegal-top+83886080
.long P280-top+117440512
.long P288-top+117440512
.long P290-top+117440512
.long P298-top+117440512
.long P2A0-top+117440512
.long P2A8-top+117440512
.long P2B0-top+117440512
.long P2B8-top
.long P2B9-top
.long r_illegal-top+83886080
.long P2C0-top+117440512
.long P2C8-top+117440512
.long P2D0-top+117440512
.long P2D8-top+117440512
.long P2E0-top+117440512
.long P2E8-top+117440512
.long P2F0-top+117440512
.long P2F8-top
.long P2F9-top
.long r_illegal-top+83886080
.long P300-top+117440512
.long P308-top+117440512
.long P310-top+117440512
.long P318-top+117440512
.long P320-top+117440512
.long P328-top+117440512
.long P330-top+117440512
.long P338-top
.long P339-top
.long r_illegal-top+83886080
.long P340-top+117440512
.long P348-top+117440512
.long P350-top+117440512
.long P358-top+117440512
.long P360-top+117440512
.long P368-top+117440512
.long P370-top+117440512
.long P378-top
.long P379-top
.long r_illegal-top+83886080
.long P380-top+117440512
.long P388-top+117440512
.long P390-top+117440512
.long P398-top+117440512
.long P3A0-top+117440512
.long P3A8-top+117440512
.long P3B0-top+117440512
.long P3B8-top
.long P3B9-top
.long r_illegal-top+83886080
.long P3C0-top+117440512
.long P3C8-top+117440512
.long P3D0-top+117440512
.long P3D8-top+117440512
.long P3E0-top+117440512
.long P3E8-top+117440512
.long P3F0-top+117440512
.long P3F8-top
.long P3F9-top
.long r_illegal-top+83886080
.long P400-top+117440512
.long P408-top+117440512
.long P410-top+117440512
.long P418-top+117440512
.long P420-top+117440512
.long P428-top+117440512
.long P430-top+117440512
.long P438-top
.long P439-top
.long r_illegal-top+83886080
.long P440-top+117440512
.long P448-top+117440512
.long P450-top+117440512
.long P458-top+117440512
.long P460-top+117440512
.long P468-top+117440512
.long P470-top+117440512
.long P478-top
.long P479-top
.long r_illegal-top+83886080
.long P480-top+117440512
.long P488-top+117440512
.long P490-top+117440512
.long P498-top+117440512
.long P4A0-top+117440512
.long P4A8-top+117440512
.long P4B0-top+117440512
.long P4B8-top
.long P4B9-top
.long r_illegal-top+83886080
.long P4C0-top+117440512
.long P4C8-top+117440512
.long P4D0-top+117440512
.long P4D8-top+117440512
.long P4E0-top+117440512
.long P4E8-top+117440512
.long P4F0-top+117440512
.long P4F8-top
.long P4F9-top
.long r_illegal-top+83886080
.long P500-top+117440512
.long P508-top+117440512
.long P510-top+117440512
.long P518-top+117440512
.long P520-top+117440512
.long P528-top+117440512
.long P530-top+117440512
.long P538-top
.long P539-top
.long r_illegal-top+83886080
.long P540-top+117440512
.long P548-top+117440512
.long P550-top+117440512
.long P558-top+117440512
.long P560-top+117440512
.long P568-top+117440512
.long P570-top+117440512
.long P578-top
.long P579-top
.long r_illegal-top+83886080
.long P580-top+117440512
.long P588-top+117440512
.long P590-top+117440512
.long P598-top+117440512
.long P5A0-top+117440512
.long P5A8-top+117440512
.long P5B0-top+117440512
.long P5B8-top
.long P5B9-top
.long r_illegal-top+83886080
.long P5C0-top+117440512
.long P5C8-top+117440512
.long P5D0-top+117440512
.long P5D8-top+117440512
.long P5E0-top+117440512
.long P5E8-top+117440512
.long P5F0-top+117440512
.long P5F8-top
.long P5F9-top
.long r_illegal-top+83886080
.long P600-top+117440512
.long P608-top+117440512
.long P610-top+117440512
.long P618-top+117440512
.long P620-top+117440512
.long P628-top+117440512
.long P630-top+117440512
.long P638-top
.long P639-top
.long r_illegal-top+83886080
.long P640-top+117440512
.long P648-top+117440512
.long P650-top+117440512
.long P658-top+117440512
.long P660-top+117440512
.long P668-top+117440512
.long P670-top+117440512
.long P678-top
.long P679-top
.long r_illegal-top+83886080
.long P680-top+117440512
.long P688-top+117440512
.long P690-top+117440512
.long P698-top+117440512
.long P6A0-top+117440512
.long P6A8-top+117440512
.long P6B0-top+117440512
.long P6B8-top
.long P6B9-top
.long r_illegal-top+83886080
.long P6C0-top+117440512
.long P6C8-top+117440512
.long P6D0-top+117440512
.long P6D8-top+117440512
.long P6E0-top+117440512
.long P6E8-top+117440512
.long P6F0-top+117440512
.long P6F8-top
.long P6F9-top
.long r_illegal-top+83886080
.long P700-top+117440512
.long P708-top+117440512
.long P710-top+117440512
.long P718-top+117440512
.long P720-top+117440512
.long P728-top+117440512
.long P730-top+117440512
.long P738-top
.long P739-top
.long r_illegal-top+83886080
.long P740-top+117440512
.long P748-top+117440512
.long P750-top+117440512
.long P758-top+117440512
.long P760-top+117440512
.long P768-top+117440512
.long P770-top+117440512
.long P778-top
.long P779-top
.long r_illegal-top+83886080
.long P780-top+117440512
.long P788-top+117440512
.long P790-top+117440512
.long P798-top+117440512
.long P7A0-top+117440512
.long P7A8-top+117440512
.long P7B0-top+117440512
.long P7B8-top
.long P7B9-top
.long r_illegal-top+83886080
.long P7C0-top+117440512
.long P7C8-top+117440512
.long P7D0-top+117440512
.long P7D8-top+117440512
.long P7E0-top+117440512
.long P7E8-top+117440512
.long P7F0-top+117440512
.long P7F8-top
.long P7F9-top
.long r_illegal-top+83886080
.long P800-top+117440512
.long P808-top+117440512
.long P810-top+117440512
.long P818-top+117440512
.long P820-top+117440512
.long P828-top+117440512
.long P830-top+117440512
.long P838-top
.long P839-top
.long r_illegal-top+83886080
.long P840-top+117440512
.long P848-top+117440512
.long P850-top+117440512
.long P858-top+117440512
.long P860-top+117440512
.long P868-top+117440512
.long P870-top+117440512
.long P878-top
.long P879-top
.long r_illegal-top+83886080
.long P880-top+117440512
.long P888-top+117440512
.long P890-top+117440512
.long P898-top+117440512
.long P8A0-top+117440512
.long P8A8-top+117440512
.long P8B0-top+117440512
.long P8B8-top
.long P8B9-top
.long r_illegal-top+83886080
.long P8C0-top+117440512
.long P8C8-top+117440512
.long P8D0-top+117440512
.long P8D8-top+117440512
.long P8E0-top+117440512
.long P8E8-top+117440512
.long P8F0-top+117440512
.long P8F8-top
.long P8F9-top
.long r_illegal-top+83886080
.long P900-top+117440512
.long P908-top+117440512
.long P910-top+117440512
.long P918-top+117440512
.long P920-top+117440512
.long P928-top+117440512
.long P930-top+117440512
.long P938-top
.long P939-top
.long r_illegal-top+83886080
.long P940-top+117440512
.long P948-top+117440512
.long P950-top+117440512
.long P958-top+117440512
.long P960-top+117440512
.long P968-top+117440512
.long P970-top+117440512
.long P978-top
.long P979-top
.long r_illegal-top+83886080
.long P980-top+117440512
.long P988-top+117440512
.long P990-top+117440512
.long P998-top+117440512
.long P9A0-top+117440512
.long P9A8-top+117440512
.long P9B0-top+117440512
.long P9B8-top
.long P9B9-top
.long r_illegal-top+83886080
.long P9C0-top+117440512
.long P9C8-top+117440512
.long P9D0-top+117440512
.long P9D8-top+117440512
.long P9E0-top+117440512
.long P9E8-top+117440512
.long P9F0-top+117440512
.long P9F8-top
.long P9F9-top
.long r_illegal-top+83886080
.long PA00-top+117440512
.long PA08-top+117440512
.long PA10-top+117440512
.long PA18-top+117440512
.long PA20-top+117440512
.long PA28-top+117440512
.long PA30-top+117440512
.long PA38-top
.long PA39-top
.long r_illegal-top+83886080
.long PA40-top+117440512
.long PA48-top+117440512
.long PA50-top+117440512
.long PA58-top+117440512
.long PA60-top+117440512
.long PA68-top+117440512
.long PA70-top+117440512
.long PA78-top
.long PA79-top
.long r_illegal-top+83886080
.long PA80-top+117440512
.long PA88-top+117440512
.long PA90-top+117440512
.long PA98-top+117440512
.long PAA0-top+117440512
.long PAA8-top+117440512
.long PAB0-top+117440512
.long PAB8-top
.long PAB9-top
.long r_illegal-top+83886080
.long PAC0-top+117440512
.long PAC8-top+117440512
.long PAD0-top+117440512
.long PAD8-top+117440512
.long PAE0-top+117440512
.long PAE8-top+117440512
.long PAF0-top+117440512
.long PAF8-top
.long PAF9-top
.long r_illegal-top+83886080
.long PB00-top+117440512
.long PB08-top+117440512
.long PB10-top+117440512
.long PB18-top+117440512
.long PB20-top+117440512
.long PB28-top+117440512
.long PB30-top+117440512
.long PB38-top
.long PB39-top
.long r_illegal-top+83886080
.long PB40-top+117440512
.long PB48-top+117440512
.long PB50-top+117440512
.long PB58-top+117440512
.long PB60-top+117440512
.long PB68-top+117440512
.long PB70-top+117440512
.long PB78-top
.long PB79-top
.long r_illegal-top+83886080
.long PB80-top+117440512
.long PB88-top+117440512
.long PB90-top+117440512
.long PB98-top+117440512
.long PBA0-top+117440512
.long PBA8-top+117440512
.long PBB0-top+117440512
.long PBB8-top
.long PBB9-top
.long r_illegal-top+83886080
.long PBC0-top+117440512
.long PBC8-top+117440512
.long PBD0-top+117440512
.long PBD8-top+117440512
.long PBE0-top+117440512
.long PBE8-top+117440512
.long PBF0-top+117440512
.long PBF8-top
.long PBF9-top
.long r_illegal-top+83886080
.long PC00-top+117440512
.long PC08-top+117440512
.long PC10-top+117440512
.long PC18-top+117440512
.long PC20-top+117440512
.long PC28-top+117440512
.long PC30-top+117440512
.long PC38-top
.long PC39-top
.long r_illegal-top+83886080
.long PC40-top+117440512
.long PC48-top+117440512
.long PC50-top+117440512
.long PC58-top+117440512
.long PC60-top+117440512
.long PC68-top+117440512
.long PC70-top+117440512
.long PC78-top
.long PC79-top
.long r_illegal-top+83886080
.long PC80-top+117440512
.long PC88-top+117440512
.long PC90-top+117440512
.long PC98-top+117440512
.long PCA0-top+117440512
.long PCA8-top+117440512
.long PCB0-top+117440512
.long PCB8-top
.long PCB9-top
.long r_illegal-top+83886080
.long PCC0-top+117440512
.long PCC8-top+117440512
.long PCD0-top+117440512
.long PCD8-top+117440512
.long PCE0-top+117440512
.long PCE8-top+117440512
.long PCF0-top+117440512
.long PCF8-top
.long PCF9-top
.long r_illegal-top+83886080
.long PD00-top+117440512
.long PD08-top+117440512
.long PD10-top+117440512
.long PD18-top+117440512
.long PD20-top+117440512
.long PD28-top+117440512
.long PD30-top+117440512
.long PD38-top
.long PD39-top
.long r_illegal-top+83886080
.long PD40-top+117440512
.long PD48-top+117440512
.long PD50-top+117440512
.long PD58-top+117440512
.long PD60-top+117440512
.long PD68-top+117440512
.long PD70-top+117440512
.long PD78-top
.long PD79-top
.long r_illegal-top+83886080
.long PD80-top+117440512
.long PD88-top+117440512
.long PD90-top+117440512
.long PD98-top+117440512
.long PDA0-top+117440512
.long PDA8-top+117440512
.long PDB0-top+117440512
.long PDB8-top
.long PDB9-top
.long r_illegal-top+83886080
.long PDC0-top+117440512
.long PDC8-top+117440512
.long PDD0-top+117440512
.long PDD8-top+117440512
.long PDE0-top+117440512
.long PDE8-top+117440512
.long PDF0-top+117440512
.long PDF8-top
.long PDF9-top
.long r_illegal-top+83886080
.long PE00-top+117440512
.long PE08-top+117440512
.long PE10-top+117440512
.long PE18-top+117440512
.long PE20-top+117440512
.long PE28-top+117440512
.long PE30-top+117440512
.long PE38-top
.long PE39-top
.long r_illegal-top+83886080
.long PE40-top+117440512
.long PE48-top+117440512
.long PE50-top+117440512
.long PE58-top+117440512
.long PE60-top+117440512
.long PE68-top+117440512
.long PE70-top+117440512
.long PE78-top
.long PE79-top
.long r_illegal-top+83886080
.long PE80-top+117440512
.long PE88-top+117440512
.long PE90-top+117440512
.long PE98-top+117440512
.long PEA0-top+117440512
.long PEA8-top+117440512
.long PEB0-top+117440512
.long PEB8-top
.long PEB9-top
.long r_illegal-top+83886080
.long PEC0-top+117440512
.long PEC8-top+117440512
.long PED0-top+117440512
.long PED8-top+117440512
.long PEE0-top+117440512
.long PEE8-top+117440512
.long PEF0-top+117440512
.long PEF8-top
.long PEF9-top
.long r_illegal-top+83886080
.long PF00-top+117440512
.long PF08-top+117440512
.long PF10-top+117440512
.long PF18-top+117440512
.long PF20-top+117440512
.long PF28-top+117440512
.long PF30-top+117440512
.long PF38-top
.long PF39-top
.long r_illegal-top+83886080
.long PF40-top+117440512
.long PF48-top+117440512
.long PF50-top+117440512
.long PF58-top+117440512
.long PF60-top+117440512
.long PF68-top+117440512
.long PF70-top+117440512
.long PF78-top
.long PF79-top
.long r_illegal-top+83886080
.long PF80-top+117440512
.long PF88-top+117440512
.long PF90-top+117440512
.long PF98-top+117440512
.long PFA0-top+117440512
.long PFA8-top+117440512
.long PFB0-top+117440512
.long PFB8-top
.long PFB9-top
.long r_illegal-top+83886080
.long PFC0-top+117440512
.long PFC8-top+117440512
.long PFD0-top+117440512
.long PFD8-top+117440512
.long PFE0-top+117440512
.long PFE8-top+117440512
.long PFF0-top+117440512
.long PFF8-top
.long PFF9-top
.long r_illegal-top+83886080
.long Q000-top
.long Q001-top+4261412864
.long Q100-top
.long Q101-top+4261412864
.long Q200-top
.long Q201-top+4261412864
.long Q300-top
.long Q301-top+4261412864
.long Q400-top
.long Q401-top+4261412864
.long Q500-top
.long Q501-top+4261412864
.long Q600-top
.long Q601-top+4261412864
.long Q700-top
.long Q701-top+4261412864
.long Q800-top
.long Q801-top+4261412864
.long Q900-top
.long Q901-top+4261412864
.long QA00-top
.long QA01-top+4261412864
.long QB00-top
.long QB01-top+4261412864
.long QC00-top
.long QC01-top+4261412864
.long QD00-top
.long QD01-top+4261412864
.long QE00-top
.long QE01-top+4261412864
.long QF00-top
.long QF01-top+4261412864
.long R000-top+4278190080
.long r_illegal-top+4278190080
.long R200-top+4278190080
.long r_illegal-top+4278190080
.long R400-top+4278190080
.long r_illegal-top+4278190080
.long R600-top+4278190080
.long r_illegal-top+4278190080
.long R800-top+4278190080
.long r_illegal-top+4278190080
.long RA00-top+4278190080
.long r_illegal-top+4278190080
.long RC00-top+4278190080
.long r_illegal-top+4278190080
.long RE00-top+4278190080
.long r_illegal-top+4278190080
.long S000-top+117440512
.long r_illegal-top+117440512
.long S010-top+117440512
.long S018-top+117440512
.long S020-top+117440512
.long S028-top+117440512
.long S030-top+117440512
.long S038-top
.long S039-top
.long S03A-top
.long S03B-top
.long S03C-top
.long r_illegal-top+33554432
.long S040-top+117440512
.long r_illegal-top+117440512
.long S050-top+117440512
.long S058-top+117440512
.long S060-top+117440512
.long S068-top+117440512
.long S070-top+117440512
.long S078-top
.long S079-top
.long S07A-top
.long S07B-top
.long S07C-top
.long r_illegal-top+33554432
.long S080-top+117440512
.long r_illegal-top+117440512
.long S090-top+117440512
.long S098-top+117440512
.long S0A0-top+117440512
.long S0A8-top+117440512
.long S0B0-top+117440512
.long S0B8-top
.long S0B9-top
.long S0BA-top
.long S0BB-top
.long S0BC-top
.long r_illegal-top+33554432
.long S0C0-top+117440512
.long r_illegal-top+117440512
.long S0D0-top+117440512
.long S0D8-top+117440512
.long S0E0-top+117440512
.long S0E8-top+117440512
.long S0F0-top+117440512
.long S0F8-top
.long S0F9-top
.long S0FA-top
.long S0FB-top
.long S0FC-top
.long r_illegal-top+33554432
.long S100-top+117440512
.long S108-top+117440512
.long S110-top+117440512
.long S118-top+117440512
.long S120-top+117440512
.long S128-top+117440512
.long S130-top+117440512
.long S138-top
.long S139-top
.long r_illegal-top+352321536
.long S150-top+117440512
.long S158-top+117440512
.long S160-top+117440512
.long S168-top+117440512
.long S170-top+117440512
.long S178-top
.long S179-top
.long r_illegal-top+352321536
.long S190-top+117440512
.long S198-top+117440512
.long S1A0-top+117440512
.long S1A8-top+117440512
.long S1B0-top+117440512
.long S1B8-top
.long S1B9-top
.long r_illegal-top+83886080
.long S1C0-top+117440512
.long r_illegal-top+117440512
.long S1D0-top+117440512
.long S1D8-top+117440512
.long S1E0-top+117440512
.long S1E8-top+117440512
.long S1F0-top+117440512
.long S1F8-top
.long S1F9-top
.long S1FA-top
.long S1FB-top
.long S1FC-top
.long r_illegal-top+33554432
.long S200-top+117440512
.long r_illegal-top+117440512
.long S210-top+117440512
.long S218-top+117440512
.long S220-top+117440512
.long S228-top+117440512
.long S230-top+117440512
.long S238-top
.long S239-top
.long S23A-top
.long S23B-top
.long S23C-top
.long r_illegal-top+33554432
.long S240-top+117440512
.long r_illegal-top+117440512
.long S250-top+117440512
.long S258-top+117440512
.long S260-top+117440512
.long S268-top+117440512
.long S270-top+117440512
.long S278-top
.long S279-top
.long S27A-top
.long S27B-top
.long S27C-top
.long r_illegal-top+33554432
.long S280-top+117440512
.long r_illegal-top+117440512
.long S290-top+117440512
.long S298-top+117440512
.long S2A0-top+117440512
.long S2A8-top+117440512
.long S2B0-top+117440512
.long S2B8-top
.long S2B9-top
.long S2BA-top
.long S2BB-top
.long S2BC-top
.long r_illegal-top+33554432
.long S2C0-top+117440512
.long r_illegal-top+117440512
.long S2D0-top+117440512
.long S2D8-top+117440512
.long S2E0-top+117440512
.long S2E8-top+117440512
.long S2F0-top+117440512
.long S2F8-top
.long S2F9-top
.long S2FA-top
.long S2FB-top
.long S2FC-top
.long r_illegal-top+33554432
.long S300-top+117440512
.long S308-top+117440512
.long S310-top+117440512
.long S318-top+117440512
.long S320-top+117440512
.long S328-top+117440512
.long S330-top+117440512
.long S338-top
.long S339-top
.long r_illegal-top+352321536
.long S350-top+117440512
.long S358-top+117440512
.long S360-top+117440512
.long S368-top+117440512
.long S370-top+117440512
.long S378-top
.long S379-top
.long r_illegal-top+352321536
.long S390-top+117440512
.long S398-top+117440512
.long S3A0-top+117440512
.long S3A8-top+117440512
.long S3B0-top+117440512
.long S3B8-top
.long S3B9-top
.long r_illegal-top+83886080
.long S3C0-top+117440512
.long r_illegal-top+117440512
.long S3D0-top+117440512
.long S3D8-top+117440512
.long S3E0-top+117440512
.long S3E8-top+117440512
.long S3F0-top+117440512
.long S3F8-top
.long S3F9-top
.long S3FA-top
.long S3FB-top
.long S3FC-top
.long r_illegal-top+33554432
.long S400-top+117440512
.long r_illegal-top+117440512
.long S410-top+117440512
.long S418-top+117440512
.long S420-top+117440512
.long S428-top+117440512
.long S430-top+117440512
.long S438-top
.long S439-top
.long S43A-top
.long S43B-top
.long S43C-top
.long r_illegal-top+33554432
.long S440-top+117440512
.long r_illegal-top+117440512
.long S450-top+117440512
.long S458-top+117440512
.long S460-top+117440512
.long S468-top+117440512
.long S470-top+117440512
.long S478-top
.long S479-top
.long S47A-top
.long S47B-top
.long S47C-top
.long r_illegal-top+33554432
.long S480-top+117440512
.long r_illegal-top+117440512
.long S490-top+117440512
.long S498-top+117440512
.long S4A0-top+117440512
.long S4A8-top+117440512
.long S4B0-top+117440512
.long S4B8-top
.long S4B9-top
.long S4BA-top
.long S4BB-top
.long S4BC-top
.long r_illegal-top+33554432
.long S4C0-top+117440512
.long r_illegal-top+117440512
.long S4D0-top+117440512
.long S4D8-top+117440512
.long S4E0-top+117440512
.long S4E8-top+117440512
.long S4F0-top+117440512
.long S4F8-top
.long S4F9-top
.long S4FA-top
.long S4FB-top
.long S4FC-top
.long r_illegal-top+33554432
.long S500-top+117440512
.long S508-top+117440512
.long S510-top+117440512
.long S518-top+117440512
.long S520-top+117440512
.long S528-top+117440512
.long S530-top+117440512
.long S538-top
.long S539-top
.long r_illegal-top+352321536
.long S550-top+117440512
.long S558-top+117440512
.long S560-top+117440512
.long S568-top+117440512
.long S570-top+117440512
.long S578-top
.long S579-top
.long r_illegal-top+352321536
.long S590-top+117440512
.long S598-top+117440512
.long S5A0-top+117440512
.long S5A8-top+117440512
.long S5B0-top+117440512
.long S5B8-top
.long S5B9-top
.long r_illegal-top+83886080
.long S5C0-top+117440512
.long r_illegal-top+117440512
.long S5D0-top+117440512
.long S5D8-top+117440512
.long S5E0-top+117440512
.long S5E8-top+117440512
.long S5F0-top+117440512
.long S5F8-top
.long S5F9-top
.long S5FA-top
.long S5FB-top
.long S5FC-top
.long r_illegal-top+33554432
.long S600-top+117440512
.long r_illegal-top+117440512
.long S610-top+117440512
.long S618-top+117440512
.long S620-top+117440512
.long S628-top+117440512
.long S630-top+117440512
.long S638-top
.long S639-top
.long S63A-top
.long S63B-top
.long S63C-top
.long r_illegal-top+33554432
.long S640-top+117440512
.long r_illegal-top+117440512
.long S650-top+117440512
.long S658-top+117440512
.long S660-top+117440512
.long S668-top+117440512
.long S670-top+117440512
.long S678-top
.long S679-top
.long S67A-top
.long S67B-top
.long S67C-top
.long r_illegal-top+33554432
.long S680-top+117440512
.long r_illegal-top+117440512
.long S690-top+117440512
.long S698-top+117440512
.long S6A0-top+117440512
.long S6A8-top+117440512
.long S6B0-top+117440512
.long S6B8-top
.long S6B9-top
.long S6BA-top
.long S6BB-top
.long S6BC-top
.long r_illegal-top+33554432
.long S6C0-top+117440512
.long r_illegal-top+117440512
.long S6D0-top+117440512
.long S6D8-top+117440512
.long S6E0-top+117440512
.long S6E8-top+117440512
.long S6F0-top+117440512
.long S6F8-top
.long S6F9-top
.long S6FA-top
.long S6FB-top
.long S6FC-top
.long r_illegal-top+33554432
.long S700-top+117440512
.long S708-top+117440512
.long S710-top+117440512
.long S718-top+117440512
.long S720-top+117440512
.long S728-top+117440512
.long S730-top+117440512
.long S738-top
.long S739-top
.long r_illegal-top+352321536
.long S750-top+117440512
.long S758-top+117440512
.long S760-top+117440512
.long S768-top+117440512
.long S770-top+117440512
.long S778-top
.long S779-top
.long r_illegal-top+352321536
.long S790-top+117440512
.long S798-top+117440512
.long S7A0-top+117440512
.long S7A8-top+117440512
.long S7B0-top+117440512
.long S7B8-top
.long S7B9-top
.long r_illegal-top+83886080
.long S7C0-top+117440512
.long r_illegal-top+117440512
.long S7D0-top+117440512
.long S7D8-top+117440512
.long S7E0-top+117440512
.long S7E8-top+117440512
.long S7F0-top+117440512
.long S7F8-top
.long S7F9-top
.long S7FA-top
.long S7FB-top
.long S7FC-top
.long r_illegal-top+33554432
.long S800-top+117440512
.long r_illegal-top+117440512
.long S810-top+117440512
.long S818-top+117440512
.long S820-top+117440512
.long S828-top+117440512
.long S830-top+117440512
.long S838-top
.long S839-top
.long S83A-top
.long S83B-top
.long S83C-top
.long r_illegal-top+33554432
.long S840-top+117440512
.long r_illegal-top+117440512
.long S850-top+117440512
.long S858-top+117440512
.long S860-top+117440512
.long S868-top+117440512
.long S870-top+117440512
.long S878-top
.long S879-top
.long S87A-top
.long S87B-top
.long S87C-top
.long r_illegal-top+33554432
.long S880-top+117440512
.long r_illegal-top+117440512
.long S890-top+117440512
.long S898-top+117440512
.long S8A0-top+117440512
.long S8A8-top+117440512
.long S8B0-top+117440512
.long S8B8-top
.long S8B9-top
.long S8BA-top
.long S8BB-top
.long S8BC-top
.long r_illegal-top+33554432
.long S8C0-top+117440512
.long r_illegal-top+117440512
.long S8D0-top+117440512
.long S8D8-top+117440512
.long S8E0-top+117440512
.long S8E8-top+117440512
.long S8F0-top+117440512
.long S8F8-top
.long S8F9-top
.long S8FA-top
.long S8FB-top
.long S8FC-top
.long r_illegal-top+33554432
.long S900-top+117440512
.long S908-top+117440512
.long S910-top+117440512
.long S918-top+117440512
.long S920-top+117440512
.long S928-top+117440512
.long S930-top+117440512
.long S938-top
.long S939-top
.long r_illegal-top+352321536
.long S950-top+117440512
.long S958-top+117440512
.long S960-top+117440512
.long S968-top+117440512
.long S970-top+117440512
.long S978-top
.long S979-top
.long r_illegal-top+352321536
.long S990-top+117440512
.long S998-top+117440512
.long S9A0-top+117440512
.long S9A8-top+117440512
.long S9B0-top+117440512
.long S9B8-top
.long S9B9-top
.long r_illegal-top+83886080
.long S9C0-top+117440512
.long r_illegal-top+117440512
.long S9D0-top+117440512
.long S9D8-top+117440512
.long S9E0-top+117440512
.long S9E8-top+117440512
.long S9F0-top+117440512
.long S9F8-top
.long S9F9-top
.long S9FA-top
.long S9FB-top
.long S9FC-top
.long r_illegal-top+33554432
.long SA00-top+117440512
.long r_illegal-top+117440512
.long SA10-top+117440512
.long SA18-top+117440512
.long SA20-top+117440512
.long SA28-top+117440512
.long SA30-top+117440512
.long SA38-top
.long SA39-top
.long SA3A-top
.long SA3B-top
.long SA3C-top
.long r_illegal-top+33554432
.long SA40-top+117440512
.long r_illegal-top+117440512
.long SA50-top+117440512
.long SA58-top+117440512
.long SA60-top+117440512
.long SA68-top+117440512
.long SA70-top+117440512
.long SA78-top
.long SA79-top
.long SA7A-top
.long SA7B-top
.long SA7C-top
.long r_illegal-top+33554432
.long SA80-top+117440512
.long r_illegal-top+117440512
.long SA90-top+117440512
.long SA98-top+117440512
.long SAA0-top+117440512
.long SAA8-top+117440512
.long SAB0-top+117440512
.long SAB8-top
.long SAB9-top
.long SABA-top
.long SABB-top
.long SABC-top
.long r_illegal-top+33554432
.long SAC0-top+117440512
.long r_illegal-top+117440512
.long SAD0-top+117440512
.long SAD8-top+117440512
.long SAE0-top+117440512
.long SAE8-top+117440512
.long SAF0-top+117440512
.long SAF8-top
.long SAF9-top
.long SAFA-top
.long SAFB-top
.long SAFC-top
.long r_illegal-top+33554432
.long SB00-top+117440512
.long SB08-top+117440512
.long SB10-top+117440512
.long SB18-top+117440512
.long SB20-top+117440512
.long SB28-top+117440512
.long SB30-top+117440512
.long SB38-top
.long SB39-top
.long r_illegal-top+352321536
.long SB50-top+117440512
.long SB58-top+117440512
.long SB60-top+117440512
.long SB68-top+117440512
.long SB70-top+117440512
.long SB78-top
.long SB79-top
.long r_illegal-top+352321536
.long SB90-top+117440512
.long SB98-top+117440512
.long SBA0-top+117440512
.long SBA8-top+117440512
.long SBB0-top+117440512
.long SBB8-top
.long SBB9-top
.long r_illegal-top+83886080
.long SBC0-top+117440512
.long r_illegal-top+117440512
.long SBD0-top+117440512
.long SBD8-top+117440512
.long SBE0-top+117440512
.long SBE8-top+117440512
.long SBF0-top+117440512
.long SBF8-top
.long SBF9-top
.long SBFA-top
.long SBFB-top
.long SBFC-top
.long r_illegal-top+33554432
.long SC00-top+117440512
.long r_illegal-top+117440512
.long SC10-top+117440512
.long SC18-top+117440512
.long SC20-top+117440512
.long SC28-top+117440512
.long SC30-top+117440512
.long SC38-top
.long SC39-top
.long SC3A-top
.long SC3B-top
.long SC3C-top
.long r_illegal-top+33554432
.long SC40-top+117440512
.long r_illegal-top+117440512
.long SC50-top+117440512
.long SC58-top+117440512
.long SC60-top+117440512
.long SC68-top+117440512
.long SC70-top+117440512
.long SC78-top
.long SC79-top
.long SC7A-top
.long SC7B-top
.long SC7C-top
.long r_illegal-top+33554432
.long SC80-top+117440512
.long r_illegal-top+117440512
.long SC90-top+117440512
.long SC98-top+117440512
.long SCA0-top+117440512
.long SCA8-top+117440512
.long SCB0-top+117440512
.long SCB8-top
.long SCB9-top
.long SCBA-top
.long SCBB-top
.long SCBC-top
.long r_illegal-top+33554432
.long SCC0-top+117440512
.long r_illegal-top+117440512
.long SCD0-top+117440512
.long SCD8-top+117440512
.long SCE0-top+117440512
.long SCE8-top+117440512
.long SCF0-top+117440512
.long SCF8-top
.long SCF9-top
.long SCFA-top
.long SCFB-top
.long SCFC-top
.long r_illegal-top+33554432
.long SD00-top+117440512
.long SD08-top+117440512
.long SD10-top+117440512
.long SD18-top+117440512
.long SD20-top+117440512
.long SD28-top+117440512
.long SD30-top+117440512
.long SD38-top
.long SD39-top
.long r_illegal-top+352321536
.long SD50-top+117440512
.long SD58-top+117440512
.long SD60-top+117440512
.long SD68-top+117440512
.long SD70-top+117440512
.long SD78-top
.long SD79-top
.long r_illegal-top+352321536
.long SD90-top+117440512
.long SD98-top+117440512
.long SDA0-top+117440512
.long SDA8-top+117440512
.long SDB0-top+117440512
.long SDB8-top
.long SDB9-top
.long r_illegal-top+83886080
.long SDC0-top+117440512
.long r_illegal-top+117440512
.long SDD0-top+117440512
.long SDD8-top+117440512
.long SDE0-top+117440512
.long SDE8-top+117440512
.long SDF0-top+117440512
.long SDF8-top
.long SDF9-top
.long SDFA-top
.long SDFB-top
.long SDFC-top
.long r_illegal-top+33554432
.long SE00-top+117440512
.long r_illegal-top+117440512
.long SE10-top+117440512
.long SE18-top+117440512
.long SE20-top+117440512
.long SE28-top+117440512
.long SE30-top+117440512
.long SE38-top
.long SE39-top
.long SE3A-top
.long SE3B-top
.long SE3C-top
.long r_illegal-top+33554432
.long SE40-top+117440512
.long r_illegal-top+117440512
.long SE50-top+117440512
.long SE58-top+117440512
.long SE60-top+117440512
.long SE68-top+117440512
.long SE70-top+117440512
.long SE78-top
.long SE79-top
.long SE7A-top
.long SE7B-top
.long SE7C-top
.long r_illegal-top+33554432
.long SE80-top+117440512
.long r_illegal-top+117440512
.long SE90-top+117440512
.long SE98-top+117440512
.long SEA0-top+117440512
.long SEA8-top+117440512
.long SEB0-top+117440512
.long SEB8-top
.long SEB9-top
.long SEBA-top
.long SEBB-top
.long SEBC-top
.long r_illegal-top+33554432
.long SEC0-top+117440512
.long r_illegal-top+117440512
.long SED0-top+117440512
.long SED8-top+117440512
.long SEE0-top+117440512
.long SEE8-top+117440512
.long SEF0-top+117440512
.long SEF8-top
.long SEF9-top
.long SEFA-top
.long SEFB-top
.long SEFC-top
.long r_illegal-top+33554432
.long SF00-top+117440512
.long SF08-top+117440512
.long SF10-top+117440512
.long SF18-top+117440512
.long SF20-top+117440512
.long SF28-top+117440512
.long SF30-top+117440512
.long SF38-top
.long SF39-top
.long r_illegal-top+352321536
.long SF50-top+117440512
.long SF58-top+117440512
.long SF60-top+117440512
.long SF68-top+117440512
.long SF70-top+117440512
.long SF78-top
.long SF79-top
.long r_illegal-top+352321536
.long SF90-top+117440512
.long SF98-top+117440512
.long SFA0-top+117440512
.long SFA8-top+117440512
.long SFB0-top+117440512
.long SFB8-top
.long SFB9-top
.long r_illegal-top+83886080
.long SFC0-top+117440512
.long r_illegal-top+117440512
.long SFD0-top+117440512
.long SFD8-top+117440512
.long SFE0-top+117440512
.long SFE8-top+117440512
.long SFF0-top+117440512
.long SFF8-top
.long SFF9-top
.long SFFA-top
.long SFFB-top
.long SFFC-top
.long r_illegal-top+33554432
.long T000-top+117440512
.long T008-top+117440512
.long T010-top+117440512
.long T018-top+117440512
.long T020-top+117440512
.long T028-top+117440512
.long T030-top+117440512
.long T038-top
.long T039-top
.long T03A-top
.long T03B-top
.long T03C-top
.long r_illegal-top+33554432
.long T040-top+117440512
.long T048-top+117440512
.long T050-top+117440512
.long T058-top+117440512
.long T060-top+117440512
.long T068-top+117440512
.long T070-top+117440512
.long T078-top
.long T079-top
.long T07A-top
.long T07B-top
.long T07C-top
.long r_illegal-top+33554432
.long T080-top+117440512
.long T088-top+117440512
.long T090-top+117440512
.long T098-top+117440512
.long T0A0-top+117440512
.long T0A8-top+117440512
.long T0B0-top+117440512
.long T0B8-top
.long T0B9-top
.long T0BA-top
.long T0BB-top
.long T0BC-top
.long r_illegal-top+33554432
.long T0C0-top+117440512
.long T0C8-top+117440512
.long T0D0-top+117440512
.long T0D8-top+117440512
.long T0E0-top+117440512
.long T0E8-top+117440512
.long T0F0-top+117440512
.long T0F8-top
.long T0F9-top
.long T0FA-top
.long T0FB-top
.long T0FC-top
.long r_illegal-top+33554432
.long T100-top+117440512
.long T108-top+117440512
.long T110-top+117440512
.long T118-top+117440512
.long T120-top+117440512
.long T128-top+117440512
.long T130-top+117440512
.long T138-top
.long T139-top
.long r_illegal-top+83886080
.long T140-top+117440512
.long T148-top+117440512
.long T150-top+117440512
.long T158-top+117440512
.long T160-top+117440512
.long T168-top+117440512
.long T170-top+117440512
.long T178-top
.long T179-top
.long r_illegal-top+83886080
.long T180-top+117440512
.long T188-top+117440512
.long T190-top+117440512
.long T198-top+117440512
.long T1A0-top+117440512
.long T1A8-top+117440512
.long T1B0-top+117440512
.long T1B8-top
.long T1B9-top
.long r_illegal-top+83886080
.long T1C0-top+117440512
.long T1C8-top+117440512
.long T1D0-top+117440512
.long T1D8-top+117440512
.long T1E0-top+117440512
.long T1E8-top+117440512
.long T1F0-top+117440512
.long T1F8-top
.long T1F9-top
.long T1FA-top
.long T1FB-top
.long T1FC-top
.long r_illegal-top+33554432
.long T200-top+117440512
.long T208-top+117440512
.long T210-top+117440512
.long T218-top+117440512
.long T220-top+117440512
.long T228-top+117440512
.long T230-top+117440512
.long T238-top
.long T239-top
.long T23A-top
.long T23B-top
.long T23C-top
.long r_illegal-top+33554432
.long T240-top+117440512
.long T248-top+117440512
.long T250-top+117440512
.long T258-top+117440512
.long T260-top+117440512
.long T268-top+117440512
.long T270-top+117440512
.long T278-top
.long T279-top
.long T27A-top
.long T27B-top
.long T27C-top
.long r_illegal-top+33554432
.long T280-top+117440512
.long T288-top+117440512
.long T290-top+117440512
.long T298-top+117440512
.long T2A0-top+117440512
.long T2A8-top+117440512
.long T2B0-top+117440512
.long T2B8-top
.long T2B9-top
.long T2BA-top
.long T2BB-top
.long T2BC-top
.long r_illegal-top+33554432
.long T2C0-top+117440512
.long T2C8-top+117440512
.long T2D0-top+117440512
.long T2D8-top+117440512
.long T2E0-top+117440512
.long T2E8-top+117440512
.long T2F0-top+117440512
.long T2F8-top
.long T2F9-top
.long T2FA-top
.long T2FB-top
.long T2FC-top
.long r_illegal-top+33554432
.long T300-top+117440512
.long T308-top+117440512
.long T310-top+117440512
.long T318-top+117440512
.long T320-top+117440512
.long T328-top+117440512
.long T330-top+117440512
.long T338-top
.long T339-top
.long r_illegal-top+83886080
.long T340-top+117440512
.long T348-top+117440512
.long T350-top+117440512
.long T358-top+117440512
.long T360-top+117440512
.long T368-top+117440512
.long T370-top+117440512
.long T378-top
.long T379-top
.long r_illegal-top+83886080
.long T380-top+117440512
.long T388-top+117440512
.long T390-top+117440512
.long T398-top+117440512
.long T3A0-top+117440512
.long T3A8-top+117440512
.long T3B0-top+117440512
.long T3B8-top
.long T3B9-top
.long r_illegal-top+83886080
.long T3C0-top+117440512
.long T3C8-top+117440512
.long T3D0-top+117440512
.long T3D8-top+117440512
.long T3E0-top+117440512
.long T3E8-top+117440512
.long T3F0-top+117440512
.long T3F8-top
.long T3F9-top
.long T3FA-top
.long T3FB-top
.long T3FC-top
.long r_illegal-top+33554432
.long T400-top+117440512
.long T408-top+117440512
.long T410-top+117440512
.long T418-top+117440512
.long T420-top+117440512
.long T428-top+117440512
.long T430-top+117440512
.long T438-top
.long T439-top
.long T43A-top
.long T43B-top
.long T43C-top
.long r_illegal-top+33554432
.long T440-top+117440512
.long T448-top+117440512
.long T450-top+117440512
.long T458-top+117440512
.long T460-top+117440512
.long T468-top+117440512
.long T470-top+117440512
.long T478-top
.long T479-top
.long T47A-top
.long T47B-top
.long T47C-top
.long r_illegal-top+33554432
.long T480-top+117440512
.long T488-top+117440512
.long T490-top+117440512
.long T498-top+117440512
.long T4A0-top+117440512
.long T4A8-top+117440512
.long T4B0-top+117440512
.long T4B8-top
.long T4B9-top
.long T4BA-top
.long T4BB-top
.long T4BC-top
.long r_illegal-top+33554432
.long T4C0-top+117440512
.long T4C8-top+117440512
.long T4D0-top+117440512
.long T4D8-top+117440512
.long T4E0-top+117440512
.long T4E8-top+117440512
.long T4F0-top+117440512
.long T4F8-top
.long T4F9-top
.long T4FA-top
.long T4FB-top
.long T4FC-top
.long r_illegal-top+33554432
.long T500-top+117440512
.long T508-top+117440512
.long T510-top+117440512
.long T518-top+117440512
.long T520-top+117440512
.long T528-top+117440512
.long T530-top+117440512
.long T538-top
.long T539-top
.long r_illegal-top+83886080
.long T540-top+117440512
.long T548-top+117440512
.long T550-top+117440512
.long T558-top+117440512
.long T560-top+117440512
.long T568-top+117440512
.long T570-top+117440512
.long T578-top
.long T579-top
.long r_illegal-top+83886080
.long T580-top+117440512
.long T588-top+117440512
.long T590-top+117440512
.long T598-top+117440512
.long T5A0-top+117440512
.long T5A8-top+117440512
.long T5B0-top+117440512
.long T5B8-top
.long T5B9-top
.long r_illegal-top+83886080
.long T5C0-top+117440512
.long T5C8-top+117440512
.long T5D0-top+117440512
.long T5D8-top+117440512
.long T5E0-top+117440512
.long T5E8-top+117440512
.long T5F0-top+117440512
.long T5F8-top
.long T5F9-top
.long T5FA-top
.long T5FB-top
.long T5FC-top
.long r_illegal-top+33554432
.long T600-top+117440512
.long T608-top+117440512
.long T610-top+117440512
.long T618-top+117440512
.long T620-top+117440512
.long T628-top+117440512
.long T630-top+117440512
.long T638-top
.long T639-top
.long T63A-top
.long T63B-top
.long T63C-top
.long r_illegal-top+33554432
.long T640-top+117440512
.long T648-top+117440512
.long T650-top+117440512
.long T658-top+117440512
.long T660-top+117440512
.long T668-top+117440512
.long T670-top+117440512
.long T678-top
.long T679-top
.long T67A-top
.long T67B-top
.long T67C-top
.long r_illegal-top+33554432
.long T680-top+117440512
.long T688-top+117440512
.long T690-top+117440512
.long T698-top+117440512
.long T6A0-top+117440512
.long T6A8-top+117440512
.long T6B0-top+117440512
.long T6B8-top
.long T6B9-top
.long T6BA-top
.long T6BB-top
.long T6BC-top
.long r_illegal-top+33554432
.long T6C0-top+117440512
.long T6C8-top+117440512
.long T6D0-top+117440512
.long T6D8-top+117440512
.long T6E0-top+117440512
.long T6E8-top+117440512
.long T6F0-top+117440512
.long T6F8-top
.long T6F9-top
.long T6FA-top
.long T6FB-top
.long T6FC-top
.long r_illegal-top+33554432
.long T700-top+117440512
.long T708-top+117440512
.long T710-top+117440512
.long T718-top+117440512
.long T720-top+117440512
.long T728-top+117440512
.long T730-top+117440512
.long T738-top
.long T739-top
.long r_illegal-top+83886080
.long T740-top+117440512
.long T748-top+117440512
.long T750-top+117440512
.long T758-top+117440512
.long T760-top+117440512
.long T768-top+117440512
.long T770-top+117440512
.long T778-top
.long T779-top
.long r_illegal-top+83886080
.long T780-top+117440512
.long T788-top+117440512
.long T790-top+117440512
.long T798-top+117440512
.long T7A0-top+117440512
.long T7A8-top+117440512
.long T7B0-top+117440512
.long T7B8-top
.long T7B9-top
.long r_illegal-top+83886080
.long T7C0-top+117440512
.long T7C8-top+117440512
.long T7D0-top+117440512
.long T7D8-top+117440512
.long T7E0-top+117440512
.long T7E8-top+117440512
.long T7F0-top+117440512
.long T7F8-top
.long T7F9-top
.long T7FA-top
.long T7FB-top
.long T7FC-top
.long r_illegal-top+33554432
.long T800-top+117440512
.long T808-top+117440512
.long T810-top+117440512
.long T818-top+117440512
.long T820-top+117440512
.long T828-top+117440512
.long T830-top+117440512
.long T838-top
.long T839-top
.long T83A-top
.long T83B-top
.long T83C-top
.long r_illegal-top+33554432
.long T840-top+117440512
.long T848-top+117440512
.long T850-top+117440512
.long T858-top+117440512
.long T860-top+117440512
.long T868-top+117440512
.long T870-top+117440512
.long T878-top
.long T879-top
.long T87A-top
.long T87B-top
.long T87C-top
.long r_illegal-top+33554432
.long T880-top+117440512
.long T888-top+117440512
.long T890-top+117440512
.long T898-top+117440512
.long T8A0-top+117440512
.long T8A8-top+117440512
.long T8B0-top+117440512
.long T8B8-top
.long T8B9-top
.long T8BA-top
.long T8BB-top
.long T8BC-top
.long r_illegal-top+33554432
.long T8C0-top+117440512
.long T8C8-top+117440512
.long T8D0-top+117440512
.long T8D8-top+117440512
.long T8E0-top+117440512
.long T8E8-top+117440512
.long T8F0-top+117440512
.long T8F8-top
.long T8F9-top
.long T8FA-top
.long T8FB-top
.long T8FC-top
.long r_illegal-top+33554432
.long T900-top+117440512
.long T908-top+117440512
.long T910-top+117440512
.long T918-top+117440512
.long T920-top+117440512
.long T928-top+117440512
.long T930-top+117440512
.long T938-top
.long T939-top
.long r_illegal-top+83886080
.long T940-top+117440512
.long T948-top+117440512
.long T950-top+117440512
.long T958-top+117440512
.long T960-top+117440512
.long T968-top+117440512
.long T970-top+117440512
.long T978-top
.long T979-top
.long r_illegal-top+83886080
.long T980-top+117440512
.long T988-top+117440512
.long T990-top+117440512
.long T998-top+117440512
.long T9A0-top+117440512
.long T9A8-top+117440512
.long T9B0-top+117440512
.long T9B8-top
.long T9B9-top
.long r_illegal-top+83886080
.long T9C0-top+117440512
.long T9C8-top+117440512
.long T9D0-top+117440512
.long T9D8-top+117440512
.long T9E0-top+117440512
.long T9E8-top+117440512
.long T9F0-top+117440512
.long T9F8-top
.long T9F9-top
.long T9FA-top
.long T9FB-top
.long T9FC-top
.long r_illegal-top+33554432
.long TA00-top+117440512
.long TA08-top+117440512
.long TA10-top+117440512
.long TA18-top+117440512
.long TA20-top+117440512
.long TA28-top+117440512
.long TA30-top+117440512
.long TA38-top
.long TA39-top
.long TA3A-top
.long TA3B-top
.long TA3C-top
.long r_illegal-top+33554432
.long TA40-top+117440512
.long TA48-top+117440512
.long TA50-top+117440512
.long TA58-top+117440512
.long TA60-top+117440512
.long TA68-top+117440512
.long TA70-top+117440512
.long TA78-top
.long TA79-top
.long TA7A-top
.long TA7B-top
.long TA7C-top
.long r_illegal-top+33554432
.long TA80-top+117440512
.long TA88-top+117440512
.long TA90-top+117440512
.long TA98-top+117440512
.long TAA0-top+117440512
.long TAA8-top+117440512
.long TAB0-top+117440512
.long TAB8-top
.long TAB9-top
.long TABA-top
.long TABB-top
.long TABC-top
.long r_illegal-top+33554432
.long TAC0-top+117440512
.long TAC8-top+117440512
.long TAD0-top+117440512
.long TAD8-top+117440512
.long TAE0-top+117440512
.long TAE8-top+117440512
.long TAF0-top+117440512
.long TAF8-top
.long TAF9-top
.long TAFA-top
.long TAFB-top
.long TAFC-top
.long r_illegal-top+33554432
.long TB00-top+117440512
.long TB08-top+117440512
.long TB10-top+117440512
.long TB18-top+117440512
.long TB20-top+117440512
.long TB28-top+117440512
.long TB30-top+117440512
.long TB38-top
.long TB39-top
.long r_illegal-top+83886080
.long TB40-top+117440512
.long TB48-top+117440512
.long TB50-top+117440512
.long TB58-top+117440512
.long TB60-top+117440512
.long TB68-top+117440512
.long TB70-top+117440512
.long TB78-top
.long TB79-top
.long r_illegal-top+83886080
.long TB80-top+117440512
.long TB88-top+117440512
.long TB90-top+117440512
.long TB98-top+117440512
.long TBA0-top+117440512
.long TBA8-top+117440512
.long TBB0-top+117440512
.long TBB8-top
.long TBB9-top
.long r_illegal-top+83886080
.long TBC0-top+117440512
.long TBC8-top+117440512
.long TBD0-top+117440512
.long TBD8-top+117440512
.long TBE0-top+117440512
.long TBE8-top+117440512
.long TBF0-top+117440512
.long TBF8-top
.long TBF9-top
.long TBFA-top
.long TBFB-top
.long TBFC-top
.long r_illegal-top+33554432
.long TC00-top+117440512
.long TC08-top+117440512
.long TC10-top+117440512
.long TC18-top+117440512
.long TC20-top+117440512
.long TC28-top+117440512
.long TC30-top+117440512
.long TC38-top
.long TC39-top
.long TC3A-top
.long TC3B-top
.long TC3C-top
.long r_illegal-top+33554432
.long TC40-top+117440512
.long TC48-top+117440512
.long TC50-top+117440512
.long TC58-top+117440512
.long TC60-top+117440512
.long TC68-top+117440512
.long TC70-top+117440512
.long TC78-top
.long TC79-top
.long TC7A-top
.long TC7B-top
.long TC7C-top
.long r_illegal-top+33554432
.long TC80-top+117440512
.long TC88-top+117440512
.long TC90-top+117440512
.long TC98-top+117440512
.long TCA0-top+117440512
.long TCA8-top+117440512
.long TCB0-top+117440512
.long TCB8-top
.long TCB9-top
.long TCBA-top
.long TCBB-top
.long TCBC-top
.long r_illegal-top+33554432
.long TCC0-top+117440512
.long TCC8-top+117440512
.long TCD0-top+117440512
.long TCD8-top+117440512
.long TCE0-top+117440512
.long TCE8-top+117440512
.long TCF0-top+117440512
.long TCF8-top
.long TCF9-top
.long TCFA-top
.long TCFB-top
.long TCFC-top
.long r_illegal-top+33554432
.long TD00-top+117440512
.long TD08-top+117440512
.long TD10-top+117440512
.long TD18-top+117440512
.long TD20-top+117440512
.long TD28-top+117440512
.long TD30-top+117440512
.long TD38-top
.long TD39-top
.long r_illegal-top+83886080
.long TD40-top+117440512
.long TD48-top+117440512
.long TD50-top+117440512
.long TD58-top+117440512
.long TD60-top+117440512
.long TD68-top+117440512
.long TD70-top+117440512
.long TD78-top
.long TD79-top
.long r_illegal-top+83886080
.long TD80-top+117440512
.long TD88-top+117440512
.long TD90-top+117440512
.long TD98-top+117440512
.long TDA0-top+117440512
.long TDA8-top+117440512
.long TDB0-top+117440512
.long TDB8-top
.long TDB9-top
.long r_illegal-top+83886080
.long TDC0-top+117440512
.long TDC8-top+117440512
.long TDD0-top+117440512
.long TDD8-top+117440512
.long TDE0-top+117440512
.long TDE8-top+117440512
.long TDF0-top+117440512
.long TDF8-top
.long TDF9-top
.long TDFA-top
.long TDFB-top
.long TDFC-top
.long r_illegal-top+33554432
.long TE00-top+117440512
.long TE08-top+117440512
.long TE10-top+117440512
.long TE18-top+117440512
.long TE20-top+117440512
.long TE28-top+117440512
.long TE30-top+117440512
.long TE38-top
.long TE39-top
.long TE3A-top
.long TE3B-top
.long TE3C-top
.long r_illegal-top+33554432
.long TE40-top+117440512
.long TE48-top+117440512
.long TE50-top+117440512
.long TE58-top+117440512
.long TE60-top+117440512
.long TE68-top+117440512
.long TE70-top+117440512
.long TE78-top
.long TE79-top
.long TE7A-top
.long TE7B-top
.long TE7C-top
.long r_illegal-top+33554432
.long TE80-top+117440512
.long TE88-top+117440512
.long TE90-top+117440512
.long TE98-top+117440512
.long TEA0-top+117440512
.long TEA8-top+117440512
.long TEB0-top+117440512
.long TEB8-top
.long TEB9-top
.long TEBA-top
.long TEBB-top
.long TEBC-top
.long r_illegal-top+33554432
.long TEC0-top+117440512
.long TEC8-top+117440512
.long TED0-top+117440512
.long TED8-top+117440512
.long TEE0-top+117440512
.long TEE8-top+117440512
.long TEF0-top+117440512
.long TEF8-top
.long TEF9-top
.long TEFA-top
.long TEFB-top
.long TEFC-top
.long r_illegal-top+33554432
.long TF00-top+117440512
.long TF08-top+117440512
.long TF10-top+117440512
.long TF18-top+117440512
.long TF20-top+117440512
.long TF28-top+117440512
.long TF30-top+117440512
.long TF38-top
.long TF39-top
.long r_illegal-top+83886080
.long TF40-top+117440512
.long TF48-top+117440512
.long TF50-top+117440512
.long TF58-top+117440512
.long TF60-top+117440512
.long TF68-top+117440512
.long TF70-top+117440512
.long TF78-top
.long TF79-top
.long r_illegal-top+83886080
.long TF80-top+117440512
.long TF88-top+117440512
.long TF90-top+117440512
.long TF98-top+117440512
.long TFA0-top+117440512
.long TFA8-top+117440512
.long TFB0-top+117440512
.long TFB8-top
.long TFB9-top
.long r_illegal-top+83886080
.long TFC0-top+117440512
.long TFC8-top+117440512
.long TFD0-top+117440512
.long TFD8-top+117440512
.long TFE0-top+117440512
.long TFE8-top+117440512
.long TFF0-top+117440512
.long TFF8-top
.long TFF9-top
.long TFFA-top
.long TFFB-top
.long TFFC-top
.long r_illegal-top+33554432
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long U000-top+4278190080
.long V000-top+117440512
.long V008-top+117440512
.long V010-top+117440512
.long V018-top+117440512
.long V020-top+117440512
.long V028-top+117440512
.long V030-top+117440512
.long V038-top
.long V039-top
.long V03A-top
.long V03B-top
.long V03C-top
.long r_illegal-top+33554432
.long V040-top+117440512
.long V048-top+117440512
.long V050-top+117440512
.long V058-top+117440512
.long V060-top+117440512
.long V068-top+117440512
.long V070-top+117440512
.long V078-top
.long V079-top
.long V07A-top
.long V07B-top
.long V07C-top
.long r_illegal-top+33554432
.long V080-top+117440512
.long V088-top+117440512
.long V090-top+117440512
.long V098-top+117440512
.long V0A0-top+117440512
.long V0A8-top+117440512
.long V0B0-top+117440512
.long V0B8-top
.long V0B9-top
.long V0BA-top
.long V0BB-top
.long V0BC-top
.long r_illegal-top+33554432
.long V0C0-top+117440512
.long V0C8-top+117440512
.long V0D0-top+117440512
.long V0D8-top+117440512
.long V0E0-top+117440512
.long V0E8-top+117440512
.long V0F0-top+117440512
.long V0F8-top
.long V0F9-top
.long V0FA-top
.long V0FB-top
.long V0FC-top
.long r_illegal-top+33554432
.long V100-top+117440512
.long V108-top+117440512
.long V110-top+117440512
.long V118-top+117440512
.long V120-top+117440512
.long V128-top+117440512
.long V130-top+117440512
.long V138-top
.long V139-top
.long r_illegal-top+83886080
.long V140-top+117440512
.long V148-top+117440512
.long V150-top+117440512
.long V158-top+117440512
.long V160-top+117440512
.long V168-top+117440512
.long V170-top+117440512
.long V178-top
.long V179-top
.long r_illegal-top+83886080
.long V180-top+117440512
.long V188-top+117440512
.long V190-top+117440512
.long V198-top+117440512
.long V1A0-top+117440512
.long V1A8-top+117440512
.long V1B0-top+117440512
.long V1B8-top
.long V1B9-top
.long r_illegal-top+83886080
.long V1C0-top+117440512
.long V1C8-top+117440512
.long V1D0-top+117440512
.long V1D8-top+117440512
.long V1E0-top+117440512
.long V1E8-top+117440512
.long V1F0-top+117440512
.long V1F8-top
.long V1F9-top
.long V1FA-top
.long V1FB-top
.long V1FC-top
.long r_illegal-top+33554432
.long V200-top+117440512
.long V208-top+117440512
.long V210-top+117440512
.long V218-top+117440512
.long V220-top+117440512
.long V228-top+117440512
.long V230-top+117440512
.long V238-top
.long V239-top
.long V23A-top
.long V23B-top
.long V23C-top
.long r_illegal-top+33554432
.long V240-top+117440512
.long V248-top+117440512
.long V250-top+117440512
.long V258-top+117440512
.long V260-top+117440512
.long V268-top+117440512
.long V270-top+117440512
.long V278-top
.long V279-top
.long V27A-top
.long V27B-top
.long V27C-top
.long r_illegal-top+33554432
.long V280-top+117440512
.long V288-top+117440512
.long V290-top+117440512
.long V298-top+117440512
.long V2A0-top+117440512
.long V2A8-top+117440512
.long V2B0-top+117440512
.long V2B8-top
.long V2B9-top
.long V2BA-top
.long V2BB-top
.long V2BC-top
.long r_illegal-top+33554432
.long V2C0-top+117440512
.long V2C8-top+117440512
.long V2D0-top+117440512
.long V2D8-top+117440512
.long V2E0-top+117440512
.long V2E8-top+117440512
.long V2F0-top+117440512
.long V2F8-top
.long V2F9-top
.long V2FA-top
.long V2FB-top
.long V2FC-top
.long r_illegal-top+33554432
.long V300-top+117440512
.long V308-top+117440512
.long V310-top+117440512
.long V318-top+117440512
.long V320-top+117440512
.long V328-top+117440512
.long V330-top+117440512
.long V338-top
.long V339-top
.long r_illegal-top+83886080
.long V340-top+117440512
.long V348-top+117440512
.long V350-top+117440512
.long V358-top+117440512
.long V360-top+117440512
.long V368-top+117440512
.long V370-top+117440512
.long V378-top
.long V379-top
.long r_illegal-top+83886080
.long V380-top+117440512
.long V388-top+117440512
.long V390-top+117440512
.long V398-top+117440512
.long V3A0-top+117440512
.long V3A8-top+117440512
.long V3B0-top+117440512
.long V3B8-top
.long V3B9-top
.long r_illegal-top+83886080
.long V3C0-top+117440512
.long V3C8-top+117440512
.long V3D0-top+117440512
.long V3D8-top+117440512
.long V3E0-top+117440512
.long V3E8-top+117440512
.long V3F0-top+117440512
.long V3F8-top
.long V3F9-top
.long V3FA-top
.long V3FB-top
.long V3FC-top
.long r_illegal-top+33554432
.long V400-top+117440512
.long V408-top+117440512
.long V410-top+117440512
.long V418-top+117440512
.long V420-top+117440512
.long V428-top+117440512
.long V430-top+117440512
.long V438-top
.long V439-top
.long V43A-top
.long V43B-top
.long V43C-top
.long r_illegal-top+33554432
.long V440-top+117440512
.long V448-top+117440512
.long V450-top+117440512
.long V458-top+117440512
.long V460-top+117440512
.long V468-top+117440512
.long V470-top+117440512
.long V478-top
.long V479-top
.long V47A-top
.long V47B-top
.long V47C-top
.long r_illegal-top+33554432
.long V480-top+117440512
.long V488-top+117440512
.long V490-top+117440512
.long V498-top+117440512
.long V4A0-top+117440512
.long V4A8-top+117440512
.long V4B0-top+117440512
.long V4B8-top
.long V4B9-top
.long V4BA-top
.long V4BB-top
.long V4BC-top
.long r_illegal-top+33554432
.long V4C0-top+117440512
.long V4C8-top+117440512
.long V4D0-top+117440512
.long V4D8-top+117440512
.long V4E0-top+117440512
.long V4E8-top+117440512
.long V4F0-top+117440512
.long V4F8-top
.long V4F9-top
.long V4FA-top
.long V4FB-top
.long V4FC-top
.long r_illegal-top+33554432
.long V500-top+117440512
.long V508-top+117440512
.long V510-top+117440512
.long V518-top+117440512
.long V520-top+117440512
.long V528-top+117440512
.long V530-top+117440512
.long V538-top
.long V539-top
.long r_illegal-top+83886080
.long V540-top+117440512
.long V548-top+117440512
.long V550-top+117440512
.long V558-top+117440512
.long V560-top+117440512
.long V568-top+117440512
.long V570-top+117440512
.long V578-top
.long V579-top
.long r_illegal-top+83886080
.long V580-top+117440512
.long V588-top+117440512
.long V590-top+117440512
.long V598-top+117440512
.long V5A0-top+117440512
.long V5A8-top+117440512
.long V5B0-top+117440512
.long V5B8-top
.long V5B9-top
.long r_illegal-top+83886080
.long V5C0-top+117440512
.long V5C8-top+117440512
.long V5D0-top+117440512
.long V5D8-top+117440512
.long V5E0-top+117440512
.long V5E8-top+117440512
.long V5F0-top+117440512
.long V5F8-top
.long V5F9-top
.long V5FA-top
.long V5FB-top
.long V5FC-top
.long r_illegal-top+33554432
.long V600-top+117440512
.long V608-top+117440512
.long V610-top+117440512
.long V618-top+117440512
.long V620-top+117440512
.long V628-top+117440512
.long V630-top+117440512
.long V638-top
.long V639-top
.long V63A-top
.long V63B-top
.long V63C-top
.long r_illegal-top+33554432
.long V640-top+117440512
.long V648-top+117440512
.long V650-top+117440512
.long V658-top+117440512
.long V660-top+117440512
.long V668-top+117440512
.long V670-top+117440512
.long V678-top
.long V679-top
.long V67A-top
.long V67B-top
.long V67C-top
.long r_illegal-top+33554432
.long V680-top+117440512
.long V688-top+117440512
.long V690-top+117440512
.long V698-top+117440512
.long V6A0-top+117440512
.long V6A8-top+117440512
.long V6B0-top+117440512
.long V6B8-top
.long V6B9-top
.long V6BA-top
.long V6BB-top
.long V6BC-top
.long r_illegal-top+33554432
.long V6C0-top+117440512
.long V6C8-top+117440512
.long V6D0-top+117440512
.long V6D8-top+117440512
.long V6E0-top+117440512
.long V6E8-top+117440512
.long V6F0-top+117440512
.long V6F8-top
.long V6F9-top
.long V6FA-top
.long V6FB-top
.long V6FC-top
.long r_illegal-top+33554432
.long V700-top+117440512
.long V708-top+117440512
.long V710-top+117440512
.long V718-top+117440512
.long V720-top+117440512
.long V728-top+117440512
.long V730-top+117440512
.long V738-top
.long V739-top
.long r_illegal-top+83886080
.long V740-top+117440512
.long V748-top+117440512
.long V750-top+117440512
.long V758-top+117440512
.long V760-top+117440512
.long V768-top+117440512
.long V770-top+117440512
.long V778-top
.long V779-top
.long r_illegal-top+83886080
.long V780-top+117440512
.long V788-top+117440512
.long V790-top+117440512
.long V798-top+117440512
.long V7A0-top+117440512
.long V7A8-top+117440512
.long V7B0-top+117440512
.long V7B8-top
.long V7B9-top
.long r_illegal-top+83886080
.long V7C0-top+117440512
.long V7C8-top+117440512
.long V7D0-top+117440512
.long V7D8-top+117440512
.long V7E0-top+117440512
.long V7E8-top+117440512
.long V7F0-top+117440512
.long V7F8-top
.long V7F9-top
.long V7FA-top
.long V7FB-top
.long V7FC-top
.long r_illegal-top+33554432
.long V800-top+117440512
.long V808-top+117440512
.long V810-top+117440512
.long V818-top+117440512
.long V820-top+117440512
.long V828-top+117440512
.long V830-top+117440512
.long V838-top
.long V839-top
.long V83A-top
.long V83B-top
.long V83C-top
.long r_illegal-top+33554432
.long V840-top+117440512
.long V848-top+117440512
.long V850-top+117440512
.long V858-top+117440512
.long V860-top+117440512
.long V868-top+117440512
.long V870-top+117440512
.long V878-top
.long V879-top
.long V87A-top
.long V87B-top
.long V87C-top
.long r_illegal-top+33554432
.long V880-top+117440512
.long V888-top+117440512
.long V890-top+117440512
.long V898-top+117440512
.long V8A0-top+117440512
.long V8A8-top+117440512
.long V8B0-top+117440512
.long V8B8-top
.long V8B9-top
.long V8BA-top
.long V8BB-top
.long V8BC-top
.long r_illegal-top+33554432
.long V8C0-top+117440512
.long V8C8-top+117440512
.long V8D0-top+117440512
.long V8D8-top+117440512
.long V8E0-top+117440512
.long V8E8-top+117440512
.long V8F0-top+117440512
.long V8F8-top
.long V8F9-top
.long V8FA-top
.long V8FB-top
.long V8FC-top
.long r_illegal-top+33554432
.long V900-top+117440512
.long V908-top+117440512
.long V910-top+117440512
.long V918-top+117440512
.long V920-top+117440512
.long V928-top+117440512
.long V930-top+117440512
.long V938-top
.long V939-top
.long r_illegal-top+83886080
.long V940-top+117440512
.long V948-top+117440512
.long V950-top+117440512
.long V958-top+117440512
.long V960-top+117440512
.long V968-top+117440512
.long V970-top+117440512
.long V978-top
.long V979-top
.long r_illegal-top+83886080
.long V980-top+117440512
.long V988-top+117440512
.long V990-top+117440512
.long V998-top+117440512
.long V9A0-top+117440512
.long V9A8-top+117440512
.long V9B0-top+117440512
.long V9B8-top
.long V9B9-top
.long r_illegal-top+83886080
.long V9C0-top+117440512
.long V9C8-top+117440512
.long V9D0-top+117440512
.long V9D8-top+117440512
.long V9E0-top+117440512
.long V9E8-top+117440512
.long V9F0-top+117440512
.long V9F8-top
.long V9F9-top
.long V9FA-top
.long V9FB-top
.long V9FC-top
.long r_illegal-top+33554432
.long VA00-top+117440512
.long VA08-top+117440512
.long VA10-top+117440512
.long VA18-top+117440512
.long VA20-top+117440512
.long VA28-top+117440512
.long VA30-top+117440512
.long VA38-top
.long VA39-top
.long VA3A-top
.long VA3B-top
.long VA3C-top
.long r_illegal-top+33554432
.long VA40-top+117440512
.long VA48-top+117440512
.long VA50-top+117440512
.long VA58-top+117440512
.long VA60-top+117440512
.long VA68-top+117440512
.long VA70-top+117440512
.long VA78-top
.long VA79-top
.long VA7A-top
.long VA7B-top
.long VA7C-top
.long r_illegal-top+33554432
.long VA80-top+117440512
.long VA88-top+117440512
.long VA90-top+117440512
.long VA98-top+117440512
.long VAA0-top+117440512
.long VAA8-top+117440512
.long VAB0-top+117440512
.long VAB8-top
.long VAB9-top
.long VABA-top
.long VABB-top
.long VABC-top
.long r_illegal-top+33554432
.long VAC0-top+117440512
.long VAC8-top+117440512
.long VAD0-top+117440512
.long VAD8-top+117440512
.long VAE0-top+117440512
.long VAE8-top+117440512
.long VAF0-top+117440512
.long VAF8-top
.long VAF9-top
.long VAFA-top
.long VAFB-top
.long VAFC-top
.long r_illegal-top+33554432
.long VB00-top+117440512
.long VB08-top+117440512
.long VB10-top+117440512
.long VB18-top+117440512
.long VB20-top+117440512
.long VB28-top+117440512
.long VB30-top+117440512
.long VB38-top
.long VB39-top
.long r_illegal-top+83886080
.long VB40-top+117440512
.long VB48-top+117440512
.long VB50-top+117440512
.long VB58-top+117440512
.long VB60-top+117440512
.long VB68-top+117440512
.long VB70-top+117440512
.long VB78-top
.long VB79-top
.long r_illegal-top+83886080
.long VB80-top+117440512
.long VB88-top+117440512
.long VB90-top+117440512
.long VB98-top+117440512
.long VBA0-top+117440512
.long VBA8-top+117440512
.long VBB0-top+117440512
.long VBB8-top
.long VBB9-top
.long r_illegal-top+83886080
.long VBC0-top+117440512
.long VBC8-top+117440512
.long VBD0-top+117440512
.long VBD8-top+117440512
.long VBE0-top+117440512
.long VBE8-top+117440512
.long VBF0-top+117440512
.long VBF8-top
.long VBF9-top
.long VBFA-top
.long VBFB-top
.long VBFC-top
.long r_illegal-top+33554432
.long VC00-top+117440512
.long VC08-top+117440512
.long VC10-top+117440512
.long VC18-top+117440512
.long VC20-top+117440512
.long VC28-top+117440512
.long VC30-top+117440512
.long VC38-top
.long VC39-top
.long VC3A-top
.long VC3B-top
.long VC3C-top
.long r_illegal-top+33554432
.long VC40-top+117440512
.long VC48-top+117440512
.long VC50-top+117440512
.long VC58-top+117440512
.long VC60-top+117440512
.long VC68-top+117440512
.long VC70-top+117440512
.long VC78-top
.long VC79-top
.long VC7A-top
.long VC7B-top
.long VC7C-top
.long r_illegal-top+33554432
.long VC80-top+117440512
.long VC88-top+117440512
.long VC90-top+117440512
.long VC98-top+117440512
.long VCA0-top+117440512
.long VCA8-top+117440512
.long VCB0-top+117440512
.long VCB8-top
.long VCB9-top
.long VCBA-top
.long VCBB-top
.long VCBC-top
.long r_illegal-top+33554432
.long VCC0-top+117440512
.long VCC8-top+117440512
.long VCD0-top+117440512
.long VCD8-top+117440512
.long VCE0-top+117440512
.long VCE8-top+117440512
.long VCF0-top+117440512
.long VCF8-top
.long VCF9-top
.long VCFA-top
.long VCFB-top
.long VCFC-top
.long r_illegal-top+33554432
.long VD00-top+117440512
.long VD08-top+117440512
.long VD10-top+117440512
.long VD18-top+117440512
.long VD20-top+117440512
.long VD28-top+117440512
.long VD30-top+117440512
.long VD38-top
.long VD39-top
.long r_illegal-top+83886080
.long VD40-top+117440512
.long VD48-top+117440512
.long VD50-top+117440512
.long VD58-top+117440512
.long VD60-top+117440512
.long VD68-top+117440512
.long VD70-top+117440512
.long VD78-top
.long VD79-top
.long r_illegal-top+83886080
.long VD80-top+117440512
.long VD88-top+117440512
.long VD90-top+117440512
.long VD98-top+117440512
.long VDA0-top+117440512
.long VDA8-top+117440512
.long VDB0-top+117440512
.long VDB8-top
.long VDB9-top
.long r_illegal-top+83886080
.long VDC0-top+117440512
.long VDC8-top+117440512
.long VDD0-top+117440512
.long VDD8-top+117440512
.long VDE0-top+117440512
.long VDE8-top+117440512
.long VDF0-top+117440512
.long VDF8-top
.long VDF9-top
.long VDFA-top
.long VDFB-top
.long VDFC-top
.long r_illegal-top+33554432
.long VE00-top+117440512
.long VE08-top+117440512
.long VE10-top+117440512
.long VE18-top+117440512
.long VE20-top+117440512
.long VE28-top+117440512
.long VE30-top+117440512
.long VE38-top
.long VE39-top
.long VE3A-top
.long VE3B-top
.long VE3C-top
.long r_illegal-top+33554432
.long VE40-top+117440512
.long VE48-top+117440512
.long VE50-top+117440512
.long VE58-top+117440512
.long VE60-top+117440512
.long VE68-top+117440512
.long VE70-top+117440512
.long VE78-top
.long VE79-top
.long VE7A-top
.long VE7B-top
.long VE7C-top
.long r_illegal-top+33554432
.long VE80-top+117440512
.long VE88-top+117440512
.long VE90-top+117440512
.long VE98-top+117440512
.long VEA0-top+117440512
.long VEA8-top+117440512
.long VEB0-top+117440512
.long VEB8-top
.long VEB9-top
.long VEBA-top
.long VEBB-top
.long VEBC-top
.long r_illegal-top+33554432
.long VEC0-top+117440512
.long VEC8-top+117440512
.long VED0-top+117440512
.long VED8-top+117440512
.long VEE0-top+117440512
.long VEE8-top+117440512
.long VEF0-top+117440512
.long VEF8-top
.long VEF9-top
.long VEFA-top
.long VEFB-top
.long VEFC-top
.long r_illegal-top+33554432
.long VF00-top+117440512
.long VF08-top+117440512
.long VF10-top+117440512
.long VF18-top+117440512
.long VF20-top+117440512
.long VF28-top+117440512
.long VF30-top+117440512
.long VF38-top
.long VF39-top
.long r_illegal-top+83886080
.long VF40-top+117440512
.long VF48-top+117440512
.long VF50-top+117440512
.long VF58-top+117440512
.long VF60-top+117440512
.long VF68-top+117440512
.long VF70-top+117440512
.long VF78-top
.long VF79-top
.long r_illegal-top+83886080
.long VF80-top+117440512
.long VF88-top+117440512
.long VF90-top+117440512
.long VF98-top+117440512
.long VFA0-top+117440512
.long VFA8-top+117440512
.long VFB0-top+117440512
.long VFB8-top
.long VFB9-top
.long r_illegal-top+83886080
.long VFC0-top+117440512
.long VFC8-top+117440512
.long VFD0-top+117440512
.long VFD8-top+117440512
.long VFE0-top+117440512
.long VFE8-top+117440512
.long VFF0-top+117440512
.long VFF8-top
.long VFF9-top
.long VFFA-top
.long VFFB-top
.long VFFC-top
.long r_illegal-top+33554432
.long W000-top+117440512
.long r_illegal-top+117440512
.long W010-top+117440512
.long W018-top+117440512
.long W020-top+117440512
.long W028-top+117440512
.long W030-top+117440512
.long W038-top
.long W039-top
.long W03A-top
.long W03B-top
.long W03C-top
.long r_illegal-top+33554432
.long W040-top+117440512
.long r_illegal-top+117440512
.long W050-top+117440512
.long W058-top+117440512
.long W060-top+117440512
.long W068-top+117440512
.long W070-top+117440512
.long W078-top
.long W079-top
.long W07A-top
.long W07B-top
.long W07C-top
.long r_illegal-top+33554432
.long W080-top+117440512
.long r_illegal-top+117440512
.long W090-top+117440512
.long W098-top+117440512
.long W0A0-top+117440512
.long W0A8-top+117440512
.long W0B0-top+117440512
.long W0B8-top
.long W0B9-top
.long W0BA-top
.long W0BB-top
.long W0BC-top
.long r_illegal-top+33554432
.long W0C0-top+117440512
.long r_illegal-top+117440512
.long W0D0-top+117440512
.long W0D8-top+117440512
.long W0E0-top+117440512
.long W0E8-top+117440512
.long W0F0-top+117440512
.long W0F8-top
.long W0F9-top
.long W0FA-top
.long W0FB-top
.long W0FC-top
.long r_illegal-top+33554432
.long W100-top+117440512
.long W108-top+117440512
.long W110-top+117440512
.long W118-top+117440512
.long W120-top+117440512
.long W128-top+117440512
.long W130-top+117440512
.long W138-top
.long W139-top
.long r_illegal-top+83886080
.long W140-top+117440512
.long W148-top+117440512
.long W150-top+117440512
.long W158-top+117440512
.long W160-top+117440512
.long W168-top+117440512
.long W170-top+117440512
.long W178-top
.long W179-top
.long r_illegal-top+218103808
.long W188-top+117440512
.long W190-top+117440512
.long W198-top+117440512
.long W1A0-top+117440512
.long W1A8-top+117440512
.long W1B0-top+117440512
.long W1B8-top
.long W1B9-top
.long r_illegal-top+83886080
.long W1C0-top+117440512
.long r_illegal-top+117440512
.long W1D0-top+117440512
.long W1D8-top+117440512
.long W1E0-top+117440512
.long W1E8-top+117440512
.long W1F0-top+117440512
.long W1F8-top
.long W1F9-top
.long W1FA-top
.long W1FB-top
.long W1FC-top
.long r_illegal-top+33554432
.long W200-top+117440512
.long r_illegal-top+117440512
.long W210-top+117440512
.long W218-top+117440512
.long W220-top+117440512
.long W228-top+117440512
.long W230-top+117440512
.long W238-top
.long W239-top
.long W23A-top
.long W23B-top
.long W23C-top
.long r_illegal-top+33554432
.long W240-top+117440512
.long r_illegal-top+117440512
.long W250-top+117440512
.long W258-top+117440512
.long W260-top+117440512
.long W268-top+117440512
.long W270-top+117440512
.long W278-top
.long W279-top
.long W27A-top
.long W27B-top
.long W27C-top
.long r_illegal-top+33554432
.long W280-top+117440512
.long r_illegal-top+117440512
.long W290-top+117440512
.long W298-top+117440512
.long W2A0-top+117440512
.long W2A8-top+117440512
.long W2B0-top+117440512
.long W2B8-top
.long W2B9-top
.long W2BA-top
.long W2BB-top
.long W2BC-top
.long r_illegal-top+33554432
.long W2C0-top+117440512
.long r_illegal-top+117440512
.long W2D0-top+117440512
.long W2D8-top+117440512
.long W2E0-top+117440512
.long W2E8-top+117440512
.long W2F0-top+117440512
.long W2F8-top
.long W2F9-top
.long W2FA-top
.long W2FB-top
.long W2FC-top
.long r_illegal-top+33554432
.long W300-top+117440512
.long W308-top+117440512
.long W310-top+117440512
.long W318-top+117440512
.long W320-top+117440512
.long W328-top+117440512
.long W330-top+117440512
.long W338-top
.long W339-top
.long r_illegal-top+83886080
.long W340-top+117440512
.long W348-top+117440512
.long W350-top+117440512
.long W358-top+117440512
.long W360-top+117440512
.long W368-top+117440512
.long W370-top+117440512
.long W378-top
.long W379-top
.long r_illegal-top+218103808
.long W388-top+117440512
.long W390-top+117440512
.long W398-top+117440512
.long W3A0-top+117440512
.long W3A8-top+117440512
.long W3B0-top+117440512
.long W3B8-top
.long W3B9-top
.long r_illegal-top+83886080
.long W3C0-top+117440512
.long r_illegal-top+117440512
.long W3D0-top+117440512
.long W3D8-top+117440512
.long W3E0-top+117440512
.long W3E8-top+117440512
.long W3F0-top+117440512
.long W3F8-top
.long W3F9-top
.long W3FA-top
.long W3FB-top
.long W3FC-top
.long r_illegal-top+33554432
.long W400-top+117440512
.long r_illegal-top+117440512
.long W410-top+117440512
.long W418-top+117440512
.long W420-top+117440512
.long W428-top+117440512
.long W430-top+117440512
.long W438-top
.long W439-top
.long W43A-top
.long W43B-top
.long W43C-top
.long r_illegal-top+33554432
.long W440-top+117440512
.long r_illegal-top+117440512
.long W450-top+117440512
.long W458-top+117440512
.long W460-top+117440512
.long W468-top+117440512
.long W470-top+117440512
.long W478-top
.long W479-top
.long W47A-top
.long W47B-top
.long W47C-top
.long r_illegal-top+33554432
.long W480-top+117440512
.long r_illegal-top+117440512
.long W490-top+117440512
.long W498-top+117440512
.long W4A0-top+117440512
.long W4A8-top+117440512
.long W4B0-top+117440512
.long W4B8-top
.long W4B9-top
.long W4BA-top
.long W4BB-top
.long W4BC-top
.long r_illegal-top+33554432
.long W4C0-top+117440512
.long r_illegal-top+117440512
.long W4D0-top+117440512
.long W4D8-top+117440512
.long W4E0-top+117440512
.long W4E8-top+117440512
.long W4F0-top+117440512
.long W4F8-top
.long W4F9-top
.long W4FA-top
.long W4FB-top
.long W4FC-top
.long r_illegal-top+33554432
.long W500-top+117440512
.long W508-top+117440512
.long W510-top+117440512
.long W518-top+117440512
.long W520-top+117440512
.long W528-top+117440512
.long W530-top+117440512
.long W538-top
.long W539-top
.long r_illegal-top+83886080
.long W540-top+117440512
.long W548-top+117440512
.long W550-top+117440512
.long W558-top+117440512
.long W560-top+117440512
.long W568-top+117440512
.long W570-top+117440512
.long W578-top
.long W579-top
.long r_illegal-top+218103808
.long W588-top+117440512
.long W590-top+117440512
.long W598-top+117440512
.long W5A0-top+117440512
.long W5A8-top+117440512
.long W5B0-top+117440512
.long W5B8-top
.long W5B9-top
.long r_illegal-top+83886080
.long W5C0-top+117440512
.long r_illegal-top+117440512
.long W5D0-top+117440512
.long W5D8-top+117440512
.long W5E0-top+117440512
.long W5E8-top+117440512
.long W5F0-top+117440512
.long W5F8-top
.long W5F9-top
.long W5FA-top
.long W5FB-top
.long W5FC-top
.long r_illegal-top+33554432
.long W600-top+117440512
.long r_illegal-top+117440512
.long W610-top+117440512
.long W618-top+117440512
.long W620-top+117440512
.long W628-top+117440512
.long W630-top+117440512
.long W638-top
.long W639-top
.long W63A-top
.long W63B-top
.long W63C-top
.long r_illegal-top+33554432
.long W640-top+117440512
.long r_illegal-top+117440512
.long W650-top+117440512
.long W658-top+117440512
.long W660-top+117440512
.long W668-top+117440512
.long W670-top+117440512
.long W678-top
.long W679-top
.long W67A-top
.long W67B-top
.long W67C-top
.long r_illegal-top+33554432
.long W680-top+117440512
.long r_illegal-top+117440512
.long W690-top+117440512
.long W698-top+117440512
.long W6A0-top+117440512
.long W6A8-top+117440512
.long W6B0-top+117440512
.long W6B8-top
.long W6B9-top
.long W6BA-top
.long W6BB-top
.long W6BC-top
.long r_illegal-top+33554432
.long W6C0-top+117440512
.long r_illegal-top+117440512
.long W6D0-top+117440512
.long W6D8-top+117440512
.long W6E0-top+117440512
.long W6E8-top+117440512
.long W6F0-top+117440512
.long W6F8-top
.long W6F9-top
.long W6FA-top
.long W6FB-top
.long W6FC-top
.long r_illegal-top+33554432
.long W700-top+117440512
.long W708-top+117440512
.long W710-top+117440512
.long W718-top+117440512
.long W720-top+117440512
.long W728-top+117440512
.long W730-top+117440512
.long W738-top
.long W739-top
.long r_illegal-top+83886080
.long W740-top+117440512
.long W748-top+117440512
.long W750-top+117440512
.long W758-top+117440512
.long W760-top+117440512
.long W768-top+117440512
.long W770-top+117440512
.long W778-top
.long W779-top
.long r_illegal-top+218103808
.long W788-top+117440512
.long W790-top+117440512
.long W798-top+117440512
.long W7A0-top+117440512
.long W7A8-top+117440512
.long W7B0-top+117440512
.long W7B8-top
.long W7B9-top
.long r_illegal-top+83886080
.long W7C0-top+117440512
.long r_illegal-top+117440512
.long W7D0-top+117440512
.long W7D8-top+117440512
.long W7E0-top+117440512
.long W7E8-top+117440512
.long W7F0-top+117440512
.long W7F8-top
.long W7F9-top
.long W7FA-top
.long W7FB-top
.long W7FC-top
.long r_illegal-top+33554432
.long W800-top+117440512
.long r_illegal-top+117440512
.long W810-top+117440512
.long W818-top+117440512
.long W820-top+117440512
.long W828-top+117440512
.long W830-top+117440512
.long W838-top
.long W839-top
.long W83A-top
.long W83B-top
.long W83C-top
.long r_illegal-top+33554432
.long W840-top+117440512
.long r_illegal-top+117440512
.long W850-top+117440512
.long W858-top+117440512
.long W860-top+117440512
.long W868-top+117440512
.long W870-top+117440512
.long W878-top
.long W879-top
.long W87A-top
.long W87B-top
.long W87C-top
.long r_illegal-top+33554432
.long W880-top+117440512
.long r_illegal-top+117440512
.long W890-top+117440512
.long W898-top+117440512
.long W8A0-top+117440512
.long W8A8-top+117440512
.long W8B0-top+117440512
.long W8B8-top
.long W8B9-top
.long W8BA-top
.long W8BB-top
.long W8BC-top
.long r_illegal-top+33554432
.long W8C0-top+117440512
.long r_illegal-top+117440512
.long W8D0-top+117440512
.long W8D8-top+117440512
.long W8E0-top+117440512
.long W8E8-top+117440512
.long W8F0-top+117440512
.long W8F8-top
.long W8F9-top
.long W8FA-top
.long W8FB-top
.long W8FC-top
.long r_illegal-top+33554432
.long W900-top+117440512
.long W908-top+117440512
.long W910-top+117440512
.long W918-top+117440512
.long W920-top+117440512
.long W928-top+117440512
.long W930-top+117440512
.long W938-top
.long W939-top
.long r_illegal-top+83886080
.long W940-top+117440512
.long W948-top+117440512
.long W950-top+117440512
.long W958-top+117440512
.long W960-top+117440512
.long W968-top+117440512
.long W970-top+117440512
.long W978-top
.long W979-top
.long r_illegal-top+218103808
.long W988-top+117440512
.long W990-top+117440512
.long W998-top+117440512
.long W9A0-top+117440512
.long W9A8-top+117440512
.long W9B0-top+117440512
.long W9B8-top
.long W9B9-top
.long r_illegal-top+83886080
.long W9C0-top+117440512
.long r_illegal-top+117440512
.long W9D0-top+117440512
.long W9D8-top+117440512
.long W9E0-top+117440512
.long W9E8-top+117440512
.long W9F0-top+117440512
.long W9F8-top
.long W9F9-top
.long W9FA-top
.long W9FB-top
.long W9FC-top
.long r_illegal-top+33554432
.long WA00-top+117440512
.long r_illegal-top+117440512
.long WA10-top+117440512
.long WA18-top+117440512
.long WA20-top+117440512
.long WA28-top+117440512
.long WA30-top+117440512
.long WA38-top
.long WA39-top
.long WA3A-top
.long WA3B-top
.long WA3C-top
.long r_illegal-top+33554432
.long WA40-top+117440512
.long r_illegal-top+117440512
.long WA50-top+117440512
.long WA58-top+117440512
.long WA60-top+117440512
.long WA68-top+117440512
.long WA70-top+117440512
.long WA78-top
.long WA79-top
.long WA7A-top
.long WA7B-top
.long WA7C-top
.long r_illegal-top+33554432
.long WA80-top+117440512
.long r_illegal-top+117440512
.long WA90-top+117440512
.long WA98-top+117440512
.long WAA0-top+117440512
.long WAA8-top+117440512
.long WAB0-top+117440512
.long WAB8-top
.long WAB9-top
.long WABA-top
.long WABB-top
.long WABC-top
.long r_illegal-top+33554432
.long WAC0-top+117440512
.long r_illegal-top+117440512
.long WAD0-top+117440512
.long WAD8-top+117440512
.long WAE0-top+117440512
.long WAE8-top+117440512
.long WAF0-top+117440512
.long WAF8-top
.long WAF9-top
.long WAFA-top
.long WAFB-top
.long WAFC-top
.long r_illegal-top+33554432
.long WB00-top+117440512
.long WB08-top+117440512
.long WB10-top+117440512
.long WB18-top+117440512
.long WB20-top+117440512
.long WB28-top+117440512
.long WB30-top+117440512
.long WB38-top
.long WB39-top
.long r_illegal-top+83886080
.long WB40-top+117440512
.long WB48-top+117440512
.long WB50-top+117440512
.long WB58-top+117440512
.long WB60-top+117440512
.long WB68-top+117440512
.long WB70-top+117440512
.long WB78-top
.long WB79-top
.long r_illegal-top+218103808
.long WB88-top+117440512
.long WB90-top+117440512
.long WB98-top+117440512
.long WBA0-top+117440512
.long WBA8-top+117440512
.long WBB0-top+117440512
.long WBB8-top
.long WBB9-top
.long r_illegal-top+83886080
.long WBC0-top+117440512
.long r_illegal-top+117440512
.long WBD0-top+117440512
.long WBD8-top+117440512
.long WBE0-top+117440512
.long WBE8-top+117440512
.long WBF0-top+117440512
.long WBF8-top
.long WBF9-top
.long WBFA-top
.long WBFB-top
.long WBFC-top
.long r_illegal-top+33554432
.long WC00-top+117440512
.long r_illegal-top+117440512
.long WC10-top+117440512
.long WC18-top+117440512
.long WC20-top+117440512
.long WC28-top+117440512
.long WC30-top+117440512
.long WC38-top
.long WC39-top
.long WC3A-top
.long WC3B-top
.long WC3C-top
.long r_illegal-top+33554432
.long WC40-top+117440512
.long r_illegal-top+117440512
.long WC50-top+117440512
.long WC58-top+117440512
.long WC60-top+117440512
.long WC68-top+117440512
.long WC70-top+117440512
.long WC78-top
.long WC79-top
.long WC7A-top
.long WC7B-top
.long WC7C-top
.long r_illegal-top+33554432
.long WC80-top+117440512
.long r_illegal-top+117440512
.long WC90-top+117440512
.long WC98-top+117440512
.long WCA0-top+117440512
.long WCA8-top+117440512
.long WCB0-top+117440512
.long WCB8-top
.long WCB9-top
.long WCBA-top
.long WCBB-top
.long WCBC-top
.long r_illegal-top+33554432
.long WCC0-top+117440512
.long r_illegal-top+117440512
.long WCD0-top+117440512
.long WCD8-top+117440512
.long WCE0-top+117440512
.long WCE8-top+117440512
.long WCF0-top+117440512
.long WCF8-top
.long WCF9-top
.long WCFA-top
.long WCFB-top
.long WCFC-top
.long r_illegal-top+33554432
.long WD00-top+117440512
.long WD08-top+117440512
.long WD10-top+117440512
.long WD18-top+117440512
.long WD20-top+117440512
.long WD28-top+117440512
.long WD30-top+117440512
.long WD38-top
.long WD39-top
.long r_illegal-top+83886080
.long WD40-top+117440512
.long WD48-top+117440512
.long WD50-top+117440512
.long WD58-top+117440512
.long WD60-top+117440512
.long WD68-top+117440512
.long WD70-top+117440512
.long WD78-top
.long WD79-top
.long r_illegal-top+218103808
.long WD88-top+117440512
.long WD90-top+117440512
.long WD98-top+117440512
.long WDA0-top+117440512
.long WDA8-top+117440512
.long WDB0-top+117440512
.long WDB8-top
.long WDB9-top
.long r_illegal-top+83886080
.long WDC0-top+117440512
.long r_illegal-top+117440512
.long WDD0-top+117440512
.long WDD8-top+117440512
.long WDE0-top+117440512
.long WDE8-top+117440512
.long WDF0-top+117440512
.long WDF8-top
.long WDF9-top
.long WDFA-top
.long WDFB-top
.long WDFC-top
.long r_illegal-top+33554432
.long WE00-top+117440512
.long r_illegal-top+117440512
.long WE10-top+117440512
.long WE18-top+117440512
.long WE20-top+117440512
.long WE28-top+117440512
.long WE30-top+117440512
.long WE38-top
.long WE39-top
.long WE3A-top
.long WE3B-top
.long WE3C-top
.long r_illegal-top+33554432
.long WE40-top+117440512
.long r_illegal-top+117440512
.long WE50-top+117440512
.long WE58-top+117440512
.long WE60-top+117440512
.long WE68-top+117440512
.long WE70-top+117440512
.long WE78-top
.long WE79-top
.long WE7A-top
.long WE7B-top
.long WE7C-top
.long r_illegal-top+33554432
.long WE80-top+117440512
.long r_illegal-top+117440512
.long WE90-top+117440512
.long WE98-top+117440512
.long WEA0-top+117440512
.long WEA8-top+117440512
.long WEB0-top+117440512
.long WEB8-top
.long WEB9-top
.long WEBA-top
.long WEBB-top
.long WEBC-top
.long r_illegal-top+33554432
.long WEC0-top+117440512
.long r_illegal-top+117440512
.long WED0-top+117440512
.long WED8-top+117440512
.long WEE0-top+117440512
.long WEE8-top+117440512
.long WEF0-top+117440512
.long WEF8-top
.long WEF9-top
.long WEFA-top
.long WEFB-top
.long WEFC-top
.long r_illegal-top+33554432
.long WF00-top+117440512
.long WF08-top+117440512
.long WF10-top+117440512
.long WF18-top+117440512
.long WF20-top+117440512
.long WF28-top+117440512
.long WF30-top+117440512
.long WF38-top
.long WF39-top
.long r_illegal-top+83886080
.long WF40-top+117440512
.long WF48-top+117440512
.long WF50-top+117440512
.long WF58-top+117440512
.long WF60-top+117440512
.long WF68-top+117440512
.long WF70-top+117440512
.long WF78-top
.long WF79-top
.long r_illegal-top+218103808
.long WF88-top+117440512
.long WF90-top+117440512
.long WF98-top+117440512
.long WFA0-top+117440512
.long WFA8-top+117440512
.long WFB0-top+117440512
.long WFB8-top
.long WFB9-top
.long r_illegal-top+83886080
.long WFC0-top+117440512
.long r_illegal-top+117440512
.long WFD0-top+117440512
.long WFD8-top+117440512
.long WFE0-top+117440512
.long WFE8-top+117440512
.long WFF0-top+117440512
.long WFF8-top
.long WFF9-top
.long WFFA-top
.long WFFB-top
.long WFFC-top
.long r_illegal-top+33554432
.long X000-top+117440512
.long X008-top+117440512
.long X010-top+117440512
.long X018-top+117440512
.long X020-top+117440512
.long X028-top+117440512
.long X030-top+117440512
.long X038-top
.long X039-top
.long X03A-top
.long X03B-top
.long X03C-top
.long r_illegal-top+33554432
.long X040-top+117440512
.long X048-top+117440512
.long X050-top+117440512
.long X058-top+117440512
.long X060-top+117440512
.long X068-top+117440512
.long X070-top+117440512
.long X078-top
.long X079-top
.long X07A-top
.long X07B-top
.long X07C-top
.long r_illegal-top+33554432
.long X080-top+117440512
.long X088-top+117440512
.long X090-top+117440512
.long X098-top+117440512
.long X0A0-top+117440512
.long X0A8-top+117440512
.long X0B0-top+117440512
.long X0B8-top
.long X0B9-top
.long X0BA-top
.long X0BB-top
.long X0BC-top
.long r_illegal-top+33554432
.long X0C0-top+117440512
.long X0C8-top+117440512
.long X0D0-top+117440512
.long X0D8-top+117440512
.long X0E0-top+117440512
.long X0E8-top+117440512
.long X0F0-top+117440512
.long X0F8-top
.long X0F9-top
.long X0FA-top
.long X0FB-top
.long X0FC-top
.long r_illegal-top+33554432
.long X100-top+117440512
.long X108-top+117440512
.long X110-top+117440512
.long X118-top+117440512
.long X120-top+117440512
.long X128-top+117440512
.long X130-top+117440512
.long X138-top
.long X139-top
.long r_illegal-top+83886080
.long X140-top+117440512
.long X148-top+117440512
.long X150-top+117440512
.long X158-top+117440512
.long X160-top+117440512
.long X168-top+117440512
.long X170-top+117440512
.long X178-top
.long X179-top
.long r_illegal-top+83886080
.long X180-top+117440512
.long X188-top+117440512
.long X190-top+117440512
.long X198-top+117440512
.long X1A0-top+117440512
.long X1A8-top+117440512
.long X1B0-top+117440512
.long X1B8-top
.long X1B9-top
.long r_illegal-top+83886080
.long X1C0-top+117440512
.long X1C8-top+117440512
.long X1D0-top+117440512
.long X1D8-top+117440512
.long X1E0-top+117440512
.long X1E8-top+117440512
.long X1F0-top+117440512
.long X1F8-top
.long X1F9-top
.long X1FA-top
.long X1FB-top
.long X1FC-top
.long r_illegal-top+33554432
.long X200-top+117440512
.long X208-top+117440512
.long X210-top+117440512
.long X218-top+117440512
.long X220-top+117440512
.long X228-top+117440512
.long X230-top+117440512
.long X238-top
.long X239-top
.long X23A-top
.long X23B-top
.long X23C-top
.long r_illegal-top+33554432
.long X240-top+117440512
.long X248-top+117440512
.long X250-top+117440512
.long X258-top+117440512
.long X260-top+117440512
.long X268-top+117440512
.long X270-top+117440512
.long X278-top
.long X279-top
.long X27A-top
.long X27B-top
.long X27C-top
.long r_illegal-top+33554432
.long X280-top+117440512
.long X288-top+117440512
.long X290-top+117440512
.long X298-top+117440512
.long X2A0-top+117440512
.long X2A8-top+117440512
.long X2B0-top+117440512
.long X2B8-top
.long X2B9-top
.long X2BA-top
.long X2BB-top
.long X2BC-top
.long r_illegal-top+33554432
.long X2C0-top+117440512
.long X2C8-top+117440512
.long X2D0-top+117440512
.long X2D8-top+117440512
.long X2E0-top+117440512
.long X2E8-top+117440512
.long X2F0-top+117440512
.long X2F8-top
.long X2F9-top
.long X2FA-top
.long X2FB-top
.long X2FC-top
.long r_illegal-top+33554432
.long X300-top+117440512
.long X308-top+117440512
.long X310-top+117440512
.long X318-top+117440512
.long X320-top+117440512
.long X328-top+117440512
.long X330-top+117440512
.long X338-top
.long X339-top
.long r_illegal-top+83886080
.long X340-top+117440512
.long X348-top+117440512
.long X350-top+117440512
.long X358-top+117440512
.long X360-top+117440512
.long X368-top+117440512
.long X370-top+117440512
.long X378-top
.long X379-top
.long r_illegal-top+83886080
.long X380-top+117440512
.long X388-top+117440512
.long X390-top+117440512
.long X398-top+117440512
.long X3A0-top+117440512
.long X3A8-top+117440512
.long X3B0-top+117440512
.long X3B8-top
.long X3B9-top
.long r_illegal-top+83886080
.long X3C0-top+117440512
.long X3C8-top+117440512
.long X3D0-top+117440512
.long X3D8-top+117440512
.long X3E0-top+117440512
.long X3E8-top+117440512
.long X3F0-top+117440512
.long X3F8-top
.long X3F9-top
.long X3FA-top
.long X3FB-top
.long X3FC-top
.long r_illegal-top+33554432
.long X400-top+117440512
.long X408-top+117440512
.long X410-top+117440512
.long X418-top+117440512
.long X420-top+117440512
.long X428-top+117440512
.long X430-top+117440512
.long X438-top
.long X439-top
.long X43A-top
.long X43B-top
.long X43C-top
.long r_illegal-top+33554432
.long X440-top+117440512
.long X448-top+117440512
.long X450-top+117440512
.long X458-top+117440512
.long X460-top+117440512
.long X468-top+117440512
.long X470-top+117440512
.long X478-top
.long X479-top
.long X47A-top
.long X47B-top
.long X47C-top
.long r_illegal-top+33554432
.long X480-top+117440512
.long X488-top+117440512
.long X490-top+117440512
.long X498-top+117440512
.long X4A0-top+117440512
.long X4A8-top+117440512
.long X4B0-top+117440512
.long X4B8-top
.long X4B9-top
.long X4BA-top
.long X4BB-top
.long X4BC-top
.long r_illegal-top+33554432
.long X4C0-top+117440512
.long X4C8-top+117440512
.long X4D0-top+117440512
.long X4D8-top+117440512
.long X4E0-top+117440512
.long X4E8-top+117440512
.long X4F0-top+117440512
.long X4F8-top
.long X4F9-top
.long X4FA-top
.long X4FB-top
.long X4FC-top
.long r_illegal-top+33554432
.long X500-top+117440512
.long X508-top+117440512
.long X510-top+117440512
.long X518-top+117440512
.long X520-top+117440512
.long X528-top+117440512
.long X530-top+117440512
.long X538-top
.long X539-top
.long r_illegal-top+83886080
.long X540-top+117440512
.long X548-top+117440512
.long X550-top+117440512
.long X558-top+117440512
.long X560-top+117440512
.long X568-top+117440512
.long X570-top+117440512
.long X578-top
.long X579-top
.long r_illegal-top+83886080
.long X580-top+117440512
.long X588-top+117440512
.long X590-top+117440512
.long X598-top+117440512
.long X5A0-top+117440512
.long X5A8-top+117440512
.long X5B0-top+117440512
.long X5B8-top
.long X5B9-top
.long r_illegal-top+83886080
.long X5C0-top+117440512
.long X5C8-top+117440512
.long X5D0-top+117440512
.long X5D8-top+117440512
.long X5E0-top+117440512
.long X5E8-top+117440512
.long X5F0-top+117440512
.long X5F8-top
.long X5F9-top
.long X5FA-top
.long X5FB-top
.long X5FC-top
.long r_illegal-top+33554432
.long X600-top+117440512
.long X608-top+117440512
.long X610-top+117440512
.long X618-top+117440512
.long X620-top+117440512
.long X628-top+117440512
.long X630-top+117440512
.long X638-top
.long X639-top
.long X63A-top
.long X63B-top
.long X63C-top
.long r_illegal-top+33554432
.long X640-top+117440512
.long X648-top+117440512
.long X650-top+117440512
.long X658-top+117440512
.long X660-top+117440512
.long X668-top+117440512
.long X670-top+117440512
.long X678-top
.long X679-top
.long X67A-top
.long X67B-top
.long X67C-top
.long r_illegal-top+33554432
.long X680-top+117440512
.long X688-top+117440512
.long X690-top+117440512
.long X698-top+117440512
.long X6A0-top+117440512
.long X6A8-top+117440512
.long X6B0-top+117440512
.long X6B8-top
.long X6B9-top
.long X6BA-top
.long X6BB-top
.long X6BC-top
.long r_illegal-top+33554432
.long X6C0-top+117440512
.long X6C8-top+117440512
.long X6D0-top+117440512
.long X6D8-top+117440512
.long X6E0-top+117440512
.long X6E8-top+117440512
.long X6F0-top+117440512
.long X6F8-top
.long X6F9-top
.long X6FA-top
.long X6FB-top
.long X6FC-top
.long r_illegal-top+33554432
.long X700-top+117440512
.long X708-top+117440512
.long X710-top+117440512
.long X718-top+117440512
.long X720-top+117440512
.long X728-top+117440512
.long X730-top+117440512
.long X738-top
.long X739-top
.long r_illegal-top+83886080
.long X740-top+117440512
.long X748-top+117440512
.long X750-top+117440512
.long X758-top+117440512
.long X760-top+117440512
.long X768-top+117440512
.long X770-top+117440512
.long X778-top
.long X779-top
.long r_illegal-top+83886080
.long X780-top+117440512
.long X788-top+117440512
.long X790-top+117440512
.long X798-top+117440512
.long X7A0-top+117440512
.long X7A8-top+117440512
.long X7B0-top+117440512
.long X7B8-top
.long X7B9-top
.long r_illegal-top+83886080
.long X7C0-top+117440512
.long X7C8-top+117440512
.long X7D0-top+117440512
.long X7D8-top+117440512
.long X7E0-top+117440512
.long X7E8-top+117440512
.long X7F0-top+117440512
.long X7F8-top
.long X7F9-top
.long X7FA-top
.long X7FB-top
.long X7FC-top
.long r_illegal-top+33554432
.long X800-top+117440512
.long X808-top+117440512
.long X810-top+117440512
.long X818-top+117440512
.long X820-top+117440512
.long X828-top+117440512
.long X830-top+117440512
.long X838-top
.long X839-top
.long X83A-top
.long X83B-top
.long X83C-top
.long r_illegal-top+33554432
.long X840-top+117440512
.long X848-top+117440512
.long X850-top+117440512
.long X858-top+117440512
.long X860-top+117440512
.long X868-top+117440512
.long X870-top+117440512
.long X878-top
.long X879-top
.long X87A-top
.long X87B-top
.long X87C-top
.long r_illegal-top+33554432
.long X880-top+117440512
.long X888-top+117440512
.long X890-top+117440512
.long X898-top+117440512
.long X8A0-top+117440512
.long X8A8-top+117440512
.long X8B0-top+117440512
.long X8B8-top
.long X8B9-top
.long X8BA-top
.long X8BB-top
.long X8BC-top
.long r_illegal-top+33554432
.long X8C0-top+117440512
.long X8C8-top+117440512
.long X8D0-top+117440512
.long X8D8-top+117440512
.long X8E0-top+117440512
.long X8E8-top+117440512
.long X8F0-top+117440512
.long X8F8-top
.long X8F9-top
.long X8FA-top
.long X8FB-top
.long X8FC-top
.long r_illegal-top+33554432
.long X900-top+117440512
.long X908-top+117440512
.long X910-top+117440512
.long X918-top+117440512
.long X920-top+117440512
.long X928-top+117440512
.long X930-top+117440512
.long X938-top
.long X939-top
.long r_illegal-top+83886080
.long X940-top+117440512
.long X948-top+117440512
.long X950-top+117440512
.long X958-top+117440512
.long X960-top+117440512
.long X968-top+117440512
.long X970-top+117440512
.long X978-top
.long X979-top
.long r_illegal-top+83886080
.long X980-top+117440512
.long X988-top+117440512
.long X990-top+117440512
.long X998-top+117440512
.long X9A0-top+117440512
.long X9A8-top+117440512
.long X9B0-top+117440512
.long X9B8-top
.long X9B9-top
.long r_illegal-top+83886080
.long X9C0-top+117440512
.long X9C8-top+117440512
.long X9D0-top+117440512
.long X9D8-top+117440512
.long X9E0-top+117440512
.long X9E8-top+117440512
.long X9F0-top+117440512
.long X9F8-top
.long X9F9-top
.long X9FA-top
.long X9FB-top
.long X9FC-top
.long r_illegal-top+33554432
.long XA00-top+117440512
.long XA08-top+117440512
.long XA10-top+117440512
.long XA18-top+117440512
.long XA20-top+117440512
.long XA28-top+117440512
.long XA30-top+117440512
.long XA38-top
.long XA39-top
.long XA3A-top
.long XA3B-top
.long XA3C-top
.long r_illegal-top+33554432
.long XA40-top+117440512
.long XA48-top+117440512
.long XA50-top+117440512
.long XA58-top+117440512
.long XA60-top+117440512
.long XA68-top+117440512
.long XA70-top+117440512
.long XA78-top
.long XA79-top
.long XA7A-top
.long XA7B-top
.long XA7C-top
.long r_illegal-top+33554432
.long XA80-top+117440512
.long XA88-top+117440512
.long XA90-top+117440512
.long XA98-top+117440512
.long XAA0-top+117440512
.long XAA8-top+117440512
.long XAB0-top+117440512
.long XAB8-top
.long XAB9-top
.long XABA-top
.long XABB-top
.long XABC-top
.long r_illegal-top+33554432
.long XAC0-top+117440512
.long XAC8-top+117440512
.long XAD0-top+117440512
.long XAD8-top+117440512
.long XAE0-top+117440512
.long XAE8-top+117440512
.long XAF0-top+117440512
.long XAF8-top
.long XAF9-top
.long XAFA-top
.long XAFB-top
.long XAFC-top
.long r_illegal-top+33554432
.long XB00-top+117440512
.long XB08-top+117440512
.long XB10-top+117440512
.long XB18-top+117440512
.long XB20-top+117440512
.long XB28-top+117440512
.long XB30-top+117440512
.long XB38-top
.long XB39-top
.long r_illegal-top+83886080
.long XB40-top+117440512
.long XB48-top+117440512
.long XB50-top+117440512
.long XB58-top+117440512
.long XB60-top+117440512
.long XB68-top+117440512
.long XB70-top+117440512
.long XB78-top
.long XB79-top
.long r_illegal-top+83886080
.long XB80-top+117440512
.long XB88-top+117440512
.long XB90-top+117440512
.long XB98-top+117440512
.long XBA0-top+117440512
.long XBA8-top+117440512
.long XBB0-top+117440512
.long XBB8-top
.long XBB9-top
.long r_illegal-top+83886080
.long XBC0-top+117440512
.long XBC8-top+117440512
.long XBD0-top+117440512
.long XBD8-top+117440512
.long XBE0-top+117440512
.long XBE8-top+117440512
.long XBF0-top+117440512
.long XBF8-top
.long XBF9-top
.long XBFA-top
.long XBFB-top
.long XBFC-top
.long r_illegal-top+33554432
.long XC00-top+117440512
.long XC08-top+117440512
.long XC10-top+117440512
.long XC18-top+117440512
.long XC20-top+117440512
.long XC28-top+117440512
.long XC30-top+117440512
.long XC38-top
.long XC39-top
.long XC3A-top
.long XC3B-top
.long XC3C-top
.long r_illegal-top+33554432
.long XC40-top+117440512
.long XC48-top+117440512
.long XC50-top+117440512
.long XC58-top+117440512
.long XC60-top+117440512
.long XC68-top+117440512
.long XC70-top+117440512
.long XC78-top
.long XC79-top
.long XC7A-top
.long XC7B-top
.long XC7C-top
.long r_illegal-top+33554432
.long XC80-top+117440512
.long XC88-top+117440512
.long XC90-top+117440512
.long XC98-top+117440512
.long XCA0-top+117440512
.long XCA8-top+117440512
.long XCB0-top+117440512
.long XCB8-top
.long XCB9-top
.long XCBA-top
.long XCBB-top
.long XCBC-top
.long r_illegal-top+33554432
.long XCC0-top+117440512
.long XCC8-top+117440512
.long XCD0-top+117440512
.long XCD8-top+117440512
.long XCE0-top+117440512
.long XCE8-top+117440512
.long XCF0-top+117440512
.long XCF8-top
.long XCF9-top
.long XCFA-top
.long XCFB-top
.long XCFC-top
.long r_illegal-top+33554432
.long XD00-top+117440512
.long XD08-top+117440512
.long XD10-top+117440512
.long XD18-top+117440512
.long XD20-top+117440512
.long XD28-top+117440512
.long XD30-top+117440512
.long XD38-top
.long XD39-top
.long r_illegal-top+83886080
.long XD40-top+117440512
.long XD48-top+117440512
.long XD50-top+117440512
.long XD58-top+117440512
.long XD60-top+117440512
.long XD68-top+117440512
.long XD70-top+117440512
.long XD78-top
.long XD79-top
.long r_illegal-top+83886080
.long XD80-top+117440512
.long XD88-top+117440512
.long XD90-top+117440512
.long XD98-top+117440512
.long XDA0-top+117440512
.long XDA8-top+117440512
.long XDB0-top+117440512
.long XDB8-top
.long XDB9-top
.long r_illegal-top+83886080
.long XDC0-top+117440512
.long XDC8-top+117440512
.long XDD0-top+117440512
.long XDD8-top+117440512
.long XDE0-top+117440512
.long XDE8-top+117440512
.long XDF0-top+117440512
.long XDF8-top
.long XDF9-top
.long XDFA-top
.long XDFB-top
.long XDFC-top
.long r_illegal-top+33554432
.long XE00-top+117440512
.long XE08-top+117440512
.long XE10-top+117440512
.long XE18-top+117440512
.long XE20-top+117440512
.long XE28-top+117440512
.long XE30-top+117440512
.long XE38-top
.long XE39-top
.long XE3A-top
.long XE3B-top
.long XE3C-top
.long r_illegal-top+33554432
.long XE40-top+117440512
.long XE48-top+117440512
.long XE50-top+117440512
.long XE58-top+117440512
.long XE60-top+117440512
.long XE68-top+117440512
.long XE70-top+117440512
.long XE78-top
.long XE79-top
.long XE7A-top
.long XE7B-top
.long XE7C-top
.long r_illegal-top+33554432
.long XE80-top+117440512
.long XE88-top+117440512
.long XE90-top+117440512
.long XE98-top+117440512
.long XEA0-top+117440512
.long XEA8-top+117440512
.long XEB0-top+117440512
.long XEB8-top
.long XEB9-top
.long XEBA-top
.long XEBB-top
.long XEBC-top
.long r_illegal-top+33554432
.long XEC0-top+117440512
.long XEC8-top+117440512
.long XED0-top+117440512
.long XED8-top+117440512
.long XEE0-top+117440512
.long XEE8-top+117440512
.long XEF0-top+117440512
.long XEF8-top
.long XEF9-top
.long XEFA-top
.long XEFB-top
.long XEFC-top
.long r_illegal-top+33554432
.long XF00-top+117440512
.long XF08-top+117440512
.long XF10-top+117440512
.long XF18-top+117440512
.long XF20-top+117440512
.long XF28-top+117440512
.long XF30-top+117440512
.long XF38-top
.long XF39-top
.long r_illegal-top+83886080
.long XF40-top+117440512
.long XF48-top+117440512
.long XF50-top+117440512
.long XF58-top+117440512
.long XF60-top+117440512
.long XF68-top+117440512
.long XF70-top+117440512
.long XF78-top
.long XF79-top
.long r_illegal-top+83886080
.long XF80-top+117440512
.long XF88-top+117440512
.long XF90-top+117440512
.long XF98-top+117440512
.long XFA0-top+117440512
.long XFA8-top+117440512
.long XFB0-top+117440512
.long XFB8-top
.long XFB9-top
.long r_illegal-top+83886080
.long XFC0-top+117440512
.long XFC8-top+117440512
.long XFD0-top+117440512
.long XFD8-top+117440512
.long XFE0-top+117440512
.long XFE8-top+117440512
.long XFF0-top+117440512
.long XFF8-top
.long XFF9-top
.long XFFA-top
.long XFFB-top
.long XFFC-top
.long r_illegal-top+33554432
.long Y000-top+117440512
.long Y008-top+117440512
.long Y010-top+117440512
.long Y018-top+117440512
.long Y020-top+117440512
.long Y028-top+117440512
.long Y030-top+117440512
.long Y038-top+117440512
.long Y040-top+117440512
.long Y048-top+117440512
.long Y050-top+117440512
.long Y058-top+117440512
.long Y060-top+117440512
.long Y068-top+117440512
.long Y070-top+117440512
.long Y078-top+117440512
.long Y080-top+117440512
.long Y088-top+117440512
.long Y090-top+117440512
.long Y098-top+117440512
.long Y0A0-top+117440512
.long Y0A8-top+117440512
.long Y0B0-top+117440512
.long Y0B8-top+117440512
.long r_illegal-top+251658240
.long Y0D0-top+117440512
.long Y0D8-top+117440512
.long Y0E0-top+117440512
.long Y0E8-top+117440512
.long Y0F0-top+117440512
.long Y0F8-top
.long Y0F9-top
.long r_illegal-top+83886080
.long Y100-top+117440512
.long Y108-top+117440512
.long Y110-top+117440512
.long Y118-top+117440512
.long Y120-top+117440512
.long Y128-top+117440512
.long Y130-top+117440512
.long Y138-top+117440512
.long Y140-top+117440512
.long Y148-top+117440512
.long Y150-top+117440512
.long Y158-top+117440512
.long Y160-top+117440512
.long Y168-top+117440512
.long Y170-top+117440512
.long Y178-top+117440512
.long Y180-top+117440512
.long Y188-top+117440512
.long Y190-top+117440512
.long Y198-top+117440512
.long Y1A0-top+117440512
.long Y1A8-top+117440512
.long Y1B0-top+117440512
.long Y1B8-top+117440512
.long r_illegal-top+251658240
.long Y1D0-top+117440512
.long Y1D8-top+117440512
.long Y1E0-top+117440512
.long Y1E8-top+117440512
.long Y1F0-top+117440512
.long Y1F8-top
.long Y1F9-top
.long r_illegal-top+83886080
.long Y200-top+117440512
.long Y208-top+117440512
.long Y210-top+117440512
.long Y218-top+117440512
.long Y220-top+117440512
.long Y228-top+117440512
.long Y230-top+117440512
.long Y238-top+117440512
.long Y240-top+117440512
.long Y248-top+117440512
.long Y250-top+117440512
.long Y258-top+117440512
.long Y260-top+117440512
.long Y268-top+117440512
.long Y270-top+117440512
.long Y278-top+117440512
.long Y280-top+117440512
.long Y288-top+117440512
.long Y290-top+117440512
.long Y298-top+117440512
.long Y2A0-top+117440512
.long Y2A8-top+117440512
.long Y2B0-top+117440512
.long Y2B8-top+117440512
.long r_illegal-top+251658240
.long Y2D0-top+117440512
.long Y2D8-top+117440512
.long Y2E0-top+117440512
.long Y2E8-top+117440512
.long Y2F0-top+117440512
.long Y2F8-top
.long Y2F9-top
.long r_illegal-top+83886080
.long Y300-top+117440512
.long Y308-top+117440512
.long Y310-top+117440512
.long Y318-top+117440512
.long Y320-top+117440512
.long Y328-top+117440512
.long Y330-top+117440512
.long Y338-top+117440512
.long Y340-top+117440512
.long Y348-top+117440512
.long Y350-top+117440512
.long Y358-top+117440512
.long Y360-top+117440512
.long Y368-top+117440512
.long Y370-top+117440512
.long Y378-top+117440512
.long Y380-top+117440512
.long Y388-top+117440512
.long Y390-top+117440512
.long Y398-top+117440512
.long Y3A0-top+117440512
.long Y3A8-top+117440512
.long Y3B0-top+117440512
.long Y3B8-top+117440512
.long r_illegal-top+251658240
.long Y3D0-top+117440512
.long Y3D8-top+117440512
.long Y3E0-top+117440512
.long Y3E8-top+117440512
.long Y3F0-top+117440512
.long Y3F8-top
.long Y3F9-top
.long r_illegal-top+83886080
.long Y400-top+117440512
.long Y408-top+117440512
.long Y410-top+117440512
.long Y418-top+117440512
.long Y420-top+117440512
.long Y428-top+117440512
.long Y430-top+117440512
.long Y438-top+117440512
.long Y440-top+117440512
.long Y448-top+117440512
.long Y450-top+117440512
.long Y458-top+117440512
.long Y460-top+117440512
.long Y468-top+117440512
.long Y470-top+117440512
.long Y478-top+117440512
.long Y480-top+117440512
.long Y488-top+117440512
.long Y490-top+117440512
.long Y498-top+117440512
.long Y4A0-top+117440512
.long Y4A8-top+117440512
.long Y4B0-top+117440512
.long Y4B8-top+117440512
.long r_illegal-top+251658240
.long Y4D0-top+117440512
.long Y4D8-top+117440512
.long Y4E0-top+117440512
.long Y4E8-top+117440512
.long Y4F0-top+117440512
.long Y4F8-top
.long Y4F9-top
.long r_illegal-top+83886080
.long Y500-top+117440512
.long Y508-top+117440512
.long Y510-top+117440512
.long Y518-top+117440512
.long Y520-top+117440512
.long Y528-top+117440512
.long Y530-top+117440512
.long Y538-top+117440512
.long Y540-top+117440512
.long Y548-top+117440512
.long Y550-top+117440512
.long Y558-top+117440512
.long Y560-top+117440512
.long Y568-top+117440512
.long Y570-top+117440512
.long Y578-top+117440512
.long Y580-top+117440512
.long Y588-top+117440512
.long Y590-top+117440512
.long Y598-top+117440512
.long Y5A0-top+117440512
.long Y5A8-top+117440512
.long Y5B0-top+117440512
.long Y5B8-top+117440512
.long r_illegal-top+251658240
.long Y5D0-top+117440512
.long Y5D8-top+117440512
.long Y5E0-top+117440512
.long Y5E8-top+117440512
.long Y5F0-top+117440512
.long Y5F8-top
.long Y5F9-top
.long r_illegal-top+83886080
.long Y600-top+117440512
.long Y608-top+117440512
.long Y610-top+117440512
.long Y618-top+117440512
.long Y620-top+117440512
.long Y628-top+117440512
.long Y630-top+117440512
.long Y638-top+117440512
.long Y640-top+117440512
.long Y648-top+117440512
.long Y650-top+117440512
.long Y658-top+117440512
.long Y660-top+117440512
.long Y668-top+117440512
.long Y670-top+117440512
.long Y678-top+117440512
.long Y680-top+117440512
.long Y688-top+117440512
.long Y690-top+117440512
.long Y698-top+117440512
.long Y6A0-top+117440512
.long Y6A8-top+117440512
.long Y6B0-top+117440512
.long Y6B8-top+117440512
.long r_illegal-top+251658240
.long Y6D0-top+117440512
.long Y6D8-top+117440512
.long Y6E0-top+117440512
.long Y6E8-top+117440512
.long Y6F0-top+117440512
.long Y6F8-top
.long Y6F9-top
.long r_illegal-top+83886080
.long Y700-top+117440512
.long Y708-top+117440512
.long Y710-top+117440512
.long Y718-top+117440512
.long Y720-top+117440512
.long Y728-top+117440512
.long Y730-top+117440512
.long Y738-top+117440512
.long Y740-top+117440512
.long Y748-top+117440512
.long Y750-top+117440512
.long Y758-top+117440512
.long Y760-top+117440512
.long Y768-top+117440512
.long Y770-top+117440512
.long Y778-top+117440512
.long Y780-top+117440512
.long Y788-top+117440512
.long Y790-top+117440512
.long Y798-top+117440512
.long Y7A0-top+117440512
.long Y7A8-top+117440512
.long Y7B0-top+117440512
.long Y7B8-top+117440512
.long r_illegal-top+251658240
.long Y7D0-top+117440512
.long Y7D8-top+117440512
.long Y7E0-top+117440512
.long Y7E8-top+117440512
.long Y7F0-top+117440512
.long Y7F8-top
.long Y7F9-top
.long r_illegal-top+83886080
.long Y800-top+117440512
.long Y808-top+117440512
.long Y810-top+117440512
.long Y818-top+117440512
.long Y820-top+117440512
.long Y828-top+117440512
.long Y830-top+117440512
.long Y838-top+117440512
.long Y840-top+117440512
.long Y848-top+117440512
.long Y850-top+117440512
.long Y858-top+117440512
.long Y860-top+117440512
.long Y868-top+117440512
.long Y870-top+117440512
.long Y878-top+117440512
.long Y880-top+117440512
.long Y888-top+117440512
.long Y890-top+117440512
.long Y898-top+117440512
.long Y8A0-top+117440512
.long Y8A8-top+117440512
.long Y8B0-top+117440512
.long Y8B8-top+117440512
.long r_illegal-top+1056964608
.long Y900-top+117440512
.long Y908-top+117440512
.long Y910-top+117440512
.long Y918-top+117440512
.long Y920-top+117440512
.long Y928-top+117440512
.long Y930-top+117440512
.long Y938-top+117440512
.long Y940-top+117440512
.long Y948-top+117440512
.long Y950-top+117440512
.long Y958-top+117440512
.long Y960-top+117440512
.long Y968-top+117440512
.long Y970-top+117440512
.long Y978-top+117440512
.long Y980-top+117440512
.long Y988-top+117440512
.long Y990-top+117440512
.long Y998-top+117440512
.long Y9A0-top+117440512
.long Y9A8-top+117440512
.long Y9B0-top+117440512
.long Y9B8-top+117440512
.long r_illegal-top+1056964608
.long YA00-top+117440512
.long YA08-top+117440512
.long YA10-top+117440512
.long YA18-top+117440512
.long YA20-top+117440512
.long YA28-top+117440512
.long YA30-top+117440512
.long YA38-top+117440512
.long YA40-top+117440512
.long YA48-top+117440512
.long YA50-top+117440512
.long YA58-top+117440512
.long YA60-top+117440512
.long YA68-top+117440512
.long YA70-top+117440512
.long YA78-top+117440512
.long YA80-top+117440512
.long YA88-top+117440512
.long YA90-top+117440512
.long YA98-top+117440512
.long YAA0-top+117440512
.long YAA8-top+117440512
.long YAB0-top+117440512
.long YAB8-top+117440512
.long r_illegal-top+1056964608
.long YB00-top+117440512
.long YB08-top+117440512
.long YB10-top+117440512
.long YB18-top+117440512
.long YB20-top+117440512
.long YB28-top+117440512
.long YB30-top+117440512
.long YB38-top+117440512
.long YB40-top+117440512
.long YB48-top+117440512
.long YB50-top+117440512
.long YB58-top+117440512
.long YB60-top+117440512
.long YB68-top+117440512
.long YB70-top+117440512
.long YB78-top+117440512
.long YB80-top+117440512
.long YB88-top+117440512
.long YB90-top+117440512
.long YB98-top+117440512
.long YBA0-top+117440512
.long YBA8-top+117440512
.long YBB0-top+117440512
.long YBB8-top+117440512
.long r_illegal-top+1056964608
.long YC00-top+117440512
.long YC08-top+117440512
.long YC10-top+117440512
.long YC18-top+117440512
.long YC20-top+117440512
.long YC28-top+117440512
.long YC30-top+117440512
.long YC38-top+117440512
.long YC40-top+117440512
.long YC48-top+117440512
.long YC50-top+117440512
.long YC58-top+117440512
.long YC60-top+117440512
.long YC68-top+117440512
.long YC70-top+117440512
.long YC78-top+117440512
.long YC80-top+117440512
.long YC88-top+117440512
.long YC90-top+117440512
.long YC98-top+117440512
.long YCA0-top+117440512
.long YCA8-top+117440512
.long YCB0-top+117440512
.long YCB8-top+117440512
.long r_illegal-top+1056964608
.long YD00-top+117440512
.long YD08-top+117440512
.long YD10-top+117440512
.long YD18-top+117440512
.long YD20-top+117440512
.long YD28-top+117440512
.long YD30-top+117440512
.long YD38-top+117440512
.long YD40-top+117440512
.long YD48-top+117440512
.long YD50-top+117440512
.long YD58-top+117440512
.long YD60-top+117440512
.long YD68-top+117440512
.long YD70-top+117440512
.long YD78-top+117440512
.long YD80-top+117440512
.long YD88-top+117440512
.long YD90-top+117440512
.long YD98-top+117440512
.long YDA0-top+117440512
.long YDA8-top+117440512
.long YDB0-top+117440512
.long YDB8-top+117440512
.long r_illegal-top+1056964608
.long YE00-top+117440512
.long YE08-top+117440512
.long YE10-top+117440512
.long YE18-top+117440512
.long YE20-top+117440512
.long YE28-top+117440512
.long YE30-top+117440512
.long YE38-top+117440512
.long YE40-top+117440512
.long YE48-top+117440512
.long YE50-top+117440512
.long YE58-top+117440512
.long YE60-top+117440512
.long YE68-top+117440512
.long YE70-top+117440512
.long YE78-top+117440512
.long YE80-top+117440512
.long YE88-top+117440512
.long YE90-top+117440512
.long YE98-top+117440512
.long YEA0-top+117440512
.long YEA8-top+117440512
.long YEB0-top+117440512
.long YEB8-top+117440512
.long r_illegal-top+1056964608
.long YF00-top+117440512
.long YF08-top+117440512
.long YF10-top+117440512
.long YF18-top+117440512
.long YF20-top+117440512
.long YF28-top+117440512
.long YF30-top+117440512
.long YF38-top+117440512
.long YF40-top+117440512
.long YF48-top+117440512
.long YF50-top+117440512
.long YF58-top+117440512
.long YF60-top+117440512
.long YF68-top+117440512
.long YF70-top+117440512
.long YF78-top+117440512
.long YF80-top+117440512
.long YF88-top+117440512
.long YF90-top+117440512
.long YF98-top+117440512
.long YFA0-top+117440512
.long YFA8-top+117440512
.long YFB0-top+117440512
.long YFB8-top+117440512
.long r_illegal-top+1056964608
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
.long Z000-top+4278190080
